import { DefaultInstanceTenancy, GatewayVpcEndpointOptions, NatProvider, SubnetSelection, Vpc, VpnConnectionOptions } from 'aws-cdk-lib/aws-ec2';
import * as ec2 from 'aws-cdk-lib/aws-ec2';
import { IConstruct } from 'constructs';
import { FlowLogFormat, IIpamPool } from '../ec2';
import { ICidrProvider } from '../ec2/lib/ip-addresses/network-provider';
export interface FlowLogOptions extends ec2.FlowLogOptions {
    readonly logFormatDefinition?: FlowLogFormat;
}
export interface FourTierNetworkProps {
    readonly availabilityZones?: string[];
    readonly cidr?: ICidrProvider;
    readonly defaultInstanceTenancy?: DefaultInstanceTenancy;
    readonly enableDnsHostnames?: boolean;
    readonly enableDnsSupport?: boolean;
    readonly flowLogs?: {
        [id: string]: FlowLogOptions;
    };
    readonly gatewayEndpoints?: {
        [id: string]: GatewayVpcEndpointOptions;
    };
    readonly maxAzs?: number;
    readonly natGateways?: number;
    readonly natGatewayProvider?: NatProvider;
    readonly natGatewaySubnets?: SubnetSelection;
    readonly vpcName?: string;
    readonly vpnConnections?: {
        [id: string]: VpnConnectionOptions;
    };
    readonly vpnGateway?: boolean;
    readonly vpnGatewayAsn?: number;
    readonly vpnRoutePropagation?: SubnetSelection[];
}
export declare class FourTierNetwork extends Vpc {
    readonly defaultInstanceTenancy?: DefaultInstanceTenancy;
    readonly enableDnsHostnames?: boolean;
    readonly enableDnsSupport?: boolean;
    readonly ipamPool?: IIpamPool;
    readonly maxAzs?: number;
    readonly netmask: number;
    readonly vpcName?: string;
    constructor(scope: IConstruct, id: string, props?: FourTierNetworkProps);
    addVpcFlowLog(id: string, options?: FlowLogOptions): ec2.FlowLog;
}
