import { Resource, ResourceProps } from 'aws-cdk-lib';
import { IConstruct } from 'constructs';
import { FourTierNetworkHub, IpAddressManager } from '.';
import { FourTierNetworkSpoke } from './four-tier-network-spoke';
import { GlobalNetwork } from '../networkmanager/global-network';
export interface NetworkControllerProps extends ResourceProps {
    readonly defaultNetmask?: number;
}
export interface AddNetworkOptions {
    readonly netmask?: number;
}
export declare class NetworkController extends Resource {
    private readonly _hubs;
    private readonly _registeredAccounts;
    private readonly _registeredRegions;
    readonly defaultNetmask: number;
    readonly addressManager: IpAddressManager;
    readonly globalNetwork: GlobalNetwork;
    get registeredAccounts(): string[];
    get registeredRegions(): string[];
    constructor(scope: IConstruct, id: string, props?: NetworkControllerProps);
    addHub(scope: IConstruct, id: string, options?: AddNetworkOptions): FourTierNetworkHub;
    addSpoke(scope: IConstruct, id: string, options?: AddNetworkOptions): FourTierNetworkSpoke;
    protected registerAccount(account: string): void;
    protected registerRegion(region: string): void;
}
