import { Resource, ResourceProps } from 'aws-cdk-lib';
import { CfnIPAMPoolCidr } from 'aws-cdk-lib/aws-ec2';
import { IConstruct } from 'constructs';
import { IIpamPool } from './ipam-pool';
export interface ResolvedIpamPoolCidrConfiguration {
    readonly cidr?: string;
    readonly netmaskLength?: number;
}
export interface IIpamPoolCidrConfiguration {
    readonly inline: boolean;
    bind(scope: IConstruct): ResolvedIpamPoolCidrConfiguration;
}
export declare class IpamPoolCidrConfiguration {
    static cidr(cidr: string): IIpamPoolCidrConfiguration;
    static netmask(length: number): IIpamPoolCidrConfiguration;
}
export interface IIpamPoolCidr {
    readonly ipamPoolCidrId: string;
    readonly ipamPoolCidrState: string;
}
declare abstract class IpamPoolCidrBase extends Resource implements IIpamPoolCidr {
    abstract readonly ipamPoolCidrId: string;
    abstract readonly ipamPoolCidrState: string;
}
export interface IpamPoolCidrProps extends ResourceProps {
    readonly configuration: IIpamPoolCidrConfiguration;
    readonly ipamPool: IIpamPool;
}
export declare class IpamPoolCidr extends IpamPoolCidrBase {
    readonly configuration: IIpamPoolCidrConfiguration;
    readonly ipamPool: IIpamPool;
    readonly resource: CfnIPAMPoolCidr;
    readonly ipamPoolCidrId: string;
    readonly ipamPoolCidrState: string;
    constructor(scope: IConstruct, id: string, props: IpamPoolCidrProps);
}
export {};
