export interface NetmaskLengthOptions {
    readonly defaultNetmaskLength?: number;
    readonly maxNetmaskLength?: number;
    readonly minNetmaskLength?: number;
}
export interface Ipv4ConfigurationOptions extends NetmaskLengthOptions {
}
export interface Ipv6ConfigurationOptions extends NetmaskLengthOptions {
    readonly publiclyAdvertisable?: boolean;
}
export interface AddressConfigurationProps extends NetmaskLengthOptions {
    readonly family: string;
    readonly publiclyAdvertisable?: boolean;
}
export interface IAddressConfiguration {
    readonly family: string;
    readonly publiclyAdvertisable?: boolean;
}
export declare class AddressConfiguration {
    static ipv4(options?: Ipv4ConfigurationOptions): AddressConfiguration;
    static ipv6(options?: Ipv6ConfigurationOptions): AddressConfiguration;
    static of(props: AddressConfigurationProps): AddressConfiguration;
    readonly defaultNetmaskLength?: number;
    readonly family: string;
    readonly publiclyAdvertisable?: boolean;
    readonly maxNetmaskLength?: number;
    readonly minNetmaskLength?: number;
    private constructor();
}
