import { ResourceProps } from 'aws-cdk-lib';
import { Construct } from 'constructs';
import { RawBucket } from './private/raw-bucket';
import { Database } from '../glue';
import { WafLogsTable } from '../glue-tables';
/**
 * Configuration for objects bucket
 */
export interface WafLogsBucketProps extends ResourceProps {
    readonly bucketName?: string;
    readonly createQueries?: boolean;
    readonly database?: Database;
    readonly friendlyQueryNames?: boolean;
    readonly tableName?: string;
}
export declare class WafLogsBucket extends RawBucket {
    readonly database: Database;
    readonly table: WafLogsTable;
    readonly createQueries?: boolean;
    readonly friendlyQueryNames?: boolean;
    /**
       * Creates a new instance of the WafLogsBucket class.
       *
       * @param scope A CDK Construct that will serve as this stack's parent in the construct tree.
       * @param id A name to be associated with the stack and used in resource naming. Must be unique
       * within the context of 'scope'.
       * @param props Arguments related to the configuration of the resource.
       */
    constructor(scope: Construct, id: string, props?: WafLogsBucketProps);
}
