# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### AdotCollector <a name="AdotCollector" id="cdk-extensions.k8s_aws.AdotCollector"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.AdotCollector.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.AdotCollector(scope: Construct, id: string, props: AdotCollectorProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.AdotCollectorProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.AdotCollector.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.AdotCollector.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.AdotCollector.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.AdotCollectorProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.AdotCollector.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.AdotCollector.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.AdotCollector.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.AdotCollector.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.AdotCollector.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.AdotCollector.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.AdotCollector.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.AdotCollector.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.AdotCollector.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.AdotCollector.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.AdotCollector.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.AdotCollector.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the ADOT Collector will be deployed. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.createNamespace">createNamespace</a></code> | <code>boolean</code> | Flag wich sets whether the deploy of the ADOT collector should include creating the Kubernetes namespace the service will be deployed to. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.manifest">manifest</a></code> | <code>aws-cdk-lib.aws_eks.KubernetesManifest</code> | The Kubernetes manifest used to deploy the ADOT Collector. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where resources related to the ADOT collector will be created. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.serviceAccount">serviceAccount</a></code> | <code>aws-cdk-lib.aws_eks.ServiceAccount</code> | The Kubernetes service account that allows the ADOT collector to gather metric information and publish it to CloudWatch. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.AdotCollector.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.AdotCollector.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.AdotCollector.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.AdotCollector.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the ADOT Collector will be deployed.

---

##### `createNamespace`<sup>Required</sup> <a name="createNamespace" id="cdk-extensions.k8s_aws.AdotCollector.property.createNamespace"></a>

```typescript
public readonly createNamespace: boolean;
```

- *Type:* boolean

Flag wich sets whether the deploy of the ADOT collector should include creating the Kubernetes namespace the service will be deployed to.

---

##### `manifest`<sup>Required</sup> <a name="manifest" id="cdk-extensions.k8s_aws.AdotCollector.property.manifest"></a>

```typescript
public readonly manifest: KubernetesManifest;
```

- *Type:* aws-cdk-lib.aws_eks.KubernetesManifest

The Kubernetes manifest used to deploy the ADOT Collector.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk-extensions.k8s_aws.AdotCollector.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where resources related to the ADOT collector will be created.

---

##### `serviceAccount`<sup>Required</sup> <a name="serviceAccount" id="cdk-extensions.k8s_aws.AdotCollector.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: ServiceAccount;
```

- *Type:* aws-cdk-lib.aws_eks.ServiceAccount

The Kubernetes service account that allows the ADOT collector to gather metric information and publish it to CloudWatch.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollector.property.DEFAULT_NAMESPACE">DEFAULT_NAMESPACE</a></code> | <code>string</code> | The default Kubernetes namespace where resources related to the ADOT collector will be created if no overriding input is provided. |

---

##### `DEFAULT_NAMESPACE`<sup>Required</sup> <a name="DEFAULT_NAMESPACE" id="cdk-extensions.k8s_aws.AdotCollector.property.DEFAULT_NAMESPACE"></a>

```typescript
public readonly DEFAULT_NAMESPACE: string;
```

- *Type:* string

The default Kubernetes namespace where resources related to the ADOT collector will be created if no overriding input is provided.

---

### AlbLogsBucket <a name="AlbLogsBucket" id="cdk-extensions.s3_buckets.AlbLogsBucket"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.s3_buckets.AlbLogsBucket.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

new s3_buckets.AlbLogsBucket(scope: Construct, id: string, props?: AlbLogsBucketProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.s3_buckets.AlbLogsBucketProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.AlbLogsBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.s3_buckets.AlbLogsBucket.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.s3_buckets.AlbLogsBucket.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.s3_buckets.AlbLogsBucketProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.addEventNotification">addEventNotification</a></code> | Adds a bucket notification event destination. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.addObjectCreatedNotification">addObjectCreatedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 created in the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.addObjectRemovedNotification">addObjectRemovedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 removed from the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.addToResourcePolicy">addToResourcePolicy</a></code> | Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.arnForObjects">arnForObjects</a></code> | Returns an ARN that represents all objects within the bucket that match
 the key pattern specified. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.enableEventBridgeNotification">enableEventBridgeNotification</a></code> | Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.grantDelete">grantDelete</a></code> | Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.grantPublicAccess">grantPublicAccess</a></code> | Allows unrestricted access to objects from this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.grantPut">grantPut</a></code> | Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.grantPutAcl">grantPutAcl</a></code> | Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.grantRead">grantRead</a></code> | Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.grantReadWrite">grantReadWrite</a></code> | Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.grantWrite">grantWrite</a></code> | Grant write permissions to this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailEvent">onCloudTrailEvent</a></code> | Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailPutObject">onCloudTrailPutObject</a></code> | Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailWriteObject">onCloudTrailWriteObject</a></code> | Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.s3UrlForObject">s3UrlForObject</a></code> | The S3 URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.transferAccelerationUrlForObject">transferAccelerationUrlForObject</a></code> | The https Transfer Acceleration URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.urlForObject">urlForObject</a></code> | The https URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.virtualHostedUrlForObject">virtualHostedUrlForObject</a></code> | The virtual hosted-style URL of an S3 object. |

---

##### `toString` <a name="toString" id="cdk-extensions.s3_buckets.AlbLogsBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.s3_buckets.AlbLogsBucket.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.s3_buckets.AlbLogsBucket.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addEventNotification` <a name="addEventNotification" id="cdk-extensions.s3_buckets.AlbLogsBucket.addEventNotification"></a>

```typescript
public addEventNotification(_event: EventType, _dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Adds a bucket notification event destination.

###### `_event`<sup>Required</sup> <a name="_event" id="cdk-extensions.s3_buckets.AlbLogsBucket.addEventNotification.parameter._event"></a>

- *Type:* aws-cdk-lib.aws_s3.EventType

---

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.AlbLogsBucket.addEventNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.AlbLogsBucket.addEventNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectCreatedNotification` <a name="addObjectCreatedNotification" id="cdk-extensions.s3_buckets.AlbLogsBucket.addObjectCreatedNotification"></a>

```typescript
public addObjectCreatedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 created in the bucket.

This is identical to calling
`onEvent(s3.EventType.OBJECT_CREATED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.AlbLogsBucket.addObjectCreatedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.AlbLogsBucket.addObjectCreatedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectRemovedNotification` <a name="addObjectRemovedNotification" id="cdk-extensions.s3_buckets.AlbLogsBucket.addObjectRemovedNotification"></a>

```typescript
public addObjectRemovedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 removed from the bucket.

This is identical to calling
`onEvent(EventType.OBJECT_REMOVED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.AlbLogsBucket.addObjectRemovedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.AlbLogsBucket.addObjectRemovedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addToResourcePolicy` <a name="addToResourcePolicy" id="cdk-extensions.s3_buckets.AlbLogsBucket.addToResourcePolicy"></a>

```typescript
public addToResourcePolicy(permission: PolicyStatement): AddToResourcePolicyResult
```

Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases.

###### `permission`<sup>Required</sup> <a name="permission" id="cdk-extensions.s3_buckets.AlbLogsBucket.addToResourcePolicy.parameter.permission"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `arnForObjects` <a name="arnForObjects" id="cdk-extensions.s3_buckets.AlbLogsBucket.arnForObjects"></a>

```typescript
public arnForObjects(_keyPattern: string): string
```

Returns an ARN that represents all objects within the bucket that match
 the key pattern specified.

To represent all keys, specify ``"*"``.

###### `_keyPattern`<sup>Required</sup> <a name="_keyPattern" id="cdk-extensions.s3_buckets.AlbLogsBucket.arnForObjects.parameter._keyPattern"></a>

- *Type:* string

---

##### `enableEventBridgeNotification` <a name="enableEventBridgeNotification" id="cdk-extensions.s3_buckets.AlbLogsBucket.enableEventBridgeNotification"></a>

```typescript
public enableEventBridgeNotification(): void
```

Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted.

##### `grantDelete` <a name="grantDelete" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantDelete"></a>

```typescript
public grantDelete(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantDelete.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantDelete.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPublicAccess` <a name="grantPublicAccess" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPublicAccess"></a>

```typescript
public grantPublicAccess(_allowedActions: string, _keyPrefix?: string): Grant
```

Allows unrestricted access to objects from this bucket.

IMPORTANT: This permission allows anyone to perform actions on S3 objects
in this bucket, which is useful for when you configure your bucket as a
website and want everyone to be able to read objects in the bucket without
needing to authenticate.

Without arguments, this method will grant read ("s3:GetObject") access to
all objects ("*") in the bucket.

The method returns the `iam.Grant` object, which can then be modified
as needed. For example, you can add a condition that will restrict access only
to an IPv4 range like this:

     const grant = bucket.grantPublicAccess();
     grant.resourceStatement!.addCondition(‘IpAddress’, { “aws:SourceIp”: “54.240.143.0/24” });

###### `_allowedActions`<sup>Required</sup> <a name="_allowedActions" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPublicAccess.parameter._allowedActions"></a>

- *Type:* string

---

###### `_keyPrefix`<sup>Optional</sup> <a name="_keyPrefix" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPublicAccess.parameter._keyPrefix"></a>

- *Type:* string

---

##### `grantPut` <a name="grantPut" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPut"></a>

```typescript
public grantPut(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPut.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPut.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPutAcl` <a name="grantPutAcl" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPutAcl"></a>

```typescript
public grantPutAcl(_identity: IGrantable, _objectsKeyPattern?: string): Grant
```

Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket.

If your application has the '@aws-cdk/aws-s3:grantWriteWithoutAcl' feature flag set,
calling `grantWrite` or `grantReadWrite` no longer grants permissions to modify the ACLs of the objects;
in this case, if you need to modify object ACLs, call this method explicitly.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPutAcl.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantPutAcl.parameter._objectsKeyPattern"></a>

- *Type:* string

---

##### `grantRead` <a name="grantRead" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantRead"></a>

```typescript
public grantRead(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If encryption is used, permission to use the key to decrypt the contents
of the bucket will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantRead.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantRead.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantReadWrite"></a>

```typescript
public grantReadWrite(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If an encryption key is used, permission to use the key for
encrypt/decrypt will also be granted.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantReadWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantReadWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantWrite` <a name="grantWrite" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantWrite"></a>

```typescript
public grantWrite(_identity: IGrantable, _objectsKeyPattern?: any, _allowedActionPatterns?: string[]): Grant
```

Grant write permissions to this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

###### `_allowedActionPatterns`<sup>Optional</sup> <a name="_allowedActionPatterns" id="cdk-extensions.s3_buckets.AlbLogsBucket.grantWrite.parameter._allowedActionPatterns"></a>

- *Type:* string[]

---

##### `onCloudTrailEvent` <a name="onCloudTrailEvent" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailEvent"></a>

```typescript
public onCloudTrailEvent(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event.

This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailEvent.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailEvent.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailPutObject` <a name="onCloudTrailPutObject" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailPutObject"></a>

```typescript
public onCloudTrailPutObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using `onCloudTrailWriteObject` may be preferable.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailPutObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailPutObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailWriteObject` <a name="onCloudTrailWriteObject" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailWriteObject"></a>

```typescript
public onCloudTrailWriteObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to.

This includes
the events PutObject, CopyObject, and CompleteMultipartUpload.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using this method may be preferable to `onCloudTrailPutObject`.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailWriteObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.AlbLogsBucket.onCloudTrailWriteObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `s3UrlForObject` <a name="s3UrlForObject" id="cdk-extensions.s3_buckets.AlbLogsBucket.s3UrlForObject"></a>

```typescript
public s3UrlForObject(_key?: string): string
```

The S3 URL of an S3 object.

For example:
- `s3://onlybucket`
- `s3://bucket/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.AlbLogsBucket.s3UrlForObject.parameter._key"></a>

- *Type:* string

---

##### `transferAccelerationUrlForObject` <a name="transferAccelerationUrlForObject" id="cdk-extensions.s3_buckets.AlbLogsBucket.transferAccelerationUrlForObject"></a>

```typescript
public transferAccelerationUrlForObject(_key?: string, _options?: TransferAccelerationUrlOptions): string
```

The https Transfer Acceleration URL of an S3 object.

Specify `dualStack: true` at the options
for dual-stack endpoint (connect to the bucket over IPv6). For example:

- `https://bucket.s3-accelerate.amazonaws.com`
- `https://bucket.s3-accelerate.amazonaws.com/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.AlbLogsBucket.transferAccelerationUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.AlbLogsBucket.transferAccelerationUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.TransferAccelerationUrlOptions

---

##### `urlForObject` <a name="urlForObject" id="cdk-extensions.s3_buckets.AlbLogsBucket.urlForObject"></a>

```typescript
public urlForObject(_key?: string): string
```

The https URL of an S3 object.

For example:

- `https://s3.us-west-1.amazonaws.com/onlybucket`
- `https://s3.us-west-1.amazonaws.com/bucket/key`
- `https://s3.cn-north-1.amazonaws.com.cn/china-bucket/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.AlbLogsBucket.urlForObject.parameter._key"></a>

- *Type:* string

---

##### `virtualHostedUrlForObject` <a name="virtualHostedUrlForObject" id="cdk-extensions.s3_buckets.AlbLogsBucket.virtualHostedUrlForObject"></a>

```typescript
public virtualHostedUrlForObject(_key?: string, _options?: VirtualHostedStyleUrlOptions): string
```

The virtual hosted-style URL of an S3 object.

Specify `regional: false` at
the options for non-regional URL. For example:

- `https://only-bucket.s3.us-west-1.amazonaws.com`
- `https://bucket.s3.us-west-1.amazonaws.com/key`
- `https://bucket.s3.amazonaws.com/key`
- `https://china-bucket.s3.cn-north-1.amazonaws.com.cn/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.AlbLogsBucket.virtualHostedUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.AlbLogsBucket.virtualHostedUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.VirtualHostedStyleUrlOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.s3_buckets.AlbLogsBucket.isConstruct"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.AlbLogsBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.s3_buckets.AlbLogsBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.s3_buckets.AlbLogsBucket.isOwnedResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.AlbLogsBucket.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.AlbLogsBucket.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.s3_buckets.AlbLogsBucket.isResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.AlbLogsBucket.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.AlbLogsBucket.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketArn">bucketArn</a></code> | <code>string</code> | The ARN of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | The IPv4 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketDualStackDomainName">bucketDualStackDomainName</a></code> | <code>string</code> | The IPv6 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketName">bucketName</a></code> | <code>string</code> | The name of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketRegionalDomainName">bucketRegionalDomainName</a></code> | <code>string</code> | The regional domain name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketWebsiteDomainName">bucketWebsiteDomainName</a></code> | <code>string</code> | The Domain name of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketWebsiteUrl">bucketWebsiteUrl</a></code> | <code>string</code> | The URL of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_s3.CfnBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | Optional KMS encryption key associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.isWebsite">isWebsite</a></code> | <code>boolean</code> | If this bucket has been configured for static website hosting. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.policy">policy</a></code> | <code>aws-cdk-lib.aws_s3.BucketPolicy</code> | The resource policy associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.table">table</a></code> | <code>cdk-extensions.glue_tables.AlbLogsTable</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucket.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bucketArn`<sup>Required</sup> <a name="bucketArn" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketArn"></a>

```typescript
public readonly bucketArn: string;
```

- *Type:* string

The ARN of the bucket.

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

The IPv4 DNS name of the specified bucket.

---

##### `bucketDualStackDomainName`<sup>Required</sup> <a name="bucketDualStackDomainName" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketDualStackDomainName"></a>

```typescript
public readonly bucketDualStackDomainName: string;
```

- *Type:* string

The IPv6 DNS name of the specified bucket.

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

The name of the bucket.

---

##### `bucketRegionalDomainName`<sup>Required</sup> <a name="bucketRegionalDomainName" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketRegionalDomainName"></a>

```typescript
public readonly bucketRegionalDomainName: string;
```

- *Type:* string

The regional domain name of the specified bucket.

---

##### `bucketWebsiteDomainName`<sup>Required</sup> <a name="bucketWebsiteDomainName" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketWebsiteDomainName"></a>

```typescript
public readonly bucketWebsiteDomainName: string;
```

- *Type:* string

The Domain name of the static website.

---

##### `bucketWebsiteUrl`<sup>Required</sup> <a name="bucketWebsiteUrl" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.bucketWebsiteUrl"></a>

```typescript
public readonly bucketWebsiteUrl: string;
```

- *Type:* string

The URL of the static website.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.resource"></a>

```typescript
public readonly resource: CfnBucket;
```

- *Type:* aws-cdk-lib.aws_s3.CfnBucket

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

Optional KMS encryption key associated with this bucket.

---

##### `isWebsite`<sup>Optional</sup> <a name="isWebsite" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.isWebsite"></a>

```typescript
public readonly isWebsite: boolean;
```

- *Type:* boolean

If this bucket has been configured for static website hosting.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.policy"></a>

```typescript
public readonly policy: BucketPolicy;
```

- *Type:* aws-cdk-lib.aws_s3.BucketPolicy

The resource policy associated with this bucket.

If `autoCreatePolicy` is true, a `BucketPolicy` will be created upon the
first call to addToResourcePolicy(s).

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.table"></a>

```typescript
public readonly table: AlbLogsTable;
```

- *Type:* cdk-extensions.glue_tables.AlbLogsTable

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.AlbLogsBucket.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---


### AlbLogsTable <a name="AlbLogsTable" id="cdk-extensions.glue_tables.AlbLogsTable"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue_tables.AlbLogsTable.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

new glue_tables.AlbLogsTable(scope: Construct, id: string, props: AlbLogsTableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue_tables.AlbLogsTableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue_tables.AlbLogsTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue_tables.AlbLogsTable.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue_tables.AlbLogsTable.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue_tables.AlbLogsTableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.addColumn">addColumn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.addParameter">addParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.addPartitionKey">addPartitionKey</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.addSerdeParameter">addSerdeParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.addStorageParameter">addStorageParameter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue_tables.AlbLogsTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue_tables.AlbLogsTable.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue_tables.AlbLogsTable.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue_tables.AlbLogsTable.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.AlbLogsTable.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.glue_tables.AlbLogsTable.addParameter"></a>

```typescript
public addParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.AlbLogsTable.addParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.AlbLogsTable.addParameter.parameter.value"></a>

- *Type:* string

---

##### `addPartitionKey` <a name="addPartitionKey" id="cdk-extensions.glue_tables.AlbLogsTable.addPartitionKey"></a>

```typescript
public addPartitionKey(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.AlbLogsTable.addPartitionKey.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addSerdeParameter` <a name="addSerdeParameter" id="cdk-extensions.glue_tables.AlbLogsTable.addSerdeParameter"></a>

```typescript
public addSerdeParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.AlbLogsTable.addSerdeParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.AlbLogsTable.addSerdeParameter.parameter.value"></a>

- *Type:* string

---

##### `addStorageParameter` <a name="addStorageParameter" id="cdk-extensions.glue_tables.AlbLogsTable.addStorageParameter"></a>

```typescript
public addStorageParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.AlbLogsTable.addStorageParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.AlbLogsTable.addStorageParameter.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue_tables.AlbLogsTable.isConstruct"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.AlbLogsTable.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue_tables.AlbLogsTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue_tables.AlbLogsTable.isOwnedResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.AlbLogsTable.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.AlbLogsTable.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue_tables.AlbLogsTable.isResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.AlbLogsTable.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.AlbLogsTable.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link TableProps.database:}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTable</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.tableArn">tableArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.compressed">compressed</a></code> | <code>boolean</code> | {@link TableProps.compressed}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | {@link TableProps.dataFormat}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.description">description</a></code> | <code>string</code> | {@link TableProps.description}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.location">location</a></code> | <code>string</code> | {@link TableProps.location}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.name">name</a></code> | <code>string</code> | {@link TableProps.name}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.owner">owner</a></code> | <code>string</code> | {@link TableProps.owner}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | {@link TableProps.retention}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.serdeName">serdeName</a></code> | <code>string</code> | {@link TableProps.serdeName}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | {@link TableProps.storedAsSubDirectories}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | {@link TableProps.tableType}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | {@link TableProps.targetTable}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | {@link TableProps.viewExpandedText}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | {@link TableProps.viewOriginalText}. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the ALB Logs. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.status5xxNamedQuery">status5xxNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTable.property.topIpsNamedQuery">topIpsNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue_tables.AlbLogsTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue_tables.AlbLogsTable.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue_tables.AlbLogsTable.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.AlbLogsTable.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link TableProps.database:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue_tables.AlbLogsTable.property.resource"></a>

```typescript
public readonly resource: CfnTable;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTable

---

##### `tableArn`<sup>Required</sup> <a name="tableArn" id="cdk-extensions.glue_tables.AlbLogsTable.property.tableArn"></a>

```typescript
public readonly tableArn: string;
```

- *Type:* string

---

##### `tableName`<sup>Required</sup> <a name="tableName" id="cdk-extensions.glue_tables.AlbLogsTable.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue_tables.AlbLogsTable.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

{@link TableProps.compressed}.

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue_tables.AlbLogsTable.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

{@link TableProps.dataFormat}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue_tables.AlbLogsTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link TableProps.description}.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue_tables.AlbLogsTable.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

{@link TableProps.location}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.AlbLogsTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link TableProps.name}.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue_tables.AlbLogsTable.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

{@link TableProps.owner}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue_tables.AlbLogsTable.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link TableProps.retention}.

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue_tables.AlbLogsTable.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

{@link TableProps.serdeName}.

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue_tables.AlbLogsTable.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

{@link TableProps.storedAsSubDirectories}.

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue_tables.AlbLogsTable.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

{@link TableProps.tableType}.

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue_tables.AlbLogsTable.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

{@link TableProps.targetTable}.

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue_tables.AlbLogsTable.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

{@link TableProps.viewExpandedText}.

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue_tables.AlbLogsTable.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

{@link TableProps.viewOriginalText}.

---

##### `createQueries`<sup>Required</sup> <a name="createQueries" id="cdk-extensions.glue_tables.AlbLogsTable.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the ALB Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Required</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.AlbLogsTable.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `status5xxNamedQuery`<sup>Optional</sup> <a name="status5xxNamedQuery" id="cdk-extensions.glue_tables.AlbLogsTable.property.status5xxNamedQuery"></a>

```typescript
public readonly status5xxNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---

##### `topIpsNamedQuery`<sup>Optional</sup> <a name="topIpsNamedQuery" id="cdk-extensions.glue_tables.AlbLogsTable.property.topIpsNamedQuery"></a>

```typescript
public readonly topIpsNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---


### AlertManagerConfiguration <a name="AlertManagerConfiguration" id="cdk-extensions.aps.AlertManagerConfiguration"></a>

- *Implements:* cdk-extensions.aps.IAlertManagerConfiguration

Represents a Prometheus alert manager configuration that can be used by Amazon APS to send generated alerts to one or more destinations.

Currently
the only destination type supported by APS is Amazon SNS.

> [[Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/)]([Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.AlertManagerConfiguration.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.AlertManagerConfiguration(scope: IConstruct, id: string, props?: AlertManagerConfigurationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this construct's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.aps.AlertManagerConfigurationProps</code> | Arguments related to the configuration of the construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerConfiguration.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this construct's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerConfiguration.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.aps.AlertManagerConfiguration.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.aps.AlertManagerConfigurationProps

Arguments related to the configuration of the construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.addInhibitRule">addInhibitRule</a></code> | Adds a new inhibit rule that can mute alerts under specific circumstances. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.addReciever">addReciever</a></code> | Adds a new receiver to the configuration. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.addTemplate">addTemplate</a></code> | Adds a new template to the configuration. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.addTimeInterval">addTimeInterval</a></code> | Adds a new time interval to the configuration. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.bind">bind</a></code> | Associates the configuration with a construct that is handling the configuration of alert manager for an APS workspace. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.AlertManagerConfiguration.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addInhibitRule` <a name="addInhibitRule" id="cdk-extensions.aps.AlertManagerConfiguration.addInhibitRule"></a>

```typescript
public addInhibitRule(id: string, options: AlertManagerInhibitRuleProps): AlertManagerInhibitRule
```

Adds a new inhibit rule that can mute alerts under specific circumstances.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerConfiguration.addInhibitRule.parameter.id"></a>

- *Type:* string

Unique identifier for the inhibit rule.

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.AlertManagerConfiguration.addInhibitRule.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertManagerInhibitRuleProps

Details for the rule being created.

---

##### `addReciever` <a name="addReciever" id="cdk-extensions.aps.AlertManagerConfiguration.addReciever"></a>

```typescript
public addReciever(id: string, options?: AlertManagerReceiverProps): AlertManagerReceiver
```

Adds a new receiver to the configuration.

The receiver can be used to
specify one or more destinations where alerts should be sent when matched
by a route in the routing tree.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerConfiguration.addReciever.parameter.id"></a>

- *Type:* string

Unique identifier for the receiver.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.aps.AlertManagerConfiguration.addReciever.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertManagerReceiverProps

Details for the receiver being created.

---

##### `addTemplate` <a name="addTemplate" id="cdk-extensions.aps.AlertManagerConfiguration.addTemplate"></a>

```typescript
public addTemplate(template: AlertManagerTemplate): IAlertManagerConfiguration
```

Adds a new template to the configuration.

The template can be referenced
within the configuration to control the formatting of the alerts being sent.

###### `template`<sup>Required</sup> <a name="template" id="cdk-extensions.aps.AlertManagerConfiguration.addTemplate.parameter.template"></a>

- *Type:* cdk-extensions.aps.AlertManagerTemplate

The template to add to the configuration.

---

##### `addTimeInterval` <a name="addTimeInterval" id="cdk-extensions.aps.AlertManagerConfiguration.addTimeInterval"></a>

```typescript
public addTimeInterval(id: string, options?: TimeIntervalProps): TimeInterval
```

Adds a new time interval to the configuration.

Time intervals can be used
to mute or activate groups of alerts under specific circumstances.

Time intervals are referenced by routes in the routing tree to control the
behavior of the route. Time intervals to mute or activate alerts cannot be
added to the default route.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerConfiguration.addTimeInterval.parameter.id"></a>

- *Type:* string

Unique identifier for the time interval.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.aps.AlertManagerConfiguration.addTimeInterval.parameter.options"></a>

- *Type:* cdk-extensions.aps.TimeIntervalProps

Details for the time interval being created.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.AlertManagerConfiguration.bind"></a>

```typescript
public bind(scope: IConstruct): AlertManagerConfigurationDetails
```

Associates the configuration with a construct that is handling the configuration of alert manager for an APS workspace.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerConfiguration.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the configuration.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationContent">fromFullConfigurationContent</a></code> | Imports an alert manager configuration from a raw string in the format expected by Amazon APS. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationFile">fromFullConfigurationFile</a></code> | Imports an alert manager configuration using a file in the format expected by Amazon APS. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationContent">fromSplitConfigurationContent</a></code> | Imports an alert manager configuration from a raw string. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationFiles">fromSplitConfigurationFiles</a></code> | Imports an alert manager configuration from a file. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.AlertManagerConfiguration.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerConfiguration.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.AlertManagerConfiguration.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromFullConfigurationContent` <a name="fromFullConfigurationContent" id="cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationContent"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerConfiguration.fromFullConfigurationContent(scope: IConstruct, id: string, content: string)
```

Imports an alert manager configuration from a raw string in the format expected by Amazon APS.

The string should combine both the alert manager configuration and the
alert template content into a single file. To import a configuration that
has the alert manager configuration and templates being loaded from
different files/sources use {@link fromSplitConfigurationContent} instead.

> [[Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/)]([Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/))

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationContent.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationContent.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `content`<sup>Required</sup> <a name="content" id="cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationContent.parameter.content"></a>

- *Type:* string

A YAML formatted string specifying the alert manager configuration as expected by Amazon APS.

---

##### `fromFullConfigurationFile` <a name="fromFullConfigurationFile" id="cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationFile"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerConfiguration.fromFullConfigurationFile(scope: IConstruct, id: string, path: string)
```

Imports an alert manager configuration using a file in the format expected by Amazon APS.

The file should combine both the alert manager configuration and the alert
template content into a single file. To import a configuration that has
the alert manager configuration and templates being loaded from different
files/sources use {@link fromSplitConfigurationFiles} instead.

> [[Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/)]([Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/))

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationFile.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationFile.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.aps.AlertManagerConfiguration.fromFullConfigurationFile.parameter.path"></a>

- *Type:* string

The path to the file containing the APS alert manager configuration.

---

##### `fromSplitConfigurationContent` <a name="fromSplitConfigurationContent" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationContent"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerConfiguration.fromSplitConfigurationContent(scope: IConstruct, id: string, content: string, templates?: {[ key: string ]: AlertManagerTemplate})
```

Imports an alert manager configuration from a raw string.

The string should be in YAML format and follow the alert manager
configuration specifications. To import a configuration using a string
that combines the alert manager configuration with the template content
that is already in the format expected by Amazon APS use the import method
{@link fromFullConfigurationContent} instead.

If the configuration references any templates then each template the
configuration references should be specified using the `templates`
argument. Templates can be read from their own separate files on disk or
as a string.

> [[Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/)]([Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/))

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationContent.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationContent.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `content`<sup>Required</sup> <a name="content" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationContent.parameter.content"></a>

- *Type:* string

A YAML formatted string specifying the alert manager configuration.

---

###### `templates`<sup>Optional</sup> <a name="templates" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationContent.parameter.templates"></a>

- *Type:* {[ key: string ]: cdk-extensions.aps.AlertManagerTemplate}

The templates referenced by the imported configuration.

---

##### `fromSplitConfigurationFiles` <a name="fromSplitConfigurationFiles" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationFiles"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerConfiguration.fromSplitConfigurationFiles(scope: IConstruct, id: string, path: string, templates?: {[ key: string ]: AlertManagerTemplate})
```

Imports an alert manager configuration from a file.

The file is a YAML file that follows the alert manager configuration
specifications. To import a configuration file that combines the alert
manager configuration with the template content that is already in the
format expected by Amazon APS use the import method
{@link fromFullConfigurationFile} instead.

If the configuration references any templates then each template the
configuration references should be specified using the `templates`
argument. Templates can be read from their own separate files on disk or
as a string.

> [[Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/)]([Alert manager configuration specification](https://prometheus.io/docs/alerting/latest/configuration/))

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationFiles.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationFiles.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationFiles.parameter.path"></a>

- *Type:* string

The path to the file containing the alert manager specification.

---

###### `templates`<sup>Optional</sup> <a name="templates" id="cdk-extensions.aps.AlertManagerConfiguration.fromSplitConfigurationFiles.parameter.templates"></a>

- *Type:* {[ key: string ]: cdk-extensions.aps.AlertManagerTemplate}

The templates referenced by the imported configuration.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.property.defaultReceiver">defaultReceiver</a></code> | <code>cdk-extensions.aps.AlertManagerReceiver</code> | The receiver configuring the destinations where all alerts that are not matched by a child route in the routing tree will be sent. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.property.defaultRoute">defaultRoute</a></code> | <code>cdk-extensions.aps.AlertManagerRoute</code> | The default root route withing the routing tree. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.property.inhibitRules">inhibitRules</a></code> | <code>cdk-extensions.aps.AlertManagerInhibitRule[]</code> | Collection of inhibit rules that mute an alert under scecific sets of circumstances. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.property.receivers">receivers</a></code> | <code>cdk-extensions.aps.AlertManagerReceiver[]</code> | Collection of notification integrations that provide the details for how and where generated alerts should be sent. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.property.templates">templates</a></code> | <code>cdk-extensions.aps.AlertManagerTemplate[]</code> | Collection of alert manager templates that the configuration uses to format the alerts that it sends. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.property.timeIntervals">timeIntervals</a></code> | <code>cdk-extensions.aps.TimeInterval[]</code> | Collection of timing configurations that can be used to control when specific alerts should be muted or activated. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfiguration.property.defaultTopic">defaultTopic</a></code> | <code>aws-cdk-lib.aws_sns.ITopic</code> | The topic that the default receiver will send messages to if no destinations are specified as inputs (input destinations are null/undefined). |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.AlertManagerConfiguration.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `defaultReceiver`<sup>Required</sup> <a name="defaultReceiver" id="cdk-extensions.aps.AlertManagerConfiguration.property.defaultReceiver"></a>

```typescript
public readonly defaultReceiver: AlertManagerReceiver;
```

- *Type:* cdk-extensions.aps.AlertManagerReceiver

The receiver configuring the destinations where all alerts that are not matched by a child route in the routing tree will be sent.

> [[Receiver Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#receiver)]([Receiver Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#receiver))

---

##### `defaultRoute`<sup>Required</sup> <a name="defaultRoute" id="cdk-extensions.aps.AlertManagerConfiguration.property.defaultRoute"></a>

```typescript
public readonly defaultRoute: AlertManagerRoute;
```

- *Type:* cdk-extensions.aps.AlertManagerRoute

The default root route withing the routing tree.

Serves as the default
configuration for all alerts. Sends alerts to the default receiver.

Must match all alerts and cannot be muted or deactivated. To add more
advanced configurations create additional routes as children of the
default route.

> [[Route OfficialDocumentation](https://prometheus.io/docs/alerting/latest/configuration/#route)]([Route OfficialDocumentation](https://prometheus.io/docs/alerting/latest/configuration/#route))

---

##### `inhibitRules`<sup>Required</sup> <a name="inhibitRules" id="cdk-extensions.aps.AlertManagerConfiguration.property.inhibitRules"></a>

```typescript
public readonly inhibitRules: AlertManagerInhibitRule[];
```

- *Type:* cdk-extensions.aps.AlertManagerInhibitRule[]

Collection of inhibit rules that mute an alert under scecific sets of circumstances.

> [[Inhibit Rule Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#inhibit_rule)]([Inhibit Rule Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#inhibit_rule))

---

##### `receivers`<sup>Required</sup> <a name="receivers" id="cdk-extensions.aps.AlertManagerConfiguration.property.receivers"></a>

```typescript
public readonly receivers: AlertManagerReceiver[];
```

- *Type:* cdk-extensions.aps.AlertManagerReceiver[]

Collection of notification integrations that provide the details for how and where generated alerts should be sent.

> [[Receiver Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#inhibit_rule)]([Receiver Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#inhibit_rule))

---

##### `templates`<sup>Required</sup> <a name="templates" id="cdk-extensions.aps.AlertManagerConfiguration.property.templates"></a>

```typescript
public readonly templates: AlertManagerTemplate[];
```

- *Type:* cdk-extensions.aps.AlertManagerTemplate[]

Collection of alert manager templates that the configuration uses to format the alerts that it sends.

---

##### `timeIntervals`<sup>Required</sup> <a name="timeIntervals" id="cdk-extensions.aps.AlertManagerConfiguration.property.timeIntervals"></a>

```typescript
public readonly timeIntervals: TimeInterval[];
```

- *Type:* cdk-extensions.aps.TimeInterval[]

Collection of timing configurations that can be used to control when specific alerts should be muted or activated.

> [[Time Interval Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#time_interval)]([Time Interval Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#time_interval))

---

##### `defaultTopic`<sup>Optional</sup> <a name="defaultTopic" id="cdk-extensions.aps.AlertManagerConfiguration.property.defaultTopic"></a>

```typescript
public readonly defaultTopic: ITopic;
```

- *Type:* aws-cdk-lib.aws_sns.ITopic

The topic that the default receiver will send messages to if no destinations are specified as inputs (input destinations are null/undefined).

The creation of this topic can be skipped to allow the defferred
configuration of default destination by providing an empty list of
destinations as inputs.

---


### AlertManagerInhibitRule <a name="AlertManagerInhibitRule" id="cdk-extensions.aps.AlertManagerInhibitRule"></a>

An inhibition rule mutes an alert (target) matching a set of matchers when an alert (source) exists that matches another set of matchers.

Both target
and source alerts can optionally be required to have the same label values
for a specified list of label names.

Semantically, a missing label and a label with an empty value are the same
thing. Therefore, if all the label names given for `equalLabels` are missing
from both the source and target alerts, the inhibition rule will apply.

To prevent an alert from inhibiting itself, an alert that matches both the
target and the source side of a rule cannot be inhibited by alerts for which
the same is true (including itself). However, we recommend to choose target
and source matchers in a way that alerts never match both sides. It is much
easier to reason about and does not trigger this special case.

> [[Inhibit Rule Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#inhibit_rule)]([Inhibit Rule Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#inhibit_rule))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.AlertManagerInhibitRule.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.AlertManagerInhibitRule(scope: AlertManagerConfiguration, id: string, options: AlertManagerInhibitRuleProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.Initializer.parameter.scope">scope</a></code> | <code>cdk-extensions.aps.AlertManagerConfiguration</code> | A CDK Construct that will serve as this construct's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.aps.AlertManagerInhibitRuleProps</code> | Arguments related to the configuration of this construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerInhibitRule.Initializer.parameter.scope"></a>

- *Type:* cdk-extensions.aps.AlertManagerConfiguration

A CDK Construct that will serve as this construct's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerInhibitRule.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.AlertManagerInhibitRule.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertManagerInhibitRuleProps

Arguments related to the configuration of this construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.addEqualLabel">addEqualLabel</a></code> | Adds a label that must be equal for both matched source and target alerts in order for the inhibition to take effect. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.addSourceMatcher">addSourceMatcher</a></code> | Adds a matcher for which one or more alerts have to exist in order for inhibition to take effect. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.addTargetMatcher">addTargetMatcher</a></code> | Adds a matcher that has to be fulfilled by a target alert in order to be muted. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.bind">bind</a></code> | Associates the inhibit rule with a construct that is handling the configuration of alert manager. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.AlertManagerInhibitRule.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addEqualLabel` <a name="addEqualLabel" id="cdk-extensions.aps.AlertManagerInhibitRule.addEqualLabel"></a>

```typescript
public addEqualLabel(label: string): AlertManagerInhibitRule
```

Adds a label that must be equal for both matched source and target alerts in order for the inhibition to take effect.

###### `label`<sup>Required</sup> <a name="label" id="cdk-extensions.aps.AlertManagerInhibitRule.addEqualLabel.parameter.label"></a>

- *Type:* string

The label to add.

---

##### `addSourceMatcher` <a name="addSourceMatcher" id="cdk-extensions.aps.AlertManagerInhibitRule.addSourceMatcher"></a>

```typescript
public addSourceMatcher(matcher: AlertManagerMatcher): AlertManagerInhibitRule
```

Adds a matcher for which one or more alerts have to exist in order for inhibition to take effect.

###### `matcher`<sup>Required</sup> <a name="matcher" id="cdk-extensions.aps.AlertManagerInhibitRule.addSourceMatcher.parameter.matcher"></a>

- *Type:* cdk-extensions.aps.AlertManagerMatcher

The source matcher to add.

---

##### `addTargetMatcher` <a name="addTargetMatcher" id="cdk-extensions.aps.AlertManagerInhibitRule.addTargetMatcher"></a>

```typescript
public addTargetMatcher(matcher: AlertManagerMatcher): AlertManagerInhibitRule
```

Adds a matcher that has to be fulfilled by a target alert in order to be muted.

###### `matcher`<sup>Required</sup> <a name="matcher" id="cdk-extensions.aps.AlertManagerInhibitRule.addTargetMatcher.parameter.matcher"></a>

- *Type:* cdk-extensions.aps.AlertManagerMatcher

The target matcher to add.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.AlertManagerInhibitRule.bind"></a>

```typescript
public bind(_scope: IConstruct): {[ key: string ]: any}
```

Associates the inhibit rule with a construct that is handling the configuration of alert manager.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.aps.AlertManagerInhibitRule.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.AlertManagerInhibitRule.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerInhibitRule.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.AlertManagerInhibitRule.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.property.equalLabels">equalLabels</a></code> | <code>string[]</code> | Collection of labels that must be equal for both matched source and target alerts in order for the inhibition to take effect. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.property.sourceMatchers">sourceMatchers</a></code> | <code>cdk-extensions.aps.AlertManagerMatcher[]</code> | Collection of matchers for which one or more alerts have to exist for the inhibition to take effect. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRule.property.targetMatchers">targetMatchers</a></code> | <code>cdk-extensions.aps.AlertManagerMatcher[]</code> | Collection of matchers that have to be fulfilled by the target alerts to be muted. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.AlertManagerInhibitRule.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `equalLabels`<sup>Required</sup> <a name="equalLabels" id="cdk-extensions.aps.AlertManagerInhibitRule.property.equalLabels"></a>

```typescript
public readonly equalLabels: string[];
```

- *Type:* string[]

Collection of labels that must be equal for both matched source and target alerts in order for the inhibition to take effect.

---

##### `sourceMatchers`<sup>Required</sup> <a name="sourceMatchers" id="cdk-extensions.aps.AlertManagerInhibitRule.property.sourceMatchers"></a>

```typescript
public readonly sourceMatchers: AlertManagerMatcher[];
```

- *Type:* cdk-extensions.aps.AlertManagerMatcher[]

Collection of matchers for which one or more alerts have to exist for the inhibition to take effect.

---

##### `targetMatchers`<sup>Required</sup> <a name="targetMatchers" id="cdk-extensions.aps.AlertManagerInhibitRule.property.targetMatchers"></a>

```typescript
public readonly targetMatchers: AlertManagerMatcher[];
```

- *Type:* cdk-extensions.aps.AlertManagerMatcher[]

Collection of matchers that have to be fulfilled by the target alerts to be muted.

---


### AlertManagerReceiver <a name="AlertManagerReceiver" id="cdk-extensions.aps.AlertManagerReceiver"></a>

Represents a notification integration within alert manager.

> [[Receiver configuration](https://prometheus.io/docs/alerting/latest/configuration/#receiver)]([Receiver configuration](https://prometheus.io/docs/alerting/latest/configuration/#receiver))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.AlertManagerReceiver.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.AlertManagerReceiver(scope: AlertManagerConfiguration, id: string, props?: AlertManagerReceiverProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.Initializer.parameter.scope">scope</a></code> | <code>cdk-extensions.aps.AlertManagerConfiguration</code> | A CDK Construct that will serve as this construct's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.aps.AlertManagerReceiverProps</code> | Arguments related to the configuration of this construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerReceiver.Initializer.parameter.scope"></a>

- *Type:* cdk-extensions.aps.AlertManagerConfiguration

A CDK Construct that will serve as this construct's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerReceiver.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.aps.AlertManagerReceiver.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.aps.AlertManagerReceiverProps

Arguments related to the configuration of this construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.addDestination">addDestination</a></code> | Adds a new generic destination that should receive alerts that have been routed to this receiver. |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.addSnsTopic">addSnsTopic</a></code> | Adds a new SNS destination that should receive alerts that have been routed to this receiver. |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.bind">bind</a></code> | Associates the receiver with a construct that is handling the configuration of alert manager that will consume the configuration. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.AlertManagerReceiver.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDestination` <a name="addDestination" id="cdk-extensions.aps.AlertManagerReceiver.addDestination"></a>

```typescript
public addDestination(destination: IAlertManagerDestination): AlertManagerReceiver
```

Adds a new generic destination that should receive alerts that have been routed to this receiver.

###### `destination`<sup>Required</sup> <a name="destination" id="cdk-extensions.aps.AlertManagerReceiver.addDestination.parameter.destination"></a>

- *Type:* cdk-extensions.aps.IAlertManagerDestination

The destination where alerts routed to this receiver should be sent.

---

##### `addSnsTopic` <a name="addSnsTopic" id="cdk-extensions.aps.AlertManagerReceiver.addSnsTopic"></a>

```typescript
public addSnsTopic(topic: ITopic, options?: AlertManagerSnsDestinationOptions): AlertManagerSnsDestination
```

Adds a new SNS destination that should receive alerts that have been routed to this receiver.

###### `topic`<sup>Required</sup> <a name="topic" id="cdk-extensions.aps.AlertManagerReceiver.addSnsTopic.parameter.topic"></a>

- *Type:* aws-cdk-lib.aws_sns.ITopic

The SNS topic where alerts should be sent.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.aps.AlertManagerReceiver.addSnsTopic.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertManagerSnsDestinationOptions

Options configuring how alerts should be sent to the SNS topic.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.AlertManagerReceiver.bind"></a>

```typescript
public bind(scope: IConstruct): {[ key: string ]: any}
```

Associates the receiver with a construct that is handling the configuration of alert manager that will consume the configuration.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerReceiver.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.AlertManagerReceiver.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerReceiver.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.AlertManagerReceiver.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.property.destinations">destinations</a></code> | <code>cdk-extensions.aps.IAlertManagerDestination[]</code> | Collection of destinations which define details for alerting providers where events routed to this receiver should be sent. |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiver.property.name">name</a></code> | <code>string</code> | The name of the receiver which can be referenced in the other parts of the configuration. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.AlertManagerReceiver.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `destinations`<sup>Required</sup> <a name="destinations" id="cdk-extensions.aps.AlertManagerReceiver.property.destinations"></a>

```typescript
public readonly destinations: IAlertManagerDestination[];
```

- *Type:* cdk-extensions.aps.IAlertManagerDestination[]

Collection of destinations which define details for alerting providers where events routed to this receiver should be sent.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.aps.AlertManagerReceiver.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the receiver which can be referenced in the other parts of the configuration.

---


### AlertManagerRoute <a name="AlertManagerRoute" id="cdk-extensions.aps.AlertManagerRoute"></a>

Defines a node in a routing tree and its children.

Its optional
configuration parameters are inherited from its parent node if not set.

Every alert enters the routing tree at the configured top-level route, which
must match all alerts (i.e. not have any configured matchers). It then
traverses the child nodes. If `continueMatching` is set to `false`, it stops
after the first matching child. If `continueMatching` is `true` on a
matching node, the alert will continue matching against subsequent siblings.
If an alert does not match any children of a node (no matching child nodes,
or none exist), the alert is handled based on the configuration parameters
of the current node.

> [[Route Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#route)]([Route Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#route))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.AlertManagerRoute.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.AlertManagerRoute(scope: AlertManagerConfiguration | AlertManagerRoute, id: string, options: AlertManagerRouteProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.Initializer.parameter.scope">scope</a></code> | <code>cdk-extensions.aps.AlertManagerConfiguration \| cdk-extensions.aps.AlertManagerRoute</code> | A CDK Construct that will serve as this construct's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.aps.AlertManagerRouteProps</code> | Arguments related to the configuration of this construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerRoute.Initializer.parameter.scope"></a>

- *Type:* cdk-extensions.aps.AlertManagerConfiguration | cdk-extensions.aps.AlertManagerRoute

A CDK Construct that will serve as this construct's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerRoute.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.AlertManagerRoute.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertManagerRouteProps

Arguments related to the configuration of this construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.addActiveTimeInterval">addActiveTimeInterval</a></code> | Adds a new time when the route should be active. The root node cannot have any active times. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.addChild">addChild</a></code> | Adds a new child route to this node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.addGroupByLabel">addGroupByLabel</a></code> | Adds a label by which incoming alerts are grouped together. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.addMatcher">addMatcher</a></code> | Adds a matcher that an alert has to fulfill to match the node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.addMuteTimeInterval">addMuteTimeInterval</a></code> | Adds a time when the route should be muted. The root node cannot have any mute times. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.bind">bind</a></code> | Associates the route with a construct that is handling the configuration of alert manager that will consume the configuration. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.AlertManagerRoute.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addActiveTimeInterval` <a name="addActiveTimeInterval" id="cdk-extensions.aps.AlertManagerRoute.addActiveTimeInterval"></a>

```typescript
public addActiveTimeInterval(interval: TimeInterval): AlertManagerRoute
```

Adds a new time when the route should be active. The root node cannot have any active times.

The route will send notifications only when active, but otherwise acts
normally (including ending the route-matching process if the
`continueMatching` option is not set).

###### `interval`<sup>Required</sup> <a name="interval" id="cdk-extensions.aps.AlertManagerRoute.addActiveTimeInterval.parameter.interval"></a>

- *Type:* cdk-extensions.aps.TimeInterval

The time interval when alerting on this route should be active.

---

##### `addChild` <a name="addChild" id="cdk-extensions.aps.AlertManagerRoute.addChild"></a>

```typescript
public addChild(id: string, options: AlertManagerRouteProps): AlertManagerRoute
```

Adds a new child route to this node.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.AlertManagerRoute.addChild.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.AlertManagerRoute.addChild.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertManagerRouteProps

The configuration options for the child route.

---

##### `addGroupByLabel` <a name="addGroupByLabel" id="cdk-extensions.aps.AlertManagerRoute.addGroupByLabel"></a>

```typescript
public addGroupByLabel(label: string): AlertManagerRoute
```

Adds a label by which incoming alerts are grouped together.

For example,
multiple alerts coming in for cluster=A and alertname=LatencyHigh would be
batched into a single group.

###### `label`<sup>Required</sup> <a name="label" id="cdk-extensions.aps.AlertManagerRoute.addGroupByLabel.parameter.label"></a>

- *Type:* string

The label by which incoming alerts should be grouped.

---

##### `addMatcher` <a name="addMatcher" id="cdk-extensions.aps.AlertManagerRoute.addMatcher"></a>

```typescript
public addMatcher(matcher: AlertManagerMatcher): AlertManagerRoute
```

Adds a matcher that an alert has to fulfill to match the node.

###### `matcher`<sup>Required</sup> <a name="matcher" id="cdk-extensions.aps.AlertManagerRoute.addMatcher.parameter.matcher"></a>

- *Type:* cdk-extensions.aps.AlertManagerMatcher

The matcher to associate.

---

##### `addMuteTimeInterval` <a name="addMuteTimeInterval" id="cdk-extensions.aps.AlertManagerRoute.addMuteTimeInterval"></a>

```typescript
public addMuteTimeInterval(interval: TimeInterval): AlertManagerRoute
```

Adds a time when the route should be muted. The root node cannot have any mute times.

When a route is muted it will not send any notifications, but otherwise
acts normally (including ending the route-matching process if the
`continueMatching` option is not set).

###### `interval`<sup>Required</sup> <a name="interval" id="cdk-extensions.aps.AlertManagerRoute.addMuteTimeInterval.parameter.interval"></a>

- *Type:* cdk-extensions.aps.TimeInterval

---

##### `bind` <a name="bind" id="cdk-extensions.aps.AlertManagerRoute.bind"></a>

```typescript
public bind(scope: IConstruct): {[ key: string ]: any}
```

Associates the route with a construct that is handling the configuration of alert manager that will consume the configuration.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerRoute.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.AlertManagerRoute.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerRoute.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.AlertManagerRoute.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.activeTimeIntervals">activeTimeIntervals</a></code> | <code>cdk-extensions.aps.TimeInterval[]</code> | Times when the route should be active. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.children">children</a></code> | <code>cdk-extensions.aps.AlertManagerRoute[]</code> | Optional child routes to add to the node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.groupByLabels">groupByLabels</a></code> | <code>string[]</code> | The labels by which incoming alerts are grouped together. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.matchers">matchers</a></code> | <code>cdk-extensions.aps.AlertManagerMatcher[]</code> | A list of matchers that an alert has to fulfill to match the node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.muteTimeIntervals">muteTimeIntervals</a></code> | <code>cdk-extensions.aps.TimeInterval[]</code> | Times when the route should be muted. The root node cannot have any mute times. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.receiver">receiver</a></code> | <code>cdk-extensions.aps.AlertManagerReceiver</code> | The receiver that should be the target of alerts that are generated by the node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.continueMatching">continueMatching</a></code> | <code>boolean</code> | Whether an alert should continue matching subsequent sibling nodes. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.groupInterval">groupInterval</a></code> | <code>aws-cdk-lib.Duration</code> | How long to wait before sending a notification about new alerts that are added to a group of alerts for which an initial notification has already been sent (usually ~5m or more). |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.groupWait">groupWait</a></code> | <code>aws-cdk-lib.Duration</code> | How long to initially wait to send a notification for a group of alerts. |
| <code><a href="#cdk-extensions.aps.AlertManagerRoute.property.repeatInterval">repeatInterval</a></code> | <code>aws-cdk-lib.Duration</code> | How long to wait before sending a notification again if it has already been sent successfully for an alert. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.AlertManagerRoute.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `activeTimeIntervals`<sup>Required</sup> <a name="activeTimeIntervals" id="cdk-extensions.aps.AlertManagerRoute.property.activeTimeIntervals"></a>

```typescript
public readonly activeTimeIntervals: TimeInterval[];
```

- *Type:* cdk-extensions.aps.TimeInterval[]

Times when the route should be active.

An empty value means that the route
is always active. Additionally, the root node cannot have any active
times.

The route will send notifications only when active, but otherwise acts
normally (including ending the route-matching process if the
`continueMatching` option is not set).

---

##### `children`<sup>Required</sup> <a name="children" id="cdk-extensions.aps.AlertManagerRoute.property.children"></a>

```typescript
public readonly children: AlertManagerRoute[];
```

- *Type:* cdk-extensions.aps.AlertManagerRoute[]

Optional child routes to add to the node.

---

##### `groupByLabels`<sup>Required</sup> <a name="groupByLabels" id="cdk-extensions.aps.AlertManagerRoute.property.groupByLabels"></a>

```typescript
public readonly groupByLabels: string[];
```

- *Type:* string[]

The labels by which incoming alerts are grouped together.

For example,
multiple alerts coming in for cluster=A and alertname=LatencyHigh would be
batched into a single group.

---

##### `matchers`<sup>Required</sup> <a name="matchers" id="cdk-extensions.aps.AlertManagerRoute.property.matchers"></a>

```typescript
public readonly matchers: AlertManagerMatcher[];
```

- *Type:* cdk-extensions.aps.AlertManagerMatcher[]

A list of matchers that an alert has to fulfill to match the node.

---

##### `muteTimeIntervals`<sup>Required</sup> <a name="muteTimeIntervals" id="cdk-extensions.aps.AlertManagerRoute.property.muteTimeIntervals"></a>

```typescript
public readonly muteTimeIntervals: TimeInterval[];
```

- *Type:* cdk-extensions.aps.TimeInterval[]

Times when the route should be muted. The root node cannot have any mute times.

When a route is muted it will not send any notifications, but otherwise
acts normally (including ending the route-matching process if the
`continueMatching` option is not set).

---

##### `receiver`<sup>Required</sup> <a name="receiver" id="cdk-extensions.aps.AlertManagerRoute.property.receiver"></a>

```typescript
public readonly receiver: AlertManagerReceiver;
```

- *Type:* cdk-extensions.aps.AlertManagerReceiver

The receiver that should be the target of alerts that are generated by the node.

---

##### `continueMatching`<sup>Optional</sup> <a name="continueMatching" id="cdk-extensions.aps.AlertManagerRoute.property.continueMatching"></a>

```typescript
public readonly continueMatching: boolean;
```

- *Type:* boolean

Whether an alert should continue matching subsequent sibling nodes.

---

##### `groupInterval`<sup>Optional</sup> <a name="groupInterval" id="cdk-extensions.aps.AlertManagerRoute.property.groupInterval"></a>

```typescript
public readonly groupInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to wait before sending a notification about new alerts that are added to a group of alerts for which an initial notification has already been sent (usually ~5m or more).

---

##### `groupWait`<sup>Optional</sup> <a name="groupWait" id="cdk-extensions.aps.AlertManagerRoute.property.groupWait"></a>

```typescript
public readonly groupWait: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to initially wait to send a notification for a group of alerts.

Allows to wait for an inhibiting alert to arrive or collect more initial
alerts for the same group (usually ~0s to few minutes).

---

##### `repeatInterval`<sup>Optional</sup> <a name="repeatInterval" id="cdk-extensions.aps.AlertManagerRoute.property.repeatInterval"></a>

```typescript
public readonly repeatInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to wait before sending a notification again if it has already been sent successfully for an alert.

(Usually ~3h or more).

---


### Assignment <a name="Assignment" id="cdk-extensions.sso.Assignment"></a>

Assigns access to a Principal for a specified AWS account using a specified permission set.

#### Initializers <a name="Initializers" id="cdk-extensions.sso.Assignment.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.Assignment(scope: Construct, id: string, props: AssignmentProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.Assignment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.sso.Assignment.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.sso.Assignment.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.sso.AssignmentProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.Assignment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.Assignment.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.sso.Assignment.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.sso.AssignmentProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.Assignment.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.sso.Assignment.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.sso.Assignment.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.sso.Assignment.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.Assignment.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.Assignment.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.sso.Assignment.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.sso.Assignment.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.sso.Assignment.isConstruct"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.Assignment.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.sso.Assignment.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.sso.Assignment.isOwnedResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.Assignment.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.Assignment.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.sso.Assignment.isResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.Assignment.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.Assignment.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.Assignment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.sso.Assignment.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.sso.Assignment.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.sso.Assignment.property.instance">instance</a></code> | <code>cdk-extensions.sso.IInstance</code> | The IAM Identity Center instance under which the operation will be executed. |
| <code><a href="#cdk-extensions.sso.Assignment.property.permissionSet">permissionSet</a></code> | <code>cdk-extensions.sso.IPermissionSet</code> | The permission set which governs the access being assigned. |
| <code><a href="#cdk-extensions.sso.Assignment.property.principal">principal</a></code> | <code>cdk-extensions.sso.IIdentityCenterPrincipal</code> | The IAM Identity Center principal you wish to grant permissions to. |
| <code><a href="#cdk-extensions.sso.Assignment.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_sso.CfnAssignment</code> | The underlying Assignment CloudFormation resource. |
| <code><a href="#cdk-extensions.sso.Assignment.property.target">target</a></code> | <code>cdk-extensions.sso.AssignmentTarget</code> | The resource you wish to grant the {@link principal} entity access to using the permissions defined in the {@link permissionSet}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.sso.Assignment.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.sso.Assignment.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.sso.Assignment.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk-extensions.sso.Assignment.property.instance"></a>

```typescript
public readonly instance: IInstance;
```

- *Type:* cdk-extensions.sso.IInstance

The IAM Identity Center instance under which the operation will be executed.

---

##### `permissionSet`<sup>Required</sup> <a name="permissionSet" id="cdk-extensions.sso.Assignment.property.permissionSet"></a>

```typescript
public readonly permissionSet: IPermissionSet;
```

- *Type:* cdk-extensions.sso.IPermissionSet

The permission set which governs the access being assigned.

The
permission set grants the {@link principal} permissions on
{@link target}.

---

##### `principal`<sup>Required</sup> <a name="principal" id="cdk-extensions.sso.Assignment.property.principal"></a>

```typescript
public readonly principal: IIdentityCenterPrincipal;
```

- *Type:* cdk-extensions.sso.IIdentityCenterPrincipal

The IAM Identity Center principal you wish to grant permissions to.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.sso.Assignment.property.resource"></a>

```typescript
public readonly resource: CfnAssignment;
```

- *Type:* aws-cdk-lib.aws_sso.CfnAssignment

The underlying Assignment CloudFormation resource.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk-extensions.sso.Assignment.property.target"></a>

```typescript
public readonly target: AssignmentTarget;
```

- *Type:* cdk-extensions.sso.AssignmentTarget

The resource you wish to grant the {@link principal} entity access to using the permissions defined in the {@link permissionSet}.

For example,
an AWS account.

---


### AwsIntegratedFargateCluster <a name="AwsIntegratedFargateCluster" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.Initializer"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

new eks_patterns.AwsIntegratedFargateCluster(scope: Construct, id: string, props: AwsIntegratedFargateClusterProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSecretsManagerSecret">registerSecretsManagerSecret</a></code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSsmParameterSecret">registerSsmParameterSecret</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `registerSecretsManagerSecret` <a name="registerSecretsManagerSecret" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSecretsManagerSecret"></a>

```typescript
public registerSecretsManagerSecret(id: string, secret: ISecret, options?: NamespacedExternalSecretOptions): ExternalSecret
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSecretsManagerSecret.parameter.id"></a>

- *Type:* string

---

###### `secret`<sup>Required</sup> <a name="secret" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSecretsManagerSecret.parameter.secret"></a>

- *Type:* aws-cdk-lib.aws_secretsmanager.ISecret

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSecretsManagerSecret.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.NamespacedExternalSecretOptions

---

##### `registerSsmParameterSecret` <a name="registerSsmParameterSecret" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSsmParameterSecret"></a>

```typescript
public registerSsmParameterSecret(id: string, parameter: IParameter, options?: NamespacedExternalSecretOptions): ExternalSecret
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSsmParameterSecret.parameter.id"></a>

- *Type:* string

---

###### `parameter`<sup>Required</sup> <a name="parameter" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSsmParameterSecret.parameter.parameter"></a>

- *Type:* aws-cdk-lib.aws_ssm.IParameter

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.registerSsmParameterSecret.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.NamespacedExternalSecretOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isConstruct"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

eks_patterns.AwsIntegratedFargateCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isOwnedResource"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

eks_patterns.AwsIntegratedFargateCluster.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isResource"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

eks_patterns.AwsIntegratedFargateCluster.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_eks.FargateCluster</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.adotCollector">adotCollector</a></code> | <code>cdk-extensions.k8s_aws.AdotCollector</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.externalSecrets">externalSecrets</a></code> | <code>cdk-extensions.k8s_aws.ExternalSecretsOperator</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.fargateLogger">fargateLogger</a></code> | <code>cdk-extensions.k8s_aws.FargateLogger</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.prometheusService">prometheusService</a></code> | <code>cdk-extensions.k8s_fargate.Prometheus</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.prometheusWorkspace">prometheusWorkspace</a></code> | <code>cdk-extensions.aps.IWorkspace</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.route53Dns">route53Dns</a></code> | <code>cdk-extensions.k8s_aws.Route53Dns</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.resource"></a>

```typescript
public readonly resource: FargateCluster;
```

- *Type:* aws-cdk-lib.aws_eks.FargateCluster

---

##### `adotCollector`<sup>Optional</sup> <a name="adotCollector" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.adotCollector"></a>

```typescript
public readonly adotCollector: AdotCollector;
```

- *Type:* cdk-extensions.k8s_aws.AdotCollector

---

##### `externalSecrets`<sup>Optional</sup> <a name="externalSecrets" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.externalSecrets"></a>

```typescript
public readonly externalSecrets: ExternalSecretsOperator;
```

- *Type:* cdk-extensions.k8s_aws.ExternalSecretsOperator

---

##### `fargateLogger`<sup>Optional</sup> <a name="fargateLogger" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.fargateLogger"></a>

```typescript
public readonly fargateLogger: FargateLogger;
```

- *Type:* cdk-extensions.k8s_aws.FargateLogger

---

##### `prometheusService`<sup>Optional</sup> <a name="prometheusService" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.prometheusService"></a>

```typescript
public readonly prometheusService: Prometheus;
```

- *Type:* cdk-extensions.k8s_fargate.Prometheus

---

##### `prometheusWorkspace`<sup>Optional</sup> <a name="prometheusWorkspace" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.prometheusWorkspace"></a>

```typescript
public readonly prometheusWorkspace: IWorkspace;
```

- *Type:* cdk-extensions.aps.IWorkspace

---

##### `route53Dns`<sup>Optional</sup> <a name="route53Dns" id="cdk-extensions.eks_patterns.AwsIntegratedFargateCluster.property.route53Dns"></a>

```typescript
public readonly route53Dns: Route53Dns;
```

- *Type:* cdk-extensions.k8s_aws.Route53Dns

---


### AwsLoggingStack <a name="AwsLoggingStack" id="cdk-extensions.stacks.AwsLoggingStack"></a>

Creates a Stack that deploys a logging strategy for several AWS services.

Stack creates a Glue Database using cdk-extensions Database, deploys
cdk-extensions/s3-buckets patterns for each service, and utilizes methods exposed
by cdk-extensions/s3-buckets S3AccessLogsBucket to enable logging for each created
bucket.

> [{@link aws-s3-buckets!WafLogsBucket | cdk-extensions/s3-buckets WafLogsBucket}]({@link aws-s3-buckets!WafLogsBucket | cdk-extensions/s3-buckets WafLogsBucket})

#### Initializers <a name="Initializers" id="cdk-extensions.stacks.AwsLoggingStack.Initializer"></a>

```typescript
import { stacks } from 'cdk-extensions'

new stacks.AwsLoggingStack(scope: Construct, id: string, props?: AwsLoggingStackProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.stacks.AwsLoggingStackProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.stacks.AwsLoggingStack.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.stacks.AwsLoggingStack.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.stacks.AwsLoggingStack.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.stacks.AwsLoggingStackProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.addDependency">addDependency</a></code> | Add a dependency between this stack and another stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.addMetadata">addMetadata</a></code> | Adds an arbitary key-value pair, with information you want to record about the stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.addTransform">addTransform</a></code> | Add a Transform to this stack. A Transform is a macro that AWS CloudFormation uses to process your template. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.exportStringListValue">exportStringListValue</a></code> | Create a CloudFormation Export for a string list value. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.exportValue">exportValue</a></code> | Create a CloudFormation Export for a string value. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.formatArn">formatArn</a></code> | Creates an ARN from components. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.getLogicalId">getLogicalId</a></code> | Allocates a stack-unique CloudFormation-compatible logical identity for a specific resource. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.regionalFact">regionalFact</a></code> | Look up a fact value for the given fact for the region of this stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.renameLogicalId">renameLogicalId</a></code> | Rename a generated logical identities. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.reportMissingContextKey">reportMissingContextKey</a></code> | Indicate that a context key was expected. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.resolve">resolve</a></code> | Resolve a tokenized value in the context of the current stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.splitArn">splitArn</a></code> | Splits the provided ARN into its components. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.toJsonString">toJsonString</a></code> | Convert an object, potentially containing tokens, to a JSON string. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.toYamlString">toYamlString</a></code> | Convert an object, potentially containing tokens, to a YAML string. |

---

##### `toString` <a name="toString" id="cdk-extensions.stacks.AwsLoggingStack.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk-extensions.stacks.AwsLoggingStack.addDependency"></a>

```typescript
public addDependency(target: Stack, reason?: string): void
```

Add a dependency between this stack and another stack.

This can be used to define dependencies between any two stacks within an
app, and also supports nested stacks.

###### `target`<sup>Required</sup> <a name="target" id="cdk-extensions.stacks.AwsLoggingStack.addDependency.parameter.target"></a>

- *Type:* aws-cdk-lib.Stack

---

###### `reason`<sup>Optional</sup> <a name="reason" id="cdk-extensions.stacks.AwsLoggingStack.addDependency.parameter.reason"></a>

- *Type:* string

---

##### `addMetadata` <a name="addMetadata" id="cdk-extensions.stacks.AwsLoggingStack.addMetadata"></a>

```typescript
public addMetadata(key: string, value: any): void
```

Adds an arbitary key-value pair, with information you want to record about the stack.

These get translated to the Metadata section of the generated template.

> [https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/metadata-section-structure.html](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/metadata-section-structure.html)

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.stacks.AwsLoggingStack.addMetadata.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.stacks.AwsLoggingStack.addMetadata.parameter.value"></a>

- *Type:* any

---

##### `addTransform` <a name="addTransform" id="cdk-extensions.stacks.AwsLoggingStack.addTransform"></a>

```typescript
public addTransform(transform: string): void
```

Add a Transform to this stack. A Transform is a macro that AWS CloudFormation uses to process your template.

Duplicate values are removed when stack is synthesized.

> [https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/transform-section-structure.html](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/transform-section-structure.html)

*Example*

```typescript
declare const stack: Stack;

stack.addTransform('AWS::Serverless-2016-10-31')
```


###### `transform`<sup>Required</sup> <a name="transform" id="cdk-extensions.stacks.AwsLoggingStack.addTransform.parameter.transform"></a>

- *Type:* string

The transform to add.

---

##### `exportStringListValue` <a name="exportStringListValue" id="cdk-extensions.stacks.AwsLoggingStack.exportStringListValue"></a>

```typescript
public exportStringListValue(exportedValue: any, options?: ExportValueOptions): string[]
```

Create a CloudFormation Export for a string list value.

Returns a string list representing the corresponding `Fn.importValue()`
expression for this Export. The export expression is automatically wrapped with an
`Fn::Join` and the import value with an `Fn::Split`, since CloudFormation can only
export strings. You can control the name for the export by passing the `name` option.

If you don't supply a value for `name`, the value you're exporting must be
a Resource attribute (for example: `bucket.bucketName`) and it will be
given the same name as the automatic cross-stack reference that would be created
if you used the attribute in another Stack.

One of the uses for this method is to *remove* the relationship between
two Stacks established by automatic cross-stack references. It will
temporarily ensure that the CloudFormation Export still exists while you
remove the reference from the consuming stack. After that, you can remove
the resource and the manual export.

See `exportValue` for an example of this process.

###### `exportedValue`<sup>Required</sup> <a name="exportedValue" id="cdk-extensions.stacks.AwsLoggingStack.exportStringListValue.parameter.exportedValue"></a>

- *Type:* any

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.stacks.AwsLoggingStack.exportStringListValue.parameter.options"></a>

- *Type:* aws-cdk-lib.ExportValueOptions

---

##### `exportValue` <a name="exportValue" id="cdk-extensions.stacks.AwsLoggingStack.exportValue"></a>

```typescript
public exportValue(exportedValue: any, options?: ExportValueOptions): string
```

Create a CloudFormation Export for a string value.

Returns a string representing the corresponding `Fn.importValue()`
expression for this Export. You can control the name for the export by
passing the `name` option.

If you don't supply a value for `name`, the value you're exporting must be
a Resource attribute (for example: `bucket.bucketName`) and it will be
given the same name as the automatic cross-stack reference that would be created
if you used the attribute in another Stack.

One of the uses for this method is to *remove* the relationship between
two Stacks established by automatic cross-stack references. It will
temporarily ensure that the CloudFormation Export still exists while you
remove the reference from the consuming stack. After that, you can remove
the resource and the manual export.

## Example

Here is how the process works. Let's say there are two stacks,
`producerStack` and `consumerStack`, and `producerStack` has a bucket
called `bucket`, which is referenced by `consumerStack` (perhaps because
an AWS Lambda Function writes into it, or something like that).

It is not safe to remove `producerStack.bucket` because as the bucket is being
deleted, `consumerStack` might still be using it.

Instead, the process takes two deployments:

### Deployment 1: break the relationship

- Make sure `consumerStack` no longer references `bucket.bucketName` (maybe the consumer
  stack now uses its own bucket, or it writes to an AWS DynamoDB table, or maybe you just
  remove the Lambda Function altogether).
- In the `ProducerStack` class, call `this.exportValue(this.bucket.bucketName)`. This
  will make sure the CloudFormation Export continues to exist while the relationship
  between the two stacks is being broken.
- Deploy (this will effectively only change the `consumerStack`, but it's safe to deploy both).

### Deployment 2: remove the bucket resource

- You are now free to remove the `bucket` resource from `producerStack`.
- Don't forget to remove the `exportValue()` call as well.
- Deploy again (this time only the `producerStack` will be changed -- the bucket will be deleted).

###### `exportedValue`<sup>Required</sup> <a name="exportedValue" id="cdk-extensions.stacks.AwsLoggingStack.exportValue.parameter.exportedValue"></a>

- *Type:* any

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.stacks.AwsLoggingStack.exportValue.parameter.options"></a>

- *Type:* aws-cdk-lib.ExportValueOptions

---

##### `formatArn` <a name="formatArn" id="cdk-extensions.stacks.AwsLoggingStack.formatArn"></a>

```typescript
public formatArn(components: ArnComponents): string
```

Creates an ARN from components.

If `partition`, `region` or `account` are not specified, the stack's
partition, region and account will be used.

If any component is the empty string, an empty string will be inserted
into the generated ARN at the location that component corresponds to.

The ARN will be formatted as follows:

  arn:{partition}:{service}:{region}:{account}:{resource}{sep}{resource-name}

The required ARN pieces that are omitted will be taken from the stack that
the 'scope' is attached to. If all ARN pieces are supplied, the supplied scope
can be 'undefined'.

###### `components`<sup>Required</sup> <a name="components" id="cdk-extensions.stacks.AwsLoggingStack.formatArn.parameter.components"></a>

- *Type:* aws-cdk-lib.ArnComponents

---

##### `getLogicalId` <a name="getLogicalId" id="cdk-extensions.stacks.AwsLoggingStack.getLogicalId"></a>

```typescript
public getLogicalId(element: CfnElement): string
```

Allocates a stack-unique CloudFormation-compatible logical identity for a specific resource.

This method is called when a `CfnElement` is created and used to render the
initial logical identity of resources. Logical ID renames are applied at
this stage.

This method uses the protected method `allocateLogicalId` to render the
logical ID for an element. To modify the naming scheme, extend the `Stack`
class and override this method.

###### `element`<sup>Required</sup> <a name="element" id="cdk-extensions.stacks.AwsLoggingStack.getLogicalId.parameter.element"></a>

- *Type:* aws-cdk-lib.CfnElement

The CloudFormation element for which a logical identity is needed.

---

##### `regionalFact` <a name="regionalFact" id="cdk-extensions.stacks.AwsLoggingStack.regionalFact"></a>

```typescript
public regionalFact(factName: string, defaultValue?: string): string
```

Look up a fact value for the given fact for the region of this stack.

Will return a definite value only if the region of the current stack is resolved.
If not, a lookup map will be added to the stack and the lookup will be done at
CDK deployment time.

What regions will be included in the lookup map is controlled by the
`@aws-cdk/core:target-partitions` context value: it must be set to a list
of partitions, and only regions from the given partitions will be included.
If no such context key is set, all regions will be included.

This function is intended to be used by construct library authors. Application
builders can rely on the abstractions offered by construct libraries and do
not have to worry about regional facts.

If `defaultValue` is not given, it is an error if the fact is unknown for
the given region.

###### `factName`<sup>Required</sup> <a name="factName" id="cdk-extensions.stacks.AwsLoggingStack.regionalFact.parameter.factName"></a>

- *Type:* string

---

###### `defaultValue`<sup>Optional</sup> <a name="defaultValue" id="cdk-extensions.stacks.AwsLoggingStack.regionalFact.parameter.defaultValue"></a>

- *Type:* string

---

##### `renameLogicalId` <a name="renameLogicalId" id="cdk-extensions.stacks.AwsLoggingStack.renameLogicalId"></a>

```typescript
public renameLogicalId(oldId: string, newId: string): void
```

Rename a generated logical identities.

To modify the naming scheme strategy, extend the `Stack` class and
override the `allocateLogicalId` method.

###### `oldId`<sup>Required</sup> <a name="oldId" id="cdk-extensions.stacks.AwsLoggingStack.renameLogicalId.parameter.oldId"></a>

- *Type:* string

---

###### `newId`<sup>Required</sup> <a name="newId" id="cdk-extensions.stacks.AwsLoggingStack.renameLogicalId.parameter.newId"></a>

- *Type:* string

---

##### `reportMissingContextKey` <a name="reportMissingContextKey" id="cdk-extensions.stacks.AwsLoggingStack.reportMissingContextKey"></a>

```typescript
public reportMissingContextKey(report: MissingContext): void
```

Indicate that a context key was expected.

Contains instructions which will be emitted into the cloud assembly on how
the key should be supplied.

###### `report`<sup>Required</sup> <a name="report" id="cdk-extensions.stacks.AwsLoggingStack.reportMissingContextKey.parameter.report"></a>

- *Type:* aws-cdk-lib.cloud_assembly_schema.MissingContext

The set of parameters needed to obtain the context.

---

##### `resolve` <a name="resolve" id="cdk-extensions.stacks.AwsLoggingStack.resolve"></a>

```typescript
public resolve(obj: any): any
```

Resolve a tokenized value in the context of the current stack.

###### `obj`<sup>Required</sup> <a name="obj" id="cdk-extensions.stacks.AwsLoggingStack.resolve.parameter.obj"></a>

- *Type:* any

---

##### `splitArn` <a name="splitArn" id="cdk-extensions.stacks.AwsLoggingStack.splitArn"></a>

```typescript
public splitArn(arn: string, arnFormat: ArnFormat): ArnComponents
```

Splits the provided ARN into its components.

Works both if 'arn' is a string like 'arn:aws:s3:::bucket',
and a Token representing a dynamic CloudFormation expression
(in which case the returned components will also be dynamic CloudFormation expressions,
encoded as Tokens).

###### `arn`<sup>Required</sup> <a name="arn" id="cdk-extensions.stacks.AwsLoggingStack.splitArn.parameter.arn"></a>

- *Type:* string

the ARN to split into its components.

---

###### `arnFormat`<sup>Required</sup> <a name="arnFormat" id="cdk-extensions.stacks.AwsLoggingStack.splitArn.parameter.arnFormat"></a>

- *Type:* aws-cdk-lib.ArnFormat

the expected format of 'arn' - depends on what format the service 'arn' represents uses.

---

##### `toJsonString` <a name="toJsonString" id="cdk-extensions.stacks.AwsLoggingStack.toJsonString"></a>

```typescript
public toJsonString(obj: any, space?: number): string
```

Convert an object, potentially containing tokens, to a JSON string.

###### `obj`<sup>Required</sup> <a name="obj" id="cdk-extensions.stacks.AwsLoggingStack.toJsonString.parameter.obj"></a>

- *Type:* any

---

###### `space`<sup>Optional</sup> <a name="space" id="cdk-extensions.stacks.AwsLoggingStack.toJsonString.parameter.space"></a>

- *Type:* number

---

##### `toYamlString` <a name="toYamlString" id="cdk-extensions.stacks.AwsLoggingStack.toYamlString"></a>

```typescript
public toYamlString(obj: any): string
```

Convert an object, potentially containing tokens, to a YAML string.

###### `obj`<sup>Required</sup> <a name="obj" id="cdk-extensions.stacks.AwsLoggingStack.toYamlString.parameter.obj"></a>

- *Type:* any

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.isStack">isStack</a></code> | Return whether the given object is a Stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.of">of</a></code> | Looks up the first stack scope in which `construct` is defined. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.stacks.AwsLoggingStack.isConstruct"></a>

```typescript
import { stacks } from 'cdk-extensions'

stacks.AwsLoggingStack.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.stacks.AwsLoggingStack.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isStack` <a name="isStack" id="cdk-extensions.stacks.AwsLoggingStack.isStack"></a>

```typescript
import { stacks } from 'cdk-extensions'

stacks.AwsLoggingStack.isStack(x: any)
```

Return whether the given object is a Stack.

We do attribute detection since we can't reliably use 'instanceof'.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.stacks.AwsLoggingStack.isStack.parameter.x"></a>

- *Type:* any

---

##### `of` <a name="of" id="cdk-extensions.stacks.AwsLoggingStack.of"></a>

```typescript
import { stacks } from 'cdk-extensions'

stacks.AwsLoggingStack.of(construct: IConstruct)
```

Looks up the first stack scope in which `construct` is defined.

Fails if there is no stack up the tree.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.stacks.AwsLoggingStack.of.parameter.construct"></a>

- *Type:* constructs.IConstruct

The construct to start the search from.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.account">account</a></code> | <code>string</code> | The AWS account into which this stack will be deployed. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.artifactId">artifactId</a></code> | <code>string</code> | The ID of the cloud assembly artifact for this stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.availabilityZones">availabilityZones</a></code> | <code>string[]</code> | Returns the list of AZs that are available in the AWS environment (account/region) associated with this stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.bundlingRequired">bundlingRequired</a></code> | <code>boolean</code> | Indicates whether the stack requires bundling or not. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.dependencies">dependencies</a></code> | <code>aws-cdk-lib.Stack[]</code> | Return the stacks this stack depends on. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.environment">environment</a></code> | <code>string</code> | The environment coordinates in which this stack is deployed. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.nested">nested</a></code> | <code>boolean</code> | Indicates if this is a nested stack, in which case `parentStack` will include a reference to it's parent. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.notificationArns">notificationArns</a></code> | <code>string[]</code> | Returns the list of notification Amazon Resource Names (ARNs) for the current stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.partition">partition</a></code> | <code>string</code> | The partition in which this stack is defined. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.region">region</a></code> | <code>string</code> | The AWS region into which this stack will be deployed (e.g. `us-west-2`). |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.stackId">stackId</a></code> | <code>string</code> | The ID of the stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.stackName">stackName</a></code> | <code>string</code> | The concrete CloudFormation physical stack name. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.synthesizer">synthesizer</a></code> | <code>aws-cdk-lib.IStackSynthesizer</code> | Synthesis method for this stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.tags">tags</a></code> | <code>aws-cdk-lib.TagManager</code> | Tags to be applied to the stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.templateFile">templateFile</a></code> | <code>string</code> | The name of the CloudFormation template file emitted to the output directory during synthesis. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.templateOptions">templateOptions</a></code> | <code>aws-cdk-lib.ITemplateOptions</code> | Options for CloudFormation template (like version, transform, description). |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.urlSuffix">urlSuffix</a></code> | <code>string</code> | The Amazon domain suffix for the region in which this stack is defined. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.nestedStackParent">nestedStackParent</a></code> | <code>aws-cdk-lib.Stack</code> | If this is a nested stack, returns it's parent stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.nestedStackResource">nestedStackResource</a></code> | <code>aws-cdk-lib.CfnResource</code> | If this is a nested stack, this represents its `AWS::CloudFormation::Stack` resource. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.terminationProtection">terminationProtection</a></code> | <code>boolean</code> | Whether termination protection is enabled for this stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.albLogsBucket">albLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.AlbLogsBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.cloudfrontLogsBucket">cloudfrontLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.CloudfrontLogsBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.cloudtrailLogsBucket">cloudtrailLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.CloudtrailBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.databaseName">databaseName</a></code> | <code>string</code> | Name for the AWS Logs Glue Database. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.flowLogsBucket">flowLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.FlowLogsBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.flowLogsFormat">flowLogsFormat</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | A cdk-extentions/ec2 {@link aws-ec2!FlowLogFormat } object defining the desired formatting for Flow Logs. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.s3AccessLogsBucket">s3AccessLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.S3AccessLogsBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.sesLogsBucket">sesLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.SesLogsBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.standardizeNames">standardizeNames</a></code> | <code>boolean</code> | Boolean for using standardized names (i.e. "aws-${service}-logs-${account} -${region}") for the created S3 Buckets. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.wafLogsBucket">wafLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.WafLogsBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStack.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.stacks.AwsLoggingStack.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `account`<sup>Required</sup> <a name="account" id="cdk-extensions.stacks.AwsLoggingStack.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string

The AWS account into which this stack will be deployed.

This value is resolved according to the following rules:

1. The value provided to `env.account` when the stack is defined. This can
   either be a concrete account (e.g. `585695031111`) or the
   `Aws.ACCOUNT_ID` token.
3. `Aws.ACCOUNT_ID`, which represents the CloudFormation intrinsic reference
   `{ "Ref": "AWS::AccountId" }` encoded as a string token.

Preferably, you should use the return value as an opaque string and not
attempt to parse it to implement your logic. If you do, you must first
check that it is a concrete value an not an unresolved token. If this
value is an unresolved token (`Token.isUnresolved(stack.account)` returns
`true`), this implies that the user wishes that this stack will synthesize
into a **account-agnostic template**. In this case, your code should either
fail (throw an error, emit a synth error using `Annotations.of(construct).addError()`) or
implement some other region-agnostic behavior.

---

##### `artifactId`<sup>Required</sup> <a name="artifactId" id="cdk-extensions.stacks.AwsLoggingStack.property.artifactId"></a>

```typescript
public readonly artifactId: string;
```

- *Type:* string

The ID of the cloud assembly artifact for this stack.

---

##### `availabilityZones`<sup>Required</sup> <a name="availabilityZones" id="cdk-extensions.stacks.AwsLoggingStack.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* string[]

Returns the list of AZs that are available in the AWS environment (account/region) associated with this stack.

If the stack is environment-agnostic (either account and/or region are
tokens), this property will return an array with 2 tokens that will resolve
at deploy-time to the first two availability zones returned from CloudFormation's
`Fn::GetAZs` intrinsic function.

If they are not available in the context, returns a set of dummy values and
reports them as missing, and let the CLI resolve them by calling EC2
`DescribeAvailabilityZones` on the target environment.

To specify a different strategy for selecting availability zones override this method.

---

##### `bundlingRequired`<sup>Required</sup> <a name="bundlingRequired" id="cdk-extensions.stacks.AwsLoggingStack.property.bundlingRequired"></a>

```typescript
public readonly bundlingRequired: boolean;
```

- *Type:* boolean

Indicates whether the stack requires bundling or not.

---

##### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk-extensions.stacks.AwsLoggingStack.property.dependencies"></a>

```typescript
public readonly dependencies: Stack[];
```

- *Type:* aws-cdk-lib.Stack[]

Return the stacks this stack depends on.

---

##### `environment`<sup>Required</sup> <a name="environment" id="cdk-extensions.stacks.AwsLoggingStack.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

The environment coordinates in which this stack is deployed.

In the form
`aws://account/region`. Use `stack.account` and `stack.region` to obtain
the specific values, no need to parse.

You can use this value to determine if two stacks are targeting the same
environment.

If either `stack.account` or `stack.region` are not concrete values (e.g.
`Aws.ACCOUNT_ID` or `Aws.REGION`) the special strings `unknown-account` and/or
`unknown-region` will be used respectively to indicate this stack is
region/account-agnostic.

---

##### `nested`<sup>Required</sup> <a name="nested" id="cdk-extensions.stacks.AwsLoggingStack.property.nested"></a>

```typescript
public readonly nested: boolean;
```

- *Type:* boolean

Indicates if this is a nested stack, in which case `parentStack` will include a reference to it's parent.

---

##### `notificationArns`<sup>Required</sup> <a name="notificationArns" id="cdk-extensions.stacks.AwsLoggingStack.property.notificationArns"></a>

```typescript
public readonly notificationArns: string[];
```

- *Type:* string[]

Returns the list of notification Amazon Resource Names (ARNs) for the current stack.

---

##### `partition`<sup>Required</sup> <a name="partition" id="cdk-extensions.stacks.AwsLoggingStack.property.partition"></a>

```typescript
public readonly partition: string;
```

- *Type:* string

The partition in which this stack is defined.

---

##### `region`<sup>Required</sup> <a name="region" id="cdk-extensions.stacks.AwsLoggingStack.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

The AWS region into which this stack will be deployed (e.g. `us-west-2`).

This value is resolved according to the following rules:

1. The value provided to `env.region` when the stack is defined. This can
   either be a concrete region (e.g. `us-west-2`) or the `Aws.REGION`
   token.
3. `Aws.REGION`, which is represents the CloudFormation intrinsic reference
   `{ "Ref": "AWS::Region" }` encoded as a string token.

Preferably, you should use the return value as an opaque string and not
attempt to parse it to implement your logic. If you do, you must first
check that it is a concrete value an not an unresolved token. If this
value is an unresolved token (`Token.isUnresolved(stack.region)` returns
`true`), this implies that the user wishes that this stack will synthesize
into a **region-agnostic template**. In this case, your code should either
fail (throw an error, emit a synth error using `Annotations.of(construct).addError()`) or
implement some other region-agnostic behavior.

---

##### `stackId`<sup>Required</sup> <a name="stackId" id="cdk-extensions.stacks.AwsLoggingStack.property.stackId"></a>

```typescript
public readonly stackId: string;
```

- *Type:* string

The ID of the stack.

---

*Example*

```typescript
// After resolving, looks like
'arn:aws:cloudformation:us-west-2:123456789012:stack/teststack/51af3dc0-da77-11e4-872e-1234567db123'
```


##### `stackName`<sup>Required</sup> <a name="stackName" id="cdk-extensions.stacks.AwsLoggingStack.property.stackName"></a>

```typescript
public readonly stackName: string;
```

- *Type:* string

The concrete CloudFormation physical stack name.

This is either the name defined explicitly in the `stackName` prop or
allocated based on the stack's location in the construct tree. Stacks that
are directly defined under the app use their construct `id` as their stack
name. Stacks that are defined deeper within the tree will use a hashed naming
scheme based on the construct path to ensure uniqueness.

If you wish to obtain the deploy-time AWS::StackName intrinsic,
you can use `Aws.STACK_NAME` directly.

---

##### `synthesizer`<sup>Required</sup> <a name="synthesizer" id="cdk-extensions.stacks.AwsLoggingStack.property.synthesizer"></a>

```typescript
public readonly synthesizer: IStackSynthesizer;
```

- *Type:* aws-cdk-lib.IStackSynthesizer

Synthesis method for this stack.

---

##### `tags`<sup>Required</sup> <a name="tags" id="cdk-extensions.stacks.AwsLoggingStack.property.tags"></a>

```typescript
public readonly tags: TagManager;
```

- *Type:* aws-cdk-lib.TagManager

Tags to be applied to the stack.

---

##### `templateFile`<sup>Required</sup> <a name="templateFile" id="cdk-extensions.stacks.AwsLoggingStack.property.templateFile"></a>

```typescript
public readonly templateFile: string;
```

- *Type:* string

The name of the CloudFormation template file emitted to the output directory during synthesis.

Example value: `MyStack.template.json`

---

##### `templateOptions`<sup>Required</sup> <a name="templateOptions" id="cdk-extensions.stacks.AwsLoggingStack.property.templateOptions"></a>

```typescript
public readonly templateOptions: ITemplateOptions;
```

- *Type:* aws-cdk-lib.ITemplateOptions

Options for CloudFormation template (like version, transform, description).

---

##### `urlSuffix`<sup>Required</sup> <a name="urlSuffix" id="cdk-extensions.stacks.AwsLoggingStack.property.urlSuffix"></a>

```typescript
public readonly urlSuffix: string;
```

- *Type:* string

The Amazon domain suffix for the region in which this stack is defined.

---

##### `nestedStackParent`<sup>Optional</sup> <a name="nestedStackParent" id="cdk-extensions.stacks.AwsLoggingStack.property.nestedStackParent"></a>

```typescript
public readonly nestedStackParent: Stack;
```

- *Type:* aws-cdk-lib.Stack

If this is a nested stack, returns it's parent stack.

---

##### `nestedStackResource`<sup>Optional</sup> <a name="nestedStackResource" id="cdk-extensions.stacks.AwsLoggingStack.property.nestedStackResource"></a>

```typescript
public readonly nestedStackResource: CfnResource;
```

- *Type:* aws-cdk-lib.CfnResource

If this is a nested stack, this represents its `AWS::CloudFormation::Stack` resource.

`undefined` for top-level (non-nested) stacks.

---

##### `terminationProtection`<sup>Optional</sup> <a name="terminationProtection" id="cdk-extensions.stacks.AwsLoggingStack.property.terminationProtection"></a>

```typescript
public readonly terminationProtection: boolean;
```

- *Type:* boolean

Whether termination protection is enabled for this stack.

---

##### `albLogsBucket`<sup>Required</sup> <a name="albLogsBucket" id="cdk-extensions.stacks.AwsLoggingStack.property.albLogsBucket"></a>

```typescript
public readonly albLogsBucket: AlbLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.AlbLogsBucket

---

##### `cloudfrontLogsBucket`<sup>Required</sup> <a name="cloudfrontLogsBucket" id="cdk-extensions.stacks.AwsLoggingStack.property.cloudfrontLogsBucket"></a>

```typescript
public readonly cloudfrontLogsBucket: CloudfrontLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.CloudfrontLogsBucket

---

##### `cloudtrailLogsBucket`<sup>Required</sup> <a name="cloudtrailLogsBucket" id="cdk-extensions.stacks.AwsLoggingStack.property.cloudtrailLogsBucket"></a>

```typescript
public readonly cloudtrailLogsBucket: CloudtrailBucket;
```

- *Type:* cdk-extensions.s3_buckets.CloudtrailBucket

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.stacks.AwsLoggingStack.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="cdk-extensions.stacks.AwsLoggingStack.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

Name for the AWS Logs Glue Database.

---

##### `flowLogsBucket`<sup>Required</sup> <a name="flowLogsBucket" id="cdk-extensions.stacks.AwsLoggingStack.property.flowLogsBucket"></a>

```typescript
public readonly flowLogsBucket: FlowLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.FlowLogsBucket

---

##### `flowLogsFormat`<sup>Required</sup> <a name="flowLogsFormat" id="cdk-extensions.stacks.AwsLoggingStack.property.flowLogsFormat"></a>

```typescript
public readonly flowLogsFormat: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

A cdk-extentions/ec2 {@link aws-ec2!FlowLogFormat } object defining the desired formatting for Flow Logs.

---

##### `s3AccessLogsBucket`<sup>Required</sup> <a name="s3AccessLogsBucket" id="cdk-extensions.stacks.AwsLoggingStack.property.s3AccessLogsBucket"></a>

```typescript
public readonly s3AccessLogsBucket: S3AccessLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.S3AccessLogsBucket

---

##### `sesLogsBucket`<sup>Required</sup> <a name="sesLogsBucket" id="cdk-extensions.stacks.AwsLoggingStack.property.sesLogsBucket"></a>

```typescript
public readonly sesLogsBucket: SesLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.SesLogsBucket

---

##### `standardizeNames`<sup>Required</sup> <a name="standardizeNames" id="cdk-extensions.stacks.AwsLoggingStack.property.standardizeNames"></a>

```typescript
public readonly standardizeNames: boolean;
```

- *Type:* boolean

Boolean for using standardized names (i.e. "aws-${service}-logs-${account} -${region}") for the created S3 Buckets.

---

##### `wafLogsBucket`<sup>Required</sup> <a name="wafLogsBucket" id="cdk-extensions.stacks.AwsLoggingStack.property.wafLogsBucket"></a>

```typescript
public readonly wafLogsBucket: WafLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.WafLogsBucket

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.stacks.AwsLoggingStack.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---


### AwsSecretStore <a name="AwsSecretStore" id="cdk-extensions.k8s_aws.AwsSecretStore"></a>

- *Implements:* cdk-extensions.k8s_aws.ISecretStore

A generic class representing secret store that is backed by an AWS service.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.AwsSecretStore.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.AwsSecretStore(scope: Construct, id: string, props: AwsSecretStoreProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.AwsSecretStoreProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.AwsSecretStore.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.AwsSecretStore.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.AwsSecretStore.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.AwsSecretStoreProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.AwsSecretStore.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.AwsSecretStore.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.AwsSecretStore.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.AwsSecretStore.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.AwsSecretStore.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.AwsSecretStore.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.AwsSecretStore.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.AwsSecretStore.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.AwsSecretStore.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.AwsSecretStore.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.AwsSecretStore.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.AwsSecretStore.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.manifest">manifest</a></code> | <code>aws-cdk-lib.aws_eks.KubernetesManifest</code> | The Kubernetes manifest that defines the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.name">name</a></code> | <code>string</code> | A human friendly name for the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.secretStoreName">secretStoreName</a></code> | <code>string</code> | The name of the secret store as it appears in Kubernetes. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.service">service</a></code> | <code>string</code> | The name of the service provider backing the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.serviceAccount">serviceAccount</a></code> | <code>aws-cdk-lib.aws_eks.ServiceAccount</code> | A Kubernetes service account mapped to an IAM role that provides the necessary permissions to sychronize secrets from an AWS rpvoder. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.AwsSecretStore.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.AwsSecretStore.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.AwsSecretStore.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.AwsSecretStore.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the secret store should be created.

---

##### `manifest`<sup>Required</sup> <a name="manifest" id="cdk-extensions.k8s_aws.AwsSecretStore.property.manifest"></a>

```typescript
public readonly manifest: KubernetesManifest;
```

- *Type:* aws-cdk-lib.aws_eks.KubernetesManifest

The Kubernetes manifest that defines the secret store.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.AwsSecretStore.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A human friendly name for the secret store.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk-extensions.k8s_aws.AwsSecretStore.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the secret store should be created.

---

##### `secretStoreName`<sup>Required</sup> <a name="secretStoreName" id="cdk-extensions.k8s_aws.AwsSecretStore.property.secretStoreName"></a>

```typescript
public readonly secretStoreName: string;
```

- *Type:* string

The name of the secret store as it appears in Kubernetes.

---

##### `service`<sup>Required</sup> <a name="service" id="cdk-extensions.k8s_aws.AwsSecretStore.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

The name of the service provider backing the secret store.

---

##### `serviceAccount`<sup>Required</sup> <a name="serviceAccount" id="cdk-extensions.k8s_aws.AwsSecretStore.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: ServiceAccount;
```

- *Type:* aws-cdk-lib.aws_eks.ServiceAccount

A Kubernetes service account mapped to an IAM role that provides the necessary permissions to sychronize secrets from an AWS rpvoder.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStore.property.NAME_VALIDATOR_REGEX">NAME_VALIDATOR_REGEX</a></code> | <code>string</code> | The regex pattern used to validate secret store names. |

---

##### `NAME_VALIDATOR_REGEX`<sup>Required</sup> <a name="NAME_VALIDATOR_REGEX" id="cdk-extensions.k8s_aws.AwsSecretStore.property.NAME_VALIDATOR_REGEX"></a>

```typescript
public readonly NAME_VALIDATOR_REGEX: string;
```

- *Type:* string

The regex pattern used to validate secret store names.

---

### CloudfrontLogsBucket <a name="CloudfrontLogsBucket" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

new s3_buckets.CloudfrontLogsBucket(scope: Construct, id: string, props?: CloudfrontLogsBucketProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.s3_buckets.CloudfrontLogsBucketProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.s3_buckets.CloudfrontLogsBucketProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.addEventNotification">addEventNotification</a></code> | Adds a bucket notification event destination. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.addObjectCreatedNotification">addObjectCreatedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 created in the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.addObjectRemovedNotification">addObjectRemovedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 removed from the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.addToResourcePolicy">addToResourcePolicy</a></code> | Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.arnForObjects">arnForObjects</a></code> | Returns an ARN that represents all objects within the bucket that match
 the key pattern specified. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.enableEventBridgeNotification">enableEventBridgeNotification</a></code> | Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantDelete">grantDelete</a></code> | Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPublicAccess">grantPublicAccess</a></code> | Allows unrestricted access to objects from this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPut">grantPut</a></code> | Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPutAcl">grantPutAcl</a></code> | Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantRead">grantRead</a></code> | Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantReadWrite">grantReadWrite</a></code> | Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantWrite">grantWrite</a></code> | Grant write permissions to this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailEvent">onCloudTrailEvent</a></code> | Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailPutObject">onCloudTrailPutObject</a></code> | Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailWriteObject">onCloudTrailWriteObject</a></code> | Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.s3UrlForObject">s3UrlForObject</a></code> | The S3 URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.transferAccelerationUrlForObject">transferAccelerationUrlForObject</a></code> | The https Transfer Acceleration URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.urlForObject">urlForObject</a></code> | The https URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.virtualHostedUrlForObject">virtualHostedUrlForObject</a></code> | The virtual hosted-style URL of an S3 object. |

---

##### `toString` <a name="toString" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addEventNotification` <a name="addEventNotification" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addEventNotification"></a>

```typescript
public addEventNotification(_event: EventType, _dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Adds a bucket notification event destination.

###### `_event`<sup>Required</sup> <a name="_event" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addEventNotification.parameter._event"></a>

- *Type:* aws-cdk-lib.aws_s3.EventType

---

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addEventNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addEventNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectCreatedNotification` <a name="addObjectCreatedNotification" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addObjectCreatedNotification"></a>

```typescript
public addObjectCreatedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 created in the bucket.

This is identical to calling
`onEvent(s3.EventType.OBJECT_CREATED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addObjectCreatedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addObjectCreatedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectRemovedNotification` <a name="addObjectRemovedNotification" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addObjectRemovedNotification"></a>

```typescript
public addObjectRemovedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 removed from the bucket.

This is identical to calling
`onEvent(EventType.OBJECT_REMOVED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addObjectRemovedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addObjectRemovedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addToResourcePolicy` <a name="addToResourcePolicy" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addToResourcePolicy"></a>

```typescript
public addToResourcePolicy(permission: PolicyStatement): AddToResourcePolicyResult
```

Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases.

###### `permission`<sup>Required</sup> <a name="permission" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.addToResourcePolicy.parameter.permission"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `arnForObjects` <a name="arnForObjects" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.arnForObjects"></a>

```typescript
public arnForObjects(_keyPattern: string): string
```

Returns an ARN that represents all objects within the bucket that match
 the key pattern specified.

To represent all keys, specify ``"*"``.

###### `_keyPattern`<sup>Required</sup> <a name="_keyPattern" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.arnForObjects.parameter._keyPattern"></a>

- *Type:* string

---

##### `enableEventBridgeNotification` <a name="enableEventBridgeNotification" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.enableEventBridgeNotification"></a>

```typescript
public enableEventBridgeNotification(): void
```

Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted.

##### `grantDelete` <a name="grantDelete" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantDelete"></a>

```typescript
public grantDelete(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantDelete.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantDelete.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPublicAccess` <a name="grantPublicAccess" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPublicAccess"></a>

```typescript
public grantPublicAccess(_allowedActions: string, _keyPrefix?: string): Grant
```

Allows unrestricted access to objects from this bucket.

IMPORTANT: This permission allows anyone to perform actions on S3 objects
in this bucket, which is useful for when you configure your bucket as a
website and want everyone to be able to read objects in the bucket without
needing to authenticate.

Without arguments, this method will grant read ("s3:GetObject") access to
all objects ("*") in the bucket.

The method returns the `iam.Grant` object, which can then be modified
as needed. For example, you can add a condition that will restrict access only
to an IPv4 range like this:

     const grant = bucket.grantPublicAccess();
     grant.resourceStatement!.addCondition(‘IpAddress’, { “aws:SourceIp”: “54.240.143.0/24” });

###### `_allowedActions`<sup>Required</sup> <a name="_allowedActions" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPublicAccess.parameter._allowedActions"></a>

- *Type:* string

---

###### `_keyPrefix`<sup>Optional</sup> <a name="_keyPrefix" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPublicAccess.parameter._keyPrefix"></a>

- *Type:* string

---

##### `grantPut` <a name="grantPut" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPut"></a>

```typescript
public grantPut(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPut.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPut.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPutAcl` <a name="grantPutAcl" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPutAcl"></a>

```typescript
public grantPutAcl(_identity: IGrantable, _objectsKeyPattern?: string): Grant
```

Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket.

If your application has the '@aws-cdk/aws-s3:grantWriteWithoutAcl' feature flag set,
calling `grantWrite` or `grantReadWrite` no longer grants permissions to modify the ACLs of the objects;
in this case, if you need to modify object ACLs, call this method explicitly.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPutAcl.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantPutAcl.parameter._objectsKeyPattern"></a>

- *Type:* string

---

##### `grantRead` <a name="grantRead" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantRead"></a>

```typescript
public grantRead(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If encryption is used, permission to use the key to decrypt the contents
of the bucket will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantRead.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantRead.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantReadWrite"></a>

```typescript
public grantReadWrite(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If an encryption key is used, permission to use the key for
encrypt/decrypt will also be granted.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantReadWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantReadWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantWrite` <a name="grantWrite" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantWrite"></a>

```typescript
public grantWrite(_identity: IGrantable, _objectsKeyPattern?: any, _allowedActionPatterns?: string[]): Grant
```

Grant write permissions to this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

###### `_allowedActionPatterns`<sup>Optional</sup> <a name="_allowedActionPatterns" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.grantWrite.parameter._allowedActionPatterns"></a>

- *Type:* string[]

---

##### `onCloudTrailEvent` <a name="onCloudTrailEvent" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailEvent"></a>

```typescript
public onCloudTrailEvent(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event.

This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailEvent.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailEvent.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailPutObject` <a name="onCloudTrailPutObject" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailPutObject"></a>

```typescript
public onCloudTrailPutObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using `onCloudTrailWriteObject` may be preferable.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailPutObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailPutObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailWriteObject` <a name="onCloudTrailWriteObject" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailWriteObject"></a>

```typescript
public onCloudTrailWriteObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to.

This includes
the events PutObject, CopyObject, and CompleteMultipartUpload.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using this method may be preferable to `onCloudTrailPutObject`.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailWriteObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.onCloudTrailWriteObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `s3UrlForObject` <a name="s3UrlForObject" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.s3UrlForObject"></a>

```typescript
public s3UrlForObject(_key?: string): string
```

The S3 URL of an S3 object.

For example:
- `s3://onlybucket`
- `s3://bucket/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.s3UrlForObject.parameter._key"></a>

- *Type:* string

---

##### `transferAccelerationUrlForObject` <a name="transferAccelerationUrlForObject" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.transferAccelerationUrlForObject"></a>

```typescript
public transferAccelerationUrlForObject(_key?: string, _options?: TransferAccelerationUrlOptions): string
```

The https Transfer Acceleration URL of an S3 object.

Specify `dualStack: true` at the options
for dual-stack endpoint (connect to the bucket over IPv6). For example:

- `https://bucket.s3-accelerate.amazonaws.com`
- `https://bucket.s3-accelerate.amazonaws.com/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.transferAccelerationUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.transferAccelerationUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.TransferAccelerationUrlOptions

---

##### `urlForObject` <a name="urlForObject" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.urlForObject"></a>

```typescript
public urlForObject(_key?: string): string
```

The https URL of an S3 object.

For example:

- `https://s3.us-west-1.amazonaws.com/onlybucket`
- `https://s3.us-west-1.amazonaws.com/bucket/key`
- `https://s3.cn-north-1.amazonaws.com.cn/china-bucket/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.urlForObject.parameter._key"></a>

- *Type:* string

---

##### `virtualHostedUrlForObject` <a name="virtualHostedUrlForObject" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.virtualHostedUrlForObject"></a>

```typescript
public virtualHostedUrlForObject(_key?: string, _options?: VirtualHostedStyleUrlOptions): string
```

The virtual hosted-style URL of an S3 object.

Specify `regional: false` at
the options for non-regional URL. For example:

- `https://only-bucket.s3.us-west-1.amazonaws.com`
- `https://bucket.s3.us-west-1.amazonaws.com/key`
- `https://bucket.s3.amazonaws.com/key`
- `https://china-bucket.s3.cn-north-1.amazonaws.com.cn/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.virtualHostedUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.virtualHostedUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.VirtualHostedStyleUrlOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.isConstruct"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.CloudfrontLogsBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.isOwnedResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.CloudfrontLogsBucket.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.isResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.CloudfrontLogsBucket.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketArn">bucketArn</a></code> | <code>string</code> | The ARN of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | The IPv4 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketDualStackDomainName">bucketDualStackDomainName</a></code> | <code>string</code> | The IPv6 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketName">bucketName</a></code> | <code>string</code> | The name of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketRegionalDomainName">bucketRegionalDomainName</a></code> | <code>string</code> | The regional domain name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketWebsiteDomainName">bucketWebsiteDomainName</a></code> | <code>string</code> | The Domain name of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketWebsiteUrl">bucketWebsiteUrl</a></code> | <code>string</code> | The URL of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_s3.CfnBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | Optional KMS encryption key associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.isWebsite">isWebsite</a></code> | <code>boolean</code> | If this bucket has been configured for static website hosting. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.policy">policy</a></code> | <code>aws-cdk-lib.aws_s3.BucketPolicy</code> | The resource policy associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.table">table</a></code> | <code>cdk-extensions.glue_tables.CloudfrontLogsTable</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bucketArn`<sup>Required</sup> <a name="bucketArn" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketArn"></a>

```typescript
public readonly bucketArn: string;
```

- *Type:* string

The ARN of the bucket.

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

The IPv4 DNS name of the specified bucket.

---

##### `bucketDualStackDomainName`<sup>Required</sup> <a name="bucketDualStackDomainName" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketDualStackDomainName"></a>

```typescript
public readonly bucketDualStackDomainName: string;
```

- *Type:* string

The IPv6 DNS name of the specified bucket.

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

The name of the bucket.

---

##### `bucketRegionalDomainName`<sup>Required</sup> <a name="bucketRegionalDomainName" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketRegionalDomainName"></a>

```typescript
public readonly bucketRegionalDomainName: string;
```

- *Type:* string

The regional domain name of the specified bucket.

---

##### `bucketWebsiteDomainName`<sup>Required</sup> <a name="bucketWebsiteDomainName" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketWebsiteDomainName"></a>

```typescript
public readonly bucketWebsiteDomainName: string;
```

- *Type:* string

The Domain name of the static website.

---

##### `bucketWebsiteUrl`<sup>Required</sup> <a name="bucketWebsiteUrl" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.bucketWebsiteUrl"></a>

```typescript
public readonly bucketWebsiteUrl: string;
```

- *Type:* string

The URL of the static website.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.resource"></a>

```typescript
public readonly resource: CfnBucket;
```

- *Type:* aws-cdk-lib.aws_s3.CfnBucket

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

Optional KMS encryption key associated with this bucket.

---

##### `isWebsite`<sup>Optional</sup> <a name="isWebsite" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.isWebsite"></a>

```typescript
public readonly isWebsite: boolean;
```

- *Type:* boolean

If this bucket has been configured for static website hosting.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.policy"></a>

```typescript
public readonly policy: BucketPolicy;
```

- *Type:* aws-cdk-lib.aws_s3.BucketPolicy

The resource policy associated with this bucket.

If `autoCreatePolicy` is true, a `BucketPolicy` will be created upon the
first call to addToResourcePolicy(s).

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.table"></a>

```typescript
public readonly table: CloudfrontLogsTable;
```

- *Type:* cdk-extensions.glue_tables.CloudfrontLogsTable

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.CloudfrontLogsBucket.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---


### CloudfrontLogsTable <a name="CloudfrontLogsTable" id="cdk-extensions.glue_tables.CloudfrontLogsTable"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue_tables.CloudfrontLogsTable.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

new glue_tables.CloudfrontLogsTable(scope: Construct, id: string, props: CloudfrontLogsTableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue_tables.CloudfrontLogsTableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue_tables.CloudfrontLogsTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue_tables.CloudfrontLogsTable.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue_tables.CloudfrontLogsTable.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue_tables.CloudfrontLogsTableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.addColumn">addColumn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.addParameter">addParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.addPartitionKey">addPartitionKey</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.addSerdeParameter">addSerdeParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.addStorageParameter">addStorageParameter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue_tables.CloudfrontLogsTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue_tables.CloudfrontLogsTable.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue_tables.CloudfrontLogsTable.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addParameter"></a>

```typescript
public addParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addParameter.parameter.value"></a>

- *Type:* string

---

##### `addPartitionKey` <a name="addPartitionKey" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addPartitionKey"></a>

```typescript
public addPartitionKey(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addPartitionKey.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addSerdeParameter` <a name="addSerdeParameter" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addSerdeParameter"></a>

```typescript
public addSerdeParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addSerdeParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addSerdeParameter.parameter.value"></a>

- *Type:* string

---

##### `addStorageParameter` <a name="addStorageParameter" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addStorageParameter"></a>

```typescript
public addStorageParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addStorageParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.CloudfrontLogsTable.addStorageParameter.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue_tables.CloudfrontLogsTable.isConstruct"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.CloudfrontLogsTable.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue_tables.CloudfrontLogsTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue_tables.CloudfrontLogsTable.isOwnedResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.CloudfrontLogsTable.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.CloudfrontLogsTable.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue_tables.CloudfrontLogsTable.isResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.CloudfrontLogsTable.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.CloudfrontLogsTable.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link TableProps.database:}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTable</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.tableArn">tableArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.compressed">compressed</a></code> | <code>boolean</code> | {@link TableProps.compressed}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | {@link TableProps.dataFormat}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.description">description</a></code> | <code>string</code> | {@link TableProps.description}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.location">location</a></code> | <code>string</code> | {@link TableProps.location}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.name">name</a></code> | <code>string</code> | {@link TableProps.name}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.owner">owner</a></code> | <code>string</code> | {@link TableProps.owner}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | {@link TableProps.retention}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.serdeName">serdeName</a></code> | <code>string</code> | {@link TableProps.serdeName}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | {@link TableProps.storedAsSubDirectories}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | {@link TableProps.tableType}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | {@link TableProps.targetTable}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | {@link TableProps.viewExpandedText}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | {@link TableProps.viewOriginalText}. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the Cloudfront Logs. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.distributionStatisticsNamedQuery">distributionStatisticsNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.requestErrorsNamedQuery">requestErrorsNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.topIpsNamedQuery">topIpsNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTable.property.topObjectsNamedQuery">topObjectsNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link TableProps.database:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.resource"></a>

```typescript
public readonly resource: CfnTable;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTable

---

##### `tableArn`<sup>Required</sup> <a name="tableArn" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.tableArn"></a>

```typescript
public readonly tableArn: string;
```

- *Type:* string

---

##### `tableName`<sup>Required</sup> <a name="tableName" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

{@link TableProps.compressed}.

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

{@link TableProps.dataFormat}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link TableProps.description}.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

{@link TableProps.location}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link TableProps.name}.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

{@link TableProps.owner}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link TableProps.retention}.

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

{@link TableProps.serdeName}.

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

{@link TableProps.storedAsSubDirectories}.

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

{@link TableProps.tableType}.

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

{@link TableProps.targetTable}.

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

{@link TableProps.viewExpandedText}.

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

{@link TableProps.viewOriginalText}.

---

##### `createQueries`<sup>Required</sup> <a name="createQueries" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the Cloudfront Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Required</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `distributionStatisticsNamedQuery`<sup>Optional</sup> <a name="distributionStatisticsNamedQuery" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.distributionStatisticsNamedQuery"></a>

```typescript
public readonly distributionStatisticsNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---

##### `requestErrorsNamedQuery`<sup>Optional</sup> <a name="requestErrorsNamedQuery" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.requestErrorsNamedQuery"></a>

```typescript
public readonly requestErrorsNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---

##### `topIpsNamedQuery`<sup>Optional</sup> <a name="topIpsNamedQuery" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.topIpsNamedQuery"></a>

```typescript
public readonly topIpsNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---

##### `topObjectsNamedQuery`<sup>Optional</sup> <a name="topObjectsNamedQuery" id="cdk-extensions.glue_tables.CloudfrontLogsTable.property.topObjectsNamedQuery"></a>

```typescript
public readonly topObjectsNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---


### CloudtrailBucket <a name="CloudtrailBucket" id="cdk-extensions.s3_buckets.CloudtrailBucket"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.s3_buckets.CloudtrailBucket.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

new s3_buckets.CloudtrailBucket(scope: Construct, id: string, props?: CloudtrailBucketProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.s3_buckets.CloudtrailBucketProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.CloudtrailBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.s3_buckets.CloudtrailBucket.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.s3_buckets.CloudtrailBucket.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.s3_buckets.CloudtrailBucketProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.addEventNotification">addEventNotification</a></code> | Adds a bucket notification event destination. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.addObjectCreatedNotification">addObjectCreatedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 created in the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.addObjectRemovedNotification">addObjectRemovedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 removed from the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.addToResourcePolicy">addToResourcePolicy</a></code> | Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.arnForObjects">arnForObjects</a></code> | Returns an ARN that represents all objects within the bucket that match
 the key pattern specified. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.enableEventBridgeNotification">enableEventBridgeNotification</a></code> | Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.grantDelete">grantDelete</a></code> | Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.grantPublicAccess">grantPublicAccess</a></code> | Allows unrestricted access to objects from this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.grantPut">grantPut</a></code> | Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.grantPutAcl">grantPutAcl</a></code> | Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.grantRead">grantRead</a></code> | Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.grantReadWrite">grantReadWrite</a></code> | Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.grantWrite">grantWrite</a></code> | Grant write permissions to this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailEvent">onCloudTrailEvent</a></code> | Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailPutObject">onCloudTrailPutObject</a></code> | Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailWriteObject">onCloudTrailWriteObject</a></code> | Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.s3UrlForObject">s3UrlForObject</a></code> | The S3 URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.transferAccelerationUrlForObject">transferAccelerationUrlForObject</a></code> | The https Transfer Acceleration URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.urlForObject">urlForObject</a></code> | The https URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.virtualHostedUrlForObject">virtualHostedUrlForObject</a></code> | The virtual hosted-style URL of an S3 object. |

---

##### `toString` <a name="toString" id="cdk-extensions.s3_buckets.CloudtrailBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.s3_buckets.CloudtrailBucket.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.s3_buckets.CloudtrailBucket.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addEventNotification` <a name="addEventNotification" id="cdk-extensions.s3_buckets.CloudtrailBucket.addEventNotification"></a>

```typescript
public addEventNotification(_event: EventType, _dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Adds a bucket notification event destination.

###### `_event`<sup>Required</sup> <a name="_event" id="cdk-extensions.s3_buckets.CloudtrailBucket.addEventNotification.parameter._event"></a>

- *Type:* aws-cdk-lib.aws_s3.EventType

---

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.CloudtrailBucket.addEventNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.CloudtrailBucket.addEventNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectCreatedNotification` <a name="addObjectCreatedNotification" id="cdk-extensions.s3_buckets.CloudtrailBucket.addObjectCreatedNotification"></a>

```typescript
public addObjectCreatedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 created in the bucket.

This is identical to calling
`onEvent(s3.EventType.OBJECT_CREATED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.CloudtrailBucket.addObjectCreatedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.CloudtrailBucket.addObjectCreatedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectRemovedNotification` <a name="addObjectRemovedNotification" id="cdk-extensions.s3_buckets.CloudtrailBucket.addObjectRemovedNotification"></a>

```typescript
public addObjectRemovedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 removed from the bucket.

This is identical to calling
`onEvent(EventType.OBJECT_REMOVED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.CloudtrailBucket.addObjectRemovedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.CloudtrailBucket.addObjectRemovedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addToResourcePolicy` <a name="addToResourcePolicy" id="cdk-extensions.s3_buckets.CloudtrailBucket.addToResourcePolicy"></a>

```typescript
public addToResourcePolicy(permission: PolicyStatement): AddToResourcePolicyResult
```

Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases.

###### `permission`<sup>Required</sup> <a name="permission" id="cdk-extensions.s3_buckets.CloudtrailBucket.addToResourcePolicy.parameter.permission"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `arnForObjects` <a name="arnForObjects" id="cdk-extensions.s3_buckets.CloudtrailBucket.arnForObjects"></a>

```typescript
public arnForObjects(_keyPattern: string): string
```

Returns an ARN that represents all objects within the bucket that match
 the key pattern specified.

To represent all keys, specify ``"*"``.

###### `_keyPattern`<sup>Required</sup> <a name="_keyPattern" id="cdk-extensions.s3_buckets.CloudtrailBucket.arnForObjects.parameter._keyPattern"></a>

- *Type:* string

---

##### `enableEventBridgeNotification` <a name="enableEventBridgeNotification" id="cdk-extensions.s3_buckets.CloudtrailBucket.enableEventBridgeNotification"></a>

```typescript
public enableEventBridgeNotification(): void
```

Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted.

##### `grantDelete` <a name="grantDelete" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantDelete"></a>

```typescript
public grantDelete(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantDelete.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantDelete.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPublicAccess` <a name="grantPublicAccess" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPublicAccess"></a>

```typescript
public grantPublicAccess(_allowedActions: string, _keyPrefix?: string): Grant
```

Allows unrestricted access to objects from this bucket.

IMPORTANT: This permission allows anyone to perform actions on S3 objects
in this bucket, which is useful for when you configure your bucket as a
website and want everyone to be able to read objects in the bucket without
needing to authenticate.

Without arguments, this method will grant read ("s3:GetObject") access to
all objects ("*") in the bucket.

The method returns the `iam.Grant` object, which can then be modified
as needed. For example, you can add a condition that will restrict access only
to an IPv4 range like this:

     const grant = bucket.grantPublicAccess();
     grant.resourceStatement!.addCondition(‘IpAddress’, { “aws:SourceIp”: “54.240.143.0/24” });

###### `_allowedActions`<sup>Required</sup> <a name="_allowedActions" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPublicAccess.parameter._allowedActions"></a>

- *Type:* string

---

###### `_keyPrefix`<sup>Optional</sup> <a name="_keyPrefix" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPublicAccess.parameter._keyPrefix"></a>

- *Type:* string

---

##### `grantPut` <a name="grantPut" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPut"></a>

```typescript
public grantPut(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPut.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPut.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPutAcl` <a name="grantPutAcl" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPutAcl"></a>

```typescript
public grantPutAcl(_identity: IGrantable, _objectsKeyPattern?: string): Grant
```

Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket.

If your application has the '@aws-cdk/aws-s3:grantWriteWithoutAcl' feature flag set,
calling `grantWrite` or `grantReadWrite` no longer grants permissions to modify the ACLs of the objects;
in this case, if you need to modify object ACLs, call this method explicitly.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPutAcl.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantPutAcl.parameter._objectsKeyPattern"></a>

- *Type:* string

---

##### `grantRead` <a name="grantRead" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantRead"></a>

```typescript
public grantRead(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If encryption is used, permission to use the key to decrypt the contents
of the bucket will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantRead.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantRead.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantReadWrite"></a>

```typescript
public grantReadWrite(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If an encryption key is used, permission to use the key for
encrypt/decrypt will also be granted.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantReadWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantReadWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantWrite` <a name="grantWrite" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantWrite"></a>

```typescript
public grantWrite(_identity: IGrantable, _objectsKeyPattern?: any, _allowedActionPatterns?: string[]): Grant
```

Grant write permissions to this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

###### `_allowedActionPatterns`<sup>Optional</sup> <a name="_allowedActionPatterns" id="cdk-extensions.s3_buckets.CloudtrailBucket.grantWrite.parameter._allowedActionPatterns"></a>

- *Type:* string[]

---

##### `onCloudTrailEvent` <a name="onCloudTrailEvent" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailEvent"></a>

```typescript
public onCloudTrailEvent(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event.

This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailEvent.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailEvent.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailPutObject` <a name="onCloudTrailPutObject" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailPutObject"></a>

```typescript
public onCloudTrailPutObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using `onCloudTrailWriteObject` may be preferable.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailPutObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailPutObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailWriteObject` <a name="onCloudTrailWriteObject" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailWriteObject"></a>

```typescript
public onCloudTrailWriteObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to.

This includes
the events PutObject, CopyObject, and CompleteMultipartUpload.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using this method may be preferable to `onCloudTrailPutObject`.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailWriteObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudtrailBucket.onCloudTrailWriteObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `s3UrlForObject` <a name="s3UrlForObject" id="cdk-extensions.s3_buckets.CloudtrailBucket.s3UrlForObject"></a>

```typescript
public s3UrlForObject(_key?: string): string
```

The S3 URL of an S3 object.

For example:
- `s3://onlybucket`
- `s3://bucket/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.CloudtrailBucket.s3UrlForObject.parameter._key"></a>

- *Type:* string

---

##### `transferAccelerationUrlForObject` <a name="transferAccelerationUrlForObject" id="cdk-extensions.s3_buckets.CloudtrailBucket.transferAccelerationUrlForObject"></a>

```typescript
public transferAccelerationUrlForObject(_key?: string, _options?: TransferAccelerationUrlOptions): string
```

The https Transfer Acceleration URL of an S3 object.

Specify `dualStack: true` at the options
for dual-stack endpoint (connect to the bucket over IPv6). For example:

- `https://bucket.s3-accelerate.amazonaws.com`
- `https://bucket.s3-accelerate.amazonaws.com/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.CloudtrailBucket.transferAccelerationUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudtrailBucket.transferAccelerationUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.TransferAccelerationUrlOptions

---

##### `urlForObject` <a name="urlForObject" id="cdk-extensions.s3_buckets.CloudtrailBucket.urlForObject"></a>

```typescript
public urlForObject(_key?: string): string
```

The https URL of an S3 object.

For example:

- `https://s3.us-west-1.amazonaws.com/onlybucket`
- `https://s3.us-west-1.amazonaws.com/bucket/key`
- `https://s3.cn-north-1.amazonaws.com.cn/china-bucket/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.CloudtrailBucket.urlForObject.parameter._key"></a>

- *Type:* string

---

##### `virtualHostedUrlForObject` <a name="virtualHostedUrlForObject" id="cdk-extensions.s3_buckets.CloudtrailBucket.virtualHostedUrlForObject"></a>

```typescript
public virtualHostedUrlForObject(_key?: string, _options?: VirtualHostedStyleUrlOptions): string
```

The virtual hosted-style URL of an S3 object.

Specify `regional: false` at
the options for non-regional URL. For example:

- `https://only-bucket.s3.us-west-1.amazonaws.com`
- `https://bucket.s3.us-west-1.amazonaws.com/key`
- `https://bucket.s3.amazonaws.com/key`
- `https://china-bucket.s3.cn-north-1.amazonaws.com.cn/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.CloudtrailBucket.virtualHostedUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.CloudtrailBucket.virtualHostedUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.VirtualHostedStyleUrlOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.s3_buckets.CloudtrailBucket.isConstruct"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.CloudtrailBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.s3_buckets.CloudtrailBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.s3_buckets.CloudtrailBucket.isOwnedResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.CloudtrailBucket.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.CloudtrailBucket.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.s3_buckets.CloudtrailBucket.isResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.CloudtrailBucket.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.CloudtrailBucket.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketArn">bucketArn</a></code> | <code>string</code> | The ARN of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | The IPv4 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketDualStackDomainName">bucketDualStackDomainName</a></code> | <code>string</code> | The IPv6 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketName">bucketName</a></code> | <code>string</code> | The name of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketRegionalDomainName">bucketRegionalDomainName</a></code> | <code>string</code> | The regional domain name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketWebsiteDomainName">bucketWebsiteDomainName</a></code> | <code>string</code> | The Domain name of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketWebsiteUrl">bucketWebsiteUrl</a></code> | <code>string</code> | The URL of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_s3.CfnBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | Optional KMS encryption key associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.isWebsite">isWebsite</a></code> | <code>boolean</code> | If this bucket has been configured for static website hosting. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.policy">policy</a></code> | <code>aws-cdk-lib.aws_s3.BucketPolicy</code> | The resource policy associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.table">table</a></code> | <code>cdk-extensions.glue_tables.CloudtrailTable</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucket.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bucketArn`<sup>Required</sup> <a name="bucketArn" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketArn"></a>

```typescript
public readonly bucketArn: string;
```

- *Type:* string

The ARN of the bucket.

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

The IPv4 DNS name of the specified bucket.

---

##### `bucketDualStackDomainName`<sup>Required</sup> <a name="bucketDualStackDomainName" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketDualStackDomainName"></a>

```typescript
public readonly bucketDualStackDomainName: string;
```

- *Type:* string

The IPv6 DNS name of the specified bucket.

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

The name of the bucket.

---

##### `bucketRegionalDomainName`<sup>Required</sup> <a name="bucketRegionalDomainName" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketRegionalDomainName"></a>

```typescript
public readonly bucketRegionalDomainName: string;
```

- *Type:* string

The regional domain name of the specified bucket.

---

##### `bucketWebsiteDomainName`<sup>Required</sup> <a name="bucketWebsiteDomainName" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketWebsiteDomainName"></a>

```typescript
public readonly bucketWebsiteDomainName: string;
```

- *Type:* string

The Domain name of the static website.

---

##### `bucketWebsiteUrl`<sup>Required</sup> <a name="bucketWebsiteUrl" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.bucketWebsiteUrl"></a>

```typescript
public readonly bucketWebsiteUrl: string;
```

- *Type:* string

The URL of the static website.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.resource"></a>

```typescript
public readonly resource: CfnBucket;
```

- *Type:* aws-cdk-lib.aws_s3.CfnBucket

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

Optional KMS encryption key associated with this bucket.

---

##### `isWebsite`<sup>Optional</sup> <a name="isWebsite" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.isWebsite"></a>

```typescript
public readonly isWebsite: boolean;
```

- *Type:* boolean

If this bucket has been configured for static website hosting.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.policy"></a>

```typescript
public readonly policy: BucketPolicy;
```

- *Type:* aws-cdk-lib.aws_s3.BucketPolicy

The resource policy associated with this bucket.

If `autoCreatePolicy` is true, a `BucketPolicy` will be created upon the
first call to addToResourcePolicy(s).

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.table"></a>

```typescript
public readonly table: CloudtrailTable;
```

- *Type:* cdk-extensions.glue_tables.CloudtrailTable

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.CloudtrailBucket.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---


### CloudtrailTable <a name="CloudtrailTable" id="cdk-extensions.glue_tables.CloudtrailTable"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue_tables.CloudtrailTable.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

new glue_tables.CloudtrailTable(scope: Construct, id: string, props: CloudtrailTableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue_tables.CloudtrailTableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue_tables.CloudtrailTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue_tables.CloudtrailTable.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue_tables.CloudtrailTable.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue_tables.CloudtrailTableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.addColumn">addColumn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.addParameter">addParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.addPartitionKey">addPartitionKey</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.addSerdeParameter">addSerdeParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.addStorageParameter">addStorageParameter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue_tables.CloudtrailTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue_tables.CloudtrailTable.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue_tables.CloudtrailTable.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue_tables.CloudtrailTable.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.CloudtrailTable.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.glue_tables.CloudtrailTable.addParameter"></a>

```typescript
public addParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.CloudtrailTable.addParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.CloudtrailTable.addParameter.parameter.value"></a>

- *Type:* string

---

##### `addPartitionKey` <a name="addPartitionKey" id="cdk-extensions.glue_tables.CloudtrailTable.addPartitionKey"></a>

```typescript
public addPartitionKey(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.CloudtrailTable.addPartitionKey.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addSerdeParameter` <a name="addSerdeParameter" id="cdk-extensions.glue_tables.CloudtrailTable.addSerdeParameter"></a>

```typescript
public addSerdeParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.CloudtrailTable.addSerdeParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.CloudtrailTable.addSerdeParameter.parameter.value"></a>

- *Type:* string

---

##### `addStorageParameter` <a name="addStorageParameter" id="cdk-extensions.glue_tables.CloudtrailTable.addStorageParameter"></a>

```typescript
public addStorageParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.CloudtrailTable.addStorageParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.CloudtrailTable.addStorageParameter.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue_tables.CloudtrailTable.isConstruct"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.CloudtrailTable.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue_tables.CloudtrailTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue_tables.CloudtrailTable.isOwnedResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.CloudtrailTable.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.CloudtrailTable.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue_tables.CloudtrailTable.isResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.CloudtrailTable.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.CloudtrailTable.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link TableProps.database:}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTable</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.tableArn">tableArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.compressed">compressed</a></code> | <code>boolean</code> | {@link TableProps.compressed}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | {@link TableProps.dataFormat}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.description">description</a></code> | <code>string</code> | {@link TableProps.description}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.location">location</a></code> | <code>string</code> | {@link TableProps.location}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.name">name</a></code> | <code>string</code> | {@link TableProps.name}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.owner">owner</a></code> | <code>string</code> | {@link TableProps.owner}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | {@link TableProps.retention}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.serdeName">serdeName</a></code> | <code>string</code> | {@link TableProps.serdeName}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | {@link TableProps.storedAsSubDirectories}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | {@link TableProps.tableType}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | {@link TableProps.targetTable}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | {@link TableProps.viewExpandedText}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | {@link TableProps.viewOriginalText}. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the Cloudtrail Logs. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.unauthorizedNamedQuery">unauthorizedNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTable.property.userLoginsNamedQuery">userLoginsNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue_tables.CloudtrailTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue_tables.CloudtrailTable.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue_tables.CloudtrailTable.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.CloudtrailTable.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link TableProps.database:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue_tables.CloudtrailTable.property.resource"></a>

```typescript
public readonly resource: CfnTable;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTable

---

##### `tableArn`<sup>Required</sup> <a name="tableArn" id="cdk-extensions.glue_tables.CloudtrailTable.property.tableArn"></a>

```typescript
public readonly tableArn: string;
```

- *Type:* string

---

##### `tableName`<sup>Required</sup> <a name="tableName" id="cdk-extensions.glue_tables.CloudtrailTable.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue_tables.CloudtrailTable.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

{@link TableProps.compressed}.

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue_tables.CloudtrailTable.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

{@link TableProps.dataFormat}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue_tables.CloudtrailTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link TableProps.description}.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue_tables.CloudtrailTable.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

{@link TableProps.location}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.CloudtrailTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link TableProps.name}.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue_tables.CloudtrailTable.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

{@link TableProps.owner}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue_tables.CloudtrailTable.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link TableProps.retention}.

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue_tables.CloudtrailTable.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

{@link TableProps.serdeName}.

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue_tables.CloudtrailTable.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

{@link TableProps.storedAsSubDirectories}.

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue_tables.CloudtrailTable.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

{@link TableProps.tableType}.

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue_tables.CloudtrailTable.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

{@link TableProps.targetTable}.

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue_tables.CloudtrailTable.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

{@link TableProps.viewExpandedText}.

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue_tables.CloudtrailTable.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

{@link TableProps.viewOriginalText}.

---

##### `createQueries`<sup>Required</sup> <a name="createQueries" id="cdk-extensions.glue_tables.CloudtrailTable.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the Cloudtrail Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Required</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.CloudtrailTable.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `unauthorizedNamedQuery`<sup>Optional</sup> <a name="unauthorizedNamedQuery" id="cdk-extensions.glue_tables.CloudtrailTable.property.unauthorizedNamedQuery"></a>

```typescript
public readonly unauthorizedNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---

##### `userLoginsNamedQuery`<sup>Optional</sup> <a name="userLoginsNamedQuery" id="cdk-extensions.glue_tables.CloudtrailTable.property.userLoginsNamedQuery"></a>

```typescript
public readonly userLoginsNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---


### Connection <a name="Connection" id="cdk-extensions.glue.Connection"></a>

- *Implements:* aws-cdk-lib.aws_ec2.IConnectable

Creates a resource specifying a Glue Connection to a data source.

> [[AWS::Glue::Connection](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-connection.html)]([AWS::Glue::Connection](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-connection.html))

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Connection.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Connection(scope: Construct, id: string, props: ConnectionProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Connection.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue.Connection.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue.Connection.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.ConnectionProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Connection.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Connection.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.Connection.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.ConnectionProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Connection.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.Connection.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue.Connection.addMatchCriteria">addMatchCriteria</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Connection.addProperty">addProperty</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.Connection.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.Connection.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.Connection.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addMatchCriteria` <a name="addMatchCriteria" id="cdk-extensions.glue.Connection.addMatchCriteria"></a>

```typescript
public addMatchCriteria(value: string): void
```

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.Connection.addMatchCriteria.parameter.value"></a>

- *Type:* string

---

##### `addProperty` <a name="addProperty" id="cdk-extensions.glue.Connection.addProperty"></a>

```typescript
public addProperty(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.Connection.addProperty.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.Connection.addProperty.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Connection.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.Connection.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.Connection.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.Connection.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Connection.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.Connection.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.Connection.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Connection.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Connection.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.Connection.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Connection.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Connection.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Connection.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.Connection.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.Connection.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.Connection.property.connectionArn">connectionArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Connection.property.connectionName">connectionName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Connection.property.connections">connections</a></code> | <code>aws-cdk-lib.aws_ec2.Connections</code> | The network connections associated with this resource. |
| <code><a href="#cdk-extensions.glue.Connection.property.connectionType">connectionType</a></code> | <code>cdk-extensions.glue.ConnectionType</code> | {@link ConnectionProps.connectionType:}. |
| <code><a href="#cdk-extensions.glue.Connection.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnConnection</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Connection.property.securityGroups">securityGroups</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup[]</code> | {@link ConnectionProps.securityGroups:}. |
| <code><a href="#cdk-extensions.glue.Connection.property.description">description</a></code> | <code>string</code> | {@link ConnectionProps.description}. |
| <code><a href="#cdk-extensions.glue.Connection.property.name">name</a></code> | <code>string</code> | {@link ConnectionProps.name}. |
| <code><a href="#cdk-extensions.glue.Connection.property.securityGroup">securityGroup</a></code> | <code>aws-cdk-lib.aws_ec2.SecurityGroup</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Connection.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | {@link ConnectionProps.subnets}. |
| <code><a href="#cdk-extensions.glue.Connection.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | {@link ConnectionProps.vpc}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.Connection.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.Connection.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.Connection.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `connectionArn`<sup>Required</sup> <a name="connectionArn" id="cdk-extensions.glue.Connection.property.connectionArn"></a>

```typescript
public readonly connectionArn: string;
```

- *Type:* string

---

##### `connectionName`<sup>Required</sup> <a name="connectionName" id="cdk-extensions.glue.Connection.property.connectionName"></a>

```typescript
public readonly connectionName: string;
```

- *Type:* string

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk-extensions.glue.Connection.property.connections"></a>

```typescript
public readonly connections: Connections;
```

- *Type:* aws-cdk-lib.aws_ec2.Connections

The network connections associated with this resource.

---

##### `connectionType`<sup>Required</sup> <a name="connectionType" id="cdk-extensions.glue.Connection.property.connectionType"></a>

```typescript
public readonly connectionType: ConnectionType;
```

- *Type:* cdk-extensions.glue.ConnectionType

{@link ConnectionProps.connectionType:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.Connection.property.resource"></a>

```typescript
public readonly resource: CfnConnection;
```

- *Type:* aws-cdk-lib.aws_glue.CfnConnection

---

##### `securityGroups`<sup>Required</sup> <a name="securityGroups" id="cdk-extensions.glue.Connection.property.securityGroups"></a>

```typescript
public readonly securityGroups: ISecurityGroup[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup[]

{@link ConnectionProps.securityGroups:}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.Connection.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link ConnectionProps.description}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.Connection.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link ConnectionProps.name}.

---

##### `securityGroup`<sup>Optional</sup> <a name="securityGroup" id="cdk-extensions.glue.Connection.property.securityGroup"></a>

```typescript
public readonly securityGroup: SecurityGroup;
```

- *Type:* aws-cdk-lib.aws_ec2.SecurityGroup

---

##### `subnets`<sup>Optional</sup> <a name="subnets" id="cdk-extensions.glue.Connection.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

{@link ConnectionProps.subnets}.

---

##### `vpc`<sup>Optional</sup> <a name="vpc" id="cdk-extensions.glue.Connection.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

{@link ConnectionProps.vpc}.

---


### Crawler <a name="Crawler" id="cdk-extensions.glue.Crawler"></a>

- *Implements:* cdk-extensions.glue.ICrawler

Create a Crawler resource to pull information from the provided resource.

> [[AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html)]([AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html))

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Crawler.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Crawler(scope: Construct, id: string, props: CrawlerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Crawler.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue.Crawler.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue.Crawler.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.CrawlerProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Crawler.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Crawler.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.Crawler.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.CrawlerProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Crawler.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.Crawler.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue.Crawler.addClassifier">addClassifier</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Crawler.addTarget">addTarget</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.Crawler.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.Crawler.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.Crawler.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addClassifier` <a name="addClassifier" id="cdk-extensions.glue.Crawler.addClassifier"></a>

```typescript
public addClassifier(classifier: string): void
```

###### `classifier`<sup>Required</sup> <a name="classifier" id="cdk-extensions.glue.Crawler.addClassifier.parameter.classifier"></a>

- *Type:* string

---

##### `addTarget` <a name="addTarget" id="cdk-extensions.glue.Crawler.addTarget"></a>

```typescript
public addTarget(target: ICrawlerTarget): void
```

###### `target`<sup>Required</sup> <a name="target" id="cdk-extensions.glue.Crawler.addTarget.parameter.target"></a>

- *Type:* cdk-extensions.glue.ICrawlerTarget

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Crawler.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.Crawler.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.Crawler.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.glue.Crawler.fromCrawlerArn">fromCrawlerArn</a></code> | Imports an existing crawler using its Amazon Resource Name (ARN). |
| <code><a href="#cdk-extensions.glue.Crawler.fromCrawlerName">fromCrawlerName</a></code> | Imports an existing crawler using its name. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.Crawler.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Crawler.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.Crawler.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.Crawler.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Crawler.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Crawler.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.Crawler.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Crawler.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Crawler.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromCrawlerArn` <a name="fromCrawlerArn" id="cdk-extensions.glue.Crawler.fromCrawlerArn"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Crawler.fromCrawlerArn(scope: IConstruct, id: string, crawlerArn: string)
```

Imports an existing crawler using its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Crawler.fromCrawlerArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Crawler.fromCrawlerArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `crawlerArn`<sup>Required</sup> <a name="crawlerArn" id="cdk-extensions.glue.Crawler.fromCrawlerArn.parameter.crawlerArn"></a>

- *Type:* string

The ARN of the crawler to import.

---

##### `fromCrawlerName` <a name="fromCrawlerName" id="cdk-extensions.glue.Crawler.fromCrawlerName"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Crawler.fromCrawlerName(scope: IConstruct, id: string, crawlerName: string)
```

Imports an existing crawler using its name.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Crawler.fromCrawlerName.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Crawler.fromCrawlerName.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `crawlerName`<sup>Required</sup> <a name="crawlerName" id="cdk-extensions.glue.Crawler.fromCrawlerName.parameter.crawlerName"></a>

- *Type:* string

The name of the crawler to import.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Crawler.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.Crawler.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.Crawler.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.Crawler.property.crawlerArn">crawlerArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the crawler. |
| <code><a href="#cdk-extensions.glue.Crawler.property.crawlerName">crawlerName</a></code> | <code>string</code> | The name of the crawler. |
| <code><a href="#cdk-extensions.glue.Crawler.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnCrawler</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Crawler.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.Role</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Crawler.property.configuration">configuration</a></code> | <code>cdk-extensions.glue.CrawlerConfiguration</code> | {@link CrawlerProps.configuration}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link CrawlerProps.database}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.deleteBehavior">deleteBehavior</a></code> | <code>cdk-extensions.glue.DeleteBehavior</code> | {@link CrawlerProps.deleteBehavior}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.description">description</a></code> | <code>string</code> | {@link CrawlerProps.description}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.name">name</a></code> | <code>string</code> | {@link CrawlerProps.name}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.recrawlBehavior">recrawlBehavior</a></code> | <code>cdk-extensions.glue.RecrawlBehavior</code> | {@link CrawlerProps.recrawlBehavior}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.scheduleExpression">scheduleExpression</a></code> | <code>aws-cdk-lib.aws_events.Schedule</code> | {@link CrawlerProps.scheduleExpression}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.securityConfiguration">securityConfiguration</a></code> | <code>cdk-extensions.glue.SecurityConfiguration</code> | {@link CrawlerProps.securityConfiguration}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.tablePrefix">tablePrefix</a></code> | <code>string</code> | {@link CrawlerProps.tablePrefix}. |
| <code><a href="#cdk-extensions.glue.Crawler.property.updateBehavior">updateBehavior</a></code> | <code>cdk-extensions.glue.UpdateBehavior</code> | {@link CrawlerProps.updateBehavior}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.Crawler.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.Crawler.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.Crawler.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `crawlerArn`<sup>Required</sup> <a name="crawlerArn" id="cdk-extensions.glue.Crawler.property.crawlerArn"></a>

```typescript
public readonly crawlerArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the crawler.

---

##### `crawlerName`<sup>Required</sup> <a name="crawlerName" id="cdk-extensions.glue.Crawler.property.crawlerName"></a>

```typescript
public readonly crawlerName: string;
```

- *Type:* string

The name of the crawler.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.Crawler.property.resource"></a>

```typescript
public readonly resource: CfnCrawler;
```

- *Type:* aws-cdk-lib.aws_glue.CfnCrawler

---

##### `role`<sup>Required</sup> <a name="role" id="cdk-extensions.glue.Crawler.property.role"></a>

```typescript
public readonly role: Role;
```

- *Type:* aws-cdk-lib.aws_iam.Role

---

##### `configuration`<sup>Optional</sup> <a name="configuration" id="cdk-extensions.glue.Crawler.property.configuration"></a>

```typescript
public readonly configuration: CrawlerConfiguration;
```

- *Type:* cdk-extensions.glue.CrawlerConfiguration

{@link CrawlerProps.configuration}.

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.glue.Crawler.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link CrawlerProps.database}.

---

##### `deleteBehavior`<sup>Optional</sup> <a name="deleteBehavior" id="cdk-extensions.glue.Crawler.property.deleteBehavior"></a>

```typescript
public readonly deleteBehavior: DeleteBehavior;
```

- *Type:* cdk-extensions.glue.DeleteBehavior

{@link CrawlerProps.deleteBehavior}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.Crawler.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link CrawlerProps.description}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.Crawler.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link CrawlerProps.name}.

---

##### `recrawlBehavior`<sup>Optional</sup> <a name="recrawlBehavior" id="cdk-extensions.glue.Crawler.property.recrawlBehavior"></a>

```typescript
public readonly recrawlBehavior: RecrawlBehavior;
```

- *Type:* cdk-extensions.glue.RecrawlBehavior

{@link CrawlerProps.recrawlBehavior}.

---

##### `scheduleExpression`<sup>Optional</sup> <a name="scheduleExpression" id="cdk-extensions.glue.Crawler.property.scheduleExpression"></a>

```typescript
public readonly scheduleExpression: Schedule;
```

- *Type:* aws-cdk-lib.aws_events.Schedule

{@link CrawlerProps.scheduleExpression}.

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.Crawler.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: SecurityConfiguration;
```

- *Type:* cdk-extensions.glue.SecurityConfiguration

{@link CrawlerProps.securityConfiguration}.

---

##### `tablePrefix`<sup>Optional</sup> <a name="tablePrefix" id="cdk-extensions.glue.Crawler.property.tablePrefix"></a>

```typescript
public readonly tablePrefix: string;
```

- *Type:* string

{@link CrawlerProps.tablePrefix}.

---

##### `updateBehavior`<sup>Optional</sup> <a name="updateBehavior" id="cdk-extensions.glue.Crawler.property.updateBehavior"></a>

```typescript
public readonly updateBehavior: UpdateBehavior;
```

- *Type:* cdk-extensions.glue.UpdateBehavior

{@link CrawlerProps.updateBehavior}.

---


### CustomerGateway <a name="CustomerGateway" id="cdk-extensions.ec2.CustomerGateway"></a>

- *Implements:* cdk-extensions.ec2.ICustomerGateway

Specifies thje details of a remote endpoint that can serve as an endpoint for connections to AWS.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.CustomerGateway.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.CustomerGateway(scope: Construct, id: string, props: CustomerGatewayProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.CustomerGatewayProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.CustomerGateway.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.CustomerGateway.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.CustomerGateway.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.CustomerGatewayProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.CustomerGateway.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.CustomerGateway.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.CustomerGateway.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayAttributes">fromCustomerGatewayAttributes</a></code> | Imports an existing custom gateway by specifying its details. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayId">fromCustomerGatewayId</a></code> | Imports an existing custom gateway using its CustomerGatewayId. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.CustomerGateway.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.CustomerGateway.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.CustomerGateway.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.CustomerGateway.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.CustomerGateway.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.CustomerGateway.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.CustomerGateway.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.CustomerGateway.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.CustomerGateway.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromCustomerGatewayAttributes` <a name="fromCustomerGatewayAttributes" id="cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayAttributes"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.CustomerGateway.fromCustomerGatewayAttributes(scope: IConstruct, id: string, attributes: CustomerGatewayAttributes)
```

Imports an existing custom gateway by specifying its details.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayAttributes.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayAttributes.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `attributes`<sup>Required</sup> <a name="attributes" id="cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayAttributes.parameter.attributes"></a>

- *Type:* cdk-extensions.ec2.CustomerGatewayAttributes

The details of the existing customer gateway being imported.

---

##### `fromCustomerGatewayId` <a name="fromCustomerGatewayId" id="cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.CustomerGateway.fromCustomerGatewayId(scope: IConstruct, id: string, customerGatewayId: string)
```

Imports an existing custom gateway using its CustomerGatewayId.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `customerGatewayId`<sup>Required</sup> <a name="customerGatewayId" id="cdk-extensions.ec2.CustomerGateway.fromCustomerGatewayId.parameter.customerGatewayId"></a>

- *Type:* string

The ID of the existing customer gateway being imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.bgpAsn">bgpAsn</a></code> | <code>number</code> | For devices that support BGP, the customer gateway's BGP ASN. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.connectionType">connectionType</a></code> | <code>cdk-extensions.ec2.VpnConnectionType</code> | The type of VPN connection that this customer gateway supports. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.customerGatewayAsn">customerGatewayAsn</a></code> | <code>number</code> | The BGP ASN of the customer gateway. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.customerGatewayId">customerGatewayId</a></code> | <code>string</code> | The ID of the customer gateway. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.customerGatewayIp">customerGatewayIp</a></code> | <code>string</code> | The IP address of the customer gateway. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.ipAddress">ipAddress</a></code> | <code>string</code> | The Internet-routable IP address for the customer gateway's outside interface. |
| <code><a href="#cdk-extensions.ec2.CustomerGateway.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnCustomerGateway</code> | The underlying CustomerGateway CloudFormation resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.CustomerGateway.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.CustomerGateway.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.CustomerGateway.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bgpAsn`<sup>Required</sup> <a name="bgpAsn" id="cdk-extensions.ec2.CustomerGateway.property.bgpAsn"></a>

```typescript
public readonly bgpAsn: number;
```

- *Type:* number

For devices that support BGP, the customer gateway's BGP ASN.

> [[CustomerGateway BgpAsn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-bgpasn)]([CustomerGateway BgpAsn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-bgpasn))

---

##### `connectionType`<sup>Required</sup> <a name="connectionType" id="cdk-extensions.ec2.CustomerGateway.property.connectionType"></a>

```typescript
public readonly connectionType: VpnConnectionType;
```

- *Type:* cdk-extensions.ec2.VpnConnectionType

The type of VPN connection that this customer gateway supports.

> [[CustomerGateway Type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-type)]([CustomerGateway Type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-type))

---

##### `customerGatewayAsn`<sup>Required</sup> <a name="customerGatewayAsn" id="cdk-extensions.ec2.CustomerGateway.property.customerGatewayAsn"></a>

```typescript
public readonly customerGatewayAsn: number;
```

- *Type:* number

The BGP ASN of the customer gateway.

---

##### `customerGatewayId`<sup>Required</sup> <a name="customerGatewayId" id="cdk-extensions.ec2.CustomerGateway.property.customerGatewayId"></a>

```typescript
public readonly customerGatewayId: string;
```

- *Type:* string

The ID of the customer gateway.

---

##### `customerGatewayIp`<sup>Required</sup> <a name="customerGatewayIp" id="cdk-extensions.ec2.CustomerGateway.property.customerGatewayIp"></a>

```typescript
public readonly customerGatewayIp: string;
```

- *Type:* string

The IP address of the customer gateway.

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="cdk-extensions.ec2.CustomerGateway.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

The Internet-routable IP address for the customer gateway's outside interface.

The address must be static.

> [[CustomerGateway IpAddress](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-ipaddress)]([CustomerGateway IpAddress](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-ipaddress))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.CustomerGateway.property.resource"></a>

```typescript
public readonly resource: CfnCustomerGateway;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnCustomerGateway

The underlying CustomerGateway CloudFormation resource.

> [[AWS::EC2::CustomerGateway](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html)]([AWS::EC2::CustomerGateway](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html))

---


### Database <a name="Database" id="cdk-extensions.glue.Database"></a>

Creates a Glue Database resource to contain a collection of metadata Tables.

> [[AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html]([AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html)

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Database.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Database(scope: Construct, id: string, props?: DatabaseProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Database.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue.Database.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue.Database.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.DatabaseProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Database.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Database.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.glue.Database.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.DatabaseProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Database.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.Database.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.Database.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.Database.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.Database.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Database.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.Database.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.Database.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.Database.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Database.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.Database.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.Database.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Database.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Database.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.Database.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Database.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Database.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Database.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.Database.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.Database.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.Database.property.catalogArn">catalogArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Database.property.catalogId">catalogId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Database.property.databaseArn">databaseArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Database.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Database.property.name">name</a></code> | <code>string</code> | {@link DatabaseProps.name:}. |
| <code><a href="#cdk-extensions.glue.Database.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnDatabase</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Database.property.description">description</a></code> | <code>string</code> | {@link DatabaseProps.description}. |
| <code><a href="#cdk-extensions.glue.Database.property.locationUri">locationUri</a></code> | <code>string</code> | {@link DatabaseProps.locationUri}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.Database.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.Database.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.Database.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `catalogArn`<sup>Required</sup> <a name="catalogArn" id="cdk-extensions.glue.Database.property.catalogArn"></a>

```typescript
public readonly catalogArn: string;
```

- *Type:* string

---

##### `catalogId`<sup>Required</sup> <a name="catalogId" id="cdk-extensions.glue.Database.property.catalogId"></a>

```typescript
public readonly catalogId: string;
```

- *Type:* string

---

##### `databaseArn`<sup>Required</sup> <a name="databaseArn" id="cdk-extensions.glue.Database.property.databaseArn"></a>

```typescript
public readonly databaseArn: string;
```

- *Type:* string

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="cdk-extensions.glue.Database.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.glue.Database.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link DatabaseProps.name:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.Database.property.resource"></a>

```typescript
public readonly resource: CfnDatabase;
```

- *Type:* aws-cdk-lib.aws_glue.CfnDatabase

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.Database.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link DatabaseProps.description}.

---

##### `locationUri`<sup>Optional</sup> <a name="locationUri" id="cdk-extensions.glue.Database.property.locationUri"></a>

```typescript
public readonly locationUri: string;
```

- *Type:* string

{@link DatabaseProps.locationUri}.

---


### DatabaseProxyEndpoint <a name="DatabaseProxyEndpoint" id="cdk-extensions.rds.DatabaseProxyEndpoint"></a>

- *Implements:* aws-cdk-lib.aws_ec2.IConnectable

#### Initializers <a name="Initializers" id="cdk-extensions.rds.DatabaseProxyEndpoint.Initializer"></a>

```typescript
import { rds } from 'cdk-extensions'

new rds.DatabaseProxyEndpoint(scope: Construct, id: string, props: DatabaseProxyEndpointProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.rds.DatabaseProxyEndpointProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.rds.DatabaseProxyEndpoint.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.rds.DatabaseProxyEndpoint.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.rds.DatabaseProxyEndpoint.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.rds.DatabaseProxyEndpointProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.rds.DatabaseProxyEndpoint.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.rds.DatabaseProxyEndpoint.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.rds.DatabaseProxyEndpoint.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.rds.DatabaseProxyEndpoint.isConstruct"></a>

```typescript
import { rds } from 'cdk-extensions'

rds.DatabaseProxyEndpoint.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.rds.DatabaseProxyEndpoint.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.rds.DatabaseProxyEndpoint.isOwnedResource"></a>

```typescript
import { rds } from 'cdk-extensions'

rds.DatabaseProxyEndpoint.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.rds.DatabaseProxyEndpoint.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.rds.DatabaseProxyEndpoint.isResource"></a>

```typescript
import { rds } from 'cdk-extensions'

rds.DatabaseProxyEndpoint.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.rds.DatabaseProxyEndpoint.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.connections">connections</a></code> | <code>aws-cdk-lib.aws_ec2.Connections</code> | The network connections associated with this resource. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxy">databaseProxy</a></code> | <code>aws-cdk-lib.aws_rds.IDatabaseProxy</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxyEndpointArn">databaseProxyEndpointArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxyEndpointHost">databaseProxyEndpointHost</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxyEndpointIsDefault">databaseProxyEndpointIsDefault</a></code> | <code>aws-cdk-lib.IResolvable</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxyEndpointVpcId">databaseProxyEndpointVpcId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_rds.CfnDBProxyEndpoint</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.vpcSubnets">vpcSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.access">access</a></code> | <code>cdk-extensions.rds.DatabaseProxyEndpointAccess</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpoint.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.connections"></a>

```typescript
public readonly connections: Connections;
```

- *Type:* aws-cdk-lib.aws_ec2.Connections

The network connections associated with this resource.

---

##### `databaseProxy`<sup>Required</sup> <a name="databaseProxy" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxy"></a>

```typescript
public readonly databaseProxy: IDatabaseProxy;
```

- *Type:* aws-cdk-lib.aws_rds.IDatabaseProxy

---

##### `databaseProxyEndpointArn`<sup>Required</sup> <a name="databaseProxyEndpointArn" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxyEndpointArn"></a>

```typescript
public readonly databaseProxyEndpointArn: string;
```

- *Type:* string

---

##### `databaseProxyEndpointHost`<sup>Required</sup> <a name="databaseProxyEndpointHost" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxyEndpointHost"></a>

```typescript
public readonly databaseProxyEndpointHost: string;
```

- *Type:* string

---

##### `databaseProxyEndpointIsDefault`<sup>Required</sup> <a name="databaseProxyEndpointIsDefault" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxyEndpointIsDefault"></a>

```typescript
public readonly databaseProxyEndpointIsDefault: IResolvable;
```

- *Type:* aws-cdk-lib.IResolvable

---

##### `databaseProxyEndpointVpcId`<sup>Required</sup> <a name="databaseProxyEndpointVpcId" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.databaseProxyEndpointVpcId"></a>

```typescript
public readonly databaseProxyEndpointVpcId: string;
```

- *Type:* string

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.resource"></a>

```typescript
public readonly resource: CfnDBProxyEndpoint;
```

- *Type:* aws-cdk-lib.aws_rds.CfnDBProxyEndpoint

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

---

##### `vpcSubnets`<sup>Required</sup> <a name="vpcSubnets" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.vpcSubnets"></a>

```typescript
public readonly vpcSubnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

---

##### `access`<sup>Optional</sup> <a name="access" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.access"></a>

```typescript
public readonly access: DatabaseProxyEndpointAccess;
```

- *Type:* cdk-extensions.rds.DatabaseProxyEndpointAccess

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.rds.DatabaseProxyEndpoint.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---


### DeliveryStream <a name="DeliveryStream" id="cdk-extensions.kinesis_firehose.DeliveryStream"></a>

- *Implements:* cdk-extensions.kinesis_firehose.IDeliveryStream

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.DeliveryStream.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.DeliveryStream(scope: Construct, id: string, props: DeliveryStreamProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.DeliveryStream.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.kinesis_firehose.DeliveryStream.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.kinesis_firehose.DeliveryStream.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.grant">grant</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.grantPutRecords">grantPutRecords</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.metric">metric</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3Bytes">metricBackupToS3Bytes</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3DataFreshness">metricBackupToS3DataFreshness</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3Records">metricBackupToS3Records</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.metricIncomingBytes">metricIncomingBytes</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.metricIncomingRecords">metricIncomingRecords</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.kinesis_firehose.DeliveryStream.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.kinesis_firehose.DeliveryStream.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.kinesis_firehose.DeliveryStream.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `grant` <a name="grant" id="cdk-extensions.kinesis_firehose.DeliveryStream.grant"></a>

```typescript
public grant(grantee: IGrantable, actions: string): Grant
```

###### `grantee`<sup>Required</sup> <a name="grantee" id="cdk-extensions.kinesis_firehose.DeliveryStream.grant.parameter.grantee"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `actions`<sup>Required</sup> <a name="actions" id="cdk-extensions.kinesis_firehose.DeliveryStream.grant.parameter.actions"></a>

- *Type:* string

---

##### `grantPutRecords` <a name="grantPutRecords" id="cdk-extensions.kinesis_firehose.DeliveryStream.grantPutRecords"></a>

```typescript
public grantPutRecords(grantee: IGrantable): Grant
```

###### `grantee`<sup>Required</sup> <a name="grantee" id="cdk-extensions.kinesis_firehose.DeliveryStream.grantPutRecords.parameter.grantee"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

##### `metric` <a name="metric" id="cdk-extensions.kinesis_firehose.DeliveryStream.metric"></a>

```typescript
public metric(metricName: string, props?: MetricOptions): Metric
```

###### `metricName`<sup>Required</sup> <a name="metricName" id="cdk-extensions.kinesis_firehose.DeliveryStream.metric.parameter.metricName"></a>

- *Type:* string

---

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.DeliveryStream.metric.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricBackupToS3Bytes` <a name="metricBackupToS3Bytes" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3Bytes"></a>

```typescript
public metricBackupToS3Bytes(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3Bytes.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricBackupToS3DataFreshness` <a name="metricBackupToS3DataFreshness" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3DataFreshness"></a>

```typescript
public metricBackupToS3DataFreshness(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3DataFreshness.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricBackupToS3Records` <a name="metricBackupToS3Records" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3Records"></a>

```typescript
public metricBackupToS3Records(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricBackupToS3Records.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricIncomingBytes` <a name="metricIncomingBytes" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricIncomingBytes"></a>

```typescript
public metricIncomingBytes(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricIncomingBytes.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricIncomingRecords` <a name="metricIncomingRecords" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricIncomingRecords"></a>

```typescript
public metricIncomingRecords(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.DeliveryStream.metricIncomingRecords.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamArn">fromDeliveryStreamArn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamAttributes">fromDeliveryStreamAttributes</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamName">fromDeliveryStreamName</a></code> | *No description.* |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.kinesis_firehose.DeliveryStream.isConstruct"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.DeliveryStream.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.kinesis_firehose.DeliveryStream.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.kinesis_firehose.DeliveryStream.isOwnedResource"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.DeliveryStream.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.kinesis_firehose.DeliveryStream.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.kinesis_firehose.DeliveryStream.isResource"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.DeliveryStream.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.kinesis_firehose.DeliveryStream.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromDeliveryStreamArn` <a name="fromDeliveryStreamArn" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamArn"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.DeliveryStream.fromDeliveryStreamArn(scope: Construct, id: string, deliveryStreamArn: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamArn.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamArn.parameter.id"></a>

- *Type:* string

---

###### `deliveryStreamArn`<sup>Required</sup> <a name="deliveryStreamArn" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamArn.parameter.deliveryStreamArn"></a>

- *Type:* string

---

##### `fromDeliveryStreamAttributes` <a name="fromDeliveryStreamAttributes" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamAttributes"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.DeliveryStream.fromDeliveryStreamAttributes(scope: Construct, id: string, attrs: DeliveryStreamAttributes)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamAttributes.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamAttributes.parameter.id"></a>

- *Type:* string

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamAttributes.parameter.attrs"></a>

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamAttributes

---

##### `fromDeliveryStreamName` <a name="fromDeliveryStreamName" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamName"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.DeliveryStream.fromDeliveryStreamName(scope: Construct, id: string, deliveryStreamName: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamName.parameter.id"></a>

- *Type:* string

---

###### `deliveryStreamName`<sup>Required</sup> <a name="deliveryStreamName" id="cdk-extensions.kinesis_firehose.DeliveryStream.fromDeliveryStreamName.parameter.deliveryStreamName"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.connections">connections</a></code> | <code>aws-cdk-lib.aws_ec2.Connections</code> | The network connections associated with this resource. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.deliveryStreamArn">deliveryStreamArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.deliveryStreamName">deliveryStreamName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.destination">destination</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamDestination</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.grantPrincipal">grantPrincipal</a></code> | <code>aws-cdk-lib.aws_iam.IPrincipal</code> | The principal to grant permissions to. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStream.property.streamType">streamType</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamType</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.connections"></a>

```typescript
public readonly connections: Connections;
```

- *Type:* aws-cdk-lib.aws_ec2.Connections

The network connections associated with this resource.

---

##### `deliveryStreamArn`<sup>Required</sup> <a name="deliveryStreamArn" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.deliveryStreamArn"></a>

```typescript
public readonly deliveryStreamArn: string;
```

- *Type:* string

---

##### `deliveryStreamName`<sup>Required</sup> <a name="deliveryStreamName" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.deliveryStreamName"></a>

```typescript
public readonly deliveryStreamName: string;
```

- *Type:* string

---

##### `destination`<sup>Required</sup> <a name="destination" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.destination"></a>

```typescript
public readonly destination: DeliveryStreamDestination;
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamDestination

---

##### `grantPrincipal`<sup>Required</sup> <a name="grantPrincipal" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.grantPrincipal"></a>

```typescript
public readonly grantPrincipal: IPrincipal;
```

- *Type:* aws-cdk-lib.aws_iam.IPrincipal

The principal to grant permissions to.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.resource"></a>

```typescript
public readonly resource: CfnDeliveryStream;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `streamType`<sup>Optional</sup> <a name="streamType" id="cdk-extensions.kinesis_firehose.DeliveryStream.property.streamType"></a>

```typescript
public readonly streamType: DeliveryStreamType;
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamType

---


### Echoserver <a name="Echoserver" id="cdk-extensions.k8s_aws.Echoserver"></a>

- *Implements:* aws-cdk-lib.aws_ec2.IConnectable, cdk-extensions.route53.IDnsResolvable

Creates a simple Kubernetes test service using the Google echoserver test image.

The server listens for incoming web requests and echos the details of the
request back to the user. Each request results in output being written to
the Docker log providing a convenient way to test logging setup.

> [[Google echoserver image repository](https://console.cloud.google.com/gcr/images/google-containers/GLOBAL/echoserver)]([Google echoserver image repository](https://console.cloud.google.com/gcr/images/google-containers/GLOBAL/echoserver))

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.Echoserver.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.Echoserver(scope: Construct, id: string, props: EchoserverProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.EchoserverProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.Echoserver.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.Echoserver.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.Echoserver.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.EchoserverProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.registerDomain">registerDomain</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.Echoserver.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.Echoserver.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.Echoserver.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `registerDomain` <a name="registerDomain" id="cdk-extensions.k8s_aws.Echoserver.registerDomain"></a>

```typescript
public registerDomain(domain: Domain): void
```

###### `domain`<sup>Required</sup> <a name="domain" id="cdk-extensions.k8s_aws.Echoserver.registerDomain.parameter.domain"></a>

- *Type:* cdk-extensions.route53.Domain

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.Echoserver.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.Echoserver.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.Echoserver.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.Echoserver.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.Echoserver.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.Echoserver.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.Echoserver.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.Echoserver.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.Echoserver.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS Cluster where the service should be deployed. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.connections">connections</a></code> | <code>aws-cdk-lib.aws_ec2.Connections</code> | Access for network connections. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.domainDiscovery">domainDiscovery</a></code> | <code>cdk-extensions.route53.DomainDiscovery</code> | Determines the behavior of automatic DNS discovery and configuration. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.loadBalancerSubnets">loadBalancerSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | The subnets where the load balancer should be created.. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.manifest">manifest</a></code> | <code>aws-cdk-lib.aws_eks.KubernetesManifest</code> | The Kubernetes manifest that creates the ConfigMap that Fargate uses to configure logging. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.name">name</a></code> | <code>string</code> | The name of the Kubernetes service to be created. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be created. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.port">port</a></code> | <code>number</code> | The port which netcat should listen on. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.replicas">replicas</a></code> | <code>number</code> | The number of replicas that should exist. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.tag">tag</a></code> | <code>string</code> | The Docker tag specifying the version of echoserver to use. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.subdomain">subdomain</a></code> | <code>string</code> | A subdomain that should be prefixed to the beginning of all registered domains. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.Echoserver.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.Echoserver.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.Echoserver.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.Echoserver.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS Cluster where the service should be deployed.

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk-extensions.k8s_aws.Echoserver.property.connections"></a>

```typescript
public readonly connections: Connections;
```

- *Type:* aws-cdk-lib.aws_ec2.Connections

Access for network connections.

---

##### `domainDiscovery`<sup>Required</sup> <a name="domainDiscovery" id="cdk-extensions.k8s_aws.Echoserver.property.domainDiscovery"></a>

```typescript
public readonly domainDiscovery: DomainDiscovery;
```

- *Type:* cdk-extensions.route53.DomainDiscovery

Determines the behavior of automatic DNS discovery and configuration.

---

##### `loadBalancerSubnets`<sup>Required</sup> <a name="loadBalancerSubnets" id="cdk-extensions.k8s_aws.Echoserver.property.loadBalancerSubnets"></a>

```typescript
public readonly loadBalancerSubnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

The subnets where the load balancer should be created..

---

##### `manifest`<sup>Required</sup> <a name="manifest" id="cdk-extensions.k8s_aws.Echoserver.property.manifest"></a>

```typescript
public readonly manifest: KubernetesManifest;
```

- *Type:* aws-cdk-lib.aws_eks.KubernetesManifest

The Kubernetes manifest that creates the ConfigMap that Fargate uses to configure logging.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.Echoserver.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Kubernetes service to be created.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk-extensions.k8s_aws.Echoserver.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the service should be created.

---

##### `port`<sup>Required</sup> <a name="port" id="cdk-extensions.k8s_aws.Echoserver.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

The port which netcat should listen on.

---

##### `replicas`<sup>Required</sup> <a name="replicas" id="cdk-extensions.k8s_aws.Echoserver.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number

The number of replicas that should exist.

---

##### `tag`<sup>Required</sup> <a name="tag" id="cdk-extensions.k8s_aws.Echoserver.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* string

The Docker tag specifying the version of echoserver to use.

> [[Google echoserver image repository](https://console.cloud.google.com/gcr/images/google-containers/GLOBAL/echoserver)]([Google echoserver image repository](https://console.cloud.google.com/gcr/images/google-containers/GLOBAL/echoserver))

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk-extensions.k8s_aws.Echoserver.property.subdomain"></a>

```typescript
public readonly subdomain: string;
```

- *Type:* string

A subdomain that should be prefixed to the beginning of all registered domains.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_DOMAIN_DISCOVERY">DEFAULT_DOMAIN_DISCOVERY</a></code> | <code>cdk-extensions.route53.DomainDiscovery</code> | The default setting controlling how automatic DNS configuration should behave if none is provided as input. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_LOAD_BALANCER_SUBNETS">DEFAULT_LOAD_BALANCER_SUBNETS</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | Default subnet selection that will be used if none is provided as input. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_NAME">DEFAULT_NAME</a></code> | <code>string</code> | Default name of the Kubernetes service that will be created if none is provided as input. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_NAMESPACE">DEFAULT_NAMESPACE</a></code> | <code>string</code> | Default Kubernetes namespace where the service will be created if none is provided as input. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_PORT">DEFAULT_PORT</a></code> | <code>number</code> | Default port where the service will be accessible if none is provided as input. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_REPLICAS">DEFAULT_REPLICAS</a></code> | <code>number</code> | Default number of replicas that should be running is none is provided as input. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_REPOSITORY">DEFAULT_REPOSITORY</a></code> | <code>string</code> | The Docker repository where the echoserver image will be pulled from. |
| <code><a href="#cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_TAG">DEFAULT_TAG</a></code> | <code>string</code> | The default Docker tag of the image to use if none is provided as input. |

---

##### `DEFAULT_DOMAIN_DISCOVERY`<sup>Required</sup> <a name="DEFAULT_DOMAIN_DISCOVERY" id="cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_DOMAIN_DISCOVERY"></a>

```typescript
public readonly DEFAULT_DOMAIN_DISCOVERY: DomainDiscovery;
```

- *Type:* cdk-extensions.route53.DomainDiscovery

The default setting controlling how automatic DNS configuration should behave if none is provided as input.

---

##### `DEFAULT_LOAD_BALANCER_SUBNETS`<sup>Required</sup> <a name="DEFAULT_LOAD_BALANCER_SUBNETS" id="cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_LOAD_BALANCER_SUBNETS"></a>

```typescript
public readonly DEFAULT_LOAD_BALANCER_SUBNETS: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

Default subnet selection that will be used if none is provided as input.

---

##### `DEFAULT_NAME`<sup>Required</sup> <a name="DEFAULT_NAME" id="cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_NAME"></a>

```typescript
public readonly DEFAULT_NAME: string;
```

- *Type:* string

Default name of the Kubernetes service that will be created if none is provided as input.

---

##### `DEFAULT_NAMESPACE`<sup>Required</sup> <a name="DEFAULT_NAMESPACE" id="cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_NAMESPACE"></a>

```typescript
public readonly DEFAULT_NAMESPACE: string;
```

- *Type:* string

Default Kubernetes namespace where the service will be created if none is provided as input.

---

##### `DEFAULT_PORT`<sup>Required</sup> <a name="DEFAULT_PORT" id="cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_PORT"></a>

```typescript
public readonly DEFAULT_PORT: number;
```

- *Type:* number

Default port where the service will be accessible if none is provided as input.

---

##### `DEFAULT_REPLICAS`<sup>Required</sup> <a name="DEFAULT_REPLICAS" id="cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_REPLICAS"></a>

```typescript
public readonly DEFAULT_REPLICAS: number;
```

- *Type:* number

Default number of replicas that should be running is none is provided as input.

---

##### `DEFAULT_REPOSITORY`<sup>Required</sup> <a name="DEFAULT_REPOSITORY" id="cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_REPOSITORY"></a>

```typescript
public readonly DEFAULT_REPOSITORY: string;
```

- *Type:* string

The Docker repository where the echoserver image will be pulled from.

---

##### `DEFAULT_TAG`<sup>Required</sup> <a name="DEFAULT_TAG" id="cdk-extensions.k8s_aws.Echoserver.property.DEFAULT_TAG"></a>

```typescript
public readonly DEFAULT_TAG: string;
```

- *Type:* string

The default Docker tag of the image to use if none is provided as input.

---

### ExternalSecret <a name="ExternalSecret" id="cdk-extensions.k8s_aws.ExternalSecret"></a>

Represents a Kubernetes secret that is being synchronized from an external provider.

On a technical level, provides the configuration for how the external
secrets operator service should manage the synchronization of the Kubernetes
secret.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.ExternalSecret.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.ExternalSecret(scope: Construct, id: string, props: ExternalSecretProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.ExternalSecretProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.ExternalSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.ExternalSecret.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.ExternalSecret.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.ExternalSecretProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.addSecret">addSecret</a></code> | Adds a provider secret reference to the synchronized Kubernetes secret. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.ExternalSecret.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.ExternalSecret.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.ExternalSecret.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addSecret` <a name="addSecret" id="cdk-extensions.k8s_aws.ExternalSecret.addSecret"></a>

```typescript
public addSecret(secret: ISecretReference): ExternalSecret
```

Adds a provider secret reference to the synchronized Kubernetes secret.

For external secrets that reference multiple provider secrets the keys of
all provider secrets will be merged into the single Kubernetes secret.

###### `secret`<sup>Required</sup> <a name="secret" id="cdk-extensions.k8s_aws.ExternalSecret.addSecret.parameter.secret"></a>

- *Type:* cdk-extensions.k8s_aws.ISecretReference

The provider secret to reference.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.ExternalSecret.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalSecret.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.ExternalSecret.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.ExternalSecret.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalSecret.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.ExternalSecret.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.ExternalSecret.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalSecret.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.ExternalSecret.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the secret should be created. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.manifest">manifest</a></code> | <code>aws-cdk-lib.aws_eks.KubernetesManifest</code> | The Kubernetes manifest defining the configuration of how to synchronize the Kubernetes secret from the provider secrets. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.name">name</a></code> | <code>string</code> | The name to use for the Kubernetes secret resource when it is synchronized into the cluster. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.secretName">secretName</a></code> | <code>string</code> | The name of the Kubernetes secret. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.secrets">secrets</a></code> | <code>cdk-extensions.k8s_aws.ISecretReference[]</code> | The collection of referenced provider secrets that are referenced in the Kubernetes secret. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.secretStore">secretStore</a></code> | <code>cdk-extensions.k8s_aws.ISecretStore</code> | The Kubernetes secret store resource that provides details and permissions to use for importing secrets from the provider. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.namespace">namespace</a></code> | <code>string</code> | The name where the synchronized secret should be created. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecret.property.refreshInterval">refreshInterval</a></code> | <code>aws-cdk-lib.Duration</code> | The frequency at which synchronization should occur. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.ExternalSecret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.ExternalSecret.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.ExternalSecret.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.ExternalSecret.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the secret should be created.

---

##### `manifest`<sup>Required</sup> <a name="manifest" id="cdk-extensions.k8s_aws.ExternalSecret.property.manifest"></a>

```typescript
public readonly manifest: KubernetesManifest;
```

- *Type:* aws-cdk-lib.aws_eks.KubernetesManifest

The Kubernetes manifest defining the configuration of how to synchronize the Kubernetes secret from the provider secrets.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.ExternalSecret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name to use for the Kubernetes secret resource when it is synchronized into the cluster.

---

##### `secretName`<sup>Required</sup> <a name="secretName" id="cdk-extensions.k8s_aws.ExternalSecret.property.secretName"></a>

```typescript
public readonly secretName: string;
```

- *Type:* string

The name of the Kubernetes secret.

---

##### `secrets`<sup>Required</sup> <a name="secrets" id="cdk-extensions.k8s_aws.ExternalSecret.property.secrets"></a>

```typescript
public readonly secrets: ISecretReference[];
```

- *Type:* cdk-extensions.k8s_aws.ISecretReference[]

The collection of referenced provider secrets that are referenced in the Kubernetes secret.

---

##### `secretStore`<sup>Required</sup> <a name="secretStore" id="cdk-extensions.k8s_aws.ExternalSecret.property.secretStore"></a>

```typescript
public readonly secretStore: ISecretStore;
```

- *Type:* cdk-extensions.k8s_aws.ISecretStore

The Kubernetes secret store resource that provides details and permissions to use for importing secrets from the provider.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.ExternalSecret.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The name where the synchronized secret should be created.

---

##### `refreshInterval`<sup>Optional</sup> <a name="refreshInterval" id="cdk-extensions.k8s_aws.ExternalSecret.property.refreshInterval"></a>

```typescript
public readonly refreshInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

The frequency at which synchronization should occur.

---


### ExternalSecretsOperator <a name="ExternalSecretsOperator" id="cdk-extensions.k8s_aws.ExternalSecretsOperator"></a>

External Secrets Operator is a Kubernetes operator that integrates external secret management systems like AWS Secrets Manager, HashiCorp Vault, Google Secrets Manager, Azure Key Vault and many more.

The operator reads
information from external APIs and automatically injects the values into a
Kubernetes Secret.

> [[External Secrets Website](https://external-secrets.io/)]([External Secrets Website](https://external-secrets.io/))

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.ExternalSecretsOperator(scope: Construct, id: string, props: ExternalSecretsOperatorProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.ExternalSecretsOperatorProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.ExternalSecretsOperatorProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSecretsManagerSecret">registerSecretsManagerSecret</a></code> | Registers a Secrets Manager secret with the external secrets operator, enabling syncing from the Secrets Manager secret into Kubernetes. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSsmParameterSecret">registerSsmParameterSecret</a></code> | Registers a Systems Manager parameter with the external secrets operator, enabling syncing from the Systems Manager parameter into Kubernetes. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `registerSecretsManagerSecret` <a name="registerSecretsManagerSecret" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSecretsManagerSecret"></a>

```typescript
public registerSecretsManagerSecret(id: string, secret: ISecret, options?: NamespacedExternalSecretOptions): ExternalSecret
```

Registers a Secrets Manager secret with the external secrets operator, enabling syncing from the Secrets Manager secret into Kubernetes.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSecretsManagerSecret.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within for each secrets manager secret within a
Kubernetes namespace.

---

###### `secret`<sup>Required</sup> <a name="secret" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSecretsManagerSecret.parameter.secret"></a>

- *Type:* aws-cdk-lib.aws_secretsmanager.ISecret

The Secrets Manager secret to enable syncing for.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSecretsManagerSecret.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.NamespacedExternalSecretOptions

Options for configuring syncing of the Secrets Manager secret.

---

##### `registerSsmParameterSecret` <a name="registerSsmParameterSecret" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSsmParameterSecret"></a>

```typescript
public registerSsmParameterSecret(id: string, parameter: IParameter, options?: NamespacedExternalSecretOptions): ExternalSecret
```

Registers a Systems Manager parameter with the external secrets operator, enabling syncing from the Systems Manager parameter into Kubernetes.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSsmParameterSecret.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within for each Systems Manager parameter within a
Kubernetes namespace.

---

###### `parameter`<sup>Required</sup> <a name="parameter" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSsmParameterSecret.parameter.parameter"></a>

- *Type:* aws-cdk-lib.aws_ssm.IParameter

The Systems Manager parameter to enable syncing for.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.registerSsmParameterSecret.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.NamespacedExternalSecretOptions

Options for configuring syncing of the Systems Manager parameter.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalSecretsOperator.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalSecretsOperator.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalSecretsOperator.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.Cluster</code> | The EKS cluster where the external secrets operator service should be installed and configured. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.helmChart">helmChart</a></code> | <code>aws-cdk-lib.aws_eks.HelmChart</code> | The Helm chart the manages the installation and configuration of the external secrets operator service. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the external secrets operator service should be installed and configured. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.createNamespace">createNamespace</a></code> | <code>boolean</code> | Determines the behavior when the service is deployed to a namespace that doesn't already exist on the EKS cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.cluster"></a>

```typescript
public readonly cluster: Cluster;
```

- *Type:* aws-cdk-lib.aws_eks.Cluster

The EKS cluster where the external secrets operator service should be installed and configured.

---

##### `helmChart`<sup>Required</sup> <a name="helmChart" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.helmChart"></a>

```typescript
public readonly helmChart: HelmChart;
```

- *Type:* aws-cdk-lib.aws_eks.HelmChart

The Helm chart the manages the installation and configuration of the external secrets operator service.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the external secrets operator service should be installed and configured.

---

##### `createNamespace`<sup>Optional</sup> <a name="createNamespace" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.createNamespace"></a>

```typescript
public readonly createNamespace: boolean;
```

- *Type:* boolean

Determines the behavior when the service is deployed to a namespace that doesn't already exist on the EKS cluster.

When this flag is `true` and the namespace doesn't exist, the namespace
will be created automatically.

When this flag is `false` and the namespace doesn't exist, an error will
occur and resource creation will fail.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.CHART_NAME">CHART_NAME</a></code> | <code>string</code> | The name of the Helm chart to install from the Helm repository. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.CHART_REPOSITORY">CHART_REPOSITORY</a></code> | <code>string</code> | The URL of the Helm repository that hostys the Helm charts used to install the externalk secrets operator service. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperator.property.DEFAULT_NAMESPACE">DEFAULT_NAMESPACE</a></code> | <code>string</code> | The default Kubernetes namespace where the external secrets operator service should be installed and configured if no overriding input is provided. |

---

##### `CHART_NAME`<sup>Required</sup> <a name="CHART_NAME" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.CHART_NAME"></a>

```typescript
public readonly CHART_NAME: string;
```

- *Type:* string

The name of the Helm chart to install from the Helm repository.

---

##### `CHART_REPOSITORY`<sup>Required</sup> <a name="CHART_REPOSITORY" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.CHART_REPOSITORY"></a>

```typescript
public readonly CHART_REPOSITORY: string;
```

- *Type:* string

The URL of the Helm repository that hostys the Helm charts used to install the externalk secrets operator service.

---

##### `DEFAULT_NAMESPACE`<sup>Required</sup> <a name="DEFAULT_NAMESPACE" id="cdk-extensions.k8s_aws.ExternalSecretsOperator.property.DEFAULT_NAMESPACE"></a>

```typescript
public readonly DEFAULT_NAMESPACE: string;
```

- *Type:* string

The default Kubernetes namespace where the external secrets operator service should be installed and configured if no overriding input is provided.

---

### FargateLogger <a name="FargateLogger" id="cdk-extensions.k8s_aws.FargateLogger"></a>

Creates a ConfigMap that configures logging for containers running in EKS on Fargate.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FargateLogger.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FargateLogger(scope: Construct, id: string, props: FargateLoggerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.FargateLoggerProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FargateLogger.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.FargateLogger.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.FargateLogger.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.FargateLoggerProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.addFargateProfile">addFargateProfile</a></code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.addFilter">addFilter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.addOutput">addOutput</a></code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.addParser">addParser</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.FargateLogger.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.FargateLogger.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.FargateLogger.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addFargateProfile` <a name="addFargateProfile" id="cdk-extensions.k8s_aws.FargateLogger.addFargateProfile"></a>

```typescript
public addFargateProfile(profile: FargateProfile): FargateLogger
```

###### `profile`<sup>Required</sup> <a name="profile" id="cdk-extensions.k8s_aws.FargateLogger.addFargateProfile.parameter.profile"></a>

- *Type:* aws-cdk-lib.aws_eks.FargateProfile

---

##### `addFilter` <a name="addFilter" id="cdk-extensions.k8s_aws.FargateLogger.addFilter"></a>

```typescript
public addFilter(filter: IFluentBitFilterPlugin): FargateLogger
```

###### `filter`<sup>Required</sup> <a name="filter" id="cdk-extensions.k8s_aws.FargateLogger.addFilter.parameter.filter"></a>

- *Type:* cdk-extensions.k8s_aws.IFluentBitFilterPlugin

---

##### `addOutput` <a name="addOutput" id="cdk-extensions.k8s_aws.FargateLogger.addOutput"></a>

```typescript
public addOutput(output: IFluentBitOutputPlugin): FargateLogger
```

###### `output`<sup>Required</sup> <a name="output" id="cdk-extensions.k8s_aws.FargateLogger.addOutput.parameter.output"></a>

- *Type:* cdk-extensions.k8s_aws.IFluentBitOutputPlugin

---

##### `addParser` <a name="addParser" id="cdk-extensions.k8s_aws.FargateLogger.addParser"></a>

```typescript
public addParser(parser: IFluentBitParserPlugin): FargateLogger
```

###### `parser`<sup>Required</sup> <a name="parser" id="cdk-extensions.k8s_aws.FargateLogger.addParser.parameter.parser"></a>

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.FargateLogger.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FargateLogger.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.FargateLogger.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.FargateLogger.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FargateLogger.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.FargateLogger.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.FargateLogger.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FargateLogger.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.FargateLogger.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where Fargate logging is being configured. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.property.filters">filters</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitFilterPlugin[]</code> | Collection of Fluent Bit filter plugins being configured for logging. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.property.manifest">manifest</a></code> | <code>aws-cdk-lib.aws_eks.KubernetesManifest</code> | The Kubernetes manifest that creates the ConfigMap that Fargate uses to configure logging. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.property.outputs">outputs</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitOutputPlugin[]</code> | Collection of Fluent Bit output plugins being configured for logging. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLogger.property.parsers">parsers</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitParserPlugin[]</code> | Collection of Fluent Bit parser plugins being configured for logging. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.FargateLogger.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.FargateLogger.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.FargateLogger.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.FargateLogger.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where Fargate logging is being configured.

---

##### `filters`<sup>Required</sup> <a name="filters" id="cdk-extensions.k8s_aws.FargateLogger.property.filters"></a>

```typescript
public readonly filters: IFluentBitFilterPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitFilterPlugin[]

Collection of Fluent Bit filter plugins being configured for logging.

---

##### `manifest`<sup>Required</sup> <a name="manifest" id="cdk-extensions.k8s_aws.FargateLogger.property.manifest"></a>

```typescript
public readonly manifest: KubernetesManifest;
```

- *Type:* aws-cdk-lib.aws_eks.KubernetesManifest

The Kubernetes manifest that creates the ConfigMap that Fargate uses to configure logging.

---

##### `outputs`<sup>Required</sup> <a name="outputs" id="cdk-extensions.k8s_aws.FargateLogger.property.outputs"></a>

```typescript
public readonly outputs: IFluentBitOutputPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitOutputPlugin[]

Collection of Fluent Bit output plugins being configured for logging.

---

##### `parsers`<sup>Required</sup> <a name="parsers" id="cdk-extensions.k8s_aws.FargateLogger.property.parsers"></a>

```typescript
public readonly parsers: IFluentBitParserPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin[]

Collection of Fluent Bit parser plugins being configured for logging.

---


### FlowLog <a name="FlowLog" id="cdk-extensions.ec2.FlowLog"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.FlowLog.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.FlowLog(scope: IConstruct, id: string, props: FlowLogProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLog.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.FlowLog.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.FlowLog.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.FlowLogProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.FlowLog.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.FlowLog.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.FlowLog.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.FlowLogProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLog.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.FlowLog.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.FlowLog.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.FlowLog.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.FlowLog.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLog.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.FlowLog.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.FlowLog.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.FlowLog.fromFlowLogId">fromFlowLogId</a></code> | Import a Flow Log by it's Id. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.FlowLog.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.FlowLog.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.FlowLog.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.FlowLog.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.FlowLog.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.FlowLog.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.FlowLog.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.FlowLog.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.FlowLog.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromFlowLogId` <a name="fromFlowLogId" id="cdk-extensions.ec2.FlowLog.fromFlowLogId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.FlowLog.fromFlowLogId(scope: Construct, id: string, flowLogId: string)
```

Import a Flow Log by it's Id.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.FlowLog.fromFlowLogId.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.FlowLog.fromFlowLogId.parameter.id"></a>

- *Type:* string

---

###### `flowLogId`<sup>Required</sup> <a name="flowLogId" id="cdk-extensions.ec2.FlowLog.fromFlowLogId.parameter.flowLogId"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.flowLogId">flowLogId</a></code> | <code>string</code> | The Id of the VPC Flow Log. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | The S3 bucket to publish flow logs to. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.iamRole">iamRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | The iam role used to publish logs to CloudWatch. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | S3 bucket key prefix to publish the flow logs under. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | The CloudWatch Logs LogGroup to publish flow logs to. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.destination">destination</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogDestination</code> | The location where flow logs should be delivered. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.logFormat">logFormat</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | The fields to include in the flow log record, in the order in which they should appear. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnFlowLog</code> | The underlying FlowLog CloudFormation resource. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.resourceType">resourceType</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogResourceType</code> | Details for the resource from which flow logs will be captured. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.trafficType">trafficType</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogTrafficType</code> | The type of traffic to monitor (accepted traffic, rejected traffic, or all traffic). |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.flowLogName">flowLogName</a></code> | <code>string</code> | The name of the FlowLog. |
| <code><a href="#cdk-extensions.ec2.FlowLog.property.maxAggregationInterval">maxAggregationInterval</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogMaxAggregationInterval</code> | The maximum interval of time during which a flow of packets is captured and aggregated into a flow log record. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.FlowLog.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.FlowLog.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.FlowLog.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `flowLogId`<sup>Required</sup> <a name="flowLogId" id="cdk-extensions.ec2.FlowLog.property.flowLogId"></a>

```typescript
public readonly flowLogId: string;
```

- *Type:* string

The Id of the VPC Flow Log.

---

##### `bucket`<sup>Optional</sup> <a name="bucket" id="cdk-extensions.ec2.FlowLog.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

The S3 bucket to publish flow logs to.

---

##### `iamRole`<sup>Optional</sup> <a name="iamRole" id="cdk-extensions.ec2.FlowLog.property.iamRole"></a>

```typescript
public readonly iamRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

The iam role used to publish logs to CloudWatch.

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk-extensions.ec2.FlowLog.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string

S3 bucket key prefix to publish the flow logs under.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.ec2.FlowLog.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The CloudWatch Logs LogGroup to publish flow logs to.

---

##### `destination`<sup>Required</sup> <a name="destination" id="cdk-extensions.ec2.FlowLog.property.destination"></a>

```typescript
public readonly destination: FlowLogDestination;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogDestination

The location where flow logs should be delivered.

> [[FlowLog LogDestinationType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestinationtype)]([FlowLog LogDestinationType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestinationtype))

---

##### `logFormat`<sup>Required</sup> <a name="logFormat" id="cdk-extensions.ec2.FlowLog.property.logFormat"></a>

```typescript
public readonly logFormat: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

The fields to include in the flow log record, in the order in which they should appear.

For a list of available fields, see {@link FlowLogField}.

> [[FlowLog LogFormat](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logformat)]([FlowLog LogFormat](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logformat))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.FlowLog.property.resource"></a>

```typescript
public readonly resource: CfnFlowLog;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnFlowLog

The underlying FlowLog CloudFormation resource.

> [[AWS::EC2::FlowLog](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html)]([AWS::EC2::FlowLog](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html))

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk-extensions.ec2.FlowLog.property.resourceType"></a>

```typescript
public readonly resourceType: FlowLogResourceType;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogResourceType

Details for the resource from which flow logs will be captured.

> [[FlowLog ResourceType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-resourcetype)]([FlowLog ResourceType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-resourcetype))

---

##### `trafficType`<sup>Required</sup> <a name="trafficType" id="cdk-extensions.ec2.FlowLog.property.trafficType"></a>

```typescript
public readonly trafficType: FlowLogTrafficType;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogTrafficType

The type of traffic to monitor (accepted traffic, rejected traffic, or all traffic).

> [[FlowLog TrafficType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-traffictype)]([FlowLog TrafficType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-traffictype))

---

##### `flowLogName`<sup>Optional</sup> <a name="flowLogName" id="cdk-extensions.ec2.FlowLog.property.flowLogName"></a>

```typescript
public readonly flowLogName: string;
```

- *Type:* string

The name of the FlowLog.

---

##### `maxAggregationInterval`<sup>Optional</sup> <a name="maxAggregationInterval" id="cdk-extensions.ec2.FlowLog.property.maxAggregationInterval"></a>

```typescript
public readonly maxAggregationInterval: FlowLogMaxAggregationInterval;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogMaxAggregationInterval

The maximum interval of time during which a flow of packets is captured and aggregated into a flow log record.

> [[FlowLog MaxAggregationInterval](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-maxaggregationinterval)]([FlowLog MaxAggregationInterval](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-maxaggregationinterval))

---


### FlowLogsBucket <a name="FlowLogsBucket" id="cdk-extensions.s3_buckets.FlowLogsBucket"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.s3_buckets.FlowLogsBucket.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

new s3_buckets.FlowLogsBucket(scope: Construct, id: string, props?: FlowLogsBucketProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.s3_buckets.FlowLogsBucketProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.FlowLogsBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.s3_buckets.FlowLogsBucket.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.s3_buckets.FlowLogsBucket.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.s3_buckets.FlowLogsBucketProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.addEventNotification">addEventNotification</a></code> | Adds a bucket notification event destination. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.addObjectCreatedNotification">addObjectCreatedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 created in the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.addObjectRemovedNotification">addObjectRemovedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 removed from the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.addToResourcePolicy">addToResourcePolicy</a></code> | Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.arnForObjects">arnForObjects</a></code> | Returns an ARN that represents all objects within the bucket that match
 the key pattern specified. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.enableEventBridgeNotification">enableEventBridgeNotification</a></code> | Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.grantDelete">grantDelete</a></code> | Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.grantPublicAccess">grantPublicAccess</a></code> | Allows unrestricted access to objects from this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.grantPut">grantPut</a></code> | Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.grantPutAcl">grantPutAcl</a></code> | Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.grantRead">grantRead</a></code> | Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.grantReadWrite">grantReadWrite</a></code> | Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.grantWrite">grantWrite</a></code> | Grant write permissions to this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailEvent">onCloudTrailEvent</a></code> | Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailPutObject">onCloudTrailPutObject</a></code> | Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailWriteObject">onCloudTrailWriteObject</a></code> | Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.s3UrlForObject">s3UrlForObject</a></code> | The S3 URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.transferAccelerationUrlForObject">transferAccelerationUrlForObject</a></code> | The https Transfer Acceleration URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.urlForObject">urlForObject</a></code> | The https URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.virtualHostedUrlForObject">virtualHostedUrlForObject</a></code> | The virtual hosted-style URL of an S3 object. |

---

##### `toString` <a name="toString" id="cdk-extensions.s3_buckets.FlowLogsBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.s3_buckets.FlowLogsBucket.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.s3_buckets.FlowLogsBucket.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addEventNotification` <a name="addEventNotification" id="cdk-extensions.s3_buckets.FlowLogsBucket.addEventNotification"></a>

```typescript
public addEventNotification(_event: EventType, _dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Adds a bucket notification event destination.

###### `_event`<sup>Required</sup> <a name="_event" id="cdk-extensions.s3_buckets.FlowLogsBucket.addEventNotification.parameter._event"></a>

- *Type:* aws-cdk-lib.aws_s3.EventType

---

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.FlowLogsBucket.addEventNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.FlowLogsBucket.addEventNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectCreatedNotification` <a name="addObjectCreatedNotification" id="cdk-extensions.s3_buckets.FlowLogsBucket.addObjectCreatedNotification"></a>

```typescript
public addObjectCreatedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 created in the bucket.

This is identical to calling
`onEvent(s3.EventType.OBJECT_CREATED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.FlowLogsBucket.addObjectCreatedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.FlowLogsBucket.addObjectCreatedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectRemovedNotification` <a name="addObjectRemovedNotification" id="cdk-extensions.s3_buckets.FlowLogsBucket.addObjectRemovedNotification"></a>

```typescript
public addObjectRemovedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 removed from the bucket.

This is identical to calling
`onEvent(EventType.OBJECT_REMOVED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.FlowLogsBucket.addObjectRemovedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.FlowLogsBucket.addObjectRemovedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addToResourcePolicy` <a name="addToResourcePolicy" id="cdk-extensions.s3_buckets.FlowLogsBucket.addToResourcePolicy"></a>

```typescript
public addToResourcePolicy(permission: PolicyStatement): AddToResourcePolicyResult
```

Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases.

###### `permission`<sup>Required</sup> <a name="permission" id="cdk-extensions.s3_buckets.FlowLogsBucket.addToResourcePolicy.parameter.permission"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `arnForObjects` <a name="arnForObjects" id="cdk-extensions.s3_buckets.FlowLogsBucket.arnForObjects"></a>

```typescript
public arnForObjects(_keyPattern: string): string
```

Returns an ARN that represents all objects within the bucket that match
 the key pattern specified.

To represent all keys, specify ``"*"``.

###### `_keyPattern`<sup>Required</sup> <a name="_keyPattern" id="cdk-extensions.s3_buckets.FlowLogsBucket.arnForObjects.parameter._keyPattern"></a>

- *Type:* string

---

##### `enableEventBridgeNotification` <a name="enableEventBridgeNotification" id="cdk-extensions.s3_buckets.FlowLogsBucket.enableEventBridgeNotification"></a>

```typescript
public enableEventBridgeNotification(): void
```

Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted.

##### `grantDelete` <a name="grantDelete" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantDelete"></a>

```typescript
public grantDelete(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantDelete.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantDelete.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPublicAccess` <a name="grantPublicAccess" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPublicAccess"></a>

```typescript
public grantPublicAccess(_allowedActions: string, _keyPrefix?: string): Grant
```

Allows unrestricted access to objects from this bucket.

IMPORTANT: This permission allows anyone to perform actions on S3 objects
in this bucket, which is useful for when you configure your bucket as a
website and want everyone to be able to read objects in the bucket without
needing to authenticate.

Without arguments, this method will grant read ("s3:GetObject") access to
all objects ("*") in the bucket.

The method returns the `iam.Grant` object, which can then be modified
as needed. For example, you can add a condition that will restrict access only
to an IPv4 range like this:

     const grant = bucket.grantPublicAccess();
     grant.resourceStatement!.addCondition(‘IpAddress’, { “aws:SourceIp”: “54.240.143.0/24” });

###### `_allowedActions`<sup>Required</sup> <a name="_allowedActions" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPublicAccess.parameter._allowedActions"></a>

- *Type:* string

---

###### `_keyPrefix`<sup>Optional</sup> <a name="_keyPrefix" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPublicAccess.parameter._keyPrefix"></a>

- *Type:* string

---

##### `grantPut` <a name="grantPut" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPut"></a>

```typescript
public grantPut(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPut.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPut.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPutAcl` <a name="grantPutAcl" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPutAcl"></a>

```typescript
public grantPutAcl(_identity: IGrantable, _objectsKeyPattern?: string): Grant
```

Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket.

If your application has the '@aws-cdk/aws-s3:grantWriteWithoutAcl' feature flag set,
calling `grantWrite` or `grantReadWrite` no longer grants permissions to modify the ACLs of the objects;
in this case, if you need to modify object ACLs, call this method explicitly.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPutAcl.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantPutAcl.parameter._objectsKeyPattern"></a>

- *Type:* string

---

##### `grantRead` <a name="grantRead" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantRead"></a>

```typescript
public grantRead(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If encryption is used, permission to use the key to decrypt the contents
of the bucket will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantRead.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantRead.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantReadWrite"></a>

```typescript
public grantReadWrite(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If an encryption key is used, permission to use the key for
encrypt/decrypt will also be granted.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantReadWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantReadWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantWrite` <a name="grantWrite" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantWrite"></a>

```typescript
public grantWrite(_identity: IGrantable, _objectsKeyPattern?: any, _allowedActionPatterns?: string[]): Grant
```

Grant write permissions to this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

###### `_allowedActionPatterns`<sup>Optional</sup> <a name="_allowedActionPatterns" id="cdk-extensions.s3_buckets.FlowLogsBucket.grantWrite.parameter._allowedActionPatterns"></a>

- *Type:* string[]

---

##### `onCloudTrailEvent` <a name="onCloudTrailEvent" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailEvent"></a>

```typescript
public onCloudTrailEvent(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event.

This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailEvent.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailEvent.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailPutObject` <a name="onCloudTrailPutObject" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailPutObject"></a>

```typescript
public onCloudTrailPutObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using `onCloudTrailWriteObject` may be preferable.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailPutObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailPutObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailWriteObject` <a name="onCloudTrailWriteObject" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailWriteObject"></a>

```typescript
public onCloudTrailWriteObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to.

This includes
the events PutObject, CopyObject, and CompleteMultipartUpload.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using this method may be preferable to `onCloudTrailPutObject`.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailWriteObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.FlowLogsBucket.onCloudTrailWriteObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `s3UrlForObject` <a name="s3UrlForObject" id="cdk-extensions.s3_buckets.FlowLogsBucket.s3UrlForObject"></a>

```typescript
public s3UrlForObject(_key?: string): string
```

The S3 URL of an S3 object.

For example:
- `s3://onlybucket`
- `s3://bucket/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.FlowLogsBucket.s3UrlForObject.parameter._key"></a>

- *Type:* string

---

##### `transferAccelerationUrlForObject` <a name="transferAccelerationUrlForObject" id="cdk-extensions.s3_buckets.FlowLogsBucket.transferAccelerationUrlForObject"></a>

```typescript
public transferAccelerationUrlForObject(_key?: string, _options?: TransferAccelerationUrlOptions): string
```

The https Transfer Acceleration URL of an S3 object.

Specify `dualStack: true` at the options
for dual-stack endpoint (connect to the bucket over IPv6). For example:

- `https://bucket.s3-accelerate.amazonaws.com`
- `https://bucket.s3-accelerate.amazonaws.com/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.FlowLogsBucket.transferAccelerationUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.FlowLogsBucket.transferAccelerationUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.TransferAccelerationUrlOptions

---

##### `urlForObject` <a name="urlForObject" id="cdk-extensions.s3_buckets.FlowLogsBucket.urlForObject"></a>

```typescript
public urlForObject(_key?: string): string
```

The https URL of an S3 object.

For example:

- `https://s3.us-west-1.amazonaws.com/onlybucket`
- `https://s3.us-west-1.amazonaws.com/bucket/key`
- `https://s3.cn-north-1.amazonaws.com.cn/china-bucket/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.FlowLogsBucket.urlForObject.parameter._key"></a>

- *Type:* string

---

##### `virtualHostedUrlForObject` <a name="virtualHostedUrlForObject" id="cdk-extensions.s3_buckets.FlowLogsBucket.virtualHostedUrlForObject"></a>

```typescript
public virtualHostedUrlForObject(_key?: string, _options?: VirtualHostedStyleUrlOptions): string
```

The virtual hosted-style URL of an S3 object.

Specify `regional: false` at
the options for non-regional URL. For example:

- `https://only-bucket.s3.us-west-1.amazonaws.com`
- `https://bucket.s3.us-west-1.amazonaws.com/key`
- `https://bucket.s3.amazonaws.com/key`
- `https://china-bucket.s3.cn-north-1.amazonaws.com.cn/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.FlowLogsBucket.virtualHostedUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.FlowLogsBucket.virtualHostedUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.VirtualHostedStyleUrlOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.s3_buckets.FlowLogsBucket.isConstruct"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.FlowLogsBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.s3_buckets.FlowLogsBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.s3_buckets.FlowLogsBucket.isOwnedResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.FlowLogsBucket.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.FlowLogsBucket.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.s3_buckets.FlowLogsBucket.isResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.FlowLogsBucket.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.FlowLogsBucket.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketArn">bucketArn</a></code> | <code>string</code> | The ARN of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | The IPv4 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketDualStackDomainName">bucketDualStackDomainName</a></code> | <code>string</code> | The IPv6 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketName">bucketName</a></code> | <code>string</code> | The name of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketRegionalDomainName">bucketRegionalDomainName</a></code> | <code>string</code> | The regional domain name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketWebsiteDomainName">bucketWebsiteDomainName</a></code> | <code>string</code> | The Domain name of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketWebsiteUrl">bucketWebsiteUrl</a></code> | <code>string</code> | The URL of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_s3.CfnBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | Optional KMS encryption key associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.isWebsite">isWebsite</a></code> | <code>boolean</code> | If this bucket has been configured for static website hosting. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.policy">policy</a></code> | <code>aws-cdk-lib.aws_s3.BucketPolicy</code> | The resource policy associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.crawler">crawler</a></code> | <code>cdk-extensions.glue.Crawler</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.format">format</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.table">table</a></code> | <code>cdk-extensions.glue_tables.FlowLogsTable</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.crawlerSchedule">crawlerSchedule</a></code> | <code>aws-cdk-lib.aws_events.Schedule</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucket.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bucketArn`<sup>Required</sup> <a name="bucketArn" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketArn"></a>

```typescript
public readonly bucketArn: string;
```

- *Type:* string

The ARN of the bucket.

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

The IPv4 DNS name of the specified bucket.

---

##### `bucketDualStackDomainName`<sup>Required</sup> <a name="bucketDualStackDomainName" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketDualStackDomainName"></a>

```typescript
public readonly bucketDualStackDomainName: string;
```

- *Type:* string

The IPv6 DNS name of the specified bucket.

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

The name of the bucket.

---

##### `bucketRegionalDomainName`<sup>Required</sup> <a name="bucketRegionalDomainName" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketRegionalDomainName"></a>

```typescript
public readonly bucketRegionalDomainName: string;
```

- *Type:* string

The regional domain name of the specified bucket.

---

##### `bucketWebsiteDomainName`<sup>Required</sup> <a name="bucketWebsiteDomainName" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketWebsiteDomainName"></a>

```typescript
public readonly bucketWebsiteDomainName: string;
```

- *Type:* string

The Domain name of the static website.

---

##### `bucketWebsiteUrl`<sup>Required</sup> <a name="bucketWebsiteUrl" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.bucketWebsiteUrl"></a>

```typescript
public readonly bucketWebsiteUrl: string;
```

- *Type:* string

The URL of the static website.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.resource"></a>

```typescript
public readonly resource: CfnBucket;
```

- *Type:* aws-cdk-lib.aws_s3.CfnBucket

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

Optional KMS encryption key associated with this bucket.

---

##### `isWebsite`<sup>Optional</sup> <a name="isWebsite" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.isWebsite"></a>

```typescript
public readonly isWebsite: boolean;
```

- *Type:* boolean

If this bucket has been configured for static website hosting.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.policy"></a>

```typescript
public readonly policy: BucketPolicy;
```

- *Type:* aws-cdk-lib.aws_s3.BucketPolicy

The resource policy associated with this bucket.

If `autoCreatePolicy` is true, a `BucketPolicy` will be created upon the
first call to addToResourcePolicy(s).

---

##### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.crawler"></a>

```typescript
public readonly crawler: Crawler;
```

- *Type:* cdk-extensions.glue.Crawler

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.format"></a>

```typescript
public readonly format: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.table"></a>

```typescript
public readonly table: FlowLogsTable;
```

- *Type:* cdk-extensions.glue_tables.FlowLogsTable

---

##### `crawlerSchedule`<sup>Optional</sup> <a name="crawlerSchedule" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.crawlerSchedule"></a>

```typescript
public readonly crawlerSchedule: Schedule;
```

- *Type:* aws-cdk-lib.aws_events.Schedule

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.FlowLogsBucket.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---


### FlowLogsTable <a name="FlowLogsTable" id="cdk-extensions.glue_tables.FlowLogsTable"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue_tables.FlowLogsTable.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

new glue_tables.FlowLogsTable(scope: Construct, id: string, props: FlowLogsTableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue_tables.FlowLogsTableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue_tables.FlowLogsTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue_tables.FlowLogsTable.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue_tables.FlowLogsTable.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue_tables.FlowLogsTableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.addColumn">addColumn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.addParameter">addParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.addPartitionKey">addPartitionKey</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.addSerdeParameter">addSerdeParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.addStorageParameter">addStorageParameter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue_tables.FlowLogsTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue_tables.FlowLogsTable.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue_tables.FlowLogsTable.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue_tables.FlowLogsTable.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.FlowLogsTable.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.glue_tables.FlowLogsTable.addParameter"></a>

```typescript
public addParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.FlowLogsTable.addParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.FlowLogsTable.addParameter.parameter.value"></a>

- *Type:* string

---

##### `addPartitionKey` <a name="addPartitionKey" id="cdk-extensions.glue_tables.FlowLogsTable.addPartitionKey"></a>

```typescript
public addPartitionKey(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.FlowLogsTable.addPartitionKey.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addSerdeParameter` <a name="addSerdeParameter" id="cdk-extensions.glue_tables.FlowLogsTable.addSerdeParameter"></a>

```typescript
public addSerdeParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.FlowLogsTable.addSerdeParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.FlowLogsTable.addSerdeParameter.parameter.value"></a>

- *Type:* string

---

##### `addStorageParameter` <a name="addStorageParameter" id="cdk-extensions.glue_tables.FlowLogsTable.addStorageParameter"></a>

```typescript
public addStorageParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.FlowLogsTable.addStorageParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.FlowLogsTable.addStorageParameter.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue_tables.FlowLogsTable.isConstruct"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.FlowLogsTable.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue_tables.FlowLogsTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue_tables.FlowLogsTable.isOwnedResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.FlowLogsTable.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.FlowLogsTable.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue_tables.FlowLogsTable.isResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.FlowLogsTable.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.FlowLogsTable.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link TableProps.database:}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTable</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.tableArn">tableArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.compressed">compressed</a></code> | <code>boolean</code> | {@link TableProps.compressed}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | {@link TableProps.dataFormat}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.description">description</a></code> | <code>string</code> | {@link TableProps.description}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.location">location</a></code> | <code>string</code> | {@link TableProps.location}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.name">name</a></code> | <code>string</code> | {@link TableProps.name}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.owner">owner</a></code> | <code>string</code> | {@link TableProps.owner}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | {@link TableProps.retention}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.serdeName">serdeName</a></code> | <code>string</code> | {@link TableProps.serdeName}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | {@link TableProps.storedAsSubDirectories}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | {@link TableProps.tableType}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | {@link TableProps.targetTable}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | {@link TableProps.viewExpandedText}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | {@link TableProps.viewOriginalText}. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the Flow Logs. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.format">format</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | A cdk-extentions/ec2 {@link aws-ec2!FlowLogFormat } object defining the desired formatting for Flow Logs. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTable.property.internalRejectedNamedQuery">internalRejectedNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue_tables.FlowLogsTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue_tables.FlowLogsTable.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue_tables.FlowLogsTable.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.FlowLogsTable.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link TableProps.database:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue_tables.FlowLogsTable.property.resource"></a>

```typescript
public readonly resource: CfnTable;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTable

---

##### `tableArn`<sup>Required</sup> <a name="tableArn" id="cdk-extensions.glue_tables.FlowLogsTable.property.tableArn"></a>

```typescript
public readonly tableArn: string;
```

- *Type:* string

---

##### `tableName`<sup>Required</sup> <a name="tableName" id="cdk-extensions.glue_tables.FlowLogsTable.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue_tables.FlowLogsTable.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

{@link TableProps.compressed}.

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue_tables.FlowLogsTable.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

{@link TableProps.dataFormat}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue_tables.FlowLogsTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link TableProps.description}.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue_tables.FlowLogsTable.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

{@link TableProps.location}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.FlowLogsTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link TableProps.name}.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue_tables.FlowLogsTable.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

{@link TableProps.owner}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue_tables.FlowLogsTable.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link TableProps.retention}.

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue_tables.FlowLogsTable.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

{@link TableProps.serdeName}.

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue_tables.FlowLogsTable.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

{@link TableProps.storedAsSubDirectories}.

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue_tables.FlowLogsTable.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

{@link TableProps.tableType}.

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue_tables.FlowLogsTable.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

{@link TableProps.targetTable}.

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue_tables.FlowLogsTable.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

{@link TableProps.viewExpandedText}.

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue_tables.FlowLogsTable.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

{@link TableProps.viewOriginalText}.

---

##### `createQueries`<sup>Required</sup> <a name="createQueries" id="cdk-extensions.glue_tables.FlowLogsTable.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the Flow Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.glue_tables.FlowLogsTable.property.format"></a>

```typescript
public readonly format: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

A cdk-extentions/ec2 {@link aws-ec2!FlowLogFormat } object defining the desired formatting for Flow Logs.

---

##### `friendlyQueryNames`<sup>Required</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.FlowLogsTable.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `internalRejectedNamedQuery`<sup>Optional</sup> <a name="internalRejectedNamedQuery" id="cdk-extensions.glue_tables.FlowLogsTable.property.internalRejectedNamedQuery"></a>

```typescript
public readonly internalRejectedNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---


### FourTierNetwork <a name="FourTierNetwork" id="cdk-extensions.ec2_patterns.FourTierNetwork"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2_patterns.FourTierNetwork.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

new ec2_patterns.FourTierNetwork(scope: IConstruct, id: string, props?: FourTierNetworkProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2_patterns.FourTierNetworkProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetwork.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2_patterns.FourTierNetwork.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2_patterns.FourTierNetworkProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.addClientVpnEndpoint">addClientVpnEndpoint</a></code> | Adds a new client VPN endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.addFlowLog">addFlowLog</a></code> | Adds a new flow log to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.addGatewayEndpoint">addGatewayEndpoint</a></code> | Adds a new gateway endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.addInterfaceEndpoint">addInterfaceEndpoint</a></code> | Adds a new interface endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.addVpnConnection">addVpnConnection</a></code> | Adds a new VPN connection to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.enableVpnGateway">enableVpnGateway</a></code> | Adds a VPN Gateway to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.selectSubnets">selectSubnets</a></code> | Returns IDs of selected subnets. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.addVpcFlowLog">addVpcFlowLog</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2_patterns.FourTierNetwork.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2_patterns.FourTierNetwork.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2_patterns.FourTierNetwork.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addClientVpnEndpoint` <a name="addClientVpnEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetwork.addClientVpnEndpoint"></a>

```typescript
public addClientVpnEndpoint(id: string, options: ClientVpnEndpointOptions): ClientVpnEndpoint
```

Adds a new client VPN endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.addClientVpnEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetwork.addClientVpnEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.ClientVpnEndpointOptions

---

##### `addFlowLog` <a name="addFlowLog" id="cdk-extensions.ec2_patterns.FourTierNetwork.addFlowLog"></a>

```typescript
public addFlowLog(id: string, options?: FlowLogOptions): FlowLog
```

Adds a new flow log to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.addFlowLog.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetwork.addFlowLog.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.FlowLogOptions

---

##### `addGatewayEndpoint` <a name="addGatewayEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetwork.addGatewayEndpoint"></a>

```typescript
public addGatewayEndpoint(id: string, options: GatewayVpcEndpointOptions): GatewayVpcEndpoint
```

Adds a new gateway endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.addGatewayEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetwork.addGatewayEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions

---

##### `addInterfaceEndpoint` <a name="addInterfaceEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetwork.addInterfaceEndpoint"></a>

```typescript
public addInterfaceEndpoint(id: string, options: InterfaceVpcEndpointOptions): InterfaceVpcEndpoint
```

Adds a new interface endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.addInterfaceEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetwork.addInterfaceEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.InterfaceVpcEndpointOptions

---

##### `addVpnConnection` <a name="addVpnConnection" id="cdk-extensions.ec2_patterns.FourTierNetwork.addVpnConnection"></a>

```typescript
public addVpnConnection(id: string, options: VpnConnectionOptions): VpnConnection
```

Adds a new VPN connection to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.addVpnConnection.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetwork.addVpnConnection.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpnConnectionOptions

---

##### `enableVpnGateway` <a name="enableVpnGateway" id="cdk-extensions.ec2_patterns.FourTierNetwork.enableVpnGateway"></a>

```typescript
public enableVpnGateway(options: EnableVpnGatewayOptions): void
```

Adds a VPN Gateway to this VPC.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetwork.enableVpnGateway.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.EnableVpnGatewayOptions

---

##### `selectSubnets` <a name="selectSubnets" id="cdk-extensions.ec2_patterns.FourTierNetwork.selectSubnets"></a>

```typescript
public selectSubnets(selection?: SubnetSelection): SelectedSubnets
```

Returns IDs of selected subnets.

###### `selection`<sup>Optional</sup> <a name="selection" id="cdk-extensions.ec2_patterns.FourTierNetwork.selectSubnets.parameter.selection"></a>

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

---

##### `addVpcFlowLog` <a name="addVpcFlowLog" id="cdk-extensions.ec2_patterns.FourTierNetwork.addVpcFlowLog"></a>

```typescript
public addVpcFlowLog(id: string, options?: FlowLogOptions): FlowLog
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.addVpcFlowLog.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetwork.addVpcFlowLog.parameter.options"></a>

- *Type:* cdk-extensions.ec2_patterns.FlowLogOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.fromLookup">fromLookup</a></code> | Import an existing VPC by querying the AWS environment this stack is deployed to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.fromVpcAttributes">fromVpcAttributes</a></code> | Import a VPC by supplying all attributes directly. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2_patterns.FourTierNetwork.isConstruct"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetwork.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2_patterns.FourTierNetwork.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2_patterns.FourTierNetwork.isOwnedResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetwork.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.FourTierNetwork.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2_patterns.FourTierNetwork.isResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetwork.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.FourTierNetwork.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromLookup` <a name="fromLookup" id="cdk-extensions.ec2_patterns.FourTierNetwork.fromLookup"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetwork.fromLookup(scope: Construct, id: string, options: VpcLookupOptions)
```

Import an existing VPC by querying the AWS environment this stack is deployed to.

This function only needs to be used to use VPCs not defined in your CDK
application. If you are looking to share a VPC between stacks, you can
pass the `Vpc` object between stacks and use it as normal.

Calling this method will lead to a lookup when the CDK CLI is executed.
You can therefore not use any values that will only be available at
CloudFormation execution time (i.e., Tokens).

The VPC information will be cached in `cdk.context.json` and the same VPC
will be used on future runs. To refresh the lookup, you will have to
evict the value from the cache using the `cdk context` command. See
https://docs.aws.amazon.com/cdk/latest/guide/context.html for more information.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetwork.fromLookup.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.fromLookup.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetwork.fromLookup.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpcLookupOptions

---

##### `fromVpcAttributes` <a name="fromVpcAttributes" id="cdk-extensions.ec2_patterns.FourTierNetwork.fromVpcAttributes"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetwork.fromVpcAttributes(scope: Construct, id: string, attrs: VpcAttributes)
```

Import a VPC by supplying all attributes directly.

NOTE: using `fromVpcAttributes()` with deploy-time parameters (like a `Fn.importValue()` or
`CfnParameter` to represent a list of subnet IDs) sometimes accidentally works. It happens
to work for constructs that need a list of subnets (like `AutoScalingGroup` and `eks.Cluster`)
but it does not work for constructs that need individual subnets (like
`Instance`). See https://github.com/aws/aws-cdk/issues/4118 for more
information.

Prefer to use `Vpc.fromLookup()` instead.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetwork.fromVpcAttributes.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetwork.fromVpcAttributes.parameter.id"></a>

- *Type:* string

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.ec2_patterns.FourTierNetwork.fromVpcAttributes.parameter.attrs"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpcAttributes

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.availabilityZones">availabilityZones</a></code> | <code>string[]</code> | AZs for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.dnsHostnamesEnabled">dnsHostnamesEnabled</a></code> | <code>boolean</code> | Indicates if instances launched in this VPC will have public DNS hostnames. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.dnsSupportEnabled">dnsSupportEnabled</a></code> | <code>boolean</code> | Indicates if DNS support is enabled for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.internetConnectivityEstablished">internetConnectivityEstablished</a></code> | <code>constructs.IDependable</code> | Dependencies for internet connectivity. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.isolatedSubnets">isolatedSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of isolated subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.privateSubnets">privateSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of private subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.publicSubnets">publicSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of public subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcArn">vpcArn</a></code> | <code>string</code> | Arn of this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcCidrBlock">vpcCidrBlock</a></code> | <code>string</code> | CIDR range for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcCidrBlockAssociations">vpcCidrBlockAssociations</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcDefaultNetworkAcl">vpcDefaultNetworkAcl</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcDefaultSecurityGroup">vpcDefaultSecurityGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcId">vpcId</a></code> | <code>string</code> | Identifier for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcIpv6CidrBlocks">vpcIpv6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.internetGatewayId">internetGatewayId</a></code> | <code>string</code> | Internet Gateway for the VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpnGatewayId">vpnGatewayId</a></code> | <code>string</code> | Returns the id of the VPN Gateway (if enabled). |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.netmask">netmask</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.defaultInstanceTenancy">defaultInstanceTenancy</a></code> | <code>aws-cdk-lib.aws_ec2.DefaultInstanceTenancy</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.enableDnsHostnames">enableDnsHostnames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.enableDnsSupport">enableDnsSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.ipamPool">ipamPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.maxAzs">maxAzs</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcName">vpcName</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `availabilityZones`<sup>Required</sup> <a name="availabilityZones" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* string[]

AZs for this VPC.

---

##### `dnsHostnamesEnabled`<sup>Required</sup> <a name="dnsHostnamesEnabled" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.dnsHostnamesEnabled"></a>

```typescript
public readonly dnsHostnamesEnabled: boolean;
```

- *Type:* boolean

Indicates if instances launched in this VPC will have public DNS hostnames.

---

##### `dnsSupportEnabled`<sup>Required</sup> <a name="dnsSupportEnabled" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.dnsSupportEnabled"></a>

```typescript
public readonly dnsSupportEnabled: boolean;
```

- *Type:* boolean

Indicates if DNS support is enabled for this VPC.

---

##### `internetConnectivityEstablished`<sup>Required</sup> <a name="internetConnectivityEstablished" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.internetConnectivityEstablished"></a>

```typescript
public readonly internetConnectivityEstablished: IDependable;
```

- *Type:* constructs.IDependable

Dependencies for internet connectivity.

---

##### `isolatedSubnets`<sup>Required</sup> <a name="isolatedSubnets" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.isolatedSubnets"></a>

```typescript
public readonly isolatedSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of isolated subnets in this VPC.

---

##### `privateSubnets`<sup>Required</sup> <a name="privateSubnets" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.privateSubnets"></a>

```typescript
public readonly privateSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of private subnets in this VPC.

---

##### `publicSubnets`<sup>Required</sup> <a name="publicSubnets" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.publicSubnets"></a>

```typescript
public readonly publicSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of public subnets in this VPC.

---

##### `vpcArn`<sup>Required</sup> <a name="vpcArn" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcArn"></a>

```typescript
public readonly vpcArn: string;
```

- *Type:* string

Arn of this VPC.

---

##### `vpcCidrBlock`<sup>Required</sup> <a name="vpcCidrBlock" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcCidrBlock"></a>

```typescript
public readonly vpcCidrBlock: string;
```

- *Type:* string

CIDR range for this VPC.

---

##### `vpcCidrBlockAssociations`<sup>Required</sup> <a name="vpcCidrBlockAssociations" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcCidrBlockAssociations"></a>

```typescript
public readonly vpcCidrBlockAssociations: string[];
```

- *Type:* string[]

---

##### `vpcDefaultNetworkAcl`<sup>Required</sup> <a name="vpcDefaultNetworkAcl" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcDefaultNetworkAcl"></a>

```typescript
public readonly vpcDefaultNetworkAcl: string;
```

- *Type:* string

---

##### `vpcDefaultSecurityGroup`<sup>Required</sup> <a name="vpcDefaultSecurityGroup" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcDefaultSecurityGroup"></a>

```typescript
public readonly vpcDefaultSecurityGroup: string;
```

- *Type:* string

---

##### `vpcId`<sup>Required</sup> <a name="vpcId" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* string

Identifier for this VPC.

---

##### `vpcIpv6CidrBlocks`<sup>Required</sup> <a name="vpcIpv6CidrBlocks" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcIpv6CidrBlocks"></a>

```typescript
public readonly vpcIpv6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internetGatewayId`<sup>Optional</sup> <a name="internetGatewayId" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.internetGatewayId"></a>

```typescript
public readonly internetGatewayId: string;
```

- *Type:* string

Internet Gateway for the VPC.

Note that in case the VPC is configured only
with ISOLATED subnets, this attribute will be `undefined`.

---

##### `vpnGatewayId`<sup>Optional</sup> <a name="vpnGatewayId" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpnGatewayId"></a>

```typescript
public readonly vpnGatewayId: string;
```

- *Type:* string

Returns the id of the VPN Gateway (if enabled).

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.netmask"></a>

```typescript
public readonly netmask: number;
```

- *Type:* number

---

##### `defaultInstanceTenancy`<sup>Optional</sup> <a name="defaultInstanceTenancy" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.defaultInstanceTenancy"></a>

```typescript
public readonly defaultInstanceTenancy: DefaultInstanceTenancy;
```

- *Type:* aws-cdk-lib.aws_ec2.DefaultInstanceTenancy

---

##### `enableDnsHostnames`<sup>Optional</sup> <a name="enableDnsHostnames" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.enableDnsHostnames"></a>

```typescript
public readonly enableDnsHostnames: boolean;
```

- *Type:* boolean

---

##### `enableDnsSupport`<sup>Optional</sup> <a name="enableDnsSupport" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.enableDnsSupport"></a>

```typescript
public readonly enableDnsSupport: boolean;
```

- *Type:* boolean

---

##### `ipamPool`<sup>Optional</sup> <a name="ipamPool" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.ipamPool"></a>

```typescript
public readonly ipamPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `maxAzs`<sup>Optional</sup> <a name="maxAzs" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.maxAzs"></a>

```typescript
public readonly maxAzs: number;
```

- *Type:* number

---

##### `vpcName`<sup>Optional</sup> <a name="vpcName" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.DEFAULT_CIDR_RANGE">DEFAULT_CIDR_RANGE</a></code> | <code>string</code> | The default CIDR range used when creating VPCs. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.DEFAULT_SUBNETS">DEFAULT_SUBNETS</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetConfiguration[]</code> | The default subnet configuration. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetwork.property.DEFAULT_SUBNETS_NO_NAT">DEFAULT_SUBNETS_NO_NAT</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetConfiguration[]</code> | The default subnet configuration if natGateways specified to be 0. |

---

##### `DEFAULT_CIDR_RANGE`<sup>Required</sup> <a name="DEFAULT_CIDR_RANGE" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.DEFAULT_CIDR_RANGE"></a>

```typescript
public readonly DEFAULT_CIDR_RANGE: string;
```

- *Type:* string

The default CIDR range used when creating VPCs.

This can be overridden using VpcProps when creating a VPCNetwork resource.
e.g. new VpcResource(this, { cidr: '192.168.0.0./16' })

---

##### `DEFAULT_SUBNETS`<sup>Required</sup> <a name="DEFAULT_SUBNETS" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.DEFAULT_SUBNETS"></a>

```typescript
public readonly DEFAULT_SUBNETS: SubnetConfiguration[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetConfiguration[]

The default subnet configuration.

1 Public and 1 Private subnet per AZ evenly split

---

##### `DEFAULT_SUBNETS_NO_NAT`<sup>Required</sup> <a name="DEFAULT_SUBNETS_NO_NAT" id="cdk-extensions.ec2_patterns.FourTierNetwork.property.DEFAULT_SUBNETS_NO_NAT"></a>

```typescript
public readonly DEFAULT_SUBNETS_NO_NAT: SubnetConfiguration[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetConfiguration[]

The default subnet configuration if natGateways specified to be 0.

1 Public and 1 Isolated Subnet per AZ evenly split

---

### FourTierNetworkHub <a name="FourTierNetworkHub" id="cdk-extensions.ec2_patterns.FourTierNetworkHub"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

new ec2_patterns.FourTierNetworkHub(scope: IConstruct, id: string, props?: FourTierNetworkHubProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2_patterns.FourTierNetworkHubProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2_patterns.FourTierNetworkHubProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.addClientVpnEndpoint">addClientVpnEndpoint</a></code> | Adds a new client VPN endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.addFlowLog">addFlowLog</a></code> | Adds a new flow log to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.addGatewayEndpoint">addGatewayEndpoint</a></code> | Adds a new gateway endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.addInterfaceEndpoint">addInterfaceEndpoint</a></code> | Adds a new interface endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.addVpnConnection">addVpnConnection</a></code> | Adds a new VPN connection to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.enableVpnGateway">enableVpnGateway</a></code> | Adds a VPN Gateway to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.selectSubnets">selectSubnets</a></code> | Returns IDs of selected subnets. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.addVpcFlowLog">addVpcFlowLog</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.addSpoke">addSpoke</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.enableTransitGateway">enableTransitGateway</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addClientVpnEndpoint` <a name="addClientVpnEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addClientVpnEndpoint"></a>

```typescript
public addClientVpnEndpoint(id: string, options: ClientVpnEndpointOptions): ClientVpnEndpoint
```

Adds a new client VPN endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addClientVpnEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addClientVpnEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.ClientVpnEndpointOptions

---

##### `addFlowLog` <a name="addFlowLog" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addFlowLog"></a>

```typescript
public addFlowLog(id: string, options?: FlowLogOptions): FlowLog
```

Adds a new flow log to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addFlowLog.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addFlowLog.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.FlowLogOptions

---

##### `addGatewayEndpoint` <a name="addGatewayEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addGatewayEndpoint"></a>

```typescript
public addGatewayEndpoint(id: string, options: GatewayVpcEndpointOptions): GatewayVpcEndpoint
```

Adds a new gateway endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addGatewayEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addGatewayEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions

---

##### `addInterfaceEndpoint` <a name="addInterfaceEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addInterfaceEndpoint"></a>

```typescript
public addInterfaceEndpoint(id: string, options: InterfaceVpcEndpointOptions): InterfaceVpcEndpoint
```

Adds a new interface endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addInterfaceEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addInterfaceEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.InterfaceVpcEndpointOptions

---

##### `addVpnConnection` <a name="addVpnConnection" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addVpnConnection"></a>

```typescript
public addVpnConnection(id: string, options: VpnConnectionOptions): VpnConnection
```

Adds a new VPN connection to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addVpnConnection.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addVpnConnection.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpnConnectionOptions

---

##### `enableVpnGateway` <a name="enableVpnGateway" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.enableVpnGateway"></a>

```typescript
public enableVpnGateway(options: EnableVpnGatewayOptions): void
```

Adds a VPN Gateway to this VPC.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.enableVpnGateway.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.EnableVpnGatewayOptions

---

##### `selectSubnets` <a name="selectSubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.selectSubnets"></a>

```typescript
public selectSubnets(selection?: SubnetSelection): SelectedSubnets
```

Returns IDs of selected subnets.

###### `selection`<sup>Optional</sup> <a name="selection" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.selectSubnets.parameter.selection"></a>

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

---

##### `addVpcFlowLog` <a name="addVpcFlowLog" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addVpcFlowLog"></a>

```typescript
public addVpcFlowLog(id: string, options?: FlowLogOptions): FlowLog
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addVpcFlowLog.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addVpcFlowLog.parameter.options"></a>

- *Type:* cdk-extensions.ec2_patterns.FlowLogOptions

---

##### `addSpoke` <a name="addSpoke" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addSpoke"></a>

```typescript
public addSpoke(scope: IConstruct, id: string, props?: AddSpokeNetworkProps): FourTierNetworkSpoke
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addSpoke.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addSpoke.parameter.id"></a>

- *Type:* string

---

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.addSpoke.parameter.props"></a>

- *Type:* cdk-extensions.ec2_patterns.AddSpokeNetworkProps

---

##### `enableTransitGateway` <a name="enableTransitGateway" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.enableTransitGateway"></a>

```typescript
public enableTransitGateway(props?: TransitGatewayProps): ITransitGateway
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.enableTransitGateway.parameter.props"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayProps

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.fromLookup">fromLookup</a></code> | Import an existing VPC by querying the AWS environment this stack is deployed to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.fromVpcAttributes">fromVpcAttributes</a></code> | Import a VPC by supplying all attributes directly. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.isConstruct"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkHub.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.isOwnedResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkHub.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.isResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkHub.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromLookup` <a name="fromLookup" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.fromLookup"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkHub.fromLookup(scope: Construct, id: string, options: VpcLookupOptions)
```

Import an existing VPC by querying the AWS environment this stack is deployed to.

This function only needs to be used to use VPCs not defined in your CDK
application. If you are looking to share a VPC between stacks, you can
pass the `Vpc` object between stacks and use it as normal.

Calling this method will lead to a lookup when the CDK CLI is executed.
You can therefore not use any values that will only be available at
CloudFormation execution time (i.e., Tokens).

The VPC information will be cached in `cdk.context.json` and the same VPC
will be used on future runs. To refresh the lookup, you will have to
evict the value from the cache using the `cdk context` command. See
https://docs.aws.amazon.com/cdk/latest/guide/context.html for more information.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.fromLookup.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.fromLookup.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.fromLookup.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpcLookupOptions

---

##### `fromVpcAttributes` <a name="fromVpcAttributes" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.fromVpcAttributes"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkHub.fromVpcAttributes(scope: Construct, id: string, attrs: VpcAttributes)
```

Import a VPC by supplying all attributes directly.

NOTE: using `fromVpcAttributes()` with deploy-time parameters (like a `Fn.importValue()` or
`CfnParameter` to represent a list of subnet IDs) sometimes accidentally works. It happens
to work for constructs that need a list of subnets (like `AutoScalingGroup` and `eks.Cluster`)
but it does not work for constructs that need individual subnets (like
`Instance`). See https://github.com/aws/aws-cdk/issues/4118 for more
information.

Prefer to use `Vpc.fromLookup()` instead.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.fromVpcAttributes.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.fromVpcAttributes.parameter.id"></a>

- *Type:* string

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.fromVpcAttributes.parameter.attrs"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpcAttributes

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.availabilityZones">availabilityZones</a></code> | <code>string[]</code> | AZs for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.dnsHostnamesEnabled">dnsHostnamesEnabled</a></code> | <code>boolean</code> | Indicates if instances launched in this VPC will have public DNS hostnames. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.dnsSupportEnabled">dnsSupportEnabled</a></code> | <code>boolean</code> | Indicates if DNS support is enabled for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.internetConnectivityEstablished">internetConnectivityEstablished</a></code> | <code>constructs.IDependable</code> | Dependencies for internet connectivity. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.isolatedSubnets">isolatedSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of isolated subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.privateSubnets">privateSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of private subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.publicSubnets">publicSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of public subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcArn">vpcArn</a></code> | <code>string</code> | Arn of this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcCidrBlock">vpcCidrBlock</a></code> | <code>string</code> | CIDR range for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcCidrBlockAssociations">vpcCidrBlockAssociations</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcDefaultNetworkAcl">vpcDefaultNetworkAcl</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcDefaultSecurityGroup">vpcDefaultSecurityGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcId">vpcId</a></code> | <code>string</code> | Identifier for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcIpv6CidrBlocks">vpcIpv6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.internetGatewayId">internetGatewayId</a></code> | <code>string</code> | Internet Gateway for the VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpnGatewayId">vpnGatewayId</a></code> | <code>string</code> | Returns the id of the VPN Gateway (if enabled). |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.netmask">netmask</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.defaultInstanceTenancy">defaultInstanceTenancy</a></code> | <code>aws-cdk-lib.aws_ec2.DefaultInstanceTenancy</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.enableDnsHostnames">enableDnsHostnames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.enableDnsSupport">enableDnsSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.ipamPool">ipamPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.maxAzs">maxAzs</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcName">vpcName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.sharing">sharing</a></code> | <code>cdk-extensions.ec2_patterns.FourTierNetworkShareProperties</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.globalNetwork">globalNetwork</a></code> | <code>cdk-extensions.networkmanager.GlobalNetwork</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `availabilityZones`<sup>Required</sup> <a name="availabilityZones" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* string[]

AZs for this VPC.

---

##### `dnsHostnamesEnabled`<sup>Required</sup> <a name="dnsHostnamesEnabled" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.dnsHostnamesEnabled"></a>

```typescript
public readonly dnsHostnamesEnabled: boolean;
```

- *Type:* boolean

Indicates if instances launched in this VPC will have public DNS hostnames.

---

##### `dnsSupportEnabled`<sup>Required</sup> <a name="dnsSupportEnabled" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.dnsSupportEnabled"></a>

```typescript
public readonly dnsSupportEnabled: boolean;
```

- *Type:* boolean

Indicates if DNS support is enabled for this VPC.

---

##### `internetConnectivityEstablished`<sup>Required</sup> <a name="internetConnectivityEstablished" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.internetConnectivityEstablished"></a>

```typescript
public readonly internetConnectivityEstablished: IDependable;
```

- *Type:* constructs.IDependable

Dependencies for internet connectivity.

---

##### `isolatedSubnets`<sup>Required</sup> <a name="isolatedSubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.isolatedSubnets"></a>

```typescript
public readonly isolatedSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of isolated subnets in this VPC.

---

##### `privateSubnets`<sup>Required</sup> <a name="privateSubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.privateSubnets"></a>

```typescript
public readonly privateSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of private subnets in this VPC.

---

##### `publicSubnets`<sup>Required</sup> <a name="publicSubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.publicSubnets"></a>

```typescript
public readonly publicSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of public subnets in this VPC.

---

##### `vpcArn`<sup>Required</sup> <a name="vpcArn" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcArn"></a>

```typescript
public readonly vpcArn: string;
```

- *Type:* string

Arn of this VPC.

---

##### `vpcCidrBlock`<sup>Required</sup> <a name="vpcCidrBlock" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcCidrBlock"></a>

```typescript
public readonly vpcCidrBlock: string;
```

- *Type:* string

CIDR range for this VPC.

---

##### `vpcCidrBlockAssociations`<sup>Required</sup> <a name="vpcCidrBlockAssociations" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcCidrBlockAssociations"></a>

```typescript
public readonly vpcCidrBlockAssociations: string[];
```

- *Type:* string[]

---

##### `vpcDefaultNetworkAcl`<sup>Required</sup> <a name="vpcDefaultNetworkAcl" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcDefaultNetworkAcl"></a>

```typescript
public readonly vpcDefaultNetworkAcl: string;
```

- *Type:* string

---

##### `vpcDefaultSecurityGroup`<sup>Required</sup> <a name="vpcDefaultSecurityGroup" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcDefaultSecurityGroup"></a>

```typescript
public readonly vpcDefaultSecurityGroup: string;
```

- *Type:* string

---

##### `vpcId`<sup>Required</sup> <a name="vpcId" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* string

Identifier for this VPC.

---

##### `vpcIpv6CidrBlocks`<sup>Required</sup> <a name="vpcIpv6CidrBlocks" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcIpv6CidrBlocks"></a>

```typescript
public readonly vpcIpv6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internetGatewayId`<sup>Optional</sup> <a name="internetGatewayId" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.internetGatewayId"></a>

```typescript
public readonly internetGatewayId: string;
```

- *Type:* string

Internet Gateway for the VPC.

Note that in case the VPC is configured only
with ISOLATED subnets, this attribute will be `undefined`.

---

##### `vpnGatewayId`<sup>Optional</sup> <a name="vpnGatewayId" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpnGatewayId"></a>

```typescript
public readonly vpnGatewayId: string;
```

- *Type:* string

Returns the id of the VPN Gateway (if enabled).

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.netmask"></a>

```typescript
public readonly netmask: number;
```

- *Type:* number

---

##### `defaultInstanceTenancy`<sup>Optional</sup> <a name="defaultInstanceTenancy" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.defaultInstanceTenancy"></a>

```typescript
public readonly defaultInstanceTenancy: DefaultInstanceTenancy;
```

- *Type:* aws-cdk-lib.aws_ec2.DefaultInstanceTenancy

---

##### `enableDnsHostnames`<sup>Optional</sup> <a name="enableDnsHostnames" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.enableDnsHostnames"></a>

```typescript
public readonly enableDnsHostnames: boolean;
```

- *Type:* boolean

---

##### `enableDnsSupport`<sup>Optional</sup> <a name="enableDnsSupport" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.enableDnsSupport"></a>

```typescript
public readonly enableDnsSupport: boolean;
```

- *Type:* boolean

---

##### `ipamPool`<sup>Optional</sup> <a name="ipamPool" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.ipamPool"></a>

```typescript
public readonly ipamPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `maxAzs`<sup>Optional</sup> <a name="maxAzs" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.maxAzs"></a>

```typescript
public readonly maxAzs: number;
```

- *Type:* number

---

##### `vpcName`<sup>Optional</sup> <a name="vpcName" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* string

---

##### `sharing`<sup>Required</sup> <a name="sharing" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.sharing"></a>

```typescript
public readonly sharing: FourTierNetworkShareProperties;
```

- *Type:* cdk-extensions.ec2_patterns.FourTierNetworkShareProperties

---

##### `globalNetwork`<sup>Optional</sup> <a name="globalNetwork" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.globalNetwork"></a>

```typescript
public readonly globalNetwork: GlobalNetwork;
```

- *Type:* cdk-extensions.networkmanager.GlobalNetwork

---

##### `transitGateway`<sup>Optional</sup> <a name="transitGateway" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.DEFAULT_CIDR_RANGE">DEFAULT_CIDR_RANGE</a></code> | <code>string</code> | The default CIDR range used when creating VPCs. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.DEFAULT_SUBNETS">DEFAULT_SUBNETS</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetConfiguration[]</code> | The default subnet configuration. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHub.property.DEFAULT_SUBNETS_NO_NAT">DEFAULT_SUBNETS_NO_NAT</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetConfiguration[]</code> | The default subnet configuration if natGateways specified to be 0. |

---

##### `DEFAULT_CIDR_RANGE`<sup>Required</sup> <a name="DEFAULT_CIDR_RANGE" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.DEFAULT_CIDR_RANGE"></a>

```typescript
public readonly DEFAULT_CIDR_RANGE: string;
```

- *Type:* string

The default CIDR range used when creating VPCs.

This can be overridden using VpcProps when creating a VPCNetwork resource.
e.g. new VpcResource(this, { cidr: '192.168.0.0./16' })

---

##### `DEFAULT_SUBNETS`<sup>Required</sup> <a name="DEFAULT_SUBNETS" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.DEFAULT_SUBNETS"></a>

```typescript
public readonly DEFAULT_SUBNETS: SubnetConfiguration[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetConfiguration[]

The default subnet configuration.

1 Public and 1 Private subnet per AZ evenly split

---

##### `DEFAULT_SUBNETS_NO_NAT`<sup>Required</sup> <a name="DEFAULT_SUBNETS_NO_NAT" id="cdk-extensions.ec2_patterns.FourTierNetworkHub.property.DEFAULT_SUBNETS_NO_NAT"></a>

```typescript
public readonly DEFAULT_SUBNETS_NO_NAT: SubnetConfiguration[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetConfiguration[]

The default subnet configuration if natGateways specified to be 0.

1 Public and 1 Isolated Subnet per AZ evenly split

---

### FourTierNetworkSpoke <a name="FourTierNetworkSpoke" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

new ec2_patterns.FourTierNetworkSpoke(scope: IConstruct, id: string, props: FourTierNetworkSpokeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addClientVpnEndpoint">addClientVpnEndpoint</a></code> | Adds a new client VPN endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addFlowLog">addFlowLog</a></code> | Adds a new flow log to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addGatewayEndpoint">addGatewayEndpoint</a></code> | Adds a new gateway endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addInterfaceEndpoint">addInterfaceEndpoint</a></code> | Adds a new interface endpoint to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addVpnConnection">addVpnConnection</a></code> | Adds a new VPN connection to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.enableVpnGateway">enableVpnGateway</a></code> | Adds a VPN Gateway to this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.selectSubnets">selectSubnets</a></code> | Returns IDs of selected subnets. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addVpcFlowLog">addVpcFlowLog</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addClientVpnEndpoint` <a name="addClientVpnEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addClientVpnEndpoint"></a>

```typescript
public addClientVpnEndpoint(id: string, options: ClientVpnEndpointOptions): ClientVpnEndpoint
```

Adds a new client VPN endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addClientVpnEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addClientVpnEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.ClientVpnEndpointOptions

---

##### `addFlowLog` <a name="addFlowLog" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addFlowLog"></a>

```typescript
public addFlowLog(id: string, options?: FlowLogOptions): FlowLog
```

Adds a new flow log to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addFlowLog.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addFlowLog.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.FlowLogOptions

---

##### `addGatewayEndpoint` <a name="addGatewayEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addGatewayEndpoint"></a>

```typescript
public addGatewayEndpoint(id: string, options: GatewayVpcEndpointOptions): GatewayVpcEndpoint
```

Adds a new gateway endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addGatewayEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addGatewayEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions

---

##### `addInterfaceEndpoint` <a name="addInterfaceEndpoint" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addInterfaceEndpoint"></a>

```typescript
public addInterfaceEndpoint(id: string, options: InterfaceVpcEndpointOptions): InterfaceVpcEndpoint
```

Adds a new interface endpoint to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addInterfaceEndpoint.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addInterfaceEndpoint.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.InterfaceVpcEndpointOptions

---

##### `addVpnConnection` <a name="addVpnConnection" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addVpnConnection"></a>

```typescript
public addVpnConnection(id: string, options: VpnConnectionOptions): VpnConnection
```

Adds a new VPN connection to this VPC.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addVpnConnection.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addVpnConnection.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpnConnectionOptions

---

##### `enableVpnGateway` <a name="enableVpnGateway" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.enableVpnGateway"></a>

```typescript
public enableVpnGateway(options: EnableVpnGatewayOptions): void
```

Adds a VPN Gateway to this VPC.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.enableVpnGateway.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.EnableVpnGatewayOptions

---

##### `selectSubnets` <a name="selectSubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.selectSubnets"></a>

```typescript
public selectSubnets(selection?: SubnetSelection): SelectedSubnets
```

Returns IDs of selected subnets.

###### `selection`<sup>Optional</sup> <a name="selection" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.selectSubnets.parameter.selection"></a>

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

---

##### `addVpcFlowLog` <a name="addVpcFlowLog" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addVpcFlowLog"></a>

```typescript
public addVpcFlowLog(id: string, options?: FlowLogOptions): FlowLog
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addVpcFlowLog.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.addVpcFlowLog.parameter.options"></a>

- *Type:* cdk-extensions.ec2_patterns.FlowLogOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromLookup">fromLookup</a></code> | Import an existing VPC by querying the AWS environment this stack is deployed to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromVpcAttributes">fromVpcAttributes</a></code> | Import a VPC by supplying all attributes directly. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isConstruct"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkSpoke.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isOwnedResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkSpoke.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkSpoke.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromLookup` <a name="fromLookup" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromLookup"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkSpoke.fromLookup(scope: Construct, id: string, options: VpcLookupOptions)
```

Import an existing VPC by querying the AWS environment this stack is deployed to.

This function only needs to be used to use VPCs not defined in your CDK
application. If you are looking to share a VPC between stacks, you can
pass the `Vpc` object between stacks and use it as normal.

Calling this method will lead to a lookup when the CDK CLI is executed.
You can therefore not use any values that will only be available at
CloudFormation execution time (i.e., Tokens).

The VPC information will be cached in `cdk.context.json` and the same VPC
will be used on future runs. To refresh the lookup, you will have to
evict the value from the cache using the `cdk context` command. See
https://docs.aws.amazon.com/cdk/latest/guide/context.html for more information.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromLookup.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromLookup.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromLookup.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpcLookupOptions

---

##### `fromVpcAttributes` <a name="fromVpcAttributes" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromVpcAttributes"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.FourTierNetworkSpoke.fromVpcAttributes(scope: Construct, id: string, attrs: VpcAttributes)
```

Import a VPC by supplying all attributes directly.

NOTE: using `fromVpcAttributes()` with deploy-time parameters (like a `Fn.importValue()` or
`CfnParameter` to represent a list of subnet IDs) sometimes accidentally works. It happens
to work for constructs that need a list of subnets (like `AutoScalingGroup` and `eks.Cluster`)
but it does not work for constructs that need individual subnets (like
`Instance`). See https://github.com/aws/aws-cdk/issues/4118 for more
information.

Prefer to use `Vpc.fromLookup()` instead.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromVpcAttributes.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromVpcAttributes.parameter.id"></a>

- *Type:* string

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.fromVpcAttributes.parameter.attrs"></a>

- *Type:* aws-cdk-lib.aws_ec2.VpcAttributes

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.availabilityZones">availabilityZones</a></code> | <code>string[]</code> | AZs for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.dnsHostnamesEnabled">dnsHostnamesEnabled</a></code> | <code>boolean</code> | Indicates if instances launched in this VPC will have public DNS hostnames. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.dnsSupportEnabled">dnsSupportEnabled</a></code> | <code>boolean</code> | Indicates if DNS support is enabled for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.internetConnectivityEstablished">internetConnectivityEstablished</a></code> | <code>constructs.IDependable</code> | Dependencies for internet connectivity. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.isolatedSubnets">isolatedSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of isolated subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.privateSubnets">privateSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of private subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.publicSubnets">publicSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.ISubnet[]</code> | List of public subnets in this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcArn">vpcArn</a></code> | <code>string</code> | Arn of this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcCidrBlock">vpcCidrBlock</a></code> | <code>string</code> | CIDR range for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcCidrBlockAssociations">vpcCidrBlockAssociations</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcDefaultNetworkAcl">vpcDefaultNetworkAcl</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcDefaultSecurityGroup">vpcDefaultSecurityGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcId">vpcId</a></code> | <code>string</code> | Identifier for this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcIpv6CidrBlocks">vpcIpv6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.internetGatewayId">internetGatewayId</a></code> | <code>string</code> | Internet Gateway for the VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpnGatewayId">vpnGatewayId</a></code> | <code>string</code> | Returns the id of the VPN Gateway (if enabled). |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.netmask">netmask</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.defaultInstanceTenancy">defaultInstanceTenancy</a></code> | <code>aws-cdk-lib.aws_ec2.DefaultInstanceTenancy</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.enableDnsHostnames">enableDnsHostnames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.enableDnsSupport">enableDnsSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.ipamPool">ipamPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.maxAzs">maxAzs</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcName">vpcName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.transitGatewayAttachment">transitGatewayAttachment</a></code> | <code>cdk-extensions.ec2.ITransitGatewayAttachment</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `availabilityZones`<sup>Required</sup> <a name="availabilityZones" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* string[]

AZs for this VPC.

---

##### `dnsHostnamesEnabled`<sup>Required</sup> <a name="dnsHostnamesEnabled" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.dnsHostnamesEnabled"></a>

```typescript
public readonly dnsHostnamesEnabled: boolean;
```

- *Type:* boolean

Indicates if instances launched in this VPC will have public DNS hostnames.

---

##### `dnsSupportEnabled`<sup>Required</sup> <a name="dnsSupportEnabled" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.dnsSupportEnabled"></a>

```typescript
public readonly dnsSupportEnabled: boolean;
```

- *Type:* boolean

Indicates if DNS support is enabled for this VPC.

---

##### `internetConnectivityEstablished`<sup>Required</sup> <a name="internetConnectivityEstablished" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.internetConnectivityEstablished"></a>

```typescript
public readonly internetConnectivityEstablished: IDependable;
```

- *Type:* constructs.IDependable

Dependencies for internet connectivity.

---

##### `isolatedSubnets`<sup>Required</sup> <a name="isolatedSubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.isolatedSubnets"></a>

```typescript
public readonly isolatedSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of isolated subnets in this VPC.

---

##### `privateSubnets`<sup>Required</sup> <a name="privateSubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.privateSubnets"></a>

```typescript
public readonly privateSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of private subnets in this VPC.

---

##### `publicSubnets`<sup>Required</sup> <a name="publicSubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.publicSubnets"></a>

```typescript
public readonly publicSubnets: ISubnet[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISubnet[]

List of public subnets in this VPC.

---

##### `vpcArn`<sup>Required</sup> <a name="vpcArn" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcArn"></a>

```typescript
public readonly vpcArn: string;
```

- *Type:* string

Arn of this VPC.

---

##### `vpcCidrBlock`<sup>Required</sup> <a name="vpcCidrBlock" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcCidrBlock"></a>

```typescript
public readonly vpcCidrBlock: string;
```

- *Type:* string

CIDR range for this VPC.

---

##### `vpcCidrBlockAssociations`<sup>Required</sup> <a name="vpcCidrBlockAssociations" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcCidrBlockAssociations"></a>

```typescript
public readonly vpcCidrBlockAssociations: string[];
```

- *Type:* string[]

---

##### `vpcDefaultNetworkAcl`<sup>Required</sup> <a name="vpcDefaultNetworkAcl" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcDefaultNetworkAcl"></a>

```typescript
public readonly vpcDefaultNetworkAcl: string;
```

- *Type:* string

---

##### `vpcDefaultSecurityGroup`<sup>Required</sup> <a name="vpcDefaultSecurityGroup" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcDefaultSecurityGroup"></a>

```typescript
public readonly vpcDefaultSecurityGroup: string;
```

- *Type:* string

---

##### `vpcId`<sup>Required</sup> <a name="vpcId" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcId"></a>

```typescript
public readonly vpcId: string;
```

- *Type:* string

Identifier for this VPC.

---

##### `vpcIpv6CidrBlocks`<sup>Required</sup> <a name="vpcIpv6CidrBlocks" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcIpv6CidrBlocks"></a>

```typescript
public readonly vpcIpv6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internetGatewayId`<sup>Optional</sup> <a name="internetGatewayId" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.internetGatewayId"></a>

```typescript
public readonly internetGatewayId: string;
```

- *Type:* string

Internet Gateway for the VPC.

Note that in case the VPC is configured only
with ISOLATED subnets, this attribute will be `undefined`.

---

##### `vpnGatewayId`<sup>Optional</sup> <a name="vpnGatewayId" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpnGatewayId"></a>

```typescript
public readonly vpnGatewayId: string;
```

- *Type:* string

Returns the id of the VPN Gateway (if enabled).

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.netmask"></a>

```typescript
public readonly netmask: number;
```

- *Type:* number

---

##### `defaultInstanceTenancy`<sup>Optional</sup> <a name="defaultInstanceTenancy" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.defaultInstanceTenancy"></a>

```typescript
public readonly defaultInstanceTenancy: DefaultInstanceTenancy;
```

- *Type:* aws-cdk-lib.aws_ec2.DefaultInstanceTenancy

---

##### `enableDnsHostnames`<sup>Optional</sup> <a name="enableDnsHostnames" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.enableDnsHostnames"></a>

```typescript
public readonly enableDnsHostnames: boolean;
```

- *Type:* boolean

---

##### `enableDnsSupport`<sup>Optional</sup> <a name="enableDnsSupport" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.enableDnsSupport"></a>

```typescript
public readonly enableDnsSupport: boolean;
```

- *Type:* boolean

---

##### `ipamPool`<sup>Optional</sup> <a name="ipamPool" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.ipamPool"></a>

```typescript
public readonly ipamPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `maxAzs`<sup>Optional</sup> <a name="maxAzs" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.maxAzs"></a>

```typescript
public readonly maxAzs: number;
```

- *Type:* number

---

##### `vpcName`<sup>Optional</sup> <a name="vpcName" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* string

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

---

##### `transitGatewayAttachment`<sup>Required</sup> <a name="transitGatewayAttachment" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.transitGatewayAttachment"></a>

```typescript
public readonly transitGatewayAttachment: ITransitGatewayAttachment;
```

- *Type:* cdk-extensions.ec2.ITransitGatewayAttachment

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.DEFAULT_CIDR_RANGE">DEFAULT_CIDR_RANGE</a></code> | <code>string</code> | The default CIDR range used when creating VPCs. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.DEFAULT_SUBNETS">DEFAULT_SUBNETS</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetConfiguration[]</code> | The default subnet configuration. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.DEFAULT_SUBNETS_NO_NAT">DEFAULT_SUBNETS_NO_NAT</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetConfiguration[]</code> | The default subnet configuration if natGateways specified to be 0. |

---

##### `DEFAULT_CIDR_RANGE`<sup>Required</sup> <a name="DEFAULT_CIDR_RANGE" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.DEFAULT_CIDR_RANGE"></a>

```typescript
public readonly DEFAULT_CIDR_RANGE: string;
```

- *Type:* string

The default CIDR range used when creating VPCs.

This can be overridden using VpcProps when creating a VPCNetwork resource.
e.g. new VpcResource(this, { cidr: '192.168.0.0./16' })

---

##### `DEFAULT_SUBNETS`<sup>Required</sup> <a name="DEFAULT_SUBNETS" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.DEFAULT_SUBNETS"></a>

```typescript
public readonly DEFAULT_SUBNETS: SubnetConfiguration[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetConfiguration[]

The default subnet configuration.

1 Public and 1 Private subnet per AZ evenly split

---

##### `DEFAULT_SUBNETS_NO_NAT`<sup>Required</sup> <a name="DEFAULT_SUBNETS_NO_NAT" id="cdk-extensions.ec2_patterns.FourTierNetworkSpoke.property.DEFAULT_SUBNETS_NO_NAT"></a>

```typescript
public readonly DEFAULT_SUBNETS_NO_NAT: SubnetConfiguration[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetConfiguration[]

The default subnet configuration if natGateways specified to be 0.

1 Public and 1 Isolated Subnet per AZ evenly split

---

### GlobalNetwork <a name="GlobalNetwork" id="cdk-extensions.networkmanager.GlobalNetwork"></a>

- *Implements:* cdk-extensions.networkmanager.IGlobalNetwork

#### Initializers <a name="Initializers" id="cdk-extensions.networkmanager.GlobalNetwork.Initializer"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

new networkmanager.GlobalNetwork(scope: IConstruct, id: string, props?: GlobalNetworkProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.networkmanager.GlobalNetworkProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.networkmanager.GlobalNetwork.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.networkmanager.GlobalNetwork.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.networkmanager.GlobalNetwork.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.networkmanager.GlobalNetworkProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.registerTransitGateway">registerTransitGateway</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.networkmanager.GlobalNetwork.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.networkmanager.GlobalNetwork.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.networkmanager.GlobalNetwork.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `registerTransitGateway` <a name="registerTransitGateway" id="cdk-extensions.networkmanager.GlobalNetwork.registerTransitGateway"></a>

```typescript
public registerTransitGateway(id: string, options: RegisterTransitGatewayProps): ITransitGatewayRegistration
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.networkmanager.GlobalNetwork.registerTransitGateway.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.networkmanager.GlobalNetwork.registerTransitGateway.parameter.options"></a>

- *Type:* cdk-extensions.networkmanager.RegisterTransitGatewayProps

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.networkmanager.GlobalNetwork.isConstruct"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.GlobalNetwork.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.networkmanager.GlobalNetwork.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.networkmanager.GlobalNetwork.isOwnedResource"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.GlobalNetwork.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.networkmanager.GlobalNetwork.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.networkmanager.GlobalNetwork.isResource"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.GlobalNetwork.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.networkmanager.GlobalNetwork.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.property.globalNetworkArn">globalNetworkArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.property.globalNetworkId">globalNetworkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetwork.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_networkmanager.CfnGlobalNetwork</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.networkmanager.GlobalNetwork.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.networkmanager.GlobalNetwork.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.networkmanager.GlobalNetwork.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `globalNetworkArn`<sup>Required</sup> <a name="globalNetworkArn" id="cdk-extensions.networkmanager.GlobalNetwork.property.globalNetworkArn"></a>

```typescript
public readonly globalNetworkArn: string;
```

- *Type:* string

---

##### `globalNetworkId`<sup>Required</sup> <a name="globalNetworkId" id="cdk-extensions.networkmanager.GlobalNetwork.property.globalNetworkId"></a>

```typescript
public readonly globalNetworkId: string;
```

- *Type:* string

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.networkmanager.GlobalNetwork.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk-extensions.networkmanager.GlobalNetwork.property.resource"></a>

```typescript
public readonly resource: CfnGlobalNetwork;
```

- *Type:* aws-cdk-lib.aws_networkmanager.CfnGlobalNetwork

---


### GroupBase <a name="GroupBase" id="cdk-extensions.sso.GroupBase"></a>

- *Implements:* cdk-extensions.sso.IGroup, cdk-extensions.sso.IIdentityCenterPrincipal

#### Initializers <a name="Initializers" id="cdk-extensions.sso.GroupBase.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.GroupBase(scope: IConstruct, id: string, props?: ResourceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.GroupBase.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.sso.GroupBase.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.sso.GroupBase.Initializer.parameter.props">props</a></code> | <code>aws-cdk-lib.ResourceProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.GroupBase.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.GroupBase.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.sso.GroupBase.Initializer.parameter.props"></a>

- *Type:* aws-cdk-lib.ResourceProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.GroupBase.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.sso.GroupBase.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.sso.GroupBase.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.sso.GroupBase.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.GroupBase.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.GroupBase.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.sso.GroupBase.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.sso.GroupBase.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.sso.GroupBase.isConstruct"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.GroupBase.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.sso.GroupBase.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.sso.GroupBase.isOwnedResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.GroupBase.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.GroupBase.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.sso.GroupBase.isResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.GroupBase.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.GroupBase.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.GroupBase.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.sso.GroupBase.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.sso.GroupBase.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.sso.GroupBase.property.groupId">groupId</a></code> | <code>string</code> | A GUID identifier for a group object in IAM Identity Center are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). |
| <code><a href="#cdk-extensions.sso.GroupBase.property.principalId">principalId</a></code> | <code>string</code> | The unique ID that identifies the entity withing IAM Identity Center. |
| <code><a href="#cdk-extensions.sso.GroupBase.property.principalType">principalType</a></code> | <code>cdk-extensions.sso.IdentityCenterPrincipalType</code> | The type of entity being represented. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.sso.GroupBase.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.sso.GroupBase.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.sso.GroupBase.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="cdk-extensions.sso.GroupBase.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

A GUID identifier for a group object in IAM Identity Center are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6).

---

##### `principalId`<sup>Required</sup> <a name="principalId" id="cdk-extensions.sso.GroupBase.property.principalId"></a>

```typescript
public readonly principalId: string;
```

- *Type:* string

The unique ID that identifies the entity withing IAM Identity Center.

---

##### `principalType`<sup>Required</sup> <a name="principalType" id="cdk-extensions.sso.GroupBase.property.principalType"></a>

```typescript
public readonly principalType: IdentityCenterPrincipalType;
```

- *Type:* cdk-extensions.sso.IdentityCenterPrincipalType

The type of entity being represented.

---


### InstanceAccessControlAttributeConfiguration <a name="InstanceAccessControlAttributeConfiguration" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration"></a>

Enables the attribute-based access control (ABAC) feature for the specified IAM Identity Center instance.

You can also specify new attributes to add to
your ABAC configuration during the enabling process. For more information
about ABAC, see [Attribute-Based Access Control](https://docs.aws.amazon.com/singlesignon/latest/userguide/abac.html) in the IAM Identity Center
User Guide.

#### Initializers <a name="Initializers" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.InstanceAccessControlAttributeConfiguration(scope: Construct, id: string, props: InstanceAccessControlAttributeConfigurationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.addAttribute">addAttribute</a></code> | Adds a new ABAC attribute in the specified IAM Identity Center instance. |

---

##### `toString` <a name="toString" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addAttribute` <a name="addAttribute" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.addAttribute"></a>

```typescript
public addAttribute(key: string, sources: string): AccessControlAttribute
```

Adds a new ABAC attribute in the specified IAM Identity Center instance.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.addAttribute.parameter.key"></a>

- *Type:* string

The name of the attribute associated with your identities in your identity source.

This is used to map a specified attribute in your
identity source with an attribute in IAM Identity Center.

---

###### `sources`<sup>Required</sup> <a name="sources" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.addAttribute.parameter.sources"></a>

- *Type:* string

The identity sources to use when mapping a specified attribute to IAM Identity Center.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isConstruct"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.InstanceAccessControlAttributeConfiguration.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isOwnedResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.InstanceAccessControlAttributeConfiguration.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.InstanceAccessControlAttributeConfiguration.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.attributes">attributes</a></code> | <code>cdk-extensions.sso.AccessControlAttribute[]</code> | Lists the attributes that are configured for ABAC in the specified IAM Identity Center instance. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.instance">instance</a></code> | <code>cdk-extensions.sso.IInstance</code> | The ARN of the IAM Identity Center {@link aws-sso.IInstance \| instance } under which the operation will be executed. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_sso.CfnInstanceAccessControlAttributeConfiguration</code> | The underlying InstanceAccessControlAttributeConfiguration CloudFormation resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `attributes`<sup>Required</sup> <a name="attributes" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.attributes"></a>

```typescript
public readonly attributes: AccessControlAttribute[];
```

- *Type:* cdk-extensions.sso.AccessControlAttribute[]

Lists the attributes that are configured for ABAC in the specified IAM Identity Center instance.

This array is readonly. Changes made to the
array will not be reflected in this resource. To add new attributes use
the `{@link addAttribute}` method.

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.instance"></a>

```typescript
public readonly instance: IInstance;
```

- *Type:* cdk-extensions.sso.IInstance

The ARN of the IAM Identity Center {@link aws-sso.IInstance | instance } under which the operation will be executed.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.sso.InstanceAccessControlAttributeConfiguration.property.resource"></a>

```typescript
public readonly resource: CfnInstanceAccessControlAttributeConfiguration;
```

- *Type:* aws-cdk-lib.aws_sso.CfnInstanceAccessControlAttributeConfiguration

The underlying InstanceAccessControlAttributeConfiguration CloudFormation resource.

---


### InstanceBase <a name="InstanceBase" id="cdk-extensions.sso.InstanceBase"></a>

- *Implements:* cdk-extensions.sso.IInstance

#### Initializers <a name="Initializers" id="cdk-extensions.sso.InstanceBase.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.InstanceBase(scope: Construct, id: string, props?: ResourceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceBase.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk-extensions.sso.InstanceBase.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.sso.InstanceBase.Initializer.parameter.props">props</a></code> | <code>aws-cdk-lib.ResourceProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.InstanceBase.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.InstanceBase.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.sso.InstanceBase.Initializer.parameter.props"></a>

- *Type:* aws-cdk-lib.ResourceProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceBase.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.sso.InstanceBase.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.sso.InstanceBase.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.sso.InstanceBase.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.InstanceBase.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceBase.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.sso.InstanceBase.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.sso.InstanceBase.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.sso.InstanceBase.isConstruct"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.InstanceBase.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.sso.InstanceBase.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.sso.InstanceBase.isOwnedResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.InstanceBase.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.InstanceBase.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.sso.InstanceBase.isResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.InstanceBase.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.InstanceBase.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceBase.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.sso.InstanceBase.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.sso.InstanceBase.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.sso.InstanceBase.property.instanceArn">instanceArn</a></code> | <code>string</code> | The ARN of the IAM Identity Center instance under which the operation will be executed. |
| <code><a href="#cdk-extensions.sso.InstanceBase.property.instanceId">instanceId</a></code> | <code>string</code> | The ID of the IAM Identity Center instance under which the operation will be executed. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.sso.InstanceBase.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.sso.InstanceBase.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.sso.InstanceBase.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `instanceArn`<sup>Required</sup> <a name="instanceArn" id="cdk-extensions.sso.InstanceBase.property.instanceArn"></a>

```typescript
public readonly instanceArn: string;
```

- *Type:* string

The ARN of the IAM Identity Center instance under which the operation will be executed.

For more information about ARNs, see Amazon Resource Names (ARNs) and AWS Service Namespaces in the AWS General Reference.

---

##### `instanceId`<sup>Required</sup> <a name="instanceId" id="cdk-extensions.sso.InstanceBase.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* string

The ID of the IAM Identity Center instance under which the operation will be executed.

---


### IpAddressManager <a name="IpAddressManager" id="cdk-extensions.ec2_patterns.IpAddressManager"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2_patterns.IpAddressManager.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

new ec2_patterns.IpAddressManager(scope: IConstruct, id: string, props?: IpAddressManagerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2_patterns.IpAddressManagerProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.IpAddressManager.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.IpAddressManager.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2_patterns.IpAddressManager.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2_patterns.IpAddressManagerProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.addPrivatePool">addPrivatePool</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.addRegion">addRegion</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.allocatePrivateNetwork">allocatePrivateNetwork</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2_patterns.IpAddressManager.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2_patterns.IpAddressManager.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2_patterns.IpAddressManager.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addPrivatePool` <a name="addPrivatePool" id="cdk-extensions.ec2_patterns.IpAddressManager.addPrivatePool"></a>

```typescript
public addPrivatePool(name: string, options?: AddPoolOptions): IIpamPool
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2_patterns.IpAddressManager.addPrivatePool.parameter.name"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.IpAddressManager.addPrivatePool.parameter.options"></a>

- *Type:* cdk-extensions.ec2_patterns.AddPoolOptions

---

##### `addRegion` <a name="addRegion" id="cdk-extensions.ec2_patterns.IpAddressManager.addRegion"></a>

```typescript
public addRegion(region: string): void
```

###### `region`<sup>Required</sup> <a name="region" id="cdk-extensions.ec2_patterns.IpAddressManager.addRegion.parameter.region"></a>

- *Type:* string

---

##### `allocatePrivateNetwork` <a name="allocatePrivateNetwork" id="cdk-extensions.ec2_patterns.IpAddressManager.allocatePrivateNetwork"></a>

```typescript
public allocatePrivateNetwork(scope: IConstruct, id: string, options?: AllocatePrivateNetworkOptions): IpamPool
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.IpAddressManager.allocatePrivateNetwork.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.IpAddressManager.allocatePrivateNetwork.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.IpAddressManager.allocatePrivateNetwork.parameter.options"></a>

- *Type:* cdk-extensions.ec2_patterns.AllocatePrivateNetworkOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2_patterns.IpAddressManager.isConstruct"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.IpAddressManager.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2_patterns.IpAddressManager.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2_patterns.IpAddressManager.isOwnedResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.IpAddressManager.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.IpAddressManager.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2_patterns.IpAddressManager.isResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.IpAddressManager.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.IpAddressManager.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.allowExternalPricipals">allowExternalPricipals</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.ipam">ipam</a></code> | <code>cdk-extensions.ec2.Ipam</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.sharingEnabled">sharingEnabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.resourceShare">resourceShare</a></code> | <code>cdk-extensions.ram.ResourceShare</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2_patterns.IpAddressManager.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2_patterns.IpAddressManager.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2_patterns.IpAddressManager.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `allowExternalPricipals`<sup>Required</sup> <a name="allowExternalPricipals" id="cdk-extensions.ec2_patterns.IpAddressManager.property.allowExternalPricipals"></a>

```typescript
public readonly allowExternalPricipals: boolean;
```

- *Type:* boolean

---

##### `ipam`<sup>Required</sup> <a name="ipam" id="cdk-extensions.ec2_patterns.IpAddressManager.property.ipam"></a>

```typescript
public readonly ipam: Ipam;
```

- *Type:* cdk-extensions.ec2.Ipam

---

##### `sharingEnabled`<sup>Required</sup> <a name="sharingEnabled" id="cdk-extensions.ec2_patterns.IpAddressManager.property.sharingEnabled"></a>

```typescript
public readonly sharingEnabled: boolean;
```

- *Type:* boolean

---

##### `resourceShare`<sup>Optional</sup> <a name="resourceShare" id="cdk-extensions.ec2_patterns.IpAddressManager.property.resourceShare"></a>

```typescript
public readonly resourceShare: ResourceShare;
```

- *Type:* cdk-extensions.ram.ResourceShare

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.DEFAULT_CIDR">DEFAULT_CIDR</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManager.property.DEFAULT_POOL_ALLOCATION_MASK">DEFAULT_POOL_ALLOCATION_MASK</a></code> | <code>number</code> | *No description.* |

---

##### `DEFAULT_CIDR`<sup>Required</sup> <a name="DEFAULT_CIDR" id="cdk-extensions.ec2_patterns.IpAddressManager.property.DEFAULT_CIDR"></a>

```typescript
public readonly DEFAULT_CIDR: string;
```

- *Type:* string

---

##### `DEFAULT_POOL_ALLOCATION_MASK`<sup>Required</sup> <a name="DEFAULT_POOL_ALLOCATION_MASK" id="cdk-extensions.ec2_patterns.IpAddressManager.property.DEFAULT_POOL_ALLOCATION_MASK"></a>

```typescript
public readonly DEFAULT_POOL_ALLOCATION_MASK: number;
```

- *Type:* number

---

### Ipam <a name="Ipam" id="cdk-extensions.ec2.Ipam"></a>

- *Implements:* cdk-extensions.ec2.IIpam

Represents an AWS IP Address Manager.

IPAM is a VPC feature that you can use to automate your IP address
management workflows including assigning, tracking, troubleshooting, and
auditing IP addresses across AWS Regions and accounts throughout your AWS
Organization.

> [[AWS::EC2::IPAM](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipam.html)]([AWS::EC2::IPAM](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipam.html))

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.Ipam.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.Ipam(scope: IConstruct, id: string, props?: IpamProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.Ipam.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.Ipam.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.Ipam.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.IpamProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.Ipam.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.Ipam.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.Ipam.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.IpamProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.Ipam.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.Ipam.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.Ipam.addRegion">addRegion</a></code> | Adds an operating region to the IPAM. |
| <code><a href="#cdk-extensions.ec2.Ipam.addScope">addScope</a></code> | Adds an IPAM scope to the IPAM. |
| <code><a href="#cdk-extensions.ec2.Ipam.associateResourceDiscovery">associateResourceDiscovery</a></code> | Associates an existing IPAM resource discovery with the IPAM. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.Ipam.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.Ipam.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.Ipam.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addRegion` <a name="addRegion" id="cdk-extensions.ec2.Ipam.addRegion"></a>

```typescript
public addRegion(region: string): void
```

Adds an operating region to the IPAM.

The operating Regions for an IPAM. Operating Regions are AWS Regions where
the IPAM is allowed to manage IP address CIDRs. IPAM only discovers and
monitors resources in the AWS Regions you select as operating Regions.

###### `region`<sup>Required</sup> <a name="region" id="cdk-extensions.ec2.Ipam.addRegion.parameter.region"></a>

- *Type:* string

The region to add to the IPAM.

---

##### `addScope` <a name="addScope" id="cdk-extensions.ec2.Ipam.addScope"></a>

```typescript
public addScope(id: string, options: IpamScopeOptions): IIpamScope
```

Adds an IPAM scope to the IPAM.

In IPAM, a scope is the highest-level container within IPAM. Scopes enable
you to reuse IP addresses across multiple unconnected networks without
causing IP address overlap or conflict.

> [[How IPAM works](https://docs.aws.amazon.com/vpc/latest/ipam/how-it-works-ipam.html)]([How IPAM works](https://docs.aws.amazon.com/vpc/latest/ipam/how-it-works-ipam.html))

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.Ipam.addScope.parameter.id"></a>

- *Type:* string

A name to be associated to the scope being added.

A unique id
must be used each time this method is invoked.

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.Ipam.addScope.parameter.options"></a>

- *Type:* cdk-extensions.ec2.IpamScopeOptions

Arguments specifying the details of the scope being added.

---

##### `associateResourceDiscovery` <a name="associateResourceDiscovery" id="cdk-extensions.ec2.Ipam.associateResourceDiscovery"></a>

```typescript
public associateResourceDiscovery(resourceDiscovery: IIpamResourceDiscovery): IIpamResourceDiscoveryAssociation
```

Associates an existing IPAM resource discovery with the IPAM.

IPAM aggregates the resource CIDRs discovered by the associated resource
discovery.

###### `resourceDiscovery`<sup>Required</sup> <a name="resourceDiscovery" id="cdk-extensions.ec2.Ipam.associateResourceDiscovery.parameter.resourceDiscovery"></a>

- *Type:* cdk-extensions.ec2.IIpamResourceDiscovery

The IPAM resource discovery to associate with the IPAM.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.Ipam.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.Ipam.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.Ipam.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.Ipam.fromIpamArn">fromIpamArn</a></code> | Imports an existing IPAM by specifying its Amazon Resource Name (ARN). |
| <code><a href="#cdk-extensions.ec2.Ipam.fromIpamAttributes">fromIpamAttributes</a></code> | Imports an existing IAPM by explicitly specifying its attributes. |
| <code><a href="#cdk-extensions.ec2.Ipam.fromIpamId">fromIpamId</a></code> | Imports an existing IPAM by explicitly specifying its AWS generated ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.Ipam.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.Ipam.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.Ipam.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.Ipam.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.Ipam.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.Ipam.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.Ipam.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.Ipam.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.Ipam.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromIpamArn` <a name="fromIpamArn" id="cdk-extensions.ec2.Ipam.fromIpamArn"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.Ipam.fromIpamArn(scope: IConstruct, id: string, ipamArn: string)
```

Imports an existing IPAM by specifying its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.Ipam.fromIpamArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.Ipam.fromIpamArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `ipamArn`<sup>Required</sup> <a name="ipamArn" id="cdk-extensions.ec2.Ipam.fromIpamArn.parameter.ipamArn"></a>

- *Type:* string

The ARN of the existing IPAM to be imported.

---

##### `fromIpamAttributes` <a name="fromIpamAttributes" id="cdk-extensions.ec2.Ipam.fromIpamAttributes"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.Ipam.fromIpamAttributes(scope: IConstruct, id: string, attrs: IpamAttributes)
```

Imports an existing IAPM by explicitly specifying its attributes.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.Ipam.fromIpamAttributes.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.Ipam.fromIpamAttributes.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.ec2.Ipam.fromIpamAttributes.parameter.attrs"></a>

- *Type:* cdk-extensions.ec2.IpamAttributes

The attributes of the existing IPAM to be imported.

---

##### `fromIpamId` <a name="fromIpamId" id="cdk-extensions.ec2.Ipam.fromIpamId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.Ipam.fromIpamId(scope: IConstruct, id: string, ipamId: string)
```

Imports an existing IPAM by explicitly specifying its AWS generated ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.Ipam.fromIpamId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.Ipam.fromIpamId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `ipamId`<sup>Required</sup> <a name="ipamId" id="cdk-extensions.ec2.Ipam.fromIpamId.parameter.ipamId"></a>

- *Type:* string

The AWS generated ID of the existing IPAM to be imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.Ipam.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.defaultPrivateScope">defaultPrivateScope</a></code> | <code>cdk-extensions.ec2.IIpamScope</code> | The IPAM's default private scope. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.defaultPublicScope">defaultPublicScope</a></code> | <code>cdk-extensions.ec2.IIpamScope</code> | The IPAM's default public scope. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.ipamArn">ipamArn</a></code> | <code>string</code> | The ARN of the IPAM. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.ipamId">ipamId</a></code> | <code>string</code> | The ID of the IPAM. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.ipamPrivateDefaultScopeId">ipamPrivateDefaultScopeId</a></code> | <code>string</code> | The ID of the IPAM's default private scope. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.ipamPublicDefaultScopeId">ipamPublicDefaultScopeId</a></code> | <code>string</code> | The ID of the IPAM's default public scope. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.ipamScopeCount">ipamScopeCount</a></code> | <code>number</code> | The number of scopes in the IPAM. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.regions">regions</a></code> | <code>string[]</code> | An immutable collection of operating Regions for an IPAM. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnIPAM</code> | The underlying IPAM CloudFormation resource. |
| <code><a href="#cdk-extensions.ec2.Ipam.property.description">description</a></code> | <code>string</code> | The description for the IPAM. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.Ipam.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.Ipam.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.Ipam.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `defaultPrivateScope`<sup>Required</sup> <a name="defaultPrivateScope" id="cdk-extensions.ec2.Ipam.property.defaultPrivateScope"></a>

```typescript
public readonly defaultPrivateScope: IIpamScope;
```

- *Type:* cdk-extensions.ec2.IIpamScope

The IPAM's default private scope.

---

##### `defaultPublicScope`<sup>Required</sup> <a name="defaultPublicScope" id="cdk-extensions.ec2.Ipam.property.defaultPublicScope"></a>

```typescript
public readonly defaultPublicScope: IIpamScope;
```

- *Type:* cdk-extensions.ec2.IIpamScope

The IPAM's default public scope.

---

##### `ipamArn`<sup>Required</sup> <a name="ipamArn" id="cdk-extensions.ec2.Ipam.property.ipamArn"></a>

```typescript
public readonly ipamArn: string;
```

- *Type:* string

The ARN of the IPAM.

---

##### `ipamId`<sup>Required</sup> <a name="ipamId" id="cdk-extensions.ec2.Ipam.property.ipamId"></a>

```typescript
public readonly ipamId: string;
```

- *Type:* string

The ID of the IPAM.

---

##### `ipamPrivateDefaultScopeId`<sup>Required</sup> <a name="ipamPrivateDefaultScopeId" id="cdk-extensions.ec2.Ipam.property.ipamPrivateDefaultScopeId"></a>

```typescript
public readonly ipamPrivateDefaultScopeId: string;
```

- *Type:* string

The ID of the IPAM's default private scope.

---

##### `ipamPublicDefaultScopeId`<sup>Required</sup> <a name="ipamPublicDefaultScopeId" id="cdk-extensions.ec2.Ipam.property.ipamPublicDefaultScopeId"></a>

```typescript
public readonly ipamPublicDefaultScopeId: string;
```

- *Type:* string

The ID of the IPAM's default public scope.

---

##### `ipamScopeCount`<sup>Required</sup> <a name="ipamScopeCount" id="cdk-extensions.ec2.Ipam.property.ipamScopeCount"></a>

```typescript
public readonly ipamScopeCount: number;
```

- *Type:* number

The number of scopes in the IPAM.

The scope quota is 5.

---

##### `regions`<sup>Required</sup> <a name="regions" id="cdk-extensions.ec2.Ipam.property.regions"></a>

```typescript
public readonly regions: string[];
```

- *Type:* string[]

An immutable collection of operating Regions for an IPAM.

Operating Regions are AWS Regions where the IPAM is allowed to manage IP
address CIDRs. IPAM only discovers and monitors resources in the AWS
Regions you select as operating Regions.

> [[Create an IPAM](https://docs.aws.amazon.com/vpc/latest/ipam/create-ipam.html)]([Create an IPAM](https://docs.aws.amazon.com/vpc/latest/ipam/create-ipam.html))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.Ipam.property.resource"></a>

```typescript
public readonly resource: CfnIPAM;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnIPAM

The underlying IPAM CloudFormation resource.

> [[AWS::EC2::IPAM](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipam.html)]([AWS::EC2::IPAM](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipam.html))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.Ipam.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The description for the IPAM.

> [[IPAM Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipam.html#cfn-ec2-ipam-description)]([IPAM Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipam.html#cfn-ec2-ipam-description))

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.Ipam.property.ARN_FORMAT">ARN_FORMAT</a></code> | <code>aws-cdk-lib.ArnFormat</code> | The format for Amazon Resource Names (ARN's) for IPAM resources. |

---

##### `ARN_FORMAT`<sup>Required</sup> <a name="ARN_FORMAT" id="cdk-extensions.ec2.Ipam.property.ARN_FORMAT"></a>

```typescript
public readonly ARN_FORMAT: ArnFormat;
```

- *Type:* aws-cdk-lib.ArnFormat

The format for Amazon Resource Names (ARN's) for IPAM resources.

---

### IpamAllocation <a name="IpamAllocation" id="cdk-extensions.ec2.IpamAllocation"></a>

- *Implements:* cdk-extensions.ec2.IIpamAllocation

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.IpamAllocation.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.IpamAllocation(scope: IConstruct, id: string, props: IpamAllocationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.IpamAllocationProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamAllocation.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamAllocation.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.IpamAllocation.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.IpamAllocationProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.IpamAllocation.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.IpamAllocation.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.IpamAllocation.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.IpamAllocation.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamAllocation.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.IpamAllocation.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.IpamAllocation.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamAllocation.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamAllocation.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.IpamAllocation.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamAllocation.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamAllocation.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.allocation">allocation</a></code> | <code>cdk-extensions.ec2.IIpamAllocationConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.ipamAllocationCidr">ipamAllocationCidr</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.ipamAllocationId">ipamAllocationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.ipamPool">ipamPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnIPAMAllocation</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocation.property.description">description</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.IpamAllocation.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.IpamAllocation.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.IpamAllocation.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `allocation`<sup>Required</sup> <a name="allocation" id="cdk-extensions.ec2.IpamAllocation.property.allocation"></a>

```typescript
public readonly allocation: IIpamAllocationConfiguration;
```

- *Type:* cdk-extensions.ec2.IIpamAllocationConfiguration

---

##### `ipamAllocationCidr`<sup>Required</sup> <a name="ipamAllocationCidr" id="cdk-extensions.ec2.IpamAllocation.property.ipamAllocationCidr"></a>

```typescript
public readonly ipamAllocationCidr: string;
```

- *Type:* string

---

##### `ipamAllocationId`<sup>Required</sup> <a name="ipamAllocationId" id="cdk-extensions.ec2.IpamAllocation.property.ipamAllocationId"></a>

```typescript
public readonly ipamAllocationId: string;
```

- *Type:* string

---

##### `ipamPool`<sup>Required</sup> <a name="ipamPool" id="cdk-extensions.ec2.IpamAllocation.property.ipamPool"></a>

```typescript
public readonly ipamPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.IpamAllocation.property.resource"></a>

```typescript
public readonly resource: CfnIPAMAllocation;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnIPAMAllocation

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamAllocation.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---


### IpamPool <a name="IpamPool" id="cdk-extensions.ec2.IpamPool"></a>

- *Implements:* cdk-extensions.ec2.IIpamPool

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.IpamPool.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.IpamPool(scope: IConstruct, id: string, props: IpamPoolProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPool.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.IpamPoolProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamPool.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamPool.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.IpamPool.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.IpamPoolProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPool.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.IpamPool.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.IpamPool.addChildPool">addChildPool</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.addCidrToPool">addCidrToPool</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.addTagRestriction">addTagRestriction</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.allocateCidrFromPool">allocateCidrFromPool</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.IpamPool.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.IpamPool.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.IpamPool.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addChildPool` <a name="addChildPool" id="cdk-extensions.ec2.IpamPool.addChildPool"></a>

```typescript
public addChildPool(id: string, options?: AddChildPoolOptions): IIpamPool
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamPool.addChildPool.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.IpamPool.addChildPool.parameter.options"></a>

- *Type:* cdk-extensions.ec2.AddChildPoolOptions

---

##### `addCidrToPool` <a name="addCidrToPool" id="cdk-extensions.ec2.IpamPool.addCidrToPool"></a>

```typescript
public addCidrToPool(id: string, options: AddCidrToPoolOptions): AddCidrToPoolResult
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamPool.addCidrToPool.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.IpamPool.addCidrToPool.parameter.options"></a>

- *Type:* cdk-extensions.ec2.AddCidrToPoolOptions

---

##### `addTagRestriction` <a name="addTagRestriction" id="cdk-extensions.ec2.IpamPool.addTagRestriction"></a>

```typescript
public addTagRestriction(key: string, value: string): IIpamPool
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.ec2.IpamPool.addTagRestriction.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.ec2.IpamPool.addTagRestriction.parameter.value"></a>

- *Type:* string

---

##### `allocateCidrFromPool` <a name="allocateCidrFromPool" id="cdk-extensions.ec2.IpamPool.allocateCidrFromPool"></a>

```typescript
public allocateCidrFromPool(id: string, options?: AllocateCidrFromPoolOptions): IIpamAllocation
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamPool.allocateCidrFromPool.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.IpamPool.allocateCidrFromPool.parameter.options"></a>

- *Type:* cdk-extensions.ec2.AllocateCidrFromPoolOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPool.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.IpamPool.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.IpamPool.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.IpamPool.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamPool.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.IpamPool.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.IpamPool.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamPool.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamPool.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.IpamPool.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamPool.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamPool.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamPoolArn">ipamPoolArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamPoolDepth">ipamPoolDepth</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamPoolId">ipamPoolId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamPoolIpamArn">ipamPoolIpamArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamPoolScopeArn">ipamPoolScopeArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamPoolScopeType">ipamPoolScopeType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamPoolState">ipamPoolState</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamPoolStateMessage">ipamPoolStateMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.ipamScope">ipamScope</a></code> | <code>cdk-extensions.ec2.IIpamScope</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnIPAMPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.addressConfiguration">addressConfiguration</a></code> | <code>cdk-extensions.ec2.AddressConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.autoImport">autoImport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.consumer">consumer</a></code> | <code>cdk-extensions.ec2.IpamConsumer</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.locale">locale</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.parentPool">parentPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPool.property.publicIpSource">publicIpSource</a></code> | <code>cdk-extensions.ec2.PublicIpSource</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.IpamPool.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.IpamPool.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.IpamPool.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `ipamPoolArn`<sup>Required</sup> <a name="ipamPoolArn" id="cdk-extensions.ec2.IpamPool.property.ipamPoolArn"></a>

```typescript
public readonly ipamPoolArn: string;
```

- *Type:* string

---

##### `ipamPoolDepth`<sup>Required</sup> <a name="ipamPoolDepth" id="cdk-extensions.ec2.IpamPool.property.ipamPoolDepth"></a>

```typescript
public readonly ipamPoolDepth: number;
```

- *Type:* number

---

##### `ipamPoolId`<sup>Required</sup> <a name="ipamPoolId" id="cdk-extensions.ec2.IpamPool.property.ipamPoolId"></a>

```typescript
public readonly ipamPoolId: string;
```

- *Type:* string

---

##### `ipamPoolIpamArn`<sup>Required</sup> <a name="ipamPoolIpamArn" id="cdk-extensions.ec2.IpamPool.property.ipamPoolIpamArn"></a>

```typescript
public readonly ipamPoolIpamArn: string;
```

- *Type:* string

---

##### `ipamPoolScopeArn`<sup>Required</sup> <a name="ipamPoolScopeArn" id="cdk-extensions.ec2.IpamPool.property.ipamPoolScopeArn"></a>

```typescript
public readonly ipamPoolScopeArn: string;
```

- *Type:* string

---

##### `ipamPoolScopeType`<sup>Required</sup> <a name="ipamPoolScopeType" id="cdk-extensions.ec2.IpamPool.property.ipamPoolScopeType"></a>

```typescript
public readonly ipamPoolScopeType: string;
```

- *Type:* string

---

##### `ipamPoolState`<sup>Required</sup> <a name="ipamPoolState" id="cdk-extensions.ec2.IpamPool.property.ipamPoolState"></a>

```typescript
public readonly ipamPoolState: string;
```

- *Type:* string

---

##### `ipamPoolStateMessage`<sup>Required</sup> <a name="ipamPoolStateMessage" id="cdk-extensions.ec2.IpamPool.property.ipamPoolStateMessage"></a>

```typescript
public readonly ipamPoolStateMessage: string;
```

- *Type:* string

---

##### `ipamScope`<sup>Required</sup> <a name="ipamScope" id="cdk-extensions.ec2.IpamPool.property.ipamScope"></a>

```typescript
public readonly ipamScope: IIpamScope;
```

- *Type:* cdk-extensions.ec2.IIpamScope

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.IpamPool.property.resource"></a>

```typescript
public readonly resource: CfnIPAMPool;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnIPAMPool

---

##### `addressConfiguration`<sup>Optional</sup> <a name="addressConfiguration" id="cdk-extensions.ec2.IpamPool.property.addressConfiguration"></a>

```typescript
public readonly addressConfiguration: AddressConfiguration;
```

- *Type:* cdk-extensions.ec2.AddressConfiguration

---

##### `autoImport`<sup>Optional</sup> <a name="autoImport" id="cdk-extensions.ec2.IpamPool.property.autoImport"></a>

```typescript
public readonly autoImport: boolean;
```

- *Type:* boolean

---

##### `consumer`<sup>Optional</sup> <a name="consumer" id="cdk-extensions.ec2.IpamPool.property.consumer"></a>

```typescript
public readonly consumer: IpamConsumer;
```

- *Type:* cdk-extensions.ec2.IpamConsumer

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamPool.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `locale`<sup>Optional</sup> <a name="locale" id="cdk-extensions.ec2.IpamPool.property.locale"></a>

```typescript
public readonly locale: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.IpamPool.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `parentPool`<sup>Optional</sup> <a name="parentPool" id="cdk-extensions.ec2.IpamPool.property.parentPool"></a>

```typescript
public readonly parentPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `publicIpSource`<sup>Optional</sup> <a name="publicIpSource" id="cdk-extensions.ec2.IpamPool.property.publicIpSource"></a>

```typescript
public readonly publicIpSource: PublicIpSource;
```

- *Type:* cdk-extensions.ec2.PublicIpSource

---


### IpamPoolCidr <a name="IpamPoolCidr" id="cdk-extensions.ec2.IpamPoolCidr"></a>

- *Implements:* cdk-extensions.ec2.IIpamPoolCidr

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.IpamPoolCidr.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.IpamPoolCidr(scope: IConstruct, id: string, props: IpamPoolCidrProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.IpamPoolCidrProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamPoolCidr.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamPoolCidr.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.IpamPoolCidr.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.IpamPoolCidrProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.IpamPoolCidr.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.IpamPoolCidr.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.IpamPoolCidr.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.IpamPoolCidr.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamPoolCidr.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.IpamPoolCidr.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.IpamPoolCidr.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamPoolCidr.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamPoolCidr.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.IpamPoolCidr.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamPoolCidr.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamPoolCidr.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.property.configuration">configuration</a></code> | <code>cdk-extensions.ec2.IIpamPoolCidrConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.property.ipamPool">ipamPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.property.ipamPoolCidrId">ipamPoolCidrId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.property.ipamPoolCidrState">ipamPoolCidrState</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidr.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnIPAMPoolCidr</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.IpamPoolCidr.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.IpamPoolCidr.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.IpamPoolCidr.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `configuration`<sup>Required</sup> <a name="configuration" id="cdk-extensions.ec2.IpamPoolCidr.property.configuration"></a>

```typescript
public readonly configuration: IIpamPoolCidrConfiguration;
```

- *Type:* cdk-extensions.ec2.IIpamPoolCidrConfiguration

---

##### `ipamPool`<sup>Required</sup> <a name="ipamPool" id="cdk-extensions.ec2.IpamPoolCidr.property.ipamPool"></a>

```typescript
public readonly ipamPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `ipamPoolCidrId`<sup>Required</sup> <a name="ipamPoolCidrId" id="cdk-extensions.ec2.IpamPoolCidr.property.ipamPoolCidrId"></a>

```typescript
public readonly ipamPoolCidrId: string;
```

- *Type:* string

---

##### `ipamPoolCidrState`<sup>Required</sup> <a name="ipamPoolCidrState" id="cdk-extensions.ec2.IpamPoolCidr.property.ipamPoolCidrState"></a>

```typescript
public readonly ipamPoolCidrState: string;
```

- *Type:* string

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.IpamPoolCidr.property.resource"></a>

```typescript
public readonly resource: CfnIPAMPoolCidr;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnIPAMPoolCidr

---


### IpamResourceDiscovery <a name="IpamResourceDiscovery" id="cdk-extensions.ec2.IpamResourceDiscovery"></a>

- *Implements:* cdk-extensions.ec2.IIpamResourceDiscovery

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.IpamResourceDiscovery.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.IpamResourceDiscovery(scope: IConstruct, id: string, props?: IpamResourceDiscoveryProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.IpamResourceDiscoveryProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamResourceDiscovery.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamResourceDiscovery.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.IpamResourceDiscovery.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.IpamResourceDiscoveryProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.addIpam">addIpam</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.addRegion">addRegion</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.associateIpam">associateIpam</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.IpamResourceDiscovery.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.IpamResourceDiscovery.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.IpamResourceDiscovery.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addIpam` <a name="addIpam" id="cdk-extensions.ec2.IpamResourceDiscovery.addIpam"></a>

```typescript
public addIpam(id: string, options: IpamProps): IIpam
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamResourceDiscovery.addIpam.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.IpamResourceDiscovery.addIpam.parameter.options"></a>

- *Type:* cdk-extensions.ec2.IpamProps

---

##### `addRegion` <a name="addRegion" id="cdk-extensions.ec2.IpamResourceDiscovery.addRegion"></a>

```typescript
public addRegion(region: string): void
```

###### `region`<sup>Required</sup> <a name="region" id="cdk-extensions.ec2.IpamResourceDiscovery.addRegion.parameter.region"></a>

- *Type:* string

---

##### `associateIpam` <a name="associateIpam" id="cdk-extensions.ec2.IpamResourceDiscovery.associateIpam"></a>

```typescript
public associateIpam(ipam: IIpam): IIpamResourceDiscoveryAssociation
```

###### `ipam`<sup>Required</sup> <a name="ipam" id="cdk-extensions.ec2.IpamResourceDiscovery.associateIpam.parameter.ipam"></a>

- *Type:* cdk-extensions.ec2.IIpam

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryArn">fromIpamResourceDiscoveryArn</a></code> | Imports an existing IPAM resource discovery by specifying its Amazon Resource Name (ARN). |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryAttributes">fromIpamResourceDiscoveryAttributes</a></code> | Imports an existing IPAM resource discovery by explicitly specifying its attributes. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryId">fromIpamResourceDiscoveryId</a></code> | Imports an existing IPAM resource discovery by explicitly specifying its AWS generated ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.IpamResourceDiscovery.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscovery.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.IpamResourceDiscovery.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.IpamResourceDiscovery.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscovery.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamResourceDiscovery.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.IpamResourceDiscovery.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscovery.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamResourceDiscovery.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromIpamResourceDiscoveryArn` <a name="fromIpamResourceDiscoveryArn" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryArn"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryArn(scope: IConstruct, id: string, ipamResourceDiscoveryArn: string)
```

Imports an existing IPAM resource discovery by specifying its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `ipamResourceDiscoveryArn`<sup>Required</sup> <a name="ipamResourceDiscoveryArn" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryArn.parameter.ipamResourceDiscoveryArn"></a>

- *Type:* string

The ARN of the existing IPAM resource discovery to be imported.

---

##### `fromIpamResourceDiscoveryAttributes` <a name="fromIpamResourceDiscoveryAttributes" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryAttributes"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryAttributes(scope: IConstruct, id: string, attrs: IpamResourceDiscoveryAttributes)
```

Imports an existing IPAM resource discovery by explicitly specifying its attributes.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryAttributes.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryAttributes.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryAttributes.parameter.attrs"></a>

- *Type:* cdk-extensions.ec2.IpamResourceDiscoveryAttributes

The attributes of the existing IPAM resource discovery to be imported.

---

##### `fromIpamResourceDiscoveryId` <a name="fromIpamResourceDiscoveryId" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryId(scope: IConstruct, id: string, ipamResourceDiscoveryId: string)
```

Imports an existing IPAM resource discovery by explicitly specifying its AWS generated ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `ipamResourceDiscoveryId`<sup>Required</sup> <a name="ipamResourceDiscoveryId" id="cdk-extensions.ec2.IpamResourceDiscovery.fromIpamResourceDiscoveryId.parameter.ipamResourceDiscoveryId"></a>

- *Type:* string

The AWS generated ID of the existing IPAM resource discovery to be imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryArn">ipamResourceDiscoveryArn</a></code> | <code>string</code> | The resource discovery ARN. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryId">ipamResourceDiscoveryId</a></code> | <code>string</code> | The resource discovery ID. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryIsDefault">ipamResourceDiscoveryIsDefault</a></code> | <code>aws-cdk-lib.IResolvable</code> | Defines if the resource discovery is the default. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryOwnerId">ipamResourceDiscoveryOwnerId</a></code> | <code>string</code> | The owner ID. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryRegion">ipamResourceDiscoveryRegion</a></code> | <code>string</code> | The resource discovery Region. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryState">ipamResourceDiscoveryState</a></code> | <code>string</code> | The resource discovery's state. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.regions">regions</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnIPAMResourceDiscovery</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.description">description</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.IpamResourceDiscovery.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.IpamResourceDiscovery.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.IpamResourceDiscovery.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `ipamResourceDiscoveryArn`<sup>Required</sup> <a name="ipamResourceDiscoveryArn" id="cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryArn"></a>

```typescript
public readonly ipamResourceDiscoveryArn: string;
```

- *Type:* string

The resource discovery ARN.

---

##### `ipamResourceDiscoveryId`<sup>Required</sup> <a name="ipamResourceDiscoveryId" id="cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryId"></a>

```typescript
public readonly ipamResourceDiscoveryId: string;
```

- *Type:* string

The resource discovery ID.

---

##### `ipamResourceDiscoveryIsDefault`<sup>Required</sup> <a name="ipamResourceDiscoveryIsDefault" id="cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryIsDefault"></a>

```typescript
public readonly ipamResourceDiscoveryIsDefault: IResolvable;
```

- *Type:* aws-cdk-lib.IResolvable

Defines if the resource discovery is the default.

The default resource
discovery is the resource discovery automatically created when you create
an IPAM.

---

##### `ipamResourceDiscoveryOwnerId`<sup>Required</sup> <a name="ipamResourceDiscoveryOwnerId" id="cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryOwnerId"></a>

```typescript
public readonly ipamResourceDiscoveryOwnerId: string;
```

- *Type:* string

The owner ID.

---

##### `ipamResourceDiscoveryRegion`<sup>Required</sup> <a name="ipamResourceDiscoveryRegion" id="cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryRegion"></a>

```typescript
public readonly ipamResourceDiscoveryRegion: string;
```

- *Type:* string

The resource discovery Region.

---

##### `ipamResourceDiscoveryState`<sup>Required</sup> <a name="ipamResourceDiscoveryState" id="cdk-extensions.ec2.IpamResourceDiscovery.property.ipamResourceDiscoveryState"></a>

```typescript
public readonly ipamResourceDiscoveryState: string;
```

- *Type:* string

The resource discovery's state.

create-in-progress - Resource discovery is being created.
- create-complete - Resource discovery creation is complete.
- create-failed - Resource discovery creation has failed.
- modify-in-progress - Resource discovery is being modified.
- modify-complete - Resource discovery modification is complete.
- modify-failed - Resource discovery modification has failed.
- delete-in-progress - Resource discovery is being deleted.
- delete-complete - Resource discovery deletion is complete.
- delete-failed - Resource discovery deletion has failed.
- isolate-in-progress - AWS account that created the resource discovery
has been removed and the resource discovery is being isolated.
- isolate-complete - Resource discovery isolation is complete.
- restore-in-progress - AWS account that created the resource discovery
and was isolated has been restored.

---

##### `regions`<sup>Required</sup> <a name="regions" id="cdk-extensions.ec2.IpamResourceDiscovery.property.regions"></a>

```typescript
public readonly regions: string[];
```

- *Type:* string[]

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.IpamResourceDiscovery.property.resource"></a>

```typescript
public readonly resource: CfnIPAMResourceDiscovery;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnIPAMResourceDiscovery

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamResourceDiscovery.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscovery.property.ARN_FORMAT">ARN_FORMAT</a></code> | <code>aws-cdk-lib.ArnFormat</code> | The format for Amazon Resource Names (ARN's) for IPAM resource discovery resources. |

---

##### `ARN_FORMAT`<sup>Required</sup> <a name="ARN_FORMAT" id="cdk-extensions.ec2.IpamResourceDiscovery.property.ARN_FORMAT"></a>

```typescript
public readonly ARN_FORMAT: ArnFormat;
```

- *Type:* aws-cdk-lib.ArnFormat

The format for Amazon Resource Names (ARN's) for IPAM resource discovery resources.

---

### IpamResourceDiscoveryAssociation <a name="IpamResourceDiscoveryAssociation" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation"></a>

- *Implements:* cdk-extensions.ec2.IIpamResourceDiscoveryAssociation

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.IpamResourceDiscoveryAssociation(scope: IConstruct, id: string, props: IpamResourceDiscoveryAssociationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscoveryAssociation.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscoveryAssociation.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamResourceDiscoveryAssociation.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipam">ipam</a></code> | <code>cdk-extensions.ec2.IIpam</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscovery">ipamResourceDiscovery</a></code> | <code>cdk-extensions.ec2.IIpamResourceDiscovery</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationArn">ipamResourceDiscoveryAssociationArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationId">ipamResourceDiscoveryAssociationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIpamArn">ipamResourceDiscoveryAssociationIpamArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIpamRegion">ipamResourceDiscoveryAssociationIpamRegion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIsDefault">ipamResourceDiscoveryAssociationIsDefault</a></code> | <code>aws-cdk-lib.IResolvable</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationOwnerId">ipamResourceDiscoveryAssociationOwnerId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationResourceDiscoveryId">ipamResourceDiscoveryAssociationResourceDiscoveryId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationResourceDiscoveryStatus">ipamResourceDiscoveryAssociationResourceDiscoveryStatus</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationState">ipamResourceDiscoveryAssociationState</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnIPAMResourceDiscoveryAssociation</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `ipam`<sup>Required</sup> <a name="ipam" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipam"></a>

```typescript
public readonly ipam: IIpam;
```

- *Type:* cdk-extensions.ec2.IIpam

---

##### `ipamResourceDiscovery`<sup>Required</sup> <a name="ipamResourceDiscovery" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscovery"></a>

```typescript
public readonly ipamResourceDiscovery: IIpamResourceDiscovery;
```

- *Type:* cdk-extensions.ec2.IIpamResourceDiscovery

---

##### `ipamResourceDiscoveryAssociationArn`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationArn" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationArn"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationArn: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationId`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationId" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationId"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationId: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationIpamArn`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationIpamArn" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIpamArn"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationIpamArn: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationIpamRegion`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationIpamRegion" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIpamRegion"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationIpamRegion: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationIsDefault`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationIsDefault" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIsDefault"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationIsDefault: IResolvable;
```

- *Type:* aws-cdk-lib.IResolvable

---

##### `ipamResourceDiscoveryAssociationOwnerId`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationOwnerId" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationOwnerId"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationOwnerId: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationResourceDiscoveryId`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationResourceDiscoveryId" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationResourceDiscoveryId"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationResourceDiscoveryId: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationResourceDiscoveryStatus`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationResourceDiscoveryStatus" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationResourceDiscoveryStatus"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationResourceDiscoveryStatus: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationState`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationState" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationState"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationState: string;
```

- *Type:* string

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociation.property.resource"></a>

```typescript
public readonly resource: CfnIPAMResourceDiscoveryAssociation;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnIPAMResourceDiscoveryAssociation

---


### IpamScope <a name="IpamScope" id="cdk-extensions.ec2.IpamScope"></a>

- *Implements:* cdk-extensions.ec2.IIpamScope

Represents an IPAM scope.

In IPAM, a scope is the highest-level container within IPAM. An IPAM
contains two default scopes. Each scope represents the IP space for a single
network. The private scope is intended for all private IP address space. The
public scope is intended for all public IP address space. Scopes enable you
to reuse IP addresses across multiple unconnected networks without causing
IP address overlap or conflict.

> [[AWS::EC2::IPAMScope](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html)]([AWS::EC2::IPAMScope](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html))

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.IpamScope.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.IpamScope(scope: IConstruct, id: string, props: IpamScopeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamScope.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.IpamScope.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.IpamScope.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.IpamScopeProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamScope.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamScope.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.IpamScope.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.IpamScopeProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamScope.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.IpamScope.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.IpamScope.addPool">addPool</a></code> | Adds an IPAM pool to the IPAM scope. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.IpamScope.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.IpamScope.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.IpamScope.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addPool` <a name="addPool" id="cdk-extensions.ec2.IpamScope.addPool"></a>

```typescript
public addPool(id: string, options?: IpamPoolOptions): IIpamPool
```

Adds an IPAM pool to the IPAM scope.

A pool is a collection of contiguous IP address ranges (or CIDRs). IPAM
pools enable you to organize your IP addresses according to your routing
and security needs.

> [[How IPAM works](https://docs.aws.amazon.com/vpc/latest/ipam/how-it-works-ipam.html)]([How IPAM works](https://docs.aws.amazon.com/vpc/latest/ipam/how-it-works-ipam.html))

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamScope.addPool.parameter.id"></a>

- *Type:* string

A name to be associated with the pool bing added.

A unique id
must be used each time the method is invoked.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.IpamScope.addPool.parameter.options"></a>

- *Type:* cdk-extensions.ec2.IpamPoolOptions

Arguments specifying the details of the pool being added.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamScope.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.IpamScope.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.IpamScope.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.IpamScope.fromIpamScopeArn">fromIpamScopeArn</a></code> | Imports an existing IPAM scope by specifying its Amazon Resource Name (ARN). |
| <code><a href="#cdk-extensions.ec2.IpamScope.fromIpamScopeAttributes">fromIpamScopeAttributes</a></code> | Imports an existing IAPM scope by explicitly specifying its attributes. |
| <code><a href="#cdk-extensions.ec2.IpamScope.fromIpamScopeId">fromIpamScopeId</a></code> | Imports an existing IPAM scope by explicitly specifying its AWS generated ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.IpamScope.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamScope.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.IpamScope.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.IpamScope.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamScope.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamScope.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.IpamScope.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamScope.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.IpamScope.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromIpamScopeArn` <a name="fromIpamScopeArn" id="cdk-extensions.ec2.IpamScope.fromIpamScopeArn"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamScope.fromIpamScopeArn(scope: IConstruct, id: string, ipamScopeArn: string)
```

Imports an existing IPAM scope by specifying its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamScope.fromIpamScopeArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamScope.fromIpamScopeArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `ipamScopeArn`<sup>Required</sup> <a name="ipamScopeArn" id="cdk-extensions.ec2.IpamScope.fromIpamScopeArn.parameter.ipamScopeArn"></a>

- *Type:* string

The ARN of the existing IPAM scope to be imported.

---

##### `fromIpamScopeAttributes` <a name="fromIpamScopeAttributes" id="cdk-extensions.ec2.IpamScope.fromIpamScopeAttributes"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamScope.fromIpamScopeAttributes(scope: IConstruct, id: string, attrs: IpamScopeAttributes)
```

Imports an existing IAPM scope by explicitly specifying its attributes.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamScope.fromIpamScopeAttributes.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamScope.fromIpamScopeAttributes.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.ec2.IpamScope.fromIpamScopeAttributes.parameter.attrs"></a>

- *Type:* cdk-extensions.ec2.IpamScopeAttributes

The attributes of the existing IPAM scope to be imported.

---

##### `fromIpamScopeId` <a name="fromIpamScopeId" id="cdk-extensions.ec2.IpamScope.fromIpamScopeId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamScope.fromIpamScopeId(scope: IConstruct, id: string, ipamScopeId: string)
```

Imports an existing IPAM scope by explicitly specifying its AWS generated ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IpamScope.fromIpamScopeId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IpamScope.fromIpamScopeId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `ipamScopeId`<sup>Required</sup> <a name="ipamScopeId" id="cdk-extensions.ec2.IpamScope.fromIpamScopeId.parameter.ipamScopeId"></a>

- *Type:* string

The AWS generated ID of the existing IPAM scope to be imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.ipam">ipam</a></code> | <code>cdk-extensions.ec2.IIpam</code> | The IPAM for which you're creating this scope. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.ipamScopeArn">ipamScopeArn</a></code> | <code>string</code> | The ARN of the scope. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.ipamScopeId">ipamScopeId</a></code> | <code>string</code> | The ID of an IPAM scope. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.ipamScopeIpamArn">ipamScopeIpamArn</a></code> | <code>string</code> | The ARN of an IPAM. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.ipamScopeIsDefault">ipamScopeIsDefault</a></code> | <code>aws-cdk-lib.IResolvable</code> | Defines if the scope is the default scope or not. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.ipamScopePoolCount">ipamScopePoolCount</a></code> | <code>number</code> | The number of pools in a scope. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.ipamScopeType">ipamScopeType</a></code> | <code>string</code> | The type of the scope. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnIPAMScope</code> | The underlying IPAM scope CloudFormation resource. |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.description">description</a></code> | <code>string</code> | The description of the scope. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.IpamScope.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.IpamScope.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.IpamScope.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `ipam`<sup>Required</sup> <a name="ipam" id="cdk-extensions.ec2.IpamScope.property.ipam"></a>

```typescript
public readonly ipam: IIpam;
```

- *Type:* cdk-extensions.ec2.IIpam

The IPAM for which you're creating this scope.

> [[IPAMScope IpamId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-ipamid)]([IPAMScope IpamId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-ipamid))

---

##### `ipamScopeArn`<sup>Required</sup> <a name="ipamScopeArn" id="cdk-extensions.ec2.IpamScope.property.ipamScopeArn"></a>

```typescript
public readonly ipamScopeArn: string;
```

- *Type:* string

The ARN of the scope.

---

##### `ipamScopeId`<sup>Required</sup> <a name="ipamScopeId" id="cdk-extensions.ec2.IpamScope.property.ipamScopeId"></a>

```typescript
public readonly ipamScopeId: string;
```

- *Type:* string

The ID of an IPAM scope.

---

##### `ipamScopeIpamArn`<sup>Required</sup> <a name="ipamScopeIpamArn" id="cdk-extensions.ec2.IpamScope.property.ipamScopeIpamArn"></a>

```typescript
public readonly ipamScopeIpamArn: string;
```

- *Type:* string

The ARN of an IPAM.

---

##### `ipamScopeIsDefault`<sup>Required</sup> <a name="ipamScopeIsDefault" id="cdk-extensions.ec2.IpamScope.property.ipamScopeIsDefault"></a>

```typescript
public readonly ipamScopeIsDefault: IResolvable;
```

- *Type:* aws-cdk-lib.IResolvable

Defines if the scope is the default scope or not.

---

##### `ipamScopePoolCount`<sup>Required</sup> <a name="ipamScopePoolCount" id="cdk-extensions.ec2.IpamScope.property.ipamScopePoolCount"></a>

```typescript
public readonly ipamScopePoolCount: number;
```

- *Type:* number

The number of pools in a scope.

---

##### `ipamScopeType`<sup>Required</sup> <a name="ipamScopeType" id="cdk-extensions.ec2.IpamScope.property.ipamScopeType"></a>

```typescript
public readonly ipamScopeType: string;
```

- *Type:* string

The type of the scope.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.IpamScope.property.resource"></a>

```typescript
public readonly resource: CfnIPAMScope;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnIPAMScope

The underlying IPAM scope CloudFormation resource.

> [[AWS::EC2::IPAMScope](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html)]([AWS::EC2::IPAMScope](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamScope.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The description of the scope.

> [[IPAMScope Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-description)]([IPAMScope Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-description))

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamScope.property.ARN_FORMAT">ARN_FORMAT</a></code> | <code>aws-cdk-lib.ArnFormat</code> | The format for Amazon Resource Names (ARN's) for IPAM scope resources. |

---

##### `ARN_FORMAT`<sup>Required</sup> <a name="ARN_FORMAT" id="cdk-extensions.ec2.IpamScope.property.ARN_FORMAT"></a>

```typescript
public readonly ARN_FORMAT: ArnFormat;
```

- *Type:* aws-cdk-lib.ArnFormat

The format for Amazon Resource Names (ARN's) for IPAM scope resources.

---

### JdbcConnection <a name="JdbcConnection" id="cdk-extensions.glue.JdbcConnection"></a>

Creates a Connection resource to a Java Database.

> [[AWS::Glue::Connection](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-connection.html)]([AWS::Glue::Connection](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-connection.html))

#### Initializers <a name="Initializers" id="cdk-extensions.glue.JdbcConnection.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.JdbcConnection(scope: Construct, id: string, props: JdbcConnectionProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcConnection.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.JdbcConnectionProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.JdbcConnection.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.JdbcConnection.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.JdbcConnection.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.JdbcConnectionProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcConnection.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.addMatchCriteria">addMatchCriteria</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.JdbcConnection.addProperty">addProperty</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.JdbcConnection.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.JdbcConnection.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.JdbcConnection.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addMatchCriteria` <a name="addMatchCriteria" id="cdk-extensions.glue.JdbcConnection.addMatchCriteria"></a>

```typescript
public addMatchCriteria(value: string): void
```

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.JdbcConnection.addMatchCriteria.parameter.value"></a>

- *Type:* string

---

##### `addProperty` <a name="addProperty" id="cdk-extensions.glue.JdbcConnection.addProperty"></a>

```typescript
public addProperty(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.JdbcConnection.addProperty.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.JdbcConnection.addProperty.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcConnection.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.JdbcConnection.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JdbcConnection.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.JdbcConnection.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.JdbcConnection.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JdbcConnection.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.JdbcConnection.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.JdbcConnection.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JdbcConnection.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.JdbcConnection.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.connectionArn">connectionArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.connectionName">connectionName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.connections">connections</a></code> | <code>aws-cdk-lib.aws_ec2.Connections</code> | The network connections associated with this resource. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.connectionType">connectionType</a></code> | <code>cdk-extensions.glue.ConnectionType</code> | {@link ConnectionProps.connectionType:}. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnConnection</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.securityGroups">securityGroups</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup[]</code> | {@link ConnectionProps.securityGroups:}. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.description">description</a></code> | <code>string</code> | {@link ConnectionProps.description}. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.name">name</a></code> | <code>string</code> | {@link ConnectionProps.name}. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.securityGroup">securityGroup</a></code> | <code>aws-cdk-lib.aws_ec2.SecurityGroup</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | {@link ConnectionProps.subnets}. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | {@link ConnectionProps.vpc}. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.password">password</a></code> | <code>aws-cdk-lib.SecretValue</code> | {@link JdbcConnectionProps.password:}. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.url">url</a></code> | <code>string</code> | {@link JdbcConnectionProps.url:}. |
| <code><a href="#cdk-extensions.glue.JdbcConnection.property.username">username</a></code> | <code>string</code> | {@link JdbcConnectionProps.username:}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.JdbcConnection.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.JdbcConnection.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.JdbcConnection.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `connectionArn`<sup>Required</sup> <a name="connectionArn" id="cdk-extensions.glue.JdbcConnection.property.connectionArn"></a>

```typescript
public readonly connectionArn: string;
```

- *Type:* string

---

##### `connectionName`<sup>Required</sup> <a name="connectionName" id="cdk-extensions.glue.JdbcConnection.property.connectionName"></a>

```typescript
public readonly connectionName: string;
```

- *Type:* string

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk-extensions.glue.JdbcConnection.property.connections"></a>

```typescript
public readonly connections: Connections;
```

- *Type:* aws-cdk-lib.aws_ec2.Connections

The network connections associated with this resource.

---

##### `connectionType`<sup>Required</sup> <a name="connectionType" id="cdk-extensions.glue.JdbcConnection.property.connectionType"></a>

```typescript
public readonly connectionType: ConnectionType;
```

- *Type:* cdk-extensions.glue.ConnectionType

{@link ConnectionProps.connectionType:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.JdbcConnection.property.resource"></a>

```typescript
public readonly resource: CfnConnection;
```

- *Type:* aws-cdk-lib.aws_glue.CfnConnection

---

##### `securityGroups`<sup>Required</sup> <a name="securityGroups" id="cdk-extensions.glue.JdbcConnection.property.securityGroups"></a>

```typescript
public readonly securityGroups: ISecurityGroup[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup[]

{@link ConnectionProps.securityGroups:}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.JdbcConnection.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link ConnectionProps.description}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.JdbcConnection.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link ConnectionProps.name}.

---

##### `securityGroup`<sup>Optional</sup> <a name="securityGroup" id="cdk-extensions.glue.JdbcConnection.property.securityGroup"></a>

```typescript
public readonly securityGroup: SecurityGroup;
```

- *Type:* aws-cdk-lib.aws_ec2.SecurityGroup

---

##### `subnets`<sup>Optional</sup> <a name="subnets" id="cdk-extensions.glue.JdbcConnection.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

{@link ConnectionProps.subnets}.

---

##### `vpc`<sup>Optional</sup> <a name="vpc" id="cdk-extensions.glue.JdbcConnection.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

{@link ConnectionProps.vpc}.

---

##### `password`<sup>Required</sup> <a name="password" id="cdk-extensions.glue.JdbcConnection.property.password"></a>

```typescript
public readonly password: SecretValue;
```

- *Type:* aws-cdk-lib.SecretValue

{@link JdbcConnectionProps.password:}.

---

##### `url`<sup>Required</sup> <a name="url" id="cdk-extensions.glue.JdbcConnection.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

{@link JdbcConnectionProps.url:}.

---

##### `username`<sup>Required</sup> <a name="username" id="cdk-extensions.glue.JdbcConnection.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

{@link JdbcConnectionProps.username:}.

---


### Job <a name="Job" id="cdk-extensions.glue.Job"></a>

- *Implements:* cdk-extensions.glue.IJob

Creates a Glue Job.

> [[AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html)]([AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html))

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Job.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Job(scope: Construct, id: string, props: JobProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Job.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue.Job.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue.Job.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.JobProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Job.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Job.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.Job.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.JobProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Job.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.Job.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue.Job.addArgument">addArgument</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Job.addConnection">addConnection</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.Job.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.Job.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.Job.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addArgument` <a name="addArgument" id="cdk-extensions.glue.Job.addArgument"></a>

```typescript
public addArgument(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.Job.addArgument.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.Job.addArgument.parameter.value"></a>

- *Type:* string

---

##### `addConnection` <a name="addConnection" id="cdk-extensions.glue.Job.addConnection"></a>

```typescript
public addConnection(connection: Connection): void
```

###### `connection`<sup>Required</sup> <a name="connection" id="cdk-extensions.glue.Job.addConnection.parameter.connection"></a>

- *Type:* cdk-extensions.glue.Connection

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Job.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.Job.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.Job.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.glue.Job.fromJobArn">fromJobArn</a></code> | Imports an existing job using its Amazon Resource Name (ARN). |
| <code><a href="#cdk-extensions.glue.Job.fromJobName">fromJobName</a></code> | Imports an existing job using its name. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.Job.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Job.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.Job.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.Job.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Job.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Job.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.Job.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Job.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Job.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromJobArn` <a name="fromJobArn" id="cdk-extensions.glue.Job.fromJobArn"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Job.fromJobArn(scope: IConstruct, id: string, jobArn: string)
```

Imports an existing job using its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Job.fromJobArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Job.fromJobArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `jobArn`<sup>Required</sup> <a name="jobArn" id="cdk-extensions.glue.Job.fromJobArn.parameter.jobArn"></a>

- *Type:* string

The ARN of the job to import.

---

##### `fromJobName` <a name="fromJobName" id="cdk-extensions.glue.Job.fromJobName"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Job.fromJobName(scope: IConstruct, id: string, jobName: string)
```

Imports an existing job using its name.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Job.fromJobName.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Job.fromJobName.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `jobName`<sup>Required</sup> <a name="jobName" id="cdk-extensions.glue.Job.fromJobName.parameter.jobName"></a>

- *Type:* string

The name of the job to import.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Job.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.Job.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.Job.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.Job.property.executable">executable</a></code> | <code>cdk-extensions.glue.JobExecutable</code> | {@link JobProps.executable:}. |
| <code><a href="#cdk-extensions.glue.Job.property.jobArn">jobArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the job. |
| <code><a href="#cdk-extensions.glue.Job.property.jobName">jobName</a></code> | <code>string</code> | The name of the job. |
| <code><a href="#cdk-extensions.glue.Job.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnJob</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Job.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Job.property.allocatedCapacity">allocatedCapacity</a></code> | <code>number</code> | {@link JobProps.allocatedCapacity }. |
| <code><a href="#cdk-extensions.glue.Job.property.connections">connections</a></code> | <code>cdk-extensions.glue.Connection[]</code> | {@link JobProps.connections}. |
| <code><a href="#cdk-extensions.glue.Job.property.continuousLogging">continuousLogging</a></code> | <code>cdk-extensions.glue.ContinuousLoggingProps</code> | {@link JobProps.continuousLogging}. |
| <code><a href="#cdk-extensions.glue.Job.property.description">description</a></code> | <code>string</code> | {@link JobProps.description}. |
| <code><a href="#cdk-extensions.glue.Job.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Job.property.maxCapacity">maxCapacity</a></code> | <code>number</code> | {@link JobProps.maxCapacity}. |
| <code><a href="#cdk-extensions.glue.Job.property.maxConcurrentRuns">maxConcurrentRuns</a></code> | <code>number</code> | {@link JobProps.maxConcurrentRuns}. |
| <code><a href="#cdk-extensions.glue.Job.property.maxRetries">maxRetries</a></code> | <code>number</code> | {@link JobProps.maxRetries}. |
| <code><a href="#cdk-extensions.glue.Job.property.name">name</a></code> | <code>string</code> | {@link JobProps.name}. |
| <code><a href="#cdk-extensions.glue.Job.property.notifyDelayAfter">notifyDelayAfter</a></code> | <code>aws-cdk-lib.Duration</code> | {@link JobProps.notifyDelayAfter}. |
| <code><a href="#cdk-extensions.glue.Job.property.securityConfiguration">securityConfiguration</a></code> | <code>cdk-extensions.glue.SecurityConfiguration</code> | {@link JobProps.securityConfiguration}. |
| <code><a href="#cdk-extensions.glue.Job.property.timeout">timeout</a></code> | <code>aws-cdk-lib.Duration</code> | {@link JobProps.timeout}. |
| <code><a href="#cdk-extensions.glue.Job.property.workerCount">workerCount</a></code> | <code>number</code> | {@link JobProps.workerCount}. |
| <code><a href="#cdk-extensions.glue.Job.property.workerType">workerType</a></code> | <code>cdk-extensions.glue.WorkerType</code> | {@link JobProps.workerType}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.Job.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.Job.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.Job.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `executable`<sup>Required</sup> <a name="executable" id="cdk-extensions.glue.Job.property.executable"></a>

```typescript
public readonly executable: JobExecutable;
```

- *Type:* cdk-extensions.glue.JobExecutable

{@link JobProps.executable:}.

---

##### `jobArn`<sup>Required</sup> <a name="jobArn" id="cdk-extensions.glue.Job.property.jobArn"></a>

```typescript
public readonly jobArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the job.

---

##### `jobName`<sup>Required</sup> <a name="jobName" id="cdk-extensions.glue.Job.property.jobName"></a>

```typescript
public readonly jobName: string;
```

- *Type:* string

The name of the job.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.Job.property.resource"></a>

```typescript
public readonly resource: CfnJob;
```

- *Type:* aws-cdk-lib.aws_glue.CfnJob

---

##### `role`<sup>Required</sup> <a name="role" id="cdk-extensions.glue.Job.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `allocatedCapacity`<sup>Optional</sup> <a name="allocatedCapacity" id="cdk-extensions.glue.Job.property.allocatedCapacity"></a>

```typescript
public readonly allocatedCapacity: number;
```

- *Type:* number

{@link JobProps.allocatedCapacity }.

---

##### `connections`<sup>Optional</sup> <a name="connections" id="cdk-extensions.glue.Job.property.connections"></a>

```typescript
public readonly connections: Connection[];
```

- *Type:* cdk-extensions.glue.Connection[]

{@link JobProps.connections}.

---

##### `continuousLogging`<sup>Optional</sup> <a name="continuousLogging" id="cdk-extensions.glue.Job.property.continuousLogging"></a>

```typescript
public readonly continuousLogging: ContinuousLoggingProps;
```

- *Type:* cdk-extensions.glue.ContinuousLoggingProps

{@link JobProps.continuousLogging}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.Job.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link JobProps.description}.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.glue.Job.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

---

##### `maxCapacity`<sup>Optional</sup> <a name="maxCapacity" id="cdk-extensions.glue.Job.property.maxCapacity"></a>

```typescript
public readonly maxCapacity: number;
```

- *Type:* number

{@link JobProps.maxCapacity}.

---

##### `maxConcurrentRuns`<sup>Optional</sup> <a name="maxConcurrentRuns" id="cdk-extensions.glue.Job.property.maxConcurrentRuns"></a>

```typescript
public readonly maxConcurrentRuns: number;
```

- *Type:* number

{@link JobProps.maxConcurrentRuns}.

---

##### `maxRetries`<sup>Optional</sup> <a name="maxRetries" id="cdk-extensions.glue.Job.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* number

{@link JobProps.maxRetries}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.Job.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link JobProps.name}.

---

##### `notifyDelayAfter`<sup>Optional</sup> <a name="notifyDelayAfter" id="cdk-extensions.glue.Job.property.notifyDelayAfter"></a>

```typescript
public readonly notifyDelayAfter: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link JobProps.notifyDelayAfter}.

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.Job.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: SecurityConfiguration;
```

- *Type:* cdk-extensions.glue.SecurityConfiguration

{@link JobProps.securityConfiguration}.

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="cdk-extensions.glue.Job.property.timeout"></a>

```typescript
public readonly timeout: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link JobProps.timeout}.

---

##### `workerCount`<sup>Optional</sup> <a name="workerCount" id="cdk-extensions.glue.Job.property.workerCount"></a>

```typescript
public readonly workerCount: number;
```

- *Type:* number

{@link JobProps.workerCount}.

---

##### `workerType`<sup>Optional</sup> <a name="workerType" id="cdk-extensions.glue.Job.property.workerType"></a>

```typescript
public readonly workerType: WorkerType;
```

- *Type:* cdk-extensions.glue.WorkerType

{@link JobProps.workerType}.

---


### LogRetentionController <a name="LogRetentionController" id="cdk-extensions.lambda.LogRetentionController"></a>

Deploys a solution that automatically sets a log retention policy for all CloudWatch log groups created by AWS Lamba.

The controller consists of an EventBridge rule that detects the creation of
new log groups and a state machine that sets a retention policy for any log
groups that triggered the rule.

The rule triggers for any log group that is created with a name that starts
with `/aws/lambda/`.

Currently existing log groups created by AWS Lambda are not affected by the
policy. It is also possible that log groups created by means other than AWS
Lambda that have a retention policy specified could have their retention
policy overridden if the log group name starts with `/aws/lambda/`.

> [[Reduce log-storage costs by automating retention settings in Amazon CloudWatch](https://aws.amazon.com/blogs/infrastructure-and-automation/reduce-log-storage-costs-by-automating-retention-settings-in-amazon-cloudwatch/)]([Reduce log-storage costs by automating retention settings in Amazon CloudWatch](https://aws.amazon.com/blogs/infrastructure-and-automation/reduce-log-storage-costs-by-automating-retention-settings-in-amazon-cloudwatch/))

#### Initializers <a name="Initializers" id="cdk-extensions.lambda.LogRetentionController.Initializer"></a>

```typescript
import { lambda } from 'cdk-extensions'

new lambda.LogRetentionController(scope: IConstruct, id: string, props?: LogRetentionControllerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.lambda.LogRetentionControllerProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.lambda.LogRetentionController.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.lambda.LogRetentionController.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.lambda.LogRetentionController.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.lambda.LogRetentionControllerProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.lambda.LogRetentionController.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.lambda.LogRetentionController.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.lambda.LogRetentionController.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.lambda.LogRetentionController.isConstruct"></a>

```typescript
import { lambda } from 'cdk-extensions'

lambda.LogRetentionController.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.lambda.LogRetentionController.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.lambda.LogRetentionController.isOwnedResource"></a>

```typescript
import { lambda } from 'cdk-extensions'

lambda.LogRetentionController.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.lambda.LogRetentionController.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.lambda.LogRetentionController.isResource"></a>

```typescript
import { lambda } from 'cdk-extensions'

lambda.LogRetentionController.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.lambda.LogRetentionController.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.property.logGroupCreatedRule">logGroupCreatedRule</a></code> | <code>aws-cdk-lib.aws_events.Rule</code> | The EventBridge rule that detects the creation of new log groups with a name matching the prefix used by AWS Lambda. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.property.retention">retention</a></code> | <code>aws-cdk-lib.aws_logs.RetentionDays</code> | The length of time logs sent to log groups created by AWS Lambda should be retained before being deleted. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.property.stateMachine">stateMachine</a></code> | <code>aws-cdk-lib.aws_stepfunctions.StateMachine</code> | The state machine that is triggered to add a retention policy for all new log groups that trigger the EventBridge rule. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.property.executionLogging">executionLogging</a></code> | <code>cdk-extensions.lambda.ExecutionLogOptions</code> | Execution logging configuration for the state machine that is used to configure log retention for log groups created via AWS Lambda. |
| <code><a href="#cdk-extensions.lambda.LogRetentionController.property.executionLogGroup">executionLogGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | The log group which will receive execution events from the state machine. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.lambda.LogRetentionController.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.lambda.LogRetentionController.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.lambda.LogRetentionController.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `logGroupCreatedRule`<sup>Required</sup> <a name="logGroupCreatedRule" id="cdk-extensions.lambda.LogRetentionController.property.logGroupCreatedRule"></a>

```typescript
public readonly logGroupCreatedRule: Rule;
```

- *Type:* aws-cdk-lib.aws_events.Rule

The EventBridge rule that detects the creation of new log groups with a name matching the prefix used by AWS Lambda.

---

##### `retention`<sup>Required</sup> <a name="retention" id="cdk-extensions.lambda.LogRetentionController.property.retention"></a>

```typescript
public readonly retention: RetentionDays;
```

- *Type:* aws-cdk-lib.aws_logs.RetentionDays

The length of time logs sent to log groups created by AWS Lambda should be retained before being deleted.

> [[LogGroup RetentionInDays](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-logs-loggroup.html#cfn-logs-loggroup-retentionindays)]([LogGroup RetentionInDays](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-logs-loggroup.html#cfn-logs-loggroup-retentionindays))

---

##### `stateMachine`<sup>Required</sup> <a name="stateMachine" id="cdk-extensions.lambda.LogRetentionController.property.stateMachine"></a>

```typescript
public readonly stateMachine: StateMachine;
```

- *Type:* aws-cdk-lib.aws_stepfunctions.StateMachine

The state machine that is triggered to add a retention policy for all new log groups that trigger the EventBridge rule.

---

##### `executionLogging`<sup>Optional</sup> <a name="executionLogging" id="cdk-extensions.lambda.LogRetentionController.property.executionLogging"></a>

```typescript
public readonly executionLogging: ExecutionLogOptions;
```

- *Type:* cdk-extensions.lambda.ExecutionLogOptions

Execution logging configuration for the state machine that is used to configure log retention for log groups created via AWS Lambda.

> [[StateMachine LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-stepfunctions-statemachine.html#cfn-stepfunctions-statemachine-loggingconfiguration)]([StateMachine LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-stepfunctions-statemachine.html#cfn-stepfunctions-statemachine-loggingconfiguration))

---

##### `executionLogGroup`<sup>Optional</sup> <a name="executionLogGroup" id="cdk-extensions.lambda.LogRetentionController.property.executionLogGroup"></a>

```typescript
public readonly executionLogGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The log group which will receive execution events from the state machine.

---


### NamedQuery <a name="NamedQuery" id="cdk-extensions.athena.NamedQuery"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.athena.NamedQuery.Initializer"></a>

```typescript
import { athena } from 'cdk-extensions'

new athena.NamedQuery(scope: Construct, id: string, props: NamedQueryProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.athena.NamedQuery.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.athena.NamedQuery.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.athena.NamedQuery.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.athena.NamedQueryProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.athena.NamedQuery.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.athena.NamedQuery.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.athena.NamedQuery.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.athena.NamedQueryProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.athena.NamedQuery.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.athena.NamedQuery.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.athena.NamedQuery.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.athena.NamedQuery.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.athena.NamedQuery.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.athena.NamedQuery.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.athena.NamedQuery.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.athena.NamedQuery.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.athena.NamedQuery.isConstruct"></a>

```typescript
import { athena } from 'cdk-extensions'

athena.NamedQuery.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.athena.NamedQuery.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.athena.NamedQuery.isOwnedResource"></a>

```typescript
import { athena } from 'cdk-extensions'

athena.NamedQuery.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.athena.NamedQuery.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.athena.NamedQuery.isResource"></a>

```typescript
import { athena } from 'cdk-extensions'

athena.NamedQuery.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.athena.NamedQuery.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | The Glue database to which the query belongs. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.namedQueryId">namedQueryId</a></code> | <code>string</code> | The unique ID of the query. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.namedQueryName">namedQueryName</a></code> | <code>string</code> | The name of the query. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.queryString">queryString</a></code> | <code>string</code> | The SQL statements that make up the query. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_athena.CfnNamedQuery</code> | The underlying NamedQuery CloudFormation resource. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.description">description</a></code> | <code>string</code> | A human friendly description explaining the functionality of the query. |
| <code><a href="#cdk-extensions.athena.NamedQuery.property.name">name</a></code> | <code>string</code> | The name of the query. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.athena.NamedQuery.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.athena.NamedQuery.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.athena.NamedQuery.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.athena.NamedQuery.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

The Glue database to which the query belongs.

> [[NamedQuery Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-database)]([NamedQuery Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-database))

---

##### `namedQueryId`<sup>Required</sup> <a name="namedQueryId" id="cdk-extensions.athena.NamedQuery.property.namedQueryId"></a>

```typescript
public readonly namedQueryId: string;
```

- *Type:* string

The unique ID of the query.

---

##### `namedQueryName`<sup>Required</sup> <a name="namedQueryName" id="cdk-extensions.athena.NamedQuery.property.namedQueryName"></a>

```typescript
public readonly namedQueryName: string;
```

- *Type:* string

The name of the query.

---

##### `queryString`<sup>Required</sup> <a name="queryString" id="cdk-extensions.athena.NamedQuery.property.queryString"></a>

```typescript
public readonly queryString: string;
```

- *Type:* string

The SQL statements that make up the query.

> [[Athena SQL reference](https://docs.aws.amazon.com/athena/latest/ug/ddl-sql-reference.html)]([Athena SQL reference](https://docs.aws.amazon.com/athena/latest/ug/ddl-sql-reference.html))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.athena.NamedQuery.property.resource"></a>

```typescript
public readonly resource: CfnNamedQuery;
```

- *Type:* aws-cdk-lib.aws_athena.CfnNamedQuery

The underlying NamedQuery CloudFormation resource.

> [[AWS::Athena::NamedQuery](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html)]([AWS::Athena::NamedQuery](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.athena.NamedQuery.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A human friendly description explaining the functionality of the query.

> [[NamedQuery Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-description)]([NamedQuery Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-description))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.athena.NamedQuery.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the query.

> [[NamedQuery Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-name)]([NamedQuery Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-name))

---


### NetworkController <a name="NetworkController" id="cdk-extensions.ec2_patterns.NetworkController"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2_patterns.NetworkController.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

new ec2_patterns.NetworkController(scope: IConstruct, id: string, props?: NetworkControllerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2_patterns.NetworkControllerProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.NetworkController.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.NetworkController.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2_patterns.NetworkController.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2_patterns.NetworkControllerProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.addHub">addHub</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.addSpoke">addSpoke</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2_patterns.NetworkController.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2_patterns.NetworkController.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2_patterns.NetworkController.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addHub` <a name="addHub" id="cdk-extensions.ec2_patterns.NetworkController.addHub"></a>

```typescript
public addHub(scope: IConstruct, id: string, options?: AddNetworkOptions): FourTierNetworkHub
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.NetworkController.addHub.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.NetworkController.addHub.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.NetworkController.addHub.parameter.options"></a>

- *Type:* cdk-extensions.ec2_patterns.AddNetworkOptions

---

##### `addSpoke` <a name="addSpoke" id="cdk-extensions.ec2_patterns.NetworkController.addSpoke"></a>

```typescript
public addSpoke(scope: IConstruct, id: string, options?: AddNetworkOptions): FourTierNetworkSpoke
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2_patterns.NetworkController.addSpoke.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2_patterns.NetworkController.addSpoke.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2_patterns.NetworkController.addSpoke.parameter.options"></a>

- *Type:* cdk-extensions.ec2_patterns.AddNetworkOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2_patterns.NetworkController.isConstruct"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.NetworkController.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2_patterns.NetworkController.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2_patterns.NetworkController.isOwnedResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.NetworkController.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.NetworkController.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2_patterns.NetworkController.isResource"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

ec2_patterns.NetworkController.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2_patterns.NetworkController.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.property.addressManager">addressManager</a></code> | <code>cdk-extensions.ec2_patterns.IpAddressManager</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.property.defaultNetmask">defaultNetmask</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.property.globalNetwork">globalNetwork</a></code> | <code>cdk-extensions.networkmanager.GlobalNetwork</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.property.registeredAccounts">registeredAccounts</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkController.property.registeredRegions">registeredRegions</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2_patterns.NetworkController.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2_patterns.NetworkController.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2_patterns.NetworkController.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `addressManager`<sup>Required</sup> <a name="addressManager" id="cdk-extensions.ec2_patterns.NetworkController.property.addressManager"></a>

```typescript
public readonly addressManager: IpAddressManager;
```

- *Type:* cdk-extensions.ec2_patterns.IpAddressManager

---

##### `defaultNetmask`<sup>Required</sup> <a name="defaultNetmask" id="cdk-extensions.ec2_patterns.NetworkController.property.defaultNetmask"></a>

```typescript
public readonly defaultNetmask: number;
```

- *Type:* number

---

##### `globalNetwork`<sup>Required</sup> <a name="globalNetwork" id="cdk-extensions.ec2_patterns.NetworkController.property.globalNetwork"></a>

```typescript
public readonly globalNetwork: GlobalNetwork;
```

- *Type:* cdk-extensions.networkmanager.GlobalNetwork

---

##### `registeredAccounts`<sup>Required</sup> <a name="registeredAccounts" id="cdk-extensions.ec2_patterns.NetworkController.property.registeredAccounts"></a>

```typescript
public readonly registeredAccounts: string[];
```

- *Type:* string[]

---

##### `registeredRegions`<sup>Required</sup> <a name="registeredRegions" id="cdk-extensions.ec2_patterns.NetworkController.property.registeredRegions"></a>

```typescript
public readonly registeredRegions: string[];
```

- *Type:* string[]

---


### PermissionSet <a name="PermissionSet" id="cdk-extensions.sso.PermissionSet"></a>

- *Implements:* cdk-extensions.sso.IPermissionSet

Specifies a permission set within a specified IAM Identity Center instance.

#### Initializers <a name="Initializers" id="cdk-extensions.sso.PermissionSet.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.PermissionSet(scope: Construct, id: string, props: PermissionSetProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.PermissionSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.sso.PermissionSet.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.sso.PermissionSet.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.sso.PermissionSetProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.PermissionSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.PermissionSet.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.sso.PermissionSet.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.sso.PermissionSetProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.PermissionSet.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.sso.PermissionSet.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.sso.PermissionSet.addCustomerManagedPolicy">addCustomerManagedPolicy</a></code> | Adds a custom managed policy to the permission set. |
| <code><a href="#cdk-extensions.sso.PermissionSet.addManagedPolicy">addManagedPolicy</a></code> | Adds a new Managed Policy to the permission set. |
| <code><a href="#cdk-extensions.sso.PermissionSet.addToPrincipalPolicy">addToPrincipalPolicy</a></code> | Adds a permission to the permission set's default policy document. |

---

##### `toString` <a name="toString" id="cdk-extensions.sso.PermissionSet.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.sso.PermissionSet.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.PermissionSet.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addCustomerManagedPolicy` <a name="addCustomerManagedPolicy" id="cdk-extensions.sso.PermissionSet.addCustomerManagedPolicy"></a>

```typescript
public addCustomerManagedPolicy(options: ReferenceOptions): ReferencedManagedPolicy
```

Adds a custom managed policy to the permission set.

When using customer
managed policies it is required that a managed policy with a matching
name and path exist in any AWS account for which the permission set
will be assigned.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.sso.PermissionSet.addCustomerManagedPolicy.parameter.options"></a>

- *Type:* cdk-extensions.sso.ReferenceOptions

The configuration for the customer managed policy.

---

##### `addManagedPolicy` <a name="addManagedPolicy" id="cdk-extensions.sso.PermissionSet.addManagedPolicy"></a>

```typescript
public addManagedPolicy(policy: IManagedPolicy): PermissionSet
```

Adds a new Managed Policy to the permission set.

Only Managed Policies
created and maintained by AWS are supported. To add a custom Managed
Policy that you control use the {@link addCustomerManagedPolicy} method.

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.PermissionSet.addManagedPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.aws_iam.IManagedPolicy

The AWS Managed Policy to associate with the Permission Set.

---

##### `addToPrincipalPolicy` <a name="addToPrincipalPolicy" id="cdk-extensions.sso.PermissionSet.addToPrincipalPolicy"></a>

```typescript
public addToPrincipalPolicy(statement: PolicyStatement): AddToPrincipalPolicyResult
```

Adds a permission to the permission set's default policy document.

If there is no default policy attached to this permission set, it will be created.

###### `statement`<sup>Required</sup> <a name="statement" id="cdk-extensions.sso.PermissionSet.addToPrincipalPolicy.parameter.statement"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

The permission statement to add to the policy document.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.PermissionSet.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.sso.PermissionSet.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.sso.PermissionSet.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.sso.PermissionSet.fromArn">fromArn</a></code> | *No description.* |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.sso.PermissionSet.isConstruct"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.PermissionSet.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.sso.PermissionSet.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.sso.PermissionSet.isOwnedResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.PermissionSet.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.PermissionSet.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.sso.PermissionSet.isResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.PermissionSet.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.PermissionSet.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromArn` <a name="fromArn" id="cdk-extensions.sso.PermissionSet.fromArn"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.PermissionSet.fromArn(scope: Construct, id: string, arn: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.PermissionSet.fromArn.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.PermissionSet.fromArn.parameter.id"></a>

- *Type:* string

---

###### `arn`<sup>Required</sup> <a name="arn" id="cdk-extensions.sso.PermissionSet.fromArn.parameter.arn"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.instance">instance</a></code> | <code>cdk-extensions.sso.IInstance</code> | The ARN of the IAM Identity Center instance under which the operation will be executed. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.permissionSetArn">permissionSetArn</a></code> | <code>string</code> | The permission set ARN of the permission set, such as `arn:aws:sso:::permissionSet/ins-instanceid/ps-permissionsetid`. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_sso.CfnPermissionSet</code> | The underlying PermissionSet CloudFormation resource. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.description">description</a></code> | <code>string</code> | A user friendly description providing details about the permission set. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.name">name</a></code> | <code>string</code> | The name of the permission set. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.permissionsBoundary">permissionsBoundary</a></code> | <code>cdk-extensions.sso.PermissionsBoundary</code> | Specifies the configuration of the AWS managed or customer managed policy that you want to set as a permissions boundary. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.relayState">relayState</a></code> | <code>string</code> | Used to redirect users within the application during the federation authentication process. |
| <code><a href="#cdk-extensions.sso.PermissionSet.property.sessionDuration">sessionDuration</a></code> | <code>aws-cdk-lib.Duration</code> | The length of time that the application user sessions are valid for. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.sso.PermissionSet.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.sso.PermissionSet.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.sso.PermissionSet.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk-extensions.sso.PermissionSet.property.instance"></a>

```typescript
public readonly instance: IInstance;
```

- *Type:* cdk-extensions.sso.IInstance

The ARN of the IAM Identity Center instance under which the operation will be executed.

---

##### `permissionSetArn`<sup>Required</sup> <a name="permissionSetArn" id="cdk-extensions.sso.PermissionSet.property.permissionSetArn"></a>

```typescript
public readonly permissionSetArn: string;
```

- *Type:* string

The permission set ARN of the permission set, such as `arn:aws:sso:::permissionSet/ins-instanceid/ps-permissionsetid`.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.sso.PermissionSet.property.resource"></a>

```typescript
public readonly resource: CfnPermissionSet;
```

- *Type:* aws-cdk-lib.aws_sso.CfnPermissionSet

The underlying PermissionSet CloudFormation resource.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.sso.PermissionSet.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A user friendly description providing details about the permission set.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.sso.PermissionSet.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the permission set.

---

##### `permissionsBoundary`<sup>Optional</sup> <a name="permissionsBoundary" id="cdk-extensions.sso.PermissionSet.property.permissionsBoundary"></a>

```typescript
public readonly permissionsBoundary: PermissionsBoundary;
```

- *Type:* cdk-extensions.sso.PermissionsBoundary

Specifies the configuration of the AWS managed or customer managed policy that you want to set as a permissions boundary.

Specify either
CustomerManagedPolicyReference to use the name and path of a customer
managed policy, or ManagedPolicyArn to use the ARN of an AWS managed
policy. A permissions boundary represents the maximum permissions that
any policy can grant your role. For more information, see [Permissions
boundaries](https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_boundaries.html) for IAM entities in the AWS Identity and Access Management
User Guide.

---

##### `relayState`<sup>Optional</sup> <a name="relayState" id="cdk-extensions.sso.PermissionSet.property.relayState"></a>

```typescript
public readonly relayState: string;
```

- *Type:* string

Used to redirect users within the application during the federation authentication process.

For example, you can redirect users to a
specific page that is most applicable to their job after singing in to
an AWS account.

---

##### `sessionDuration`<sup>Optional</sup> <a name="sessionDuration" id="cdk-extensions.sso.PermissionSet.property.sessionDuration"></a>

```typescript
public readonly sessionDuration: Duration;
```

- *Type:* aws-cdk-lib.Duration

The length of time that the application user sessions are valid for.

---


### Prometheus <a name="Prometheus" id="cdk-extensions.k8s_fargate.Prometheus"></a>

Deploys Prometheus into EKS.

The service is run in Fargate and writes data to Amazon Managed Service for
Prometheus which provides the backing data store.

> [[Official Helm chart documentation](https://github.com/prometheus-community/helm-charts/tree/main/charts/prometheus#readme)]([Official Helm chart documentation](https://github.com/prometheus-community/helm-charts/tree/main/charts/prometheus#readme))

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_fargate.Prometheus.Initializer"></a>

```typescript
import { k8s_fargate } from 'cdk-extensions'

new k8s_fargate.Prometheus(scope: IConstruct, id: string, props: PrometheusProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_fargate.PrometheusProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_fargate.Prometheus.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_fargate.Prometheus.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_fargate.Prometheus.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_fargate.PrometheusProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_fargate.Prometheus.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_fargate.Prometheus.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_fargate.Prometheus.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_fargate.Prometheus.isConstruct"></a>

```typescript
import { k8s_fargate } from 'cdk-extensions'

k8s_fargate.Prometheus.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_fargate.Prometheus.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_fargate.Prometheus.isOwnedResource"></a>

```typescript
import { k8s_fargate } from 'cdk-extensions'

k8s_fargate.Prometheus.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_fargate.Prometheus.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_fargate.Prometheus.isResource"></a>

```typescript
import { k8s_fargate } from 'cdk-extensions'

k8s_fargate.Prometheus.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_fargate.Prometheus.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.chart">chart</a></code> | <code>aws-cdk-lib.aws_eks.HelmChart</code> | The Helm chart that was used to deploy Prometheus. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.Cluster</code> | {@inheritdoc PrometheusProps.cluster}. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.fargateProfile">fargateProfile</a></code> | <code>aws-cdk-lib.aws_eks.FargateProfile</code> | The Fargate profile used for running the service in Fargate. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.namespace">namespace</a></code> | <code>string</code> | {@inheritdoc PrometheusOptions.namespace}. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.serviceAccount">serviceAccount</a></code> | <code>aws-cdk-lib.aws_eks.ServiceAccount</code> | The service account that Prometheus will use to gain permissions for Kubernetes and AWS. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.serviceAccountName">serviceAccountName</a></code> | <code>string</code> | {@inheritdoc PrometheusOptions.serviceAccountName}. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.workspace">workspace</a></code> | <code>cdk-extensions.aps.IWorkspace</code> | {@inheritdoc PrometheusProps.workspace}. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.queueConfiguration">queueConfiguration</a></code> | <code>cdk-extensions.k8s_fargate.QueueConfiguration</code> | {@inheritdoc PropmetheusOptions.queueConfiguration}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_fargate.Prometheus.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_fargate.Prometheus.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_fargate.Prometheus.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk-extensions.k8s_fargate.Prometheus.property.chart"></a>

```typescript
public readonly chart: HelmChart;
```

- *Type:* aws-cdk-lib.aws_eks.HelmChart

The Helm chart that was used to deploy Prometheus.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_fargate.Prometheus.property.cluster"></a>

```typescript
public readonly cluster: Cluster;
```

- *Type:* aws-cdk-lib.aws_eks.Cluster

{@inheritdoc PrometheusProps.cluster}.

---

##### `fargateProfile`<sup>Required</sup> <a name="fargateProfile" id="cdk-extensions.k8s_fargate.Prometheus.property.fargateProfile"></a>

```typescript
public readonly fargateProfile: FargateProfile;
```

- *Type:* aws-cdk-lib.aws_eks.FargateProfile

The Fargate profile used for running the service in Fargate.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk-extensions.k8s_fargate.Prometheus.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

{@inheritdoc PrometheusOptions.namespace}.

---

##### `serviceAccount`<sup>Required</sup> <a name="serviceAccount" id="cdk-extensions.k8s_fargate.Prometheus.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: ServiceAccount;
```

- *Type:* aws-cdk-lib.aws_eks.ServiceAccount

The service account that Prometheus will use to gain permissions for Kubernetes and AWS.

---

##### `serviceAccountName`<sup>Required</sup> <a name="serviceAccountName" id="cdk-extensions.k8s_fargate.Prometheus.property.serviceAccountName"></a>

```typescript
public readonly serviceAccountName: string;
```

- *Type:* string

{@inheritdoc PrometheusOptions.serviceAccountName}.

---

##### `workspace`<sup>Required</sup> <a name="workspace" id="cdk-extensions.k8s_fargate.Prometheus.property.workspace"></a>

```typescript
public readonly workspace: IWorkspace;
```

- *Type:* cdk-extensions.aps.IWorkspace

{@inheritdoc PrometheusProps.workspace}.

---

##### `queueConfiguration`<sup>Optional</sup> <a name="queueConfiguration" id="cdk-extensions.k8s_fargate.Prometheus.property.queueConfiguration"></a>

```typescript
public readonly queueConfiguration: QueueConfiguration;
```

- *Type:* cdk-extensions.k8s_fargate.QueueConfiguration

{@inheritdoc PropmetheusOptions.queueConfiguration}.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.CHART_NAME">CHART_NAME</a></code> | <code>string</code> | The name of the Prometheus Helm chart. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.CHART_REPOSITORY">CHART_REPOSITORY</a></code> | <code>string</code> | The Helm repository providing the chart to be used for installing the Prometheus service. |
| <code><a href="#cdk-extensions.k8s_fargate.Prometheus.property.DEFAULT_NAMESPACE">DEFAULT_NAMESPACE</a></code> | <code>string</code> | The default Kubernetes namespace where Prometheus will be installed if an alternative isn't given as input. |

---

##### `CHART_NAME`<sup>Required</sup> <a name="CHART_NAME" id="cdk-extensions.k8s_fargate.Prometheus.property.CHART_NAME"></a>

```typescript
public readonly CHART_NAME: string;
```

- *Type:* string

The name of the Prometheus Helm chart.

---

##### `CHART_REPOSITORY`<sup>Required</sup> <a name="CHART_REPOSITORY" id="cdk-extensions.k8s_fargate.Prometheus.property.CHART_REPOSITORY"></a>

```typescript
public readonly CHART_REPOSITORY: string;
```

- *Type:* string

The Helm repository providing the chart to be used for installing the Prometheus service.

---

##### `DEFAULT_NAMESPACE`<sup>Required</sup> <a name="DEFAULT_NAMESPACE" id="cdk-extensions.k8s_fargate.Prometheus.property.DEFAULT_NAMESPACE"></a>

```typescript
public readonly DEFAULT_NAMESPACE: string;
```

- *Type:* string

The default Kubernetes namespace where Prometheus will be installed if an alternative isn't given as input.

---

### RawBucket <a name="RawBucket" id="cdk-extensions.s3_buckets.RawBucket"></a>

- *Implements:* aws-cdk-lib.aws_s3.IBucket

Do not use directly.

Will be removed once a better replacemnt is written.

#### Initializers <a name="Initializers" id="cdk-extensions.s3_buckets.RawBucket.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

new s3_buckets.RawBucket(scope: Construct, id: string, props?: RawBucketProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.s3_buckets.RawBucketProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.RawBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.s3_buckets.RawBucket.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.s3_buckets.RawBucket.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.s3_buckets.RawBucketProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.addEventNotification">addEventNotification</a></code> | Adds a bucket notification event destination. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.addObjectCreatedNotification">addObjectCreatedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 created in the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.addObjectRemovedNotification">addObjectRemovedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 removed from the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.addToResourcePolicy">addToResourcePolicy</a></code> | Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.arnForObjects">arnForObjects</a></code> | Returns an ARN that represents all objects within the bucket that match
 the key pattern specified. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.enableEventBridgeNotification">enableEventBridgeNotification</a></code> | Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.grantDelete">grantDelete</a></code> | Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.grantPublicAccess">grantPublicAccess</a></code> | Allows unrestricted access to objects from this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.grantPut">grantPut</a></code> | Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.grantPutAcl">grantPutAcl</a></code> | Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.grantRead">grantRead</a></code> | Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.grantReadWrite">grantReadWrite</a></code> | Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.grantWrite">grantWrite</a></code> | Grant write permissions to this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.onCloudTrailEvent">onCloudTrailEvent</a></code> | Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.onCloudTrailPutObject">onCloudTrailPutObject</a></code> | Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.onCloudTrailWriteObject">onCloudTrailWriteObject</a></code> | Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.s3UrlForObject">s3UrlForObject</a></code> | The S3 URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.transferAccelerationUrlForObject">transferAccelerationUrlForObject</a></code> | The https Transfer Acceleration URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.urlForObject">urlForObject</a></code> | The https URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.virtualHostedUrlForObject">virtualHostedUrlForObject</a></code> | The virtual hosted-style URL of an S3 object. |

---

##### `toString` <a name="toString" id="cdk-extensions.s3_buckets.RawBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.s3_buckets.RawBucket.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.s3_buckets.RawBucket.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addEventNotification` <a name="addEventNotification" id="cdk-extensions.s3_buckets.RawBucket.addEventNotification"></a>

```typescript
public addEventNotification(_event: EventType, _dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Adds a bucket notification event destination.

###### `_event`<sup>Required</sup> <a name="_event" id="cdk-extensions.s3_buckets.RawBucket.addEventNotification.parameter._event"></a>

- *Type:* aws-cdk-lib.aws_s3.EventType

---

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.RawBucket.addEventNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.RawBucket.addEventNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectCreatedNotification` <a name="addObjectCreatedNotification" id="cdk-extensions.s3_buckets.RawBucket.addObjectCreatedNotification"></a>

```typescript
public addObjectCreatedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 created in the bucket.

This is identical to calling
`onEvent(s3.EventType.OBJECT_CREATED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.RawBucket.addObjectCreatedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.RawBucket.addObjectCreatedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectRemovedNotification` <a name="addObjectRemovedNotification" id="cdk-extensions.s3_buckets.RawBucket.addObjectRemovedNotification"></a>

```typescript
public addObjectRemovedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 removed from the bucket.

This is identical to calling
`onEvent(EventType.OBJECT_REMOVED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.RawBucket.addObjectRemovedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.RawBucket.addObjectRemovedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addToResourcePolicy` <a name="addToResourcePolicy" id="cdk-extensions.s3_buckets.RawBucket.addToResourcePolicy"></a>

```typescript
public addToResourcePolicy(permission: PolicyStatement): AddToResourcePolicyResult
```

Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases.

###### `permission`<sup>Required</sup> <a name="permission" id="cdk-extensions.s3_buckets.RawBucket.addToResourcePolicy.parameter.permission"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `arnForObjects` <a name="arnForObjects" id="cdk-extensions.s3_buckets.RawBucket.arnForObjects"></a>

```typescript
public arnForObjects(_keyPattern: string): string
```

Returns an ARN that represents all objects within the bucket that match
 the key pattern specified.

To represent all keys, specify ``"*"``.

###### `_keyPattern`<sup>Required</sup> <a name="_keyPattern" id="cdk-extensions.s3_buckets.RawBucket.arnForObjects.parameter._keyPattern"></a>

- *Type:* string

---

##### `enableEventBridgeNotification` <a name="enableEventBridgeNotification" id="cdk-extensions.s3_buckets.RawBucket.enableEventBridgeNotification"></a>

```typescript
public enableEventBridgeNotification(): void
```

Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted.

##### `grantDelete` <a name="grantDelete" id="cdk-extensions.s3_buckets.RawBucket.grantDelete"></a>

```typescript
public grantDelete(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.RawBucket.grantDelete.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.RawBucket.grantDelete.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPublicAccess` <a name="grantPublicAccess" id="cdk-extensions.s3_buckets.RawBucket.grantPublicAccess"></a>

```typescript
public grantPublicAccess(_allowedActions: string, _keyPrefix?: string): Grant
```

Allows unrestricted access to objects from this bucket.

IMPORTANT: This permission allows anyone to perform actions on S3 objects
in this bucket, which is useful for when you configure your bucket as a
website and want everyone to be able to read objects in the bucket without
needing to authenticate.

Without arguments, this method will grant read ("s3:GetObject") access to
all objects ("*") in the bucket.

The method returns the `iam.Grant` object, which can then be modified
as needed. For example, you can add a condition that will restrict access only
to an IPv4 range like this:

     const grant = bucket.grantPublicAccess();
     grant.resourceStatement!.addCondition(‘IpAddress’, { “aws:SourceIp”: “54.240.143.0/24” });

###### `_allowedActions`<sup>Required</sup> <a name="_allowedActions" id="cdk-extensions.s3_buckets.RawBucket.grantPublicAccess.parameter._allowedActions"></a>

- *Type:* string

---

###### `_keyPrefix`<sup>Optional</sup> <a name="_keyPrefix" id="cdk-extensions.s3_buckets.RawBucket.grantPublicAccess.parameter._keyPrefix"></a>

- *Type:* string

---

##### `grantPut` <a name="grantPut" id="cdk-extensions.s3_buckets.RawBucket.grantPut"></a>

```typescript
public grantPut(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.RawBucket.grantPut.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.RawBucket.grantPut.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPutAcl` <a name="grantPutAcl" id="cdk-extensions.s3_buckets.RawBucket.grantPutAcl"></a>

```typescript
public grantPutAcl(_identity: IGrantable, _objectsKeyPattern?: string): Grant
```

Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket.

If your application has the '@aws-cdk/aws-s3:grantWriteWithoutAcl' feature flag set,
calling `grantWrite` or `grantReadWrite` no longer grants permissions to modify the ACLs of the objects;
in this case, if you need to modify object ACLs, call this method explicitly.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.RawBucket.grantPutAcl.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.RawBucket.grantPutAcl.parameter._objectsKeyPattern"></a>

- *Type:* string

---

##### `grantRead` <a name="grantRead" id="cdk-extensions.s3_buckets.RawBucket.grantRead"></a>

```typescript
public grantRead(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If encryption is used, permission to use the key to decrypt the contents
of the bucket will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.RawBucket.grantRead.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.RawBucket.grantRead.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk-extensions.s3_buckets.RawBucket.grantReadWrite"></a>

```typescript
public grantReadWrite(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If an encryption key is used, permission to use the key for
encrypt/decrypt will also be granted.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.RawBucket.grantReadWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.RawBucket.grantReadWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantWrite` <a name="grantWrite" id="cdk-extensions.s3_buckets.RawBucket.grantWrite"></a>

```typescript
public grantWrite(_identity: IGrantable, _objectsKeyPattern?: any, _allowedActionPatterns?: string[]): Grant
```

Grant write permissions to this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.RawBucket.grantWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.RawBucket.grantWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

###### `_allowedActionPatterns`<sup>Optional</sup> <a name="_allowedActionPatterns" id="cdk-extensions.s3_buckets.RawBucket.grantWrite.parameter._allowedActionPatterns"></a>

- *Type:* string[]

---

##### `onCloudTrailEvent` <a name="onCloudTrailEvent" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailEvent"></a>

```typescript
public onCloudTrailEvent(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event.

This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailEvent.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailEvent.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailPutObject` <a name="onCloudTrailPutObject" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailPutObject"></a>

```typescript
public onCloudTrailPutObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using `onCloudTrailWriteObject` may be preferable.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailPutObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailPutObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailWriteObject` <a name="onCloudTrailWriteObject" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailWriteObject"></a>

```typescript
public onCloudTrailWriteObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to.

This includes
the events PutObject, CopyObject, and CompleteMultipartUpload.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using this method may be preferable to `onCloudTrailPutObject`.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailWriteObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.RawBucket.onCloudTrailWriteObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `s3UrlForObject` <a name="s3UrlForObject" id="cdk-extensions.s3_buckets.RawBucket.s3UrlForObject"></a>

```typescript
public s3UrlForObject(_key?: string): string
```

The S3 URL of an S3 object.

For example:
- `s3://onlybucket`
- `s3://bucket/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.RawBucket.s3UrlForObject.parameter._key"></a>

- *Type:* string

---

##### `transferAccelerationUrlForObject` <a name="transferAccelerationUrlForObject" id="cdk-extensions.s3_buckets.RawBucket.transferAccelerationUrlForObject"></a>

```typescript
public transferAccelerationUrlForObject(_key?: string, _options?: TransferAccelerationUrlOptions): string
```

The https Transfer Acceleration URL of an S3 object.

Specify `dualStack: true` at the options
for dual-stack endpoint (connect to the bucket over IPv6). For example:

- `https://bucket.s3-accelerate.amazonaws.com`
- `https://bucket.s3-accelerate.amazonaws.com/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.RawBucket.transferAccelerationUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.RawBucket.transferAccelerationUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.TransferAccelerationUrlOptions

---

##### `urlForObject` <a name="urlForObject" id="cdk-extensions.s3_buckets.RawBucket.urlForObject"></a>

```typescript
public urlForObject(_key?: string): string
```

The https URL of an S3 object.

For example:

- `https://s3.us-west-1.amazonaws.com/onlybucket`
- `https://s3.us-west-1.amazonaws.com/bucket/key`
- `https://s3.cn-north-1.amazonaws.com.cn/china-bucket/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.RawBucket.urlForObject.parameter._key"></a>

- *Type:* string

---

##### `virtualHostedUrlForObject` <a name="virtualHostedUrlForObject" id="cdk-extensions.s3_buckets.RawBucket.virtualHostedUrlForObject"></a>

```typescript
public virtualHostedUrlForObject(_key?: string, _options?: VirtualHostedStyleUrlOptions): string
```

The virtual hosted-style URL of an S3 object.

Specify `regional: false` at
the options for non-regional URL. For example:

- `https://only-bucket.s3.us-west-1.amazonaws.com`
- `https://bucket.s3.us-west-1.amazonaws.com/key`
- `https://bucket.s3.amazonaws.com/key`
- `https://china-bucket.s3.cn-north-1.amazonaws.com.cn/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.RawBucket.virtualHostedUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.RawBucket.virtualHostedUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.VirtualHostedStyleUrlOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.s3_buckets.RawBucket.isConstruct"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.RawBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.s3_buckets.RawBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.s3_buckets.RawBucket.isOwnedResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.RawBucket.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.RawBucket.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.s3_buckets.RawBucket.isResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.RawBucket.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.RawBucket.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.bucketArn">bucketArn</a></code> | <code>string</code> | The ARN of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | The IPv4 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.bucketDualStackDomainName">bucketDualStackDomainName</a></code> | <code>string</code> | The IPv6 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.bucketName">bucketName</a></code> | <code>string</code> | The name of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.bucketRegionalDomainName">bucketRegionalDomainName</a></code> | <code>string</code> | The regional domain name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.bucketWebsiteDomainName">bucketWebsiteDomainName</a></code> | <code>string</code> | The Domain name of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.bucketWebsiteUrl">bucketWebsiteUrl</a></code> | <code>string</code> | The URL of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_s3.CfnBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | Optional KMS encryption key associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.isWebsite">isWebsite</a></code> | <code>boolean</code> | If this bucket has been configured for static website hosting. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucket.property.policy">policy</a></code> | <code>aws-cdk-lib.aws_s3.BucketPolicy</code> | The resource policy associated with this bucket. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.s3_buckets.RawBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.s3_buckets.RawBucket.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.s3_buckets.RawBucket.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bucketArn`<sup>Required</sup> <a name="bucketArn" id="cdk-extensions.s3_buckets.RawBucket.property.bucketArn"></a>

```typescript
public readonly bucketArn: string;
```

- *Type:* string

The ARN of the bucket.

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="cdk-extensions.s3_buckets.RawBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

The IPv4 DNS name of the specified bucket.

---

##### `bucketDualStackDomainName`<sup>Required</sup> <a name="bucketDualStackDomainName" id="cdk-extensions.s3_buckets.RawBucket.property.bucketDualStackDomainName"></a>

```typescript
public readonly bucketDualStackDomainName: string;
```

- *Type:* string

The IPv6 DNS name of the specified bucket.

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.RawBucket.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

The name of the bucket.

---

##### `bucketRegionalDomainName`<sup>Required</sup> <a name="bucketRegionalDomainName" id="cdk-extensions.s3_buckets.RawBucket.property.bucketRegionalDomainName"></a>

```typescript
public readonly bucketRegionalDomainName: string;
```

- *Type:* string

The regional domain name of the specified bucket.

---

##### `bucketWebsiteDomainName`<sup>Required</sup> <a name="bucketWebsiteDomainName" id="cdk-extensions.s3_buckets.RawBucket.property.bucketWebsiteDomainName"></a>

```typescript
public readonly bucketWebsiteDomainName: string;
```

- *Type:* string

The Domain name of the static website.

---

##### `bucketWebsiteUrl`<sup>Required</sup> <a name="bucketWebsiteUrl" id="cdk-extensions.s3_buckets.RawBucket.property.bucketWebsiteUrl"></a>

```typescript
public readonly bucketWebsiteUrl: string;
```

- *Type:* string

The URL of the static website.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.s3_buckets.RawBucket.property.resource"></a>

```typescript
public readonly resource: CfnBucket;
```

- *Type:* aws-cdk-lib.aws_s3.CfnBucket

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.s3_buckets.RawBucket.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

Optional KMS encryption key associated with this bucket.

---

##### `isWebsite`<sup>Optional</sup> <a name="isWebsite" id="cdk-extensions.s3_buckets.RawBucket.property.isWebsite"></a>

```typescript
public readonly isWebsite: boolean;
```

- *Type:* boolean

If this bucket has been configured for static website hosting.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk-extensions.s3_buckets.RawBucket.property.policy"></a>

```typescript
public readonly policy: BucketPolicy;
```

- *Type:* aws-cdk-lib.aws_s3.BucketPolicy

The resource policy associated with this bucket.

If `autoCreatePolicy` is true, a `BucketPolicy` will be created upon the
first call to addToResourcePolicy(s).

---


### ReferencedManagedPolicy <a name="ReferencedManagedPolicy" id="cdk-extensions.sso.ReferencedManagedPolicy"></a>

A managed policy that is referenced via IAM Identity Center.

#### Initializers <a name="Initializers" id="cdk-extensions.sso.ReferencedManagedPolicy.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.ReferencedManagedPolicy(scope: Construct, id: string, props?: ReferencedManagedPolicyProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.sso.ReferencedManagedPolicyProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.ReferencedManagedPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.ReferencedManagedPolicy.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.sso.ReferencedManagedPolicy.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.sso.ReferencedManagedPolicyProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.addStatements">addStatements</a></code> | Adds a statement to the policy document. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.attachToGroup">attachToGroup</a></code> | Attaches this policy to a group. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.attachToRole">attachToRole</a></code> | Attaches this policy to a role. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.attachToUser">attachToUser</a></code> | Attaches this policy to a user. |

---

##### `toString` <a name="toString" id="cdk-extensions.sso.ReferencedManagedPolicy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.sso.ReferencedManagedPolicy.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.ReferencedManagedPolicy.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addStatements` <a name="addStatements" id="cdk-extensions.sso.ReferencedManagedPolicy.addStatements"></a>

```typescript
public addStatements(statement: PolicyStatement): void
```

Adds a statement to the policy document.

###### `statement`<sup>Required</sup> <a name="statement" id="cdk-extensions.sso.ReferencedManagedPolicy.addStatements.parameter.statement"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `attachToGroup` <a name="attachToGroup" id="cdk-extensions.sso.ReferencedManagedPolicy.attachToGroup"></a>

```typescript
public attachToGroup(group: IGroup): void
```

Attaches this policy to a group.

###### `group`<sup>Required</sup> <a name="group" id="cdk-extensions.sso.ReferencedManagedPolicy.attachToGroup.parameter.group"></a>

- *Type:* aws-cdk-lib.aws_iam.IGroup

---

##### `attachToRole` <a name="attachToRole" id="cdk-extensions.sso.ReferencedManagedPolicy.attachToRole"></a>

```typescript
public attachToRole(role: IRole): void
```

Attaches this policy to a role.

###### `role`<sup>Required</sup> <a name="role" id="cdk-extensions.sso.ReferencedManagedPolicy.attachToRole.parameter.role"></a>

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `attachToUser` <a name="attachToUser" id="cdk-extensions.sso.ReferencedManagedPolicy.attachToUser"></a>

```typescript
public attachToUser(user: IUser): void
```

Attaches this policy to a user.

###### `user`<sup>Required</sup> <a name="user" id="cdk-extensions.sso.ReferencedManagedPolicy.attachToUser.parameter.user"></a>

- *Type:* aws-cdk-lib.aws_iam.IUser

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.fromAwsManagedPolicyName">fromAwsManagedPolicyName</a></code> | Import a managed policy from one of the policies that AWS manages. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyArn">fromManagedPolicyArn</a></code> | Import an external managed policy by ARN. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyName">fromManagedPolicyName</a></code> | Import a customer managed policy from the managedPolicyName. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.of">of</a></code> | Dynamically generates a new class that can be used to create a managed policy that matches a reference in IAM Identity Center. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.sso.ReferencedManagedPolicy.isConstruct"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedManagedPolicy.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.sso.ReferencedManagedPolicy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.sso.ReferencedManagedPolicy.isOwnedResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedManagedPolicy.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.ReferencedManagedPolicy.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.sso.ReferencedManagedPolicy.isResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedManagedPolicy.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.ReferencedManagedPolicy.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromAwsManagedPolicyName` <a name="fromAwsManagedPolicyName" id="cdk-extensions.sso.ReferencedManagedPolicy.fromAwsManagedPolicyName"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedManagedPolicy.fromAwsManagedPolicyName(managedPolicyName: string)
```

Import a managed policy from one of the policies that AWS manages.

For this managed policy, you only need to know the name to be able to use it.

Some managed policy names start with "service-role/", some start with
"job-function/", and some don't start with anything. Include the
prefix when constructing this object.

###### `managedPolicyName`<sup>Required</sup> <a name="managedPolicyName" id="cdk-extensions.sso.ReferencedManagedPolicy.fromAwsManagedPolicyName.parameter.managedPolicyName"></a>

- *Type:* string

---

##### `fromManagedPolicyArn` <a name="fromManagedPolicyArn" id="cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyArn"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedManagedPolicy.fromManagedPolicyArn(scope: Construct, id: string, managedPolicyArn: string)
```

Import an external managed policy by ARN.

For this managed policy, you only need to know the ARN to be able to use it.
This can be useful if you got the ARN from a CloudFormation Export.

If the imported Managed Policy ARN is a Token (such as a
`CfnParameter.valueAsString` or a `Fn.importValue()`) *and* the referenced
managed policy has a `path` (like `arn:...:policy/AdminPolicy/AdminAllow`), the
`managedPolicyName` property will not resolve to the correct value. Instead it
will resolve to the first path component. We unfortunately cannot express
the correct calculation of the full path name as a CloudFormation
expression. In this scenario the Managed Policy ARN should be supplied without the
`path` in order to resolve the correct managed policy resource.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyArn.parameter.scope"></a>

- *Type:* constructs.Construct

construct scope.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyArn.parameter.id"></a>

- *Type:* string

construct id.

---

###### `managedPolicyArn`<sup>Required</sup> <a name="managedPolicyArn" id="cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyArn.parameter.managedPolicyArn"></a>

- *Type:* string

the ARN of the managed policy to import.

---

##### `fromManagedPolicyName` <a name="fromManagedPolicyName" id="cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyName"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedManagedPolicy.fromManagedPolicyName(scope: Construct, id: string, managedPolicyName: string)
```

Import a customer managed policy from the managedPolicyName.

For this managed policy, you only need to know the name to be able to use it.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyName.parameter.id"></a>

- *Type:* string

---

###### `managedPolicyName`<sup>Required</sup> <a name="managedPolicyName" id="cdk-extensions.sso.ReferencedManagedPolicy.fromManagedPolicyName.parameter.managedPolicyName"></a>

- *Type:* string

---

##### `of` <a name="of" id="cdk-extensions.sso.ReferencedManagedPolicy.of"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedManagedPolicy.of(options: ReferenceOptions)
```

Dynamically generates a new class that can be used to create a managed policy that matches a reference in IAM Identity Center.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.sso.ReferencedManagedPolicy.of.parameter.options"></a>

- *Type:* cdk-extensions.sso.ReferenceOptions

The reference configuration used when registering a customer managed policy with a permission set in IAM Identity Center.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.description">description</a></code> | <code>string</code> | The description of this policy. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.document">document</a></code> | <code>aws-cdk-lib.aws_iam.PolicyDocument</code> | The policy document. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.grantPrincipal">grantPrincipal</a></code> | <code>aws-cdk-lib.aws_iam.IPrincipal</code> | The principal to grant permissions to. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.managedPolicyArn">managedPolicyArn</a></code> | <code>string</code> | Returns the ARN of this managed policy. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.managedPolicyName">managedPolicyName</a></code> | <code>string</code> | The name of this policy. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.path">path</a></code> | <code>string</code> | The path of this policy. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.referencedName">referencedName</a></code> | <code>string</code> | The name of the managed policy. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.referencedPath">referencedPath</a></code> | <code>string</code> | The path for the managed policy. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.sso.ReferencedManagedPolicy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.sso.ReferencedManagedPolicy.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.sso.ReferencedManagedPolicy.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `description`<sup>Required</sup> <a name="description" id="cdk-extensions.sso.ReferencedManagedPolicy.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The description of this policy.

---

##### `document`<sup>Required</sup> <a name="document" id="cdk-extensions.sso.ReferencedManagedPolicy.property.document"></a>

```typescript
public readonly document: PolicyDocument;
```

- *Type:* aws-cdk-lib.aws_iam.PolicyDocument

The policy document.

---

##### `grantPrincipal`<sup>Required</sup> <a name="grantPrincipal" id="cdk-extensions.sso.ReferencedManagedPolicy.property.grantPrincipal"></a>

```typescript
public readonly grantPrincipal: IPrincipal;
```

- *Type:* aws-cdk-lib.aws_iam.IPrincipal

The principal to grant permissions to.

---

##### `managedPolicyArn`<sup>Required</sup> <a name="managedPolicyArn" id="cdk-extensions.sso.ReferencedManagedPolicy.property.managedPolicyArn"></a>

```typescript
public readonly managedPolicyArn: string;
```

- *Type:* string

Returns the ARN of this managed policy.

---

##### `managedPolicyName`<sup>Required</sup> <a name="managedPolicyName" id="cdk-extensions.sso.ReferencedManagedPolicy.property.managedPolicyName"></a>

```typescript
public readonly managedPolicyName: string;
```

- *Type:* string

The name of this policy.

---

##### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.sso.ReferencedManagedPolicy.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

The path of this policy.

---

##### `referencedName`<sup>Required</sup> <a name="referencedName" id="cdk-extensions.sso.ReferencedManagedPolicy.property.referencedName"></a>

```typescript
public readonly referencedName: string;
```

- *Type:* string

The name of the managed policy.

---

##### `referencedPath`<sup>Optional</sup> <a name="referencedPath" id="cdk-extensions.sso.ReferencedManagedPolicy.property.referencedPath"></a>

```typescript
public readonly referencedPath: string;
```

- *Type:* string

The path for the managed policy.

For more information about paths, see [IAM identifiers](https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_Identifiers.html) in the IAM User
Guide.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.policyName">policyName</a></code> | <code>string</code> | The name of the managed policy. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicy.property.policyPath">policyPath</a></code> | <code>string</code> | The path for the managed policy. |

---

##### `policyName`<sup>Required</sup> <a name="policyName" id="cdk-extensions.sso.ReferencedManagedPolicy.property.policyName"></a>

```typescript
public readonly policyName: string;
```

- *Type:* string

The name of the managed policy.

---

##### `policyPath`<sup>Optional</sup> <a name="policyPath" id="cdk-extensions.sso.ReferencedManagedPolicy.property.policyPath"></a>

```typescript
public readonly policyPath: string;
```

- *Type:* string

The path for the managed policy.

For more information about paths, see [IAM identifiers](https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_Identifiers.html) in the IAM User
Guide.

---

### ResourceShare <a name="ResourceShare" id="cdk-extensions.ram.ResourceShare"></a>

- *Implements:* cdk-extensions.ram.IResourceShare

Creates a resource share that can used to share AWS resources with other AWS accounts, organizations, or organizational units (OU's).

> [[AWS::RAM::ResourceShare](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html)]([AWS::RAM::ResourceShare](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html))

#### Initializers <a name="Initializers" id="cdk-extensions.ram.ResourceShare.Initializer"></a>

```typescript
import { ram } from 'cdk-extensions'

new ram.ResourceShare(scope: Construct, id: string, props?: ResourceShareProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ram.ResourceShare.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.ram.ResourceShare.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ram.ResourceShare.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ram.ResourceShareProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ram.ResourceShare.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ram.ResourceShare.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ram.ResourceShare.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ram.ResourceShareProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram.ResourceShare.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ram.ResourceShare.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ram.ResourceShare.addPrincipal">addPrincipal</a></code> | {@inheritdoc IResourceShare.addPrincipal}. |
| <code><a href="#cdk-extensions.ram.ResourceShare.addResource">addResource</a></code> | {@inheritdoc IResourceShare.addResource}. |
| <code><a href="#cdk-extensions.ram.ResourceShare.enableAutoDiscovery">enableAutoDiscovery</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ram.ResourceShare.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ram.ResourceShare.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ram.ResourceShare.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addPrincipal` <a name="addPrincipal" id="cdk-extensions.ram.ResourceShare.addPrincipal"></a>

```typescript
public addPrincipal(principal: ISharedPrincipal): void
```

{@inheritdoc IResourceShare.addPrincipal}.

###### `principal`<sup>Required</sup> <a name="principal" id="cdk-extensions.ram.ResourceShare.addPrincipal.parameter.principal"></a>

- *Type:* cdk-extensions.ram.ISharedPrincipal

---

##### `addResource` <a name="addResource" id="cdk-extensions.ram.ResourceShare.addResource"></a>

```typescript
public addResource(resource: ISharable): void
```

{@inheritdoc IResourceShare.addResource}.

###### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ram.ResourceShare.addResource.parameter.resource"></a>

- *Type:* cdk-extensions.ram.ISharable

---

##### `enableAutoDiscovery` <a name="enableAutoDiscovery" id="cdk-extensions.ram.ResourceShare.enableAutoDiscovery"></a>

```typescript
public enableAutoDiscovery(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram.ResourceShare.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ram.ResourceShare.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ram.ResourceShare.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ram.ResourceShare.fromResourceShareArn">fromResourceShareArn</a></code> | Imports an existing RAM resource share by specifying its Amazon Resource Name (ARN). |
| <code><a href="#cdk-extensions.ram.ResourceShare.fromResourceShareAttributes">fromResourceShareAttributes</a></code> | Imports an existing RAM resource share by explicitly specifying its attributes. |
| <code><a href="#cdk-extensions.ram.ResourceShare.fromResourceShareId">fromResourceShareId</a></code> | Imports an existing RAM resource share by specifying its AWS generated ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ram.ResourceShare.isConstruct"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.ResourceShare.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ram.ResourceShare.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ram.ResourceShare.isOwnedResource"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.ResourceShare.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ram.ResourceShare.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ram.ResourceShare.isResource"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.ResourceShare.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ram.ResourceShare.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromResourceShareArn` <a name="fromResourceShareArn" id="cdk-extensions.ram.ResourceShare.fromResourceShareArn"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.ResourceShare.fromResourceShareArn(scope: IConstruct, id: string, resourceShareArn: string)
```

Imports an existing RAM resource share by specifying its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ram.ResourceShare.fromResourceShareArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ram.ResourceShare.fromResourceShareArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `resourceShareArn`<sup>Required</sup> <a name="resourceShareArn" id="cdk-extensions.ram.ResourceShare.fromResourceShareArn.parameter.resourceShareArn"></a>

- *Type:* string

The ARN of the existing RAM resource share to be imported.

---

##### `fromResourceShareAttributes` <a name="fromResourceShareAttributes" id="cdk-extensions.ram.ResourceShare.fromResourceShareAttributes"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.ResourceShare.fromResourceShareAttributes(scope: IConstruct, id: string, attrs: ResourceShareAttributes)
```

Imports an existing RAM resource share by explicitly specifying its attributes.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ram.ResourceShare.fromResourceShareAttributes.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ram.ResourceShare.fromResourceShareAttributes.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.ram.ResourceShare.fromResourceShareAttributes.parameter.attrs"></a>

- *Type:* cdk-extensions.ram.ResourceShareAttributes

The attributes of the existing RAM resource share to be imported.

---

##### `fromResourceShareId` <a name="fromResourceShareId" id="cdk-extensions.ram.ResourceShare.fromResourceShareId"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.ResourceShare.fromResourceShareId(scope: IConstruct, id: string, resourceShareId: string)
```

Imports an existing RAM resource share by specifying its AWS generated ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ram.ResourceShare.fromResourceShareId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ram.ResourceShare.fromResourceShareId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `resourceShareId`<sup>Required</sup> <a name="resourceShareId" id="cdk-extensions.ram.ResourceShare.fromResourceShareId.parameter.resourceShareId"></a>

- *Type:* string

The AWS generated ID of the existing APS workspace to be imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.autoDiscovery">autoDiscovery</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.name">name</a></code> | <code>string</code> | Specifies the name of the resource share. |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ram.CfnResourceShare</code> | The underlying ResourceShare CloudFormation resource. |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.resourceShareArn">resourceShareArn</a></code> | <code>string</code> | {@inheritdoc IResourceShare.resourceShareArn}. |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.resourceShareId">resourceShareId</a></code> | <code>string</code> | {@inheritdoc IResourceShare.resourceShareId}. |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.allowExternalPrincipals">allowExternalPrincipals</a></code> | <code>boolean</code> | Specifies whether principals outside your organization in AWS Organizations can be associated with a resource share. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ram.ResourceShare.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ram.ResourceShare.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ram.ResourceShare.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `autoDiscovery`<sup>Required</sup> <a name="autoDiscovery" id="cdk-extensions.ram.ResourceShare.property.autoDiscovery"></a>

```typescript
public readonly autoDiscovery: boolean;
```

- *Type:* boolean

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ram.ResourceShare.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Specifies the name of the resource share.

> [[ResourceShare.Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-name)]([ResourceShare.Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-name))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ram.ResourceShare.property.resource"></a>

```typescript
public readonly resource: CfnResourceShare;
```

- *Type:* aws-cdk-lib.aws_ram.CfnResourceShare

The underlying ResourceShare CloudFormation resource.

> [[AWS::RAM::ResourceShare](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html)]([AWS::RAM::ResourceShare](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html))

---

##### `resourceShareArn`<sup>Required</sup> <a name="resourceShareArn" id="cdk-extensions.ram.ResourceShare.property.resourceShareArn"></a>

```typescript
public readonly resourceShareArn: string;
```

- *Type:* string

{@inheritdoc IResourceShare.resourceShareArn}.

---

##### `resourceShareId`<sup>Required</sup> <a name="resourceShareId" id="cdk-extensions.ram.ResourceShare.property.resourceShareId"></a>

```typescript
public readonly resourceShareId: string;
```

- *Type:* string

{@inheritdoc IResourceShare.resourceShareId}.

---

##### `allowExternalPrincipals`<sup>Optional</sup> <a name="allowExternalPrincipals" id="cdk-extensions.ram.ResourceShare.property.allowExternalPrincipals"></a>

```typescript
public readonly allowExternalPrincipals: boolean;
```

- *Type:* boolean

Specifies whether principals outside your organization in AWS Organizations can be associated with a resource share.

A value of `true`
lets you share with individual AWS accounts that are not in your
organization. A value of `false` only has meaning if your account is a
member of an AWS Organization.

In order for an account to be auto discovered it must be part of the same
CDK application. It must also be an explicitly defined environment and not
environment agnostic.

> [[CDK Environments](https://docs.aws.amazon.com/cdk/v2/guide/environments.html)]([CDK Environments](https://docs.aws.amazon.com/cdk/v2/guide/environments.html))

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ram.ResourceShare.property.ARN_FORMAT">ARN_FORMAT</a></code> | <code>aws-cdk-lib.ArnFormat</code> | *No description.* |

---

##### `ARN_FORMAT`<sup>Required</sup> <a name="ARN_FORMAT" id="cdk-extensions.ram.ResourceShare.property.ARN_FORMAT"></a>

```typescript
public readonly ARN_FORMAT: ArnFormat;
```

- *Type:* aws-cdk-lib.ArnFormat

---

### Route53Dns <a name="Route53Dns" id="cdk-extensions.k8s_aws.Route53Dns"></a>

External DNS is a Kubernetes service that make Kubernetes resources dicoverable via public DNS servers.

It retrieves a list of resources
(Services, Ingresses, etc.) from the Kubernetes API to determine a desired
list of DNS records and configures DNS providers accordingly.

The version provided here specifically targets Amazon's Route 53 service and
all options provded are for configuring Route 53. After being installed
external-dns will create and manage Route 53 DNS records automatically to
allow easy network access to your pods and services.

> [[Kubernetes SIGs](https://github.com/kubernetes-sigs/external-dns)]([Kubernetes SIGs](https://github.com/kubernetes-sigs/external-dns))

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.Route53Dns.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.Route53Dns(scope: Construct, id: string, props: Route53DnsProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.Route53DnsProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.Route53Dns.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.Route53Dns.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.Route53Dns.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.Route53DnsProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.addDomainFilter">addDomainFilter</a></code> | Adds a domain to the domain filter list. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.addZoneTag">addZoneTag</a></code> | Adds a zone tag filter to the external DNS service. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.Route53Dns.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.Route53Dns.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.Route53Dns.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addDomainFilter` <a name="addDomainFilter" id="cdk-extensions.k8s_aws.Route53Dns.addDomainFilter"></a>

```typescript
public addDomainFilter(domain: string): Route53Dns
```

Adds a domain to the domain filter list.

The domain filter list acts as a whitelist for the domains/hosted zones
which external-dns will manage.

When domains are added to the domain filter list, external-dns will only
create and manage records when their domain ends in with a domain that has
been approved.

###### `domain`<sup>Required</sup> <a name="domain" id="cdk-extensions.k8s_aws.Route53Dns.addDomainFilter.parameter.domain"></a>

- *Type:* string

The domain to be added to the whitelist.

---

##### `addZoneTag` <a name="addZoneTag" id="cdk-extensions.k8s_aws.Route53Dns.addZoneTag"></a>

```typescript
public addZoneTag(tag: ExternalDnsZoneTag): Route53Dns
```

Adds a zone tag filter to the external DNS service.

When zone tags are provided only Routew 53 Hosted Zones that have matching
tags will be managed by external DNS.

###### `tag`<sup>Required</sup> <a name="tag" id="cdk-extensions.k8s_aws.Route53Dns.addZoneTag.parameter.tag"></a>

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneTag

The tag that external-dns is allowed to manage.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.Route53Dns.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.Route53Dns.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.Route53Dns.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.Route53Dns.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.Route53Dns.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.Route53Dns.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.Route53Dns.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.Route53Dns.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.Route53Dns.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.chart">chart</a></code> | <code>aws-cdk-lib.aws_eks.HelmChart</code> | The Helm chart that provides the installation of external-dns. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where external-dns should be deployed. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.domainFilter">domainFilter</a></code> | <code>string[]</code> | The domain suffixes that control which hosted zones external-dns is allowed to make changes for. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.recordOwnershipRegistry">recordOwnershipRegistry</a></code> | <code>cdk-extensions.k8s_aws.IExternalDnsRegistry</code> | Registry specifying how ExternalDNS should track record ownership. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.region">region</a></code> | <code>string</code> | Override the default region external-dns uses when calling AWS API's. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.serviceAccount">serviceAccount</a></code> | <code>aws-cdk-lib.aws_eks.ServiceAccount</code> | The Kubernetes service account that is linked with the IAM Role that allows external-dns to make changes on your behalf. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.zoneTags">zoneTags</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsZoneTag[]</code> | The AWS tags that control which hosted zones external-dns is allowed to make changes for. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.apiRetries">apiRetries</a></code> | <code>number</code> | Maximum number of retries for AWS API calls before giving up. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.batchChangeSize">batchChangeSize</a></code> | <code>number</code> | Set the maximum number of changes that will be applied in each batch. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.evaluateTargetHealth">evaluateTargetHealth</a></code> | <code>boolean</code> | Sets a flag determining whether the health of the backend service should be evaluated when determining DNS routing. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.logFormat">logFormat</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsLogFormat</code> | Sets the output format external dns will use when generating logs. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.logLevel">logLevel</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsLogLevel</code> | Controls the verbosity of logs generated using the external-dns service. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be deployed. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.preferCname">preferCname</a></code> | <code>boolean</code> | When true, alias records will be avoided and CNAME records will be used instead. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.replicaCount">replicaCount</a></code> | <code>number</code> | Desired number of ExternalDNS replicas. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.syncPolicy">syncPolicy</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsSyncPolicy</code> | Controls the operations ExternalDNS will perform on the records it manages. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.zoneType">zoneType</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsZoneType</code> | Controls the types of hosted zones external-dns will create records for. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.Route53Dns.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.Route53Dns.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.Route53Dns.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk-extensions.k8s_aws.Route53Dns.property.chart"></a>

```typescript
public readonly chart: HelmChart;
```

- *Type:* aws-cdk-lib.aws_eks.HelmChart

The Helm chart that provides the installation of external-dns.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.Route53Dns.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where external-dns should be deployed.

---

##### `domainFilter`<sup>Required</sup> <a name="domainFilter" id="cdk-extensions.k8s_aws.Route53Dns.property.domainFilter"></a>

```typescript
public readonly domainFilter: string[];
```

- *Type:* string[]

The domain suffixes that control which hosted zones external-dns is allowed to make changes for.

---

##### `recordOwnershipRegistry`<sup>Required</sup> <a name="recordOwnershipRegistry" id="cdk-extensions.k8s_aws.Route53Dns.property.recordOwnershipRegistry"></a>

```typescript
public readonly recordOwnershipRegistry: IExternalDnsRegistry;
```

- *Type:* cdk-extensions.k8s_aws.IExternalDnsRegistry

Registry specifying how ExternalDNS should track record ownership.

Without a registry to track record ownership, External has no way to know
which records it owns and manages and which are owned and managed by a
different service.

This can cause conflicts if there are multiple instances of External DNS
running or if there are other services managing DNS records in similar
zones as the different services could try to make conflicting changes due
to lacking a shared state.

---

##### `region`<sup>Required</sup> <a name="region" id="cdk-extensions.k8s_aws.Route53Dns.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

Override the default region external-dns uses when calling AWS API's.

---

##### `serviceAccount`<sup>Required</sup> <a name="serviceAccount" id="cdk-extensions.k8s_aws.Route53Dns.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: ServiceAccount;
```

- *Type:* aws-cdk-lib.aws_eks.ServiceAccount

The Kubernetes service account that is linked with the IAM Role that allows external-dns to make changes on your behalf.

---

##### `zoneTags`<sup>Required</sup> <a name="zoneTags" id="cdk-extensions.k8s_aws.Route53Dns.property.zoneTags"></a>

```typescript
public readonly zoneTags: ExternalDnsZoneTag[];
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneTag[]

The AWS tags that control which hosted zones external-dns is allowed to make changes for.

---

##### `apiRetries`<sup>Optional</sup> <a name="apiRetries" id="cdk-extensions.k8s_aws.Route53Dns.property.apiRetries"></a>

```typescript
public readonly apiRetries: number;
```

- *Type:* number

Maximum number of retries for AWS API calls before giving up.

---

##### `batchChangeSize`<sup>Optional</sup> <a name="batchChangeSize" id="cdk-extensions.k8s_aws.Route53Dns.property.batchChangeSize"></a>

```typescript
public readonly batchChangeSize: number;
```

- *Type:* number

Set the maximum number of changes that will be applied in each batch.

---

##### `evaluateTargetHealth`<sup>Optional</sup> <a name="evaluateTargetHealth" id="cdk-extensions.k8s_aws.Route53Dns.property.evaluateTargetHealth"></a>

```typescript
public readonly evaluateTargetHealth: boolean;
```

- *Type:* boolean

Sets a flag determining whether the health of the backend service should be evaluated when determining DNS routing.

---

##### `logFormat`<sup>Optional</sup> <a name="logFormat" id="cdk-extensions.k8s_aws.Route53Dns.property.logFormat"></a>

```typescript
public readonly logFormat: ExternalDnsLogFormat;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsLogFormat

Sets the output format external dns will use when generating logs.

---

##### `logLevel`<sup>Optional</sup> <a name="logLevel" id="cdk-extensions.k8s_aws.Route53Dns.property.logLevel"></a>

```typescript
public readonly logLevel: ExternalDnsLogLevel;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsLogLevel

Controls the verbosity of logs generated using the external-dns service.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.Route53Dns.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the service should be deployed.

---

##### `preferCname`<sup>Optional</sup> <a name="preferCname" id="cdk-extensions.k8s_aws.Route53Dns.property.preferCname"></a>

```typescript
public readonly preferCname: boolean;
```

- *Type:* boolean

When true, alias records will be avoided and CNAME records will be used instead.

---

##### `replicaCount`<sup>Optional</sup> <a name="replicaCount" id="cdk-extensions.k8s_aws.Route53Dns.property.replicaCount"></a>

```typescript
public readonly replicaCount: number;
```

- *Type:* number

Desired number of ExternalDNS replicas.

---

##### `syncPolicy`<sup>Optional</sup> <a name="syncPolicy" id="cdk-extensions.k8s_aws.Route53Dns.property.syncPolicy"></a>

```typescript
public readonly syncPolicy: ExternalDnsSyncPolicy;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsSyncPolicy

Controls the operations ExternalDNS will perform on the records it manages.

---

##### `zoneType`<sup>Optional</sup> <a name="zoneType" id="cdk-extensions.k8s_aws.Route53Dns.property.zoneType"></a>

```typescript
public readonly zoneType: ExternalDnsZoneType;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneType

Controls the types of hosted zones external-dns will create records for.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.CHART_NAME">CHART_NAME</a></code> | <code>string</code> | The name of the external-dns Helm chart. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.CHART_REPOSITORY">CHART_REPOSITORY</a></code> | <code>string</code> | The Helm repository providing the chart to be used for installing the external-dns service. |
| <code><a href="#cdk-extensions.k8s_aws.Route53Dns.property.DEFAULT_NAMESPACE">DEFAULT_NAMESPACE</a></code> | <code>string</code> | The default Kubernetes namespace where external-dns will be installed if an alternative isn't given as input. |

---

##### `CHART_NAME`<sup>Required</sup> <a name="CHART_NAME" id="cdk-extensions.k8s_aws.Route53Dns.property.CHART_NAME"></a>

```typescript
public readonly CHART_NAME: string;
```

- *Type:* string

The name of the external-dns Helm chart.

---

##### `CHART_REPOSITORY`<sup>Required</sup> <a name="CHART_REPOSITORY" id="cdk-extensions.k8s_aws.Route53Dns.property.CHART_REPOSITORY"></a>

```typescript
public readonly CHART_REPOSITORY: string;
```

- *Type:* string

The Helm repository providing the chart to be used for installing the external-dns service.

---

##### `DEFAULT_NAMESPACE`<sup>Required</sup> <a name="DEFAULT_NAMESPACE" id="cdk-extensions.k8s_aws.Route53Dns.property.DEFAULT_NAMESPACE"></a>

```typescript
public readonly DEFAULT_NAMESPACE: string;
```

- *Type:* string

The default Kubernetes namespace where external-dns will be installed if an alternative isn't given as input.

---

### RuleGroup <a name="RuleGroup" id="cdk-extensions.aps.RuleGroup"></a>

A group of alerting and recording rules for use inside an APS rule groups namespace configuration.

Rules within a group are run sequentially at a
regular interval, with the same evaluation time. The names of recording
rules must be valid metric names. The names of alerting rules must be valid
label values.

> [[Prometheus rule_group specification](https://prometheus.io/docs/prometheus/latest/configuration/recording_rules/#rule_group)]([Prometheus rule_group specification](https://prometheus.io/docs/prometheus/latest/configuration/recording_rules/#rule_group))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.RuleGroup.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.RuleGroup(scope: IConstruct, id: string, props?: RuleGroupProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this construct's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.RuleGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.RuleGroup.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.aps.RuleGroupProps</code> | Arguments related to the configuration of the construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.RuleGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this construct's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.RuleGroup.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.aps.RuleGroup.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.aps.RuleGroupProps

Arguments related to the configuration of the construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.RuleGroup.addAlertingRule">addAlertingRule</a></code> | Adds an alerting rule to the rule group. |
| <code><a href="#cdk-extensions.aps.RuleGroup.addRecordingRule">addRecordingRule</a></code> | Adds a recording rule to the rule group. |
| <code><a href="#cdk-extensions.aps.RuleGroup.addRule">addRule</a></code> | Adds a Prometheus rule to the rule group. |
| <code><a href="#cdk-extensions.aps.RuleGroup.bind">bind</a></code> | Associates the rule group with a construct that is configuring an APS rule groups namespace. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.RuleGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addAlertingRule` <a name="addAlertingRule" id="cdk-extensions.aps.RuleGroup.addAlertingRule"></a>

```typescript
public addAlertingRule(options: AlertingRuleProps): AlertingRule
```

Adds an alerting rule to the rule group.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.RuleGroup.addAlertingRule.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertingRuleProps

Options for configuring the alerting rule to be added.

---

##### `addRecordingRule` <a name="addRecordingRule" id="cdk-extensions.aps.RuleGroup.addRecordingRule"></a>

```typescript
public addRecordingRule(options: RecordingRuleProps): RecordingRule
```

Adds a recording rule to the rule group.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.RuleGroup.addRecordingRule.parameter.options"></a>

- *Type:* cdk-extensions.aps.RecordingRuleProps

Options for configuring the recording rule to be added.

---

##### `addRule` <a name="addRule" id="cdk-extensions.aps.RuleGroup.addRule"></a>

```typescript
public addRule(rule: IPrometheusRule): RuleGroup
```

Adds a Prometheus rule to the rule group.

This method can be used to implement any rules that are created outside of
the the rule group that were created manually by calling their
constructors or for adding Prometheus rules that use their own custom
implementations.

###### `rule`<sup>Required</sup> <a name="rule" id="cdk-extensions.aps.RuleGroup.addRule.parameter.rule"></a>

- *Type:* cdk-extensions.aps.IPrometheusRule

The rule to add to the rule group.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.RuleGroup.bind"></a>

```typescript
public bind(scope: IConstruct): {[ key: string ]: any}
```

Associates the rule group with a construct that is configuring an APS rule groups namespace.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.RuleGroup.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of the APS rule groups namespace that will be consuming this rule group.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.RuleGroup.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.RuleGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.RuleGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.RuleGroup.property.name">name</a></code> | <code>string</code> | The name of the group. |
| <code><a href="#cdk-extensions.aps.RuleGroup.property.interval">interval</a></code> | <code>aws-cdk-lib.Duration</code> | How often rules in the group are evaluated. |
| <code><a href="#cdk-extensions.aps.RuleGroup.property.limit">limit</a></code> | <code>number</code> | Limit the number of alerts an alerting rule and series a recording rule can produce. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.RuleGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.aps.RuleGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the group.

Must be unique within the configuration.

---

##### `interval`<sup>Optional</sup> <a name="interval" id="cdk-extensions.aps.RuleGroup.property.interval"></a>

```typescript
public readonly interval: Duration;
```

- *Type:* aws-cdk-lib.Duration

How often rules in the group are evaluated.

---

##### `limit`<sup>Optional</sup> <a name="limit" id="cdk-extensions.aps.RuleGroup.property.limit"></a>

```typescript
public readonly limit: number;
```

- *Type:* number

Limit the number of alerts an alerting rule and series a recording rule can produce.

0 is no limit.

---


### RuleGroupConfiguration <a name="RuleGroupConfiguration" id="cdk-extensions.aps.RuleGroupConfiguration"></a>

- *Implements:* cdk-extensions.aps.IRuleGroupConfiguration

Represents a rules file definition that can be consumed by Amazon Managed Service for Prometheus.

> [[Creating a rules file](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-ruler-rulesfile.html)]([Creating a rules file](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-ruler-rulesfile.html))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.RuleGroupConfiguration.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.RuleGroupConfiguration(scope: IConstruct, id: string, _props?: RuleGroupConfigurationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this construct's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.Initializer.parameter._props">_props</a></code> | <code>cdk-extensions.aps.RuleGroupConfigurationProps</code> | Arguments related to the configuration of the construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.RuleGroupConfiguration.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this construct's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.RuleGroupConfiguration.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `_props`<sup>Optional</sup> <a name="_props" id="cdk-extensions.aps.RuleGroupConfiguration.Initializer.parameter._props"></a>

- *Type:* cdk-extensions.aps.RuleGroupConfigurationProps

Arguments related to the configuration of the construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.addRuleGroup">addRuleGroup</a></code> | Adds a new rule group to the configuration. |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.bind">bind</a></code> | Associates the configuration with a resource that is handling the creation of an APS rule groups namespace. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.RuleGroupConfiguration.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addRuleGroup` <a name="addRuleGroup" id="cdk-extensions.aps.RuleGroupConfiguration.addRuleGroup"></a>

```typescript
public addRuleGroup(id: string, options?: RuleGroupProps): RuleGroup
```

Adds a new rule group to the configuration.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.RuleGroupConfiguration.addRuleGroup.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.aps.RuleGroupConfiguration.addRuleGroup.parameter.options"></a>

- *Type:* cdk-extensions.aps.RuleGroupProps

Configuration options for the new rule group being added.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.RuleGroupConfiguration.bind"></a>

```typescript
public bind(scope: IConstruct): RuleGroupConfigurationDetails
```

Associates the configuration with a resource that is handling the creation of an APS rule groups namespace.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.RuleGroupConfiguration.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of an APS rule groups namespace that will be consuming this configuration.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.fromContent">fromContent</a></code> | Imports an APS rules configuration using a raw string. |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.fromRulesFile">fromRulesFile</a></code> | Imports an APS rules file from the local filesystem. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.RuleGroupConfiguration.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.RuleGroupConfiguration.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.RuleGroupConfiguration.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromContent` <a name="fromContent" id="cdk-extensions.aps.RuleGroupConfiguration.fromContent"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.RuleGroupConfiguration.fromContent(scope: IConstruct, id: string, content: string)
```

Imports an APS rules configuration using a raw string.

The string should be in YAML format and follow the specification expected
by the `aps:CreateRuleGroupsNamespace` API call.

> [[Rules file specification](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-ruler-rulesfile.html)]([Rules file specification](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-ruler-rulesfile.html))

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.RuleGroupConfiguration.fromContent.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of a rule groups namespace that will consume the rendered configuration.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.RuleGroupConfiguration.fromContent.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `content`<sup>Required</sup> <a name="content" id="cdk-extensions.aps.RuleGroupConfiguration.fromContent.parameter.content"></a>

- *Type:* string

The raw string content of a rule groups configuration.

---

##### `fromRulesFile` <a name="fromRulesFile" id="cdk-extensions.aps.RuleGroupConfiguration.fromRulesFile"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.RuleGroupConfiguration.fromRulesFile(scope: IConstruct, id: string, path: string)
```

Imports an APS rules file from the local filesystem.

The file should be in YAML format and follow the specification expected by
the `aps:CreateRuleGroupsNamespace` API call.

> [[Rules file specification](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-ruler-rulesfile.html)]([Rules file specification](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-ruler-rulesfile.html))

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.RuleGroupConfiguration.fromRulesFile.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of a rule groups namespace that will consume the rendered configuration.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.RuleGroupConfiguration.fromRulesFile.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.aps.RuleGroupConfiguration.fromRulesFile.parameter.path"></a>

- *Type:* string

The path to the file containing the rule group definitions.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.RuleGroupConfiguration.property.ruleGroups">ruleGroups</a></code> | <code>cdk-extensions.aps.RuleGroup[]</code> | Collection of rule groups that are part of this configuration. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.RuleGroupConfiguration.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `ruleGroups`<sup>Required</sup> <a name="ruleGroups" id="cdk-extensions.aps.RuleGroupConfiguration.property.ruleGroups"></a>

```typescript
public readonly ruleGroups: RuleGroup[];
```

- *Type:* cdk-extensions.aps.RuleGroup[]

Collection of rule groups that are part of this configuration.

---


### RuleGroupsNamespace <a name="RuleGroupsNamespace" id="cdk-extensions.aps.RuleGroupsNamespace"></a>

- *Implements:* cdk-extensions.aps.IRuleGroupsNamespace

Amazon Managed Service for Prometheus allows for the configuration of rules that configure alerting and precomputation of frequently needed expressions.

These rules are added to a workspace using configurations that define one or
more resource groups. Eache group can contain one or more rules and
configures the frequency that its rules should be evaluated.

You can have multiple configurations per workspace. Each configuration is
contained in a separate _namespace_. Having multiple configuration lets you
import existing Prometheus rules files to a workspace without having to
change or combine them. Different rule group namespaces can also have
different tags.

> [[Recording rules and alerting rules](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-Ruler.html)]([Recording rules and alerting rules](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-Ruler.html))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.RuleGroupsNamespace.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.RuleGroupsNamespace(scope: IConstruct, id: string, props: RuleGroupsNamespaceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.aps.RuleGroupsNamespaceProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.RuleGroupsNamespace.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.RuleGroupsNamespace.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.aps.RuleGroupsNamespace.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.aps.RuleGroupsNamespaceProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.addRuleGroup">addRuleGroup</a></code> | Adds a new rule group to the configuration. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.RuleGroupsNamespace.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.aps.RuleGroupsNamespace.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.aps.RuleGroupsNamespace.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addRuleGroup` <a name="addRuleGroup" id="cdk-extensions.aps.RuleGroupsNamespace.addRuleGroup"></a>

```typescript
public addRuleGroup(id: string, options?: RuleGroupProps): RuleGroup
```

Adds a new rule group to the configuration.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.RuleGroupsNamespace.addRuleGroup.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.aps.RuleGroupsNamespace.addRuleGroup.parameter.options"></a>

- *Type:* cdk-extensions.aps.RuleGroupProps

Configuration options for the new rule group being added.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.fromRuleGroupsNamespaceArn">fromRuleGroupsNamespaceArn</a></code> | Imports an existing APS rule groups namespace by specifying its Amazon Resource Name (ARN). |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.RuleGroupsNamespace.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.RuleGroupsNamespace.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.RuleGroupsNamespace.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.aps.RuleGroupsNamespace.isOwnedResource"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.RuleGroupsNamespace.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.aps.RuleGroupsNamespace.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.aps.RuleGroupsNamespace.isResource"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.RuleGroupsNamespace.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.aps.RuleGroupsNamespace.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromRuleGroupsNamespaceArn` <a name="fromRuleGroupsNamespaceArn" id="cdk-extensions.aps.RuleGroupsNamespace.fromRuleGroupsNamespaceArn"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.RuleGroupsNamespace.fromRuleGroupsNamespaceArn(scope: IConstruct, id: string, arn: string)
```

Imports an existing APS rule groups namespace by specifying its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.RuleGroupsNamespace.fromRuleGroupsNamespaceArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.RuleGroupsNamespace.fromRuleGroupsNamespaceArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `arn`<sup>Required</sup> <a name="arn" id="cdk-extensions.aps.RuleGroupsNamespace.fromRuleGroupsNamespaceArn.parameter.arn"></a>

- *Type:* string

The ARN of the existing APS rule groups namespace.

to be
imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.property.configuration">configuration</a></code> | <code>cdk-extensions.aps.IRuleGroupConfiguration</code> | The rules definition file for this namespace. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.property.name">name</a></code> | <code>string</code> | The name of the rule groups namespace. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_aps.CfnRuleGroupsNamespace</code> | The underlying RuleGroupsNamespace CloudFormation resource. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.property.rulesGroupsNamespaceArn">rulesGroupsNamespaceArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the APS rule groups namespace. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespace.property.workspace">workspace</a></code> | <code>cdk-extensions.aps.IWorkspace</code> | The APS workspace that contains this rule groups namespace. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.RuleGroupsNamespace.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.aps.RuleGroupsNamespace.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.aps.RuleGroupsNamespace.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `configuration`<sup>Required</sup> <a name="configuration" id="cdk-extensions.aps.RuleGroupsNamespace.property.configuration"></a>

```typescript
public readonly configuration: IRuleGroupConfiguration;
```

- *Type:* cdk-extensions.aps.IRuleGroupConfiguration

The rules definition file for this namespace.

> [[RuleGroupsNamespace Data](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-data)]([RuleGroupsNamespace Data](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-data))

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.aps.RuleGroupsNamespace.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the rule groups namespace.

> [[RuleGroupsNamespace Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-name)]([RuleGroupsNamespace Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-name))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.aps.RuleGroupsNamespace.property.resource"></a>

```typescript
public readonly resource: CfnRuleGroupsNamespace;
```

- *Type:* aws-cdk-lib.aws_aps.CfnRuleGroupsNamespace

The underlying RuleGroupsNamespace CloudFormation resource.

> [[AWS::APS::RuleGroupsNamespace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html)]([AWS::APS::RuleGroupsNamespace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html))

---

##### `rulesGroupsNamespaceArn`<sup>Required</sup> <a name="rulesGroupsNamespaceArn" id="cdk-extensions.aps.RuleGroupsNamespace.property.rulesGroupsNamespaceArn"></a>

```typescript
public readonly rulesGroupsNamespaceArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the APS rule groups namespace.

---

##### `workspace`<sup>Required</sup> <a name="workspace" id="cdk-extensions.aps.RuleGroupsNamespace.property.workspace"></a>

```typescript
public readonly workspace: IWorkspace;
```

- *Type:* cdk-extensions.aps.IWorkspace

The APS workspace that contains this rule groups namespace.

> [[RuleGroupsNamespace Workspace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-workspace)]([RuleGroupsNamespace Workspace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-workspace))

---


### S3AccessLogsBucket <a name="S3AccessLogsBucket" id="cdk-extensions.s3_buckets.S3AccessLogsBucket"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

new s3_buckets.S3AccessLogsBucket(scope: Construct, id: string, props?: S3AccessLogsBucketProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.s3_buckets.S3AccessLogsBucketProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.s3_buckets.S3AccessLogsBucketProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.addEventNotification">addEventNotification</a></code> | Adds a bucket notification event destination. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.addObjectCreatedNotification">addObjectCreatedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 created in the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.addObjectRemovedNotification">addObjectRemovedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 removed from the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.addToResourcePolicy">addToResourcePolicy</a></code> | Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.arnForObjects">arnForObjects</a></code> | Returns an ARN that represents all objects within the bucket that match
 the key pattern specified. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.enableEventBridgeNotification">enableEventBridgeNotification</a></code> | Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.grantDelete">grantDelete</a></code> | Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPublicAccess">grantPublicAccess</a></code> | Allows unrestricted access to objects from this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPut">grantPut</a></code> | Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPutAcl">grantPutAcl</a></code> | Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.grantRead">grantRead</a></code> | Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.grantReadWrite">grantReadWrite</a></code> | Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.grantWrite">grantWrite</a></code> | Grant write permissions to this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailEvent">onCloudTrailEvent</a></code> | Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailPutObject">onCloudTrailPutObject</a></code> | Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailWriteObject">onCloudTrailWriteObject</a></code> | Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.s3UrlForObject">s3UrlForObject</a></code> | The S3 URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.transferAccelerationUrlForObject">transferAccelerationUrlForObject</a></code> | The https Transfer Acceleration URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.urlForObject">urlForObject</a></code> | The https URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.virtualHostedUrlForObject">virtualHostedUrlForObject</a></code> | The virtual hosted-style URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.addLoggingAspect">addLoggingAspect</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addEventNotification` <a name="addEventNotification" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addEventNotification"></a>

```typescript
public addEventNotification(_event: EventType, _dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Adds a bucket notification event destination.

###### `_event`<sup>Required</sup> <a name="_event" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addEventNotification.parameter._event"></a>

- *Type:* aws-cdk-lib.aws_s3.EventType

---

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addEventNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addEventNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectCreatedNotification` <a name="addObjectCreatedNotification" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addObjectCreatedNotification"></a>

```typescript
public addObjectCreatedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 created in the bucket.

This is identical to calling
`onEvent(s3.EventType.OBJECT_CREATED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addObjectCreatedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addObjectCreatedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectRemovedNotification` <a name="addObjectRemovedNotification" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addObjectRemovedNotification"></a>

```typescript
public addObjectRemovedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 removed from the bucket.

This is identical to calling
`onEvent(EventType.OBJECT_REMOVED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addObjectRemovedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addObjectRemovedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addToResourcePolicy` <a name="addToResourcePolicy" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addToResourcePolicy"></a>

```typescript
public addToResourcePolicy(permission: PolicyStatement): AddToResourcePolicyResult
```

Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases.

###### `permission`<sup>Required</sup> <a name="permission" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addToResourcePolicy.parameter.permission"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `arnForObjects` <a name="arnForObjects" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.arnForObjects"></a>

```typescript
public arnForObjects(_keyPattern: string): string
```

Returns an ARN that represents all objects within the bucket that match
 the key pattern specified.

To represent all keys, specify ``"*"``.

###### `_keyPattern`<sup>Required</sup> <a name="_keyPattern" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.arnForObjects.parameter._keyPattern"></a>

- *Type:* string

---

##### `enableEventBridgeNotification` <a name="enableEventBridgeNotification" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.enableEventBridgeNotification"></a>

```typescript
public enableEventBridgeNotification(): void
```

Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted.

##### `grantDelete` <a name="grantDelete" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantDelete"></a>

```typescript
public grantDelete(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantDelete.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantDelete.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPublicAccess` <a name="grantPublicAccess" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPublicAccess"></a>

```typescript
public grantPublicAccess(_allowedActions: string, _keyPrefix?: string): Grant
```

Allows unrestricted access to objects from this bucket.

IMPORTANT: This permission allows anyone to perform actions on S3 objects
in this bucket, which is useful for when you configure your bucket as a
website and want everyone to be able to read objects in the bucket without
needing to authenticate.

Without arguments, this method will grant read ("s3:GetObject") access to
all objects ("*") in the bucket.

The method returns the `iam.Grant` object, which can then be modified
as needed. For example, you can add a condition that will restrict access only
to an IPv4 range like this:

     const grant = bucket.grantPublicAccess();
     grant.resourceStatement!.addCondition(‘IpAddress’, { “aws:SourceIp”: “54.240.143.0/24” });

###### `_allowedActions`<sup>Required</sup> <a name="_allowedActions" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPublicAccess.parameter._allowedActions"></a>

- *Type:* string

---

###### `_keyPrefix`<sup>Optional</sup> <a name="_keyPrefix" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPublicAccess.parameter._keyPrefix"></a>

- *Type:* string

---

##### `grantPut` <a name="grantPut" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPut"></a>

```typescript
public grantPut(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPut.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPut.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPutAcl` <a name="grantPutAcl" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPutAcl"></a>

```typescript
public grantPutAcl(_identity: IGrantable, _objectsKeyPattern?: string): Grant
```

Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket.

If your application has the '@aws-cdk/aws-s3:grantWriteWithoutAcl' feature flag set,
calling `grantWrite` or `grantReadWrite` no longer grants permissions to modify the ACLs of the objects;
in this case, if you need to modify object ACLs, call this method explicitly.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPutAcl.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantPutAcl.parameter._objectsKeyPattern"></a>

- *Type:* string

---

##### `grantRead` <a name="grantRead" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantRead"></a>

```typescript
public grantRead(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If encryption is used, permission to use the key to decrypt the contents
of the bucket will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantRead.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantRead.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantReadWrite"></a>

```typescript
public grantReadWrite(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If an encryption key is used, permission to use the key for
encrypt/decrypt will also be granted.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantReadWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantReadWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantWrite` <a name="grantWrite" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantWrite"></a>

```typescript
public grantWrite(_identity: IGrantable, _objectsKeyPattern?: any, _allowedActionPatterns?: string[]): Grant
```

Grant write permissions to this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

###### `_allowedActionPatterns`<sup>Optional</sup> <a name="_allowedActionPatterns" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.grantWrite.parameter._allowedActionPatterns"></a>

- *Type:* string[]

---

##### `onCloudTrailEvent` <a name="onCloudTrailEvent" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailEvent"></a>

```typescript
public onCloudTrailEvent(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event.

This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailEvent.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailEvent.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailPutObject` <a name="onCloudTrailPutObject" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailPutObject"></a>

```typescript
public onCloudTrailPutObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using `onCloudTrailWriteObject` may be preferable.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailPutObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailPutObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailWriteObject` <a name="onCloudTrailWriteObject" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailWriteObject"></a>

```typescript
public onCloudTrailWriteObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to.

This includes
the events PutObject, CopyObject, and CompleteMultipartUpload.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using this method may be preferable to `onCloudTrailPutObject`.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailWriteObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.onCloudTrailWriteObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `s3UrlForObject` <a name="s3UrlForObject" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.s3UrlForObject"></a>

```typescript
public s3UrlForObject(_key?: string): string
```

The S3 URL of an S3 object.

For example:
- `s3://onlybucket`
- `s3://bucket/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.s3UrlForObject.parameter._key"></a>

- *Type:* string

---

##### `transferAccelerationUrlForObject` <a name="transferAccelerationUrlForObject" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.transferAccelerationUrlForObject"></a>

```typescript
public transferAccelerationUrlForObject(_key?: string, _options?: TransferAccelerationUrlOptions): string
```

The https Transfer Acceleration URL of an S3 object.

Specify `dualStack: true` at the options
for dual-stack endpoint (connect to the bucket over IPv6). For example:

- `https://bucket.s3-accelerate.amazonaws.com`
- `https://bucket.s3-accelerate.amazonaws.com/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.transferAccelerationUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.transferAccelerationUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.TransferAccelerationUrlOptions

---

##### `urlForObject` <a name="urlForObject" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.urlForObject"></a>

```typescript
public urlForObject(_key?: string): string
```

The https URL of an S3 object.

For example:

- `https://s3.us-west-1.amazonaws.com/onlybucket`
- `https://s3.us-west-1.amazonaws.com/bucket/key`
- `https://s3.cn-north-1.amazonaws.com.cn/china-bucket/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.urlForObject.parameter._key"></a>

- *Type:* string

---

##### `virtualHostedUrlForObject` <a name="virtualHostedUrlForObject" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.virtualHostedUrlForObject"></a>

```typescript
public virtualHostedUrlForObject(_key?: string, _options?: VirtualHostedStyleUrlOptions): string
```

The virtual hosted-style URL of an S3 object.

Specify `regional: false` at
the options for non-regional URL. For example:

- `https://only-bucket.s3.us-west-1.amazonaws.com`
- `https://bucket.s3.us-west-1.amazonaws.com/key`
- `https://bucket.s3.amazonaws.com/key`
- `https://china-bucket.s3.cn-north-1.amazonaws.com.cn/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.virtualHostedUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.virtualHostedUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.VirtualHostedStyleUrlOptions

---

##### `addLoggingAspect` <a name="addLoggingAspect" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addLoggingAspect"></a>

```typescript
public addLoggingAspect(scope: IConstruct, options?: LoggingAspectOptions): void
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addLoggingAspect.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.addLoggingAspect.parameter.options"></a>

- *Type:* cdk-extensions.s3_buckets.LoggingAspectOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.isConstruct"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.S3AccessLogsBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.isOwnedResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.S3AccessLogsBucket.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.isResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.S3AccessLogsBucket.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketArn">bucketArn</a></code> | <code>string</code> | The ARN of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | The IPv4 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketDualStackDomainName">bucketDualStackDomainName</a></code> | <code>string</code> | The IPv6 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketName">bucketName</a></code> | <code>string</code> | The name of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketRegionalDomainName">bucketRegionalDomainName</a></code> | <code>string</code> | The regional domain name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketWebsiteDomainName">bucketWebsiteDomainName</a></code> | <code>string</code> | The Domain name of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketWebsiteUrl">bucketWebsiteUrl</a></code> | <code>string</code> | The URL of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_s3.CfnBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | Optional KMS encryption key associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.isWebsite">isWebsite</a></code> | <code>boolean</code> | If this bucket has been configured for static website hosting. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.policy">policy</a></code> | <code>aws-cdk-lib.aws_s3.BucketPolicy</code> | The resource policy associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.table">table</a></code> | <code>cdk-extensions.glue_tables.S3AccessLogsTable</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucket.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bucketArn`<sup>Required</sup> <a name="bucketArn" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketArn"></a>

```typescript
public readonly bucketArn: string;
```

- *Type:* string

The ARN of the bucket.

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

The IPv4 DNS name of the specified bucket.

---

##### `bucketDualStackDomainName`<sup>Required</sup> <a name="bucketDualStackDomainName" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketDualStackDomainName"></a>

```typescript
public readonly bucketDualStackDomainName: string;
```

- *Type:* string

The IPv6 DNS name of the specified bucket.

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

The name of the bucket.

---

##### `bucketRegionalDomainName`<sup>Required</sup> <a name="bucketRegionalDomainName" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketRegionalDomainName"></a>

```typescript
public readonly bucketRegionalDomainName: string;
```

- *Type:* string

The regional domain name of the specified bucket.

---

##### `bucketWebsiteDomainName`<sup>Required</sup> <a name="bucketWebsiteDomainName" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketWebsiteDomainName"></a>

```typescript
public readonly bucketWebsiteDomainName: string;
```

- *Type:* string

The Domain name of the static website.

---

##### `bucketWebsiteUrl`<sup>Required</sup> <a name="bucketWebsiteUrl" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.bucketWebsiteUrl"></a>

```typescript
public readonly bucketWebsiteUrl: string;
```

- *Type:* string

The URL of the static website.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.resource"></a>

```typescript
public readonly resource: CfnBucket;
```

- *Type:* aws-cdk-lib.aws_s3.CfnBucket

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

Optional KMS encryption key associated with this bucket.

---

##### `isWebsite`<sup>Optional</sup> <a name="isWebsite" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.isWebsite"></a>

```typescript
public readonly isWebsite: boolean;
```

- *Type:* boolean

If this bucket has been configured for static website hosting.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.policy"></a>

```typescript
public readonly policy: BucketPolicy;
```

- *Type:* aws-cdk-lib.aws_s3.BucketPolicy

The resource policy associated with this bucket.

If `autoCreatePolicy` is true, a `BucketPolicy` will be created upon the
first call to addToResourcePolicy(s).

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.table"></a>

```typescript
public readonly table: S3AccessLogsTable;
```

- *Type:* cdk-extensions.glue_tables.S3AccessLogsTable

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.S3AccessLogsBucket.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---


### S3AccessLogsTable <a name="S3AccessLogsTable" id="cdk-extensions.glue_tables.S3AccessLogsTable"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue_tables.S3AccessLogsTable.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

new glue_tables.S3AccessLogsTable(scope: Construct, id: string, props: S3AccessLogsTableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue_tables.S3AccessLogsTableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue_tables.S3AccessLogsTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue_tables.S3AccessLogsTable.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue_tables.S3AccessLogsTable.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue_tables.S3AccessLogsTableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.addColumn">addColumn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.addParameter">addParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.addPartitionKey">addPartitionKey</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.addSerdeParameter">addSerdeParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.addStorageParameter">addStorageParameter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue_tables.S3AccessLogsTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue_tables.S3AccessLogsTable.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue_tables.S3AccessLogsTable.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue_tables.S3AccessLogsTable.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.S3AccessLogsTable.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.glue_tables.S3AccessLogsTable.addParameter"></a>

```typescript
public addParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.S3AccessLogsTable.addParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.S3AccessLogsTable.addParameter.parameter.value"></a>

- *Type:* string

---

##### `addPartitionKey` <a name="addPartitionKey" id="cdk-extensions.glue_tables.S3AccessLogsTable.addPartitionKey"></a>

```typescript
public addPartitionKey(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.S3AccessLogsTable.addPartitionKey.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addSerdeParameter` <a name="addSerdeParameter" id="cdk-extensions.glue_tables.S3AccessLogsTable.addSerdeParameter"></a>

```typescript
public addSerdeParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.S3AccessLogsTable.addSerdeParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.S3AccessLogsTable.addSerdeParameter.parameter.value"></a>

- *Type:* string

---

##### `addStorageParameter` <a name="addStorageParameter" id="cdk-extensions.glue_tables.S3AccessLogsTable.addStorageParameter"></a>

```typescript
public addStorageParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.S3AccessLogsTable.addStorageParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.S3AccessLogsTable.addStorageParameter.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue_tables.S3AccessLogsTable.isConstruct"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.S3AccessLogsTable.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue_tables.S3AccessLogsTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue_tables.S3AccessLogsTable.isOwnedResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.S3AccessLogsTable.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.S3AccessLogsTable.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue_tables.S3AccessLogsTable.isResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.S3AccessLogsTable.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.S3AccessLogsTable.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link TableProps.database:}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTable</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.tableArn">tableArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.compressed">compressed</a></code> | <code>boolean</code> | {@link TableProps.compressed}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | {@link TableProps.dataFormat}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.description">description</a></code> | <code>string</code> | {@link TableProps.description}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.location">location</a></code> | <code>string</code> | {@link TableProps.location}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.name">name</a></code> | <code>string</code> | {@link TableProps.name}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.owner">owner</a></code> | <code>string</code> | {@link TableProps.owner}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | {@link TableProps.retention}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.serdeName">serdeName</a></code> | <code>string</code> | {@link TableProps.serdeName}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | {@link TableProps.storedAsSubDirectories}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | {@link TableProps.tableType}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | {@link TableProps.targetTable}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | {@link TableProps.viewExpandedText}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | {@link TableProps.viewOriginalText}. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the S3 Access Logs. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTable.property.requestErrorsNamedQuery">requestErrorsNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link TableProps.database:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.resource"></a>

```typescript
public readonly resource: CfnTable;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTable

---

##### `tableArn`<sup>Required</sup> <a name="tableArn" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.tableArn"></a>

```typescript
public readonly tableArn: string;
```

- *Type:* string

---

##### `tableName`<sup>Required</sup> <a name="tableName" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

{@link TableProps.compressed}.

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

{@link TableProps.dataFormat}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link TableProps.description}.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

{@link TableProps.location}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link TableProps.name}.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

{@link TableProps.owner}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link TableProps.retention}.

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

{@link TableProps.serdeName}.

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

{@link TableProps.storedAsSubDirectories}.

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

{@link TableProps.tableType}.

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

{@link TableProps.targetTable}.

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

{@link TableProps.viewExpandedText}.

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

{@link TableProps.viewOriginalText}.

---

##### `createQueries`<sup>Required</sup> <a name="createQueries" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the S3 Access Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Required</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `requestErrorsNamedQuery`<sup>Optional</sup> <a name="requestErrorsNamedQuery" id="cdk-extensions.glue_tables.S3AccessLogsTable.property.requestErrorsNamedQuery"></a>

```typescript
public readonly requestErrorsNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---


### SecretsManagerSecretStore <a name="SecretsManagerSecretStore" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore"></a>

A secret store that allows secrets from AWS Secrets Managers to be synchronized into Kubernetes as Kubernetes secrets.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.SecretsManagerSecretStore(scope: Construct, id: string, props: SecretsManagerSecretStoreProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.addSecret">addSecret</a></code> | Registers a new Secrets Manager secret to be synchronized into Kubernetes. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addSecret` <a name="addSecret" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.addSecret"></a>

```typescript
public addSecret(id: string, secret: ISecret, options?: ExternalSecretOptions): ExternalSecret
```

Registers a new Secrets Manager secret to be synchronized into Kubernetes.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.addSecret.parameter.id"></a>

- *Type:* string

The ID of the secret import configuration in the CDK construct tree.

The configuration is placed under the Secrets Manager secret it
synchronizes and so must be unique per secret.

---

###### `secret`<sup>Required</sup> <a name="secret" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.addSecret.parameter.secret"></a>

- *Type:* aws-cdk-lib.aws_secretsmanager.ISecret

The Secrets Manager secret to synchronize into Kubernetes.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.addSecret.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.ExternalSecretOptions

Configuration options for how the secret should be synchronized.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.SecretsManagerSecretStore.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.SecretsManagerSecretStore.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.SecretsManagerSecretStore.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.manifest">manifest</a></code> | <code>aws-cdk-lib.aws_eks.KubernetesManifest</code> | The Kubernetes manifest that defines the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.name">name</a></code> | <code>string</code> | A human friendly name for the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.secretStoreName">secretStoreName</a></code> | <code>string</code> | The name of the secret store as it appears in Kubernetes. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.service">service</a></code> | <code>string</code> | The name of the service provider backing the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.serviceAccount">serviceAccount</a></code> | <code>aws-cdk-lib.aws_eks.ServiceAccount</code> | A Kubernetes service account mapped to an IAM role that provides the necessary permissions to sychronize secrets from an AWS rpvoder. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the secret store should be created.

---

##### `manifest`<sup>Required</sup> <a name="manifest" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.manifest"></a>

```typescript
public readonly manifest: KubernetesManifest;
```

- *Type:* aws-cdk-lib.aws_eks.KubernetesManifest

The Kubernetes manifest that defines the secret store.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A human friendly name for the secret store.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the secret store should be created.

---

##### `secretStoreName`<sup>Required</sup> <a name="secretStoreName" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.secretStoreName"></a>

```typescript
public readonly secretStoreName: string;
```

- *Type:* string

The name of the secret store as it appears in Kubernetes.

---

##### `service`<sup>Required</sup> <a name="service" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

The name of the service provider backing the secret store.

---

##### `serviceAccount`<sup>Required</sup> <a name="serviceAccount" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: ServiceAccount;
```

- *Type:* aws-cdk-lib.aws_eks.ServiceAccount

A Kubernetes service account mapped to an IAM role that provides the necessary permissions to sychronize secrets from an AWS rpvoder.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.NAME_VALIDATOR_REGEX">NAME_VALIDATOR_REGEX</a></code> | <code>string</code> | The regex pattern used to validate secret store names. |

---

##### `NAME_VALIDATOR_REGEX`<sup>Required</sup> <a name="NAME_VALIDATOR_REGEX" id="cdk-extensions.k8s_aws.SecretsManagerSecretStore.property.NAME_VALIDATOR_REGEX"></a>

```typescript
public readonly NAME_VALIDATOR_REGEX: string;
```

- *Type:* string

The regex pattern used to validate secret store names.

---

### SecurityConfiguration <a name="SecurityConfiguration" id="cdk-extensions.glue.SecurityConfiguration"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue.SecurityConfiguration.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.SecurityConfiguration(scope: Construct, id: string, props: SecurityConfigurationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.SecurityConfigurationProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.SecurityConfiguration.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.SecurityConfiguration.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.SecurityConfiguration.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.SecurityConfigurationProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.SecurityConfiguration.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.SecurityConfiguration.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.SecurityConfiguration.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.SecurityConfiguration.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.SecurityConfiguration.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.SecurityConfiguration.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.SecurityConfiguration.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.SecurityConfiguration.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.SecurityConfiguration.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.SecurityConfiguration.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.SecurityConfiguration.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.SecurityConfiguration.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.key">key</a></code> | <code>aws-cdk-lib.aws_kms.Key</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnSecurityConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.securityConfigurationName">securityConfigurationName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.cloudWatchEncryption">cloudWatchEncryption</a></code> | <code>cdk-extensions.glue.CloudWatchEncryption</code> | {@link SecurityConfigurationProps.cloudWatchEncryption}. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.jobBookmarksEncryption">jobBookmarksEncryption</a></code> | <code>cdk-extensions.glue.JobBookmarksEncryption</code> | {@link SecurityConfigurationProps.jobBookmarksEncryption}. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.name">name</a></code> | <code>string</code> | {@link SecurityConfigurationProps.name}. |
| <code><a href="#cdk-extensions.glue.SecurityConfiguration.property.s3Encryption">s3Encryption</a></code> | <code>cdk-extensions.glue.S3Encryption</code> | {@link SecurityConfigurationProps.s3Encryption}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.SecurityConfiguration.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.SecurityConfiguration.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.SecurityConfiguration.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.SecurityConfiguration.property.key"></a>

```typescript
public readonly key: Key;
```

- *Type:* aws-cdk-lib.aws_kms.Key

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.SecurityConfiguration.property.resource"></a>

```typescript
public readonly resource: CfnSecurityConfiguration;
```

- *Type:* aws-cdk-lib.aws_glue.CfnSecurityConfiguration

---

##### `securityConfigurationName`<sup>Required</sup> <a name="securityConfigurationName" id="cdk-extensions.glue.SecurityConfiguration.property.securityConfigurationName"></a>

```typescript
public readonly securityConfigurationName: string;
```

- *Type:* string

---

##### `cloudWatchEncryption`<sup>Optional</sup> <a name="cloudWatchEncryption" id="cdk-extensions.glue.SecurityConfiguration.property.cloudWatchEncryption"></a>

```typescript
public readonly cloudWatchEncryption: CloudWatchEncryption;
```

- *Type:* cdk-extensions.glue.CloudWatchEncryption

{@link SecurityConfigurationProps.cloudWatchEncryption}.

---

##### `jobBookmarksEncryption`<sup>Optional</sup> <a name="jobBookmarksEncryption" id="cdk-extensions.glue.SecurityConfiguration.property.jobBookmarksEncryption"></a>

```typescript
public readonly jobBookmarksEncryption: JobBookmarksEncryption;
```

- *Type:* cdk-extensions.glue.JobBookmarksEncryption

{@link SecurityConfigurationProps.jobBookmarksEncryption}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.SecurityConfiguration.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link SecurityConfigurationProps.name}.

---

##### `s3Encryption`<sup>Optional</sup> <a name="s3Encryption" id="cdk-extensions.glue.SecurityConfiguration.property.s3Encryption"></a>

```typescript
public readonly s3Encryption: S3Encryption;
```

- *Type:* cdk-extensions.glue.S3Encryption

{@link SecurityConfigurationProps.s3Encryption}.

---


### SesLogsBucket <a name="SesLogsBucket" id="cdk-extensions.s3_buckets.SesLogsBucket"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.s3_buckets.SesLogsBucket.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

new s3_buckets.SesLogsBucket(scope: Construct, id: string, props?: SesLogsBucketProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.s3_buckets.SesLogsBucketProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.SesLogsBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.s3_buckets.SesLogsBucket.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.s3_buckets.SesLogsBucket.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.s3_buckets.SesLogsBucketProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.addEventNotification">addEventNotification</a></code> | Adds a bucket notification event destination. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.addObjectCreatedNotification">addObjectCreatedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 created in the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.addObjectRemovedNotification">addObjectRemovedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 removed from the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.addToResourcePolicy">addToResourcePolicy</a></code> | Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.arnForObjects">arnForObjects</a></code> | Returns an ARN that represents all objects within the bucket that match
 the key pattern specified. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.enableEventBridgeNotification">enableEventBridgeNotification</a></code> | Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.grantDelete">grantDelete</a></code> | Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.grantPublicAccess">grantPublicAccess</a></code> | Allows unrestricted access to objects from this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.grantPut">grantPut</a></code> | Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.grantPutAcl">grantPutAcl</a></code> | Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.grantRead">grantRead</a></code> | Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.grantReadWrite">grantReadWrite</a></code> | Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.grantWrite">grantWrite</a></code> | Grant write permissions to this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailEvent">onCloudTrailEvent</a></code> | Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailPutObject">onCloudTrailPutObject</a></code> | Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailWriteObject">onCloudTrailWriteObject</a></code> | Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.s3UrlForObject">s3UrlForObject</a></code> | The S3 URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.transferAccelerationUrlForObject">transferAccelerationUrlForObject</a></code> | The https Transfer Acceleration URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.urlForObject">urlForObject</a></code> | The https URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.virtualHostedUrlForObject">virtualHostedUrlForObject</a></code> | The virtual hosted-style URL of an S3 object. |

---

##### `toString` <a name="toString" id="cdk-extensions.s3_buckets.SesLogsBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.s3_buckets.SesLogsBucket.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.s3_buckets.SesLogsBucket.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addEventNotification` <a name="addEventNotification" id="cdk-extensions.s3_buckets.SesLogsBucket.addEventNotification"></a>

```typescript
public addEventNotification(_event: EventType, _dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Adds a bucket notification event destination.

###### `_event`<sup>Required</sup> <a name="_event" id="cdk-extensions.s3_buckets.SesLogsBucket.addEventNotification.parameter._event"></a>

- *Type:* aws-cdk-lib.aws_s3.EventType

---

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.SesLogsBucket.addEventNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.SesLogsBucket.addEventNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectCreatedNotification` <a name="addObjectCreatedNotification" id="cdk-extensions.s3_buckets.SesLogsBucket.addObjectCreatedNotification"></a>

```typescript
public addObjectCreatedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 created in the bucket.

This is identical to calling
`onEvent(s3.EventType.OBJECT_CREATED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.SesLogsBucket.addObjectCreatedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.SesLogsBucket.addObjectCreatedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectRemovedNotification` <a name="addObjectRemovedNotification" id="cdk-extensions.s3_buckets.SesLogsBucket.addObjectRemovedNotification"></a>

```typescript
public addObjectRemovedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 removed from the bucket.

This is identical to calling
`onEvent(EventType.OBJECT_REMOVED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.SesLogsBucket.addObjectRemovedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.SesLogsBucket.addObjectRemovedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addToResourcePolicy` <a name="addToResourcePolicy" id="cdk-extensions.s3_buckets.SesLogsBucket.addToResourcePolicy"></a>

```typescript
public addToResourcePolicy(permission: PolicyStatement): AddToResourcePolicyResult
```

Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases.

###### `permission`<sup>Required</sup> <a name="permission" id="cdk-extensions.s3_buckets.SesLogsBucket.addToResourcePolicy.parameter.permission"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `arnForObjects` <a name="arnForObjects" id="cdk-extensions.s3_buckets.SesLogsBucket.arnForObjects"></a>

```typescript
public arnForObjects(_keyPattern: string): string
```

Returns an ARN that represents all objects within the bucket that match
 the key pattern specified.

To represent all keys, specify ``"*"``.

###### `_keyPattern`<sup>Required</sup> <a name="_keyPattern" id="cdk-extensions.s3_buckets.SesLogsBucket.arnForObjects.parameter._keyPattern"></a>

- *Type:* string

---

##### `enableEventBridgeNotification` <a name="enableEventBridgeNotification" id="cdk-extensions.s3_buckets.SesLogsBucket.enableEventBridgeNotification"></a>

```typescript
public enableEventBridgeNotification(): void
```

Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted.

##### `grantDelete` <a name="grantDelete" id="cdk-extensions.s3_buckets.SesLogsBucket.grantDelete"></a>

```typescript
public grantDelete(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.SesLogsBucket.grantDelete.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.SesLogsBucket.grantDelete.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPublicAccess` <a name="grantPublicAccess" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPublicAccess"></a>

```typescript
public grantPublicAccess(_allowedActions: string, _keyPrefix?: string): Grant
```

Allows unrestricted access to objects from this bucket.

IMPORTANT: This permission allows anyone to perform actions on S3 objects
in this bucket, which is useful for when you configure your bucket as a
website and want everyone to be able to read objects in the bucket without
needing to authenticate.

Without arguments, this method will grant read ("s3:GetObject") access to
all objects ("*") in the bucket.

The method returns the `iam.Grant` object, which can then be modified
as needed. For example, you can add a condition that will restrict access only
to an IPv4 range like this:

     const grant = bucket.grantPublicAccess();
     grant.resourceStatement!.addCondition(‘IpAddress’, { “aws:SourceIp”: “54.240.143.0/24” });

###### `_allowedActions`<sup>Required</sup> <a name="_allowedActions" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPublicAccess.parameter._allowedActions"></a>

- *Type:* string

---

###### `_keyPrefix`<sup>Optional</sup> <a name="_keyPrefix" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPublicAccess.parameter._keyPrefix"></a>

- *Type:* string

---

##### `grantPut` <a name="grantPut" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPut"></a>

```typescript
public grantPut(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPut.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPut.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPutAcl` <a name="grantPutAcl" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPutAcl"></a>

```typescript
public grantPutAcl(_identity: IGrantable, _objectsKeyPattern?: string): Grant
```

Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket.

If your application has the '@aws-cdk/aws-s3:grantWriteWithoutAcl' feature flag set,
calling `grantWrite` or `grantReadWrite` no longer grants permissions to modify the ACLs of the objects;
in this case, if you need to modify object ACLs, call this method explicitly.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPutAcl.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.SesLogsBucket.grantPutAcl.parameter._objectsKeyPattern"></a>

- *Type:* string

---

##### `grantRead` <a name="grantRead" id="cdk-extensions.s3_buckets.SesLogsBucket.grantRead"></a>

```typescript
public grantRead(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If encryption is used, permission to use the key to decrypt the contents
of the bucket will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.SesLogsBucket.grantRead.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.SesLogsBucket.grantRead.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk-extensions.s3_buckets.SesLogsBucket.grantReadWrite"></a>

```typescript
public grantReadWrite(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If an encryption key is used, permission to use the key for
encrypt/decrypt will also be granted.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.SesLogsBucket.grantReadWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.SesLogsBucket.grantReadWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantWrite` <a name="grantWrite" id="cdk-extensions.s3_buckets.SesLogsBucket.grantWrite"></a>

```typescript
public grantWrite(_identity: IGrantable, _objectsKeyPattern?: any, _allowedActionPatterns?: string[]): Grant
```

Grant write permissions to this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.SesLogsBucket.grantWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.SesLogsBucket.grantWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

###### `_allowedActionPatterns`<sup>Optional</sup> <a name="_allowedActionPatterns" id="cdk-extensions.s3_buckets.SesLogsBucket.grantWrite.parameter._allowedActionPatterns"></a>

- *Type:* string[]

---

##### `onCloudTrailEvent` <a name="onCloudTrailEvent" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailEvent"></a>

```typescript
public onCloudTrailEvent(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event.

This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailEvent.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailEvent.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailPutObject` <a name="onCloudTrailPutObject" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailPutObject"></a>

```typescript
public onCloudTrailPutObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using `onCloudTrailWriteObject` may be preferable.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailPutObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailPutObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailWriteObject` <a name="onCloudTrailWriteObject" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailWriteObject"></a>

```typescript
public onCloudTrailWriteObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to.

This includes
the events PutObject, CopyObject, and CompleteMultipartUpload.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using this method may be preferable to `onCloudTrailPutObject`.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailWriteObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.SesLogsBucket.onCloudTrailWriteObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `s3UrlForObject` <a name="s3UrlForObject" id="cdk-extensions.s3_buckets.SesLogsBucket.s3UrlForObject"></a>

```typescript
public s3UrlForObject(_key?: string): string
```

The S3 URL of an S3 object.

For example:
- `s3://onlybucket`
- `s3://bucket/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.SesLogsBucket.s3UrlForObject.parameter._key"></a>

- *Type:* string

---

##### `transferAccelerationUrlForObject` <a name="transferAccelerationUrlForObject" id="cdk-extensions.s3_buckets.SesLogsBucket.transferAccelerationUrlForObject"></a>

```typescript
public transferAccelerationUrlForObject(_key?: string, _options?: TransferAccelerationUrlOptions): string
```

The https Transfer Acceleration URL of an S3 object.

Specify `dualStack: true` at the options
for dual-stack endpoint (connect to the bucket over IPv6). For example:

- `https://bucket.s3-accelerate.amazonaws.com`
- `https://bucket.s3-accelerate.amazonaws.com/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.SesLogsBucket.transferAccelerationUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.SesLogsBucket.transferAccelerationUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.TransferAccelerationUrlOptions

---

##### `urlForObject` <a name="urlForObject" id="cdk-extensions.s3_buckets.SesLogsBucket.urlForObject"></a>

```typescript
public urlForObject(_key?: string): string
```

The https URL of an S3 object.

For example:

- `https://s3.us-west-1.amazonaws.com/onlybucket`
- `https://s3.us-west-1.amazonaws.com/bucket/key`
- `https://s3.cn-north-1.amazonaws.com.cn/china-bucket/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.SesLogsBucket.urlForObject.parameter._key"></a>

- *Type:* string

---

##### `virtualHostedUrlForObject` <a name="virtualHostedUrlForObject" id="cdk-extensions.s3_buckets.SesLogsBucket.virtualHostedUrlForObject"></a>

```typescript
public virtualHostedUrlForObject(_key?: string, _options?: VirtualHostedStyleUrlOptions): string
```

The virtual hosted-style URL of an S3 object.

Specify `regional: false` at
the options for non-regional URL. For example:

- `https://only-bucket.s3.us-west-1.amazonaws.com`
- `https://bucket.s3.us-west-1.amazonaws.com/key`
- `https://bucket.s3.amazonaws.com/key`
- `https://china-bucket.s3.cn-north-1.amazonaws.com.cn/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.SesLogsBucket.virtualHostedUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.SesLogsBucket.virtualHostedUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.VirtualHostedStyleUrlOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.s3_buckets.SesLogsBucket.isConstruct"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.SesLogsBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.s3_buckets.SesLogsBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.s3_buckets.SesLogsBucket.isOwnedResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.SesLogsBucket.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.SesLogsBucket.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.s3_buckets.SesLogsBucket.isResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.SesLogsBucket.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.SesLogsBucket.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.bucketArn">bucketArn</a></code> | <code>string</code> | The ARN of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | The IPv4 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.bucketDualStackDomainName">bucketDualStackDomainName</a></code> | <code>string</code> | The IPv6 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.bucketName">bucketName</a></code> | <code>string</code> | The name of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.bucketRegionalDomainName">bucketRegionalDomainName</a></code> | <code>string</code> | The regional domain name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.bucketWebsiteDomainName">bucketWebsiteDomainName</a></code> | <code>string</code> | The Domain name of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.bucketWebsiteUrl">bucketWebsiteUrl</a></code> | <code>string</code> | The URL of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_s3.CfnBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | Optional KMS encryption key associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.isWebsite">isWebsite</a></code> | <code>boolean</code> | If this bucket has been configured for static website hosting. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.policy">policy</a></code> | <code>aws-cdk-lib.aws_s3.BucketPolicy</code> | The resource policy associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.table">table</a></code> | <code>cdk-extensions.glue_tables.SesLogsTable</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucket.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.s3_buckets.SesLogsBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.s3_buckets.SesLogsBucket.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.s3_buckets.SesLogsBucket.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bucketArn`<sup>Required</sup> <a name="bucketArn" id="cdk-extensions.s3_buckets.SesLogsBucket.property.bucketArn"></a>

```typescript
public readonly bucketArn: string;
```

- *Type:* string

The ARN of the bucket.

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="cdk-extensions.s3_buckets.SesLogsBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

The IPv4 DNS name of the specified bucket.

---

##### `bucketDualStackDomainName`<sup>Required</sup> <a name="bucketDualStackDomainName" id="cdk-extensions.s3_buckets.SesLogsBucket.property.bucketDualStackDomainName"></a>

```typescript
public readonly bucketDualStackDomainName: string;
```

- *Type:* string

The IPv6 DNS name of the specified bucket.

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.SesLogsBucket.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

The name of the bucket.

---

##### `bucketRegionalDomainName`<sup>Required</sup> <a name="bucketRegionalDomainName" id="cdk-extensions.s3_buckets.SesLogsBucket.property.bucketRegionalDomainName"></a>

```typescript
public readonly bucketRegionalDomainName: string;
```

- *Type:* string

The regional domain name of the specified bucket.

---

##### `bucketWebsiteDomainName`<sup>Required</sup> <a name="bucketWebsiteDomainName" id="cdk-extensions.s3_buckets.SesLogsBucket.property.bucketWebsiteDomainName"></a>

```typescript
public readonly bucketWebsiteDomainName: string;
```

- *Type:* string

The Domain name of the static website.

---

##### `bucketWebsiteUrl`<sup>Required</sup> <a name="bucketWebsiteUrl" id="cdk-extensions.s3_buckets.SesLogsBucket.property.bucketWebsiteUrl"></a>

```typescript
public readonly bucketWebsiteUrl: string;
```

- *Type:* string

The URL of the static website.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.s3_buckets.SesLogsBucket.property.resource"></a>

```typescript
public readonly resource: CfnBucket;
```

- *Type:* aws-cdk-lib.aws_s3.CfnBucket

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.s3_buckets.SesLogsBucket.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

Optional KMS encryption key associated with this bucket.

---

##### `isWebsite`<sup>Optional</sup> <a name="isWebsite" id="cdk-extensions.s3_buckets.SesLogsBucket.property.isWebsite"></a>

```typescript
public readonly isWebsite: boolean;
```

- *Type:* boolean

If this bucket has been configured for static website hosting.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk-extensions.s3_buckets.SesLogsBucket.property.policy"></a>

```typescript
public readonly policy: BucketPolicy;
```

- *Type:* aws-cdk-lib.aws_s3.BucketPolicy

The resource policy associated with this bucket.

If `autoCreatePolicy` is true, a `BucketPolicy` will be created upon the
first call to addToResourcePolicy(s).

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.s3_buckets.SesLogsBucket.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.s3_buckets.SesLogsBucket.property.table"></a>

```typescript
public readonly table: SesLogsTable;
```

- *Type:* cdk-extensions.glue_tables.SesLogsTable

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.SesLogsBucket.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.SesLogsBucket.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---


### SesLogsTable <a name="SesLogsTable" id="cdk-extensions.glue_tables.SesLogsTable"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue_tables.SesLogsTable.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

new glue_tables.SesLogsTable(scope: Construct, id: string, props: SesLogsTableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue_tables.SesLogsTableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue_tables.SesLogsTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue_tables.SesLogsTable.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue_tables.SesLogsTable.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue_tables.SesLogsTableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.addColumn">addColumn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.addParameter">addParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.addPartitionKey">addPartitionKey</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.addSerdeParameter">addSerdeParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.addStorageParameter">addStorageParameter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue_tables.SesLogsTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue_tables.SesLogsTable.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue_tables.SesLogsTable.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue_tables.SesLogsTable.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.SesLogsTable.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.glue_tables.SesLogsTable.addParameter"></a>

```typescript
public addParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.SesLogsTable.addParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.SesLogsTable.addParameter.parameter.value"></a>

- *Type:* string

---

##### `addPartitionKey` <a name="addPartitionKey" id="cdk-extensions.glue_tables.SesLogsTable.addPartitionKey"></a>

```typescript
public addPartitionKey(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.SesLogsTable.addPartitionKey.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addSerdeParameter` <a name="addSerdeParameter" id="cdk-extensions.glue_tables.SesLogsTable.addSerdeParameter"></a>

```typescript
public addSerdeParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.SesLogsTable.addSerdeParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.SesLogsTable.addSerdeParameter.parameter.value"></a>

- *Type:* string

---

##### `addStorageParameter` <a name="addStorageParameter" id="cdk-extensions.glue_tables.SesLogsTable.addStorageParameter"></a>

```typescript
public addStorageParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.SesLogsTable.addStorageParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.SesLogsTable.addStorageParameter.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue_tables.SesLogsTable.isConstruct"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.SesLogsTable.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue_tables.SesLogsTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue_tables.SesLogsTable.isOwnedResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.SesLogsTable.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.SesLogsTable.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue_tables.SesLogsTable.isResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.SesLogsTable.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.SesLogsTable.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link TableProps.database:}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTable</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.tableArn">tableArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.compressed">compressed</a></code> | <code>boolean</code> | {@link TableProps.compressed}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | {@link TableProps.dataFormat}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.description">description</a></code> | <code>string</code> | {@link TableProps.description}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.location">location</a></code> | <code>string</code> | {@link TableProps.location}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.name">name</a></code> | <code>string</code> | {@link TableProps.name}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.owner">owner</a></code> | <code>string</code> | {@link TableProps.owner}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | {@link TableProps.retention}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.serdeName">serdeName</a></code> | <code>string</code> | {@link TableProps.serdeName}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | {@link TableProps.storedAsSubDirectories}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | {@link TableProps.tableType}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | {@link TableProps.targetTable}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | {@link TableProps.viewExpandedText}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | {@link TableProps.viewOriginalText}. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the Ses Logs. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.bouncesQuery">bouncesQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTable.property.complaintsQuery">complaintsQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue_tables.SesLogsTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue_tables.SesLogsTable.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue_tables.SesLogsTable.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.SesLogsTable.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link TableProps.database:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue_tables.SesLogsTable.property.resource"></a>

```typescript
public readonly resource: CfnTable;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTable

---

##### `tableArn`<sup>Required</sup> <a name="tableArn" id="cdk-extensions.glue_tables.SesLogsTable.property.tableArn"></a>

```typescript
public readonly tableArn: string;
```

- *Type:* string

---

##### `tableName`<sup>Required</sup> <a name="tableName" id="cdk-extensions.glue_tables.SesLogsTable.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue_tables.SesLogsTable.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

{@link TableProps.compressed}.

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue_tables.SesLogsTable.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

{@link TableProps.dataFormat}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue_tables.SesLogsTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link TableProps.description}.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue_tables.SesLogsTable.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

{@link TableProps.location}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.SesLogsTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link TableProps.name}.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue_tables.SesLogsTable.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

{@link TableProps.owner}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue_tables.SesLogsTable.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link TableProps.retention}.

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue_tables.SesLogsTable.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

{@link TableProps.serdeName}.

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue_tables.SesLogsTable.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

{@link TableProps.storedAsSubDirectories}.

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue_tables.SesLogsTable.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

{@link TableProps.tableType}.

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue_tables.SesLogsTable.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

{@link TableProps.targetTable}.

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue_tables.SesLogsTable.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

{@link TableProps.viewExpandedText}.

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue_tables.SesLogsTable.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

{@link TableProps.viewOriginalText}.

---

##### `createQueries`<sup>Required</sup> <a name="createQueries" id="cdk-extensions.glue_tables.SesLogsTable.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the Ses Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Required</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.SesLogsTable.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `bouncesQuery`<sup>Optional</sup> <a name="bouncesQuery" id="cdk-extensions.glue_tables.SesLogsTable.property.bouncesQuery"></a>

```typescript
public readonly bouncesQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---

##### `complaintsQuery`<sup>Optional</sup> <a name="complaintsQuery" id="cdk-extensions.glue_tables.SesLogsTable.property.complaintsQuery"></a>

```typescript
public readonly complaintsQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---


### Site <a name="Site" id="cdk-extensions.networkmanager.Site"></a>

- *Implements:* cdk-extensions.networkmanager.ISite

#### Initializers <a name="Initializers" id="cdk-extensions.networkmanager.Site.Initializer"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

new networkmanager.Site(scope: IConstruct, id: string, props: SiteProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.Site.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.networkmanager.SiteProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.networkmanager.Site.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.networkmanager.Site.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.networkmanager.Site.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.networkmanager.SiteProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.networkmanager.Site.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.networkmanager.Site.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.networkmanager.Site.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.networkmanager.Site.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.networkmanager.Site.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.networkmanager.Site.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.networkmanager.Site.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.networkmanager.Site.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.networkmanager.Site.isConstruct"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.Site.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.networkmanager.Site.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.networkmanager.Site.isOwnedResource"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.Site.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.networkmanager.Site.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.networkmanager.Site.isResource"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.Site.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.networkmanager.Site.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.Site.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.networkmanager.Site.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.Site.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.networkmanager.Site.property.globalNetwork">globalNetwork</a></code> | <code>cdk-extensions.networkmanager.IGlobalNetwork</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.property.siteArn">siteArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.property.siteId">siteId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.property.latitude">latitude</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.property.longitude">longitude</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.Site.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_networkmanager.CfnSite</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.networkmanager.Site.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.networkmanager.Site.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.networkmanager.Site.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `globalNetwork`<sup>Required</sup> <a name="globalNetwork" id="cdk-extensions.networkmanager.Site.property.globalNetwork"></a>

```typescript
public readonly globalNetwork: IGlobalNetwork;
```

- *Type:* cdk-extensions.networkmanager.IGlobalNetwork

---

##### `siteArn`<sup>Required</sup> <a name="siteArn" id="cdk-extensions.networkmanager.Site.property.siteArn"></a>

```typescript
public readonly siteArn: string;
```

- *Type:* string

---

##### `siteId`<sup>Required</sup> <a name="siteId" id="cdk-extensions.networkmanager.Site.property.siteId"></a>

```typescript
public readonly siteId: string;
```

- *Type:* string

---

##### `address`<sup>Optional</sup> <a name="address" id="cdk-extensions.networkmanager.Site.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.networkmanager.Site.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `latitude`<sup>Optional</sup> <a name="latitude" id="cdk-extensions.networkmanager.Site.property.latitude"></a>

```typescript
public readonly latitude: string;
```

- *Type:* string

---

##### `longitude`<sup>Optional</sup> <a name="longitude" id="cdk-extensions.networkmanager.Site.property.longitude"></a>

```typescript
public readonly longitude: string;
```

- *Type:* string

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk-extensions.networkmanager.Site.property.resource"></a>

```typescript
public readonly resource: CfnSite;
```

- *Type:* aws-cdk-lib.aws_networkmanager.CfnSite

---


### SsmParameterSecretStore <a name="SsmParameterSecretStore" id="cdk-extensions.k8s_aws.SsmParameterSecretStore"></a>

A secret store that allows parameters from Systems Manager to be synchronized into Kubernetes as Kubernetes secrets.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.SsmParameterSecretStore(scope: Construct, id: string, props: SsmParameterSecretStoreProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the resource and used in resource naming. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.k8s_aws.SsmParameterSecretStoreProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the resource and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.k8s_aws.SsmParameterSecretStoreProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.addSecret">addSecret</a></code> | Registers a new SSSM parameter to be synchronized into Kubernetes. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addSecret` <a name="addSecret" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.addSecret"></a>

```typescript
public addSecret(id: string, parameter: IParameter, options?: ExternalSecretOptions): ExternalSecret
```

Registers a new SSSM parameter to be synchronized into Kubernetes.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.addSecret.parameter.id"></a>

- *Type:* string

The ID of the secret import configuration in the CDK construct tree.

The configuration is placed under the SSM parameter it synchronizes and so
must be unique per secret.

---

###### `parameter`<sup>Required</sup> <a name="parameter" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.addSecret.parameter.parameter"></a>

- *Type:* aws-cdk-lib.aws_ssm.IParameter

The SSM parameter to synchronize into Kubernetes.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.addSecret.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.ExternalSecretOptions

Configuration options for how the secret should be synchronized.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.isConstruct"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.SsmParameterSecretStore.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.isOwnedResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.SsmParameterSecretStore.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.isResource"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.SsmParameterSecretStore.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.manifest">manifest</a></code> | <code>aws-cdk-lib.aws_eks.KubernetesManifest</code> | The Kubernetes manifest that defines the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.name">name</a></code> | <code>string</code> | A human friendly name for the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.secretStoreName">secretStoreName</a></code> | <code>string</code> | The name of the secret store as it appears in Kubernetes. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.service">service</a></code> | <code>string</code> | The name of the service provider backing the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.serviceAccount">serviceAccount</a></code> | <code>aws-cdk-lib.aws_eks.ServiceAccount</code> | A Kubernetes service account mapped to an IAM role that provides the necessary permissions to sychronize secrets from an AWS rpvoder. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the secret store should be created.

---

##### `manifest`<sup>Required</sup> <a name="manifest" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.manifest"></a>

```typescript
public readonly manifest: KubernetesManifest;
```

- *Type:* aws-cdk-lib.aws_eks.KubernetesManifest

The Kubernetes manifest that defines the secret store.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A human friendly name for the secret store.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the secret store should be created.

---

##### `secretStoreName`<sup>Required</sup> <a name="secretStoreName" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.secretStoreName"></a>

```typescript
public readonly secretStoreName: string;
```

- *Type:* string

The name of the secret store as it appears in Kubernetes.

---

##### `service`<sup>Required</sup> <a name="service" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

The name of the service provider backing the secret store.

---

##### `serviceAccount`<sup>Required</sup> <a name="serviceAccount" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: ServiceAccount;
```

- *Type:* aws-cdk-lib.aws_eks.ServiceAccount

A Kubernetes service account mapped to an IAM role that provides the necessary permissions to sychronize secrets from an AWS rpvoder.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStore.property.NAME_VALIDATOR_REGEX">NAME_VALIDATOR_REGEX</a></code> | <code>string</code> | The regex pattern used to validate secret store names. |

---

##### `NAME_VALIDATOR_REGEX`<sup>Required</sup> <a name="NAME_VALIDATOR_REGEX" id="cdk-extensions.k8s_aws.SsmParameterSecretStore.property.NAME_VALIDATOR_REGEX"></a>

```typescript
public readonly NAME_VALIDATOR_REGEX: string;
```

- *Type:* string

The regex pattern used to validate secret store names.

---

### Table <a name="Table" id="cdk-extensions.glue.Table"></a>

Creates a Table resource specifying tabular data in the Glue Database.

> [[AWS::Glue::Table](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-table.html)]([AWS::Glue::Table](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-table.html))

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Table.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Table(scope: Construct, id: string, props: TableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Table.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue.Table.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue.Table.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.TableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Table.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Table.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.Table.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.TableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Table.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.Table.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue.Table.addColumn">addColumn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Table.addParameter">addParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Table.addPartitionKey">addPartitionKey</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Table.addSerdeParameter">addSerdeParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Table.addStorageParameter">addStorageParameter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.Table.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.Table.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.Table.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue.Table.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue.Table.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.glue.Table.addParameter"></a>

```typescript
public addParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.Table.addParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.Table.addParameter.parameter.value"></a>

- *Type:* string

---

##### `addPartitionKey` <a name="addPartitionKey" id="cdk-extensions.glue.Table.addPartitionKey"></a>

```typescript
public addPartitionKey(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue.Table.addPartitionKey.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addSerdeParameter` <a name="addSerdeParameter" id="cdk-extensions.glue.Table.addSerdeParameter"></a>

```typescript
public addSerdeParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.Table.addSerdeParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.Table.addSerdeParameter.parameter.value"></a>

- *Type:* string

---

##### `addStorageParameter` <a name="addStorageParameter" id="cdk-extensions.glue.Table.addStorageParameter"></a>

```typescript
public addStorageParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.Table.addStorageParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.Table.addStorageParameter.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Table.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.Table.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.Table.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.Table.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Table.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.Table.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.Table.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Table.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Table.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.Table.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Table.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Table.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Table.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.Table.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.Table.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.Table.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link TableProps.database:}. |
| <code><a href="#cdk-extensions.glue.Table.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTable</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Table.property.tableArn">tableArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Table.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Table.property.compressed">compressed</a></code> | <code>boolean</code> | {@link TableProps.compressed}. |
| <code><a href="#cdk-extensions.glue.Table.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | {@link TableProps.dataFormat}. |
| <code><a href="#cdk-extensions.glue.Table.property.description">description</a></code> | <code>string</code> | {@link TableProps.description}. |
| <code><a href="#cdk-extensions.glue.Table.property.location">location</a></code> | <code>string</code> | {@link TableProps.location}. |
| <code><a href="#cdk-extensions.glue.Table.property.name">name</a></code> | <code>string</code> | {@link TableProps.name}. |
| <code><a href="#cdk-extensions.glue.Table.property.owner">owner</a></code> | <code>string</code> | {@link TableProps.owner}. |
| <code><a href="#cdk-extensions.glue.Table.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | {@link TableProps.retention}. |
| <code><a href="#cdk-extensions.glue.Table.property.serdeName">serdeName</a></code> | <code>string</code> | {@link TableProps.serdeName}. |
| <code><a href="#cdk-extensions.glue.Table.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | {@link TableProps.storedAsSubDirectories}. |
| <code><a href="#cdk-extensions.glue.Table.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | {@link TableProps.tableType}. |
| <code><a href="#cdk-extensions.glue.Table.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | {@link TableProps.targetTable}. |
| <code><a href="#cdk-extensions.glue.Table.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | {@link TableProps.viewExpandedText}. |
| <code><a href="#cdk-extensions.glue.Table.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | {@link TableProps.viewOriginalText}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.Table.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.Table.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.Table.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue.Table.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link TableProps.database:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.Table.property.resource"></a>

```typescript
public readonly resource: CfnTable;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTable

---

##### `tableArn`<sup>Required</sup> <a name="tableArn" id="cdk-extensions.glue.Table.property.tableArn"></a>

```typescript
public readonly tableArn: string;
```

- *Type:* string

---

##### `tableName`<sup>Required</sup> <a name="tableName" id="cdk-extensions.glue.Table.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue.Table.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

{@link TableProps.compressed}.

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue.Table.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

{@link TableProps.dataFormat}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.Table.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link TableProps.description}.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue.Table.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

{@link TableProps.location}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.Table.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link TableProps.name}.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue.Table.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

{@link TableProps.owner}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue.Table.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link TableProps.retention}.

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue.Table.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

{@link TableProps.serdeName}.

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue.Table.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

{@link TableProps.storedAsSubDirectories}.

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue.Table.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

{@link TableProps.tableType}.

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue.Table.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

{@link TableProps.targetTable}.

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue.Table.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

{@link TableProps.viewExpandedText}.

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue.Table.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

{@link TableProps.viewOriginalText}.

---


### TimeInterval <a name="TimeInterval" id="cdk-extensions.aps.TimeInterval"></a>

Represents a named interval of time that may be referenced by the alert manager router to mute/activate particular routes for particular times of day.

> [[Time Interval Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#time_interval-0)]([Time Interval Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#time_interval-0))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.TimeInterval.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.TimeInterval(scope: AlertManagerConfiguration, id: string, options: TimeIntervalProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.TimeInterval.Initializer.parameter.scope">scope</a></code> | <code>cdk-extensions.aps.AlertManagerConfiguration</code> | A CDK Construct that will serve as this construct's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.TimeInterval.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.TimeInterval.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.aps.TimeIntervalProps</code> | Arguments related to the configuration of this construct. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.TimeInterval.Initializer.parameter.scope"></a>

- *Type:* cdk-extensions.aps.AlertManagerConfiguration

A CDK Construct that will serve as this construct's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.TimeInterval.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.TimeInterval.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.aps.TimeIntervalProps

Arguments related to the configuration of this construct.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.TimeInterval.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.TimeInterval.addInterval">addInterval</a></code> | Adds a new time interval entry to the time interval. |
| <code><a href="#cdk-extensions.aps.TimeInterval.bind">bind</a></code> | Associates the time interval with a construct that is handling the configuration of alert manager. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.TimeInterval.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addInterval` <a name="addInterval" id="cdk-extensions.aps.TimeInterval.addInterval"></a>

```typescript
public addInterval(interval: TimeIntervalEntry): TimeIntervalEntry
```

Adds a new time interval entry to the time interval.

###### `interval`<sup>Required</sup> <a name="interval" id="cdk-extensions.aps.TimeInterval.addInterval.parameter.interval"></a>

- *Type:* cdk-extensions.aps.TimeIntervalEntry

The the time interval entry to be added.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.TimeInterval.bind"></a>

```typescript
public bind(scope: IConstruct): {[ key: string ]: any}
```

Associates the time interval with a construct that is handling the configuration of alert manager.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.TimeInterval.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.TimeInterval.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.TimeInterval.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.TimeInterval.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.TimeInterval.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.TimeInterval.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.TimeInterval.property.intervals">intervals</a></code> | <code>cdk-extensions.aps.TimeIntervalEntry[]</code> | Collection of interval entries that defined the the full scope of the periods for which the time interval should apply. |
| <code><a href="#cdk-extensions.aps.TimeInterval.property.name">name</a></code> | <code>string</code> | The name of the time interval as it will be referenced throught the rest of the alert manager configuration. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.TimeInterval.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `intervals`<sup>Required</sup> <a name="intervals" id="cdk-extensions.aps.TimeInterval.property.intervals"></a>

```typescript
public readonly intervals: TimeIntervalEntry[];
```

- *Type:* cdk-extensions.aps.TimeIntervalEntry[]

Collection of interval entries that defined the the full scope of the periods for which the time interval should apply.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.aps.TimeInterval.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the time interval as it will be referenced throught the rest of the alert manager configuration.

---


### TransitGateway <a name="TransitGateway" id="cdk-extensions.ec2.TransitGateway"></a>

- *Implements:* cdk-extensions.ec2.ITransitGateway

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGateway.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGateway(scope: Construct, id: string, props?: TransitGatewayProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGateway.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.TransitGatewayProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGateway.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGateway.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.TransitGateway.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGateway.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.addCidrBlock">addCidrBlock</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGateway.addRouteTable">addRouteTable</a></code> | Creates a new Transit Gateway Route Table for this Transit Gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.addVpn">addVpn</a></code> | Creates a new VPN connection that terminates on the AWS side at this Transit Gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.attachPeer">attachPeer</a></code> | Creates a new transit gateway peering attachment for this transit gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.attachVpc">attachVpc</a></code> | Creates a new VPC transit gateway attachment for this transit gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.enableSharing">enableSharing</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.TransitGateway.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.TransitGateway.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.TransitGateway.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addCidrBlock` <a name="addCidrBlock" id="cdk-extensions.ec2.TransitGateway.addCidrBlock"></a>

```typescript
public addCidrBlock(cidr: string): void
```

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.TransitGateway.addCidrBlock.parameter.cidr"></a>

- *Type:* string

---

##### `addRouteTable` <a name="addRouteTable" id="cdk-extensions.ec2.TransitGateway.addRouteTable"></a>

```typescript
public addRouteTable(options?: TransitGatewayRouteTableOptions): TransitGatewayRouteTable
```

Creates a new Transit Gateway Route Table for this Transit Gateway.

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.TransitGateway.addRouteTable.parameter.options"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayRouteTableOptions

Options used for configuring the Transit Gateway Route Table.

---

##### `addVpn` <a name="addVpn" id="cdk-extensions.ec2.TransitGateway.addVpn"></a>

```typescript
public addVpn(id: string, options: VpnAttachmentOptions): VpnConnection
```

Creates a new VPN connection that terminates on the AWS side at this Transit Gateway.

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGateway.addVpn.parameter.id"></a>

- *Type:* string

A unique identifier for this VPN connection.

Must be unique
within the context of scope.

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.TransitGateway.addVpn.parameter.options"></a>

- *Type:* cdk-extensions.ec2.VpnAttachmentOptions

The options for configuring the VPN connection.

---

##### `attachPeer` <a name="attachPeer" id="cdk-extensions.ec2.TransitGateway.attachPeer"></a>

```typescript
public attachPeer(peer: ITransitGateway, options?: TransitGatewayPeeringAttachmentOptions): TransitGatewayPeeringAttachment
```

Creates a new transit gateway peering attachment for this transit gateway.

###### `peer`<sup>Required</sup> <a name="peer" id="cdk-extensions.ec2.TransitGateway.attachPeer.parameter.peer"></a>

- *Type:* cdk-extensions.ec2.ITransitGateway

The remote transit gateway to create the peering connection with.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.TransitGateway.attachPeer.parameter.options"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions

Options used to configure the peering connection.

---

##### `attachVpc` <a name="attachVpc" id="cdk-extensions.ec2.TransitGateway.attachVpc"></a>

```typescript
public attachVpc(vpc: IVpc, options?: VpcAttachmentOptions): TransitGatewayAttachment
```

Creates a new VPC transit gateway attachment for this transit gateway.

###### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.ec2.TransitGateway.attachVpc.parameter.vpc"></a>

- *Type:* aws-cdk-lib.aws_ec2.IVpc

The VPC to connect to this Transit Gateway.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.TransitGateway.attachVpc.parameter.options"></a>

- *Type:* cdk-extensions.ec2.VpcAttachmentOptions

Options used for configuring the Transit Gateway Attachment.

---

##### `enableSharing` <a name="enableSharing" id="cdk-extensions.ec2.TransitGateway.enableSharing"></a>

```typescript
public enableSharing(options?: SharingOptions): ResourceShare
```

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.TransitGateway.enableSharing.parameter.options"></a>

- *Type:* cdk-extensions.ec2.SharingOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGateway.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.fromTransitGatewayId">fromTransitGatewayId</a></code> | *No description.* |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.TransitGateway.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGateway.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.TransitGateway.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.TransitGateway.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGateway.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGateway.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.TransitGateway.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGateway.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGateway.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromTransitGatewayId` <a name="fromTransitGatewayId" id="cdk-extensions.ec2.TransitGateway.fromTransitGatewayId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGateway.fromTransitGatewayId(scope: IConstruct, id: string, transitGatewayId: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGateway.fromTransitGatewayId.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGateway.fromTransitGatewayId.parameter.id"></a>

- *Type:* string

---

###### `transitGatewayId`<sup>Required</sup> <a name="transitGatewayId" id="cdk-extensions.ec2.TransitGateway.fromTransitGatewayId.parameter.transitGatewayId"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.autoAcceptSharedAttachments">autoAcceptSharedAttachments</a></code> | <code>boolean</code> | Enable or disable automatic acceptance of attachment requests. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.defaultRouteTableAssociation">defaultRouteTableAssociation</a></code> | <code>boolean</code> | Enable or disable automatic association with the default association route table. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.defaultRouteTablePropagation">defaultRouteTablePropagation</a></code> | <code>boolean</code> | Enable or disable automatic propagation of routes to the default propagation route table. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.dnsSupport">dnsSupport</a></code> | <code>boolean</code> | Enable or disable DNS support. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.multicastSupport">multicastSupport</a></code> | <code>boolean</code> | Indicates whether multicast is enabled on the transit gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnTransitGateway</code> | The underlying TransitGateway CloudFormation resource. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.transitGatewayArn">transitGatewayArn</a></code> | <code>string</code> | The ARN of this Transit Gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.transitGatewayId">transitGatewayId</a></code> | <code>string</code> | The ID of this Transit Gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.amazonSideAsn">amazonSideAsn</a></code> | <code>number</code> | A private Autonomous System Number (ASN) for the Amazon side of a BGP session. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.defaultRouteTable">defaultRouteTable</a></code> | <code>cdk-extensions.ec2.ITransitGatewayRouteTable</code> | The default route table that got created along with the Transit Gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.defaultRouteTableId">defaultRouteTableId</a></code> | <code>string</code> | The ID of the default route table that was created with the transit gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.description">description</a></code> | <code>string</code> | The description of the transit gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.name">name</a></code> | <code>string</code> | The name of the transit gateway. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.resourceShare">resourceShare</a></code> | <code>cdk-extensions.ram.ResourceShare</code> | The RAM resource share that is used for sharing the transit gateway with other accounts. |
| <code><a href="#cdk-extensions.ec2.TransitGateway.property.vpnEcmpSupport">vpnEcmpSupport</a></code> | <code>boolean</code> | Enable or disable Equal Cost Multipath Protocol support. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.TransitGateway.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.TransitGateway.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.TransitGateway.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `autoAcceptSharedAttachments`<sup>Required</sup> <a name="autoAcceptSharedAttachments" id="cdk-extensions.ec2.TransitGateway.property.autoAcceptSharedAttachments"></a>

```typescript
public readonly autoAcceptSharedAttachments: boolean;
```

- *Type:* boolean

Enable or disable automatic acceptance of attachment requests.

When enabled any new transit gateway attachments that are created in other
accounts via a resource share will be accepted automatically. Otherwise,
manual intervention will be required to approve all new attachments.

This is disabled by default to maintain the highest levels of security,
however enabling should be strongly considered as without this full
automation of infrastructure will not be possible for cross account
setups.

> [[Accept a shared attachment](https://docs.aws.amazon.com/vpc/latest/tgw/tgw-transit-gateways.html#tgw-accept-shared-attachment)]([Accept a shared attachment](https://docs.aws.amazon.com/vpc/latest/tgw/tgw-transit-gateways.html#tgw-accept-shared-attachment))

---

##### `defaultRouteTableAssociation`<sup>Required</sup> <a name="defaultRouteTableAssociation" id="cdk-extensions.ec2.TransitGateway.property.defaultRouteTableAssociation"></a>

```typescript
public readonly defaultRouteTableAssociation: boolean;
```

- *Type:* boolean

Enable or disable automatic association with the default association route table.

When enabled, all new attachments that are accepted will be automatically
associated with the default association route table. By default this is
the route table that is created automatically when the transit gateway is
created.

> [[TransitGateway.DefaultRouteTableAssociation](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html#cfn-ec2-transitgateway-defaultroutetableassociation)]([TransitGateway.DefaultRouteTableAssociation](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html#cfn-ec2-transitgateway-defaultroutetableassociation))

---

##### `defaultRouteTablePropagation`<sup>Required</sup> <a name="defaultRouteTablePropagation" id="cdk-extensions.ec2.TransitGateway.property.defaultRouteTablePropagation"></a>

```typescript
public readonly defaultRouteTablePropagation: boolean;
```

- *Type:* boolean

Enable or disable automatic propagation of routes to the default propagation route table.

When a new attachment is accepted, the routes associated with that
attachment will automatically be added to the default propagation route
table. By default this is the route table that is created automatically
when the transit gateway is created.

> [[Route propagation](https://docs.aws.amazon.com/vpc/latest/tgw/how-transit-gateways-work.html#tgw-route-propagation-overview)]([Route propagation](https://docs.aws.amazon.com/vpc/latest/tgw/how-transit-gateways-work.html#tgw-route-propagation-overview))

---

##### `dnsSupport`<sup>Required</sup> <a name="dnsSupport" id="cdk-extensions.ec2.TransitGateway.property.dnsSupport"></a>

```typescript
public readonly dnsSupport: boolean;
```

- *Type:* boolean

Enable or disable DNS support.

When DNS support is enabled on a transit gateway, VPC DNS resolution in
attached VPC's will automatically resolve public IP addresses from other
VPC's to their provate IP address equivalent.

> [[Create a transit gateway](https://docs.aws.amazon.com/vpc/latest/tgw/tgw-transit-gateways.html#create-tgw)]([Create a transit gateway](https://docs.aws.amazon.com/vpc/latest/tgw/tgw-transit-gateways.html#create-tgw))

---

##### `multicastSupport`<sup>Required</sup> <a name="multicastSupport" id="cdk-extensions.ec2.TransitGateway.property.multicastSupport"></a>

```typescript
public readonly multicastSupport: boolean;
```

- *Type:* boolean

Indicates whether multicast is enabled on the transit gateway.

> [[Multicast reference architectures](https://d1.awsstatic.com/architecture-diagrams/ArchitectureDiagrams/transitgateway_multicast_ra.pdf?did=wp_card&trk=wp_card)]([Multicast reference architectures](https://d1.awsstatic.com/architecture-diagrams/ArchitectureDiagrams/transitgateway_multicast_ra.pdf?did=wp_card&trk=wp_card))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.TransitGateway.property.resource"></a>

```typescript
public readonly resource: CfnTransitGateway;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnTransitGateway

The underlying TransitGateway CloudFormation resource.

> [[AWS::EC2::TransitGateway](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html)]([AWS::EC2::TransitGateway](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html))

---

##### `transitGatewayArn`<sup>Required</sup> <a name="transitGatewayArn" id="cdk-extensions.ec2.TransitGateway.property.transitGatewayArn"></a>

```typescript
public readonly transitGatewayArn: string;
```

- *Type:* string

The ARN of this Transit Gateway.

---

##### `transitGatewayId`<sup>Required</sup> <a name="transitGatewayId" id="cdk-extensions.ec2.TransitGateway.property.transitGatewayId"></a>

```typescript
public readonly transitGatewayId: string;
```

- *Type:* string

The ID of this Transit Gateway.

---

##### `amazonSideAsn`<sup>Optional</sup> <a name="amazonSideAsn" id="cdk-extensions.ec2.TransitGateway.property.amazonSideAsn"></a>

```typescript
public readonly amazonSideAsn: number;
```

- *Type:* number

A private Autonomous System Number (ASN) for the Amazon side of a BGP session.

The range is 64512 to 65534 for 16-bit ASNs.

> [[TransitGateway.AmazonSideAsn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html#cfn-ec2-transitgateway-amazonsideasn)]([TransitGateway.AmazonSideAsn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html#cfn-ec2-transitgateway-amazonsideasn))

---

##### `defaultRouteTable`<sup>Optional</sup> <a name="defaultRouteTable" id="cdk-extensions.ec2.TransitGateway.property.defaultRouteTable"></a>

```typescript
public readonly defaultRouteTable: ITransitGatewayRouteTable;
```

- *Type:* cdk-extensions.ec2.ITransitGatewayRouteTable

The default route table that got created along with the Transit Gateway.

This information is not exposed by CloudFormation. As such, this resource
will only be available if the default reoute table ID is passed in.

---

##### `defaultRouteTableId`<sup>Optional</sup> <a name="defaultRouteTableId" id="cdk-extensions.ec2.TransitGateway.property.defaultRouteTableId"></a>

```typescript
public readonly defaultRouteTableId: string;
```

- *Type:* string

The ID of the default route table that was created with the transit gateway.

This route table is critical to some transit gateway architectures and is
not exposed by CloudFormation.

Passing in the ID of the default route table will make an object available
that represents it and can be used for further operations.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.TransitGateway.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The description of the transit gateway.

> [[TransitGateway.Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html#cfn-ec2-transitgateway-description)]([TransitGateway.Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html#cfn-ec2-transitgateway-description))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGateway.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the transit gateway.

Used to tag the transit gateway with a name that will be displayed in the
AWS VPC console.

> [[TransitGateway.Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html#cfn-ec2-transitgateway-tags)]([TransitGateway.Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgateway.html#cfn-ec2-transitgateway-tags))

---

##### `resourceShare`<sup>Optional</sup> <a name="resourceShare" id="cdk-extensions.ec2.TransitGateway.property.resourceShare"></a>

```typescript
public readonly resourceShare: ResourceShare;
```

- *Type:* cdk-extensions.ram.ResourceShare

The RAM resource share that is used for sharing the transit gateway with other accounts.

---

##### `vpnEcmpSupport`<sup>Optional</sup> <a name="vpnEcmpSupport" id="cdk-extensions.ec2.TransitGateway.property.vpnEcmpSupport"></a>

```typescript
public readonly vpnEcmpSupport: boolean;
```

- *Type:* boolean

Enable or disable Equal Cost Multipath Protocol support.

> [[Achieve ECMP with multiple VPN tunnels](https://aws.amazon.com/premiumsupport/knowledge-center/transit-gateway-ecmp-multiple-tunnels/)]([Achieve ECMP with multiple VPN tunnels](https://aws.amazon.com/premiumsupport/knowledge-center/transit-gateway-ecmp-multiple-tunnels/))

---


### TransitGatewayAttachment <a name="TransitGatewayAttachment" id="cdk-extensions.ec2.TransitGatewayAttachment"></a>

Attaches a VPC to a transit gateway.

If you attach a VPC with a CIDR range that overlaps the CIDR range of a VPC
that is already attached, the new VPC CIDR range is not propagated to the
default propagation route table.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGatewayAttachment.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGatewayAttachment(scope: Construct, id: string, props: TransitGatewayAttachmentProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resources's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.TransitGatewayAttachmentProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayAttachment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayAttachment.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.TransitGatewayAttachment.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayAttachmentProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.addRoute">addRoute</a></code> | Adds a route that directs traffic to this transit gateway attachment. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.TransitGatewayAttachment.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.TransitGatewayAttachment.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.TransitGatewayAttachment.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addRoute` <a name="addRoute" id="cdk-extensions.ec2.TransitGatewayAttachment.addRoute"></a>

```typescript
public addRoute(cidr: string, routeTable: ITransitGatewayRouteTable): ITransitGatewayRoute
```

Adds a route that directs traffic to this transit gateway attachment.

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.TransitGatewayAttachment.addRoute.parameter.cidr"></a>

- *Type:* string

CIDR range that should be routed to this attachment.

---

###### `routeTable`<sup>Required</sup> <a name="routeTable" id="cdk-extensions.ec2.TransitGatewayAttachment.addRoute.parameter.routeTable"></a>

- *Type:* cdk-extensions.ec2.ITransitGatewayRouteTable

The transit gateway route table where the route should be added.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.fromTransitGatewayAttachmentId">fromTransitGatewayAttachmentId</a></code> | Imports an existing Transit Gateway Attachment using its attachment ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.TransitGatewayAttachment.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachment.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.TransitGatewayAttachment.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.TransitGatewayAttachment.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachment.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayAttachment.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.TransitGatewayAttachment.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachment.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayAttachment.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromTransitGatewayAttachmentId` <a name="fromTransitGatewayAttachmentId" id="cdk-extensions.ec2.TransitGatewayAttachment.fromTransitGatewayAttachmentId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachment.fromTransitGatewayAttachmentId(scope: IConstruct, id: string, transitGatewayAttachmentId: string)
```

Imports an existing Transit Gateway Attachment using its attachment ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayAttachment.fromTransitGatewayAttachmentId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayAttachment.fromTransitGatewayAttachmentId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `transitGatewayAttachmentId`<sup>Required</sup> <a name="transitGatewayAttachmentId" id="cdk-extensions.ec2.TransitGatewayAttachment.fromTransitGatewayAttachmentId.parameter.transitGatewayAttachmentId"></a>

- *Type:* string

The attachment ID of the Transit Gateway attachment being imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.transitGatewayAttachmentArn">transitGatewayAttachmentArn</a></code> | <code>string</code> | The ARN of this Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.transitGatewayAttachmentId">transitGatewayAttachmentId</a></code> | <code>string</code> | The ID of this Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | The subnets where the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The transit gateway for which the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | The VPC where the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.applianceModeSupport">applianceModeSupport</a></code> | <code>boolean</code> | Enables appliance mode on the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.dnsSupport">dnsSupport</a></code> | <code>boolean</code> | Enables DNS support for the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.ipv6Support">ipv6Support</a></code> | <code>boolean</code> | Enables DNS support for the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.name">name</a></code> | <code>string</code> | The name of the Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachment.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnTransitGatewayAttachment</code> | The underlying NamedQuery CloudFormation resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.TransitGatewayAttachment.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.TransitGatewayAttachment.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.TransitGatewayAttachment.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `transitGatewayAttachmentArn`<sup>Required</sup> <a name="transitGatewayAttachmentArn" id="cdk-extensions.ec2.TransitGatewayAttachment.property.transitGatewayAttachmentArn"></a>

```typescript
public readonly transitGatewayAttachmentArn: string;
```

- *Type:* string

The ARN of this Transit Gateway Attachment.

---

##### `transitGatewayAttachmentId`<sup>Required</sup> <a name="transitGatewayAttachmentId" id="cdk-extensions.ec2.TransitGatewayAttachment.property.transitGatewayAttachmentId"></a>

```typescript
public readonly transitGatewayAttachmentId: string;
```

- *Type:* string

The ID of this Transit Gateway Attachment.

---

##### `subnets`<sup>Required</sup> <a name="subnets" id="cdk-extensions.ec2.TransitGatewayAttachment.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

The subnets where the attachment should be created.

Can select up to one subnet per Availability Zone.

> [[TransitGatewayVpcAttachment SubnetIds](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-subnetids)]([TransitGatewayVpcAttachment SubnetIds](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-subnetids))

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayAttachment.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The transit gateway for which the attachment should be created.

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.ec2.TransitGatewayAttachment.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

The VPC where the attachment should be created.

> [[TransitGatewayVpcAttachment VpcId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-vpcid)]([TransitGatewayVpcAttachment VpcId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-vpcid))

---

##### `applianceModeSupport`<sup>Optional</sup> <a name="applianceModeSupport" id="cdk-extensions.ec2.TransitGatewayAttachment.property.applianceModeSupport"></a>

```typescript
public readonly applianceModeSupport: boolean;
```

- *Type:* boolean

Enables appliance mode on the attachment.

When appliance mode is enabled, all traffic flowing between attachments is
forwarded to an appliance in a shared VPC to be inspected and processed.

> [[Appliance in a shared services VPC](https://docs.aws.amazon.com/vpc/latest/tgw/transit-gateway-appliance-scenario.html)]([Appliance in a shared services VPC](https://docs.aws.amazon.com/vpc/latest/tgw/transit-gateway-appliance-scenario.html))

---

##### `dnsSupport`<sup>Optional</sup> <a name="dnsSupport" id="cdk-extensions.ec2.TransitGatewayAttachment.property.dnsSupport"></a>

```typescript
public readonly dnsSupport: boolean;
```

- *Type:* boolean

Enables DNS support for the attachment.

With DNS Support enabled public DNS names that resolve to a connected VPC
will be translated to private IP addresses when resolved in a connected VPC.

> [[TransitGatewayVpcAttachment DnsSupport](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-ec2-transitgatewayvpcattachment-options.html#cfn-ec2-transitgatewayvpcattachment-options-dnssupport)]([TransitGatewayVpcAttachment DnsSupport](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-ec2-transitgatewayvpcattachment-options.html#cfn-ec2-transitgatewayvpcattachment-options-dnssupport))

---

##### `ipv6Support`<sup>Optional</sup> <a name="ipv6Support" id="cdk-extensions.ec2.TransitGatewayAttachment.property.ipv6Support"></a>

```typescript
public readonly ipv6Support: boolean;
```

- *Type:* boolean

Enables DNS support for the attachment.

With DNS Support enabled public DNS names that resolve to a connected VPC
will be translated to private IP addresses when resolved in a connected VPC.

> [[IPv6 connectivity with TransitGateway](https://docs.aws.amazon.com/whitepapers/latest/ipv6-on-aws/amazon-vpc-connectivity-options-for-ipv6.html#ipv6-connectivity-with-transit-gateway)]([IPv6 connectivity with TransitGateway](https://docs.aws.amazon.com/whitepapers/latest/ipv6-on-aws/amazon-vpc-connectivity-options-for-ipv6.html#ipv6-connectivity-with-transit-gateway))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayAttachment.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Transit Gateway Attachment.

Used to tag the attachment with a name that will be displayed in the AWS
EC2 console.

> [[TransitGatewayVpcAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-tags)]([TransitGatewayVpcAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-tags))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.TransitGatewayAttachment.property.resource"></a>

```typescript
public readonly resource: CfnTransitGatewayAttachment;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnTransitGatewayAttachment

The underlying NamedQuery CloudFormation resource.

> [[AWS::EC2::TransitGatewayVpcAttachment](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html)]([AWS::EC2::TransitGatewayVpcAttachment](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html))

---


### TransitGatewayAttachmentBase <a name="TransitGatewayAttachmentBase" id="cdk-extensions.ec2.TransitGatewayAttachmentBase"></a>

- *Implements:* cdk-extensions.ec2.ITransitGatewayAttachment

A base class providing common functionality between created and imported Transit Gateway Attachments.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGatewayAttachmentBase(scope: Construct, id: string, props?: ResourceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.Initializer.parameter.props">props</a></code> | <code>aws-cdk-lib.ResourceProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.Initializer.parameter.props"></a>

- *Type:* aws-cdk-lib.ResourceProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.addRoute">addRoute</a></code> | Adds a route that directs traffic to this transit gateway attachment. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addRoute` <a name="addRoute" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.addRoute"></a>

```typescript
public addRoute(cidr: string, routeTable: ITransitGatewayRouteTable): ITransitGatewayRoute
```

Adds a route that directs traffic to this transit gateway attachment.

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.addRoute.parameter.cidr"></a>

- *Type:* string

CIDR range that should be routed to this attachment.

---

###### `routeTable`<sup>Required</sup> <a name="routeTable" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.addRoute.parameter.routeTable"></a>

- *Type:* cdk-extensions.ec2.ITransitGatewayRouteTable

The transit gateway route table where the route should be added.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachmentBase.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachmentBase.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachmentBase.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.property.transitGatewayAttachmentArn">transitGatewayAttachmentArn</a></code> | <code>string</code> | The ARN of this Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentBase.property.transitGatewayAttachmentId">transitGatewayAttachmentId</a></code> | <code>string</code> | The name of this Transit Gateway Attachment. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `transitGatewayAttachmentArn`<sup>Required</sup> <a name="transitGatewayAttachmentArn" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.property.transitGatewayAttachmentArn"></a>

```typescript
public readonly transitGatewayAttachmentArn: string;
```

- *Type:* string

The ARN of this Transit Gateway Attachment.

---

##### `transitGatewayAttachmentId`<sup>Required</sup> <a name="transitGatewayAttachmentId" id="cdk-extensions.ec2.TransitGatewayAttachmentBase.property.transitGatewayAttachmentId"></a>

```typescript
public readonly transitGatewayAttachmentId: string;
```

- *Type:* string

The name of this Transit Gateway Attachment.

---


### TransitGatewayAttachmentResource <a name="TransitGatewayAttachmentResource" id="cdk-extensions.ec2.TransitGatewayAttachmentResource"></a>

Attaches a VPC to a transit gateway.

If you attach a VPC with a CIDR range that overlaps the CIDR range of a VPC
that is already attached, the new VPC CIDR range is not propagated to the
default propagation route table.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGatewayAttachmentResource(scope: Construct, id: string, props: TransitGatewayAttachmentResourceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resources's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.TransitGatewayAttachmentResourceProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayAttachmentResourceProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.addRoute">addRoute</a></code> | Adds a route that directs traffic to this transit gateway attachment. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addRoute` <a name="addRoute" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.addRoute"></a>

```typescript
public addRoute(cidr: string, routeTable: ITransitGatewayRouteTable): ITransitGatewayRoute
```

Adds a route that directs traffic to this transit gateway attachment.

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.addRoute.parameter.cidr"></a>

- *Type:* string

CIDR range that should be routed to this attachment.

---

###### `routeTable`<sup>Required</sup> <a name="routeTable" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.addRoute.parameter.routeTable"></a>

- *Type:* cdk-extensions.ec2.ITransitGatewayRouteTable

The transit gateway route table where the route should be added.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachmentResource.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachmentResource.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayAttachmentResource.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.transitGatewayAttachmentArn">transitGatewayAttachmentArn</a></code> | <code>string</code> | The ARN of this Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.transitGatewayAttachmentId">transitGatewayAttachmentId</a></code> | <code>string</code> | The ID of this Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | The subnets where the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The transit gateway for which the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | The VPC where the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.applianceModeSupport">applianceModeSupport</a></code> | <code>boolean</code> | Enables appliance mode on the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.dnsSupport">dnsSupport</a></code> | <code>boolean</code> | Enables DNS support for the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.ipv6Support">ipv6Support</a></code> | <code>boolean</code> | Enables DNS support for the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResource.property.name">name</a></code> | <code>string</code> | The name of the Transit Gateway Attachment. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `transitGatewayAttachmentArn`<sup>Required</sup> <a name="transitGatewayAttachmentArn" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.transitGatewayAttachmentArn"></a>

```typescript
public readonly transitGatewayAttachmentArn: string;
```

- *Type:* string

The ARN of this Transit Gateway Attachment.

---

##### `transitGatewayAttachmentId`<sup>Required</sup> <a name="transitGatewayAttachmentId" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.transitGatewayAttachmentId"></a>

```typescript
public readonly transitGatewayAttachmentId: string;
```

- *Type:* string

The ID of this Transit Gateway Attachment.

---

##### `subnets`<sup>Required</sup> <a name="subnets" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

The subnets where the attachment should be created.

Can select up to one subnet per Availability Zone.

> [[TransitGatewayVpcAttachment SubnetIds](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-subnetids)]([TransitGatewayVpcAttachment SubnetIds](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-subnetids))

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The transit gateway for which the attachment should be created.

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

The VPC where the attachment should be created.

> [[TransitGatewayVpcAttachment VpcId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-vpcid)]([TransitGatewayVpcAttachment VpcId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-vpcid))

---

##### `applianceModeSupport`<sup>Optional</sup> <a name="applianceModeSupport" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.applianceModeSupport"></a>

```typescript
public readonly applianceModeSupport: boolean;
```

- *Type:* boolean

Enables appliance mode on the attachment.

When appliance mode is enabled, all traffic flowing between attachments is
forwarded to an appliance in a shared VPC to be inspected and processed.

> [[Appliance in a shared services VPC](https://docs.aws.amazon.com/vpc/latest/tgw/transit-gateway-appliance-scenario.html)]([Appliance in a shared services VPC](https://docs.aws.amazon.com/vpc/latest/tgw/transit-gateway-appliance-scenario.html))

---

##### `dnsSupport`<sup>Optional</sup> <a name="dnsSupport" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.dnsSupport"></a>

```typescript
public readonly dnsSupport: boolean;
```

- *Type:* boolean

Enables DNS support for the attachment.

With DNS Support enabled public DNS names that resolve to a connected VPC
will be translated to private IP addresses when resolved in a connected VPC.

> [[TransitGatewayVpcAttachment DnsSupport](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-ec2-transitgatewayvpcattachment-options.html#cfn-ec2-transitgatewayvpcattachment-options-dnssupport)]([TransitGatewayVpcAttachment DnsSupport](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-ec2-transitgatewayvpcattachment-options.html#cfn-ec2-transitgatewayvpcattachment-options-dnssupport))

---

##### `ipv6Support`<sup>Optional</sup> <a name="ipv6Support" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.ipv6Support"></a>

```typescript
public readonly ipv6Support: boolean;
```

- *Type:* boolean

Enables DNS support for the attachment.

With DNS Support enabled public DNS names that resolve to a connected VPC
will be translated to private IP addresses when resolved in a connected VPC.

> [[IPv6 connectivity with TransitGateway](https://docs.aws.amazon.com/whitepapers/latest/ipv6-on-aws/amazon-vpc-connectivity-options-for-ipv6.html#ipv6-connectivity-with-transit-gateway)]([IPv6 connectivity with TransitGateway](https://docs.aws.amazon.com/whitepapers/latest/ipv6-on-aws/amazon-vpc-connectivity-options-for-ipv6.html#ipv6-connectivity-with-transit-gateway))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayAttachmentResource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Transit Gateway Attachment.

Used to tag the attachment with a name that will be displayed in the AWS
EC2 console.

> [[TransitGatewayVpcAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-tags)]([TransitGatewayVpcAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-tags))

---


### TransitGatewayPeeringAttachment <a name="TransitGatewayPeeringAttachment" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment"></a>

- *Implements:* cdk-extensions.ec2.ITransitGatewayPeeringAttachment

Requests a transit gateway peering attachment between the specified transit gateway (requester) and a peer transit gateway (accepter).

The peer transit
gateway can be in your account or a different AWS account.

After you create the peering attachment, the owner of the accepter transit
gateway must accept the attachment request.

> [[AWS::EC2::TransitGatewayPeeringAttachment](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html)]([AWS::EC2::TransitGatewayPeeringAttachment](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html))

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGatewayPeeringAttachment(scope: Construct, id: string, props: TransitGatewayPeeringAttachmentProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.addRoute">addRoute</a></code> | Adds a route that directs traffic to this transit gateway attachment. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addRoute` <a name="addRoute" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.addRoute"></a>

```typescript
public addRoute(cidr: string, routeTable: ITransitGatewayRouteTable): ITransitGatewayRoute
```

Adds a route that directs traffic to this transit gateway attachment.

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.addRoute.parameter.cidr"></a>

- *Type:* string

CIDR range that should be routed to this attachment.

---

###### `routeTable`<sup>Required</sup> <a name="routeTable" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.addRoute.parameter.routeTable"></a>

- *Type:* cdk-extensions.ec2.ITransitGatewayRouteTable

The transit gateway route table where the route should be added.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentArn">fromTransitGatewayPeeringAttachmentArn</a></code> | Imports an existing transit gateway peering attachment using its ARN. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentAttributes">fromTransitGatewayPeeringAttachmentAttributes</a></code> | Imports an existing transit gateway peering attachment by defining its components. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentId">fromTransitGatewayPeeringAttachmentId</a></code> | Imports an existing transit gateway peering attachment using its attachment ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayPeeringAttachment.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayPeeringAttachment.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayPeeringAttachment.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromTransitGatewayPeeringAttachmentArn` <a name="fromTransitGatewayPeeringAttachmentArn" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentArn"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentArn(scope: IConstruct, id: string, arn: string)
```

Imports an existing transit gateway peering attachment using its ARN.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `arn`<sup>Required</sup> <a name="arn" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentArn.parameter.arn"></a>

- *Type:* string

The Amazon Resource Name (ARN) of the resource being imported.

---

##### `fromTransitGatewayPeeringAttachmentAttributes` <a name="fromTransitGatewayPeeringAttachmentAttributes" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentAttributes"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentAttributes(scope: IConstruct, id: string, attrs: TransitGatewayPeeringAttachmentImportAttributes)
```

Imports an existing transit gateway peering attachment by defining its components.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentAttributes.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentAttributes.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentAttributes.parameter.attrs"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes

An object describing the details of the resource being imported.

---

##### `fromTransitGatewayPeeringAttachmentId` <a name="fromTransitGatewayPeeringAttachmentId" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentId(scope: IConstruct, id: string, attachmentId: string)
```

Imports an existing transit gateway peering attachment using its attachment ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `attachmentId`<sup>Required</sup> <a name="attachmentId" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.fromTransitGatewayPeeringAttachmentId.parameter.attachmentId"></a>

- *Type:* string

The ID of the resource being imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentArn">transitGatewayAttachmentArn</a></code> | <code>string</code> | The ARN of this transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentId">transitGatewayAttachmentId</a></code> | <code>string</code> | The ID of this transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.localTransitGateway">localTransitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The local side of the transit gateway peering connection. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.peerTransitGateway">peerTransitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The remote transit gateway being peered with. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnTransitGatewayPeeringAttachment</code> | The underlying TransitGatewayRouteTable CloudFormation resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentCreationTime">transitGatewayAttachmentCreationTime</a></code> | <code>string</code> | The time the transit gateway peering attachment was created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentState">transitGatewayAttachmentState</a></code> | <code>string</code> | The state of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatus">transitGatewayAttachmentStatus</a></code> | <code>string</code> | The status of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatusCode">transitGatewayAttachmentStatusCode</a></code> | <code>string</code> | The status code for the current status of the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatusMessage">transitGatewayAttachmentStatusMessage</a></code> | <code>string</code> | The status message for the current status of the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.name">name</a></code> | <code>string</code> | The name of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.peerAccountId">peerAccountId</a></code> | <code>string</code> | The account that contains the transit gateway being peered with. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.peerRegion">peerRegion</a></code> | <code>string</code> | The region that contains the transit gateway being peered with. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `transitGatewayAttachmentArn`<sup>Required</sup> <a name="transitGatewayAttachmentArn" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentArn"></a>

```typescript
public readonly transitGatewayAttachmentArn: string;
```

- *Type:* string

The ARN of this transit gateway peering attachment.

---

##### `transitGatewayAttachmentId`<sup>Required</sup> <a name="transitGatewayAttachmentId" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentId"></a>

```typescript
public readonly transitGatewayAttachmentId: string;
```

- *Type:* string

The ID of this transit gateway peering attachment.

---

##### `localTransitGateway`<sup>Required</sup> <a name="localTransitGateway" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.localTransitGateway"></a>

```typescript
public readonly localTransitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The local side of the transit gateway peering connection.

> [[TransitGatewayPeeringAttachment TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-transitgatewayid)]([TransitGatewayPeeringAttachment TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-transitgatewayid))

---

##### `peerTransitGateway`<sup>Required</sup> <a name="peerTransitGateway" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.peerTransitGateway"></a>

```typescript
public readonly peerTransitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The remote transit gateway being peered with.

> [[TransitGatewayPeeringAttachment PeerTransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peertransitgatewayid)]([TransitGatewayPeeringAttachment PeerTransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peertransitgatewayid))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.resource"></a>

```typescript
public readonly resource: CfnTransitGatewayPeeringAttachment;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnTransitGatewayPeeringAttachment

The underlying TransitGatewayRouteTable CloudFormation resource.

> [[AWS::EC2::TransitGatewayRouteTable](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html)]([AWS::EC2::TransitGatewayRouteTable](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html))

---

##### `transitGatewayAttachmentCreationTime`<sup>Required</sup> <a name="transitGatewayAttachmentCreationTime" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentCreationTime"></a>

```typescript
public readonly transitGatewayAttachmentCreationTime: string;
```

- *Type:* string

The time the transit gateway peering attachment was created.

---

##### `transitGatewayAttachmentState`<sup>Required</sup> <a name="transitGatewayAttachmentState" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentState"></a>

```typescript
public readonly transitGatewayAttachmentState: string;
```

- *Type:* string

The state of the transit gateway peering attachment.

---

##### `transitGatewayAttachmentStatus`<sup>Required</sup> <a name="transitGatewayAttachmentStatus" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatus"></a>

```typescript
public readonly transitGatewayAttachmentStatus: string;
```

- *Type:* string

The status of the transit gateway peering attachment.

---

##### `transitGatewayAttachmentStatusCode`<sup>Required</sup> <a name="transitGatewayAttachmentStatusCode" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatusCode"></a>

```typescript
public readonly transitGatewayAttachmentStatusCode: string;
```

- *Type:* string

The status code for the current status of the attachment.

---

##### `transitGatewayAttachmentStatusMessage`<sup>Required</sup> <a name="transitGatewayAttachmentStatusMessage" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatusMessage"></a>

```typescript
public readonly transitGatewayAttachmentStatusMessage: string;
```

- *Type:* string

The status message for the current status of the attachment.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the transit gateway peering attachment.

Used to tag the attachment with a name that will be displayed in the AWS
EC2 console.

> [[TransitGatewayPeeringAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-tags)]([TransitGatewayPeeringAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-tags))

---

##### `peerAccountId`<sup>Optional</sup> <a name="peerAccountId" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.peerAccountId"></a>

```typescript
public readonly peerAccountId: string;
```

- *Type:* string

The account that contains the transit gateway being peered with.

> [[TransitGatewayPeeringAttachment PeerAccountId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peeraccountid)]([TransitGatewayPeeringAttachment PeerAccountId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peeraccountid))

---

##### `peerRegion`<sup>Optional</sup> <a name="peerRegion" id="cdk-extensions.ec2.TransitGatewayPeeringAttachment.property.peerRegion"></a>

```typescript
public readonly peerRegion: string;
```

- *Type:* string

The region that contains the transit gateway being peered with.

> [[TransitGatewayPeeringAttachment PeerRegion](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peerregion)]([TransitGatewayPeeringAttachment PeerRegion](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peerregion))

---


### TransitGatewayRegistration <a name="TransitGatewayRegistration" id="cdk-extensions.networkmanager.TransitGatewayRegistration"></a>

- *Implements:* cdk-extensions.networkmanager.ITransitGatewayRegistration

#### Initializers <a name="Initializers" id="cdk-extensions.networkmanager.TransitGatewayRegistration.Initializer"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

new networkmanager.TransitGatewayRegistration(scope: IConstruct, id: string, props: TransitGatewayRegistrationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.networkmanager.TransitGatewayRegistrationProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.networkmanager.TransitGatewayRegistration.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.networkmanager.TransitGatewayRegistration.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.networkmanager.TransitGatewayRegistration.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.networkmanager.TransitGatewayRegistrationProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.networkmanager.TransitGatewayRegistration.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.networkmanager.TransitGatewayRegistration.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.networkmanager.TransitGatewayRegistration.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.networkmanager.TransitGatewayRegistration.isConstruct"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.TransitGatewayRegistration.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.networkmanager.TransitGatewayRegistration.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.networkmanager.TransitGatewayRegistration.isOwnedResource"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.TransitGatewayRegistration.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.networkmanager.TransitGatewayRegistration.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.networkmanager.TransitGatewayRegistration.isResource"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

networkmanager.TransitGatewayRegistration.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.networkmanager.TransitGatewayRegistration.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.property.globalNetwork">globalNetwork</a></code> | <code>cdk-extensions.networkmanager.IGlobalNetwork</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistration.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_networkmanager.CfnTransitGatewayRegistration</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.networkmanager.TransitGatewayRegistration.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.networkmanager.TransitGatewayRegistration.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.networkmanager.TransitGatewayRegistration.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `globalNetwork`<sup>Required</sup> <a name="globalNetwork" id="cdk-extensions.networkmanager.TransitGatewayRegistration.property.globalNetwork"></a>

```typescript
public readonly globalNetwork: IGlobalNetwork;
```

- *Type:* cdk-extensions.networkmanager.IGlobalNetwork

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.networkmanager.TransitGatewayRegistration.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk-extensions.networkmanager.TransitGatewayRegistration.property.resource"></a>

```typescript
public readonly resource: CfnTransitGatewayRegistration;
```

- *Type:* aws-cdk-lib.aws_networkmanager.CfnTransitGatewayRegistration

---


### TransitGatewayRoute <a name="TransitGatewayRoute" id="cdk-extensions.ec2.TransitGatewayRoute"></a>

Adds a routing rule for a transit gateway route table.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGatewayRoute.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGatewayRoute(scope: Construct, id: string, props: TransitGatewayRouteProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.TransitGatewayRouteProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayRoute.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayRoute.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.TransitGatewayRoute.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayRouteProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.TransitGatewayRoute.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.TransitGatewayRoute.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.TransitGatewayRoute.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.fromTransitGatewayRouteId">fromTransitGatewayRouteId</a></code> | Imports an existing Transit Gateway Route using its route ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.TransitGatewayRoute.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayRoute.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.TransitGatewayRoute.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.TransitGatewayRoute.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayRoute.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayRoute.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.TransitGatewayRoute.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayRoute.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayRoute.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromTransitGatewayRouteId` <a name="fromTransitGatewayRouteId" id="cdk-extensions.ec2.TransitGatewayRoute.fromTransitGatewayRouteId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayRoute.fromTransitGatewayRouteId(scope: IConstruct, id: string, transitGatewayRouteId: string)
```

Imports an existing Transit Gateway Route using its route ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayRoute.fromTransitGatewayRouteId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayRoute.fromTransitGatewayRouteId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `transitGatewayRouteId`<sup>Required</sup> <a name="transitGatewayRouteId" id="cdk-extensions.ec2.TransitGatewayRoute.fromTransitGatewayRouteId.parameter.transitGatewayRouteId"></a>

- *Type:* string

The ID of the Transit Gateway route being imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.cidr">cidr</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnTransitGatewayRoute</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.routeTable">routeTable</a></code> | <code>cdk-extensions.ec2.ITransitGatewayRouteTable</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.transitGatewayRouteId">transitGatewayRouteId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.attachment">attachment</a></code> | <code>cdk-extensions.ec2.ITransitGatewayAttachment</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRoute.property.blackhole">blackhole</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.TransitGatewayRoute.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.TransitGatewayRoute.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.TransitGatewayRoute.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.TransitGatewayRoute.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* string

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.TransitGatewayRoute.property.resource"></a>

```typescript
public readonly resource: CfnTransitGatewayRoute;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnTransitGatewayRoute

---

##### `routeTable`<sup>Required</sup> <a name="routeTable" id="cdk-extensions.ec2.TransitGatewayRoute.property.routeTable"></a>

```typescript
public readonly routeTable: ITransitGatewayRouteTable;
```

- *Type:* cdk-extensions.ec2.ITransitGatewayRouteTable

---

##### `transitGatewayRouteId`<sup>Required</sup> <a name="transitGatewayRouteId" id="cdk-extensions.ec2.TransitGatewayRoute.property.transitGatewayRouteId"></a>

```typescript
public readonly transitGatewayRouteId: string;
```

- *Type:* string

---

##### `attachment`<sup>Optional</sup> <a name="attachment" id="cdk-extensions.ec2.TransitGatewayRoute.property.attachment"></a>

```typescript
public readonly attachment: ITransitGatewayAttachment;
```

- *Type:* cdk-extensions.ec2.ITransitGatewayAttachment

---

##### `blackhole`<sup>Optional</sup> <a name="blackhole" id="cdk-extensions.ec2.TransitGatewayRoute.property.blackhole"></a>

```typescript
public readonly blackhole: boolean;
```

- *Type:* boolean

---


### TransitGatewayRouteTable <a name="TransitGatewayRouteTable" id="cdk-extensions.ec2.TransitGatewayRouteTable"></a>

- *Implements:* cdk-extensions.ec2.ITransitGatewayRouteTable

Creates a route table for traffic being processed by a transit gateway.

When traffic is routed to a transit gateway via an attachment, the route
table associated with that attachment is used when evaluating how the
inbound traffic should be routed.

> [[AWS::EC2::TransitGatewayRouteTable](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html)]([AWS::EC2::TransitGatewayRouteTable](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html))

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGatewayRouteTable.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGatewayRouteTable(scope: Construct, id: string, props: TransitGatewayRouteTableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.TransitGatewayRouteTableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayRouteTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayRouteTable.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.TransitGatewayRouteTable.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayRouteTableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.addRoute">addRoute</a></code> | Adds a route to this transit gateway route table. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.TransitGatewayRouteTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.TransitGatewayRouteTable.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.TransitGatewayRouteTable.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addRoute` <a name="addRoute" id="cdk-extensions.ec2.TransitGatewayRouteTable.addRoute"></a>

```typescript
public addRoute(options: TransitGatewayRouteOptions): TransitGatewayRoute
```

Adds a route to this transit gateway route table.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.TransitGatewayRouteTable.addRoute.parameter.options"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayRouteOptions

Configuration for the route being added.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.fromTransitGatewayRouteTableId">fromTransitGatewayRouteTableId</a></code> | Imports an existing transit gateway route table using its route table ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.TransitGatewayRouteTable.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayRouteTable.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.TransitGatewayRouteTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.TransitGatewayRouteTable.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayRouteTable.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayRouteTable.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.TransitGatewayRouteTable.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayRouteTable.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.TransitGatewayRouteTable.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromTransitGatewayRouteTableId` <a name="fromTransitGatewayRouteTableId" id="cdk-extensions.ec2.TransitGatewayRouteTable.fromTransitGatewayRouteTableId"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayRouteTable.fromTransitGatewayRouteTableId(scope: IConstruct, id: string, transitGatewayRouteTableId: string)
```

Imports an existing transit gateway route table using its route table ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.TransitGatewayRouteTable.fromTransitGatewayRouteTableId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.TransitGatewayRouteTable.fromTransitGatewayRouteTableId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `transitGatewayRouteTableId`<sup>Required</sup> <a name="transitGatewayRouteTableId" id="cdk-extensions.ec2.TransitGatewayRouteTable.fromTransitGatewayRouteTableId.parameter.transitGatewayRouteTableId"></a>

- *Type:* string

The attachment ID of the transit gateway route table being imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnTransitGatewayRouteTable</code> | The underlying TransitGatewayRouteTable CloudFormation resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The transit gateway for which the route table should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.property.transitGatewayRouteTableArn">transitGatewayRouteTableArn</a></code> | <code>string</code> | The ARN of this transit gateway route table. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.property.transitGatewayRouteTableId">transitGatewayRouteTableId</a></code> | <code>string</code> | The ID of this transit gateway route table. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTable.property.name">name</a></code> | <code>string</code> | The name of the transit gateway route table. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.TransitGatewayRouteTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.TransitGatewayRouteTable.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.TransitGatewayRouteTable.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.TransitGatewayRouteTable.property.resource"></a>

```typescript
public readonly resource: CfnTransitGatewayRouteTable;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnTransitGatewayRouteTable

The underlying TransitGatewayRouteTable CloudFormation resource.

> [[AWS::EC2::TransitGatewayRouteTable](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html)]([AWS::EC2::TransitGatewayRouteTable](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html))

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayRouteTable.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The transit gateway for which the route table should be created.

> [[TransitGatewayRouteTable TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html#cfn-ec2-transitgatewayroutetable-transitgatewayid)]([TransitGatewayRouteTable TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html#cfn-ec2-transitgatewayroutetable-transitgatewayid))

---

##### `transitGatewayRouteTableArn`<sup>Required</sup> <a name="transitGatewayRouteTableArn" id="cdk-extensions.ec2.TransitGatewayRouteTable.property.transitGatewayRouteTableArn"></a>

```typescript
public readonly transitGatewayRouteTableArn: string;
```

- *Type:* string

The ARN of this transit gateway route table.

---

##### `transitGatewayRouteTableId`<sup>Required</sup> <a name="transitGatewayRouteTableId" id="cdk-extensions.ec2.TransitGatewayRouteTable.property.transitGatewayRouteTableId"></a>

```typescript
public readonly transitGatewayRouteTableId: string;
```

- *Type:* string

The ID of this transit gateway route table.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayRouteTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the transit gateway route table.

Used to tag the route table with a name that will be displayed in the AWS
EC2 console.

> [[TransitGatewayRouteTable Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html#cfn-ec2-transitgatewayroutetable-tags)]([TransitGatewayRouteTable Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html#cfn-ec2-transitgatewayroutetable-tags))

---


### Trigger <a name="Trigger" id="cdk-extensions.glue.Trigger"></a>

- *Implements:* cdk-extensions.glue.ITrigger

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Trigger.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Trigger(scope: Construct, id: string, props: TriggerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Trigger.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue.Trigger.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue.Trigger.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.TriggerProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Trigger.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Trigger.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.Trigger.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.TriggerProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Trigger.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.Trigger.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue.Trigger.addAction">addAction</a></code> | Registers an action with the trigger. |
| <code><a href="#cdk-extensions.glue.Trigger.addPredicate">addPredicate</a></code> | Registers a predicate with the trigger. |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.Trigger.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.Trigger.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.Trigger.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addAction` <a name="addAction" id="cdk-extensions.glue.Trigger.addAction"></a>

```typescript
public addAction(action: ITriggerAction): Trigger
```

Registers an action with the trigger.

All actions associated with the
trigger are run when the conditions to trigger the trigger are met.

###### `action`<sup>Required</sup> <a name="action" id="cdk-extensions.glue.Trigger.addAction.parameter.action"></a>

- *Type:* cdk-extensions.glue.ITriggerAction

The action to be run by this trigger.

---

##### `addPredicate` <a name="addPredicate" id="cdk-extensions.glue.Trigger.addPredicate"></a>

```typescript
public addPredicate(predicate: ITriggerPredicate): Trigger
```

Registers a predicate with the trigger.

Triggers with predicates must meet
the conditions they specify in order to run.

###### `predicate`<sup>Required</sup> <a name="predicate" id="cdk-extensions.glue.Trigger.addPredicate.parameter.predicate"></a>

- *Type:* cdk-extensions.glue.ITriggerPredicate

The predicate to be added to the trigger.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Trigger.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.Trigger.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.Trigger.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.glue.Trigger.fromTriggerArn">fromTriggerArn</a></code> | Imports an existing trigger using its Amazon Resource Name (ARN). |
| <code><a href="#cdk-extensions.glue.Trigger.fromTriggerName">fromTriggerName</a></code> | Imports an existing trigger using its name. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.Trigger.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Trigger.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.Trigger.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.Trigger.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Trigger.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Trigger.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.Trigger.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Trigger.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Trigger.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromTriggerArn` <a name="fromTriggerArn" id="cdk-extensions.glue.Trigger.fromTriggerArn"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Trigger.fromTriggerArn(scope: IConstruct, id: string, triggerArn: string)
```

Imports an existing trigger using its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Trigger.fromTriggerArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Trigger.fromTriggerArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `triggerArn`<sup>Required</sup> <a name="triggerArn" id="cdk-extensions.glue.Trigger.fromTriggerArn.parameter.triggerArn"></a>

- *Type:* string

The ARN of the trigger to import.

---

##### `fromTriggerName` <a name="fromTriggerName" id="cdk-extensions.glue.Trigger.fromTriggerName"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Trigger.fromTriggerName(scope: IConstruct, id: string, triggerName: string)
```

Imports an existing trigger using its name.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Trigger.fromTriggerName.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Trigger.fromTriggerName.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `triggerName`<sup>Required</sup> <a name="triggerName" id="cdk-extensions.glue.Trigger.fromTriggerName.parameter.triggerName"></a>

- *Type:* string

The name of the trigger to import.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Trigger.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.Trigger.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.Trigger.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.Trigger.property.predicateOperator">predicateOperator</a></code> | <code>cdk-extensions.glue.PredicateOperator</code> | Operator for chaining predicate conditions if multiple are given. |
| <code><a href="#cdk-extensions.glue.Trigger.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTrigger</code> | The underlying Trigger CloudFormation resource. |
| <code><a href="#cdk-extensions.glue.Trigger.property.triggerArn">triggerArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the trigger. |
| <code><a href="#cdk-extensions.glue.Trigger.property.triggerName">triggerName</a></code> | <code>string</code> | The name of the trigger. |
| <code><a href="#cdk-extensions.glue.Trigger.property.type">type</a></code> | <code>cdk-extensions.glue.TriggerType</code> | The type of trigger that this is. |
| <code><a href="#cdk-extensions.glue.Trigger.property.description">description</a></code> | <code>string</code> | A description for the trigger. |
| <code><a href="#cdk-extensions.glue.Trigger.property.name">name</a></code> | <code>string</code> | A name for the trigger. |
| <code><a href="#cdk-extensions.glue.Trigger.property.schedule">schedule</a></code> | <code>aws-cdk-lib.aws_events.Schedule</code> | A cron expression used to specify the schedule. |
| <code><a href="#cdk-extensions.glue.Trigger.property.startOnCreation">startOnCreation</a></code> | <code>boolean</code> | Set to true to start SCHEDULED and CONDITIONAL triggers when created. |
| <code><a href="#cdk-extensions.glue.Trigger.property.workflow">workflow</a></code> | <code>cdk-extensions.glue.Workflow</code> | The name of the workflow associated with the trigger. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.Trigger.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.Trigger.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.Trigger.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `predicateOperator`<sup>Required</sup> <a name="predicateOperator" id="cdk-extensions.glue.Trigger.property.predicateOperator"></a>

```typescript
public readonly predicateOperator: PredicateOperator;
```

- *Type:* cdk-extensions.glue.PredicateOperator

Operator for chaining predicate conditions if multiple are given.

> [[Trigger Predicate.Logical](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-predicate.html#cfn-glue-trigger-predicate-logical)]([Trigger Predicate.Logical](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-predicate.html#cfn-glue-trigger-predicate-logical))

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.Trigger.property.resource"></a>

```typescript
public readonly resource: CfnTrigger;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTrigger

The underlying Trigger CloudFormation resource.

> [[AWS::Glue::Trigger](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html)]([AWS::Glue::Trigger](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html))

---

##### `triggerArn`<sup>Required</sup> <a name="triggerArn" id="cdk-extensions.glue.Trigger.property.triggerArn"></a>

```typescript
public readonly triggerArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the trigger.

---

##### `triggerName`<sup>Required</sup> <a name="triggerName" id="cdk-extensions.glue.Trigger.property.triggerName"></a>

```typescript
public readonly triggerName: string;
```

- *Type:* string

The name of the trigger.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk-extensions.glue.Trigger.property.type"></a>

```typescript
public readonly type: TriggerType;
```

- *Type:* cdk-extensions.glue.TriggerType

The type of trigger that this is.

> [[Trigger Type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-type)]([Trigger Type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-type))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.Trigger.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A description for the trigger.

> [[Trigger Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-description)]([Trigger Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-description))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.Trigger.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A name for the trigger.

> [[Trigger Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-name)]([Trigger Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-name))

---

##### `schedule`<sup>Optional</sup> <a name="schedule" id="cdk-extensions.glue.Trigger.property.schedule"></a>

```typescript
public readonly schedule: Schedule;
```

- *Type:* aws-cdk-lib.aws_events.Schedule

A cron expression used to specify the schedule.

> [[Time-Based Schedules for Jobs and Crawlers](https://docs.aws.amazon.com/glue/latest/dg/monitor-data-warehouse-schedule.html)]([Time-Based Schedules for Jobs and Crawlers](https://docs.aws.amazon.com/glue/latest/dg/monitor-data-warehouse-schedule.html))

---

##### `startOnCreation`<sup>Optional</sup> <a name="startOnCreation" id="cdk-extensions.glue.Trigger.property.startOnCreation"></a>

```typescript
public readonly startOnCreation: boolean;
```

- *Type:* boolean

Set to true to start SCHEDULED and CONDITIONAL triggers when created.

True
is not supported for ON_DEMAND triggers.

> [[Trigger StartOnCreation](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-startoncreation)]([Trigger StartOnCreation](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-startoncreation))

---

##### `workflow`<sup>Optional</sup> <a name="workflow" id="cdk-extensions.glue.Trigger.property.workflow"></a>

```typescript
public readonly workflow: Workflow;
```

- *Type:* cdk-extensions.glue.Workflow

The name of the workflow associated with the trigger.

> [[Trigger WorkflowName](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-workflowname)]([Trigger WorkflowName](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-workflowname))

---


### UserBase <a name="UserBase" id="cdk-extensions.sso.UserBase"></a>

- *Implements:* cdk-extensions.sso.IUser, cdk-extensions.sso.IIdentityCenterPrincipal

#### Initializers <a name="Initializers" id="cdk-extensions.sso.UserBase.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.UserBase(scope: IConstruct, id: string, props?: ResourceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.UserBase.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |
| <code><a href="#cdk-extensions.sso.UserBase.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.sso.UserBase.Initializer.parameter.props">props</a></code> | <code>aws-cdk-lib.ResourceProps</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.UserBase.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.UserBase.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.sso.UserBase.Initializer.parameter.props"></a>

- *Type:* aws-cdk-lib.ResourceProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.UserBase.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.sso.UserBase.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.sso.UserBase.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.sso.UserBase.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.UserBase.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.UserBase.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.sso.UserBase.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.sso.UserBase.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.sso.UserBase.isConstruct"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.UserBase.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.sso.UserBase.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.sso.UserBase.isOwnedResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.UserBase.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.UserBase.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.sso.UserBase.isResource"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.UserBase.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.sso.UserBase.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.UserBase.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.sso.UserBase.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.sso.UserBase.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.sso.UserBase.property.principalId">principalId</a></code> | <code>string</code> | The unique ID that identifies the entity withing IAM Identity Center. |
| <code><a href="#cdk-extensions.sso.UserBase.property.principalType">principalType</a></code> | <code>cdk-extensions.sso.IdentityCenterPrincipalType</code> | The type of entity being represented. |
| <code><a href="#cdk-extensions.sso.UserBase.property.userId">userId</a></code> | <code>string</code> | A GUID identifier for a user object in IAM Identity Center (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.sso.UserBase.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.sso.UserBase.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.sso.UserBase.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `principalId`<sup>Required</sup> <a name="principalId" id="cdk-extensions.sso.UserBase.property.principalId"></a>

```typescript
public readonly principalId: string;
```

- *Type:* string

The unique ID that identifies the entity withing IAM Identity Center.

---

##### `principalType`<sup>Required</sup> <a name="principalType" id="cdk-extensions.sso.UserBase.property.principalType"></a>

```typescript
public readonly principalType: IdentityCenterPrincipalType;
```

- *Type:* cdk-extensions.sso.IdentityCenterPrincipalType

The type of entity being represented.

---

##### `userId`<sup>Required</sup> <a name="userId" id="cdk-extensions.sso.UserBase.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* string

A GUID identifier for a user object in IAM Identity Center (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6).

---


### VpnConnection <a name="VpnConnection" id="cdk-extensions.ec2.VpnConnection"></a>

- *Implements:* aws-cdk-lib.aws_ec2.IVpnConnection

Specifies a VPN connection between a virtual private gateway and a VPN customer gateway or a transit gateway and a VPN customer gateway.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.VpnConnection.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.VpnConnection(scope: Construct, id: string, props: VpnConnectionProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnection.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.ec2.VpnConnectionProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.VpnConnection.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.VpnConnection.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.VpnConnection.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.ec2.VpnConnectionProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnection.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.addTunnelConfiguration">addTunnelConfiguration</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnection.metric">metric</a></code> | Return the given named metric for this VPNConnection. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.metricTunnelDataIn">metricTunnelDataIn</a></code> | The bytes received through the VPN tunnel. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.metricTunnelDataOut">metricTunnelDataOut</a></code> | The bytes sent through the VPN tunnel. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.metricTunnelState">metricTunnelState</a></code> | The state of the tunnel. |

---

##### `toString` <a name="toString" id="cdk-extensions.ec2.VpnConnection.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.ec2.VpnConnection.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.ec2.VpnConnection.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addTunnelConfiguration` <a name="addTunnelConfiguration" id="cdk-extensions.ec2.VpnConnection.addTunnelConfiguration"></a>

```typescript
public addTunnelConfiguration(options: TunnelOptions): void
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.VpnConnection.addTunnelConfiguration.parameter.options"></a>

- *Type:* cdk-extensions.ec2.TunnelOptions

---

##### `metric` <a name="metric" id="cdk-extensions.ec2.VpnConnection.metric"></a>

```typescript
public metric(metricName: string, props?: MetricOptions): Metric
```

Return the given named metric for this VPNConnection.

###### `metricName`<sup>Required</sup> <a name="metricName" id="cdk-extensions.ec2.VpnConnection.metric.parameter.metricName"></a>

- *Type:* string

---

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.VpnConnection.metric.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricTunnelDataIn` <a name="metricTunnelDataIn" id="cdk-extensions.ec2.VpnConnection.metricTunnelDataIn"></a>

```typescript
public metricTunnelDataIn(props?: MetricOptions): Metric
```

The bytes received through the VPN tunnel.

Sum over 5 minutes

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.VpnConnection.metricTunnelDataIn.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricTunnelDataOut` <a name="metricTunnelDataOut" id="cdk-extensions.ec2.VpnConnection.metricTunnelDataOut"></a>

```typescript
public metricTunnelDataOut(props?: MetricOptions): Metric
```

The bytes sent through the VPN tunnel.

Sum over 5 minutes

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.VpnConnection.metricTunnelDataOut.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricTunnelState` <a name="metricTunnelState" id="cdk-extensions.ec2.VpnConnection.metricTunnelState"></a>

```typescript
public metricTunnelState(props?: MetricOptions): Metric
```

The state of the tunnel.

0 indicates DOWN and 1 indicates UP.

Average over 5 minutes

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.VpnConnection.metricTunnelState.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnection.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.ec2.VpnConnection.isConstruct"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.VpnConnection.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.ec2.VpnConnection.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.ec2.VpnConnection.isOwnedResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.VpnConnection.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.VpnConnection.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.ec2.VpnConnection.isResource"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.VpnConnection.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ec2.VpnConnection.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.connectionType">connectionType</a></code> | <code>cdk-extensions.ec2.VpnConnectionType</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.customerGatewayAsn">customerGatewayAsn</a></code> | <code>number</code> | The ASN of the customer gateway. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.customerGatewayId">customerGatewayId</a></code> | <code>string</code> | The id of the customer gateway. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.customerGatewayIp">customerGatewayIp</a></code> | <code>string</code> | The ip address of the customer gateway. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.localEndpoint">localEndpoint</a></code> | <code>cdk-extensions.ec2.ILocalVpnEndpoint</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.remoteEndpoint">remoteEndpoint</a></code> | <code>cdk-extensions.ec2.IRemoteVpnEndpoint</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_ec2.CfnVPNConnection</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.tunnelConfigurations">tunnelConfigurations</a></code> | <code>cdk-extensions.ec2.TunnelOptions[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.vpnId">vpnId</a></code> | <code>string</code> | The id of the VPN connection. |
| <code><a href="#cdk-extensions.ec2.VpnConnection.property.staticRoutesOnly">staticRoutesOnly</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.VpnConnection.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.VpnConnection.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.VpnConnection.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `connectionType`<sup>Required</sup> <a name="connectionType" id="cdk-extensions.ec2.VpnConnection.property.connectionType"></a>

```typescript
public readonly connectionType: VpnConnectionType;
```

- *Type:* cdk-extensions.ec2.VpnConnectionType

---

##### `customerGatewayAsn`<sup>Required</sup> <a name="customerGatewayAsn" id="cdk-extensions.ec2.VpnConnection.property.customerGatewayAsn"></a>

```typescript
public readonly customerGatewayAsn: number;
```

- *Type:* number

The ASN of the customer gateway.

---

##### `customerGatewayId`<sup>Required</sup> <a name="customerGatewayId" id="cdk-extensions.ec2.VpnConnection.property.customerGatewayId"></a>

```typescript
public readonly customerGatewayId: string;
```

- *Type:* string

The id of the customer gateway.

---

##### `customerGatewayIp`<sup>Required</sup> <a name="customerGatewayIp" id="cdk-extensions.ec2.VpnConnection.property.customerGatewayIp"></a>

```typescript
public readonly customerGatewayIp: string;
```

- *Type:* string

The ip address of the customer gateway.

---

##### `localEndpoint`<sup>Required</sup> <a name="localEndpoint" id="cdk-extensions.ec2.VpnConnection.property.localEndpoint"></a>

```typescript
public readonly localEndpoint: ILocalVpnEndpoint;
```

- *Type:* cdk-extensions.ec2.ILocalVpnEndpoint

---

##### `remoteEndpoint`<sup>Required</sup> <a name="remoteEndpoint" id="cdk-extensions.ec2.VpnConnection.property.remoteEndpoint"></a>

```typescript
public readonly remoteEndpoint: IRemoteVpnEndpoint;
```

- *Type:* cdk-extensions.ec2.IRemoteVpnEndpoint

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ec2.VpnConnection.property.resource"></a>

```typescript
public readonly resource: CfnVPNConnection;
```

- *Type:* aws-cdk-lib.aws_ec2.CfnVPNConnection

---

##### `tunnelConfigurations`<sup>Required</sup> <a name="tunnelConfigurations" id="cdk-extensions.ec2.VpnConnection.property.tunnelConfigurations"></a>

```typescript
public readonly tunnelConfigurations: TunnelOptions[];
```

- *Type:* cdk-extensions.ec2.TunnelOptions[]

---

##### `vpnId`<sup>Required</sup> <a name="vpnId" id="cdk-extensions.ec2.VpnConnection.property.vpnId"></a>

```typescript
public readonly vpnId: string;
```

- *Type:* string

The id of the VPN connection.

---

##### `staticRoutesOnly`<sup>Optional</sup> <a name="staticRoutesOnly" id="cdk-extensions.ec2.VpnConnection.property.staticRoutesOnly"></a>

```typescript
public readonly staticRoutesOnly: boolean;
```

- *Type:* boolean

---


### WafLogsBucket <a name="WafLogsBucket" id="cdk-extensions.s3_buckets.WafLogsBucket"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.s3_buckets.WafLogsBucket.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

new s3_buckets.WafLogsBucket(scope: Construct, id: string, props?: WafLogsBucketProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.s3_buckets.WafLogsBucketProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.s3_buckets.WafLogsBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.s3_buckets.WafLogsBucket.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.s3_buckets.WafLogsBucket.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.s3_buckets.WafLogsBucketProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.addEventNotification">addEventNotification</a></code> | Adds a bucket notification event destination. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.addObjectCreatedNotification">addObjectCreatedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 created in the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.addObjectRemovedNotification">addObjectRemovedNotification</a></code> | Subscribes a destination to receive notifications when an object is
 removed from the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.addToResourcePolicy">addToResourcePolicy</a></code> | Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.arnForObjects">arnForObjects</a></code> | Returns an ARN that represents all objects within the bucket that match
 the key pattern specified. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.enableEventBridgeNotification">enableEventBridgeNotification</a></code> | Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.grantDelete">grantDelete</a></code> | Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.grantPublicAccess">grantPublicAccess</a></code> | Allows unrestricted access to objects from this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.grantPut">grantPut</a></code> | Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.grantPutAcl">grantPutAcl</a></code> | Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.grantRead">grantRead</a></code> | Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.grantReadWrite">grantReadWrite</a></code> | Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User). |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.grantWrite">grantWrite</a></code> | Grant write permissions to this bucket to an IAM principal. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailEvent">onCloudTrailEvent</a></code> | Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailPutObject">onCloudTrailPutObject</a></code> | Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailWriteObject">onCloudTrailWriteObject</a></code> | Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.s3UrlForObject">s3UrlForObject</a></code> | The S3 URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.transferAccelerationUrlForObject">transferAccelerationUrlForObject</a></code> | The https Transfer Acceleration URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.urlForObject">urlForObject</a></code> | The https URL of an S3 object. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.virtualHostedUrlForObject">virtualHostedUrlForObject</a></code> | The virtual hosted-style URL of an S3 object. |

---

##### `toString` <a name="toString" id="cdk-extensions.s3_buckets.WafLogsBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.s3_buckets.WafLogsBucket.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.s3_buckets.WafLogsBucket.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addEventNotification` <a name="addEventNotification" id="cdk-extensions.s3_buckets.WafLogsBucket.addEventNotification"></a>

```typescript
public addEventNotification(_event: EventType, _dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Adds a bucket notification event destination.

###### `_event`<sup>Required</sup> <a name="_event" id="cdk-extensions.s3_buckets.WafLogsBucket.addEventNotification.parameter._event"></a>

- *Type:* aws-cdk-lib.aws_s3.EventType

---

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.WafLogsBucket.addEventNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.WafLogsBucket.addEventNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectCreatedNotification` <a name="addObjectCreatedNotification" id="cdk-extensions.s3_buckets.WafLogsBucket.addObjectCreatedNotification"></a>

```typescript
public addObjectCreatedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 created in the bucket.

This is identical to calling
`onEvent(s3.EventType.OBJECT_CREATED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.WafLogsBucket.addObjectCreatedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.WafLogsBucket.addObjectCreatedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addObjectRemovedNotification` <a name="addObjectRemovedNotification" id="cdk-extensions.s3_buckets.WafLogsBucket.addObjectRemovedNotification"></a>

```typescript
public addObjectRemovedNotification(_dest: IBucketNotificationDestination, _filters: NotificationKeyFilter): void
```

Subscribes a destination to receive notifications when an object is
 removed from the bucket.

This is identical to calling
`onEvent(EventType.OBJECT_REMOVED)`.

###### `_dest`<sup>Required</sup> <a name="_dest" id="cdk-extensions.s3_buckets.WafLogsBucket.addObjectRemovedNotification.parameter._dest"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucketNotificationDestination

---

###### `_filters`<sup>Required</sup> <a name="_filters" id="cdk-extensions.s3_buckets.WafLogsBucket.addObjectRemovedNotification.parameter._filters"></a>

- *Type:* aws-cdk-lib.aws_s3.NotificationKeyFilter

---

##### `addToResourcePolicy` <a name="addToResourcePolicy" id="cdk-extensions.s3_buckets.WafLogsBucket.addToResourcePolicy"></a>

```typescript
public addToResourcePolicy(permission: PolicyStatement): AddToResourcePolicyResult
```

Adds a statement to the resource policy for a principal (i.e.
 account/role/service) to perform actions on this bucket and/or its
 contents. Use `bucketArn` and `arnForObjects(keys)` to obtain ARNs for
 this bucket or objects.
 
 Note that the policy statement may or may not be added to the policy.
 For example, when an `IBucket` is created from an existing bucket,
 it's not possible to tell whether the bucket already has a policy
 attached, let alone to re-use that policy to add more statements to it.
 So it's safest to do nothing in these cases.

###### `permission`<sup>Required</sup> <a name="permission" id="cdk-extensions.s3_buckets.WafLogsBucket.addToResourcePolicy.parameter.permission"></a>

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement

---

##### `arnForObjects` <a name="arnForObjects" id="cdk-extensions.s3_buckets.WafLogsBucket.arnForObjects"></a>

```typescript
public arnForObjects(_keyPattern: string): string
```

Returns an ARN that represents all objects within the bucket that match
 the key pattern specified.

To represent all keys, specify ``"*"``.

###### `_keyPattern`<sup>Required</sup> <a name="_keyPattern" id="cdk-extensions.s3_buckets.WafLogsBucket.arnForObjects.parameter._keyPattern"></a>

- *Type:* string

---

##### `enableEventBridgeNotification` <a name="enableEventBridgeNotification" id="cdk-extensions.s3_buckets.WafLogsBucket.enableEventBridgeNotification"></a>

```typescript
public enableEventBridgeNotification(): void
```

Enables event bridge notification, causing all events below to be sent to EventBridge:
 
 - Object Deleted (DeleteObject)
 - Object Deleted (Lifecycle expiration)
 - Object Restore Initiated
 - Object Restore Completed
 - Object Restore Expired
 - Object Storage Class Changed
 - Object Access Tier Changed
 - Object ACL Updated
 - Object Tags Added
 - Object Tags Deleted.

##### `grantDelete` <a name="grantDelete" id="cdk-extensions.s3_buckets.WafLogsBucket.grantDelete"></a>

```typescript
public grantDelete(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:DeleteObject* permission to an IAM principal for objects
 in this bucket.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.WafLogsBucket.grantDelete.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.WafLogsBucket.grantDelete.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPublicAccess` <a name="grantPublicAccess" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPublicAccess"></a>

```typescript
public grantPublicAccess(_allowedActions: string, _keyPrefix?: string): Grant
```

Allows unrestricted access to objects from this bucket.

IMPORTANT: This permission allows anyone to perform actions on S3 objects
in this bucket, which is useful for when you configure your bucket as a
website and want everyone to be able to read objects in the bucket without
needing to authenticate.

Without arguments, this method will grant read ("s3:GetObject") access to
all objects ("*") in the bucket.

The method returns the `iam.Grant` object, which can then be modified
as needed. For example, you can add a condition that will restrict access only
to an IPv4 range like this:

     const grant = bucket.grantPublicAccess();
     grant.resourceStatement!.addCondition(‘IpAddress’, { “aws:SourceIp”: “54.240.143.0/24” });

###### `_allowedActions`<sup>Required</sup> <a name="_allowedActions" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPublicAccess.parameter._allowedActions"></a>

- *Type:* string

---

###### `_keyPrefix`<sup>Optional</sup> <a name="_keyPrefix" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPublicAccess.parameter._keyPrefix"></a>

- *Type:* string

---

##### `grantPut` <a name="grantPut" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPut"></a>

```typescript
public grantPut(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants s3:PutObject* and s3:Abort* permissions for this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPut.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPut.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantPutAcl` <a name="grantPutAcl" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPutAcl"></a>

```typescript
public grantPutAcl(_identity: IGrantable, _objectsKeyPattern?: string): Grant
```

Grant the given IAM identity permissions to modify the ACLs of objects in the given Bucket.

If your application has the '@aws-cdk/aws-s3:grantWriteWithoutAcl' feature flag set,
calling `grantWrite` or `grantReadWrite` no longer grants permissions to modify the ACLs of the objects;
in this case, if you need to modify object ACLs, call this method explicitly.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPutAcl.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.WafLogsBucket.grantPutAcl.parameter._objectsKeyPattern"></a>

- *Type:* string

---

##### `grantRead` <a name="grantRead" id="cdk-extensions.s3_buckets.WafLogsBucket.grantRead"></a>

```typescript
public grantRead(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grant read permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If encryption is used, permission to use the key to decrypt the contents
of the bucket will also be granted to the same principal.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.WafLogsBucket.grantRead.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.WafLogsBucket.grantRead.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk-extensions.s3_buckets.WafLogsBucket.grantReadWrite"></a>

```typescript
public grantReadWrite(_identity: IGrantable, _objectsKeyPattern?: any): Grant
```

Grants read/write permissions for this bucket and it's contents to an IAM
 principal (Role/Group/User).

If an encryption key is used, permission to use the key for
encrypt/decrypt will also be granted.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.WafLogsBucket.grantReadWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.WafLogsBucket.grantReadWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

##### `grantWrite` <a name="grantWrite" id="cdk-extensions.s3_buckets.WafLogsBucket.grantWrite"></a>

```typescript
public grantWrite(_identity: IGrantable, _objectsKeyPattern?: any, _allowedActionPatterns?: string[]): Grant
```

Grant write permissions to this bucket to an IAM principal.

If encryption is used, permission to use the key to encrypt the contents
of written files will also be granted to the same principal.

Before CDK version 1.85.0, this method granted the `s3:PutObject*` permission that included `s3:PutObjectAcl`,
which could be used to grant read/write object access to IAM principals in other accounts.
If you want to get rid of that behavior, update your CDK version to 1.85.0 or later,
and make sure the `@aws-cdk/aws-s3:grantWriteWithoutAcl` feature flag is set to `true`
in the `context` key of your cdk.json file.
If you've already updated, but still need the principal to have permissions to modify the ACLs,
use the `grantPutAcl` method.

###### `_identity`<sup>Required</sup> <a name="_identity" id="cdk-extensions.s3_buckets.WafLogsBucket.grantWrite.parameter._identity"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `_objectsKeyPattern`<sup>Optional</sup> <a name="_objectsKeyPattern" id="cdk-extensions.s3_buckets.WafLogsBucket.grantWrite.parameter._objectsKeyPattern"></a>

- *Type:* any

---

###### `_allowedActionPatterns`<sup>Optional</sup> <a name="_allowedActionPatterns" id="cdk-extensions.s3_buckets.WafLogsBucket.grantWrite.parameter._allowedActionPatterns"></a>

- *Type:* string[]

---

##### `onCloudTrailEvent` <a name="onCloudTrailEvent" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailEvent"></a>

```typescript
public onCloudTrailEvent(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines a CloudWatch event that triggers when something happens to this bucket
 
 Requires that there exists at least one CloudTrail Trail in your account
 that captures the event.

This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailEvent.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailEvent.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailPutObject` <a name="onCloudTrailPutObject" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailPutObject"></a>

```typescript
public onCloudTrailPutObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object is uploaded
 to the specified paths (keys) in this bucket using the PutObject API call.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using `onCloudTrailWriteObject` may be preferable.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailPutObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailPutObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `onCloudTrailWriteObject` <a name="onCloudTrailWriteObject" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailWriteObject"></a>

```typescript
public onCloudTrailWriteObject(_id: string, _options?: OnCloudTrailBucketEventOptions): Rule
```

Defines an AWS CloudWatch event that triggers when an object at the
 specified paths (keys) in this bucket are written to.

This includes
the events PutObject, CopyObject, and CompleteMultipartUpload.

Note that some tools like `aws s3 cp` will automatically use either
PutObject or the multipart upload API depending on the file size,
so using this method may be preferable to `onCloudTrailPutObject`.

Requires that there exists at least one CloudTrail Trail in your account
that captures the event. This method will not create the Trail.

###### `_id`<sup>Required</sup> <a name="_id" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailWriteObject.parameter._id"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.WafLogsBucket.onCloudTrailWriteObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.OnCloudTrailBucketEventOptions

---

##### `s3UrlForObject` <a name="s3UrlForObject" id="cdk-extensions.s3_buckets.WafLogsBucket.s3UrlForObject"></a>

```typescript
public s3UrlForObject(_key?: string): string
```

The S3 URL of an S3 object.

For example:
- `s3://onlybucket`
- `s3://bucket/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.WafLogsBucket.s3UrlForObject.parameter._key"></a>

- *Type:* string

---

##### `transferAccelerationUrlForObject` <a name="transferAccelerationUrlForObject" id="cdk-extensions.s3_buckets.WafLogsBucket.transferAccelerationUrlForObject"></a>

```typescript
public transferAccelerationUrlForObject(_key?: string, _options?: TransferAccelerationUrlOptions): string
```

The https Transfer Acceleration URL of an S3 object.

Specify `dualStack: true` at the options
for dual-stack endpoint (connect to the bucket over IPv6). For example:

- `https://bucket.s3-accelerate.amazonaws.com`
- `https://bucket.s3-accelerate.amazonaws.com/key`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.WafLogsBucket.transferAccelerationUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.WafLogsBucket.transferAccelerationUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.TransferAccelerationUrlOptions

---

##### `urlForObject` <a name="urlForObject" id="cdk-extensions.s3_buckets.WafLogsBucket.urlForObject"></a>

```typescript
public urlForObject(_key?: string): string
```

The https URL of an S3 object.

For example:

- `https://s3.us-west-1.amazonaws.com/onlybucket`
- `https://s3.us-west-1.amazonaws.com/bucket/key`
- `https://s3.cn-north-1.amazonaws.com.cn/china-bucket/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.WafLogsBucket.urlForObject.parameter._key"></a>

- *Type:* string

---

##### `virtualHostedUrlForObject` <a name="virtualHostedUrlForObject" id="cdk-extensions.s3_buckets.WafLogsBucket.virtualHostedUrlForObject"></a>

```typescript
public virtualHostedUrlForObject(_key?: string, _options?: VirtualHostedStyleUrlOptions): string
```

The virtual hosted-style URL of an S3 object.

Specify `regional: false` at
the options for non-regional URL. For example:

- `https://only-bucket.s3.us-west-1.amazonaws.com`
- `https://bucket.s3.us-west-1.amazonaws.com/key`
- `https://bucket.s3.amazonaws.com/key`
- `https://china-bucket.s3.cn-north-1.amazonaws.com.cn/mykey`

###### `_key`<sup>Optional</sup> <a name="_key" id="cdk-extensions.s3_buckets.WafLogsBucket.virtualHostedUrlForObject.parameter._key"></a>

- *Type:* string

---

###### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.s3_buckets.WafLogsBucket.virtualHostedUrlForObject.parameter._options"></a>

- *Type:* aws-cdk-lib.aws_s3.VirtualHostedStyleUrlOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.s3_buckets.WafLogsBucket.isConstruct"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.WafLogsBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.s3_buckets.WafLogsBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.s3_buckets.WafLogsBucket.isOwnedResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.WafLogsBucket.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.WafLogsBucket.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.s3_buckets.WafLogsBucket.isResource"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

s3_buckets.WafLogsBucket.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.s3_buckets.WafLogsBucket.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.bucketArn">bucketArn</a></code> | <code>string</code> | The ARN of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | The IPv4 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.bucketDualStackDomainName">bucketDualStackDomainName</a></code> | <code>string</code> | The IPv6 DNS name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.bucketName">bucketName</a></code> | <code>string</code> | The name of the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.bucketRegionalDomainName">bucketRegionalDomainName</a></code> | <code>string</code> | The regional domain name of the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.bucketWebsiteDomainName">bucketWebsiteDomainName</a></code> | <code>string</code> | The Domain name of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.bucketWebsiteUrl">bucketWebsiteUrl</a></code> | <code>string</code> | The URL of the static website. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_s3.CfnBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | Optional KMS encryption key associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.isWebsite">isWebsite</a></code> | <code>boolean</code> | If this bucket has been configured for static website hosting. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.policy">policy</a></code> | <code>aws-cdk-lib.aws_s3.BucketPolicy</code> | The resource policy associated with this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.table">table</a></code> | <code>cdk-extensions.glue_tables.WafLogsTable</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucket.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.s3_buckets.WafLogsBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.s3_buckets.WafLogsBucket.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.s3_buckets.WafLogsBucket.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `bucketArn`<sup>Required</sup> <a name="bucketArn" id="cdk-extensions.s3_buckets.WafLogsBucket.property.bucketArn"></a>

```typescript
public readonly bucketArn: string;
```

- *Type:* string

The ARN of the bucket.

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="cdk-extensions.s3_buckets.WafLogsBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

The IPv4 DNS name of the specified bucket.

---

##### `bucketDualStackDomainName`<sup>Required</sup> <a name="bucketDualStackDomainName" id="cdk-extensions.s3_buckets.WafLogsBucket.property.bucketDualStackDomainName"></a>

```typescript
public readonly bucketDualStackDomainName: string;
```

- *Type:* string

The IPv6 DNS name of the specified bucket.

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.WafLogsBucket.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

The name of the bucket.

---

##### `bucketRegionalDomainName`<sup>Required</sup> <a name="bucketRegionalDomainName" id="cdk-extensions.s3_buckets.WafLogsBucket.property.bucketRegionalDomainName"></a>

```typescript
public readonly bucketRegionalDomainName: string;
```

- *Type:* string

The regional domain name of the specified bucket.

---

##### `bucketWebsiteDomainName`<sup>Required</sup> <a name="bucketWebsiteDomainName" id="cdk-extensions.s3_buckets.WafLogsBucket.property.bucketWebsiteDomainName"></a>

```typescript
public readonly bucketWebsiteDomainName: string;
```

- *Type:* string

The Domain name of the static website.

---

##### `bucketWebsiteUrl`<sup>Required</sup> <a name="bucketWebsiteUrl" id="cdk-extensions.s3_buckets.WafLogsBucket.property.bucketWebsiteUrl"></a>

```typescript
public readonly bucketWebsiteUrl: string;
```

- *Type:* string

The URL of the static website.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.s3_buckets.WafLogsBucket.property.resource"></a>

```typescript
public readonly resource: CfnBucket;
```

- *Type:* aws-cdk-lib.aws_s3.CfnBucket

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.s3_buckets.WafLogsBucket.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

Optional KMS encryption key associated with this bucket.

---

##### `isWebsite`<sup>Optional</sup> <a name="isWebsite" id="cdk-extensions.s3_buckets.WafLogsBucket.property.isWebsite"></a>

```typescript
public readonly isWebsite: boolean;
```

- *Type:* boolean

If this bucket has been configured for static website hosting.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk-extensions.s3_buckets.WafLogsBucket.property.policy"></a>

```typescript
public readonly policy: BucketPolicy;
```

- *Type:* aws-cdk-lib.aws_s3.BucketPolicy

The resource policy associated with this bucket.

If `autoCreatePolicy` is true, a `BucketPolicy` will be created upon the
first call to addToResourcePolicy(s).

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.s3_buckets.WafLogsBucket.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.s3_buckets.WafLogsBucket.property.table"></a>

```typescript
public readonly table: WafLogsTable;
```

- *Type:* cdk-extensions.glue_tables.WafLogsTable

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.WafLogsBucket.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.WafLogsBucket.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---


### WafLogsTable <a name="WafLogsTable" id="cdk-extensions.glue_tables.WafLogsTable"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue_tables.WafLogsTable.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

new glue_tables.WafLogsTable(scope: Construct, id: string, props: WafLogsTableProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue_tables.WafLogsTableProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue_tables.WafLogsTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue_tables.WafLogsTable.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue_tables.WafLogsTable.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue_tables.WafLogsTableProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.addColumn">addColumn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.addParameter">addParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.addPartitionKey">addPartitionKey</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.addSerdeParameter">addSerdeParameter</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.addStorageParameter">addStorageParameter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue_tables.WafLogsTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue_tables.WafLogsTable.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue_tables.WafLogsTable.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue_tables.WafLogsTable.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.WafLogsTable.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.glue_tables.WafLogsTable.addParameter"></a>

```typescript
public addParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.WafLogsTable.addParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.WafLogsTable.addParameter.parameter.value"></a>

- *Type:* string

---

##### `addPartitionKey` <a name="addPartitionKey" id="cdk-extensions.glue_tables.WafLogsTable.addPartitionKey"></a>

```typescript
public addPartitionKey(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue_tables.WafLogsTable.addPartitionKey.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---

##### `addSerdeParameter` <a name="addSerdeParameter" id="cdk-extensions.glue_tables.WafLogsTable.addSerdeParameter"></a>

```typescript
public addSerdeParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.WafLogsTable.addSerdeParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.WafLogsTable.addSerdeParameter.parameter.value"></a>

- *Type:* string

---

##### `addStorageParameter` <a name="addStorageParameter" id="cdk-extensions.glue_tables.WafLogsTable.addStorageParameter"></a>

```typescript
public addStorageParameter(key: string, value: string): void
```

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue_tables.WafLogsTable.addStorageParameter.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue_tables.WafLogsTable.addStorageParameter.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue_tables.WafLogsTable.isConstruct"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.WafLogsTable.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue_tables.WafLogsTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue_tables.WafLogsTable.isOwnedResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.WafLogsTable.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.WafLogsTable.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue_tables.WafLogsTable.isResource"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

glue_tables.WafLogsTable.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue_tables.WafLogsTable.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | {@link TableProps.database:}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnTable</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.tableArn">tableArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.compressed">compressed</a></code> | <code>boolean</code> | {@link TableProps.compressed}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | {@link TableProps.dataFormat}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.description">description</a></code> | <code>string</code> | {@link TableProps.description}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.location">location</a></code> | <code>string</code> | {@link TableProps.location}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.name">name</a></code> | <code>string</code> | {@link TableProps.name}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.owner">owner</a></code> | <code>string</code> | {@link TableProps.owner}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | {@link TableProps.retention}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.serdeName">serdeName</a></code> | <code>string</code> | {@link TableProps.serdeName}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | {@link TableProps.storedAsSubDirectories}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | {@link TableProps.tableType}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | {@link TableProps.targetTable}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | {@link TableProps.viewExpandedText}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | {@link TableProps.viewOriginalText}. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the WAF Logs. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.status5xxNamedQuery">status5xxNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTable.property.topIpsNamedQuery">topIpsNamedQuery</a></code> | <code>cdk-extensions.athena.NamedQuery</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue_tables.WafLogsTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue_tables.WafLogsTable.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue_tables.WafLogsTable.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.WafLogsTable.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

{@link TableProps.database:}.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue_tables.WafLogsTable.property.resource"></a>

```typescript
public readonly resource: CfnTable;
```

- *Type:* aws-cdk-lib.aws_glue.CfnTable

---

##### `tableArn`<sup>Required</sup> <a name="tableArn" id="cdk-extensions.glue_tables.WafLogsTable.property.tableArn"></a>

```typescript
public readonly tableArn: string;
```

- *Type:* string

---

##### `tableName`<sup>Required</sup> <a name="tableName" id="cdk-extensions.glue_tables.WafLogsTable.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue_tables.WafLogsTable.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

{@link TableProps.compressed}.

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue_tables.WafLogsTable.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

{@link TableProps.dataFormat}.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue_tables.WafLogsTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link TableProps.description}.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue_tables.WafLogsTable.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

{@link TableProps.location}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.WafLogsTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link TableProps.name}.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue_tables.WafLogsTable.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

{@link TableProps.owner}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue_tables.WafLogsTable.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

{@link TableProps.retention}.

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue_tables.WafLogsTable.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

{@link TableProps.serdeName}.

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue_tables.WafLogsTable.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

{@link TableProps.storedAsSubDirectories}.

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue_tables.WafLogsTable.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

{@link TableProps.tableType}.

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue_tables.WafLogsTable.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

{@link TableProps.targetTable}.

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue_tables.WafLogsTable.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

{@link TableProps.viewExpandedText}.

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue_tables.WafLogsTable.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

{@link TableProps.viewOriginalText}.

---

##### `createQueries`<sup>Required</sup> <a name="createQueries" id="cdk-extensions.glue_tables.WafLogsTable.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the WAF Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Required</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.WafLogsTable.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `status5xxNamedQuery`<sup>Optional</sup> <a name="status5xxNamedQuery" id="cdk-extensions.glue_tables.WafLogsTable.property.status5xxNamedQuery"></a>

```typescript
public readonly status5xxNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---

##### `topIpsNamedQuery`<sup>Optional</sup> <a name="topIpsNamedQuery" id="cdk-extensions.glue_tables.WafLogsTable.property.topIpsNamedQuery"></a>

```typescript
public readonly topIpsNamedQuery: NamedQuery;
```

- *Type:* cdk-extensions.athena.NamedQuery

---


### Workflow <a name="Workflow" id="cdk-extensions.glue.Workflow"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Workflow.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Workflow(scope: Construct, id: string, props: WorkflowProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Workflow.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | A CDK Construct that will serve as this stack's parent in the construct tree. |
| <code><a href="#cdk-extensions.glue.Workflow.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.glue.Workflow.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.WorkflowProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Workflow.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

A CDK Construct that will serve as this stack's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Workflow.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique
within the context of 'scope'.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.Workflow.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.WorkflowProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Workflow.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.glue.Workflow.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |
| <code><a href="#cdk-extensions.glue.Workflow.addTrigger">addTrigger</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk-extensions.glue.Workflow.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.glue.Workflow.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.glue.Workflow.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

##### `addTrigger` <a name="addTrigger" id="cdk-extensions.glue.Workflow.addTrigger"></a>

```typescript
public addTrigger(id: string, options: TriggerOptions): ITrigger
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.glue.Workflow.addTrigger.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.glue.Workflow.addTrigger.parameter.options"></a>

- *Type:* cdk-extensions.glue.TriggerOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Workflow.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.glue.Workflow.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.glue.Workflow.isResource">isResource</a></code> | Check whether the given construct is a Resource. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.glue.Workflow.isConstruct"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Workflow.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.glue.Workflow.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.glue.Workflow.isOwnedResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Workflow.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Workflow.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.glue.Workflow.isResource"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Workflow.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.glue.Workflow.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Workflow.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.Workflow.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.glue.Workflow.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.glue.Workflow.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_glue.CfnWorkflow</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Workflow.property.workflowArn">workflowArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Workflow.property.workflowName">workflowName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Workflow.property.description">description</a></code> | <code>string</code> | {@link WorkflowProps.description}. |
| <code><a href="#cdk-extensions.glue.Workflow.property.name">name</a></code> | <code>string</code> | {@link WorkflowProps.name}. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.Workflow.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.glue.Workflow.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.glue.Workflow.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.glue.Workflow.property.resource"></a>

```typescript
public readonly resource: CfnWorkflow;
```

- *Type:* aws-cdk-lib.aws_glue.CfnWorkflow

---

##### `workflowArn`<sup>Required</sup> <a name="workflowArn" id="cdk-extensions.glue.Workflow.property.workflowArn"></a>

```typescript
public readonly workflowArn: string;
```

- *Type:* string

---

##### `workflowName`<sup>Required</sup> <a name="workflowName" id="cdk-extensions.glue.Workflow.property.workflowName"></a>

```typescript
public readonly workflowName: string;
```

- *Type:* string

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.Workflow.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

{@link WorkflowProps.description}.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.Workflow.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

{@link WorkflowProps.name}.

---


### Workspace <a name="Workspace" id="cdk-extensions.aps.Workspace"></a>

- *Implements:* cdk-extensions.aps.IWorkspace

Represents an Amazon Managed Service for Prometheus workspace.

A _workspace_ is a logical and isolated Prometheus server dedicated to
Prometheus resources such as metrics.

You can have one or more workspaces in each Region in your account.

> [[AWS::APS::Workspace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#aws-resource-aps-workspace-return-values)]([AWS::APS::Workspace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#aws-resource-aps-workspace-return-values))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.Workspace.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.Workspace(scope: IConstruct, id: string, props?: WorkspaceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.Workspace.Initializer.parameter.scope">scope</a></code> | <code>constructs.IConstruct</code> | A CDK Construct that will serve as this resource's parent in the construct tree. |
| <code><a href="#cdk-extensions.aps.Workspace.Initializer.parameter.id">id</a></code> | <code>string</code> | A name to be associated with the stack and used in resource naming. |
| <code><a href="#cdk-extensions.aps.Workspace.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.aps.WorkspaceProps</code> | Arguments related to the configuration of the resource. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.Workspace.Initializer.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resource's parent in the construct tree.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.Workspace.Initializer.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.aps.Workspace.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.aps.WorkspaceProps

Arguments related to the configuration of the resource.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.Workspace.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk-extensions.aps.Workspace.applyRemovalPolicy">applyRemovalPolicy</a></code> | Apply the given removal policy to this resource. |

---

##### `toString` <a name="toString" id="cdk-extensions.aps.Workspace.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `applyRemovalPolicy` <a name="applyRemovalPolicy" id="cdk-extensions.aps.Workspace.applyRemovalPolicy"></a>

```typescript
public applyRemovalPolicy(policy: RemovalPolicy): void
```

Apply the given removal policy to this resource.

The Removal Policy controls what happens to this resource when it stops
being managed by CloudFormation, either because you've removed it from the
CDK application or because you've made a change that requires the resource
to be replaced.

The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.aps.Workspace.applyRemovalPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.RemovalPolicy

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.Workspace.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk-extensions.aps.Workspace.isOwnedResource">isOwnedResource</a></code> | Returns true if the construct was created by CDK, and false otherwise. |
| <code><a href="#cdk-extensions.aps.Workspace.isResource">isResource</a></code> | Check whether the given construct is a Resource. |
| <code><a href="#cdk-extensions.aps.Workspace.fromWorkspaceArn">fromWorkspaceArn</a></code> | Imports an existing APS workspace by specifying its Amazon Resource Name (ARN). |
| <code><a href="#cdk-extensions.aps.Workspace.fromWorkspaceAttributes">fromWorkspaceAttributes</a></code> | Imports an existing APS workspace by explicitly specifying its attributes. |
| <code><a href="#cdk-extensions.aps.Workspace.fromWorkspaceId">fromWorkspaceId</a></code> | Imports an existing APS workspace by explicitly specifying its AWS generated ID. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="cdk-extensions.aps.Workspace.isConstruct"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.Workspace.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.aps.Workspace.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isOwnedResource` <a name="isOwnedResource" id="cdk-extensions.aps.Workspace.isOwnedResource"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.Workspace.isOwnedResource(construct: IConstruct)
```

Returns true if the construct was created by CDK, and false otherwise.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.aps.Workspace.isOwnedResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `isResource` <a name="isResource" id="cdk-extensions.aps.Workspace.isResource"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.Workspace.isResource(construct: IConstruct)
```

Check whether the given construct is a Resource.

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.aps.Workspace.isResource.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromWorkspaceArn` <a name="fromWorkspaceArn" id="cdk-extensions.aps.Workspace.fromWorkspaceArn"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.Workspace.fromWorkspaceArn(scope: IConstruct, id: string, workspaceArn: string)
```

Imports an existing APS workspace by specifying its Amazon Resource Name (ARN).

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.Workspace.fromWorkspaceArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.Workspace.fromWorkspaceArn.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `workspaceArn`<sup>Required</sup> <a name="workspaceArn" id="cdk-extensions.aps.Workspace.fromWorkspaceArn.parameter.workspaceArn"></a>

- *Type:* string

The ARN of the existing APS workspace to be imported.

---

##### `fromWorkspaceAttributes` <a name="fromWorkspaceAttributes" id="cdk-extensions.aps.Workspace.fromWorkspaceAttributes"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.Workspace.fromWorkspaceAttributes(scope: IConstruct, id: string, attrs: WorkspaceAttributes)
```

Imports an existing APS workspace by explicitly specifying its attributes.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.Workspace.fromWorkspaceAttributes.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.Workspace.fromWorkspaceAttributes.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `attrs`<sup>Required</sup> <a name="attrs" id="cdk-extensions.aps.Workspace.fromWorkspaceAttributes.parameter.attrs"></a>

- *Type:* cdk-extensions.aps.WorkspaceAttributes

The attributes of the existing APS workspace to be imported.

---

##### `fromWorkspaceId` <a name="fromWorkspaceId" id="cdk-extensions.aps.Workspace.fromWorkspaceId"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.Workspace.fromWorkspaceId(scope: IConstruct, id: string, workspaceId: string)
```

Imports an existing APS workspace by explicitly specifying its AWS generated ID.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.Workspace.fromWorkspaceId.parameter.scope"></a>

- *Type:* constructs.IConstruct

A CDK Construct that will serve as this resources's parent in the construct tree.

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.aps.Workspace.fromWorkspaceId.parameter.id"></a>

- *Type:* string

A name to be associated with the stack and used in resource naming.

Must be unique within the context of 'scope'.

---

###### `workspaceId`<sup>Required</sup> <a name="workspaceId" id="cdk-extensions.aps.Workspace.fromWorkspaceId.parameter.workspaceId"></a>

- *Type:* string

The AWS generated ID of the existing APS workspace to be imported.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.Workspace.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.aps.Workspace.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.aps.Workspace.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.aps.Workspace.property.resource">resource</a></code> | <code>aws-cdk-lib.aws_aps.CfnWorkspace</code> | The underlying Workspace CloudFormation resource. |
| <code><a href="#cdk-extensions.aps.Workspace.property.workspaceArn">workspaceArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the APS workspace. |
| <code><a href="#cdk-extensions.aps.Workspace.property.workspaceId">workspaceId</a></code> | <code>string</code> | The ID generated by AWS for the APS workspace. |
| <code><a href="#cdk-extensions.aps.Workspace.property.workspacePrometheusEndpoint">workspacePrometheusEndpoint</a></code> | <code>string</code> | The Prometheus endpoint attribute of the workspace. |
| <code><a href="#cdk-extensions.aps.Workspace.property.workspaceQueryUrl">workspaceQueryUrl</a></code> | <code>string</code> | The URL of the remote write endpoint which can be used to ingest metrics into the Prometheus workspace. |
| <code><a href="#cdk-extensions.aps.Workspace.property.workspaceRemoteWriteUrl">workspaceRemoteWriteUrl</a></code> | <code>string</code> | The URL of the endpoint that other services can use to query the workspace. |
| <code><a href="#cdk-extensions.aps.Workspace.property.alerting">alerting</a></code> | <code>cdk-extensions.aps.WorkspaceAlertingOptions</code> | The details used to configure alerting for the APS workspace. |
| <code><a href="#cdk-extensions.aps.Workspace.property.alertManagerConfiguration">alertManagerConfiguration</a></code> | <code>cdk-extensions.aps.AlertManagerConfiguration</code> | The configuration contolling how alerts are sent for the workspace. |
| <code><a href="#cdk-extensions.aps.Workspace.property.alertTopic">alertTopic</a></code> | <code>aws-cdk-lib.aws_sns.ITopic</code> | The SNS topic where alerts generated by the workspace will be sent. |
| <code><a href="#cdk-extensions.aps.Workspace.property.alias">alias</a></code> | <code>string</code> | An alias that you assign to this workspace to help you identify it. It does not need to be unique. |
| <code><a href="#cdk-extensions.aps.Workspace.property.logging">logging</a></code> | <code>cdk-extensions.aps.WorkspaceLoggingOptions</code> | The details used for configuring logging for the APS workspace. |
| <code><a href="#cdk-extensions.aps.Workspace.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | The CloudWatch log group where logs emitted by the APS workspace will be sent. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.Workspace.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.aps.Workspace.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.aps.Workspace.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.aps.Workspace.property.resource"></a>

```typescript
public readonly resource: CfnWorkspace;
```

- *Type:* aws-cdk-lib.aws_aps.CfnWorkspace

The underlying Workspace CloudFormation resource.

> [[AWS::APS::Workspace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html)]([AWS::APS::Workspace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html))

---

##### `workspaceArn`<sup>Required</sup> <a name="workspaceArn" id="cdk-extensions.aps.Workspace.property.workspaceArn"></a>

```typescript
public readonly workspaceArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the APS workspace.

---

##### `workspaceId`<sup>Required</sup> <a name="workspaceId" id="cdk-extensions.aps.Workspace.property.workspaceId"></a>

```typescript
public readonly workspaceId: string;
```

- *Type:* string

The ID generated by AWS for the APS workspace.

---

##### `workspacePrometheusEndpoint`<sup>Required</sup> <a name="workspacePrometheusEndpoint" id="cdk-extensions.aps.Workspace.property.workspacePrometheusEndpoint"></a>

```typescript
public readonly workspacePrometheusEndpoint: string;
```

- *Type:* string

The Prometheus endpoint attribute of the workspace.

This is the endpoint prefix without the remote_write or query API
appended.

---

##### `workspaceQueryUrl`<sup>Required</sup> <a name="workspaceQueryUrl" id="cdk-extensions.aps.Workspace.property.workspaceQueryUrl"></a>

```typescript
public readonly workspaceQueryUrl: string;
```

- *Type:* string

The URL of the remote write endpoint which can be used to ingest metrics into the Prometheus workspace.

---

##### `workspaceRemoteWriteUrl`<sup>Required</sup> <a name="workspaceRemoteWriteUrl" id="cdk-extensions.aps.Workspace.property.workspaceRemoteWriteUrl"></a>

```typescript
public readonly workspaceRemoteWriteUrl: string;
```

- *Type:* string

The URL of the endpoint that other services can use to query the workspace.

---

##### `alerting`<sup>Optional</sup> <a name="alerting" id="cdk-extensions.aps.Workspace.property.alerting"></a>

```typescript
public readonly alerting: WorkspaceAlertingOptions;
```

- *Type:* cdk-extensions.aps.WorkspaceAlertingOptions

The details used to configure alerting for the APS workspace.

> [[Workspace AlertManagerDefinition](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-alertmanagerdefinition)]([Workspace AlertManagerDefinition](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-alertmanagerdefinition))

---

##### `alertManagerConfiguration`<sup>Optional</sup> <a name="alertManagerConfiguration" id="cdk-extensions.aps.Workspace.property.alertManagerConfiguration"></a>

```typescript
public readonly alertManagerConfiguration: AlertManagerConfiguration;
```

- *Type:* cdk-extensions.aps.AlertManagerConfiguration

The configuration contolling how alerts are sent for the workspace.

Only
available when alerting is enabled and the default alerting configuration
is used.

---

##### `alertTopic`<sup>Optional</sup> <a name="alertTopic" id="cdk-extensions.aps.Workspace.property.alertTopic"></a>

```typescript
public readonly alertTopic: ITopic;
```

- *Type:* aws-cdk-lib.aws_sns.ITopic

The SNS topic where alerts generated by the workspace will be sent.

Only
set if alerting is enabled and the default alert manager configuration is
used.

---

##### `alias`<sup>Optional</sup> <a name="alias" id="cdk-extensions.aps.Workspace.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

An alias that you assign to this workspace to help you identify it. It does not need to be unique.

The alias can be as many as 100 characters and can include any type of
characters.

> [[Workspace Alias](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-alias)]([Workspace Alias](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-alias))

---

##### `logging`<sup>Optional</sup> <a name="logging" id="cdk-extensions.aps.Workspace.property.logging"></a>

```typescript
public readonly logging: WorkspaceLoggingOptions;
```

- *Type:* cdk-extensions.aps.WorkspaceLoggingOptions

The details used for configuring logging for the APS workspace.

> [[Workspace LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-loggingconfiguration)]([Workspace LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-loggingconfiguration))

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.aps.Workspace.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The CloudWatch log group where logs emitted by the APS workspace will be sent.

---


## Structs <a name="Structs" id="Structs"></a>

### AccessControlAttributeOptions <a name="AccessControlAttributeOptions" id="cdk-extensions.sso.AccessControlAttributeOptions"></a>

Configuration options for adding an ABAC attribute to IAM Identity Center.

#### Initializer <a name="Initializer" id="cdk-extensions.sso.AccessControlAttributeOptions.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

const accessControlAttributeOptions: sso.AccessControlAttributeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.AccessControlAttributeOptions.property.name">name</a></code> | <code>string</code> | The name of the attribute associated with your identities in your identity source. |
| <code><a href="#cdk-extensions.sso.AccessControlAttributeOptions.property.sources">sources</a></code> | <code>string[]</code> | A list of identity sources to use when mapping a specified attribute to IAM Identity Center. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.sso.AccessControlAttributeOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute associated with your identities in your identity source.

This is used to map a specified attribute in your
identity source with an attribute in IAM Identity Center.

---

##### `sources`<sup>Optional</sup> <a name="sources" id="cdk-extensions.sso.AccessControlAttributeOptions.property.sources"></a>

```typescript
public readonly sources: string[];
```

- *Type:* string[]

A list of identity sources to use when mapping a specified attribute to IAM Identity Center.

> [[AWS::SSO::InstanceAccessControlAttributeConfiguration AccessControlAttributeValue](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sso-instanceaccesscontrolattributeconfiguration-accesscontrolattributevalue.html#cfn-sso-instanceaccesscontrolattributeconfiguration-accesscontrolattributevalue-source)]([AWS::SSO::InstanceAccessControlAttributeConfiguration AccessControlAttributeValue](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sso-instanceaccesscontrolattributeconfiguration-accesscontrolattributevalue.html#cfn-sso-instanceaccesscontrolattributeconfiguration-accesscontrolattributevalue-source))

---

### AddChildPoolOptions <a name="AddChildPoolOptions" id="cdk-extensions.ec2.AddChildPoolOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.AddChildPoolOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const addChildPoolOptions: ec2.AddChildPoolOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.addressConfiguration">addressConfiguration</a></code> | <code>cdk-extensions.ec2.AddressConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.autoImport">autoImport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.consumer">consumer</a></code> | <code>cdk-extensions.ec2.IpamConsumer</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.locale">locale</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.provisionedCidrs">provisionedCidrs</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.publicIpSource">publicIpSource</a></code> | <code>cdk-extensions.ec2.PublicIpSource</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddChildPoolOptions.property.tagRestrictions">tagRestrictions</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `addressConfiguration`<sup>Optional</sup> <a name="addressConfiguration" id="cdk-extensions.ec2.AddChildPoolOptions.property.addressConfiguration"></a>

```typescript
public readonly addressConfiguration: AddressConfiguration;
```

- *Type:* cdk-extensions.ec2.AddressConfiguration

---

##### `autoImport`<sup>Optional</sup> <a name="autoImport" id="cdk-extensions.ec2.AddChildPoolOptions.property.autoImport"></a>

```typescript
public readonly autoImport: boolean;
```

- *Type:* boolean

---

##### `consumer`<sup>Optional</sup> <a name="consumer" id="cdk-extensions.ec2.AddChildPoolOptions.property.consumer"></a>

```typescript
public readonly consumer: IpamConsumer;
```

- *Type:* cdk-extensions.ec2.IpamConsumer

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.AddChildPoolOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `locale`<sup>Optional</sup> <a name="locale" id="cdk-extensions.ec2.AddChildPoolOptions.property.locale"></a>

```typescript
public readonly locale: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.AddChildPoolOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `provisionedCidrs`<sup>Optional</sup> <a name="provisionedCidrs" id="cdk-extensions.ec2.AddChildPoolOptions.property.provisionedCidrs"></a>

```typescript
public readonly provisionedCidrs: string[];
```

- *Type:* string[]

---

##### `publicIpSource`<sup>Optional</sup> <a name="publicIpSource" id="cdk-extensions.ec2.AddChildPoolOptions.property.publicIpSource"></a>

```typescript
public readonly publicIpSource: PublicIpSource;
```

- *Type:* cdk-extensions.ec2.PublicIpSource

---

##### `tagRestrictions`<sup>Optional</sup> <a name="tagRestrictions" id="cdk-extensions.ec2.AddChildPoolOptions.property.tagRestrictions"></a>

```typescript
public readonly tagRestrictions: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

### AddCidrToPoolOptions <a name="AddCidrToPoolOptions" id="cdk-extensions.ec2.AddCidrToPoolOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.AddCidrToPoolOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const addCidrToPoolOptions: ec2.AddCidrToPoolOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.AddCidrToPoolOptions.property.configuration">configuration</a></code> | <code>cdk-extensions.ec2.IIpamPoolCidrConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddCidrToPoolOptions.property.allowInline">allowInline</a></code> | <code>boolean</code> | *No description.* |

---

##### `configuration`<sup>Required</sup> <a name="configuration" id="cdk-extensions.ec2.AddCidrToPoolOptions.property.configuration"></a>

```typescript
public readonly configuration: IIpamPoolCidrConfiguration;
```

- *Type:* cdk-extensions.ec2.IIpamPoolCidrConfiguration

---

##### `allowInline`<sup>Optional</sup> <a name="allowInline" id="cdk-extensions.ec2.AddCidrToPoolOptions.property.allowInline"></a>

```typescript
public readonly allowInline: boolean;
```

- *Type:* boolean

---

### AddCidrToPoolResult <a name="AddCidrToPoolResult" id="cdk-extensions.ec2.AddCidrToPoolResult"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.AddCidrToPoolResult.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const addCidrToPoolResult: ec2.AddCidrToPoolResult = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.AddCidrToPoolResult.property.inline">inline</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddCidrToPoolResult.property.cidr">cidr</a></code> | <code>cdk-extensions.ec2.IIpamPoolCidr</code> | *No description.* |

---

##### `inline`<sup>Required</sup> <a name="inline" id="cdk-extensions.ec2.AddCidrToPoolResult.property.inline"></a>

```typescript
public readonly inline: boolean;
```

- *Type:* boolean

---

##### `cidr`<sup>Optional</sup> <a name="cidr" id="cdk-extensions.ec2.AddCidrToPoolResult.property.cidr"></a>

```typescript
public readonly cidr: IIpamPoolCidr;
```

- *Type:* cdk-extensions.ec2.IIpamPoolCidr

---

### AddNetworkOptions <a name="AddNetworkOptions" id="cdk-extensions.ec2_patterns.AddNetworkOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.AddNetworkOptions.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const addNetworkOptions: ec2_patterns.AddNetworkOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.AddNetworkOptions.property.netmask">netmask</a></code> | <code>number</code> | *No description.* |

---

##### `netmask`<sup>Optional</sup> <a name="netmask" id="cdk-extensions.ec2_patterns.AddNetworkOptions.property.netmask"></a>

```typescript
public readonly netmask: number;
```

- *Type:* number

---

### AddPoolOptions <a name="AddPoolOptions" id="cdk-extensions.ec2_patterns.AddPoolOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.AddPoolOptions.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const addPoolOptions: ec2_patterns.AddPoolOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.AddPoolOptions.property.cidrs">cidrs</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddPoolOptions.property.defaultNetmaskLength">defaultNetmaskLength</a></code> | <code>number</code> | *No description.* |

---

##### `cidrs`<sup>Optional</sup> <a name="cidrs" id="cdk-extensions.ec2_patterns.AddPoolOptions.property.cidrs"></a>

```typescript
public readonly cidrs: string[];
```

- *Type:* string[]

---

##### `defaultNetmaskLength`<sup>Optional</sup> <a name="defaultNetmaskLength" id="cdk-extensions.ec2_patterns.AddPoolOptions.property.defaultNetmaskLength"></a>

```typescript
public readonly defaultNetmaskLength: number;
```

- *Type:* number

---

### AddressConfigurationProps <a name="AddressConfigurationProps" id="cdk-extensions.ec2.AddressConfigurationProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.AddressConfigurationProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const addressConfigurationProps: ec2.AddressConfigurationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.AddressConfigurationProps.property.defaultNetmaskLength">defaultNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfigurationProps.property.maxNetmaskLength">maxNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfigurationProps.property.minNetmaskLength">minNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfigurationProps.property.family">family</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfigurationProps.property.publiclyAdvertisable">publiclyAdvertisable</a></code> | <code>boolean</code> | *No description.* |

---

##### `defaultNetmaskLength`<sup>Optional</sup> <a name="defaultNetmaskLength" id="cdk-extensions.ec2.AddressConfigurationProps.property.defaultNetmaskLength"></a>

```typescript
public readonly defaultNetmaskLength: number;
```

- *Type:* number

---

##### `maxNetmaskLength`<sup>Optional</sup> <a name="maxNetmaskLength" id="cdk-extensions.ec2.AddressConfigurationProps.property.maxNetmaskLength"></a>

```typescript
public readonly maxNetmaskLength: number;
```

- *Type:* number

---

##### `minNetmaskLength`<sup>Optional</sup> <a name="minNetmaskLength" id="cdk-extensions.ec2.AddressConfigurationProps.property.minNetmaskLength"></a>

```typescript
public readonly minNetmaskLength: number;
```

- *Type:* number

---

##### `family`<sup>Required</sup> <a name="family" id="cdk-extensions.ec2.AddressConfigurationProps.property.family"></a>

```typescript
public readonly family: string;
```

- *Type:* string

---

##### `publiclyAdvertisable`<sup>Optional</sup> <a name="publiclyAdvertisable" id="cdk-extensions.ec2.AddressConfigurationProps.property.publiclyAdvertisable"></a>

```typescript
public readonly publiclyAdvertisable: boolean;
```

- *Type:* boolean

---

### AddSpokeNetworkProps <a name="AddSpokeNetworkProps" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const addSpokeNetworkProps: ec2_patterns.AddSpokeNetworkProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.availabilityZones">availabilityZones</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.cidr">cidr</a></code> | <code>cdk-extensions.ec2.ICidrProvider</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.defaultInstanceTenancy">defaultInstanceTenancy</a></code> | <code>aws-cdk-lib.aws_ec2.DefaultInstanceTenancy</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.enableDnsHostnames">enableDnsHostnames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.enableDnsSupport">enableDnsSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.flowLogs">flowLogs</a></code> | <code>{[ key: string ]: cdk-extensions.ec2_patterns.FlowLogOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.gatewayEndpoints">gatewayEndpoints</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.maxAzs">maxAzs</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpcName">vpcName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpnConnections">vpnConnections</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.VpnConnectionOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpnGateway">vpnGateway</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpnGatewayAsn">vpnGatewayAsn</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpnRoutePropagation">vpnRoutePropagation</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection[]</code> | *No description.* |

---

##### `availabilityZones`<sup>Optional</sup> <a name="availabilityZones" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* string[]

---

##### `cidr`<sup>Optional</sup> <a name="cidr" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.cidr"></a>

```typescript
public readonly cidr: ICidrProvider;
```

- *Type:* cdk-extensions.ec2.ICidrProvider

---

##### `defaultInstanceTenancy`<sup>Optional</sup> <a name="defaultInstanceTenancy" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.defaultInstanceTenancy"></a>

```typescript
public readonly defaultInstanceTenancy: DefaultInstanceTenancy;
```

- *Type:* aws-cdk-lib.aws_ec2.DefaultInstanceTenancy

---

##### `enableDnsHostnames`<sup>Optional</sup> <a name="enableDnsHostnames" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.enableDnsHostnames"></a>

```typescript
public readonly enableDnsHostnames: boolean;
```

- *Type:* boolean

---

##### `enableDnsSupport`<sup>Optional</sup> <a name="enableDnsSupport" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.enableDnsSupport"></a>

```typescript
public readonly enableDnsSupport: boolean;
```

- *Type:* boolean

---

##### `flowLogs`<sup>Optional</sup> <a name="flowLogs" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.flowLogs"></a>

```typescript
public readonly flowLogs: {[ key: string ]: FlowLogOptions};
```

- *Type:* {[ key: string ]: cdk-extensions.ec2_patterns.FlowLogOptions}

---

##### `gatewayEndpoints`<sup>Optional</sup> <a name="gatewayEndpoints" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.gatewayEndpoints"></a>

```typescript
public readonly gatewayEndpoints: {[ key: string ]: GatewayVpcEndpointOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions}

---

##### `maxAzs`<sup>Optional</sup> <a name="maxAzs" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.maxAzs"></a>

```typescript
public readonly maxAzs: number;
```

- *Type:* number

---

##### `vpcName`<sup>Optional</sup> <a name="vpcName" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* string

---

##### `vpnConnections`<sup>Optional</sup> <a name="vpnConnections" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpnConnections"></a>

```typescript
public readonly vpnConnections: {[ key: string ]: VpnConnectionOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.VpnConnectionOptions}

---

##### `vpnGateway`<sup>Optional</sup> <a name="vpnGateway" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpnGateway"></a>

```typescript
public readonly vpnGateway: boolean;
```

- *Type:* boolean

---

##### `vpnGatewayAsn`<sup>Optional</sup> <a name="vpnGatewayAsn" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpnGatewayAsn"></a>

```typescript
public readonly vpnGatewayAsn: number;
```

- *Type:* number

---

##### `vpnRoutePropagation`<sup>Optional</sup> <a name="vpnRoutePropagation" id="cdk-extensions.ec2_patterns.AddSpokeNetworkProps.property.vpnRoutePropagation"></a>

```typescript
public readonly vpnRoutePropagation: SubnetSelection[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection[]

---

### AdotCollectorProps <a name="AdotCollectorProps" id="cdk-extensions.k8s_aws.AdotCollectorProps"></a>

Condifuration for the AdorCollector resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.AdotCollectorProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const adotCollectorProps: k8s_aws.AdotCollectorProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollectorProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollectorProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollectorProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollectorProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollectorProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the ADOT Collector will be deployed. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollectorProps.property.createNamespace">createNamespace</a></code> | <code>boolean</code> | Flag wich sets whether the deploy of the ADOT collector should include creating the Kubernetes namespace the service will be deployed to. |
| <code><a href="#cdk-extensions.k8s_aws.AdotCollectorProps.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where resources related to the ADOT collector will be created. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.AdotCollectorProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.AdotCollectorProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.AdotCollectorProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.AdotCollectorProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.AdotCollectorProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the ADOT Collector will be deployed.

---

##### `createNamespace`<sup>Optional</sup> <a name="createNamespace" id="cdk-extensions.k8s_aws.AdotCollectorProps.property.createNamespace"></a>

```typescript
public readonly createNamespace: boolean;
```

- *Type:* boolean
- *Default:* true

Flag wich sets whether the deploy of the ADOT collector should include creating the Kubernetes namespace the service will be deployed to.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.AdotCollectorProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string
- *Default:* {@link AdotCollector.DEFAULT_NAMESPACE}

The Kubernetes namespace where resources related to the ADOT collector will be created.

---

### AlbLogsBucketProps <a name="AlbLogsBucketProps" id="cdk-extensions.s3_buckets.AlbLogsBucketProps"></a>

Configuration for objects bucket.

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const albLogsBucketProps: s3_buckets.AlbLogsBucketProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.bucketName">bucketName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.AlbLogsBucketProps.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucketName`<sup>Optional</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---

##### `tableName`<sup>Optional</sup> <a name="tableName" id="cdk-extensions.s3_buckets.AlbLogsBucketProps.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

### AlbLogsTableProps <a name="AlbLogsTableProps" id="cdk-extensions.glue_tables.AlbLogsTableProps"></a>

Configuration for AlbLogsTable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue_tables.AlbLogsTableProps.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

const albLogsTableProps: glue_tables.AlbLogsTableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | A bucket where logs will be stored. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the ALB Logs. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.name">name</a></code> | <code>string</code> | Name for Alb Logs Table. |
| <code><a href="#cdk-extensions.glue_tables.AlbLogsTableProps.property.s3Prefix">s3Prefix</a></code> | <code>string</code> | Set a custom prefix for the S3 Bucket. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

A bucket where logs will be stored.

> [[AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html)]([AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html))

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in.

> [[AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html)]([AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html))

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the ALB Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name for Alb Logs Table.

---

##### `s3Prefix`<sup>Optional</sup> <a name="s3Prefix" id="cdk-extensions.glue_tables.AlbLogsTableProps.property.s3Prefix"></a>

```typescript
public readonly s3Prefix: string;
```

- *Type:* string

Set a custom prefix for the S3 Bucket.

---

### AlertingRuleProps <a name="AlertingRuleProps" id="cdk-extensions.aps.AlertingRuleProps"></a>

Options needed to configure a Prometheus alerting rule inside an APS rules configuration.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.AlertingRuleProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const alertingRuleProps: aps.AlertingRuleProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertingRuleProps.property.alert">alert</a></code> | <code>string</code> | The name of the alert. |
| <code><a href="#cdk-extensions.aps.AlertingRuleProps.property.expression">expression</a></code> | <code>string</code> | The PromQL expression to evaluate. |
| <code><a href="#cdk-extensions.aps.AlertingRuleProps.property.annotations">annotations</a></code> | <code>{[ key: string ]: string}</code> | Annotations to add to each alert. |
| <code><a href="#cdk-extensions.aps.AlertingRuleProps.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Labels to add or overwrite for each alert. |
| <code><a href="#cdk-extensions.aps.AlertingRuleProps.property.period">period</a></code> | <code>aws-cdk-lib.Duration</code> | Alerts are considered firing once they have been returned for this long. |

---

##### `alert`<sup>Required</sup> <a name="alert" id="cdk-extensions.aps.AlertingRuleProps.property.alert"></a>

```typescript
public readonly alert: string;
```

- *Type:* string

The name of the alert.

Must be a valid label value.

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk-extensions.aps.AlertingRuleProps.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

The PromQL expression to evaluate.

Every evaluation cycle this is
evaluated at the current time, and all resultant time series become
pending/firing alerts.

> [[Querying prometheus](https://prometheus.io/docs/prometheus/latest/querying/basics/)]([Querying prometheus](https://prometheus.io/docs/prometheus/latest/querying/basics/))

---

##### `annotations`<sup>Optional</sup> <a name="annotations" id="cdk-extensions.aps.AlertingRuleProps.property.annotations"></a>

```typescript
public readonly annotations: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Annotations to add to each alert.

Supports templating.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk-extensions.aps.AlertingRuleProps.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Labels to add or overwrite for each alert.

---

##### `period`<sup>Optional</sup> <a name="period" id="cdk-extensions.aps.AlertingRuleProps.property.period"></a>

```typescript
public readonly period: Duration;
```

- *Type:* aws-cdk-lib.Duration

Alerts are considered firing once they have been returned for this long.

Alerts which have not yet fired for long enough are considered pending.

---

### AlertManagerConfigurationDetails <a name="AlertManagerConfigurationDetails" id="cdk-extensions.aps.AlertManagerConfigurationDetails"></a>

The details that are needed to configure alert manager for an Amazon APS workspace.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.AlertManagerConfigurationDetails.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const alertManagerConfigurationDetails: aps.AlertManagerConfigurationDetails = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerConfigurationDetails.property.contents">contents</a></code> | <code>string</code> | The rendered alert manager configuration in the format expected by an Amazon APS workspace. |

---

##### `contents`<sup>Required</sup> <a name="contents" id="cdk-extensions.aps.AlertManagerConfigurationDetails.property.contents"></a>

```typescript
public readonly contents: string;
```

- *Type:* string

The rendered alert manager configuration in the format expected by an Amazon APS workspace.

---

### AlertManagerConfigurationProps <a name="AlertManagerConfigurationProps" id="cdk-extensions.aps.AlertManagerConfigurationProps"></a>

Configuration for alert manager running on Amazon APS.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.AlertManagerConfigurationProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const alertManagerConfigurationProps: aps.AlertManagerConfigurationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerConfigurationProps.property.defaultReceiverDestinations">defaultReceiverDestinations</a></code> | <code>cdk-extensions.aps.IAlertManagerDestination[]</code> | Destinations where all alerts generated by APS should be sent. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfigurationProps.property.defaultRoute">defaultRoute</a></code> | <code>cdk-extensions.aps.DefaultRouteOptions</code> | Options for configuring the behavior of the default route that gets created for alerts. |
| <code><a href="#cdk-extensions.aps.AlertManagerConfigurationProps.property.templates">templates</a></code> | <code>cdk-extensions.aps.AlertManagerTemplate[]</code> | Collection of templates to make available to alert manager. |

---

##### `defaultReceiverDestinations`<sup>Optional</sup> <a name="defaultReceiverDestinations" id="cdk-extensions.aps.AlertManagerConfigurationProps.property.defaultReceiverDestinations"></a>

```typescript
public readonly defaultReceiverDestinations: IAlertManagerDestination[];
```

- *Type:* cdk-extensions.aps.IAlertManagerDestination[]

Destinations where all alerts generated by APS should be sent.

If this property is not a provided, a new default topic will be created to
receive notifications. If a default topic is not desired (such as in cases
where topics will be registered dynamically later in the build) an empty
list can be provided. This will result in the default topic not being
created an no destinations being configured for the default receiver.

Note that the default receiver requires at least one destination to be
registered, so if the default topic is skipped and no destinations are
provided here, at least one destination _must_ be registered for the
default route before the CDK app is synthed.

---

##### `defaultRoute`<sup>Optional</sup> <a name="defaultRoute" id="cdk-extensions.aps.AlertManagerConfigurationProps.property.defaultRoute"></a>

```typescript
public readonly defaultRoute: DefaultRouteOptions;
```

- *Type:* cdk-extensions.aps.DefaultRouteOptions

Options for configuring the behavior of the default route that gets created for alerts.

The default route for alert manager does not support all options allowed
by child routes.

---

##### `templates`<sup>Optional</sup> <a name="templates" id="cdk-extensions.aps.AlertManagerConfigurationProps.property.templates"></a>

```typescript
public readonly templates: AlertManagerTemplate[];
```

- *Type:* cdk-extensions.aps.AlertManagerTemplate[]

Collection of templates to make available to alert manager.

The templates
are available to be referenced in any field that supports templating by
using the `template` templating function and referencing the name of the
template as defined in the template content with the `define` keyword.

> [[Reference defined templates](https://pkg.go.dev/text/template#hdr-Nested_template_definitions)]([Reference defined templates](https://pkg.go.dev/text/template#hdr-Nested_template_definitions))

---

### AlertManagerReceiverProps <a name="AlertManagerReceiverProps" id="cdk-extensions.aps.AlertManagerReceiverProps"></a>

Configuration for the aler manager route.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.AlertManagerReceiverProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const alertManagerReceiverProps: aps.AlertManagerReceiverProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiverProps.property.destinations">destinations</a></code> | <code>cdk-extensions.aps.IAlertManagerDestination[]</code> | Details for alerting providers where events routed to this receiver should be sent,. |
| <code><a href="#cdk-extensions.aps.AlertManagerReceiverProps.property.name">name</a></code> | <code>string</code> | The name of the receiver which can be referenced in the other parts of the configuration. |

---

##### `destinations`<sup>Optional</sup> <a name="destinations" id="cdk-extensions.aps.AlertManagerReceiverProps.property.destinations"></a>

```typescript
public readonly destinations: IAlertManagerDestination[];
```

- *Type:* cdk-extensions.aps.IAlertManagerDestination[]

Details for alerting providers where events routed to this receiver should be sent,.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.aps.AlertManagerReceiverProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the receiver which can be referenced in the other parts of the configuration.

---

### AlertManagerRouteProps <a name="AlertManagerRouteProps" id="cdk-extensions.aps.AlertManagerRouteProps"></a>

Configuration for the alert manager route.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.AlertManagerRouteProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const alertManagerRouteProps: aps.AlertManagerRouteProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.receiver">receiver</a></code> | <code>cdk-extensions.aps.AlertManagerReceiver</code> | The receiver that should be the target of alerts that are generated by the node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.activeTimeIntervals">activeTimeIntervals</a></code> | <code>cdk-extensions.aps.TimeInterval[]</code> | Times when the route should be active. |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.children">children</a></code> | <code>cdk-extensions.aps.AlertManagerRouteProps[]</code> | Optional child routes to add to the node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.continueMatching">continueMatching</a></code> | <code>boolean</code> | Whether an alert should continue matching subsequent sibling nodes. |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.groupByLabels">groupByLabels</a></code> | <code>string[]</code> | The labels by which incoming alerts are grouped together. |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.groupInterval">groupInterval</a></code> | <code>aws-cdk-lib.Duration</code> | How long to wait before sending a notification about new alerts that are added to a group of alerts for which an initial notification has already been sent (usually ~5m or more). |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.groupWait">groupWait</a></code> | <code>aws-cdk-lib.Duration</code> | How long to initially wait to send a notification for a group of alerts. |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.matchers">matchers</a></code> | <code>cdk-extensions.aps.AlertManagerMatcher[]</code> | A list of matchers that an alert has to fulfill to match the node. |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.muteTimeInterval">muteTimeInterval</a></code> | <code>cdk-extensions.aps.TimeInterval[]</code> | Times when the route should be muted. The root node cannot have any mute times. |
| <code><a href="#cdk-extensions.aps.AlertManagerRouteProps.property.repeatInterval">repeatInterval</a></code> | <code>aws-cdk-lib.Duration</code> | How long to wait before sending a notification again if it has already been sent successfully for an alert. |

---

##### `receiver`<sup>Required</sup> <a name="receiver" id="cdk-extensions.aps.AlertManagerRouteProps.property.receiver"></a>

```typescript
public readonly receiver: AlertManagerReceiver;
```

- *Type:* cdk-extensions.aps.AlertManagerReceiver

The receiver that should be the target of alerts that are generated by the node.

---

##### `activeTimeIntervals`<sup>Optional</sup> <a name="activeTimeIntervals" id="cdk-extensions.aps.AlertManagerRouteProps.property.activeTimeIntervals"></a>

```typescript
public readonly activeTimeIntervals: TimeInterval[];
```

- *Type:* cdk-extensions.aps.TimeInterval[]

Times when the route should be active.

An empty value means that the route
is always active. Additionally, the root node cannot have any active
times.

The route will send notifications only when active, but otherwise acts
normally (including ending the route-matching process if the
`continueMatching` option is not set).

---

##### `children`<sup>Optional</sup> <a name="children" id="cdk-extensions.aps.AlertManagerRouteProps.property.children"></a>

```typescript
public readonly children: AlertManagerRouteProps[];
```

- *Type:* cdk-extensions.aps.AlertManagerRouteProps[]

Optional child routes to add to the node.

---

##### `continueMatching`<sup>Optional</sup> <a name="continueMatching" id="cdk-extensions.aps.AlertManagerRouteProps.property.continueMatching"></a>

```typescript
public readonly continueMatching: boolean;
```

- *Type:* boolean

Whether an alert should continue matching subsequent sibling nodes.

---

##### `groupByLabels`<sup>Optional</sup> <a name="groupByLabels" id="cdk-extensions.aps.AlertManagerRouteProps.property.groupByLabels"></a>

```typescript
public readonly groupByLabels: string[];
```

- *Type:* string[]

The labels by which incoming alerts are grouped together.

For example,
multiple alerts coming in for cluster=A and alertname=LatencyHigh would be
batched into a single group.

---

##### `groupInterval`<sup>Optional</sup> <a name="groupInterval" id="cdk-extensions.aps.AlertManagerRouteProps.property.groupInterval"></a>

```typescript
public readonly groupInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to wait before sending a notification about new alerts that are added to a group of alerts for which an initial notification has already been sent (usually ~5m or more).

---

##### `groupWait`<sup>Optional</sup> <a name="groupWait" id="cdk-extensions.aps.AlertManagerRouteProps.property.groupWait"></a>

```typescript
public readonly groupWait: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to initially wait to send a notification for a group of alerts.

Allows to wait for an inhibiting alert to arrive or collect more initial
alerts for the same group (usually ~0s to few minutes).

---

##### `matchers`<sup>Optional</sup> <a name="matchers" id="cdk-extensions.aps.AlertManagerRouteProps.property.matchers"></a>

```typescript
public readonly matchers: AlertManagerMatcher[];
```

- *Type:* cdk-extensions.aps.AlertManagerMatcher[]

A list of matchers that an alert has to fulfill to match the node.

---

##### `muteTimeInterval`<sup>Optional</sup> <a name="muteTimeInterval" id="cdk-extensions.aps.AlertManagerRouteProps.property.muteTimeInterval"></a>

```typescript
public readonly muteTimeInterval: TimeInterval[];
```

- *Type:* cdk-extensions.aps.TimeInterval[]

Times when the route should be muted. The root node cannot have any mute times.

When a route is muted it will not send any notifications, but otherwise
acts normally (including ending the route-matching process if the
`continueMatching` option is not set).

---

##### `repeatInterval`<sup>Optional</sup> <a name="repeatInterval" id="cdk-extensions.aps.AlertManagerRouteProps.property.repeatInterval"></a>

```typescript
public readonly repeatInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to wait before sending a notification again if it has already been sent successfully for an alert.

(Usually ~3h or more).

---

### AlertManagerSnsDestinationOptions <a name="AlertManagerSnsDestinationOptions" id="cdk-extensions.aps.AlertManagerSnsDestinationOptions"></a>

Optional configuration for an alert manager SNS destination.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.AlertManagerSnsDestinationOptions.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const alertManagerSnsDestinationOptions: aps.AlertManagerSnsDestinationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.apiUrl">apiUrl</a></code> | <code>string</code> | The SNS API URL i.e. https://sns.us-east-2.amazonaws.com. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.attributes">attributes</a></code> | <code>{[ key: string ]: string}</code> | SNS message attributes. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.message">message</a></code> | <code>string</code> | The message content of the SNS notification. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.sendResolved">sendResolved</a></code> | <code>boolean</code> | Controls whether to notify about resolved alerts. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.subject">subject</a></code> | <code>string</code> | Subject line when the message is delivered to email endpoints. |

---

##### `apiUrl`<sup>Optional</sup> <a name="apiUrl" id="cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.apiUrl"></a>

```typescript
public readonly apiUrl: string;
```

- *Type:* string

The SNS API URL i.e. https://sns.us-east-2.amazonaws.com.

If not specified, the SNS API URL from the SNS SDK will be used.

---

##### `attributes`<sup>Optional</sup> <a name="attributes" id="cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.attributes"></a>

```typescript
public readonly attributes: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

SNS message attributes.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

The message content of the SNS notification.

---

##### `sendResolved`<sup>Optional</sup> <a name="sendResolved" id="cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.sendResolved"></a>

```typescript
public readonly sendResolved: boolean;
```

- *Type:* boolean

Controls whether to notify about resolved alerts.

---

##### `subject`<sup>Optional</sup> <a name="subject" id="cdk-extensions.aps.AlertManagerSnsDestinationOptions.property.subject"></a>

```typescript
public readonly subject: string;
```

- *Type:* string

Subject line when the message is delivered to email endpoints.

---

### AlertManagerSnsDestinationProps <a name="AlertManagerSnsDestinationProps" id="cdk-extensions.aps.AlertManagerSnsDestinationProps"></a>

Configuration for an alert manager SNS destination.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.AlertManagerSnsDestinationProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const alertManagerSnsDestinationProps: aps.AlertManagerSnsDestinationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationProps.property.apiUrl">apiUrl</a></code> | <code>string</code> | The SNS API URL i.e. https://sns.us-east-2.amazonaws.com. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationProps.property.attributes">attributes</a></code> | <code>{[ key: string ]: string}</code> | SNS message attributes. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationProps.property.message">message</a></code> | <code>string</code> | The message content of the SNS notification. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationProps.property.sendResolved">sendResolved</a></code> | <code>boolean</code> | Controls whether to notify about resolved alerts. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationProps.property.subject">subject</a></code> | <code>string</code> | Subject line when the message is delivered to email endpoints. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestinationProps.property.topic">topic</a></code> | <code>aws-cdk-lib.aws_sns.ITopic</code> | SNS topic where alerts will be sent. |

---

##### `apiUrl`<sup>Optional</sup> <a name="apiUrl" id="cdk-extensions.aps.AlertManagerSnsDestinationProps.property.apiUrl"></a>

```typescript
public readonly apiUrl: string;
```

- *Type:* string

The SNS API URL i.e. https://sns.us-east-2.amazonaws.com.

If not specified, the SNS API URL from the SNS SDK will be used.

---

##### `attributes`<sup>Optional</sup> <a name="attributes" id="cdk-extensions.aps.AlertManagerSnsDestinationProps.property.attributes"></a>

```typescript
public readonly attributes: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

SNS message attributes.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk-extensions.aps.AlertManagerSnsDestinationProps.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

The message content of the SNS notification.

---

##### `sendResolved`<sup>Optional</sup> <a name="sendResolved" id="cdk-extensions.aps.AlertManagerSnsDestinationProps.property.sendResolved"></a>

```typescript
public readonly sendResolved: boolean;
```

- *Type:* boolean

Controls whether to notify about resolved alerts.

---

##### `subject`<sup>Optional</sup> <a name="subject" id="cdk-extensions.aps.AlertManagerSnsDestinationProps.property.subject"></a>

```typescript
public readonly subject: string;
```

- *Type:* string

Subject line when the message is delivered to email endpoints.

---

##### `topic`<sup>Required</sup> <a name="topic" id="cdk-extensions.aps.AlertManagerSnsDestinationProps.property.topic"></a>

```typescript
public readonly topic: ITopic;
```

- *Type:* aws-cdk-lib.aws_sns.ITopic

SNS topic where alerts will be sent.

If you are using a FIFO SNS topic you should set a message group interval
longer than 5 minutes to prevent messages with the same group key being
deduplicated by the SNS default deduplication window.

---

### AllocateCidrFromPoolOptions <a name="AllocateCidrFromPoolOptions" id="cdk-extensions.ec2.AllocateCidrFromPoolOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.AllocateCidrFromPoolOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const allocateCidrFromPoolOptions: ec2.AllocateCidrFromPoolOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.AllocateCidrFromPoolOptions.property.allocation">allocation</a></code> | <code>cdk-extensions.ec2.IIpamAllocationConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AllocateCidrFromPoolOptions.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AllocateCidrFromPoolOptions.property.scope">scope</a></code> | <code>constructs.IConstruct</code> | *No description.* |

---

##### `allocation`<sup>Optional</sup> <a name="allocation" id="cdk-extensions.ec2.AllocateCidrFromPoolOptions.property.allocation"></a>

```typescript
public readonly allocation: IIpamAllocationConfiguration;
```

- *Type:* cdk-extensions.ec2.IIpamAllocationConfiguration

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.AllocateCidrFromPoolOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk-extensions.ec2.AllocateCidrFromPoolOptions.property.scope"></a>

```typescript
public readonly scope: IConstruct;
```

- *Type:* constructs.IConstruct

---

### AllocatePrivateNetworkOptions <a name="AllocatePrivateNetworkOptions" id="cdk-extensions.ec2_patterns.AllocatePrivateNetworkOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.AllocatePrivateNetworkOptions.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const allocatePrivateNetworkOptions: ec2_patterns.AllocatePrivateNetworkOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.AllocatePrivateNetworkOptions.property.netmask">netmask</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.AllocatePrivateNetworkOptions.property.pool">pool</a></code> | <code>string</code> | *No description.* |

---

##### `netmask`<sup>Optional</sup> <a name="netmask" id="cdk-extensions.ec2_patterns.AllocatePrivateNetworkOptions.property.netmask"></a>

```typescript
public readonly netmask: number;
```

- *Type:* number

---

##### `pool`<sup>Optional</sup> <a name="pool" id="cdk-extensions.ec2_patterns.AllocatePrivateNetworkOptions.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* string

---

### AppendDelimiterProcessorOptions <a name="AppendDelimiterProcessorOptions" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessorOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessorOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const appendDelimiterProcessorOptions: kinesis_firehose.AppendDelimiterProcessorOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.AppendDelimiterProcessorOptions.property.delimiter">delimiter</a></code> | <code>string</code> | *No description.* |

---

##### `delimiter`<sup>Required</sup> <a name="delimiter" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessorOptions.property.delimiter"></a>

```typescript
public readonly delimiter: string;
```

- *Type:* string

---

### AppendedRecord <a name="AppendedRecord" id="cdk-extensions.k8s_aws.AppendedRecord"></a>

Represents a record field to be added by the record modifier Fluent Bit filter plugin.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.AppendedRecord.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const appendedRecord: k8s_aws.AppendedRecord = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AppendedRecord.property.fieldName">fieldName</a></code> | <code>string</code> | The name of the field to be added. |
| <code><a href="#cdk-extensions.k8s_aws.AppendedRecord.property.value">value</a></code> | <code>string</code> | The value that the added field should be set to. |

---

##### `fieldName`<sup>Required</sup> <a name="fieldName" id="cdk-extensions.k8s_aws.AppendedRecord.property.fieldName"></a>

```typescript
public readonly fieldName: string;
```

- *Type:* string

The name of the field to be added.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.AppendedRecord.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

The value that the added field should be set to.

---

### ArrayColumnProps <a name="ArrayColumnProps" id="cdk-extensions.glue.ArrayColumnProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.glue.ArrayColumnProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const arrayColumnProps: glue.ArrayColumnProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ArrayColumnProps.property.comment">comment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ArrayColumnProps.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ArrayColumnProps.property.data">data</a></code> | <code>cdk-extensions.glue.Column</code> | *No description.* |

---

##### `comment`<sup>Optional</sup> <a name="comment" id="cdk-extensions.glue.ArrayColumnProps.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.ArrayColumnProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `data`<sup>Required</sup> <a name="data" id="cdk-extensions.glue.ArrayColumnProps.property.data"></a>

```typescript
public readonly data: Column;
```

- *Type:* cdk-extensions.glue.Column

---

### AssignmentProps <a name="AssignmentProps" id="cdk-extensions.sso.AssignmentProps"></a>

Configuration for Assignment resource.

#### Initializer <a name="Initializer" id="cdk-extensions.sso.AssignmentProps.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

const assignmentProps: sso.AssignmentProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.AssignmentProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.sso.AssignmentProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.sso.AssignmentProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.sso.AssignmentProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.sso.AssignmentProps.property.instance">instance</a></code> | <code>cdk-extensions.sso.IInstance</code> | The IAM Identity Center {@link aws-sso.IInstance \| instance } under which the operation will be executed. |
| <code><a href="#cdk-extensions.sso.AssignmentProps.property.permissionSet">permissionSet</a></code> | <code>cdk-extensions.sso.IPermissionSet</code> | The permission set which governs the access being assigned. |
| <code><a href="#cdk-extensions.sso.AssignmentProps.property.principal">principal</a></code> | <code>cdk-extensions.sso.IIdentityCenterPrincipal</code> | The IAM Identity Center principal you wish to grant permissions to. |
| <code><a href="#cdk-extensions.sso.AssignmentProps.property.target">target</a></code> | <code>cdk-extensions.sso.AssignmentTarget</code> | The resource you wish to grant the {@link principal} entity access to using the permissions defined in the {@link permissionSet}. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.sso.AssignmentProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.sso.AssignmentProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.sso.AssignmentProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.sso.AssignmentProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk-extensions.sso.AssignmentProps.property.instance"></a>

```typescript
public readonly instance: IInstance;
```

- *Type:* cdk-extensions.sso.IInstance

The IAM Identity Center {@link aws-sso.IInstance | instance } under which the operation will be executed.

---

##### `permissionSet`<sup>Required</sup> <a name="permissionSet" id="cdk-extensions.sso.AssignmentProps.property.permissionSet"></a>

```typescript
public readonly permissionSet: IPermissionSet;
```

- *Type:* cdk-extensions.sso.IPermissionSet

The permission set which governs the access being assigned.

The
permission set grants the {@link principal} permissions on
{@link target}.

---

##### `principal`<sup>Required</sup> <a name="principal" id="cdk-extensions.sso.AssignmentProps.property.principal"></a>

```typescript
public readonly principal: IIdentityCenterPrincipal;
```

- *Type:* cdk-extensions.sso.IIdentityCenterPrincipal

The IAM Identity Center principal you wish to grant permissions to.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk-extensions.sso.AssignmentProps.property.target"></a>

```typescript
public readonly target: AssignmentTarget;
```

- *Type:* cdk-extensions.sso.AssignmentTarget

The resource you wish to grant the {@link principal} entity access to using the permissions defined in the {@link permissionSet}.

For example,
an AWS account.

---

### AwsIntegratedFargateClusterProps <a name="AwsIntegratedFargateClusterProps" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.Initializer"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

const awsIntegratedFargateClusterProps: eks_patterns.AwsIntegratedFargateClusterProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.version">version</a></code> | <code>aws-cdk-lib.aws_eks.KubernetesVersion</code> | The Kubernetes version to run in the cluster. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.clusterName">clusterName</a></code> | <code>string</code> | Name for the cluster. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.outputClusterName">outputClusterName</a></code> | <code>boolean</code> | Determines whether a CloudFormation output with the name of the cluster will be synthesized. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.outputConfigCommand">outputConfigCommand</a></code> | <code>boolean</code> | Determines whether a CloudFormation output with the `aws eks update-kubeconfig` command will be synthesized. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | Role that provides permissions for the Kubernetes control plane to make calls to AWS API operations on your behalf. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.securityGroup">securityGroup</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup</code> | Security Group to use for Control Plane ENIs. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | The VPC in which to create the Cluster. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.vpcSubnets">vpcSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection[]</code> | Where to place EKS Control Plane ENIs. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.albController">albController</a></code> | <code>aws-cdk-lib.aws_eks.AlbControllerOptions</code> | Install the AWS Load Balancer Controller onto the cluster. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.awscliLayer">awscliLayer</a></code> | <code>aws-cdk-lib.aws_lambda.ILayerVersion</code> | An AWS Lambda layer that contains the `aws` CLI. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.clusterHandlerEnvironment">clusterHandlerEnvironment</a></code> | <code>{[ key: string ]: string}</code> | Custom environment variables when interacting with the EKS endpoint to manage the cluster lifecycle. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.clusterHandlerSecurityGroup">clusterHandlerSecurityGroup</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup</code> | A security group to associate with the Cluster Handler's Lambdas. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.clusterLogging">clusterLogging</a></code> | <code>aws-cdk-lib.aws_eks.ClusterLoggingTypes[]</code> | The cluster log types which you want to enable. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.coreDnsComputeType">coreDnsComputeType</a></code> | <code>aws-cdk-lib.aws_eks.CoreDnsComputeType</code> | Controls the "eks.amazonaws.com/compute-type" annotation in the CoreDNS configuration on your cluster to determine which compute type to use for CoreDNS. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.endpointAccess">endpointAccess</a></code> | <code>aws-cdk-lib.aws_eks.EndpointAccess</code> | Configure access to the Kubernetes API server endpoint.. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.kubectlEnvironment">kubectlEnvironment</a></code> | <code>{[ key: string ]: string}</code> | Environment variables for the kubectl execution. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.kubectlLayer">kubectlLayer</a></code> | <code>aws-cdk-lib.aws_lambda.ILayerVersion</code> | An AWS Lambda Layer which includes `kubectl` and Helm. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.kubectlMemory">kubectlMemory</a></code> | <code>aws-cdk-lib.Size</code> | Amount of memory to allocate to the provider's lambda function. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.mastersRole">mastersRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | An IAM role that will be added to the `system:masters` Kubernetes RBAC group. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.onEventLayer">onEventLayer</a></code> | <code>aws-cdk-lib.aws_lambda.ILayerVersion</code> | An AWS Lambda Layer which includes the NPM dependency `proxy-agent`. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.outputMastersRoleArn">outputMastersRoleArn</a></code> | <code>boolean</code> | Determines whether a CloudFormation output with the ARN of the "masters" IAM role will be synthesized (if `mastersRole` is specified). |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.placeClusterHandlerInVpc">placeClusterHandlerInVpc</a></code> | <code>boolean</code> | If set to true, the cluster handler functions will be placed in the private subnets of the cluster vpc, subject to the `vpcSubnets` selection strategy. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.prune">prune</a></code> | <code>boolean</code> | Indicates whether Kubernetes resources added through `addManifest()` can be automatically pruned. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.secretsEncryptionKey">secretsEncryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | KMS secret for envelope encryption for Kubernetes secrets. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.serviceIpv4Cidr">serviceIpv4Cidr</a></code> | <code>string</code> | The CIDR block to assign Kubernetes service IP addresses from. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.defaultProfile">defaultProfile</a></code> | <code>aws-cdk-lib.aws_eks.FargateProfileOptions</code> | Fargate Profile to create along with the cluster. |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.containerInsightsOptions">containerInsightsOptions</a></code> | <code>cdk-extensions.eks_patterns.ContainerInsightsOptions</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.externalDnsOptions">externalDnsOptions</a></code> | <code>cdk-extensions.eks_patterns.ClusterRoute53DnsOptions</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.externalSecretsOptions">externalSecretsOptions</a></code> | <code>cdk-extensions.eks_patterns.ExternalSecretsOptions</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.loggingOptions">loggingOptions</a></code> | <code>cdk-extensions.eks_patterns.ClusterFargateLoggingOptions</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.prometheusOptions">prometheusOptions</a></code> | <code>cdk-extensions.eks_patterns.ClusterPrometheusOptions</code> | *No description.* |

---

##### `version`<sup>Required</sup> <a name="version" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.version"></a>

```typescript
public readonly version: KubernetesVersion;
```

- *Type:* aws-cdk-lib.aws_eks.KubernetesVersion

The Kubernetes version to run in the cluster.

---

##### `clusterName`<sup>Optional</sup> <a name="clusterName" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.clusterName"></a>

```typescript
public readonly clusterName: string;
```

- *Type:* string
- *Default:* Automatically generated name

Name for the cluster.

---

##### `outputClusterName`<sup>Optional</sup> <a name="outputClusterName" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.outputClusterName"></a>

```typescript
public readonly outputClusterName: boolean;
```

- *Type:* boolean
- *Default:* false

Determines whether a CloudFormation output with the name of the cluster will be synthesized.

---

##### `outputConfigCommand`<sup>Optional</sup> <a name="outputConfigCommand" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.outputConfigCommand"></a>

```typescript
public readonly outputConfigCommand: boolean;
```

- *Type:* boolean
- *Default:* true

Determines whether a CloudFormation output with the `aws eks update-kubeconfig` command will be synthesized.

This command will include
the cluster name and, if applicable, the ARN of the masters IAM role.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole
- *Default:* A role is automatically created for you

Role that provides permissions for the Kubernetes control plane to make calls to AWS API operations on your behalf.

---

##### `securityGroup`<sup>Optional</sup> <a name="securityGroup" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.securityGroup"></a>

```typescript
public readonly securityGroup: ISecurityGroup;
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup
- *Default:* A security group is automatically created

Security Group to use for Control Plane ENIs.

---

##### `vpc`<sup>Optional</sup> <a name="vpc" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc
- *Default:* a VPC with default configuration will be created and can be accessed through `cluster.vpc`.

The VPC in which to create the Cluster.

---

##### `vpcSubnets`<sup>Optional</sup> <a name="vpcSubnets" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.vpcSubnets"></a>

```typescript
public readonly vpcSubnets: SubnetSelection[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection[]
- *Default:* All public and private subnets

Where to place EKS Control Plane ENIs.

If you want to create public load balancers, this must include public subnets.

For example, to only select private subnets, supply the following:

`vpcSubnets: [{ subnetType: ec2.SubnetType.PRIVATE_WITH_EGRESS }]`

---

##### `albController`<sup>Optional</sup> <a name="albController" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.albController"></a>

```typescript
public readonly albController: AlbControllerOptions;
```

- *Type:* aws-cdk-lib.aws_eks.AlbControllerOptions
- *Default:* The controller is not installed.

Install the AWS Load Balancer Controller onto the cluster.

> [https://kubernetes-sigs.github.io/aws-load-balancer-controller](https://kubernetes-sigs.github.io/aws-load-balancer-controller)

---

##### `awscliLayer`<sup>Optional</sup> <a name="awscliLayer" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.awscliLayer"></a>

```typescript
public readonly awscliLayer: ILayerVersion;
```

- *Type:* aws-cdk-lib.aws_lambda.ILayerVersion
- *Default:* a default layer with the AWS CLI 1.x

An AWS Lambda layer that contains the `aws` CLI.

The handler expects the layer to include the following executables:

```
/opt/awscli/aws
```

---

##### `clusterHandlerEnvironment`<sup>Optional</sup> <a name="clusterHandlerEnvironment" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.clusterHandlerEnvironment"></a>

```typescript
public readonly clusterHandlerEnvironment: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}
- *Default:* No environment variables.

Custom environment variables when interacting with the EKS endpoint to manage the cluster lifecycle.

---

##### `clusterHandlerSecurityGroup`<sup>Optional</sup> <a name="clusterHandlerSecurityGroup" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.clusterHandlerSecurityGroup"></a>

```typescript
public readonly clusterHandlerSecurityGroup: ISecurityGroup;
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup
- *Default:* No security group.

A security group to associate with the Cluster Handler's Lambdas.

The Cluster Handler's Lambdas are responsible for calling AWS's EKS API.

Requires `placeClusterHandlerInVpc` to be set to true.

---

##### `clusterLogging`<sup>Optional</sup> <a name="clusterLogging" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.clusterLogging"></a>

```typescript
public readonly clusterLogging: ClusterLoggingTypes[];
```

- *Type:* aws-cdk-lib.aws_eks.ClusterLoggingTypes[]
- *Default:* none

The cluster log types which you want to enable.

---

##### `coreDnsComputeType`<sup>Optional</sup> <a name="coreDnsComputeType" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.coreDnsComputeType"></a>

```typescript
public readonly coreDnsComputeType: CoreDnsComputeType;
```

- *Type:* aws-cdk-lib.aws_eks.CoreDnsComputeType
- *Default:* CoreDnsComputeType.EC2 (for `FargateCluster` the default is FARGATE)

Controls the "eks.amazonaws.com/compute-type" annotation in the CoreDNS configuration on your cluster to determine which compute type to use for CoreDNS.

---

##### `endpointAccess`<sup>Optional</sup> <a name="endpointAccess" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.endpointAccess"></a>

```typescript
public readonly endpointAccess: EndpointAccess;
```

- *Type:* aws-cdk-lib.aws_eks.EndpointAccess
- *Default:* EndpointAccess.PUBLIC_AND_PRIVATE

Configure access to the Kubernetes API server endpoint..

> [https://docs.aws.amazon.com/eks/latest/userguide/cluster-endpoint.html](https://docs.aws.amazon.com/eks/latest/userguide/cluster-endpoint.html)

---

##### `kubectlEnvironment`<sup>Optional</sup> <a name="kubectlEnvironment" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.kubectlEnvironment"></a>

```typescript
public readonly kubectlEnvironment: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}
- *Default:* No environment variables.

Environment variables for the kubectl execution.

Only relevant for kubectl enabled clusters.

---

##### `kubectlLayer`<sup>Optional</sup> <a name="kubectlLayer" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.kubectlLayer"></a>

```typescript
public readonly kubectlLayer: ILayerVersion;
```

- *Type:* aws-cdk-lib.aws_lambda.ILayerVersion
- *Default:* a default layer with Kubectl 1.20.

An AWS Lambda Layer which includes `kubectl` and Helm.

This layer is used by the kubectl handler to apply manifests and install
helm charts. You must pick an appropriate releases of one of the
`@aws-cdk/layer-kubectl-vXX` packages, that works with the version of
Kubernetes you have chosen. If you don't supply this value `kubectl`
1.20 will be used, but that version is most likely too old.

The handler expects the layer to include the following executables:

```
/opt/helm/helm
/opt/kubectl/kubectl
```

---

##### `kubectlMemory`<sup>Optional</sup> <a name="kubectlMemory" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.kubectlMemory"></a>

```typescript
public readonly kubectlMemory: Size;
```

- *Type:* aws-cdk-lib.Size
- *Default:* Size.gibibytes(1)

Amount of memory to allocate to the provider's lambda function.

---

##### `mastersRole`<sup>Optional</sup> <a name="mastersRole" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.mastersRole"></a>

```typescript
public readonly mastersRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole
- *Default:* a role that assumable by anyone with permissions in the same account will automatically be defined

An IAM role that will be added to the `system:masters` Kubernetes RBAC group.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#default-roles-and-role-bindings](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#default-roles-and-role-bindings)

---

##### `onEventLayer`<sup>Optional</sup> <a name="onEventLayer" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.onEventLayer"></a>

```typescript
public readonly onEventLayer: ILayerVersion;
```

- *Type:* aws-cdk-lib.aws_lambda.ILayerVersion
- *Default:* a layer bundled with this module.

An AWS Lambda Layer which includes the NPM dependency `proxy-agent`.

This layer
is used by the onEvent handler to route AWS SDK requests through a proxy.

By default, the provider will use the layer included in the
"aws-lambda-layer-node-proxy-agent" SAR application which is available in all
commercial regions.

To deploy the layer locally define it in your app as follows:

```ts
const layer = new lambda.LayerVersion(this, 'proxy-agent-layer', {
  code: lambda.Code.fromAsset(`${__dirname}/layer.zip`),
  compatibleRuntimes: [lambda.Runtime.NODEJS_14_X],
});
```

---

##### `outputMastersRoleArn`<sup>Optional</sup> <a name="outputMastersRoleArn" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.outputMastersRoleArn"></a>

```typescript
public readonly outputMastersRoleArn: boolean;
```

- *Type:* boolean
- *Default:* false

Determines whether a CloudFormation output with the ARN of the "masters" IAM role will be synthesized (if `mastersRole` is specified).

---

##### `placeClusterHandlerInVpc`<sup>Optional</sup> <a name="placeClusterHandlerInVpc" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.placeClusterHandlerInVpc"></a>

```typescript
public readonly placeClusterHandlerInVpc: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, the cluster handler functions will be placed in the private subnets of the cluster vpc, subject to the `vpcSubnets` selection strategy.

---

##### `prune`<sup>Optional</sup> <a name="prune" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.prune"></a>

```typescript
public readonly prune: boolean;
```

- *Type:* boolean
- *Default:* true

Indicates whether Kubernetes resources added through `addManifest()` can be automatically pruned.

When this is enabled (default), prune labels will be
allocated and injected to each resource. These labels will then be used
when issuing the `kubectl apply` operation with the `--prune` switch.

---

##### `secretsEncryptionKey`<sup>Optional</sup> <a name="secretsEncryptionKey" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.secretsEncryptionKey"></a>

```typescript
public readonly secretsEncryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey
- *Default:* By default, Kubernetes stores all secret object data within etcd and   all etcd volumes used by Amazon EKS are encrypted at the disk-level   using AWS-Managed encryption keys.

KMS secret for envelope encryption for Kubernetes secrets.

---

##### `serviceIpv4Cidr`<sup>Optional</sup> <a name="serviceIpv4Cidr" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.serviceIpv4Cidr"></a>

```typescript
public readonly serviceIpv4Cidr: string;
```

- *Type:* string
- *Default:* Kubernetes assigns addresses from either the   10.100.0.0/16 or 172.20.0.0/16 CIDR blocks

The CIDR block to assign Kubernetes service IP addresses from.

> [https://docs.aws.amazon.com/eks/latest/APIReference/API_KubernetesNetworkConfigRequest.html#AmazonEKS-Type-KubernetesNetworkConfigRequest-serviceIpv4Cidr](https://docs.aws.amazon.com/eks/latest/APIReference/API_KubernetesNetworkConfigRequest.html#AmazonEKS-Type-KubernetesNetworkConfigRequest-serviceIpv4Cidr)

---

##### `defaultProfile`<sup>Optional</sup> <a name="defaultProfile" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.defaultProfile"></a>

```typescript
public readonly defaultProfile: FargateProfileOptions;
```

- *Type:* aws-cdk-lib.aws_eks.FargateProfileOptions
- *Default:* A profile called "default" with 'default' and 'kube-system'   selectors will be created if this is left undefined.

Fargate Profile to create along with the cluster.

---

##### `containerInsightsOptions`<sup>Optional</sup> <a name="containerInsightsOptions" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.containerInsightsOptions"></a>

```typescript
public readonly containerInsightsOptions: ContainerInsightsOptions;
```

- *Type:* cdk-extensions.eks_patterns.ContainerInsightsOptions

---

##### `externalDnsOptions`<sup>Optional</sup> <a name="externalDnsOptions" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.externalDnsOptions"></a>

```typescript
public readonly externalDnsOptions: ClusterRoute53DnsOptions;
```

- *Type:* cdk-extensions.eks_patterns.ClusterRoute53DnsOptions

---

##### `externalSecretsOptions`<sup>Optional</sup> <a name="externalSecretsOptions" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.externalSecretsOptions"></a>

```typescript
public readonly externalSecretsOptions: ExternalSecretsOptions;
```

- *Type:* cdk-extensions.eks_patterns.ExternalSecretsOptions

---

##### `loggingOptions`<sup>Optional</sup> <a name="loggingOptions" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.loggingOptions"></a>

```typescript
public readonly loggingOptions: ClusterFargateLoggingOptions;
```

- *Type:* cdk-extensions.eks_patterns.ClusterFargateLoggingOptions

---

##### `prometheusOptions`<sup>Optional</sup> <a name="prometheusOptions" id="cdk-extensions.eks_patterns.AwsIntegratedFargateClusterProps.property.prometheusOptions"></a>

```typescript
public readonly prometheusOptions: ClusterPrometheusOptions;
```

- *Type:* cdk-extensions.eks_patterns.ClusterPrometheusOptions

---

### AwsLoggingStackProps <a name="AwsLoggingStackProps" id="cdk-extensions.stacks.AwsLoggingStackProps"></a>

Configuration for AwsLoggingStack.

#### Initializer <a name="Initializer" id="cdk-extensions.stacks.AwsLoggingStackProps.Initializer"></a>

```typescript
import { stacks } from 'cdk-extensions'

const awsLoggingStackProps: stacks.AwsLoggingStackProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.analyticsReporting">analyticsReporting</a></code> | <code>boolean</code> | Include runtime versioning information in this Stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.crossRegionReferences">crossRegionReferences</a></code> | <code>boolean</code> | Enable this flag to allow native cross region stack references. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.description">description</a></code> | <code>string</code> | A description of the stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.env">env</a></code> | <code>aws-cdk-lib.Environment</code> | The AWS environment (account/region) where this stack will be deployed. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.permissionsBoundary">permissionsBoundary</a></code> | <code>aws-cdk-lib.PermissionsBoundary</code> | Options for applying a permissions boundary to all IAM Roles and Users created within this Stage. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.stackName">stackName</a></code> | <code>string</code> | Name to deploy the stack with. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.synthesizer">synthesizer</a></code> | <code>aws-cdk-lib.IStackSynthesizer</code> | Synthesis method to use while deploying this stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.tags">tags</a></code> | <code>{[ key: string ]: string}</code> | Stack tags that will be applied to all the taggable resources and the stack itself. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.terminationProtection">terminationProtection</a></code> | <code>boolean</code> | Whether to enable termination protection for this stack. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.albLogsBucket">albLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.AlbLogsBucket</code> | A cdk-extensions/s3-buckets {@link aws-s3-buckets!AlbLogsBucket} object. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.cloudfrontLogsBucket">cloudfrontLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.CloudfrontLogsBucket</code> | A cdk-extensions/s3-buckets {@link aws-s3-buckets!CloudfrontLogsBucket} object. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.cloudtrailLogsBucket">cloudtrailLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.CloudtrailBucket</code> | A cdk-extensions/s3-buckets {@link aws-s3-buckets!CloudtrailBucket} object. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.databaseName">databaseName</a></code> | <code>string</code> | Name used for the Glue Database that will be created. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.flowLogsBucket">flowLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.FlowLogsBucket</code> | A cdk-extensions/s3-buckets {@link aws-s3-buckets!FlowLogsBucket} object. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.flowLogsFormat">flowLogsFormat</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | A cdk-extentions/ec2 {@link aws-ec2!FlowLogFormat } object defining the desired formatting for Flow Logs. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.sesLogsBucket">sesLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.SesLogsBucket</code> | A cdk-extensions/s3-buckets {@link aws-s3-buckets!SesLogsBucket} object. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.standardizeNames">standardizeNames</a></code> | <code>boolean</code> | Boolean for using "standardized" naming (i.e. "aws-${service}-logs-${account} -${region}") for the created S3 Buckets. |
| <code><a href="#cdk-extensions.stacks.AwsLoggingStackProps.property.wafLogsBucket">wafLogsBucket</a></code> | <code>cdk-extensions.s3_buckets.WafLogsBucket</code> | A cdk-extensions/s3-buckets {@link aws-s3-buckets!WafLogsBucket} object. |

---

##### `analyticsReporting`<sup>Optional</sup> <a name="analyticsReporting" id="cdk-extensions.stacks.AwsLoggingStackProps.property.analyticsReporting"></a>

```typescript
public readonly analyticsReporting: boolean;
```

- *Type:* boolean
- *Default:* `analyticsReporting` setting of containing `App`, or value of 'aws:cdk:version-reporting' context key

Include runtime versioning information in this Stack.

---

##### `crossRegionReferences`<sup>Optional</sup> <a name="crossRegionReferences" id="cdk-extensions.stacks.AwsLoggingStackProps.property.crossRegionReferences"></a>

```typescript
public readonly crossRegionReferences: boolean;
```

- *Type:* boolean
- *Default:* false

Enable this flag to allow native cross region stack references.

Enabling this will create a CloudFormation custom resource
in both the producing stack and consuming stack in order to perform the export/import

This feature is currently experimental

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.stacks.AwsLoggingStackProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string
- *Default:* No description.

A description of the stack.

---

##### `env`<sup>Optional</sup> <a name="env" id="cdk-extensions.stacks.AwsLoggingStackProps.property.env"></a>

```typescript
public readonly env: Environment;
```

- *Type:* aws-cdk-lib.Environment
- *Default:* The environment of the containing `Stage` if available, otherwise create the stack will be environment-agnostic.

The AWS environment (account/region) where this stack will be deployed.

Set the `region`/`account` fields of `env` to either a concrete value to
select the indicated environment (recommended for production stacks), or to
the values of environment variables
`CDK_DEFAULT_REGION`/`CDK_DEFAULT_ACCOUNT` to let the target environment
depend on the AWS credentials/configuration that the CDK CLI is executed
under (recommended for development stacks).

If the `Stack` is instantiated inside a `Stage`, any undefined
`region`/`account` fields from `env` will default to the same field on the
encompassing `Stage`, if configured there.

If either `region` or `account` are not set nor inherited from `Stage`, the
Stack will be considered "*environment-agnostic*"". Environment-agnostic
stacks can be deployed to any environment but may not be able to take
advantage of all features of the CDK. For example, they will not be able to
use environmental context lookups such as `ec2.Vpc.fromLookup` and will not
automatically translate Service Principals to the right format based on the
environment's AWS partition, and other such enhancements.

---

*Example*

```typescript
// Use a concrete account and region to deploy this stack to:
// `.account` and `.region` will simply return these values.
new Stack(app, 'Stack1', {
  env: {
    account: '123456789012',
    region: 'us-east-1'
  },
});

// Use the CLI's current credentials to determine the target environment:
// `.account` and `.region` will reflect the account+region the CLI
// is configured to use (based on the user CLI credentials)
new Stack(app, 'Stack2', {
  env: {
    account: process.env.CDK_DEFAULT_ACCOUNT,
    region: process.env.CDK_DEFAULT_REGION
  },
});

// Define multiple stacks stage associated with an environment
const myStage = new Stage(app, 'MyStage', {
  env: {
    account: '123456789012',
    region: 'us-east-1'
  }
});

// both of these stacks will use the stage's account/region:
// `.account` and `.region` will resolve to the concrete values as above
new MyStack(myStage, 'Stack1');
new YourStack(myStage, 'Stack2');

// Define an environment-agnostic stack:
// `.account` and `.region` will resolve to `{ "Ref": "AWS::AccountId" }` and `{ "Ref": "AWS::Region" }` respectively.
// which will only resolve to actual values by CloudFormation during deployment.
new MyStack(app, 'Stack1');
```


##### `permissionsBoundary`<sup>Optional</sup> <a name="permissionsBoundary" id="cdk-extensions.stacks.AwsLoggingStackProps.property.permissionsBoundary"></a>

```typescript
public readonly permissionsBoundary: PermissionsBoundary;
```

- *Type:* aws-cdk-lib.PermissionsBoundary
- *Default:* no permissions boundary is applied

Options for applying a permissions boundary to all IAM Roles and Users created within this Stage.

---

##### `stackName`<sup>Optional</sup> <a name="stackName" id="cdk-extensions.stacks.AwsLoggingStackProps.property.stackName"></a>

```typescript
public readonly stackName: string;
```

- *Type:* string
- *Default:* Derived from construct path.

Name to deploy the stack with.

---

##### `synthesizer`<sup>Optional</sup> <a name="synthesizer" id="cdk-extensions.stacks.AwsLoggingStackProps.property.synthesizer"></a>

```typescript
public readonly synthesizer: IStackSynthesizer;
```

- *Type:* aws-cdk-lib.IStackSynthesizer
- *Default:* The synthesizer specified on `App`, or `DefaultStackSynthesizer` otherwise.

Synthesis method to use while deploying this stack.

The Stack Synthesizer controls aspects of synthesis and deployment,
like how assets are referenced and what IAM roles to use. For more
information, see the README of the main CDK package.

If not specified, the `defaultStackSynthesizer` from `App` will be used.
If that is not specified, `DefaultStackSynthesizer` is used if
`@aws-cdk/core:newStyleStackSynthesis` is set to `true` or the CDK major
version is v2. In CDK v1 `LegacyStackSynthesizer` is the default if no
other synthesizer is specified.

---

##### `tags`<sup>Optional</sup> <a name="tags" id="cdk-extensions.stacks.AwsLoggingStackProps.property.tags"></a>

```typescript
public readonly tags: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}
- *Default:* {}

Stack tags that will be applied to all the taggable resources and the stack itself.

---

##### `terminationProtection`<sup>Optional</sup> <a name="terminationProtection" id="cdk-extensions.stacks.AwsLoggingStackProps.property.terminationProtection"></a>

```typescript
public readonly terminationProtection: boolean;
```

- *Type:* boolean
- *Default:* false

Whether to enable termination protection for this stack.

---

##### `albLogsBucket`<sup>Optional</sup> <a name="albLogsBucket" id="cdk-extensions.stacks.AwsLoggingStackProps.property.albLogsBucket"></a>

```typescript
public readonly albLogsBucket: AlbLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.AlbLogsBucket

A cdk-extensions/s3-buckets {@link aws-s3-buckets!AlbLogsBucket} object.

---

##### `cloudfrontLogsBucket`<sup>Optional</sup> <a name="cloudfrontLogsBucket" id="cdk-extensions.stacks.AwsLoggingStackProps.property.cloudfrontLogsBucket"></a>

```typescript
public readonly cloudfrontLogsBucket: CloudfrontLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.CloudfrontLogsBucket

A cdk-extensions/s3-buckets {@link aws-s3-buckets!CloudfrontLogsBucket} object.

---

##### `cloudtrailLogsBucket`<sup>Optional</sup> <a name="cloudtrailLogsBucket" id="cdk-extensions.stacks.AwsLoggingStackProps.property.cloudtrailLogsBucket"></a>

```typescript
public readonly cloudtrailLogsBucket: CloudtrailBucket;
```

- *Type:* cdk-extensions.s3_buckets.CloudtrailBucket

A cdk-extensions/s3-buckets {@link aws-s3-buckets!CloudtrailBucket} object.

---

##### `databaseName`<sup>Optional</sup> <a name="databaseName" id="cdk-extensions.stacks.AwsLoggingStackProps.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

Name used for the Glue Database that will be created.

---

##### `flowLogsBucket`<sup>Optional</sup> <a name="flowLogsBucket" id="cdk-extensions.stacks.AwsLoggingStackProps.property.flowLogsBucket"></a>

```typescript
public readonly flowLogsBucket: FlowLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.FlowLogsBucket

A cdk-extensions/s3-buckets {@link aws-s3-buckets!FlowLogsBucket} object.

---

##### `flowLogsFormat`<sup>Optional</sup> <a name="flowLogsFormat" id="cdk-extensions.stacks.AwsLoggingStackProps.property.flowLogsFormat"></a>

```typescript
public readonly flowLogsFormat: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

A cdk-extentions/ec2 {@link aws-ec2!FlowLogFormat } object defining the desired formatting for Flow Logs.

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.stacks.AwsLoggingStackProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `sesLogsBucket`<sup>Optional</sup> <a name="sesLogsBucket" id="cdk-extensions.stacks.AwsLoggingStackProps.property.sesLogsBucket"></a>

```typescript
public readonly sesLogsBucket: SesLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.SesLogsBucket

A cdk-extensions/s3-buckets {@link aws-s3-buckets!SesLogsBucket} object.

---

##### `standardizeNames`<sup>Optional</sup> <a name="standardizeNames" id="cdk-extensions.stacks.AwsLoggingStackProps.property.standardizeNames"></a>

```typescript
public readonly standardizeNames: boolean;
```

- *Type:* boolean

Boolean for using "standardized" naming (i.e. "aws-${service}-logs-${account} -${region}") for the created S3 Buckets.

---

##### `wafLogsBucket`<sup>Optional</sup> <a name="wafLogsBucket" id="cdk-extensions.stacks.AwsLoggingStackProps.property.wafLogsBucket"></a>

```typescript
public readonly wafLogsBucket: WafLogsBucket;
```

- *Type:* cdk-extensions.s3_buckets.WafLogsBucket

A cdk-extensions/s3-buckets {@link aws-s3-buckets!WafLogsBucket} object.

---

### AwsSecretStoreProps <a name="AwsSecretStoreProps" id="cdk-extensions.k8s_aws.AwsSecretStoreProps"></a>

Configuration options for adding a new secret store resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const awsSecretStoreProps: k8s_aws.AwsSecretStoreProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStoreProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStoreProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStoreProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStoreProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStoreProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStoreProps.property.service">service</a></code> | <code>string</code> | The name of the service provider backing the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStoreProps.property.name">name</a></code> | <code>string</code> | A human friendly name for the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.AwsSecretStoreProps.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the secret store should be created. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the secret store should be created.

---

##### `service`<sup>Required</sup> <a name="service" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

The name of the service provider backing the secret store.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A human friendly name for the secret store.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.AwsSecretStoreProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the secret store should be created.

---

### BackupConfigurationOptions <a name="BackupConfigurationOptions" id="cdk-extensions.kinesis_firehose.BackupConfigurationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.BackupConfigurationOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const backupConfigurationOptions: kinesis_firehose.BackupConfigurationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BackupConfigurationOptions.property.destination">destination</a></code> | <code>cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.BackupConfigurationOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |

---

##### `destination`<sup>Required</sup> <a name="destination" id="cdk-extensions.kinesis_firehose.BackupConfigurationOptions.property.destination"></a>

```typescript
public readonly destination: IDeliveryStreamBackupDestination;
```

- *Type:* cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.BackupConfigurationOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

### BackupConfigurationResult <a name="BackupConfigurationResult" id="cdk-extensions.kinesis_firehose.BackupConfigurationResult"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.BackupConfigurationResult.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const backupConfigurationResult: kinesis_firehose.BackupConfigurationResult = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BackupConfigurationResult.property.s3BackupConfiguration">s3BackupConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.S3DestinationConfigurationProperty</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.BackupConfigurationResult.property.s3BackupMode">s3BackupMode</a></code> | <code>string</code> | *No description.* |

---

##### `s3BackupConfiguration`<sup>Required</sup> <a name="s3BackupConfiguration" id="cdk-extensions.kinesis_firehose.BackupConfigurationResult.property.s3BackupConfiguration"></a>

```typescript
public readonly s3BackupConfiguration: S3DestinationConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.S3DestinationConfigurationProperty

---

##### `s3BackupMode`<sup>Optional</sup> <a name="s3BackupMode" id="cdk-extensions.kinesis_firehose.BackupConfigurationResult.property.s3BackupMode"></a>

```typescript
public readonly s3BackupMode: string;
```

- *Type:* string

---

### BasicColumnProps <a name="BasicColumnProps" id="cdk-extensions.glue.BasicColumnProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.glue.BasicColumnProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const basicColumnProps: glue.BasicColumnProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.BasicColumnProps.property.comment">comment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.BasicColumnProps.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.BasicColumnProps.property.type">type</a></code> | <code>string</code> | *No description.* |

---

##### `comment`<sup>Optional</sup> <a name="comment" id="cdk-extensions.glue.BasicColumnProps.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.BasicColumnProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="cdk-extensions.glue.BasicColumnProps.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

### BookmarkRange <a name="BookmarkRange" id="cdk-extensions.glue.BookmarkRange"></a>

A range of job run ID's that specify the job bookmark state of a Glue job which has had its bookmark state set to paused.

> [[Using job bookmarks in AWS Glue](https://docs.aws.amazon.com/glue/latest/dg/monitor-continuations.html#monitor-continuations-implement)]([Using job bookmarks in AWS Glue](https://docs.aws.amazon.com/glue/latest/dg/monitor-continuations.html#monitor-continuations-implement))

#### Initializer <a name="Initializer" id="cdk-extensions.glue.BookmarkRange.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const bookmarkRange: glue.BookmarkRange = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.BookmarkRange.property.from">from</a></code> | <code>string</code> | The run ID which represents all the input that was processed until the last successful run before and including the specified run ID. |
| <code><a href="#cdk-extensions.glue.BookmarkRange.property.to">to</a></code> | <code>string</code> | The run ID which represents all the input that was processed until the last successful run before and including the specified run ID. |

---

##### `from`<sup>Required</sup> <a name="from" id="cdk-extensions.glue.BookmarkRange.property.from"></a>

```typescript
public readonly from: string;
```

- *Type:* string

The run ID which represents all the input that was processed until the last successful run before and including the specified run ID.

The
corresponding input is ignored.

---

##### `to`<sup>Required</sup> <a name="to" id="cdk-extensions.glue.BookmarkRange.property.to"></a>

```typescript
public readonly to: string;
```

- *Type:* string

The run ID which represents all the input that was processed until the last successful run before and including the specified run ID.

The
corresponding input excluding the input identified by the
{@link BookmarkRange.from | from} is processed by the job. Any input later
than this input is also excluded for processing.

---

### BufferingConfigurationOptions <a name="BufferingConfigurationOptions" id="cdk-extensions.kinesis_firehose.BufferingConfigurationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.BufferingConfigurationOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const bufferingConfigurationOptions: kinesis_firehose.BufferingConfigurationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BufferingConfigurationOptions.property.interval">interval</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.BufferingConfigurationOptions.property.sizeInMb">sizeInMb</a></code> | <code>number</code> | *No description.* |

---

##### `interval`<sup>Optional</sup> <a name="interval" id="cdk-extensions.kinesis_firehose.BufferingConfigurationOptions.property.interval"></a>

```typescript
public readonly interval: Duration;
```

- *Type:* aws-cdk-lib.Duration

---

##### `sizeInMb`<sup>Optional</sup> <a name="sizeInMb" id="cdk-extensions.kinesis_firehose.BufferingConfigurationOptions.property.sizeInMb"></a>

```typescript
public readonly sizeInMb: number;
```

- *Type:* number

---

### CloudfrontLogsBucketProps <a name="CloudfrontLogsBucketProps" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps"></a>

Configuration for objects bucket.

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const cloudfrontLogsBucketProps: s3_buckets.CloudfrontLogsBucketProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.bucketName">bucketName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucketName`<sup>Optional</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---

##### `tableName`<sup>Optional</sup> <a name="tableName" id="cdk-extensions.s3_buckets.CloudfrontLogsBucketProps.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

### CloudfrontLogsTableProps <a name="CloudfrontLogsTableProps" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps"></a>

Configuration for CloudfrontAccessLogsTable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

const cloudfrontLogsTableProps: glue_tables.CloudfrontLogsTableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | The bucket where logs will be contained. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the Cloudfront Logs. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.name">name</a></code> | <code>string</code> | Name for Cloudfront Logs Table. |
| <code><a href="#cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.s3Prefix">s3Prefix</a></code> | <code>string</code> | Set a custom prefix for the S3 Bucket. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

The bucket where logs will be contained.

> [[AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html)]([AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html))

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in.

> [[AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html)]([AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html))

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the Cloudfront Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name for Cloudfront Logs Table.

---

##### `s3Prefix`<sup>Optional</sup> <a name="s3Prefix" id="cdk-extensions.glue_tables.CloudfrontLogsTableProps.property.s3Prefix"></a>

```typescript
public readonly s3Prefix: string;
```

- *Type:* string

Set a custom prefix for the S3 Bucket.

---

### CloudtrailBucketProps <a name="CloudtrailBucketProps" id="cdk-extensions.s3_buckets.CloudtrailBucketProps"></a>

Configuration for objects bucket.

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const cloudtrailBucketProps: s3_buckets.CloudtrailBucketProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.bucketName">bucketName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.CloudtrailBucketProps.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucketName`<sup>Optional</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---

##### `tableName`<sup>Optional</sup> <a name="tableName" id="cdk-extensions.s3_buckets.CloudtrailBucketProps.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

### CloudtrailTableProps <a name="CloudtrailTableProps" id="cdk-extensions.glue_tables.CloudtrailTableProps"></a>

Configuration for FlowLogsTable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue_tables.CloudtrailTableProps.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

const cloudtrailTableProps: glue_tables.CloudtrailTableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | A bucket where logs will be stored. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the Cloudtrail Logs. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.name">name</a></code> | <code>string</code> | Name for Cloudtrail Logs Table. |
| <code><a href="#cdk-extensions.glue_tables.CloudtrailTableProps.property.s3Prefix">s3Prefix</a></code> | <code>string</code> | Set a custom prefix for the S3 Bucket. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

A bucket where logs will be stored.

> [[AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html)]([AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html))

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in.

> [[AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html)]([AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html))

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the Cloudtrail Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name for Cloudtrail Logs Table.

---

##### `s3Prefix`<sup>Optional</sup> <a name="s3Prefix" id="cdk-extensions.glue_tables.CloudtrailTableProps.property.s3Prefix"></a>

```typescript
public readonly s3Prefix: string;
```

- *Type:* string

Set a custom prefix for the S3 Bucket.

---

### CloudWatchEncryption <a name="CloudWatchEncryption" id="cdk-extensions.glue.CloudWatchEncryption"></a>

CloudWatch Logs encryption configuration.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.CloudWatchEncryption.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const cloudWatchEncryption: glue.CloudWatchEncryption = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.CloudWatchEncryption.property.mode">mode</a></code> | <code>cdk-extensions.glue.CloudWatchEncryptionMode</code> | Encryption mode. |
| <code><a href="#cdk-extensions.glue.CloudWatchEncryption.property.kmsKey">kmsKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | The KMS key to be used to encrypt the data. |

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk-extensions.glue.CloudWatchEncryption.property.mode"></a>

```typescript
public readonly mode: CloudWatchEncryptionMode;
```

- *Type:* cdk-extensions.glue.CloudWatchEncryptionMode

Encryption mode.

---

##### `kmsKey`<sup>Optional</sup> <a name="kmsKey" id="cdk-extensions.glue.CloudWatchEncryption.property.kmsKey"></a>

```typescript
public readonly kmsKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey
- *Default:* A key will be created if one is not provided.

The KMS key to be used to encrypt the data.

---

### CloudWatchLoggingConfigurationOptions <a name="CloudWatchLoggingConfigurationOptions" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const cloudWatchLoggingConfigurationOptions: kinesis_firehose.CloudWatchLoggingConfigurationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions.property.logStream">logStream</a></code> | <code>aws-cdk-lib.aws_logs.ILogStream</code> | *No description.* |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

---

##### `logStream`<sup>Optional</sup> <a name="logStream" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions.property.logStream"></a>

```typescript
public readonly logStream: ILogStream;
```

- *Type:* aws-cdk-lib.aws_logs.ILogStream

---

### ClusterFargateLoggingOptions <a name="ClusterFargateLoggingOptions" id="cdk-extensions.eks_patterns.ClusterFargateLoggingOptions"></a>

Configuration options for enabling persistent logging for Fargate containers on the cluster.

#### Initializer <a name="Initializer" id="cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.Initializer"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

const clusterFargateLoggingOptions: eks_patterns.ClusterFargateLoggingOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.fargateProfiles">fargateProfiles</a></code> | <code>aws-cdk-lib.aws_eks.FargateProfile[]</code> | A default list of Fargate profiles that should have permissions configured. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.filters">filters</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitFilterPlugin[]</code> | The filters that should be applied to logs being processed. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | The CloudWatch log group where Farget container logs will be sent. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.outputs">outputs</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitOutputPlugin[]</code> | The output destinations where logs should be written. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.parsers">parsers</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitParserPlugin[]</code> | The parsers to be used when reading log files. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.enabled">enabled</a></code> | <code>boolean</code> | Controls whether logging will be set up for pods using the default Fargate provide on the EKS cluster. |

---

##### `fargateProfiles`<sup>Optional</sup> <a name="fargateProfiles" id="cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.fargateProfiles"></a>

```typescript
public readonly fargateProfiles: FargateProfile[];
```

- *Type:* aws-cdk-lib.aws_eks.FargateProfile[]

A default list of Fargate profiles that should have permissions configured.

Alternatively profiles can be added at any time by calling
`addProfile`.

---

##### `filters`<sup>Optional</sup> <a name="filters" id="cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.filters"></a>

```typescript
public readonly filters: IFluentBitFilterPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitFilterPlugin[]

The filters that should be applied to logs being processed.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The CloudWatch log group where Farget container logs will be sent.

---

##### `outputs`<sup>Optional</sup> <a name="outputs" id="cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.outputs"></a>

```typescript
public readonly outputs: IFluentBitOutputPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitOutputPlugin[]

The output destinations where logs should be written.

---

##### `parsers`<sup>Optional</sup> <a name="parsers" id="cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.parsers"></a>

```typescript
public readonly parsers: IFluentBitParserPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin[]

The parsers to be used when reading log files.

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.eks_patterns.ClusterFargateLoggingOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean
- *Default:* true

Controls whether logging will be set up for pods using the default Fargate provide on the EKS cluster.

---

### ClusterPrometheusOptions <a name="ClusterPrometheusOptions" id="cdk-extensions.eks_patterns.ClusterPrometheusOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.eks_patterns.ClusterPrometheusOptions.Initializer"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

const clusterPrometheusOptions: eks_patterns.ClusterPrometheusOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be deployed. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.queueConfiguration">queueConfiguration</a></code> | <code>cdk-extensions.k8s_fargate.QueueConfiguration</code> | {@inheritdoc QueueConfiguration}. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.serviceAccountName">serviceAccountName</a></code> | <code>string</code> | Name of the Kubernetes service account that should be created and used by Prometheus. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.workspace">workspace</a></code> | <code>cdk-extensions.aps.IWorkspace</code> | *No description.* |

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the service should be deployed.

---

##### `queueConfiguration`<sup>Optional</sup> <a name="queueConfiguration" id="cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.queueConfiguration"></a>

```typescript
public readonly queueConfiguration: QueueConfiguration;
```

- *Type:* cdk-extensions.k8s_fargate.QueueConfiguration

{@inheritdoc QueueConfiguration}.

---

##### `serviceAccountName`<sup>Optional</sup> <a name="serviceAccountName" id="cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.serviceAccountName"></a>

```typescript
public readonly serviceAccountName: string;
```

- *Type:* string

Name of the Kubernetes service account that should be created and used by Prometheus.

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `workspace`<sup>Optional</sup> <a name="workspace" id="cdk-extensions.eks_patterns.ClusterPrometheusOptions.property.workspace"></a>

```typescript
public readonly workspace: IWorkspace;
```

- *Type:* cdk-extensions.aps.IWorkspace

---

### ClusterRoute53DnsOptions <a name="ClusterRoute53DnsOptions" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.Initializer"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

const clusterRoute53DnsOptions: eks_patterns.ClusterRoute53DnsOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.apiRetries">apiRetries</a></code> | <code>number</code> | Maximum number of retries for AWS API calls before giving up. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.batchChangeSize">batchChangeSize</a></code> | <code>number</code> | Set the maximum number of changes that will be applied in each batch. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.domainFilter">domainFilter</a></code> | <code>string[]</code> | Limits possible target zones by domain suffixes. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.evaluateTargetHealth">evaluateTargetHealth</a></code> | <code>boolean</code> | Sets a flag determining whether the health of the backend service should be evaluated when determining DNS routing. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.logFormat">logFormat</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsLogFormat</code> | Sets the output format external dns will use when generating logs. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.logLevel">logLevel</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsLogLevel</code> | Controls the verbosity of logs generated using the external-dns service. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be deployed. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.preferCname">preferCname</a></code> | <code>boolean</code> | When true, alias records will be avoided and CNAME records will be used instead. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.recordOwnershipRegistry">recordOwnershipRegistry</a></code> | <code>cdk-extensions.k8s_aws.IExternalDnsRegistry</code> | Registry specifying how ExternalDNS should track record ownership. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.region">region</a></code> | <code>string</code> | Override the default region external-dns uses when calling AWS API's. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.replicaCount">replicaCount</a></code> | <code>number</code> | Desired number of ExternalDNS replicas. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.syncPolicy">syncPolicy</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsSyncPolicy</code> | Controls the operations ExternalDNS will perform on the records it manages. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.zoneTags">zoneTags</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsZoneTag[]</code> | A set of tags that can be used to restrict which hosted zones external DNS will make changes to. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.zoneType">zoneType</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsZoneType</code> | Controls the types of hosted zones external-dns will create records for. |
| <code><a href="#cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |

---

##### `apiRetries`<sup>Optional</sup> <a name="apiRetries" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.apiRetries"></a>

```typescript
public readonly apiRetries: number;
```

- *Type:* number
- *Default:* 3

Maximum number of retries for AWS API calls before giving up.

---

##### `batchChangeSize`<sup>Optional</sup> <a name="batchChangeSize" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.batchChangeSize"></a>

```typescript
public readonly batchChangeSize: number;
```

- *Type:* number
- *Default:* 1000

Set the maximum number of changes that will be applied in each batch.

---

##### `domainFilter`<sup>Optional</sup> <a name="domainFilter" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.domainFilter"></a>

```typescript
public readonly domainFilter: string[];
```

- *Type:* string[]

Limits possible target zones by domain suffixes.

---

##### `evaluateTargetHealth`<sup>Optional</sup> <a name="evaluateTargetHealth" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.evaluateTargetHealth"></a>

```typescript
public readonly evaluateTargetHealth: boolean;
```

- *Type:* boolean

Sets a flag determining whether the health of the backend service should be evaluated when determining DNS routing.

---

##### `logFormat`<sup>Optional</sup> <a name="logFormat" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.logFormat"></a>

```typescript
public readonly logFormat: ExternalDnsLogFormat;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsLogFormat
- *Default:* {@link ExternalDnsLogLevel.JSON}

Sets the output format external dns will use when generating logs.

---

##### `logLevel`<sup>Optional</sup> <a name="logLevel" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.logLevel"></a>

```typescript
public readonly logLevel: ExternalDnsLogLevel;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsLogLevel
- *Default:* {@link ExternalDnsLogLevel.INFO}

Controls the verbosity of logs generated using the external-dns service.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string
- *Default:* 'kube-system'

The Kubernetes namespace where the service should be deployed.

---

##### `preferCname`<sup>Optional</sup> <a name="preferCname" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.preferCname"></a>

```typescript
public readonly preferCname: boolean;
```

- *Type:* boolean
- *Default:* false

When true, alias records will be avoided and CNAME records will be used instead.

---

##### `recordOwnershipRegistry`<sup>Optional</sup> <a name="recordOwnershipRegistry" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.recordOwnershipRegistry"></a>

```typescript
public readonly recordOwnershipRegistry: IExternalDnsRegistry;
```

- *Type:* cdk-extensions.k8s_aws.IExternalDnsRegistry
- *Default:* A TXT registry configured with defaults.

Registry specifying how ExternalDNS should track record ownership.

Without a registry to track record ownership, External has no way to know
which records it owns and manages and which are owned and managed by a
different service.

This can cause conflicts if there are multiple instances of External DNS
running or if there are other services managing DNS records in similar
zones as the different services could try to make conflicting changes due
to lacking a shared state.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

Override the default region external-dns uses when calling AWS API's.

---

##### `replicaCount`<sup>Optional</sup> <a name="replicaCount" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.replicaCount"></a>

```typescript
public readonly replicaCount: number;
```

- *Type:* number
- *Default:* 1

Desired number of ExternalDNS replicas.

---

##### `syncPolicy`<sup>Optional</sup> <a name="syncPolicy" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.syncPolicy"></a>

```typescript
public readonly syncPolicy: ExternalDnsSyncPolicy;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsSyncPolicy
- *Default:* {@link ExternalDnsSyncPolicy.SYNC}

Controls the operations ExternalDNS will perform on the records it manages.

---

##### `zoneTags`<sup>Optional</sup> <a name="zoneTags" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.zoneTags"></a>

```typescript
public readonly zoneTags: ExternalDnsZoneTag[];
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneTag[]

A set of tags that can be used to restrict which hosted zones external DNS will make changes to.

---

##### `zoneType`<sup>Optional</sup> <a name="zoneType" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.zoneType"></a>

```typescript
public readonly zoneType: ExternalDnsZoneType;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneType
- *Default:* ExternalDnsZoneType.ALL

Controls the types of hosted zones external-dns will create records for.

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.eks_patterns.ClusterRoute53DnsOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

### CodeConfig <a name="CodeConfig" id="cdk-extensions.glue.CodeConfig"></a>

Result of binding `Code` into a `Job`.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.CodeConfig.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const codeConfig: glue.CodeConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.CodeConfig.property.s3Location">s3Location</a></code> | <code>aws-cdk-lib.aws_s3.Location</code> | The location of the code in S3. |

---

##### `s3Location`<sup>Required</sup> <a name="s3Location" id="cdk-extensions.glue.CodeConfig.property.s3Location"></a>

```typescript
public readonly s3Location: Location;
```

- *Type:* aws-cdk-lib.aws_s3.Location

The location of the code in S3.

---

### ColumnProps <a name="ColumnProps" id="cdk-extensions.glue.ColumnProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.glue.ColumnProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const columnProps: glue.ColumnProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ColumnProps.property.comment">comment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ColumnProps.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `comment`<sup>Optional</sup> <a name="comment" id="cdk-extensions.glue.ColumnProps.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.ColumnProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

### CommonPartitioningOptions <a name="CommonPartitioningOptions" id="cdk-extensions.kinesis_firehose.CommonPartitioningOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.CommonPartitioningOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const commonPartitioningOptions: kinesis_firehose.CommonPartitioningOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CommonPartitioningOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.CommonPartitioningOptions.property.retryInterval">retryInterval</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.CommonPartitioningOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `retryInterval`<sup>Optional</sup> <a name="retryInterval" id="cdk-extensions.kinesis_firehose.CommonPartitioningOptions.property.retryInterval"></a>

```typescript
public readonly retryInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

---

### ConnectionProps <a name="ConnectionProps" id="cdk-extensions.glue.ConnectionProps"></a>

Configuration for the Glue Workflow resource.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.ConnectionProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const connectionProps: glue.ConnectionProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.connectionType">connectionType</a></code> | <code>cdk-extensions.glue.ConnectionType</code> | The type of the connection. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.description">description</a></code> | <code>string</code> | A description for the Connection. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.name">name</a></code> | <code>string</code> | The name of the connection. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.properties">properties</a></code> | <code>{[ key: string ]: string}</code> | List of Key/Value pairs defining the properties of the Connection. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.securityGroups">securityGroups</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup[]</code> | Existing Security Group to assign to the Connection. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | Options for selection of subnets from the VPC to attach to the Connection. |
| <code><a href="#cdk-extensions.glue.ConnectionProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | VPC to attach to the Connection. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.ConnectionProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.ConnectionProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.ConnectionProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.ConnectionProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `connectionType`<sup>Required</sup> <a name="connectionType" id="cdk-extensions.glue.ConnectionProps.property.connectionType"></a>

```typescript
public readonly connectionType: ConnectionType;
```

- *Type:* cdk-extensions.glue.ConnectionType

The type of the connection.

> [[AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype)]([AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.ConnectionProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A description for the Connection.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.ConnectionProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the connection.

Connection will not function as expected without a name.

> [[AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-name)]([AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-name))

---

##### `properties`<sup>Optional</sup> <a name="properties" id="cdk-extensions.glue.ConnectionProps.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

List of Key/Value pairs defining the properties of the Connection.

> [[AWS::Glue::Connection Properties](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-connection.html#Properties)]([AWS::Glue::Connection Properties](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-connection.html#Properties))

---

##### `securityGroups`<sup>Optional</sup> <a name="securityGroups" id="cdk-extensions.glue.ConnectionProps.property.securityGroups"></a>

```typescript
public readonly securityGroups: ISecurityGroup[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup[]

Existing Security Group to assign to the Connection.

If none is provided a new Security Group will be created.

---

##### `subnets`<sup>Optional</sup> <a name="subnets" id="cdk-extensions.glue.ConnectionProps.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

Options for selection of subnets from the VPC to attach to the Connection.

> [[CDK SubnetSelection](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.SubnetSelection.html)]([CDK SubnetSelection](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.SubnetSelection.html))

---

##### `vpc`<sup>Optional</sup> <a name="vpc" id="cdk-extensions.glue.ConnectionProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

VPC to attach to the Connection.

> [[IVpc Interface](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.IVpc.html)]([IVpc Interface](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.IVpc.html))

---

### ContainerInsightsOptions <a name="ContainerInsightsOptions" id="cdk-extensions.eks_patterns.ContainerInsightsOptions"></a>

Configuration options for enabling CloudWatch monitoring on the cluster.

#### Initializer <a name="Initializer" id="cdk-extensions.eks_patterns.ContainerInsightsOptions.Initializer"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

const containerInsightsOptions: eks_patterns.ContainerInsightsOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.ContainerInsightsOptions.property.enabled">enabled</a></code> | <code>boolean</code> | Flag that controls whether CloudWatch Monitoring should be enabled or not. |
| <code><a href="#cdk-extensions.eks_patterns.ContainerInsightsOptions.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where resources related to the the configuration of Container Insights will be created. |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.eks_patterns.ContainerInsightsOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean
- *Default:* true

Flag that controls whether CloudWatch Monitoring should be enabled or not.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.eks_patterns.ContainerInsightsOptions.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string
- *Default:* {@link AdotCollector.DEFAULT_NAMESPACE}

The Kubernetes namespace where resources related to the the configuration of Container Insights will be created.

---

### ContinuousLoggingProps <a name="ContinuousLoggingProps" id="cdk-extensions.glue.ContinuousLoggingProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.glue.ContinuousLoggingProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const continuousLoggingProps: glue.ContinuousLoggingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ContinuousLoggingProps.property.enabled">enabled</a></code> | <code>boolean</code> | Enable continouous logging. |
| <code><a href="#cdk-extensions.glue.ContinuousLoggingProps.property.conversionPattern">conversionPattern</a></code> | <code>string</code> | Apply the provided conversion pattern. |
| <code><a href="#cdk-extensions.glue.ContinuousLoggingProps.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | Specify a custom CloudWatch log group name. |
| <code><a href="#cdk-extensions.glue.ContinuousLoggingProps.property.logStreamPrefix">logStreamPrefix</a></code> | <code>string</code> | Specify a custom CloudWatch log stream prefix. |
| <code><a href="#cdk-extensions.glue.ContinuousLoggingProps.property.quiet">quiet</a></code> | <code>boolean</code> | Filter out non-useful Apache Spark driver/executor and Apache Hadoop YARN heartbeat log messages. |

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="cdk-extensions.glue.ContinuousLoggingProps.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

Enable continouous logging.

---

##### `conversionPattern`<sup>Optional</sup> <a name="conversionPattern" id="cdk-extensions.glue.ContinuousLoggingProps.property.conversionPattern"></a>

```typescript
public readonly conversionPattern: string;
```

- *Type:* string
- *Default:* `%d{yy/MM/dd HH:mm:ss} %p %c{1}: %m%n`

Apply the provided conversion pattern.

This is a Log4j Conversion Pattern to customize driver and executor logs.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.glue.ContinuousLoggingProps.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup
- *Default:* a log group is created with name `/aws-glue/jobs/logs-v2/`.

Specify a custom CloudWatch log group name.

---

##### `logStreamPrefix`<sup>Optional</sup> <a name="logStreamPrefix" id="cdk-extensions.glue.ContinuousLoggingProps.property.logStreamPrefix"></a>

```typescript
public readonly logStreamPrefix: string;
```

- *Type:* string
- *Default:* the job run ID.

Specify a custom CloudWatch log stream prefix.

---

##### `quiet`<sup>Optional</sup> <a name="quiet" id="cdk-extensions.glue.ContinuousLoggingProps.property.quiet"></a>

```typescript
public readonly quiet: boolean;
```

- *Type:* boolean
- *Default:* true

Filter out non-useful Apache Spark driver/executor and Apache Hadoop YARN heartbeat log messages.

---

### CrawlerConfiguration <a name="CrawlerConfiguration" id="cdk-extensions.glue.CrawlerConfiguration"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.glue.CrawlerConfiguration.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const crawlerConfiguration: glue.CrawlerConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.CrawlerConfiguration.property.partitionUpdateBehavior">partitionUpdateBehavior</a></code> | <code>cdk-extensions.glue.PartitionUpdateBehavior</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.CrawlerConfiguration.property.tableGroupingPolicy">tableGroupingPolicy</a></code> | <code>cdk-extensions.glue.TableGroupingPolicy</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.CrawlerConfiguration.property.tableLevel">tableLevel</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.CrawlerConfiguration.property.tableUpdateBehavior">tableUpdateBehavior</a></code> | <code>cdk-extensions.glue.TableUpdateBehavior</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.CrawlerConfiguration.property.version">version</a></code> | <code>cdk-extensions.glue.ConfigurationVersion</code> | *No description.* |

---

##### `partitionUpdateBehavior`<sup>Optional</sup> <a name="partitionUpdateBehavior" id="cdk-extensions.glue.CrawlerConfiguration.property.partitionUpdateBehavior"></a>

```typescript
public readonly partitionUpdateBehavior: PartitionUpdateBehavior;
```

- *Type:* cdk-extensions.glue.PartitionUpdateBehavior

---

##### `tableGroupingPolicy`<sup>Optional</sup> <a name="tableGroupingPolicy" id="cdk-extensions.glue.CrawlerConfiguration.property.tableGroupingPolicy"></a>

```typescript
public readonly tableGroupingPolicy: TableGroupingPolicy;
```

- *Type:* cdk-extensions.glue.TableGroupingPolicy

---

##### `tableLevel`<sup>Optional</sup> <a name="tableLevel" id="cdk-extensions.glue.CrawlerConfiguration.property.tableLevel"></a>

```typescript
public readonly tableLevel: number;
```

- *Type:* number

---

##### `tableUpdateBehavior`<sup>Optional</sup> <a name="tableUpdateBehavior" id="cdk-extensions.glue.CrawlerConfiguration.property.tableUpdateBehavior"></a>

```typescript
public readonly tableUpdateBehavior: TableUpdateBehavior;
```

- *Type:* cdk-extensions.glue.TableUpdateBehavior

---

##### `version`<sup>Optional</sup> <a name="version" id="cdk-extensions.glue.CrawlerConfiguration.property.version"></a>

```typescript
public readonly version: ConfigurationVersion;
```

- *Type:* cdk-extensions.glue.ConfigurationVersion

---

### CrawlerProps <a name="CrawlerProps" id="cdk-extensions.glue.CrawlerProps"></a>

Configuration for Crawler.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.CrawlerProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const crawlerProps: glue.CrawlerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.classifiers">classifiers</a></code> | <code>string[]</code> | A list of UTF-8 strings that specify the names of custom classifiers that are associated with the crawler. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.configuration">configuration</a></code> | <code>cdk-extensions.glue.CrawlerConfiguration</code> | Crawler configuration information. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | The {@link aws-glue.Database \| Database } object in which the crawler's output is stored. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.deleteBehavior">deleteBehavior</a></code> | <code>cdk-extensions.glue.DeleteBehavior</code> | The deletion behavior when the crawler finds a deleted object. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.description">description</a></code> | <code>string</code> | Description of the Crawler. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.name">name</a></code> | <code>string</code> | Name of the Crawler. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.recrawlBehavior">recrawlBehavior</a></code> | <code>cdk-extensions.glue.RecrawlBehavior</code> | When crawling an Amazon S3 data source after the first crawl is complete, specifies whether to crawl the entire dataset again or to crawl only folders that were added since the last crawler run. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.scheduleExpression">scheduleExpression</a></code> | <code>aws-cdk-lib.aws_events.Schedule</code> | For scheduled crawlers, the schedule when the crawler runs. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.securityConfiguration">securityConfiguration</a></code> | <code>cdk-extensions.glue.SecurityConfiguration</code> | A {@link aws-glue.SecurityConfiguration \| SecurityConfiguration } object to apply to the Crawler. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.tablePrefix">tablePrefix</a></code> | <code>string</code> | The prefix added to the names of tables that are created. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.targets">targets</a></code> | <code>cdk-extensions.glue.ICrawlerTarget[]</code> | A collection of targets to crawl. |
| <code><a href="#cdk-extensions.glue.CrawlerProps.property.updateBehavior">updateBehavior</a></code> | <code>cdk-extensions.glue.UpdateBehavior</code> | The update behavior when the crawler finds a changed schema. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.CrawlerProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.CrawlerProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.CrawlerProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.CrawlerProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `classifiers`<sup>Optional</sup> <a name="classifiers" id="cdk-extensions.glue.CrawlerProps.property.classifiers"></a>

```typescript
public readonly classifiers: string[];
```

- *Type:* string[]

A list of UTF-8 strings that specify the names of custom classifiers that are associated with the crawler.

> [[AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html#cfn-glue-crawler-classifiers)]([AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html#cfn-glue-crawler-classifiers))

---

##### `configuration`<sup>Optional</sup> <a name="configuration" id="cdk-extensions.glue.CrawlerProps.property.configuration"></a>

```typescript
public readonly configuration: CrawlerConfiguration;
```

- *Type:* cdk-extensions.glue.CrawlerConfiguration

Crawler configuration information.

This versioned JSON string allows users to specify aspects of a crawler's behavior. For more information, see Configuring a Crawler.

> [[AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html#cfn-glue-crawler-configuration)]([AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html#cfn-glue-crawler-configuration))

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.glue.CrawlerProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

The {@link aws-glue.Database | Database } object in which the crawler's output is stored.

---

##### `deleteBehavior`<sup>Optional</sup> <a name="deleteBehavior" id="cdk-extensions.glue.CrawlerProps.property.deleteBehavior"></a>

```typescript
public readonly deleteBehavior: DeleteBehavior;
```

- *Type:* cdk-extensions.glue.DeleteBehavior

The deletion behavior when the crawler finds a deleted object.

> [[AWS::Glue::Crawler SchemaChangePolicy](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-schemachangepolicy.html#cfn-glue-crawler-schemachangepolicy-deletebehavior)]([AWS::Glue::Crawler SchemaChangePolicy](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-schemachangepolicy.html#cfn-glue-crawler-schemachangepolicy-deletebehavior))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.CrawlerProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Description of the Crawler.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.CrawlerProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the Crawler.

---

##### `recrawlBehavior`<sup>Optional</sup> <a name="recrawlBehavior" id="cdk-extensions.glue.CrawlerProps.property.recrawlBehavior"></a>

```typescript
public readonly recrawlBehavior: RecrawlBehavior;
```

- *Type:* cdk-extensions.glue.RecrawlBehavior

When crawling an Amazon S3 data source after the first crawl is complete, specifies whether to crawl the entire dataset again or to crawl only folders that were added since the last crawler run.

> [[AWS::Glue::Crawler RecrawlPolicy](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-recrawlpolicy.html)]([AWS::Glue::Crawler RecrawlPolicy](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-recrawlpolicy.html))

---

##### `scheduleExpression`<sup>Optional</sup> <a name="scheduleExpression" id="cdk-extensions.glue.CrawlerProps.property.scheduleExpression"></a>

```typescript
public readonly scheduleExpression: Schedule;
```

- *Type:* aws-cdk-lib.aws_events.Schedule

For scheduled crawlers, the schedule when the crawler runs.

> [[AWS::Glue::Crawler Schedule](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-schedule.html)]([AWS::Glue::Crawler Schedule](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-schedule.html))

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.CrawlerProps.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: SecurityConfiguration;
```

- *Type:* cdk-extensions.glue.SecurityConfiguration

A {@link aws-glue.SecurityConfiguration | SecurityConfiguration } object to apply to the Crawler.

---

##### `tablePrefix`<sup>Optional</sup> <a name="tablePrefix" id="cdk-extensions.glue.CrawlerProps.property.tablePrefix"></a>

```typescript
public readonly tablePrefix: string;
```

- *Type:* string

The prefix added to the names of tables that are created.

> [[AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html#cfn-glue-crawler-tableprefix)]([AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html#cfn-glue-crawler-tableprefix))

---

##### `targets`<sup>Optional</sup> <a name="targets" id="cdk-extensions.glue.CrawlerProps.property.targets"></a>

```typescript
public readonly targets: ICrawlerTarget[];
```

- *Type:* cdk-extensions.glue.ICrawlerTarget[]

A collection of targets to crawl.

> [[AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html#cfn-glue-crawler-targets)]([AWS::Glue::Crawler](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-crawler.html#cfn-glue-crawler-targets))

---

##### `updateBehavior`<sup>Optional</sup> <a name="updateBehavior" id="cdk-extensions.glue.CrawlerProps.property.updateBehavior"></a>

```typescript
public readonly updateBehavior: UpdateBehavior;
```

- *Type:* cdk-extensions.glue.UpdateBehavior

The update behavior when the crawler finds a changed schema.

> [[AWS::Glue::Crawler SchemaChangePolicy](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-schemachangepolicy.html#cfn-glue-crawler-schemachangepolicy-updatebehavior)]([AWS::Glue::Crawler SchemaChangePolicy](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-schemachangepolicy.html#cfn-glue-crawler-schemachangepolicy-updatebehavior))

---

### CrawlerTargetCollection <a name="CrawlerTargetCollection" id="cdk-extensions.glue.CrawlerTargetCollection"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.glue.CrawlerTargetCollection.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const crawlerTargetCollection: glue.CrawlerTargetCollection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.CrawlerTargetCollection.property.catalogTargets">catalogTargets</a></code> | <code>aws-cdk-lib.aws_glue.CfnCrawler.CatalogTargetProperty[]</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.CrawlerTargetCollection.property.dynamoDbTargets">dynamoDbTargets</a></code> | <code>aws-cdk-lib.aws_glue.CfnCrawler.DynamoDBTargetProperty[]</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.CrawlerTargetCollection.property.jdbcTargets">jdbcTargets</a></code> | <code>aws-cdk-lib.aws_glue.CfnCrawler.JdbcTargetProperty[]</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.CrawlerTargetCollection.property.s3Targets">s3Targets</a></code> | <code>aws-cdk-lib.aws_glue.CfnCrawler.S3TargetProperty[]</code> | *No description.* |

---

##### `catalogTargets`<sup>Optional</sup> <a name="catalogTargets" id="cdk-extensions.glue.CrawlerTargetCollection.property.catalogTargets"></a>

```typescript
public readonly catalogTargets: CatalogTargetProperty[];
```

- *Type:* aws-cdk-lib.aws_glue.CfnCrawler.CatalogTargetProperty[]

---

##### `dynamoDbTargets`<sup>Optional</sup> <a name="dynamoDbTargets" id="cdk-extensions.glue.CrawlerTargetCollection.property.dynamoDbTargets"></a>

```typescript
public readonly dynamoDbTargets: DynamoDBTargetProperty[];
```

- *Type:* aws-cdk-lib.aws_glue.CfnCrawler.DynamoDBTargetProperty[]

---

##### `jdbcTargets`<sup>Optional</sup> <a name="jdbcTargets" id="cdk-extensions.glue.CrawlerTargetCollection.property.jdbcTargets"></a>

```typescript
public readonly jdbcTargets: JdbcTargetProperty[];
```

- *Type:* aws-cdk-lib.aws_glue.CfnCrawler.JdbcTargetProperty[]

---

##### `s3Targets`<sup>Optional</sup> <a name="s3Targets" id="cdk-extensions.glue.CrawlerTargetCollection.property.s3Targets"></a>

```typescript
public readonly s3Targets: S3TargetProperty[];
```

- *Type:* aws-cdk-lib.aws_glue.CfnCrawler.S3TargetProperty[]

---

### CustomerGatewayAttributes <a name="CustomerGatewayAttributes" id="cdk-extensions.ec2.CustomerGatewayAttributes"></a>

Attributes used to import an existing customer gateway.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.CustomerGatewayAttributes.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const customerGatewayAttributes: ec2.CustomerGatewayAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayAttributes.property.customerGatewayId">customerGatewayId</a></code> | <code>string</code> | The ID of the existing customer gateway being imported. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayAttributes.property.bgpAsn">bgpAsn</a></code> | <code>number</code> | For devices that support BGP, the customer gateway's BGP ASN. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayAttributes.property.ipAddress">ipAddress</a></code> | <code>string</code> | The Internet-routable IP address for the customer gateway's outside interface. |

---

##### `customerGatewayId`<sup>Required</sup> <a name="customerGatewayId" id="cdk-extensions.ec2.CustomerGatewayAttributes.property.customerGatewayId"></a>

```typescript
public readonly customerGatewayId: string;
```

- *Type:* string

The ID of the existing customer gateway being imported.

---

##### `bgpAsn`<sup>Optional</sup> <a name="bgpAsn" id="cdk-extensions.ec2.CustomerGatewayAttributes.property.bgpAsn"></a>

```typescript
public readonly bgpAsn: number;
```

- *Type:* number

For devices that support BGP, the customer gateway's BGP ASN.

---

##### `ipAddress`<sup>Optional</sup> <a name="ipAddress" id="cdk-extensions.ec2.CustomerGatewayAttributes.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

The Internet-routable IP address for the customer gateway's outside interface.

The address must be static.

---

### CustomerGatewayProps <a name="CustomerGatewayProps" id="cdk-extensions.ec2.CustomerGatewayProps"></a>

Configuration for the CustomerGateway resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.CustomerGatewayProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const customerGatewayProps: ec2.CustomerGatewayProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayProps.property.ipAddress">ipAddress</a></code> | <code>string</code> | The Internet-routable IP address for the customer gateway's outside interface. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayProps.property.bgpAsn">bgpAsn</a></code> | <code>number</code> | For devices that support BGP, the customer gateway's BGP ASN. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayProps.property.connectionType">connectionType</a></code> | <code>cdk-extensions.ec2.VpnConnectionType</code> | The type of VPN connection that this customer gateway supports. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.CustomerGatewayProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.CustomerGatewayProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.CustomerGatewayProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.CustomerGatewayProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="cdk-extensions.ec2.CustomerGatewayProps.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

The Internet-routable IP address for the customer gateway's outside interface.

The address must be static.

> [[CustomerGateway IpAddress](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-ipaddress)]([CustomerGateway IpAddress](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-ipaddress))

---

##### `bgpAsn`<sup>Optional</sup> <a name="bgpAsn" id="cdk-extensions.ec2.CustomerGatewayProps.property.bgpAsn"></a>

```typescript
public readonly bgpAsn: number;
```

- *Type:* number

For devices that support BGP, the customer gateway's BGP ASN.

> [[CustomerGateway BgpAsn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-bgpasn)]([CustomerGateway BgpAsn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-bgpasn))

---

##### `connectionType`<sup>Optional</sup> <a name="connectionType" id="cdk-extensions.ec2.CustomerGatewayProps.property.connectionType"></a>

```typescript
public readonly connectionType: VpnConnectionType;
```

- *Type:* cdk-extensions.ec2.VpnConnectionType

The type of VPN connection that this customer gateway supports.

> [[CustomerGateway Type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-type)]([CustomerGateway Type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-customergateway.html#cfn-ec2-customergateway-type))

---

### CustomProcessorOptions <a name="CustomProcessorOptions" id="cdk-extensions.kinesis_firehose.CustomProcessorOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.CustomProcessorOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const customProcessorOptions: kinesis_firehose.CustomProcessorOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CustomProcessorOptions.property.processorType">processorType</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.CustomProcessorOptions.property.parameters">parameters</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `processorType`<sup>Required</sup> <a name="processorType" id="cdk-extensions.kinesis_firehose.CustomProcessorOptions.property.processorType"></a>

```typescript
public readonly processorType: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk-extensions.kinesis_firehose.CustomProcessorOptions.property.parameters"></a>

```typescript
public readonly parameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

### DatabaseProps <a name="DatabaseProps" id="cdk-extensions.glue.DatabaseProps"></a>

Configuration for Database.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.DatabaseProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const databaseProps: glue.DatabaseProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.DatabaseProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.DatabaseProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.DatabaseProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.DatabaseProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.DatabaseProps.property.description">description</a></code> | <code>string</code> | A description of the database. |
| <code><a href="#cdk-extensions.glue.DatabaseProps.property.locationUri">locationUri</a></code> | <code>string</code> | The location of the database (for example, an HDFS path). |
| <code><a href="#cdk-extensions.glue.DatabaseProps.property.name">name</a></code> | <code>string</code> | The name of the database. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.DatabaseProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.DatabaseProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.DatabaseProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.DatabaseProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.DatabaseProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A description of the database.

---

##### `locationUri`<sup>Optional</sup> <a name="locationUri" id="cdk-extensions.glue.DatabaseProps.property.locationUri"></a>

```typescript
public readonly locationUri: string;
```

- *Type:* string

The location of the database (for example, an HDFS path).

> [[AWS::Glue::Database DatabaseInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-database-databaseinput.html#cfn-glue-database-databaseinput-locationuri)]([AWS::Glue::Database DatabaseInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-database-databaseinput.html#cfn-glue-database-databaseinput-locationuri))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.DatabaseProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the database.

For Hive compatibility, this is folded to lowercase when it is stored.

---

### DatabaseProxyEndpointProps <a name="DatabaseProxyEndpointProps" id="cdk-extensions.rds.DatabaseProxyEndpointProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.rds.DatabaseProxyEndpointProps.Initializer"></a>

```typescript
import { rds } from 'cdk-extensions'

const databaseProxyEndpointProps: rds.DatabaseProxyEndpointProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.databaseProxy">databaseProxy</a></code> | <code>aws-cdk-lib.aws_rds.IDatabaseProxy</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.access">access</a></code> | <code>cdk-extensions.rds.DatabaseProxyEndpointAccess</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.securityGroups">securityGroups</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup[]</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointProps.property.vpcSubnets">vpcSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `databaseProxy`<sup>Required</sup> <a name="databaseProxy" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.databaseProxy"></a>

```typescript
public readonly databaseProxy: IDatabaseProxy;
```

- *Type:* aws-cdk-lib.aws_rds.IDatabaseProxy

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

---

##### `access`<sup>Optional</sup> <a name="access" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.access"></a>

```typescript
public readonly access: DatabaseProxyEndpointAccess;
```

- *Type:* cdk-extensions.rds.DatabaseProxyEndpointAccess

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `securityGroups`<sup>Optional</sup> <a name="securityGroups" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.securityGroups"></a>

```typescript
public readonly securityGroups: ISecurityGroup[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup[]

---

##### `vpcSubnets`<sup>Optional</sup> <a name="vpcSubnets" id="cdk-extensions.rds.DatabaseProxyEndpointProps.property.vpcSubnets"></a>

```typescript
public readonly vpcSubnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

---

### DataFormatConversionOptions <a name="DataFormatConversionOptions" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const dataFormatConversionOptions: kinesis_firehose.DataFormatConversionOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.inputFormat">inputFormat</a></code> | <code>cdk-extensions.kinesis_firehose.InputFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.outputFormat">outputFormat</a></code> | <code>cdk-extensions.kinesis_firehose.OutputFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.table">table</a></code> | <code>cdk-extensions.glue.Table</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.catalogId">catalogId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.region">region</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.version">version</a></code> | <code>cdk-extensions.kinesis_firehose.TableVersion</code> | *No description.* |

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `inputFormat`<sup>Required</sup> <a name="inputFormat" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.inputFormat"></a>

```typescript
public readonly inputFormat: InputFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.InputFormat

---

##### `outputFormat`<sup>Required</sup> <a name="outputFormat" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.outputFormat"></a>

```typescript
public readonly outputFormat: OutputFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.OutputFormat

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.table"></a>

```typescript
public readonly table: Table;
```

- *Type:* cdk-extensions.glue.Table

---

##### `catalogId`<sup>Optional</sup> <a name="catalogId" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.catalogId"></a>

```typescript
public readonly catalogId: string;
```

- *Type:* string

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `version`<sup>Optional</sup> <a name="version" id="cdk-extensions.kinesis_firehose.DataFormatConversionOptions.property.version"></a>

```typescript
public readonly version: TableVersion;
```

- *Type:* cdk-extensions.kinesis_firehose.TableVersion

---

### DataFormatProps <a name="DataFormatProps" id="cdk-extensions.glue.DataFormatProps"></a>

Properties of a DataFormat instance.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.DataFormatProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const dataFormatProps: glue.DataFormatProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.DataFormatProps.property.inputFormat">inputFormat</a></code> | <code>cdk-extensions.glue.InputFormat</code> | `InputFormat` for this data format. |
| <code><a href="#cdk-extensions.glue.DataFormatProps.property.outputFormat">outputFormat</a></code> | <code>cdk-extensions.glue.OutputFormat</code> | `OutputFormat` for this data format. |
| <code><a href="#cdk-extensions.glue.DataFormatProps.property.serializationLibrary">serializationLibrary</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | Serialization library for this data format. |
| <code><a href="#cdk-extensions.glue.DataFormatProps.property.classificationString">classificationString</a></code> | <code>cdk-extensions.glue.ClassificationString</code> | Classification string given to tables with this data format. |

---

##### `inputFormat`<sup>Required</sup> <a name="inputFormat" id="cdk-extensions.glue.DataFormatProps.property.inputFormat"></a>

```typescript
public readonly inputFormat: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

`InputFormat` for this data format.

---

##### `outputFormat`<sup>Required</sup> <a name="outputFormat" id="cdk-extensions.glue.DataFormatProps.property.outputFormat"></a>

```typescript
public readonly outputFormat: OutputFormat;
```

- *Type:* cdk-extensions.glue.OutputFormat

`OutputFormat` for this data format.

---

##### `serializationLibrary`<sup>Required</sup> <a name="serializationLibrary" id="cdk-extensions.glue.DataFormatProps.property.serializationLibrary"></a>

```typescript
public readonly serializationLibrary: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

Serialization library for this data format.

---

##### `classificationString`<sup>Optional</sup> <a name="classificationString" id="cdk-extensions.glue.DataFormatProps.property.classificationString"></a>

```typescript
public readonly classificationString: ClassificationString;
```

- *Type:* cdk-extensions.glue.ClassificationString
- *Default:* No classification is specified.

Classification string given to tables with this data format.

---

### DayOfMonthRange <a name="DayOfMonthRange" id="cdk-extensions.aps.DayOfMonthRange"></a>

A range specifying the numerical days in the month.

Days begin at 1. Negative values are also accepted which begin at the end of
the month, e.g. -1 during January would represent January 31. For example:
`start: 1` and `end: 5` or `start:-3` and `end: -1` would both be valid
ranges.

Extending past the start or end of the month will cause it to be clamped.
E.g. specifying `start: 1` and `end: 31` during February will clamp the
actual end date to 28 or 29 depending on leap years.

Inclusive on both ends.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.DayOfMonthRange.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const dayOfMonthRange: aps.DayOfMonthRange = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.DayOfMonthRange.property.end">end</a></code> | <code>number</code> | The last day of the month for which the range should apply (inclusive). |
| <code><a href="#cdk-extensions.aps.DayOfMonthRange.property.start">start</a></code> | <code>number</code> | The first day of the month for which the range should apply. |

---

##### `end`<sup>Required</sup> <a name="end" id="cdk-extensions.aps.DayOfMonthRange.property.end"></a>

```typescript
public readonly end: number;
```

- *Type:* number

The last day of the month for which the range should apply (inclusive).

---

##### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.DayOfMonthRange.property.start"></a>

```typescript
public readonly start: number;
```

- *Type:* number

The first day of the month for which the range should apply.

---

### DefaultRouteOptions <a name="DefaultRouteOptions" id="cdk-extensions.aps.DefaultRouteOptions"></a>

Configuration options that control the default behavior of alerts.

These are the settings that will be used for any alerts that do not match a
child node in the default routing tree or alerts that do match a child node
that doesn't override the settings provded here.

The default route does not support all the settings supported by other
(child) routes.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.DefaultRouteOptions.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const defaultRouteOptions: aps.DefaultRouteOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.DefaultRouteOptions.property.groupByLabels">groupByLabels</a></code> | <code>string[]</code> | The labels by which incoming alerts are grouped together. |
| <code><a href="#cdk-extensions.aps.DefaultRouteOptions.property.groupInterval">groupInterval</a></code> | <code>aws-cdk-lib.Duration</code> | How long to wait before sending a notification about new alerts that are added to a group of alerts for which an initial notification has already been sent (usually ~5m or more). |
| <code><a href="#cdk-extensions.aps.DefaultRouteOptions.property.groupWait">groupWait</a></code> | <code>aws-cdk-lib.Duration</code> | How long to initially wait to send a notification for a group of alerts. |
| <code><a href="#cdk-extensions.aps.DefaultRouteOptions.property.matchers">matchers</a></code> | <code>cdk-extensions.aps.AlertManagerMatcher[]</code> | A list of matchers that an alert has to fulfill to match the node. |
| <code><a href="#cdk-extensions.aps.DefaultRouteOptions.property.repeatInterval">repeatInterval</a></code> | <code>aws-cdk-lib.Duration</code> | How long to wait before sending a notification again if it has already been sent successfully for an alert. |

---

##### `groupByLabels`<sup>Optional</sup> <a name="groupByLabels" id="cdk-extensions.aps.DefaultRouteOptions.property.groupByLabels"></a>

```typescript
public readonly groupByLabels: string[];
```

- *Type:* string[]

The labels by which incoming alerts are grouped together.

For example,
multiple alerts coming in for cluster=A and alertname=LatencyHigh would be
batched into a single group.

---

##### `groupInterval`<sup>Optional</sup> <a name="groupInterval" id="cdk-extensions.aps.DefaultRouteOptions.property.groupInterval"></a>

```typescript
public readonly groupInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to wait before sending a notification about new alerts that are added to a group of alerts for which an initial notification has already been sent (usually ~5m or more).

---

##### `groupWait`<sup>Optional</sup> <a name="groupWait" id="cdk-extensions.aps.DefaultRouteOptions.property.groupWait"></a>

```typescript
public readonly groupWait: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to initially wait to send a notification for a group of alerts.

Allows to wait for an inhibiting alert to arrive or collect more initial
alerts for the same group (usually ~0s to few minutes).

---

##### `matchers`<sup>Optional</sup> <a name="matchers" id="cdk-extensions.aps.DefaultRouteOptions.property.matchers"></a>

```typescript
public readonly matchers: AlertManagerMatcher[];
```

- *Type:* cdk-extensions.aps.AlertManagerMatcher[]

A list of matchers that an alert has to fulfill to match the node.

---

##### `repeatInterval`<sup>Optional</sup> <a name="repeatInterval" id="cdk-extensions.aps.DefaultRouteOptions.property.repeatInterval"></a>

```typescript
public readonly repeatInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

How long to wait before sending a notification again if it has already been sent successfully for an alert.

(Usually ~3h or more).

---

### DelimitedDeaggregationOptions <a name="DelimitedDeaggregationOptions" id="cdk-extensions.kinesis_firehose.DelimitedDeaggregationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.DelimitedDeaggregationOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const delimitedDeaggregationOptions: kinesis_firehose.DelimitedDeaggregationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DelimitedDeaggregationOptions.property.delimiter">delimiter</a></code> | <code>string</code> | *No description.* |

---

##### `delimiter`<sup>Required</sup> <a name="delimiter" id="cdk-extensions.kinesis_firehose.DelimitedDeaggregationOptions.property.delimiter"></a>

```typescript
public readonly delimiter: string;
```

- *Type:* string

---

### DeliveryStreamAttributes <a name="DeliveryStreamAttributes" id="cdk-extensions.kinesis_firehose.DeliveryStreamAttributes"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.DeliveryStreamAttributes.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const deliveryStreamAttributes: kinesis_firehose.DeliveryStreamAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamAttributes.property.deliveryStreamArn">deliveryStreamArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamAttributes.property.deliveryStreamName">deliveryStreamName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamAttributes.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |

---

##### `deliveryStreamArn`<sup>Optional</sup> <a name="deliveryStreamArn" id="cdk-extensions.kinesis_firehose.DeliveryStreamAttributes.property.deliveryStreamArn"></a>

```typescript
public readonly deliveryStreamArn: string;
```

- *Type:* string

---

##### `deliveryStreamName`<sup>Optional</sup> <a name="deliveryStreamName" id="cdk-extensions.kinesis_firehose.DeliveryStreamAttributes.property.deliveryStreamName"></a>

```typescript
public readonly deliveryStreamName: string;
```

- *Type:* string

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.DeliveryStreamAttributes.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

### DeliveryStreamDestinationConfiguration <a name="DeliveryStreamDestinationConfiguration" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const deliveryStreamDestinationConfiguration: kinesis_firehose.DeliveryStreamDestinationConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.amazonopensearchserviceDestinationConfiguration">amazonopensearchserviceDestinationConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.AmazonopensearchserviceDestinationConfigurationProperty</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.elasticsearchDestinationConfiguration">elasticsearchDestinationConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.ElasticsearchDestinationConfigurationProperty</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.extendedS3DestinationConfiguration">extendedS3DestinationConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.ExtendedS3DestinationConfigurationProperty</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.httpEndpointDestinationConfiguration">httpEndpointDestinationConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.HttpEndpointDestinationConfigurationProperty</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.redshiftDestinationConfiguration">redshiftDestinationConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.RedshiftDestinationConfigurationProperty</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.s3DestinationConfiguration">s3DestinationConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.S3DestinationConfigurationProperty</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.splunkDestinationConfiguration">splunkDestinationConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.SplunkDestinationConfigurationProperty</code> | *No description.* |

---

##### `amazonopensearchserviceDestinationConfiguration`<sup>Optional</sup> <a name="amazonopensearchserviceDestinationConfiguration" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.amazonopensearchserviceDestinationConfiguration"></a>

```typescript
public readonly amazonopensearchserviceDestinationConfiguration: AmazonopensearchserviceDestinationConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.AmazonopensearchserviceDestinationConfigurationProperty

---

##### `elasticsearchDestinationConfiguration`<sup>Optional</sup> <a name="elasticsearchDestinationConfiguration" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.elasticsearchDestinationConfiguration"></a>

```typescript
public readonly elasticsearchDestinationConfiguration: ElasticsearchDestinationConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.ElasticsearchDestinationConfigurationProperty

---

##### `extendedS3DestinationConfiguration`<sup>Optional</sup> <a name="extendedS3DestinationConfiguration" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.extendedS3DestinationConfiguration"></a>

```typescript
public readonly extendedS3DestinationConfiguration: ExtendedS3DestinationConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.ExtendedS3DestinationConfigurationProperty

---

##### `httpEndpointDestinationConfiguration`<sup>Optional</sup> <a name="httpEndpointDestinationConfiguration" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.httpEndpointDestinationConfiguration"></a>

```typescript
public readonly httpEndpointDestinationConfiguration: HttpEndpointDestinationConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.HttpEndpointDestinationConfigurationProperty

---

##### `redshiftDestinationConfiguration`<sup>Optional</sup> <a name="redshiftDestinationConfiguration" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.redshiftDestinationConfiguration"></a>

```typescript
public readonly redshiftDestinationConfiguration: RedshiftDestinationConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.RedshiftDestinationConfigurationProperty

---

##### `s3DestinationConfiguration`<sup>Optional</sup> <a name="s3DestinationConfiguration" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.s3DestinationConfiguration"></a>

```typescript
public readonly s3DestinationConfiguration: S3DestinationConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.S3DestinationConfigurationProperty

---

##### `splunkDestinationConfiguration`<sup>Optional</sup> <a name="splunkDestinationConfiguration" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestinationConfiguration.property.splunkDestinationConfiguration"></a>

```typescript
public readonly splunkDestinationConfiguration: SplunkDestinationConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.SplunkDestinationConfigurationProperty

---

### DeliveryStreamProcessorOptions <a name="DeliveryStreamProcessorOptions" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessorOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessorOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const deliveryStreamProcessorOptions: kinesis_firehose.DeliveryStreamProcessorOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProcessorOptions.property.processorType">processorType</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProcessorOptions.property.parameters">parameters</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `processorType`<sup>Required</sup> <a name="processorType" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessorOptions.property.processorType"></a>

```typescript
public readonly processorType: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessorOptions.property.parameters"></a>

```typescript
public readonly parameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

### DeliveryStreamProps <a name="DeliveryStreamProps" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const deliveryStreamProps: kinesis_firehose.DeliveryStreamProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.destination">destination</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamDestination</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.streamType">streamType</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamType</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `destination`<sup>Required</sup> <a name="destination" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.destination"></a>

```typescript
public readonly destination: DeliveryStreamDestination;
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamDestination

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `streamType`<sup>Optional</sup> <a name="streamType" id="cdk-extensions.kinesis_firehose.DeliveryStreamProps.property.streamType"></a>

```typescript
public readonly streamType: DeliveryStreamType;
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamType

---

### DomainOptions <a name="DomainOptions" id="cdk-extensions.route53.DomainOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.route53.DomainOptions.Initializer"></a>

```typescript
import { route53 } from 'cdk-extensions'

const domainOptions: route53.DomainOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.route53.DomainOptions.property.certificate">certificate</a></code> | <code>aws-cdk-lib.aws_certificatemanager.ICertificate</code> | *No description.* |
| <code><a href="#cdk-extensions.route53.DomainOptions.property.subdomain">subdomain</a></code> | <code>string</code> | *No description.* |

---

##### `certificate`<sup>Optional</sup> <a name="certificate" id="cdk-extensions.route53.DomainOptions.property.certificate"></a>

```typescript
public readonly certificate: ICertificate;
```

- *Type:* aws-cdk-lib.aws_certificatemanager.ICertificate

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk-extensions.route53.DomainOptions.property.subdomain"></a>

```typescript
public readonly subdomain: string;
```

- *Type:* string

---

### DynamicPartitioningConfiguration <a name="DynamicPartitioningConfiguration" id="cdk-extensions.kinesis_firehose.DynamicPartitioningConfiguration"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.DynamicPartitioningConfiguration.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const dynamicPartitioningConfiguration: kinesis_firehose.DynamicPartitioningConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DynamicPartitioningConfiguration.property.partitioningConfiguration">partitioningConfiguration</a></code> | <code>aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.DynamicPartitioningConfigurationProperty</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DynamicPartitioningConfiguration.property.processors">processors</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]</code> | *No description.* |

---

##### `partitioningConfiguration`<sup>Required</sup> <a name="partitioningConfiguration" id="cdk-extensions.kinesis_firehose.DynamicPartitioningConfiguration.property.partitioningConfiguration"></a>

```typescript
public readonly partitioningConfiguration: DynamicPartitioningConfigurationProperty;
```

- *Type:* aws-cdk-lib.aws_kinesisfirehose.CfnDeliveryStream.DynamicPartitioningConfigurationProperty

---

##### `processors`<sup>Optional</sup> <a name="processors" id="cdk-extensions.kinesis_firehose.DynamicPartitioningConfiguration.property.processors"></a>

```typescript
public readonly processors: DeliveryStreamProcessor[];
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]

---

### EchoserverProps <a name="EchoserverProps" id="cdk-extensions.k8s_aws.EchoserverProps"></a>

Configuration for the Echoserver resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.EchoserverProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const echoserverProps: k8s_aws.EchoserverProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS Cluster where the service should be deployed. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.domainDiscovery">domainDiscovery</a></code> | <code>cdk-extensions.route53.DomainDiscovery</code> | Determines the behavior of automatic DNS discovery and configuration. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.loadBalancerSubnets">loadBalancerSubnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | The subnets where the load balancer should be created. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.name">name</a></code> | <code>string</code> | The name of the Kubernetes service to be created. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be created. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.port">port</a></code> | <code>number</code> | The port which netcat should listen on. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.replicas">replicas</a></code> | <code>number</code> | The number of replicas that should exist. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.securityGroups">securityGroups</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup[]</code> | The Security groups which should be applied to the service. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.subdomain">subdomain</a></code> | <code>string</code> | A subdomain that should be prefixed to the beginning of all registered domains. |
| <code><a href="#cdk-extensions.k8s_aws.EchoserverProps.property.tag">tag</a></code> | <code>string</code> | The Docker tag specifying the version of echoserver to use. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.EchoserverProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.EchoserverProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.EchoserverProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.EchoserverProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.EchoserverProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS Cluster where the service should be deployed.

---

##### `domainDiscovery`<sup>Optional</sup> <a name="domainDiscovery" id="cdk-extensions.k8s_aws.EchoserverProps.property.domainDiscovery"></a>

```typescript
public readonly domainDiscovery: DomainDiscovery;
```

- *Type:* cdk-extensions.route53.DomainDiscovery
- *Default:* DomainDiscovery.PUBLIC

Determines the behavior of automatic DNS discovery and configuration.

---

##### `loadBalancerSubnets`<sup>Optional</sup> <a name="loadBalancerSubnets" id="cdk-extensions.k8s_aws.EchoserverProps.property.loadBalancerSubnets"></a>

```typescript
public readonly loadBalancerSubnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

The subnets where the load balancer should be created.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.k8s_aws.EchoserverProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* 'echoserver'

The name of the Kubernetes service to be created.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.EchoserverProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string
- *Default:* 'default'

The Kubernetes namespace where the service should be created.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk-extensions.k8s_aws.EchoserverProps.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* 80

The port which netcat should listen on.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk-extensions.k8s_aws.EchoserverProps.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number
- *Default:* 1

The number of replicas that should exist.

---

##### `securityGroups`<sup>Optional</sup> <a name="securityGroups" id="cdk-extensions.k8s_aws.EchoserverProps.property.securityGroups"></a>

```typescript
public readonly securityGroups: ISecurityGroup[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup[]

The Security groups which should be applied to the service.

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk-extensions.k8s_aws.EchoserverProps.property.subdomain"></a>

```typescript
public readonly subdomain: string;
```

- *Type:* string

A subdomain that should be prefixed to the beginning of all registered domains.

---

##### `tag`<sup>Optional</sup> <a name="tag" id="cdk-extensions.k8s_aws.EchoserverProps.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* string

The Docker tag specifying the version of echoserver to use.

> [[Google echoserver image repository](https://console.cloud.google.com/gcr/images/google-containers/GLOBAL/echoserver)]([Google echoserver image repository](https://console.cloud.google.com/gcr/images/google-containers/GLOBAL/echoserver))

---

### ExecutionLogOptions <a name="ExecutionLogOptions" id="cdk-extensions.lambda.ExecutionLogOptions"></a>

Options for configuring logging from an executing state machine.

#### Initializer <a name="Initializer" id="cdk-extensions.lambda.ExecutionLogOptions.Initializer"></a>

```typescript
import { lambda } from 'cdk-extensions'

const executionLogOptions: lambda.ExecutionLogOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.lambda.ExecutionLogOptions.property.includeExecutionData">includeExecutionData</a></code> | <code>boolean</code> | Determines whether execution data is included in your log. |
| <code><a href="#cdk-extensions.lambda.ExecutionLogOptions.property.level">level</a></code> | <code>aws-cdk-lib.aws_stepfunctions.LogLevel</code> | Defines which category of execution history events are logged. |
| <code><a href="#cdk-extensions.lambda.ExecutionLogOptions.property.enabled">enabled</a></code> | <code>boolean</code> | Controls whether logging from the state machine is enabled. |
| <code><a href="#cdk-extensions.lambda.ExecutionLogOptions.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | Specifies a log group which will receive execution events from the state machine. |
| <code><a href="#cdk-extensions.lambda.ExecutionLogOptions.property.retention">retention</a></code> | <code>aws-cdk-lib.aws_logs.RetentionDays</code> | The number of days execution logging events should be retained before being deleted. |

---

##### `includeExecutionData`<sup>Required</sup> <a name="includeExecutionData" id="cdk-extensions.lambda.ExecutionLogOptions.property.includeExecutionData"></a>

```typescript
public readonly includeExecutionData: boolean;
```

- *Type:* boolean
- *Default:* true

Determines whether execution data is included in your log.

When set to
`false`, data is excluded.

> [[StateMachine LoggingConfiguration.IncludeExecutionData](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-stepfunctions-statemachine-loggingconfiguration.html#cfn-stepfunctions-statemachine-loggingconfiguration-includeexecutiondata)]([StateMachine LoggingConfiguration.IncludeExecutionData](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-stepfunctions-statemachine-loggingconfiguration.html#cfn-stepfunctions-statemachine-loggingconfiguration-includeexecutiondata))

---

##### `level`<sup>Required</sup> <a name="level" id="cdk-extensions.lambda.ExecutionLogOptions.property.level"></a>

```typescript
public readonly level: LogLevel;
```

- *Type:* aws-cdk-lib.aws_stepfunctions.LogLevel
- *Default:* LogLevel.ALL

Defines which category of execution history events are logged.

> [[StateMachine LoggingConfiguration.Level](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-stepfunctions-statemachine-loggingconfiguration.html#cfn-stepfunctions-statemachine-loggingconfiguration-level)]([StateMachine LoggingConfiguration.Level](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-stepfunctions-statemachine-loggingconfiguration.html#cfn-stepfunctions-statemachine-loggingconfiguration-level))

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.lambda.ExecutionLogOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean
- *Default:* true

Controls whether logging from the state machine is enabled.

> [[StateMachine LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-stepfunctions-statemachine.html#cfn-stepfunctions-statemachine-loggingconfiguration)]([StateMachine LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-stepfunctions-statemachine.html#cfn-stepfunctions-statemachine-loggingconfiguration))

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.lambda.ExecutionLogOptions.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

Specifies a log group which will receive execution events from the state machine.

If no log group is passed and loggin is enabled, a log group will be
created automatically.

> [[StateMachine LoggingConfiguration.Destinations.CloudWatchLogsLogGroup.LogGroupArn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-stepfunctions-statemachine-cloudwatchlogsloggroup.html#cfn-stepfunctions-statemachine-cloudwatchlogsloggroup-loggrouparn)]([StateMachine LoggingConfiguration.Destinations.CloudWatchLogsLogGroup.LogGroupArn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-stepfunctions-statemachine-cloudwatchlogsloggroup.html#cfn-stepfunctions-statemachine-cloudwatchlogsloggroup-loggrouparn))

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.lambda.ExecutionLogOptions.property.retention"></a>

```typescript
public readonly retention: RetentionDays;
```

- *Type:* aws-cdk-lib.aws_logs.RetentionDays

The number of days execution logging events should be retained before being deleted.

This value is ignored if `logGroup` is passed.

> [[LogGroup RetentionInDays](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-logs-loggroup.html#cfn-logs-loggroup-retentionindays)]([LogGroup RetentionInDays](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-logs-loggroup.html#cfn-logs-loggroup-retentionindays))

---

### ExtendedS3DestinationOptions <a name="ExtendedS3DestinationOptions" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const extendedS3DestinationOptions: kinesis_firehose.ExtendedS3DestinationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.buffering">buffering</a></code> | <code>cdk-extensions.kinesis_firehose.BufferingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.cloudwatchLoggingConfiguration">cloudwatchLoggingConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.compressionFormat">compressionFormat</a></code> | <code>cdk-extensions.kinesis_firehose.S3CompressionFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.encryptionEnabled">encryptionEnabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.errorOutputPrefix">errorOutputPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.backupConfiguration">backupConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.BackupConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.dataFormatConversion">dataFormatConversion</a></code> | <code>cdk-extensions.kinesis_firehose.DataFormatConversion</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.dynamicPartitioning">dynamicPartitioning</a></code> | <code>cdk-extensions.kinesis_firehose.DynamicPartitioning</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.processorConfiguration">processorConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorConfiguration</code> | *No description.* |

---

##### `buffering`<sup>Optional</sup> <a name="buffering" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.buffering"></a>

```typescript
public readonly buffering: BufferingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BufferingConfiguration

---

##### `cloudwatchLoggingConfiguration`<sup>Optional</sup> <a name="cloudwatchLoggingConfiguration" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.cloudwatchLoggingConfiguration"></a>

```typescript
public readonly cloudwatchLoggingConfiguration: CloudWatchLoggingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration

---

##### `compressionFormat`<sup>Optional</sup> <a name="compressionFormat" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.compressionFormat"></a>

```typescript
public readonly compressionFormat: S3CompressionFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.S3CompressionFormat

---

##### `encryptionEnabled`<sup>Optional</sup> <a name="encryptionEnabled" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.encryptionEnabled"></a>

```typescript
public readonly encryptionEnabled: boolean;
```

- *Type:* boolean

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

---

##### `errorOutputPrefix`<sup>Optional</sup> <a name="errorOutputPrefix" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.errorOutputPrefix"></a>

```typescript
public readonly errorOutputPrefix: string;
```

- *Type:* string

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `backupConfiguration`<sup>Optional</sup> <a name="backupConfiguration" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.backupConfiguration"></a>

```typescript
public readonly backupConfiguration: BackupConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BackupConfiguration

---

##### `dataFormatConversion`<sup>Optional</sup> <a name="dataFormatConversion" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.dataFormatConversion"></a>

```typescript
public readonly dataFormatConversion: DataFormatConversion;
```

- *Type:* cdk-extensions.kinesis_firehose.DataFormatConversion

---

##### `dynamicPartitioning`<sup>Optional</sup> <a name="dynamicPartitioning" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.dynamicPartitioning"></a>

```typescript
public readonly dynamicPartitioning: DynamicPartitioning;
```

- *Type:* cdk-extensions.kinesis_firehose.DynamicPartitioning

---

##### `processorConfiguration`<sup>Optional</sup> <a name="processorConfiguration" id="cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions.property.processorConfiguration"></a>

```typescript
public readonly processorConfiguration: ProcessorConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorConfiguration

---

### ExternalDnsRegistryConfiguration <a name="ExternalDnsRegistryConfiguration" id="cdk-extensions.k8s_aws.ExternalDnsRegistryConfiguration"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.ExternalDnsRegistryConfiguration.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const externalDnsRegistryConfiguration: k8s_aws.ExternalDnsRegistryConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsRegistryConfiguration.property.registryType">registryType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsRegistryConfiguration.property.permissions">permissions</a></code> | <code>aws-cdk-lib.aws_iam.PolicyStatement[]</code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsRegistryConfiguration.property.properties">properties</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |

---

##### `registryType`<sup>Required</sup> <a name="registryType" id="cdk-extensions.k8s_aws.ExternalDnsRegistryConfiguration.property.registryType"></a>

```typescript
public readonly registryType: string;
```

- *Type:* string

---

##### `permissions`<sup>Optional</sup> <a name="permissions" id="cdk-extensions.k8s_aws.ExternalDnsRegistryConfiguration.property.permissions"></a>

```typescript
public readonly permissions: PolicyStatement[];
```

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement[]

---

##### `properties`<sup>Optional</sup> <a name="properties" id="cdk-extensions.k8s_aws.ExternalDnsRegistryConfiguration.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

### ExternalDnsZoneTag <a name="ExternalDnsZoneTag" id="cdk-extensions.k8s_aws.ExternalDnsZoneTag"></a>

Specifies a tag that can be used to restrict which Hosted Zone external-dns will have access to.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.ExternalDnsZoneTag.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const externalDnsZoneTag: k8s_aws.ExternalDnsZoneTag = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsZoneTag.property.key">key</a></code> | <code>string</code> | The name of the tag to filter on. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsZoneTag.property.value">value</a></code> | <code>string</code> | The value of the tag to filter on. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ExternalDnsZoneTag.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The name of the tag to filter on.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ExternalDnsZoneTag.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

The value of the tag to filter on.

---

### ExternalSecretOptions <a name="ExternalSecretOptions" id="cdk-extensions.k8s_aws.ExternalSecretOptions"></a>

Configuration options for adding a Kubernetes secret synced from an external provider to Kubernetes.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.ExternalSecretOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const externalSecretOptions: k8s_aws.ExternalSecretOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretOptions.property.fields">fields</a></code> | <code>cdk-extensions.k8s_aws.SecretFieldReference[]</code> | A collection of field mappings that tells the external secrets operator the structure of the Kubernetes secret to create and which how fields in the Kubernetes secret should map to fields in the secret from the external secret provider. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretOptions.property.name">name</a></code> | <code>string</code> | The name of the Kubernetes secret that will be created, as it will appear from within the Kubernetes cluster. |

---

##### `fields`<sup>Optional</sup> <a name="fields" id="cdk-extensions.k8s_aws.ExternalSecretOptions.property.fields"></a>

```typescript
public readonly fields: SecretFieldReference[];
```

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference[]
- *Default:* The Kubernetes secret will mirror the fields from the secret in the external provider.

A collection of field mappings that tells the external secrets operator the structure of the Kubernetes secret to create and which how fields in the Kubernetes secret should map to fields in the secret from the external secret provider.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.k8s_aws.ExternalSecretOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* A name will be auto-generated.

The name of the Kubernetes secret that will be created, as it will appear from within the Kubernetes cluster.

---

### ExternalSecretProps <a name="ExternalSecretProps" id="cdk-extensions.k8s_aws.ExternalSecretProps"></a>

Configuration for the ExternalSecret resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.ExternalSecretProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const externalSecretProps: k8s_aws.ExternalSecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the secret should be created. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.secretStore">secretStore</a></code> | <code>cdk-extensions.k8s_aws.ISecretStore</code> | The Kubernetes secret store resource that provides details and permissions to use for importing secrets from the provider. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.name">name</a></code> | <code>string</code> | The name to use for the Kubernetes secret resource when it is synchronized into the cluster. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.namespace">namespace</a></code> | <code>string</code> | The name where the synchronized secret should be created. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.refreshInterval">refreshInterval</a></code> | <code>aws-cdk-lib.Duration</code> | The frequency at which synchronization should occur. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretProps.property.secrets">secrets</a></code> | <code>cdk-extensions.k8s_aws.ISecretReference[]</code> | The secrets to synchronize into this Kubernetes secret. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the secret should be created.

---

##### `secretStore`<sup>Required</sup> <a name="secretStore" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.secretStore"></a>

```typescript
public readonly secretStore: ISecretStore;
```

- *Type:* cdk-extensions.k8s_aws.ISecretStore

The Kubernetes secret store resource that provides details and permissions to use for importing secrets from the provider.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name to use for the Kubernetes secret resource when it is synchronized into the cluster.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The name where the synchronized secret should be created.

---

##### `refreshInterval`<sup>Optional</sup> <a name="refreshInterval" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.refreshInterval"></a>

```typescript
public readonly refreshInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

The frequency at which synchronization should occur.

---

##### `secrets`<sup>Optional</sup> <a name="secrets" id="cdk-extensions.k8s_aws.ExternalSecretProps.property.secrets"></a>

```typescript
public readonly secrets: ISecretReference[];
```

- *Type:* cdk-extensions.k8s_aws.ISecretReference[]

The secrets to synchronize into this Kubernetes secret.

If multiple secrets are provided their fields will be merged.

---

### ExternalSecretsOperatorProps <a name="ExternalSecretsOperatorProps" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps"></a>

Configuration for the ExternalSecretsOperator resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const externalSecretsOperatorProps: k8s_aws.ExternalSecretsOperatorProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.Cluster</code> | The EKS cluster where the external secrets operator should be installed. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.createNamespace">createNamespace</a></code> | <code>boolean</code> | Determines the behavior when the service is deployed to a namespace that doesn't already exist on the EKS cluster. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the external secrets operator service should be installed and configured. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.cluster"></a>

```typescript
public readonly cluster: Cluster;
```

- *Type:* aws-cdk-lib.aws_eks.Cluster

The EKS cluster where the external secrets operator should be installed.

---

##### `createNamespace`<sup>Optional</sup> <a name="createNamespace" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.createNamespace"></a>

```typescript
public readonly createNamespace: boolean;
```

- *Type:* boolean
- *Default:* true

Determines the behavior when the service is deployed to a namespace that doesn't already exist on the EKS cluster.

When this flag is `true` and the namespace doesn't exist, the namespace
will be created automatically.

When this flag is `false` and the namespace doesn't exist, an error will
occur and resource creation will fail.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.ExternalSecretsOperatorProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string
- *Default:* {@link ExternalSecretsOperator.DEFAULT_NAMESPACE}

The Kubernetes namespace where the external secrets operator service should be installed and configured.

---

### ExternalSecretsOptions <a name="ExternalSecretsOptions" id="cdk-extensions.eks_patterns.ExternalSecretsOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.eks_patterns.ExternalSecretsOptions.Initializer"></a>

```typescript
import { eks_patterns } from 'cdk-extensions'

const externalSecretsOptions: eks_patterns.ExternalSecretsOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.eks_patterns.ExternalSecretsOptions.property.createNamespace">createNamespace</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.ExternalSecretsOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.ExternalSecretsOptions.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.eks_patterns.ExternalSecretsOptions.property.namespace">namespace</a></code> | <code>string</code> | *No description.* |

---

##### `createNamespace`<sup>Optional</sup> <a name="createNamespace" id="cdk-extensions.eks_patterns.ExternalSecretsOptions.property.createNamespace"></a>

```typescript
public readonly createNamespace: boolean;
```

- *Type:* boolean

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.eks_patterns.ExternalSecretsOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.eks_patterns.ExternalSecretsOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.eks_patterns.ExternalSecretsOptions.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

---

### FargateLoggerOptions <a name="FargateLoggerOptions" id="cdk-extensions.k8s_aws.FargateLoggerOptions"></a>

Optional configuration for the FargateLogger resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FargateLoggerOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fargateLoggerOptions: k8s_aws.FargateLoggerOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerOptions.property.fargateProfiles">fargateProfiles</a></code> | <code>aws-cdk-lib.aws_eks.FargateProfile[]</code> | A default list of Fargate profiles that should have permissions configured. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerOptions.property.filters">filters</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitFilterPlugin[]</code> | The filters that should be applied to logs being processed. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerOptions.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | The CloudWatch log group where Farget container logs will be sent. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerOptions.property.outputs">outputs</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitOutputPlugin[]</code> | The output destinations where logs should be written. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerOptions.property.parsers">parsers</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitParserPlugin[]</code> | The parsers to be used when reading log files. |

---

##### `fargateProfiles`<sup>Optional</sup> <a name="fargateProfiles" id="cdk-extensions.k8s_aws.FargateLoggerOptions.property.fargateProfiles"></a>

```typescript
public readonly fargateProfiles: FargateProfile[];
```

- *Type:* aws-cdk-lib.aws_eks.FargateProfile[]

A default list of Fargate profiles that should have permissions configured.

Alternatively profiles can be added at any time by calling
`addProfile`.

---

##### `filters`<sup>Optional</sup> <a name="filters" id="cdk-extensions.k8s_aws.FargateLoggerOptions.property.filters"></a>

```typescript
public readonly filters: IFluentBitFilterPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitFilterPlugin[]

The filters that should be applied to logs being processed.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.k8s_aws.FargateLoggerOptions.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The CloudWatch log group where Farget container logs will be sent.

---

##### `outputs`<sup>Optional</sup> <a name="outputs" id="cdk-extensions.k8s_aws.FargateLoggerOptions.property.outputs"></a>

```typescript
public readonly outputs: IFluentBitOutputPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitOutputPlugin[]

The output destinations where logs should be written.

---

##### `parsers`<sup>Optional</sup> <a name="parsers" id="cdk-extensions.k8s_aws.FargateLoggerOptions.property.parsers"></a>

```typescript
public readonly parsers: IFluentBitParserPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin[]

The parsers to be used when reading log files.

---

### FargateLoggerProps <a name="FargateLoggerProps" id="cdk-extensions.k8s_aws.FargateLoggerProps"></a>

Required configuration for the Fargate logger resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FargateLoggerProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fargateLoggerProps: k8s_aws.FargateLoggerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.fargateProfiles">fargateProfiles</a></code> | <code>aws-cdk-lib.aws_eks.FargateProfile[]</code> | A default list of Fargate profiles that should have permissions configured. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.filters">filters</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitFilterPlugin[]</code> | The filters that should be applied to logs being processed. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | The CloudWatch log group where Farget container logs will be sent. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.outputs">outputs</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitOutputPlugin[]</code> | The output destinations where logs should be written. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.parsers">parsers</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitParserPlugin[]</code> | The parsers to be used when reading log files. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.FargateLoggerProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS Cluster to configure Fargate logging for. |

---

##### `fargateProfiles`<sup>Optional</sup> <a name="fargateProfiles" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.fargateProfiles"></a>

```typescript
public readonly fargateProfiles: FargateProfile[];
```

- *Type:* aws-cdk-lib.aws_eks.FargateProfile[]

A default list of Fargate profiles that should have permissions configured.

Alternatively profiles can be added at any time by calling
`addProfile`.

---

##### `filters`<sup>Optional</sup> <a name="filters" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.filters"></a>

```typescript
public readonly filters: IFluentBitFilterPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitFilterPlugin[]

The filters that should be applied to logs being processed.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The CloudWatch log group where Farget container logs will be sent.

---

##### `outputs`<sup>Optional</sup> <a name="outputs" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.outputs"></a>

```typescript
public readonly outputs: IFluentBitOutputPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitOutputPlugin[]

The output destinations where logs should be written.

---

##### `parsers`<sup>Optional</sup> <a name="parsers" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.parsers"></a>

```typescript
public readonly parsers: IFluentBitParserPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin[]

The parsers to be used when reading log files.

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.FargateLoggerProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS Cluster to configure Fargate logging for.

---

### FlowLogDestinationConfig <a name="FlowLogDestinationConfig" id="cdk-extensions.ec2.FlowLogDestinationConfig"></a>

A configuration object providing the details necessary to set up log delivery to a given destination.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.FlowLogDestinationConfig.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const flowLogDestinationConfig: ec2.FlowLogDestinationConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogDestinationConfig.property.destinationType">destinationType</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogDestinationType</code> | The type of destination for the flow log data. |
| <code><a href="#cdk-extensions.ec2.FlowLogDestinationConfig.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | An S3 bucket where logs should be delivered. |
| <code><a href="#cdk-extensions.ec2.FlowLogDestinationConfig.property.destinationOptions">destinationOptions</a></code> | <code>{[ key: string ]: any}</code> | Additional options that control the format and behavior of logs delivered to the destination. |
| <code><a href="#cdk-extensions.ec2.FlowLogDestinationConfig.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | A CloudWatch LogGroup where logs should be delivered. |
| <code><a href="#cdk-extensions.ec2.FlowLogDestinationConfig.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | The ARN of the IAM role that allows Amazon EC2 to publish flow logs in your account. |
| <code><a href="#cdk-extensions.ec2.FlowLogDestinationConfig.property.s3Path">s3Path</a></code> | <code>string</code> | An Amazon Resource Name (ARN) for the S3 destination where log files are to be delivered. |

---

##### `destinationType`<sup>Required</sup> <a name="destinationType" id="cdk-extensions.ec2.FlowLogDestinationConfig.property.destinationType"></a>

```typescript
public readonly destinationType: FlowLogDestinationType;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogDestinationType

The type of destination for the flow log data.

> [[FlowLog LogDestinationType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestinationtype)]([FlowLog LogDestinationType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestinationtype))

---

##### `bucket`<sup>Optional</sup> <a name="bucket" id="cdk-extensions.ec2.FlowLogDestinationConfig.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

An S3 bucket where logs should be delivered.

> [[FlowLog LogDestination](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestination)]([FlowLog LogDestination](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestination))

---

##### `destinationOptions`<sup>Optional</sup> <a name="destinationOptions" id="cdk-extensions.ec2.FlowLogDestinationConfig.property.destinationOptions"></a>

```typescript
public readonly destinationOptions: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Additional options that control the format and behavior of logs delivered to the destination.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.ec2.FlowLogDestinationConfig.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

A CloudWatch LogGroup where logs should be delivered.

> [[FlowLog LogDestination](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestination)]([FlowLog LogDestination](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestination))

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.ec2.FlowLogDestinationConfig.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

The ARN of the IAM role that allows Amazon EC2 to publish flow logs in your account.

> [[FlowLog DeliverLogsPermissionArn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-deliverlogspermissionarn)]([FlowLog DeliverLogsPermissionArn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-deliverlogspermissionarn))

---

##### `s3Path`<sup>Optional</sup> <a name="s3Path" id="cdk-extensions.ec2.FlowLogDestinationConfig.property.s3Path"></a>

```typescript
public readonly s3Path: string;
```

- *Type:* string

An Amazon Resource Name (ARN) for the S3 destination where log files are to be delivered.

If a custom prefix is being added the ARN should reflect that prefix.

> [[FlowLog LogDestination](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestination)]([FlowLog LogDestination](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestination))

---

### FlowLogOptions <a name="FlowLogOptions" id="cdk-extensions.ec2_patterns.FlowLogOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.FlowLogOptions.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const flowLogOptions: ec2_patterns.FlowLogOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FlowLogOptions.property.destination">destination</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogDestination</code> | Specifies the type of destination to which the flow log data is to be published. |
| <code><a href="#cdk-extensions.ec2_patterns.FlowLogOptions.property.logFormat">logFormat</a></code> | <code>aws-cdk-lib.aws_ec2.LogFormat[]</code> | The fields to include in the flow log record, in the order in which they should appear. |
| <code><a href="#cdk-extensions.ec2_patterns.FlowLogOptions.property.maxAggregationInterval">maxAggregationInterval</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogMaxAggregationInterval</code> | The maximum interval of time during which a flow of packets is captured and aggregated into a flow log record. |
| <code><a href="#cdk-extensions.ec2_patterns.FlowLogOptions.property.trafficType">trafficType</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogTrafficType</code> | The type of traffic to log. |
| <code><a href="#cdk-extensions.ec2_patterns.FlowLogOptions.property.logFormatDefinition">logFormatDefinition</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | *No description.* |

---

##### `destination`<sup>Optional</sup> <a name="destination" id="cdk-extensions.ec2_patterns.FlowLogOptions.property.destination"></a>

```typescript
public readonly destination: FlowLogDestination;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogDestination
- *Default:* FlowLogDestinationType.toCloudWatchLogs()

Specifies the type of destination to which the flow log data is to be published.

Flow log data can be published to CloudWatch Logs or Amazon S3

---

##### `logFormat`<sup>Optional</sup> <a name="logFormat" id="cdk-extensions.ec2_patterns.FlowLogOptions.property.logFormat"></a>

```typescript
public readonly logFormat: LogFormat[];
```

- *Type:* aws-cdk-lib.aws_ec2.LogFormat[]
- *Default:* default log format is used.

The fields to include in the flow log record, in the order in which they should appear.

If multiple fields are specified, they will be separated by spaces. For full control over the literal log format
string, pass a single field constructed with `LogFormat.custom()`.

See https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs.html#flow-log-records

---

##### `maxAggregationInterval`<sup>Optional</sup> <a name="maxAggregationInterval" id="cdk-extensions.ec2_patterns.FlowLogOptions.property.maxAggregationInterval"></a>

```typescript
public readonly maxAggregationInterval: FlowLogMaxAggregationInterval;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogMaxAggregationInterval
- *Default:* FlowLogMaxAggregationInterval.TEN_MINUTES

The maximum interval of time during which a flow of packets is captured and aggregated into a flow log record.

---

##### `trafficType`<sup>Optional</sup> <a name="trafficType" id="cdk-extensions.ec2_patterns.FlowLogOptions.property.trafficType"></a>

```typescript
public readonly trafficType: FlowLogTrafficType;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogTrafficType
- *Default:* ALL

The type of traffic to log.

You can log traffic that the resource accepts or rejects, or all traffic.

---

##### `logFormatDefinition`<sup>Optional</sup> <a name="logFormatDefinition" id="cdk-extensions.ec2_patterns.FlowLogOptions.property.logFormatDefinition"></a>

```typescript
public readonly logFormatDefinition: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

---

### FlowLogProps <a name="FlowLogProps" id="cdk-extensions.ec2.FlowLogProps"></a>

Configuration for the FlowLog class.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.FlowLogProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const flowLogProps: ec2.FlowLogProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.resourceType">resourceType</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogResourceType</code> | Details for the resource from which flow logs will be captured. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.destination">destination</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogDestination</code> | The location where flow logs should be delivered. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.flowLogName">flowLogName</a></code> | <code>string</code> | The name of the FlowLog. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.logFormat">logFormat</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | The fields to include in the flow log record, in the order in which they should appear. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.maxAggregationInterval">maxAggregationInterval</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogMaxAggregationInterval</code> | The maximum interval of time during which a flow of packets is captured and aggregated into a flow log record. |
| <code><a href="#cdk-extensions.ec2.FlowLogProps.property.trafficType">trafficType</a></code> | <code>aws-cdk-lib.aws_ec2.FlowLogTrafficType</code> | The type of traffic to monitor (accepted traffic, rejected traffic, or all traffic). |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.FlowLogProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.FlowLogProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.FlowLogProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.FlowLogProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk-extensions.ec2.FlowLogProps.property.resourceType"></a>

```typescript
public readonly resourceType: FlowLogResourceType;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogResourceType

Details for the resource from which flow logs will be captured.

> [[FlowLog ResourceType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-resourcetype)]([FlowLog ResourceType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-resourcetype))

---

##### `destination`<sup>Optional</sup> <a name="destination" id="cdk-extensions.ec2.FlowLogProps.property.destination"></a>

```typescript
public readonly destination: FlowLogDestination;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogDestination

The location where flow logs should be delivered.

> [[FlowLog LogDestinationType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestinationtype)]([FlowLog LogDestinationType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestinationtype))

---

##### `flowLogName`<sup>Optional</sup> <a name="flowLogName" id="cdk-extensions.ec2.FlowLogProps.property.flowLogName"></a>

```typescript
public readonly flowLogName: string;
```

- *Type:* string

The name of the FlowLog.

---

##### `logFormat`<sup>Optional</sup> <a name="logFormat" id="cdk-extensions.ec2.FlowLogProps.property.logFormat"></a>

```typescript
public readonly logFormat: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

The fields to include in the flow log record, in the order in which they should appear.

For a list of available fields, see {@link FlowLogField}.

> [[FlowLog LogFormat](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logformat)]([FlowLog LogFormat](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logformat))

---

##### `maxAggregationInterval`<sup>Optional</sup> <a name="maxAggregationInterval" id="cdk-extensions.ec2.FlowLogProps.property.maxAggregationInterval"></a>

```typescript
public readonly maxAggregationInterval: FlowLogMaxAggregationInterval;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogMaxAggregationInterval

The maximum interval of time during which a flow of packets is captured and aggregated into a flow log record.

> [[FlowLog MaxAggregationInterval](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-maxaggregationinterval)]([FlowLog MaxAggregationInterval](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-maxaggregationinterval))

---

##### `trafficType`<sup>Optional</sup> <a name="trafficType" id="cdk-extensions.ec2.FlowLogProps.property.trafficType"></a>

```typescript
public readonly trafficType: FlowLogTrafficType;
```

- *Type:* aws-cdk-lib.aws_ec2.FlowLogTrafficType

The type of traffic to monitor (accepted traffic, rejected traffic, or all traffic).

> [[FlowLog TrafficType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-traffictype)]([FlowLog TrafficType](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-traffictype))

---

### FlowLogS3Options <a name="FlowLogS3Options" id="cdk-extensions.ec2.FlowLogS3Options"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.FlowLogS3Options.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const flowLogS3Options: ec2.FlowLogS3Options = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogS3Options.property.fileFormat">fileFormat</a></code> | <code>cdk-extensions.ec2.FlowLogFileFormat</code> | The file format in which flow logs should be delivered to S3. |
| <code><a href="#cdk-extensions.ec2.FlowLogS3Options.property.hiveCompatiblePartitions">hiveCompatiblePartitions</a></code> | <code>boolean</code> | Controls the format of partitions ("folders") when the flow logs are delivered to S3. |
| <code><a href="#cdk-extensions.ec2.FlowLogS3Options.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | An optional prefix that will be added to the start of all flow log files delivered to the S3 bucket. |
| <code><a href="#cdk-extensions.ec2.FlowLogS3Options.property.perHourPartition">perHourPartition</a></code> | <code>boolean</code> | Indicates whether to partition the flow log per hour. |

---

##### `fileFormat`<sup>Optional</sup> <a name="fileFormat" id="cdk-extensions.ec2.FlowLogS3Options.property.fileFormat"></a>

```typescript
public readonly fileFormat: FlowLogFileFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFileFormat

The file format in which flow logs should be delivered to S3.

> [[Flow log files](https://docs.aws.amazon.com/vpc/latest/tgw/flow-logs-s3.html#flow-logs-s3-path)]([Flow log files](https://docs.aws.amazon.com/vpc/latest/tgw/flow-logs-s3.html#flow-logs-s3-path))

---

##### `hiveCompatiblePartitions`<sup>Optional</sup> <a name="hiveCompatiblePartitions" id="cdk-extensions.ec2.FlowLogS3Options.property.hiveCompatiblePartitions"></a>

```typescript
public readonly hiveCompatiblePartitions: boolean;
```

- *Type:* boolean

Controls the format of partitions ("folders") when the flow logs are delivered to S3.

By default, flow logs are delivered partitioned such that each part of
the S3 path represents a values pertaining to details of the log.

When hive compatible partitions are enabled, partitions will be
structured such that keys declaring the partition name are added at
each level.

An example of standard partitioning:
```
/us-east-1/2020/03/08/log.tar.gz
```

An example with Hive compatible partitions:
```
/region=us-east-1/year=2020/month=03/day=08/log.tar.gz
```

> [[AWS Big Data Blog](https://aws.amazon.com/blogs/big-data/optimize-performance-and-reduce-costs-for-network-analytics-with-vpc-flow-logs-in-apache-parquet-format/)]([AWS Big Data Blog](https://aws.amazon.com/blogs/big-data/optimize-performance-and-reduce-costs-for-network-analytics-with-vpc-flow-logs-in-apache-parquet-format/))

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk-extensions.ec2.FlowLogS3Options.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string

An optional prefix that will be added to the start of all flow log files delivered to the S3 bucket.

> [[FlowLog LogDestination](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestination)]([FlowLog LogDestination](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-flowlog.html#cfn-ec2-flowlog-logdestination))

---

##### `perHourPartition`<sup>Optional</sup> <a name="perHourPartition" id="cdk-extensions.ec2.FlowLogS3Options.property.perHourPartition"></a>

```typescript
public readonly perHourPartition: boolean;
```

- *Type:* boolean

Indicates whether to partition the flow log per hour.

By default, flow logs are partitioned (organized into S3 "folders") by
day.

Setting this to true will add an extra layer of directories splitting
flow log files by the hour in which they were delivered.

> [[Flow log files](https://docs.aws.amazon.com/vpc/latest/tgw/flow-logs-s3.html#flow-logs-s3-path)]([Flow log files](https://docs.aws.amazon.com/vpc/latest/tgw/flow-logs-s3.html#flow-logs-s3-path))

---

### FlowLogsBucketProps <a name="FlowLogsBucketProps" id="cdk-extensions.s3_buckets.FlowLogsBucketProps"></a>

Configuration for objects bucket.

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const flowLogsBucketProps: s3_buckets.FlowLogsBucketProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.bucketName">bucketName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.crawlerSchedule">crawlerSchedule</a></code> | <code>aws-cdk-lib.aws_events.Schedule</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.format">format</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.FlowLogsBucketProps.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucketName`<sup>Optional</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

---

##### `crawlerSchedule`<sup>Optional</sup> <a name="crawlerSchedule" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.crawlerSchedule"></a>

```typescript
public readonly crawlerSchedule: Schedule;
```

- *Type:* aws-cdk-lib.aws_events.Schedule

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `format`<sup>Optional</sup> <a name="format" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.format"></a>

```typescript
public readonly format: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---

##### `tableName`<sup>Optional</sup> <a name="tableName" id="cdk-extensions.s3_buckets.FlowLogsBucketProps.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

### FlowLogsTableProps <a name="FlowLogsTableProps" id="cdk-extensions.glue_tables.FlowLogsTableProps"></a>

Configuration for FlowLogsTable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue_tables.FlowLogsTableProps.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

const flowLogsTableProps: glue_tables.FlowLogsTableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | A bucket where logs will be stored. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the Flow Logs. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.format">format</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | A cdk-extentions/ec2 {@link aws-ec2!FlowLogFormat } object defining the desired formatting for Flow Logs. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.name">name</a></code> | <code>string</code> | Name for Flow Logs Table. |
| <code><a href="#cdk-extensions.glue_tables.FlowLogsTableProps.property.s3Prefix">s3Prefix</a></code> | <code>string</code> | Set a custom prefix for the S3 Bucket. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

A bucket where logs will be stored.

> [[AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html)]([AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html))

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in.

> [[AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html)]([AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html))

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the Flow Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `format`<sup>Optional</sup> <a name="format" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.format"></a>

```typescript
public readonly format: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

A cdk-extentions/ec2 {@link aws-ec2!FlowLogFormat } object defining the desired formatting for Flow Logs.

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name for Flow Logs Table.

---

##### `s3Prefix`<sup>Optional</sup> <a name="s3Prefix" id="cdk-extensions.glue_tables.FlowLogsTableProps.property.s3Prefix"></a>

```typescript
public readonly s3Prefix: string;
```

- *Type:* string

Set a custom prefix for the S3 Bucket.

---

### FluentBitCloudWatchLogsOutputOptions <a name="FluentBitCloudWatchLogsOutputOptions" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions"></a>

Options for configuring the CloudWatch Logs Fluent Bit output plugin.

> [[CloudWatch Logs Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/cloudwatch)]([CloudWatch Logs Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/cloudwatch))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitCloudWatchLogsOutputOptions: k8s_aws.FluentBitCloudWatchLogsOutputOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.autoCreateGroup">autoCreateGroup</a></code> | <code>boolean</code> | Automatically create the log group. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.autoRetryRequests">autoRetryRequests</a></code> | <code>boolean</code> | Immediately retry failed requests to AWS services once. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.endpoint">endpoint</a></code> | <code>string</code> | Specify a custom endpoint for the CloudWatch Logs API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logFormat">logFormat</a></code> | <code>string</code> | An optional parameter that can be used to tell CloudWatch the format of the data. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logGroup">logGroup</a></code> | <code>cdk-extensions.k8s_aws.FluentBitLogGroupOutput</code> | The CloudWatch Log Group configuration for output records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logGroupTemplate">logGroupTemplate</a></code> | <code>string</code> | Template for Log Group name using Fluent Bit record_accessor syntax. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logKey">logKey</a></code> | <code>string</code> | By default, the whole log record will be sent to CloudWatch. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logRetention">logRetention</a></code> | <code>aws-cdk-lib.aws_logs.RetentionDays</code> | If set to a number greater than zero, and newly create log group's retention policy is set to this many days. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logStream">logStream</a></code> | <code>cdk-extensions.k8s_aws.FluentBitLogStreamOutput</code> | The CloudWatch LogStream configuration for outbound records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logStreamTemplate">logStreamTemplate</a></code> | <code>string</code> | Template for Log Stream name using Fluent Bit record accessor syntax. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.metricDimensions">metricDimensions</a></code> | <code>string[]</code> | A list of lists containing the dimension keys that will be applied to all metrics. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.metricNamespace">metricNamespace</a></code> | <code>string</code> | An optional string representing the CloudWatch namespace for the metrics. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.region">region</a></code> | <code>string</code> | The AWS region. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | ARN of an IAM role to assume (for cross account access). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.stsEndpoint">stsEndpoint</a></code> | <code>string</code> | Specify a custom STS endpoint for the AWS STS API. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `autoCreateGroup`<sup>Optional</sup> <a name="autoCreateGroup" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.autoCreateGroup"></a>

```typescript
public readonly autoCreateGroup: boolean;
```

- *Type:* boolean
- *Default:* false

Automatically create the log group.

---

##### `autoRetryRequests`<sup>Optional</sup> <a name="autoRetryRequests" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.autoRetryRequests"></a>

```typescript
public readonly autoRetryRequests: boolean;
```

- *Type:* boolean
- *Default:* true

Immediately retry failed requests to AWS services once.

This option does
not affect the normal Fluent Bit retry mechanism with backoff. Instead,
it enables an immediate retry with no delay for networking errors, which
may help improve throughput when there are transient/random networking
issues.

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

Specify a custom endpoint for the CloudWatch Logs API.

---

##### `logFormat`<sup>Optional</sup> <a name="logFormat" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logFormat"></a>

```typescript
public readonly logFormat: string;
```

- *Type:* string

An optional parameter that can be used to tell CloudWatch the format of the data.

A value of json/emf enables CloudWatch to extract custom
metrics embedded in a JSON payload.

> [[Embedded Metric Format](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CloudWatch_Embedded_Metric_Format_Specification.html)]([Embedded Metric Format](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CloudWatch_Embedded_Metric_Format_Specification.html))

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logGroup"></a>

```typescript
public readonly logGroup: FluentBitLogGroupOutput;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitLogGroupOutput

The CloudWatch Log Group configuration for output records.

---

##### `logGroupTemplate`<sup>Optional</sup> <a name="logGroupTemplate" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logGroupTemplate"></a>

```typescript
public readonly logGroupTemplate: string;
```

- *Type:* string

Template for Log Group name using Fluent Bit record_accessor syntax.

This field is optional and if configured it overrides the configured Log
Group.

If the template translation fails, an error is logged and the provided
Log Group (which is still required) is used instead.

> [[Fluent Bit record accessor snytax](https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/record-accessor)]([Fluent Bit record accessor snytax](https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/record-accessor))

---

##### `logKey`<sup>Optional</sup> <a name="logKey" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logKey"></a>

```typescript
public readonly logKey: string;
```

- *Type:* string

By default, the whole log record will be sent to CloudWatch.

If you
specify a key name with this option, then only the value of that key
will be sent to CloudWatch.

---

##### `logRetention`<sup>Optional</sup> <a name="logRetention" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logRetention"></a>

```typescript
public readonly logRetention: RetentionDays;
```

- *Type:* aws-cdk-lib.aws_logs.RetentionDays

If set to a number greater than zero, and newly create log group's retention policy is set to this many days.

---

##### `logStream`<sup>Optional</sup> <a name="logStream" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logStream"></a>

```typescript
public readonly logStream: FluentBitLogStreamOutput;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitLogStreamOutput

The CloudWatch LogStream configuration for outbound records.

---

##### `logStreamTemplate`<sup>Optional</sup> <a name="logStreamTemplate" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.logStreamTemplate"></a>

```typescript
public readonly logStreamTemplate: string;
```

- *Type:* string

Template for Log Stream name using Fluent Bit record accessor syntax.

This field is optional and if configured it overrides the other log
stream options. If the template translation fails, an error is logged
and the logStream or logStreamPrefix are used instead (and thus one of
those fields is still required to be configured).

> [[Fluent Bit record accessor snytax](https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/record-accessor)]([Fluent Bit record accessor snytax](https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/record-accessor))

---

##### `metricDimensions`<sup>Optional</sup> <a name="metricDimensions" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.metricDimensions"></a>

```typescript
public readonly metricDimensions: string[];
```

- *Type:* string[]

A list of lists containing the dimension keys that will be applied to all metrics.

The values within a dimension set MUST also be members on
the root-node.

> [[Dimensions](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/cloudwatch_concepts.html#Dimension)]([Dimensions](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/cloudwatch_concepts.html#Dimension))

---

##### `metricNamespace`<sup>Optional</sup> <a name="metricNamespace" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.metricNamespace"></a>

```typescript
public readonly metricNamespace: string;
```

- *Type:* string

An optional string representing the CloudWatch namespace for the metrics.

> [[Metric Tutorial](https://docs.fluentbit.io/manual/pipeline/outputs/cloudwatch#metrics-tutorial)]([Metric Tutorial](https://docs.fluentbit.io/manual/pipeline/outputs/cloudwatch#metrics-tutorial))

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

The AWS region.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

ARN of an IAM role to assume (for cross account access).

---

##### `stsEndpoint`<sup>Optional</sup> <a name="stsEndpoint" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions.property.stsEndpoint"></a>

```typescript
public readonly stsEndpoint: string;
```

- *Type:* string

Specify a custom STS endpoint for the AWS STS API.

---

### FluentBitElasticsearchOutputOptions <a name="FluentBitElasticsearchOutputOptions" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions"></a>

Options for configuring the Elasticsearch Fluent Bit output plugin.

> [[Opensearch Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/elasticsearch)]([Opensearch Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/elasticsearch))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitElasticsearchOutputOptions: k8s_aws.FluentBitElasticsearchOutputOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.host">host</a></code> | <code>string</code> | IP address or hostname of the target Elasticsearch instance. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsAuth">awsAuth</a></code> | <code>boolean</code> | Enable AWS Sigv4 Authentication for Amazon Elasticsearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsExternalId">awsExternalId</a></code> | <code>string</code> | External ID for the AWS IAM Role specified with `awsRole`. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsRegion">awsRegion</a></code> | <code>string</code> | Specify the AWS region for Elasticsearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsRole">awsRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | AWS IAM Role to assume to put records to your Amazon cluster. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsStsEndpoint">awsStsEndpoint</a></code> | <code>string</code> | Specify the custom sts endpoint to be used with STS API for Amazon Elasticsearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.bufferSize">bufferSize</a></code> | <code>cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize</code> | Specify the buffer size used to read the response from the Elasticsearch HTTP service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.cloudAuth">cloudAuth</a></code> | <code>string</code> | Specify the credentials to use to connect to Elastic's Elasticsearch Service running on Elastic Cloud. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.cloudId">cloudId</a></code> | <code>string</code> | If you are using Elastic's Elasticsearch Service you can specify the cloud_id of the cluster running. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.compress">compress</a></code> | <code>cdk-extensions.k8s_aws.ElasticsearchCompressionFormat</code> | Set payload compression mechanism. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.currentTimeIndex">currentTimeIndex</a></code> | <code>boolean</code> | Use current time for index generation instead of message record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.generateId">generateId</a></code> | <code>boolean</code> | When enabled, generate `_id` for outgoing records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.httpPasswd">httpPasswd</a></code> | <code>string</code> | Password for user defined in `httpUser`. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.httpUser">httpUser</a></code> | <code>string</code> | Optional username credential for access. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.idKey">idKey</a></code> | <code>string</code> | If set, `_id` will be the value of the key from incoming record and `generateId` option is ignored. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.includeTagKey">includeTagKey</a></code> | <code>boolean</code> | When enabled, it append the Tag name to the record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.index">index</a></code> | <code>string</code> | Index name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.logstashDateFormat">logstashDateFormat</a></code> | <code>string</code> | Time format (based on strftime) to generate the second part of the Index name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.logstashFormat">logstashFormat</a></code> | <code>boolean</code> | Enable Logstash format compatibility. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.logstashPrefix">logstashPrefix</a></code> | <code>string</code> | When `logstashFormat` is enabled, the Index name is composed using a prefix and the date, e.g: If `logstashPrefix` is equals to 'mydata' your index will become 'mydata-YYYY.MM.DD'. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.logstashPrefixKey">logstashPrefixKey</a></code> | <code>string</code> | When included: the value in the record that belongs to the key will be looked up and over-write the `logstashPrefix` for index generation. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.path">path</a></code> | <code>string</code> | Elasticsearch accepts new data on HTTP query path "/_bulk". |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.pipeline">pipeline</a></code> | <code>string</code> | Elasticsearch allows to setup filters called pipelines. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.port">port</a></code> | <code>number</code> | TCP port of the target Elasticsearch instance. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.replaceDots">replaceDots</a></code> | <code>boolean</code> | When enabled, replace field name dots with underscore. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.suppressTypeName">suppressTypeName</a></code> | <code>boolean</code> | When enabled, mapping types is removed and `type` option is ignored. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.tagKey">tagKey</a></code> | <code>string</code> | When `includeTagKey` is enabled, this property defines the key name for the tag. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.timeKey">timeKey</a></code> | <code>string</code> | When `logstashFormat` is enabled, each record will get a new timestamp field. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.timeKeyFormat">timeKeyFormat</a></code> | <code>string</code> | When `logstashFormat` is enabled, this property defines the format of the timestamp. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.timeKeyNanos">timeKeyNanos</a></code> | <code>boolean</code> | When `logstashFormat` is enabled, enabling this property sends nanosecond precision timestamps. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.traceError">traceError</a></code> | <code>boolean</code> | When enabled print the Elasticsearch API calls to stdout when Elasticsearch returns an error (for diag only). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.traceOutput">traceOutput</a></code> | <code>boolean</code> | When enabled print the Elasticsearch API calls to stdout (for diag only). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.type">type</a></code> | <code>string</code> | Type name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.workers">workers</a></code> | <code>number</code> | Enables dedicated thread(s) for this output. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.writeOperation">writeOperation</a></code> | <code>string</code> | Operation to use to write in bulk requests. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `host`<sup>Required</sup> <a name="host" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

IP address or hostname of the target Elasticsearch instance.

---

##### `awsAuth`<sup>Optional</sup> <a name="awsAuth" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsAuth"></a>

```typescript
public readonly awsAuth: boolean;
```

- *Type:* boolean
- *Default:* false

Enable AWS Sigv4 Authentication for Amazon Elasticsearch Service.

---

##### `awsExternalId`<sup>Optional</sup> <a name="awsExternalId" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsExternalId"></a>

```typescript
public readonly awsExternalId: string;
```

- *Type:* string

External ID for the AWS IAM Role specified with `awsRole`.

---

##### `awsRegion`<sup>Optional</sup> <a name="awsRegion" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsRegion"></a>

```typescript
public readonly awsRegion: string;
```

- *Type:* string

Specify the AWS region for Elasticsearch Service.

---

##### `awsRole`<sup>Optional</sup> <a name="awsRole" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsRole"></a>

```typescript
public readonly awsRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

AWS IAM Role to assume to put records to your Amazon cluster.

---

##### `awsStsEndpoint`<sup>Optional</sup> <a name="awsStsEndpoint" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.awsStsEndpoint"></a>

```typescript
public readonly awsStsEndpoint: string;
```

- *Type:* string

Specify the custom sts endpoint to be used with STS API for Amazon Elasticsearch Service.

---

##### `bufferSize`<sup>Optional</sup> <a name="bufferSize" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.bufferSize"></a>

```typescript
public readonly bufferSize: ElasticsearchOutputBufferSize;
```

- *Type:* cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize

Specify the buffer size used to read the response from the Elasticsearch HTTP service.

This option is useful for debugging purposes where is
required to read full responses, note that response size grows depending
of the number of records inserted.

---

##### `cloudAuth`<sup>Optional</sup> <a name="cloudAuth" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.cloudAuth"></a>

```typescript
public readonly cloudAuth: string;
```

- *Type:* string

Specify the credentials to use to connect to Elastic's Elasticsearch Service running on Elastic Cloud.

---

##### `cloudId`<sup>Optional</sup> <a name="cloudId" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

If you are using Elastic's Elasticsearch Service you can specify the cloud_id of the cluster running.

---

##### `compress`<sup>Optional</sup> <a name="compress" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.compress"></a>

```typescript
public readonly compress: ElasticsearchCompressionFormat;
```

- *Type:* cdk-extensions.k8s_aws.ElasticsearchCompressionFormat

Set payload compression mechanism.

---

##### `currentTimeIndex`<sup>Optional</sup> <a name="currentTimeIndex" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.currentTimeIndex"></a>

```typescript
public readonly currentTimeIndex: boolean;
```

- *Type:* boolean
- *Default:* false

Use current time for index generation instead of message record.

---

##### `generateId`<sup>Optional</sup> <a name="generateId" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.generateId"></a>

```typescript
public readonly generateId: boolean;
```

- *Type:* boolean

When enabled, generate `_id` for outgoing records.

This prevents duplicate
records when retrying.

---

##### `httpPasswd`<sup>Optional</sup> <a name="httpPasswd" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.httpPasswd"></a>

```typescript
public readonly httpPasswd: string;
```

- *Type:* string

Password for user defined in `httpUser`.

---

##### `httpUser`<sup>Optional</sup> <a name="httpUser" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.httpUser"></a>

```typescript
public readonly httpUser: string;
```

- *Type:* string

Optional username credential for access.

---

##### `idKey`<sup>Optional</sup> <a name="idKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.idKey"></a>

```typescript
public readonly idKey: string;
```

- *Type:* string

If set, `_id` will be the value of the key from incoming record and `generateId` option is ignored.

---

##### `includeTagKey`<sup>Optional</sup> <a name="includeTagKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.includeTagKey"></a>

```typescript
public readonly includeTagKey: boolean;
```

- *Type:* boolean

When enabled, it append the Tag name to the record.

---

##### `index`<sup>Optional</sup> <a name="index" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* string
- *Default:* 'fluent-bit

Index name.

---

##### `logstashDateFormat`<sup>Optional</sup> <a name="logstashDateFormat" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.logstashDateFormat"></a>

```typescript
public readonly logstashDateFormat: string;
```

- *Type:* string
- *Default:* '%Y.%m.%d'

Time format (based on strftime) to generate the second part of the Index name.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `logstashFormat`<sup>Optional</sup> <a name="logstashFormat" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.logstashFormat"></a>

```typescript
public readonly logstashFormat: boolean;
```

- *Type:* boolean
- *Default:* false

Enable Logstash format compatibility.

---

##### `logstashPrefix`<sup>Optional</sup> <a name="logstashPrefix" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.logstashPrefix"></a>

```typescript
public readonly logstashPrefix: string;
```

- *Type:* string
- *Default:* 'logstash'

When `logstashFormat` is enabled, the Index name is composed using a prefix and the date, e.g: If `logstashPrefix` is equals to 'mydata' your index will become 'mydata-YYYY.MM.DD'.

The last string appended belongs to the date when the data is being
generated.

---

##### `logstashPrefixKey`<sup>Optional</sup> <a name="logstashPrefixKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.logstashPrefixKey"></a>

```typescript
public readonly logstashPrefixKey: string;
```

- *Type:* string

When included: the value in the record that belongs to the key will be looked up and over-write the `logstashPrefix` for index generation.

If
the key/value is not found in the record then the `logstashPrefix` option
will act as a fallback.

Nested keys are not supported (if desired, you can use the nest filter
plugin to remove nesting)

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Elasticsearch accepts new data on HTTP query path "/_bulk".

But it is
also possible to serve Elasticsearch behind a reverse proxy on a
subpath. This option defines such path on the fluent-bit side. It
simply adds a path prefix in the indexing HTTP POST URI..

---

##### `pipeline`<sup>Optional</sup> <a name="pipeline" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.pipeline"></a>

```typescript
public readonly pipeline: string;
```

- *Type:* string

Elasticsearch allows to setup filters called pipelines.

This option
allows to define which pipeline the database should use.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* 9200

TCP port of the target Elasticsearch instance.

---

##### `replaceDots`<sup>Optional</sup> <a name="replaceDots" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.replaceDots"></a>

```typescript
public readonly replaceDots: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled, replace field name dots with underscore.

---

##### `suppressTypeName`<sup>Optional</sup> <a name="suppressTypeName" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.suppressTypeName"></a>

```typescript
public readonly suppressTypeName: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled, mapping types is removed and `type` option is ignored.

---

##### `tagKey`<sup>Optional</sup> <a name="tagKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.tagKey"></a>

```typescript
public readonly tagKey: string;
```

- *Type:* string
- *Default:* '_flb-key'

When `includeTagKey` is enabled, this property defines the key name for the tag.

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string
- *Default:* '

When `logstashFormat` is enabled, each record will get a new timestamp field.

The`timeKey` property defines the name of that field.

---

##### `timeKeyFormat`<sup>Optional</sup> <a name="timeKeyFormat" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.timeKeyFormat"></a>

```typescript
public readonly timeKeyFormat: string;
```

- *Type:* string
- *Default:* '%Y-%m-%dT%H:%M:%S'

When `logstashFormat` is enabled, this property defines the format of the timestamp.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKeyNanos`<sup>Optional</sup> <a name="timeKeyNanos" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.timeKeyNanos"></a>

```typescript
public readonly timeKeyNanos: boolean;
```

- *Type:* boolean
- *Default:* false

When `logstashFormat` is enabled, enabling this property sends nanosecond precision timestamps.

---

##### `traceError`<sup>Optional</sup> <a name="traceError" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.traceError"></a>

```typescript
public readonly traceError: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled print the Elasticsearch API calls to stdout when Elasticsearch returns an error (for diag only).

---

##### `traceOutput`<sup>Optional</sup> <a name="traceOutput" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.traceOutput"></a>

```typescript
public readonly traceOutput: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled print the Elasticsearch API calls to stdout (for diag only).

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string
- *Default:* '_doc'

Type name.

---

##### `workers`<sup>Optional</sup> <a name="workers" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.workers"></a>

```typescript
public readonly workers: number;
```

- *Type:* number
- *Default:* 2

Enables dedicated thread(s) for this output.

---

##### `writeOperation`<sup>Optional</sup> <a name="writeOperation" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions.property.writeOperation"></a>

```typescript
public readonly writeOperation: string;
```

- *Type:* string
- *Default:* 'create'

Operation to use to write in bulk requests.

---

### FluentBitFilterPluginCommonOptions <a name="FluentBitFilterPluginCommonOptions" id="cdk-extensions.k8s_aws.FluentBitFilterPluginCommonOptions"></a>

Configuration options that apply to all Fluent Bit output plugins.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitFilterPluginCommonOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitFilterPluginCommonOptions: k8s_aws.FluentBitFilterPluginCommonOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilterPluginCommonOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilterPluginCommonOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

### FluentBitGrepFilterOptions <a name="FluentBitGrepFilterOptions" id="cdk-extensions.k8s_aws.FluentBitGrepFilterOptions"></a>

Options for configuring the Grep Fluent Bit filter plugin.

> [[Grep Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/grep)]([Grep Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/grep))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitGrepFilterOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitGrepFilterOptions: k8s_aws.FluentBitGrepFilterOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepFilterOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepFilterOptions.property.pattern">pattern</a></code> | <code>cdk-extensions.k8s_aws.FluentBitGrepRegex</code> | The pattern to use for filtering records processed by the plugin. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitGrepFilterOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.k8s_aws.FluentBitGrepFilterOptions.property.pattern"></a>

```typescript
public readonly pattern: FluentBitGrepRegex;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitGrepRegex

The pattern to use for filtering records processed by the plugin.

---

### FluentBitGrepRegex <a name="FluentBitGrepRegex" id="cdk-extensions.k8s_aws.FluentBitGrepRegex"></a>

Configures a pattern to match against a Fluent Bit record.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitGrepRegex.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitGrepRegex: k8s_aws.FluentBitGrepRegex = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepRegex.property.key">key</a></code> | <code>string</code> | The key of the fields which you want to filter using the regex. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepRegex.property.regex">regex</a></code> | <code>string</code> | The regular expression to apply to the specified field. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepRegex.property.exclude">exclude</a></code> | <code>boolean</code> | Whether the matched expression should exclude or include records from being output. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.FluentBitGrepRegex.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The key of the fields which you want to filter using the regex.

---

##### `regex`<sup>Required</sup> <a name="regex" id="cdk-extensions.k8s_aws.FluentBitGrepRegex.property.regex"></a>

```typescript
public readonly regex: string;
```

- *Type:* string

The regular expression to apply to the specified field.

---

##### `exclude`<sup>Optional</sup> <a name="exclude" id="cdk-extensions.k8s_aws.FluentBitGrepRegex.property.exclude"></a>

```typescript
public readonly exclude: boolean;
```

- *Type:* boolean
- *Default:* false

Whether the matched expression should exclude or include records from being output.

When this is true, only records that match the given expression will be
output.

When this is false, only records that do not match the given expression
will be output.

---

### FluentBitJsonParserOptions <a name="FluentBitJsonParserOptions" id="cdk-extensions.k8s_aws.FluentBitJsonParserOptions"></a>

Options for configuring the JSON Fluent Bit parser plugin.

> [[JSON Plugin Documention](https://docs.fluentbit.io/manual/pipeline/parsers/json)]([JSON Plugin Documention](https://docs.fluentbit.io/manual/pipeline/parsers/json))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitJsonParserOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitJsonParserOptions: k8s_aws.FluentBitJsonParserOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParserOptions.property.timeFormat">timeFormat</a></code> | <code>string</code> | Defines the format of the timestamp on the inbound record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParserOptions.property.timeKey">timeKey</a></code> | <code>string</code> | The key under which timestamp information for the inbound record is given. |

---

##### `timeFormat`<sup>Optional</sup> <a name="timeFormat" id="cdk-extensions.k8s_aws.FluentBitJsonParserOptions.property.timeFormat"></a>

```typescript
public readonly timeFormat: string;
```

- *Type:* string

Defines the format of the timestamp on the inbound record.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitJsonParserOptions.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

The key under which timestamp information for the inbound record is given.

---

### FluentBitKinesisFirehoseOutputOptions <a name="FluentBitKinesisFirehoseOutputOptions" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions"></a>

Options for configuring the Kinesis Firehose Fluent Bit output plugin.

> [[Kinesis Firehose Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/firehose)]([Kinesis Firehose Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/firehose))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitKinesisFirehoseOutputOptions: k8s_aws.FluentBitKinesisFirehoseOutputOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.autoRetryRequests">autoRetryRequests</a></code> | <code>boolean</code> | Immediately retry failed requests to AWS services once. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.compression">compression</a></code> | <code>cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat</code> | Compression type for Firehose records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.deliveryStream">deliveryStream</a></code> | <code>cdk-extensions.kinesis_firehose.IDeliveryStream</code> | The Kinesis Firehose Delivery stream that you want log records sent to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.endpoint">endpoint</a></code> | <code>string</code> | Specify a custom endpoint for the Firehose API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.logKey">logKey</a></code> | <code>string</code> | By default, the whole log record will be sent to Firehose. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.region">region</a></code> | <code>string</code> | The AWS region. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | ARN of an IAM role to assume (for cross account access). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.stsEndpoint">stsEndpoint</a></code> | <code>string</code> | Specify a custom STS endpoint for the AWS STS API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.timeKey">timeKey</a></code> | <code>string</code> | Add the timestamp to the record under this key. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.timeKeyFormat">timeKeyFormat</a></code> | <code>string</code> | A strftime compliant format string for the timestamp. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `autoRetryRequests`<sup>Optional</sup> <a name="autoRetryRequests" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.autoRetryRequests"></a>

```typescript
public readonly autoRetryRequests: boolean;
```

- *Type:* boolean
- *Default:* true

Immediately retry failed requests to AWS services once.

This option does
not affect the normal Fluent Bit retry mechanism with backoff. Instead,
it enables an immediate retry with no delay for networking errors, which
may help improve throughput when there are transient/random networking
issues.

---

##### `compression`<sup>Optional</sup> <a name="compression" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.compression"></a>

```typescript
public readonly compression: KinesisFirehoseCompressionFormat;
```

- *Type:* cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat

Compression type for Firehose records.

Each log record is individually
compressed and sent to Firehose.

---

##### `deliveryStream`<sup>Optional</sup> <a name="deliveryStream" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.deliveryStream"></a>

```typescript
public readonly deliveryStream: IDeliveryStream;
```

- *Type:* cdk-extensions.kinesis_firehose.IDeliveryStream

The Kinesis Firehose Delivery stream that you want log records sent to.

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

Specify a custom endpoint for the Firehose API.

---

##### `logKey`<sup>Optional</sup> <a name="logKey" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.logKey"></a>

```typescript
public readonly logKey: string;
```

- *Type:* string

By default, the whole log record will be sent to Firehose.

If you
specify a key name with this option, then only the value of that key
will be sent to Firehose.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

The AWS region.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

ARN of an IAM role to assume (for cross account access).

---

##### `stsEndpoint`<sup>Optional</sup> <a name="stsEndpoint" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.stsEndpoint"></a>

```typescript
public readonly stsEndpoint: string;
```

- *Type:* string

Specify a custom STS endpoint for the AWS STS API.

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

Add the timestamp to the record under this key.

---

##### `timeKeyFormat`<sup>Optional</sup> <a name="timeKeyFormat" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions.property.timeKeyFormat"></a>

```typescript
public readonly timeKeyFormat: string;
```

- *Type:* string
- *Default:* '%Y-%m-%dT%H:%M:%S'

A strftime compliant format string for the timestamp.

---

### FluentBitKinesisOutputOptions <a name="FluentBitKinesisOutputOptions" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions"></a>

Options for configuring the Kinesis Data Streams Fluent Bit output plugin.

> [[Kinesis Streams Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/kinesis)]([Kinesis Streams Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/kinesis))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitKinesisOutputOptions: k8s_aws.FluentBitKinesisOutputOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.autoRetryRequests">autoRetryRequests</a></code> | <code>boolean</code> | Immediately retry failed requests to AWS services once. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.endpoint">endpoint</a></code> | <code>string</code> | Specify a custom endpoint for the Firehose API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.logKey">logKey</a></code> | <code>string</code> | By default, the whole log record will be sent to Firehose. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.region">region</a></code> | <code>string</code> | The AWS region. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | ARN of an IAM role to assume (for cross account access). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.stream">stream</a></code> | <code>aws-cdk-lib.aws_kinesis.IStream</code> | The name of the Kinesis Streams Delivery stream that you want log records sent to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.stsEndpoint">stsEndpoint</a></code> | <code>string</code> | Specify a custom STS endpoint for the AWS STS API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.timeKey">timeKey</a></code> | <code>string</code> | Add the timestamp to the record under this key. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.timeKeyFormat">timeKeyFormat</a></code> | <code>string</code> | A strftime compliant format string for the timestamp. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `autoRetryRequests`<sup>Optional</sup> <a name="autoRetryRequests" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.autoRetryRequests"></a>

```typescript
public readonly autoRetryRequests: boolean;
```

- *Type:* boolean
- *Default:* true

Immediately retry failed requests to AWS services once.

This option does
not affect the normal Fluent Bit retry mechanism with backoff. Instead,
it enables an immediate retry with no delay for networking errors, which
may help improve throughput when there are transient/random networking
issues.

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

Specify a custom endpoint for the Firehose API.

---

##### `logKey`<sup>Optional</sup> <a name="logKey" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.logKey"></a>

```typescript
public readonly logKey: string;
```

- *Type:* string

By default, the whole log record will be sent to Firehose.

If you
specify a key name with this option, then only the value of that key
will be sent to Firehose.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

The AWS region.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

ARN of an IAM role to assume (for cross account access).

---

##### `stream`<sup>Optional</sup> <a name="stream" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.stream"></a>

```typescript
public readonly stream: IStream;
```

- *Type:* aws-cdk-lib.aws_kinesis.IStream

The name of the Kinesis Streams Delivery stream that you want log records sent to.

---

##### `stsEndpoint`<sup>Optional</sup> <a name="stsEndpoint" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.stsEndpoint"></a>

```typescript
public readonly stsEndpoint: string;
```

- *Type:* string

Specify a custom STS endpoint for the AWS STS API.

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

Add the timestamp to the record under this key.

---

##### `timeKeyFormat`<sup>Optional</sup> <a name="timeKeyFormat" id="cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions.property.timeKeyFormat"></a>

```typescript
public readonly timeKeyFormat: string;
```

- *Type:* string
- *Default:* '%Y-%m-%dT%H:%M:%S'

A strftime compliant format string for the timestamp.

---

### FluentBitKubernetesFilterOptions <a name="FluentBitKubernetesFilterOptions" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions"></a>

Options for configuring the Kubernetes Fluent Bit filter plugin.

> [[Kubernetes Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/kubernetes)]([Kubernetes Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/kubernetes))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitKubernetesFilterOptions: k8s_aws.FluentBitKubernetesFilterOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.annotations">annotations</a></code> | <code>boolean</code> | Include Kubernetes resource annotations in the extra metadata. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.bufferSize">bufferSize</a></code> | <code>cdk-extensions.core.DataSize</code> | Set the buffer size for HTTP client when reading responses from Kubernetes API server. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.cacheUseDockerId">cacheUseDockerId</a></code> | <code>boolean</code> | When enabled, metadata will be fetched from K8s when docker_id is changed. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.dnsRetries">dnsRetries</a></code> | <code>number</code> | DNS lookup retries N times until the network starts working. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.dnsWaitTime">dnsWaitTime</a></code> | <code>aws-cdk-lib.Duration</code> | DNS lookup interval between network status checks. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.dummyMeta">dummyMeta</a></code> | <code>boolean</code> | If set, use dummy-meta data (for test/dev purposes). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.k8sLoggingExclude">k8sLoggingExclude</a></code> | <code>boolean</code> | Allow Kubernetes Pods to exclude their logs from the log processor. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.k8sLoggingParser">k8sLoggingParser</a></code> | <code>boolean</code> | Allow Kubernetes Pods to suggest a pre-defined Parser. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.keepLog">keepLog</a></code> | <code>boolean</code> | When `keepLog` is disabled, the log field is removed from the incoming message once it has been successfully merged (`mergeLog` must be enabled as well). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeCaFile">kubeCaFile</a></code> | <code>string</code> | CA certificate file. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeCaPath">kubeCaPath</a></code> | <code>string</code> | Absolute path to scan for certificate files. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeletHost">kubeletHost</a></code> | <code>string</code> | Kubelet host using for HTTP request, this only works when `useKubelet` is enabled. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeletPort">kubeletPort</a></code> | <code>number</code> | Kubelet port using for HTTP request, this only works when `useKubelet` is enabled. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeMetaCacheTtl">kubeMetaCacheTtl</a></code> | <code>aws-cdk-lib.Duration</code> | Configurable TTL for K8s cached metadata. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeMetaPreloadCacheDir">kubeMetaPreloadCacheDir</a></code> | <code>string</code> | If set, Kubernetes meta-data can be cached/pre-loaded from files in JSON format in this directory, named as namespace-pod.meta. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeTagPrefix">kubeTagPrefix</a></code> | <code>string</code> | When the source records comes from Tail input plugin, this option allows to specify what's the prefix used in Tail configuration. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeTokenCommand">kubeTokenCommand</a></code> | <code>string</code> | Command to get Kubernetes authorization token. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeTokenFile">kubeTokenFile</a></code> | <code>string</code> | Token file. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeTokenTtl">kubeTokenTtl</a></code> | <code>aws-cdk-lib.Duration</code> | Configurable 'time to live' for the K8s token. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeUrl">kubeUrl</a></code> | <code>string</code> | API Server end-point. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.labels">labels</a></code> | <code>boolean</code> | Include Kubernetes resource labels in the extra metadata. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.mergeLog">mergeLog</a></code> | <code>boolean</code> | When enabled, it checks if the `log` field content is a JSON string map, if so, it append the map fields as part of the log structure. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.mergeLogKey">mergeLogKey</a></code> | <code>string</code> | When `mergeLog` is enabled, the filter tries to assume the `log` field from the incoming message is a JSON string message and make a structured representation of it at the same level of the `log` field in the map. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.mergeLogTrim">mergeLogTrim</a></code> | <code>boolean</code> | When Merge_Log is enabled, trim (remove possible \n or \r) field values. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.mergeParser">mergeParser</a></code> | <code>string</code> | Optional parser name to specify how to parse the data contained in the log key. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.regexParser">regexParser</a></code> | <code>string</code> | Set an alternative Parser to process record Tag and extract pod_name, namespace_name, container_name and docker_id. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.tlsDebug">tlsDebug</a></code> | <code>number</code> | Debug level between 0 (nothing) and 4 (every detail). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.tlsVerify">tlsVerify</a></code> | <code>boolean</code> | When enabled, turns on certificate validation when connecting to the Kubernetes API server. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.useJournal">useJournal</a></code> | <code>boolean</code> | When enabled, the filter reads logs coming in Journald format. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.useKubelet">useKubelet</a></code> | <code>boolean</code> | This is an optional feature flag to get metadata information from kubelet instead of calling Kube Server API to enhance the log. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `annotations`<sup>Optional</sup> <a name="annotations" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.annotations"></a>

```typescript
public readonly annotations: boolean;
```

- *Type:* boolean
- *Default:* true

Include Kubernetes resource annotations in the extra metadata.

---

##### `bufferSize`<sup>Optional</sup> <a name="bufferSize" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.bufferSize"></a>

```typescript
public readonly bufferSize: DataSize;
```

- *Type:* cdk-extensions.core.DataSize
- *Default:* 32k

Set the buffer size for HTTP client when reading responses from Kubernetes API server.

A value of 0 results in no limit, and the buffer will expand as-needed.

Note that if pod specifications exceed the buffer limit, the API
response will be discarded when retrieving metadata, and some kubernetes
metadata will fail to be injected to the logs.

---

##### `cacheUseDockerId`<sup>Optional</sup> <a name="cacheUseDockerId" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.cacheUseDockerId"></a>

```typescript
public readonly cacheUseDockerId: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled, metadata will be fetched from K8s when docker_id is changed.

---

##### `dnsRetries`<sup>Optional</sup> <a name="dnsRetries" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.dnsRetries"></a>

```typescript
public readonly dnsRetries: number;
```

- *Type:* number
- *Default:* 6

DNS lookup retries N times until the network starts working.

---

##### `dnsWaitTime`<sup>Optional</sup> <a name="dnsWaitTime" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.dnsWaitTime"></a>

```typescript
public readonly dnsWaitTime: Duration;
```

- *Type:* aws-cdk-lib.Duration
- *Default:* 30 seconds

DNS lookup interval between network status checks.

---

##### `dummyMeta`<sup>Optional</sup> <a name="dummyMeta" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.dummyMeta"></a>

```typescript
public readonly dummyMeta: boolean;
```

- *Type:* boolean
- *Default:* false

If set, use dummy-meta data (for test/dev purposes).

---

##### `k8sLoggingExclude`<sup>Optional</sup> <a name="k8sLoggingExclude" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.k8sLoggingExclude"></a>

```typescript
public readonly k8sLoggingExclude: boolean;
```

- *Type:* boolean
- *Default:* false

Allow Kubernetes Pods to exclude their logs from the log processor.

---

##### `k8sLoggingParser`<sup>Optional</sup> <a name="k8sLoggingParser" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.k8sLoggingParser"></a>

```typescript
public readonly k8sLoggingParser: boolean;
```

- *Type:* boolean
- *Default:* false

Allow Kubernetes Pods to suggest a pre-defined Parser.

---

##### `keepLog`<sup>Optional</sup> <a name="keepLog" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.keepLog"></a>

```typescript
public readonly keepLog: boolean;
```

- *Type:* boolean
- *Default:* true

When `keepLog` is disabled, the log field is removed from the incoming message once it has been successfully merged (`mergeLog` must be enabled as well).

---

##### `kubeCaFile`<sup>Optional</sup> <a name="kubeCaFile" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeCaFile"></a>

```typescript
public readonly kubeCaFile: string;
```

- *Type:* string
- *Default:* '/var/run/secrets/kubernetes.io/serviceaccount/ca.crt'

CA certificate file.

---

##### `kubeCaPath`<sup>Optional</sup> <a name="kubeCaPath" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeCaPath"></a>

```typescript
public readonly kubeCaPath: string;
```

- *Type:* string

Absolute path to scan for certificate files.

---

##### `kubeletHost`<sup>Optional</sup> <a name="kubeletHost" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeletHost"></a>

```typescript
public readonly kubeletHost: string;
```

- *Type:* string

Kubelet host using for HTTP request, this only works when `useKubelet` is enabled.

---

##### `kubeletPort`<sup>Optional</sup> <a name="kubeletPort" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeletPort"></a>

```typescript
public readonly kubeletPort: number;
```

- *Type:* number
- *Default:* 10250

Kubelet port using for HTTP request, this only works when `useKubelet` is enabled.

---

##### `kubeMetaCacheTtl`<sup>Optional</sup> <a name="kubeMetaCacheTtl" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeMetaCacheTtl"></a>

```typescript
public readonly kubeMetaCacheTtl: Duration;
```

- *Type:* aws-cdk-lib.Duration
- *Default:* 0

Configurable TTL for K8s cached metadata.

By default, it is set to 0 which means TTL for cache entries is disabled
and cache entries are evicted at random when capacity is reached.

In order to enable this option, you should set the number to a time
interval.

---

##### `kubeMetaPreloadCacheDir`<sup>Optional</sup> <a name="kubeMetaPreloadCacheDir" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeMetaPreloadCacheDir"></a>

```typescript
public readonly kubeMetaPreloadCacheDir: string;
```

- *Type:* string

If set, Kubernetes meta-data can be cached/pre-loaded from files in JSON format in this directory, named as namespace-pod.meta.

---

##### `kubeTagPrefix`<sup>Optional</sup> <a name="kubeTagPrefix" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeTagPrefix"></a>

```typescript
public readonly kubeTagPrefix: string;
```

- *Type:* string
- *Default:* 'kube.var.log.containers.'

When the source records comes from Tail input plugin, this option allows to specify what's the prefix used in Tail configuration.

---

##### `kubeTokenCommand`<sup>Optional</sup> <a name="kubeTokenCommand" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeTokenCommand"></a>

```typescript
public readonly kubeTokenCommand: string;
```

- *Type:* string

Command to get Kubernetes authorization token.

If you want to manually choose a command to get it, you can set the
command here.

For example, run running the following to get the token using aws-cli:

```
aws-iam-authenticator -i your-cluster-name token --token-only
```

This option is currently Linux-only.

---

##### `kubeTokenFile`<sup>Optional</sup> <a name="kubeTokenFile" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeTokenFile"></a>

```typescript
public readonly kubeTokenFile: string;
```

- *Type:* string
- *Default:* '/var/run/secrets/kubernetes.io/serviceaccount/token'

Token file.

---

##### `kubeTokenTtl`<sup>Optional</sup> <a name="kubeTokenTtl" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeTokenTtl"></a>

```typescript
public readonly kubeTokenTtl: Duration;
```

- *Type:* aws-cdk-lib.Duration
- *Default:* 10 minutes

Configurable 'time to live' for the K8s token.

After this time, the token is reloaded from `kubeTokenFile` or the
`kubeTokenCommand`.

---

##### `kubeUrl`<sup>Optional</sup> <a name="kubeUrl" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.kubeUrl"></a>

```typescript
public readonly kubeUrl: string;
```

- *Type:* string
- *Default:* 'https://kubernetes.default.svc/'

API Server end-point.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.labels"></a>

```typescript
public readonly labels: boolean;
```

- *Type:* boolean
- *Default:* true

Include Kubernetes resource labels in the extra metadata.

---

##### `mergeLog`<sup>Optional</sup> <a name="mergeLog" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.mergeLog"></a>

```typescript
public readonly mergeLog: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled, it checks if the `log` field content is a JSON string map, if so, it append the map fields as part of the log structure.

---

##### `mergeLogKey`<sup>Optional</sup> <a name="mergeLogKey" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.mergeLogKey"></a>

```typescript
public readonly mergeLogKey: string;
```

- *Type:* string

When `mergeLog` is enabled, the filter tries to assume the `log` field from the incoming message is a JSON string message and make a structured representation of it at the same level of the `log` field in the map.

Now if `mergeLogKey` is set (a string name), all the new structured
fields taken from the original `log` content are inserted under the new
key.

---

##### `mergeLogTrim`<sup>Optional</sup> <a name="mergeLogTrim" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.mergeLogTrim"></a>

```typescript
public readonly mergeLogTrim: boolean;
```

- *Type:* boolean
- *Default:* true

When Merge_Log is enabled, trim (remove possible \n or \r) field values.

---

##### `mergeParser`<sup>Optional</sup> <a name="mergeParser" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.mergeParser"></a>

```typescript
public readonly mergeParser: string;
```

- *Type:* string

Optional parser name to specify how to parse the data contained in the log key.

Recommended use is for developers or testing only.

---

##### `regexParser`<sup>Optional</sup> <a name="regexParser" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.regexParser"></a>

```typescript
public readonly regexParser: string;
```

- *Type:* string

Set an alternative Parser to process record Tag and extract pod_name, namespace_name, container_name and docker_id.

The parser must be registered in a parsers file.

> [[Parsers File](https://github.com/fluent/fluent-bit/blob/master/conf/parsers.conf)]([Parsers File](https://github.com/fluent/fluent-bit/blob/master/conf/parsers.conf))

---

##### `tlsDebug`<sup>Optional</sup> <a name="tlsDebug" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.tlsDebug"></a>

```typescript
public readonly tlsDebug: number;
```

- *Type:* number
- *Default:* 1

Debug level between 0 (nothing) and 4 (every detail).

---

##### `tlsVerify`<sup>Optional</sup> <a name="tlsVerify" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.tlsVerify"></a>

```typescript
public readonly tlsVerify: boolean;
```

- *Type:* boolean
- *Default:* true

When enabled, turns on certificate validation when connecting to the Kubernetes API server.

---

##### `useJournal`<sup>Optional</sup> <a name="useJournal" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.useJournal"></a>

```typescript
public readonly useJournal: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled, the filter reads logs coming in Journald format.

---

##### `useKubelet`<sup>Optional</sup> <a name="useKubelet" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions.property.useKubelet"></a>

```typescript
public readonly useKubelet: boolean;
```

- *Type:* boolean
- *Default:* false

This is an optional feature flag to get metadata information from kubelet instead of calling Kube Server API to enhance the log.

> [[Kube API heavy traffic issue for large cluster](https://docs.fluentbit.io/manual/pipeline/filters/kubernetes#optional-feature-using-kubelet-to-get-metadata)]([Kube API heavy traffic issue for large cluster](https://docs.fluentbit.io/manual/pipeline/filters/kubernetes#optional-feature-using-kubelet-to-get-metadata))

---

### FluentBitLogfmtParserOptions <a name="FluentBitLogfmtParserOptions" id="cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions"></a>

Options for configuring the logfmt Fluent Bit parser plugin.

> [[Logfmt Plugin Documention](https://docs.fluentbit.io/manual/pipeline/parsers/logfmt)]([Logfmt Plugin Documention](https://docs.fluentbit.io/manual/pipeline/parsers/logfmt))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitLogfmtParserOptions: k8s_aws.FluentBitLogfmtParserOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions.property.timeFormat">timeFormat</a></code> | <code>string</code> | Defines the format of the timestamp on the inbound record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions.property.timeKey">timeKey</a></code> | <code>string</code> | The key under which timestamp information for the inbound record is given. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions.property.types">types</a></code> | <code>{[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}</code> | Maps group names matched by the regex to the data types they should be interpreted as. |

---

##### `timeFormat`<sup>Optional</sup> <a name="timeFormat" id="cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions.property.timeFormat"></a>

```typescript
public readonly timeFormat: string;
```

- *Type:* string

Defines the format of the timestamp on the inbound record.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

The key under which timestamp information for the inbound record is given.

---

##### `types`<sup>Optional</sup> <a name="types" id="cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions.property.types"></a>

```typescript
public readonly types: {[ key: string ]: ParserPluginDataType};
```

- *Type:* {[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}

Maps group names matched by the regex to the data types they should be interpreted as.

---

### FluentBitLtsvParserOptions <a name="FluentBitLtsvParserOptions" id="cdk-extensions.k8s_aws.FluentBitLtsvParserOptions"></a>

Options for configuring the LTSV Fluent Bit parser plugin.

> [[LTSV Plugin Documention](https://docs.fluentbit.io/manual/pipeline/parsers/ltsv)]([LTSV Plugin Documention](https://docs.fluentbit.io/manual/pipeline/parsers/ltsv))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitLtsvParserOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitLtsvParserOptions: k8s_aws.FluentBitLtsvParserOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParserOptions.property.timeFormat">timeFormat</a></code> | <code>string</code> | Defines the format of the timestamp on the inbound record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParserOptions.property.timeKey">timeKey</a></code> | <code>string</code> | The key under which timestamp information for the inbound record is given. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParserOptions.property.types">types</a></code> | <code>{[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}</code> | Maps group names matched by the regex to the data types they should be interpreted as. |

---

##### `timeFormat`<sup>Optional</sup> <a name="timeFormat" id="cdk-extensions.k8s_aws.FluentBitLtsvParserOptions.property.timeFormat"></a>

```typescript
public readonly timeFormat: string;
```

- *Type:* string

Defines the format of the timestamp on the inbound record.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitLtsvParserOptions.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

The key under which timestamp information for the inbound record is given.

---

##### `types`<sup>Optional</sup> <a name="types" id="cdk-extensions.k8s_aws.FluentBitLtsvParserOptions.property.types"></a>

```typescript
public readonly types: {[ key: string ]: ParserPluginDataType};
```

- *Type:* {[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}

Maps group names matched by the regex to the data types they should be interpreted as.

---

### FluentBitModifyFilterOptions <a name="FluentBitModifyFilterOptions" id="cdk-extensions.k8s_aws.FluentBitModifyFilterOptions"></a>

Options for configuring the Modify Fluent Bit filter plugin.

> [[Modify Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/modify)]([Modify Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/modify))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitModifyFilterOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitModifyFilterOptions: k8s_aws.FluentBitModifyFilterOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilterOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilterOptions.property.conditions">conditions</a></code> | <code>cdk-extensions.k8s_aws.ModifyCondition[]</code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilterOptions.property.operations">operations</a></code> | <code>cdk-extensions.k8s_aws.ModifyOperation[]</code> | *No description.* |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitModifyFilterOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `conditions`<sup>Optional</sup> <a name="conditions" id="cdk-extensions.k8s_aws.FluentBitModifyFilterOptions.property.conditions"></a>

```typescript
public readonly conditions: ModifyCondition[];
```

- *Type:* cdk-extensions.k8s_aws.ModifyCondition[]

---

##### `operations`<sup>Optional</sup> <a name="operations" id="cdk-extensions.k8s_aws.FluentBitModifyFilterOptions.property.operations"></a>

```typescript
public readonly operations: ModifyOperation[];
```

- *Type:* cdk-extensions.k8s_aws.ModifyOperation[]

---

### FluentBitNestFilterOptions <a name="FluentBitNestFilterOptions" id="cdk-extensions.k8s_aws.FluentBitNestFilterOptions"></a>

Options for configuring the Nest Fluent Bit filter plugin.

> [[Nest Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/nest)]([Nest Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/nest))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitNestFilterOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitNestFilterOptions: k8s_aws.FluentBitNestFilterOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilterOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilterOptions.property.operation">operation</a></code> | <code>cdk-extensions.k8s_aws.NestFilterOperation</code> | The operation the filter will perform. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilterOptions.property.addPrefix">addPrefix</a></code> | <code>string</code> | Prefix affected keys with this string. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilterOptions.property.removePrefix">removePrefix</a></code> | <code>string</code> | Remove prefix from affected keys if it matches this string. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitNestFilterOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `operation`<sup>Required</sup> <a name="operation" id="cdk-extensions.k8s_aws.FluentBitNestFilterOptions.property.operation"></a>

```typescript
public readonly operation: NestFilterOperation;
```

- *Type:* cdk-extensions.k8s_aws.NestFilterOperation

The operation the filter will perform.

---

##### `addPrefix`<sup>Optional</sup> <a name="addPrefix" id="cdk-extensions.k8s_aws.FluentBitNestFilterOptions.property.addPrefix"></a>

```typescript
public readonly addPrefix: string;
```

- *Type:* string

Prefix affected keys with this string.

---

##### `removePrefix`<sup>Optional</sup> <a name="removePrefix" id="cdk-extensions.k8s_aws.FluentBitNestFilterOptions.property.removePrefix"></a>

```typescript
public readonly removePrefix: string;
```

- *Type:* string

Remove prefix from affected keys if it matches this string.

---

### FluentBitOpenSearchOutputOptions <a name="FluentBitOpenSearchOutputOptions" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions"></a>

Options for configuring the OpenSearch Fluent Bit output plugin.

> [[OpenSearch Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/opensearch)]([OpenSearch Plugin Documention](https://docs.fluentbit.io/manual/pipeline/outputs/opensearch))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitOpenSearchOutputOptions: k8s_aws.FluentBitOpenSearchOutputOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.domain">domain</a></code> | <code>aws-cdk-lib.aws_opensearchservice.IDomain</code> | The Opensearch domain to which logs should be shipped. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsAuth">awsAuth</a></code> | <code>boolean</code> | Enable AWS Sigv4 Authentication for Amazon OpenSearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsExternalId">awsExternalId</a></code> | <code>string</code> | External ID for the AWS IAM Role specified with `awsRole`. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsRegion">awsRegion</a></code> | <code>string</code> | Specify the AWS region for Amazon OpenSearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsRole">awsRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | AWS IAM Role to assume to put records to your Amazon cluster. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsStsEndpoint">awsStsEndpoint</a></code> | <code>string</code> | Specify the custom sts endpoint to be used with STS API for Amazon OpenSearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.bufferSize">bufferSize</a></code> | <code>cdk-extensions.k8s_aws.OpenSearchOutputBufferSize</code> | Specify the buffer size used to read the response from the OpenSearch HTTP service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.currentTimeIndex">currentTimeIndex</a></code> | <code>boolean</code> | Use current time for index generation instead of message record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.generateId">generateId</a></code> | <code>boolean</code> | When enabled, generate `_id` for outgoing records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.host">host</a></code> | <code>string</code> | IP address or hostname of the target OpenSearch instance. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.httpPasswd">httpPasswd</a></code> | <code>string</code> | Password for user defined in `httpUser`. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.httpUser">httpUser</a></code> | <code>string</code> | Optional username credential for access. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.idKey">idKey</a></code> | <code>string</code> | If set, `_id` will be the value of the key from incoming record and `generateId` option is ignored. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.includeTagKey">includeTagKey</a></code> | <code>boolean</code> | When enabled, it append the Tag name to the record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.index">index</a></code> | <code>string</code> | Index name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.logstashDateFormat">logstashDateFormat</a></code> | <code>string</code> | Time format (based on strftime) to generate the second part of the Index name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.logstashFormat">logstashFormat</a></code> | <code>boolean</code> | Enable Logstash format compatibility. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.logstashPrefix">logstashPrefix</a></code> | <code>string</code> | When `logstashFormat` is enabled, the Index name is composed using a prefix and the date, e.g: If `logstashPrefix` is equals to 'mydata' your index will become 'mydata-YYYY.MM.DD'. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.logstashPrefixKey">logstashPrefixKey</a></code> | <code>string</code> | When included: the value in the record that belongs to the key will be looked up and over-write the `logstashPrefix` for index generation. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.path">path</a></code> | <code>string</code> | OpenSearch accepts new data on HTTP query path "/_bulk". |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.pipeline">pipeline</a></code> | <code>string</code> | OpenSearch allows to setup filters called pipelines. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.port">port</a></code> | <code>number</code> | TCP port of the target OpenSearch instance. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.replaceDots">replaceDots</a></code> | <code>boolean</code> | When enabled, replace field name dots with underscore. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.suppressTypeName">suppressTypeName</a></code> | <code>boolean</code> | When enabled, mapping types is removed and `type` option is ignored. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.tagKey">tagKey</a></code> | <code>string</code> | When `includeTagKey` is enabled, this property defines the key name for the tag. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.timeKey">timeKey</a></code> | <code>string</code> | When `logstashFormat` is enabled, each record will get a new timestamp field. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.timeKeyFormat">timeKeyFormat</a></code> | <code>string</code> | When `logstashFormat` is enabled, this property defines the format of the timestamp. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.timeKeyNanos">timeKeyNanos</a></code> | <code>boolean</code> | When `logstashFormat` is enabled, enabling this property sends nanosecond precision timestamps. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.traceError">traceError</a></code> | <code>boolean</code> | When enabled print the OpenSearch API calls to stdout when OpenSearch returns an error (for diag only). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.traceOutput">traceOutput</a></code> | <code>boolean</code> | When enabled print the OpenSearch API calls to stdout (for diag only). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.type">type</a></code> | <code>string</code> | Type name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.workers">workers</a></code> | <code>number</code> | Enables dedicated thread(s) for this output. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.writeOperation">writeOperation</a></code> | <code>string</code> | Operation to use to write in bulk requests. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `domain`<sup>Required</sup> <a name="domain" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.domain"></a>

```typescript
public readonly domain: IDomain;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.IDomain

The Opensearch domain to which logs should be shipped.

---

##### `awsAuth`<sup>Optional</sup> <a name="awsAuth" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsAuth"></a>

```typescript
public readonly awsAuth: boolean;
```

- *Type:* boolean
- *Default:* false

Enable AWS Sigv4 Authentication for Amazon OpenSearch Service.

---

##### `awsExternalId`<sup>Optional</sup> <a name="awsExternalId" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsExternalId"></a>

```typescript
public readonly awsExternalId: string;
```

- *Type:* string

External ID for the AWS IAM Role specified with `awsRole`.

---

##### `awsRegion`<sup>Optional</sup> <a name="awsRegion" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsRegion"></a>

```typescript
public readonly awsRegion: string;
```

- *Type:* string

Specify the AWS region for Amazon OpenSearch Service.

---

##### `awsRole`<sup>Optional</sup> <a name="awsRole" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsRole"></a>

```typescript
public readonly awsRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

AWS IAM Role to assume to put records to your Amazon cluster.

---

##### `awsStsEndpoint`<sup>Optional</sup> <a name="awsStsEndpoint" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.awsStsEndpoint"></a>

```typescript
public readonly awsStsEndpoint: string;
```

- *Type:* string

Specify the custom sts endpoint to be used with STS API for Amazon OpenSearch Service.

---

##### `bufferSize`<sup>Optional</sup> <a name="bufferSize" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.bufferSize"></a>

```typescript
public readonly bufferSize: OpenSearchOutputBufferSize;
```

- *Type:* cdk-extensions.k8s_aws.OpenSearchOutputBufferSize

Specify the buffer size used to read the response from the OpenSearch HTTP service.

This option is useful for debugging purposes where is
required to read full responses, note that response size grows depending
of the number of records inserted.

---

##### `currentTimeIndex`<sup>Optional</sup> <a name="currentTimeIndex" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.currentTimeIndex"></a>

```typescript
public readonly currentTimeIndex: boolean;
```

- *Type:* boolean
- *Default:* false

Use current time for index generation instead of message record.

---

##### `generateId`<sup>Optional</sup> <a name="generateId" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.generateId"></a>

```typescript
public readonly generateId: boolean;
```

- *Type:* boolean

When enabled, generate `_id` for outgoing records.

This prevents duplicate
records when retrying.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

IP address or hostname of the target OpenSearch instance.

---

##### `httpPasswd`<sup>Optional</sup> <a name="httpPasswd" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.httpPasswd"></a>

```typescript
public readonly httpPasswd: string;
```

- *Type:* string

Password for user defined in `httpUser`.

---

##### `httpUser`<sup>Optional</sup> <a name="httpUser" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.httpUser"></a>

```typescript
public readonly httpUser: string;
```

- *Type:* string

Optional username credential for access.

---

##### `idKey`<sup>Optional</sup> <a name="idKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.idKey"></a>

```typescript
public readonly idKey: string;
```

- *Type:* string

If set, `_id` will be the value of the key from incoming record and `generateId` option is ignored.

---

##### `includeTagKey`<sup>Optional</sup> <a name="includeTagKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.includeTagKey"></a>

```typescript
public readonly includeTagKey: boolean;
```

- *Type:* boolean

When enabled, it append the Tag name to the record.

---

##### `index`<sup>Optional</sup> <a name="index" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* string
- *Default:* 'fluent-bit

Index name.

---

##### `logstashDateFormat`<sup>Optional</sup> <a name="logstashDateFormat" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.logstashDateFormat"></a>

```typescript
public readonly logstashDateFormat: string;
```

- *Type:* string
- *Default:* '%Y.%m.%d'

Time format (based on strftime) to generate the second part of the Index name.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `logstashFormat`<sup>Optional</sup> <a name="logstashFormat" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.logstashFormat"></a>

```typescript
public readonly logstashFormat: boolean;
```

- *Type:* boolean
- *Default:* false

Enable Logstash format compatibility.

---

##### `logstashPrefix`<sup>Optional</sup> <a name="logstashPrefix" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.logstashPrefix"></a>

```typescript
public readonly logstashPrefix: string;
```

- *Type:* string
- *Default:* 'logstash'

When `logstashFormat` is enabled, the Index name is composed using a prefix and the date, e.g: If `logstashPrefix` is equals to 'mydata' your index will become 'mydata-YYYY.MM.DD'.

The last string appended belongs to the date when the data is being
generated.

---

##### `logstashPrefixKey`<sup>Optional</sup> <a name="logstashPrefixKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.logstashPrefixKey"></a>

```typescript
public readonly logstashPrefixKey: string;
```

- *Type:* string

When included: the value in the record that belongs to the key will be looked up and over-write the `logstashPrefix` for index generation.

If
the key/value is not found in the record then the `logstashPrefix` option
will act as a fallback.

Nested keys are not supported (if desired, you can use the nest filter
plugin to remove nesting)

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

OpenSearch accepts new data on HTTP query path "/_bulk".

But it is also
possible to serve OpenSearch behind a reverse proxy on a subpath. This
option defines such path on the fluent-bit side. It simply adds a path
prefix in the indexing HTTP POST URI..

---

##### `pipeline`<sup>Optional</sup> <a name="pipeline" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.pipeline"></a>

```typescript
public readonly pipeline: string;
```

- *Type:* string

OpenSearch allows to setup filters called pipelines.

This option allows
to define which pipeline the database should use.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* 9200

TCP port of the target OpenSearch instance.

---

##### `replaceDots`<sup>Optional</sup> <a name="replaceDots" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.replaceDots"></a>

```typescript
public readonly replaceDots: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled, replace field name dots with underscore.

---

##### `suppressTypeName`<sup>Optional</sup> <a name="suppressTypeName" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.suppressTypeName"></a>

```typescript
public readonly suppressTypeName: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled, mapping types is removed and `type` option is ignored.

---

##### `tagKey`<sup>Optional</sup> <a name="tagKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.tagKey"></a>

```typescript
public readonly tagKey: string;
```

- *Type:* string
- *Default:* '_flb-key'

When `includeTagKey` is enabled, this property defines the key name for the tag.

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string
- *Default:* '

When `logstashFormat` is enabled, each record will get a new timestamp field.

The`timeKey` property defines the name of that field.

---

##### `timeKeyFormat`<sup>Optional</sup> <a name="timeKeyFormat" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.timeKeyFormat"></a>

```typescript
public readonly timeKeyFormat: string;
```

- *Type:* string
- *Default:* '%Y-%m-%dT%H:%M:%S'

When `logstashFormat` is enabled, this property defines the format of the timestamp.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKeyNanos`<sup>Optional</sup> <a name="timeKeyNanos" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.timeKeyNanos"></a>

```typescript
public readonly timeKeyNanos: boolean;
```

- *Type:* boolean
- *Default:* false

When `logstashFormat` is enabled, enabling this property sends nanosecond precision timestamps.

---

##### `traceError`<sup>Optional</sup> <a name="traceError" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.traceError"></a>

```typescript
public readonly traceError: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled print the OpenSearch API calls to stdout when OpenSearch returns an error (for diag only).

---

##### `traceOutput`<sup>Optional</sup> <a name="traceOutput" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.traceOutput"></a>

```typescript
public readonly traceOutput: boolean;
```

- *Type:* boolean
- *Default:* false

When enabled print the OpenSearch API calls to stdout (for diag only).

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string
- *Default:* '_doc'

Type name.

---

##### `workers`<sup>Optional</sup> <a name="workers" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.workers"></a>

```typescript
public readonly workers: number;
```

- *Type:* number
- *Default:* 2

Enables dedicated thread(s) for this output.

---

##### `writeOperation`<sup>Optional</sup> <a name="writeOperation" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions.property.writeOperation"></a>

```typescript
public readonly writeOperation: string;
```

- *Type:* string
- *Default:* 'create'

Operation to use to write in bulk requests.

---

### FluentBitOutputPluginCommonOptions <a name="FluentBitOutputPluginCommonOptions" id="cdk-extensions.k8s_aws.FluentBitOutputPluginCommonOptions"></a>

Configuration options that apply to all Fluent Bit output plugins.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitOutputPluginCommonOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitOutputPluginCommonOptions: k8s_aws.FluentBitOutputPluginCommonOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutputPluginCommonOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitOutputPluginCommonOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

### FluentBitParserFilterOptions <a name="FluentBitParserFilterOptions" id="cdk-extensions.k8s_aws.FluentBitParserFilterOptions"></a>

Options for configuring the Parser Fluent Bit filter plugin.

> [[Parser Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/parser)]([Parser Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/parser))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitParserFilterOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitParserFilterOptions: k8s_aws.FluentBitParserFilterOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.keyName">keyName</a></code> | <code>string</code> | Specify field name in record to parse. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.parsers">parsers</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitParserPlugin[]</code> | The parsers to use to interpret the field. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.preserveKey">preserveKey</a></code> | <code>boolean</code> | Keep original `keyName` field in the parsed result. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.reserveData">reserveData</a></code> | <code>boolean</code> | Keep all other original fields in the parsed result. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `keyName`<sup>Required</sup> <a name="keyName" id="cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.keyName"></a>

```typescript
public readonly keyName: string;
```

- *Type:* string

Specify field name in record to parse.

---

##### `parsers`<sup>Optional</sup> <a name="parsers" id="cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.parsers"></a>

```typescript
public readonly parsers: IFluentBitParserPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin[]

The parsers to use to interpret the field.

---

##### `preserveKey`<sup>Optional</sup> <a name="preserveKey" id="cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.preserveKey"></a>

```typescript
public readonly preserveKey: boolean;
```

- *Type:* boolean
- *Default:* false

Keep original `keyName` field in the parsed result.

If `false`, the field will be removed.

---

##### `reserveData`<sup>Optional</sup> <a name="reserveData" id="cdk-extensions.k8s_aws.FluentBitParserFilterOptions.property.reserveData"></a>

```typescript
public readonly reserveData: boolean;
```

- *Type:* boolean
- *Default:* false

Keep all other original fields in the parsed result.

If `false`, all other original fields will be removed.

---

### FluentBitParserPluginCommonOptions <a name="FluentBitParserPluginCommonOptions" id="cdk-extensions.k8s_aws.FluentBitParserPluginCommonOptions"></a>

Configuration options that apply to all Fluent Bit parser plugins.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitParserPluginCommonOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitParserPluginCommonOptions: k8s_aws.FluentBitParserPluginCommonOptions = { ... }
```


### FluentBitPluginCommonOptions <a name="FluentBitPluginCommonOptions" id="cdk-extensions.k8s_aws.FluentBitPluginCommonOptions"></a>

Options that are applicable to all Fluent Bit Plugins regardless of type.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitPluginCommonOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitPluginCommonOptions: k8s_aws.FluentBitPluginCommonOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPluginCommonOptions.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPluginCommonOptions.property.pluginType">pluginType</a></code> | <code>cdk-extensions.k8s_aws.FluentBitPluginType</code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitPluginCommonOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitPluginCommonOptions.property.pluginType"></a>

```typescript
public readonly pluginType: FluentBitPluginType;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitPluginType

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

---

### FluentBitRecordModifierFilterOptions <a name="FluentBitRecordModifierFilterOptions" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions"></a>

Options for configuring the Record Modifier Fluent Bit filter plugin.

> [[Record Modifier Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/record-modifier)]([Record Modifier Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/record-modifier))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitRecordModifierFilterOptions: k8s_aws.FluentBitRecordModifierFilterOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.property.allow">allow</a></code> | <code>string[]</code> | If a tag is not match, that field is removed. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.property.records">records</a></code> | <code>cdk-extensions.k8s_aws.AppendedRecord[]</code> | Add fields to the output. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.property.remove">remove</a></code> | <code>string[]</code> | If a tag is match, that field is removed. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `allow`<sup>Optional</sup> <a name="allow" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.property.allow"></a>

```typescript
public readonly allow: string[];
```

- *Type:* string[]

If a tag is not match, that field is removed.

---

##### `records`<sup>Optional</sup> <a name="records" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.property.records"></a>

```typescript
public readonly records: AppendedRecord[];
```

- *Type:* cdk-extensions.k8s_aws.AppendedRecord[]

Add fields to the output.

---

##### `remove`<sup>Optional</sup> <a name="remove" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions.property.remove"></a>

```typescript
public readonly remove: string[];
```

- *Type:* string[]

If a tag is match, that field is removed.

---

### FluentBitRegexParserOptions <a name="FluentBitRegexParserOptions" id="cdk-extensions.k8s_aws.FluentBitRegexParserOptions"></a>

Options for configuring the Regex Fluent Bit parser plugin.

> [[Regex Plugin Documention](https://docs.fluentbit.io/manual/pipeline/parsers/regular-expression)]([Regex Plugin Documention](https://docs.fluentbit.io/manual/pipeline/parsers/regular-expression))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitRegexParserOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitRegexParserOptions: k8s_aws.FluentBitRegexParserOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.regex">regex</a></code> | <code>string</code> | The regular expression to use to parse the incoming records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.skipEmptyValues">skipEmptyValues</a></code> | <code>boolean</code> | If enabled, the parser ignores empty value of the record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.timeFormat">timeFormat</a></code> | <code>string</code> | Defines the format of the timestamp on the inbound record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.timeKey">timeKey</a></code> | <code>string</code> | The key under which timestamp information for the inbound record is given. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.types">types</a></code> | <code>{[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}</code> | Maps group names matched by the regex to the data types they should be interpreted as. |

---

##### `regex`<sup>Required</sup> <a name="regex" id="cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.regex"></a>

```typescript
public readonly regex: string;
```

- *Type:* string

The regular expression to use to parse the incoming records.

Use regex group names to define the name of fields being captured.

---

##### `skipEmptyValues`<sup>Optional</sup> <a name="skipEmptyValues" id="cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.skipEmptyValues"></a>

```typescript
public readonly skipEmptyValues: boolean;
```

- *Type:* boolean

If enabled, the parser ignores empty value of the record.

---

##### `timeFormat`<sup>Optional</sup> <a name="timeFormat" id="cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.timeFormat"></a>

```typescript
public readonly timeFormat: string;
```

- *Type:* string

Defines the format of the timestamp on the inbound record.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

The key under which timestamp information for the inbound record is given.

---

##### `types`<sup>Optional</sup> <a name="types" id="cdk-extensions.k8s_aws.FluentBitRegexParserOptions.property.types"></a>

```typescript
public readonly types: {[ key: string ]: ParserPluginDataType};
```

- *Type:* {[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}

Maps group names matched by the regex to the data types they should be interpreted as.

---

### FluentBitRewriteTagFilterOptions <a name="FluentBitRewriteTagFilterOptions" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions"></a>

Options for configuring the Parser Fluent Bit filter plugin.

> [[Parser Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/parser)]([Parser Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/parser))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitRewriteTagFilterOptions: k8s_aws.FluentBitRewriteTagFilterOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.emitterMemBufLimit">emitterMemBufLimit</a></code> | <code>cdk-extensions.core.DataSize</code> | Set a limit on the amount of memory the tag rewrite emitter can consume if the outputs provide backpressure. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.emitterName">emitterName</a></code> | <code>string</code> | When the filter emits a record under the new Tag, there is an internal emitter plugin that takes care of the job. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.emitterStorageType">emitterStorageType</a></code> | <code>cdk-extensions.k8s_aws.EmitterStorageType</code> | Define a buffering mechanism for the new records created. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.rules">rules</a></code> | <code>cdk-extensions.k8s_aws.RewriteTagRule[]</code> | Defines the matching criteria and the format of the Tag for the matching record. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `emitterMemBufLimit`<sup>Optional</sup> <a name="emitterMemBufLimit" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.emitterMemBufLimit"></a>

```typescript
public readonly emitterMemBufLimit: DataSize;
```

- *Type:* cdk-extensions.core.DataSize
- *Default:* 10M

Set a limit on the amount of memory the tag rewrite emitter can consume if the outputs provide backpressure.

---

##### `emitterName`<sup>Optional</sup> <a name="emitterName" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.emitterName"></a>

```typescript
public readonly emitterName: string;
```

- *Type:* string

When the filter emits a record under the new Tag, there is an internal emitter plugin that takes care of the job.

Since this emitter expose
metrics as any other component of the pipeline, you can use this
property to configure an optional name for it.

---

##### `emitterStorageType`<sup>Optional</sup> <a name="emitterStorageType" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.emitterStorageType"></a>

```typescript
public readonly emitterStorageType: EmitterStorageType;
```

- *Type:* cdk-extensions.k8s_aws.EmitterStorageType

Define a buffering mechanism for the new records created.

Note these records are part of the emitter plugin.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions.property.rules"></a>

```typescript
public readonly rules: RewriteTagRule[];
```

- *Type:* cdk-extensions.k8s_aws.RewriteTagRule[]

Defines the matching criteria and the format of the Tag for the matching record.

---

### FluentBitThrottleFilterOptions <a name="FluentBitThrottleFilterOptions" id="cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions"></a>

Options for configuring the Throttle Fluent Bit filter plugin.

> [[Throttle Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/throttle)]([Throttle Plugin Documention](https://docs.fluentbit.io/manual/pipeline/filters/throttle))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const fluentBitThrottleFilterOptions: k8s_aws.FluentBitThrottleFilterOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.interval">interval</a></code> | <code>aws-cdk-lib.Duration</code> | Time interval. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.printStatus">printStatus</a></code> | <code>boolean</code> | Whether to print status messages with current rate and the limits to information logs. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.rate">rate</a></code> | <code>number</code> | Amount of messages for the time. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.window">window</a></code> | <code>number</code> | Amount of intervals to calculate average over. |

---

##### `match`<sup>Optional</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `interval`<sup>Optional</sup> <a name="interval" id="cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.interval"></a>

```typescript
public readonly interval: Duration;
```

- *Type:* aws-cdk-lib.Duration

Time interval.

---

##### `printStatus`<sup>Optional</sup> <a name="printStatus" id="cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.printStatus"></a>

```typescript
public readonly printStatus: boolean;
```

- *Type:* boolean

Whether to print status messages with current rate and the limits to information logs.

---

##### `rate`<sup>Optional</sup> <a name="rate" id="cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.rate"></a>

```typescript
public readonly rate: number;
```

- *Type:* number

Amount of messages for the time.

---

##### `window`<sup>Optional</sup> <a name="window" id="cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions.property.window"></a>

```typescript
public readonly window: number;
```

- *Type:* number
- *Default:* 5

Amount of intervals to calculate average over.

---

### FourTierNetworkHubProps <a name="FourTierNetworkHubProps" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const fourTierNetworkHubProps: ec2_patterns.FourTierNetworkHubProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.availabilityZones">availabilityZones</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.cidr">cidr</a></code> | <code>cdk-extensions.ec2.ICidrProvider</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.defaultInstanceTenancy">defaultInstanceTenancy</a></code> | <code>aws-cdk-lib.aws_ec2.DefaultInstanceTenancy</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.enableDnsHostnames">enableDnsHostnames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.enableDnsSupport">enableDnsSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.flowLogs">flowLogs</a></code> | <code>{[ key: string ]: cdk-extensions.ec2_patterns.FlowLogOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.gatewayEndpoints">gatewayEndpoints</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.globalNetwork">globalNetwork</a></code> | <code>cdk-extensions.networkmanager.GlobalNetwork</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.maxAzs">maxAzs</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.sharing">sharing</a></code> | <code>cdk-extensions.ec2_patterns.FourTierNetworkShareProperties</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpcName">vpcName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpnConnections">vpnConnections</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.VpnConnectionOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpnGateway">vpnGateway</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpnGatewayAsn">vpnGatewayAsn</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpnRoutePropagation">vpnRoutePropagation</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection[]</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `availabilityZones`<sup>Optional</sup> <a name="availabilityZones" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* string[]

---

##### `cidr`<sup>Optional</sup> <a name="cidr" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.cidr"></a>

```typescript
public readonly cidr: ICidrProvider;
```

- *Type:* cdk-extensions.ec2.ICidrProvider

---

##### `defaultInstanceTenancy`<sup>Optional</sup> <a name="defaultInstanceTenancy" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.defaultInstanceTenancy"></a>

```typescript
public readonly defaultInstanceTenancy: DefaultInstanceTenancy;
```

- *Type:* aws-cdk-lib.aws_ec2.DefaultInstanceTenancy

---

##### `enableDnsHostnames`<sup>Optional</sup> <a name="enableDnsHostnames" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.enableDnsHostnames"></a>

```typescript
public readonly enableDnsHostnames: boolean;
```

- *Type:* boolean

---

##### `enableDnsSupport`<sup>Optional</sup> <a name="enableDnsSupport" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.enableDnsSupport"></a>

```typescript
public readonly enableDnsSupport: boolean;
```

- *Type:* boolean

---

##### `flowLogs`<sup>Optional</sup> <a name="flowLogs" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.flowLogs"></a>

```typescript
public readonly flowLogs: {[ key: string ]: FlowLogOptions};
```

- *Type:* {[ key: string ]: cdk-extensions.ec2_patterns.FlowLogOptions}

---

##### `gatewayEndpoints`<sup>Optional</sup> <a name="gatewayEndpoints" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.gatewayEndpoints"></a>

```typescript
public readonly gatewayEndpoints: {[ key: string ]: GatewayVpcEndpointOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions}

---

##### `globalNetwork`<sup>Optional</sup> <a name="globalNetwork" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.globalNetwork"></a>

```typescript
public readonly globalNetwork: GlobalNetwork;
```

- *Type:* cdk-extensions.networkmanager.GlobalNetwork

---

##### `maxAzs`<sup>Optional</sup> <a name="maxAzs" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.maxAzs"></a>

```typescript
public readonly maxAzs: number;
```

- *Type:* number

---

##### `sharing`<sup>Optional</sup> <a name="sharing" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.sharing"></a>

```typescript
public readonly sharing: FourTierNetworkShareProperties;
```

- *Type:* cdk-extensions.ec2_patterns.FourTierNetworkShareProperties

---

##### `vpcName`<sup>Optional</sup> <a name="vpcName" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* string

---

##### `vpnConnections`<sup>Optional</sup> <a name="vpnConnections" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpnConnections"></a>

```typescript
public readonly vpnConnections: {[ key: string ]: VpnConnectionOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.VpnConnectionOptions}

---

##### `vpnGateway`<sup>Optional</sup> <a name="vpnGateway" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpnGateway"></a>

```typescript
public readonly vpnGateway: boolean;
```

- *Type:* boolean

---

##### `vpnGatewayAsn`<sup>Optional</sup> <a name="vpnGatewayAsn" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpnGatewayAsn"></a>

```typescript
public readonly vpnGatewayAsn: number;
```

- *Type:* number

---

##### `vpnRoutePropagation`<sup>Optional</sup> <a name="vpnRoutePropagation" id="cdk-extensions.ec2_patterns.FourTierNetworkHubProps.property.vpnRoutePropagation"></a>

```typescript
public readonly vpnRoutePropagation: SubnetSelection[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection[]

---

### FourTierNetworkProps <a name="FourTierNetworkProps" id="cdk-extensions.ec2_patterns.FourTierNetworkProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const fourTierNetworkProps: ec2_patterns.FourTierNetworkProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.availabilityZones">availabilityZones</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.cidr">cidr</a></code> | <code>cdk-extensions.ec2.ICidrProvider</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.defaultInstanceTenancy">defaultInstanceTenancy</a></code> | <code>aws-cdk-lib.aws_ec2.DefaultInstanceTenancy</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.enableDnsHostnames">enableDnsHostnames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.enableDnsSupport">enableDnsSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.flowLogs">flowLogs</a></code> | <code>{[ key: string ]: cdk-extensions.ec2_patterns.FlowLogOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.gatewayEndpoints">gatewayEndpoints</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.maxAzs">maxAzs</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.natGatewayProvider">natGatewayProvider</a></code> | <code>aws-cdk-lib.aws_ec2.NatProvider</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.natGateways">natGateways</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.natGatewaySubnets">natGatewaySubnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpcName">vpcName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpnConnections">vpnConnections</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.VpnConnectionOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpnGateway">vpnGateway</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpnGatewayAsn">vpnGatewayAsn</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpnRoutePropagation">vpnRoutePropagation</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection[]</code> | *No description.* |

---

##### `availabilityZones`<sup>Optional</sup> <a name="availabilityZones" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* string[]

---

##### `cidr`<sup>Optional</sup> <a name="cidr" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.cidr"></a>

```typescript
public readonly cidr: ICidrProvider;
```

- *Type:* cdk-extensions.ec2.ICidrProvider

---

##### `defaultInstanceTenancy`<sup>Optional</sup> <a name="defaultInstanceTenancy" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.defaultInstanceTenancy"></a>

```typescript
public readonly defaultInstanceTenancy: DefaultInstanceTenancy;
```

- *Type:* aws-cdk-lib.aws_ec2.DefaultInstanceTenancy

---

##### `enableDnsHostnames`<sup>Optional</sup> <a name="enableDnsHostnames" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.enableDnsHostnames"></a>

```typescript
public readonly enableDnsHostnames: boolean;
```

- *Type:* boolean

---

##### `enableDnsSupport`<sup>Optional</sup> <a name="enableDnsSupport" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.enableDnsSupport"></a>

```typescript
public readonly enableDnsSupport: boolean;
```

- *Type:* boolean

---

##### `flowLogs`<sup>Optional</sup> <a name="flowLogs" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.flowLogs"></a>

```typescript
public readonly flowLogs: {[ key: string ]: FlowLogOptions};
```

- *Type:* {[ key: string ]: cdk-extensions.ec2_patterns.FlowLogOptions}

---

##### `gatewayEndpoints`<sup>Optional</sup> <a name="gatewayEndpoints" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.gatewayEndpoints"></a>

```typescript
public readonly gatewayEndpoints: {[ key: string ]: GatewayVpcEndpointOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions}

---

##### `maxAzs`<sup>Optional</sup> <a name="maxAzs" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.maxAzs"></a>

```typescript
public readonly maxAzs: number;
```

- *Type:* number

---

##### `natGatewayProvider`<sup>Optional</sup> <a name="natGatewayProvider" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.natGatewayProvider"></a>

```typescript
public readonly natGatewayProvider: NatProvider;
```

- *Type:* aws-cdk-lib.aws_ec2.NatProvider

---

##### `natGateways`<sup>Optional</sup> <a name="natGateways" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.natGateways"></a>

```typescript
public readonly natGateways: number;
```

- *Type:* number

---

##### `natGatewaySubnets`<sup>Optional</sup> <a name="natGatewaySubnets" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.natGatewaySubnets"></a>

```typescript
public readonly natGatewaySubnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

---

##### `vpcName`<sup>Optional</sup> <a name="vpcName" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* string

---

##### `vpnConnections`<sup>Optional</sup> <a name="vpnConnections" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpnConnections"></a>

```typescript
public readonly vpnConnections: {[ key: string ]: VpnConnectionOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.VpnConnectionOptions}

---

##### `vpnGateway`<sup>Optional</sup> <a name="vpnGateway" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpnGateway"></a>

```typescript
public readonly vpnGateway: boolean;
```

- *Type:* boolean

---

##### `vpnGatewayAsn`<sup>Optional</sup> <a name="vpnGatewayAsn" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpnGatewayAsn"></a>

```typescript
public readonly vpnGatewayAsn: number;
```

- *Type:* number

---

##### `vpnRoutePropagation`<sup>Optional</sup> <a name="vpnRoutePropagation" id="cdk-extensions.ec2_patterns.FourTierNetworkProps.property.vpnRoutePropagation"></a>

```typescript
public readonly vpnRoutePropagation: SubnetSelection[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection[]

---

### FourTierNetworkShareProperties <a name="FourTierNetworkShareProperties" id="cdk-extensions.ec2_patterns.FourTierNetworkShareProperties"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.FourTierNetworkShareProperties.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const fourTierNetworkShareProperties: ec2_patterns.FourTierNetworkShareProperties = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkShareProperties.property.allowExternalPrincipals">allowExternalPrincipals</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkShareProperties.property.autoAddAccounts">autoAddAccounts</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkShareProperties.property.pricipals">pricipals</a></code> | <code>cdk-extensions.ram.ISharedPrincipal[]</code> | *No description.* |

---

##### `allowExternalPrincipals`<sup>Optional</sup> <a name="allowExternalPrincipals" id="cdk-extensions.ec2_patterns.FourTierNetworkShareProperties.property.allowExternalPrincipals"></a>

```typescript
public readonly allowExternalPrincipals: boolean;
```

- *Type:* boolean

---

##### `autoAddAccounts`<sup>Optional</sup> <a name="autoAddAccounts" id="cdk-extensions.ec2_patterns.FourTierNetworkShareProperties.property.autoAddAccounts"></a>

```typescript
public readonly autoAddAccounts: boolean;
```

- *Type:* boolean

---

##### `pricipals`<sup>Optional</sup> <a name="pricipals" id="cdk-extensions.ec2_patterns.FourTierNetworkShareProperties.property.pricipals"></a>

```typescript
public readonly pricipals: ISharedPrincipal[];
```

- *Type:* cdk-extensions.ram.ISharedPrincipal[]

---

### FourTierNetworkSpokeProps <a name="FourTierNetworkSpokeProps" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const fourTierNetworkSpokeProps: ec2_patterns.FourTierNetworkSpokeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.hub">hub</a></code> | <code>cdk-extensions.ec2_patterns.FourTierNetworkHub</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.availabilityZones">availabilityZones</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.cidr">cidr</a></code> | <code>cdk-extensions.ec2.ICidrProvider</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.defaultInstanceTenancy">defaultInstanceTenancy</a></code> | <code>aws-cdk-lib.aws_ec2.DefaultInstanceTenancy</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.enableDnsHostnames">enableDnsHostnames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.enableDnsSupport">enableDnsSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.flowLogs">flowLogs</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.FlowLogOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.gatewayEndpoints">gatewayEndpoints</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.maxAzs">maxAzs</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpcName">vpcName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpnConnections">vpnConnections</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_ec2.VpnConnectionOptions}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpnGateway">vpnGateway</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpnGatewayAsn">vpnGatewayAsn</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpnRoutePropagation">vpnRoutePropagation</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection[]</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `hub`<sup>Required</sup> <a name="hub" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.hub"></a>

```typescript
public readonly hub: FourTierNetworkHub;
```

- *Type:* cdk-extensions.ec2_patterns.FourTierNetworkHub

---

##### `availabilityZones`<sup>Optional</sup> <a name="availabilityZones" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.availabilityZones"></a>

```typescript
public readonly availabilityZones: string[];
```

- *Type:* string[]

---

##### `cidr`<sup>Optional</sup> <a name="cidr" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.cidr"></a>

```typescript
public readonly cidr: ICidrProvider;
```

- *Type:* cdk-extensions.ec2.ICidrProvider

---

##### `defaultInstanceTenancy`<sup>Optional</sup> <a name="defaultInstanceTenancy" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.defaultInstanceTenancy"></a>

```typescript
public readonly defaultInstanceTenancy: DefaultInstanceTenancy;
```

- *Type:* aws-cdk-lib.aws_ec2.DefaultInstanceTenancy

---

##### `enableDnsHostnames`<sup>Optional</sup> <a name="enableDnsHostnames" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.enableDnsHostnames"></a>

```typescript
public readonly enableDnsHostnames: boolean;
```

- *Type:* boolean

---

##### `enableDnsSupport`<sup>Optional</sup> <a name="enableDnsSupport" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.enableDnsSupport"></a>

```typescript
public readonly enableDnsSupport: boolean;
```

- *Type:* boolean

---

##### `flowLogs`<sup>Optional</sup> <a name="flowLogs" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.flowLogs"></a>

```typescript
public readonly flowLogs: {[ key: string ]: FlowLogOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.FlowLogOptions}

---

##### `gatewayEndpoints`<sup>Optional</sup> <a name="gatewayEndpoints" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.gatewayEndpoints"></a>

```typescript
public readonly gatewayEndpoints: {[ key: string ]: GatewayVpcEndpointOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.GatewayVpcEndpointOptions}

---

##### `maxAzs`<sup>Optional</sup> <a name="maxAzs" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.maxAzs"></a>

```typescript
public readonly maxAzs: number;
```

- *Type:* number

---

##### `vpcName`<sup>Optional</sup> <a name="vpcName" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpcName"></a>

```typescript
public readonly vpcName: string;
```

- *Type:* string

---

##### `vpnConnections`<sup>Optional</sup> <a name="vpnConnections" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpnConnections"></a>

```typescript
public readonly vpnConnections: {[ key: string ]: VpnConnectionOptions};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_ec2.VpnConnectionOptions}

---

##### `vpnGateway`<sup>Optional</sup> <a name="vpnGateway" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpnGateway"></a>

```typescript
public readonly vpnGateway: boolean;
```

- *Type:* boolean

---

##### `vpnGatewayAsn`<sup>Optional</sup> <a name="vpnGatewayAsn" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpnGatewayAsn"></a>

```typescript
public readonly vpnGatewayAsn: number;
```

- *Type:* number

---

##### `vpnRoutePropagation`<sup>Optional</sup> <a name="vpnRoutePropagation" id="cdk-extensions.ec2_patterns.FourTierNetworkSpokeProps.property.vpnRoutePropagation"></a>

```typescript
public readonly vpnRoutePropagation: SubnetSelection[];
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection[]

---

### GlobalNetworkProps <a name="GlobalNetworkProps" id="cdk-extensions.networkmanager.GlobalNetworkProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.networkmanager.GlobalNetworkProps.Initializer"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

const globalNetworkProps: networkmanager.GlobalNetworkProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetworkProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetworkProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetworkProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetworkProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.GlobalNetworkProps.property.description">description</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.networkmanager.GlobalNetworkProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.networkmanager.GlobalNetworkProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.networkmanager.GlobalNetworkProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.networkmanager.GlobalNetworkProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.networkmanager.GlobalNetworkProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

### HiveJsonInputSerDeOptions <a name="HiveJsonInputSerDeOptions" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const hiveJsonInputSerDeOptions: kinesis_firehose.HiveJsonInputSerDeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions.property.timestampFormats">timestampFormats</a></code> | <code>string[]</code> | *No description.* |

---

##### `timestampFormats`<sup>Optional</sup> <a name="timestampFormats" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions.property.timestampFormats"></a>

```typescript
public readonly timestampFormats: string[];
```

- *Type:* string[]

---

### HttpEndpointDestinationOptions <a name="HttpEndpointDestinationOptions" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const httpEndpointDestinationOptions: kinesis_firehose.HttpEndpointDestinationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.accessKey">accessKey</a></code> | <code>aws-cdk-lib.SecretValue</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.backupConfiguration">backupConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.BackupConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.buffering">buffering</a></code> | <code>cdk-extensions.kinesis_firehose.BufferingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.cloudwatchLoggingConfiguration">cloudwatchLoggingConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.commonAttributes">commonAttributes</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.contentEncoding">contentEncoding</a></code> | <code>cdk-extensions.kinesis_firehose.ContentEncoding</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.endpointName">endpointName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.processorConfiguration">processorConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.retryDuration">retryDuration</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |

---

##### `accessKey`<sup>Optional</sup> <a name="accessKey" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.accessKey"></a>

```typescript
public readonly accessKey: SecretValue;
```

- *Type:* aws-cdk-lib.SecretValue

---

##### `backupConfiguration`<sup>Optional</sup> <a name="backupConfiguration" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.backupConfiguration"></a>

```typescript
public readonly backupConfiguration: BackupConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BackupConfiguration

---

##### `buffering`<sup>Optional</sup> <a name="buffering" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.buffering"></a>

```typescript
public readonly buffering: BufferingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BufferingConfiguration

---

##### `cloudwatchLoggingConfiguration`<sup>Optional</sup> <a name="cloudwatchLoggingConfiguration" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.cloudwatchLoggingConfiguration"></a>

```typescript
public readonly cloudwatchLoggingConfiguration: CloudWatchLoggingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration

---

##### `commonAttributes`<sup>Optional</sup> <a name="commonAttributes" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.commonAttributes"></a>

```typescript
public readonly commonAttributes: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `contentEncoding`<sup>Optional</sup> <a name="contentEncoding" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.contentEncoding"></a>

```typescript
public readonly contentEncoding: ContentEncoding;
```

- *Type:* cdk-extensions.kinesis_firehose.ContentEncoding

---

##### `endpointName`<sup>Optional</sup> <a name="endpointName" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.endpointName"></a>

```typescript
public readonly endpointName: string;
```

- *Type:* string

---

##### `processorConfiguration`<sup>Optional</sup> <a name="processorConfiguration" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.processorConfiguration"></a>

```typescript
public readonly processorConfiguration: ProcessorConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorConfiguration

---

##### `retryDuration`<sup>Optional</sup> <a name="retryDuration" id="cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions.property.retryDuration"></a>

```typescript
public readonly retryDuration: Duration;
```

- *Type:* aws-cdk-lib.Duration

---

### InstanceAccessControlAttributeConfigurationProps <a name="InstanceAccessControlAttributeConfigurationProps" id="cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps"></a>

Configuration for InstanceAccessControlAttributeConfiguration resource.

#### Initializer <a name="Initializer" id="cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

const instanceAccessControlAttributeConfigurationProps: sso.InstanceAccessControlAttributeConfigurationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.instance">instance</a></code> | <code>cdk-extensions.sso.IInstance</code> | The ARN of the IAM Identity Center instance under which the operation will be executed. |
| <code><a href="#cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.attributeMapping">attributeMapping</a></code> | <code>{[ key: string ]: string[]}</code> | Lists the attributes that are configured for ABAC in the specified IAM Identity Center instance. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.instance"></a>

```typescript
public readonly instance: IInstance;
```

- *Type:* cdk-extensions.sso.IInstance

The ARN of the IAM Identity Center instance under which the operation will be executed.

---

##### `attributeMapping`<sup>Optional</sup> <a name="attributeMapping" id="cdk-extensions.sso.InstanceAccessControlAttributeConfigurationProps.property.attributeMapping"></a>

```typescript
public readonly attributeMapping: {[ key: string ]: string[]};
```

- *Type:* {[ key: string ]: string[]}

Lists the attributes that are configured for ABAC in the specified IAM Identity Center instance.

---

### IpAddressManagerProps <a name="IpAddressManagerProps" id="cdk-extensions.ec2_patterns.IpAddressManagerProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const ipAddressManagerProps: ec2_patterns.IpAddressManagerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerProps.property.defaultPoolAllocationMask">defaultPoolAllocationMask</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerProps.property.defaultPoolCidrs">defaultPoolCidrs</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerProps.property.regions">regions</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerProps.property.sharing">sharing</a></code> | <code>cdk-extensions.ec2_patterns.IpAddressManagerSharingProps</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `defaultPoolAllocationMask`<sup>Optional</sup> <a name="defaultPoolAllocationMask" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.property.defaultPoolAllocationMask"></a>

```typescript
public readonly defaultPoolAllocationMask: number;
```

- *Type:* number

---

##### `defaultPoolCidrs`<sup>Optional</sup> <a name="defaultPoolCidrs" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.property.defaultPoolCidrs"></a>

```typescript
public readonly defaultPoolCidrs: string[];
```

- *Type:* string[]

---

##### `regions`<sup>Optional</sup> <a name="regions" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.property.regions"></a>

```typescript
public readonly regions: string[];
```

- *Type:* string[]

---

##### `sharing`<sup>Optional</sup> <a name="sharing" id="cdk-extensions.ec2_patterns.IpAddressManagerProps.property.sharing"></a>

```typescript
public readonly sharing: IpAddressManagerSharingProps;
```

- *Type:* cdk-extensions.ec2_patterns.IpAddressManagerSharingProps

---

### IpAddressManagerSharingProps <a name="IpAddressManagerSharingProps" id="cdk-extensions.ec2_patterns.IpAddressManagerSharingProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.IpAddressManagerSharingProps.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const ipAddressManagerSharingProps: ec2_patterns.IpAddressManagerSharingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerSharingProps.property.allowExternalPricipals">allowExternalPricipals</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2_patterns.IpAddressManagerSharingProps.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |

---

##### `allowExternalPricipals`<sup>Optional</sup> <a name="allowExternalPricipals" id="cdk-extensions.ec2_patterns.IpAddressManagerSharingProps.property.allowExternalPricipals"></a>

```typescript
public readonly allowExternalPricipals: boolean;
```

- *Type:* boolean

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.ec2_patterns.IpAddressManagerSharingProps.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

### IpamAllocationOptions <a name="IpamAllocationOptions" id="cdk-extensions.ec2.IpamAllocationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamAllocationOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamAllocationOptions: ec2.IpamAllocationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamAllocationOptions.property.allocation">allocation</a></code> | <code>cdk-extensions.ec2.IIpamAllocationConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocationOptions.property.description">description</a></code> | <code>string</code> | *No description.* |

---

##### `allocation`<sup>Optional</sup> <a name="allocation" id="cdk-extensions.ec2.IpamAllocationOptions.property.allocation"></a>

```typescript
public readonly allocation: IIpamAllocationConfiguration;
```

- *Type:* cdk-extensions.ec2.IIpamAllocationConfiguration

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamAllocationOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

### IpamAllocationProps <a name="IpamAllocationProps" id="cdk-extensions.ec2.IpamAllocationProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamAllocationProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamAllocationProps: ec2.IpamAllocationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamAllocationProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamAllocationProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.IpamAllocationProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.IpamAllocationProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamAllocationProps.property.allocation">allocation</a></code> | <code>cdk-extensions.ec2.IIpamAllocationConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocationProps.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocationProps.property.ipamPool">ipamPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.IpamAllocationProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.IpamAllocationProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.IpamAllocationProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.IpamAllocationProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `allocation`<sup>Optional</sup> <a name="allocation" id="cdk-extensions.ec2.IpamAllocationProps.property.allocation"></a>

```typescript
public readonly allocation: IIpamAllocationConfiguration;
```

- *Type:* cdk-extensions.ec2.IIpamAllocationConfiguration

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamAllocationProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `ipamPool`<sup>Required</sup> <a name="ipamPool" id="cdk-extensions.ec2.IpamAllocationProps.property.ipamPool"></a>

```typescript
public readonly ipamPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

### IpamAttributes <a name="IpamAttributes" id="cdk-extensions.ec2.IpamAttributes"></a>

Configuration for importing an existing IPAM.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamAttributes.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamAttributes: ec2.IpamAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamAttributes.property.ipamArn">ipamArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the IPAM. |
| <code><a href="#cdk-extensions.ec2.IpamAttributes.property.ipamId">ipamId</a></code> | <code>string</code> | The ID generated by AWS for the IPAM. |
| <code><a href="#cdk-extensions.ec2.IpamAttributes.property.privateDefaultScope">privateDefaultScope</a></code> | <code>cdk-extensions.ec2.IIpamScope</code> | The IPAM's default private scope. |
| <code><a href="#cdk-extensions.ec2.IpamAttributes.property.publicDefaultScope">publicDefaultScope</a></code> | <code>cdk-extensions.ec2.IIpamScope</code> | The IPAM's default public scope. |
| <code><a href="#cdk-extensions.ec2.IpamAttributes.property.scopeCount">scopeCount</a></code> | <code>number</code> | The number of scopes in the IPAM. |

---

##### `ipamArn`<sup>Optional</sup> <a name="ipamArn" id="cdk-extensions.ec2.IpamAttributes.property.ipamArn"></a>

```typescript
public readonly ipamArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the IPAM.

---

##### `ipamId`<sup>Optional</sup> <a name="ipamId" id="cdk-extensions.ec2.IpamAttributes.property.ipamId"></a>

```typescript
public readonly ipamId: string;
```

- *Type:* string

The ID generated by AWS for the IPAM.

---

##### `privateDefaultScope`<sup>Optional</sup> <a name="privateDefaultScope" id="cdk-extensions.ec2.IpamAttributes.property.privateDefaultScope"></a>

```typescript
public readonly privateDefaultScope: IIpamScope;
```

- *Type:* cdk-extensions.ec2.IIpamScope

The IPAM's default private scope.

---

##### `publicDefaultScope`<sup>Optional</sup> <a name="publicDefaultScope" id="cdk-extensions.ec2.IpamAttributes.property.publicDefaultScope"></a>

```typescript
public readonly publicDefaultScope: IIpamScope;
```

- *Type:* cdk-extensions.ec2.IIpamScope

The IPAM's default public scope.

---

##### `scopeCount`<sup>Optional</sup> <a name="scopeCount" id="cdk-extensions.ec2.IpamAttributes.property.scopeCount"></a>

```typescript
public readonly scopeCount: number;
```

- *Type:* number

The number of scopes in the IPAM.

---

### IpamPoolCidrProps <a name="IpamPoolCidrProps" id="cdk-extensions.ec2.IpamPoolCidrProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamPoolCidrProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamPoolCidrProps: ec2.IpamPoolCidrProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidrProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidrProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidrProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidrProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidrProps.property.configuration">configuration</a></code> | <code>cdk-extensions.ec2.IIpamPoolCidrConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidrProps.property.ipamPool">ipamPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.IpamPoolCidrProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.IpamPoolCidrProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.IpamPoolCidrProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.IpamPoolCidrProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `configuration`<sup>Required</sup> <a name="configuration" id="cdk-extensions.ec2.IpamPoolCidrProps.property.configuration"></a>

```typescript
public readonly configuration: IIpamPoolCidrConfiguration;
```

- *Type:* cdk-extensions.ec2.IIpamPoolCidrConfiguration

---

##### `ipamPool`<sup>Required</sup> <a name="ipamPool" id="cdk-extensions.ec2.IpamPoolCidrProps.property.ipamPool"></a>

```typescript
public readonly ipamPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

### IpamPoolOptions <a name="IpamPoolOptions" id="cdk-extensions.ec2.IpamPoolOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamPoolOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamPoolOptions: ec2.IpamPoolOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.addressConfiguration">addressConfiguration</a></code> | <code>cdk-extensions.ec2.AddressConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.autoImport">autoImport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.consumer">consumer</a></code> | <code>cdk-extensions.ec2.IpamConsumer</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.locale">locale</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.parentPool">parentPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.provisionedCidrs">provisionedCidrs</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.publicIpSource">publicIpSource</a></code> | <code>cdk-extensions.ec2.PublicIpSource</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolOptions.property.tagRestrictions">tagRestrictions</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `addressConfiguration`<sup>Optional</sup> <a name="addressConfiguration" id="cdk-extensions.ec2.IpamPoolOptions.property.addressConfiguration"></a>

```typescript
public readonly addressConfiguration: AddressConfiguration;
```

- *Type:* cdk-extensions.ec2.AddressConfiguration

---

##### `autoImport`<sup>Optional</sup> <a name="autoImport" id="cdk-extensions.ec2.IpamPoolOptions.property.autoImport"></a>

```typescript
public readonly autoImport: boolean;
```

- *Type:* boolean

---

##### `consumer`<sup>Optional</sup> <a name="consumer" id="cdk-extensions.ec2.IpamPoolOptions.property.consumer"></a>

```typescript
public readonly consumer: IpamConsumer;
```

- *Type:* cdk-extensions.ec2.IpamConsumer

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamPoolOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `locale`<sup>Optional</sup> <a name="locale" id="cdk-extensions.ec2.IpamPoolOptions.property.locale"></a>

```typescript
public readonly locale: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.IpamPoolOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `parentPool`<sup>Optional</sup> <a name="parentPool" id="cdk-extensions.ec2.IpamPoolOptions.property.parentPool"></a>

```typescript
public readonly parentPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `provisionedCidrs`<sup>Optional</sup> <a name="provisionedCidrs" id="cdk-extensions.ec2.IpamPoolOptions.property.provisionedCidrs"></a>

```typescript
public readonly provisionedCidrs: string[];
```

- *Type:* string[]

---

##### `publicIpSource`<sup>Optional</sup> <a name="publicIpSource" id="cdk-extensions.ec2.IpamPoolOptions.property.publicIpSource"></a>

```typescript
public readonly publicIpSource: PublicIpSource;
```

- *Type:* cdk-extensions.ec2.PublicIpSource

---

##### `tagRestrictions`<sup>Optional</sup> <a name="tagRestrictions" id="cdk-extensions.ec2.IpamPoolOptions.property.tagRestrictions"></a>

```typescript
public readonly tagRestrictions: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

### IpamPoolProps <a name="IpamPoolProps" id="cdk-extensions.ec2.IpamPoolProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamPoolProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamPoolProps: ec2.IpamPoolProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.addressConfiguration">addressConfiguration</a></code> | <code>cdk-extensions.ec2.AddressConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.autoImport">autoImport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.consumer">consumer</a></code> | <code>cdk-extensions.ec2.IpamConsumer</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.locale">locale</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.parentPool">parentPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.provisionedCidrs">provisionedCidrs</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.publicIpSource">publicIpSource</a></code> | <code>cdk-extensions.ec2.PublicIpSource</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.tagRestrictions">tagRestrictions</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolProps.property.ipamScope">ipamScope</a></code> | <code>cdk-extensions.ec2.IIpamScope</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.IpamPoolProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.IpamPoolProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.IpamPoolProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.IpamPoolProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `addressConfiguration`<sup>Optional</sup> <a name="addressConfiguration" id="cdk-extensions.ec2.IpamPoolProps.property.addressConfiguration"></a>

```typescript
public readonly addressConfiguration: AddressConfiguration;
```

- *Type:* cdk-extensions.ec2.AddressConfiguration

---

##### `autoImport`<sup>Optional</sup> <a name="autoImport" id="cdk-extensions.ec2.IpamPoolProps.property.autoImport"></a>

```typescript
public readonly autoImport: boolean;
```

- *Type:* boolean

---

##### `consumer`<sup>Optional</sup> <a name="consumer" id="cdk-extensions.ec2.IpamPoolProps.property.consumer"></a>

```typescript
public readonly consumer: IpamConsumer;
```

- *Type:* cdk-extensions.ec2.IpamConsumer

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamPoolProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `locale`<sup>Optional</sup> <a name="locale" id="cdk-extensions.ec2.IpamPoolProps.property.locale"></a>

```typescript
public readonly locale: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.IpamPoolProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `parentPool`<sup>Optional</sup> <a name="parentPool" id="cdk-extensions.ec2.IpamPoolProps.property.parentPool"></a>

```typescript
public readonly parentPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `provisionedCidrs`<sup>Optional</sup> <a name="provisionedCidrs" id="cdk-extensions.ec2.IpamPoolProps.property.provisionedCidrs"></a>

```typescript
public readonly provisionedCidrs: string[];
```

- *Type:* string[]

---

##### `publicIpSource`<sup>Optional</sup> <a name="publicIpSource" id="cdk-extensions.ec2.IpamPoolProps.property.publicIpSource"></a>

```typescript
public readonly publicIpSource: PublicIpSource;
```

- *Type:* cdk-extensions.ec2.PublicIpSource

---

##### `tagRestrictions`<sup>Optional</sup> <a name="tagRestrictions" id="cdk-extensions.ec2.IpamPoolProps.property.tagRestrictions"></a>

```typescript
public readonly tagRestrictions: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `ipamScope`<sup>Required</sup> <a name="ipamScope" id="cdk-extensions.ec2.IpamPoolProps.property.ipamScope"></a>

```typescript
public readonly ipamScope: IIpamScope;
```

- *Type:* cdk-extensions.ec2.IIpamScope

---

### IpamProps <a name="IpamProps" id="cdk-extensions.ec2.IpamProps"></a>

Configuration for the IPAM resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamProps: ec2.IpamProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.IpamProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.IpamProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamProps.property.description">description</a></code> | <code>string</code> | The description for the IPAM. |
| <code><a href="#cdk-extensions.ec2.IpamProps.property.regions">regions</a></code> | <code>string[]</code> | The operating Regions for an IPAM. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.IpamProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.IpamProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.IpamProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.IpamProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The description for the IPAM.

> [[IPAM Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipam.html#cfn-ec2-ipam-description)]([IPAM Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipam.html#cfn-ec2-ipam-description))

---

##### `regions`<sup>Optional</sup> <a name="regions" id="cdk-extensions.ec2.IpamProps.property.regions"></a>

```typescript
public readonly regions: string[];
```

- *Type:* string[]

The operating Regions for an IPAM.

Operating Regions are AWS Regions where
the IPAM is allowed to manage IP address CIDRs. IPAM only discovers and
monitors resources in the AWS Regions you select as operating Regions.

> [[Create an IPAM](https://docs.aws.amazon.com/vpc/latest/ipam/create-ipam.html)]([Create an IPAM](https://docs.aws.amazon.com/vpc/latest/ipam/create-ipam.html))

---

### IpamResourceDiscoveryAssociationProps <a name="IpamResourceDiscoveryAssociationProps" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamResourceDiscoveryAssociationProps: ec2.IpamResourceDiscoveryAssociationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.ipam">ipam</a></code> | <code>cdk-extensions.ec2.IIpam</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.ipamResourceDiscovery">ipamResourceDiscovery</a></code> | <code>cdk-extensions.ec2.IIpamResourceDiscovery</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `ipam`<sup>Required</sup> <a name="ipam" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.ipam"></a>

```typescript
public readonly ipam: IIpam;
```

- *Type:* cdk-extensions.ec2.IIpam

---

##### `ipamResourceDiscovery`<sup>Required</sup> <a name="ipamResourceDiscovery" id="cdk-extensions.ec2.IpamResourceDiscoveryAssociationProps.property.ipamResourceDiscovery"></a>

```typescript
public readonly ipamResourceDiscovery: IIpamResourceDiscovery;
```

- *Type:* cdk-extensions.ec2.IIpamResourceDiscovery

---

### IpamResourceDiscoveryAttributes <a name="IpamResourceDiscoveryAttributes" id="cdk-extensions.ec2.IpamResourceDiscoveryAttributes"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamResourceDiscoveryAttributes.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamResourceDiscoveryAttributes: ec2.IpamResourceDiscoveryAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.isDefault">isDefault</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.ownerId">ownerId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.region">region</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.resourceDiscoveryArn">resourceDiscoveryArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.resourceDiscoveryId">resourceDiscoveryId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.state">state</a></code> | <code>string</code> | *No description.* |

---

##### `isDefault`<sup>Optional</sup> <a name="isDefault" id="cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.isDefault"></a>

```typescript
public readonly isDefault: boolean;
```

- *Type:* boolean

---

##### `ownerId`<sup>Optional</sup> <a name="ownerId" id="cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.ownerId"></a>

```typescript
public readonly ownerId: string;
```

- *Type:* string

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

---

##### `resourceDiscoveryArn`<sup>Optional</sup> <a name="resourceDiscoveryArn" id="cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.resourceDiscoveryArn"></a>

```typescript
public readonly resourceDiscoveryArn: string;
```

- *Type:* string

---

##### `resourceDiscoveryId`<sup>Optional</sup> <a name="resourceDiscoveryId" id="cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.resourceDiscoveryId"></a>

```typescript
public readonly resourceDiscoveryId: string;
```

- *Type:* string

---

##### `state`<sup>Optional</sup> <a name="state" id="cdk-extensions.ec2.IpamResourceDiscoveryAttributes.property.state"></a>

```typescript
public readonly state: string;
```

- *Type:* string

---

### IpamResourceDiscoveryProps <a name="IpamResourceDiscoveryProps" id="cdk-extensions.ec2.IpamResourceDiscoveryProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamResourceDiscoveryProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamResourceDiscoveryProps: ec2.IpamResourceDiscoveryProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryProps.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamResourceDiscoveryProps.property.regions">regions</a></code> | <code>string[]</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.IpamResourceDiscoveryProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.IpamResourceDiscoveryProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.IpamResourceDiscoveryProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.IpamResourceDiscoveryProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamResourceDiscoveryProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `regions`<sup>Optional</sup> <a name="regions" id="cdk-extensions.ec2.IpamResourceDiscoveryProps.property.regions"></a>

```typescript
public readonly regions: string[];
```

- *Type:* string[]

---

### IpamScopeAttributes <a name="IpamScopeAttributes" id="cdk-extensions.ec2.IpamScopeAttributes"></a>

Configuration for importing an existing IPAM scope.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamScopeAttributes.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamScopeAttributes: ec2.IpamScopeAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamScopeAttributes.property.ipam">ipam</a></code> | <code>cdk-extensions.ec2.IIpam</code> | The IPAM to which the scope belongs. |
| <code><a href="#cdk-extensions.ec2.IpamScopeAttributes.property.ipamScopeArn">ipamScopeArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the IPAM scope. |
| <code><a href="#cdk-extensions.ec2.IpamScopeAttributes.property.ipamScopeId">ipamScopeId</a></code> | <code>string</code> | The ID generated by AWS for the IPAM scope. |
| <code><a href="#cdk-extensions.ec2.IpamScopeAttributes.property.isDefault">isDefault</a></code> | <code>boolean</code> | Defines if the scope is the default scope or not. |
| <code><a href="#cdk-extensions.ec2.IpamScopeAttributes.property.poolCount">poolCount</a></code> | <code>number</code> | The number of pools in a scope. |
| <code><a href="#cdk-extensions.ec2.IpamScopeAttributes.property.scopeType">scopeType</a></code> | <code>string</code> | The type of the scope. |

---

##### `ipam`<sup>Optional</sup> <a name="ipam" id="cdk-extensions.ec2.IpamScopeAttributes.property.ipam"></a>

```typescript
public readonly ipam: IIpam;
```

- *Type:* cdk-extensions.ec2.IIpam

The IPAM to which the scope belongs.

---

##### `ipamScopeArn`<sup>Optional</sup> <a name="ipamScopeArn" id="cdk-extensions.ec2.IpamScopeAttributes.property.ipamScopeArn"></a>

```typescript
public readonly ipamScopeArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the IPAM scope.

---

##### `ipamScopeId`<sup>Optional</sup> <a name="ipamScopeId" id="cdk-extensions.ec2.IpamScopeAttributes.property.ipamScopeId"></a>

```typescript
public readonly ipamScopeId: string;
```

- *Type:* string

The ID generated by AWS for the IPAM scope.

---

##### `isDefault`<sup>Optional</sup> <a name="isDefault" id="cdk-extensions.ec2.IpamScopeAttributes.property.isDefault"></a>

```typescript
public readonly isDefault: boolean;
```

- *Type:* boolean

Defines if the scope is the default scope or not.

---

##### `poolCount`<sup>Optional</sup> <a name="poolCount" id="cdk-extensions.ec2.IpamScopeAttributes.property.poolCount"></a>

```typescript
public readonly poolCount: number;
```

- *Type:* number

The number of pools in a scope.

---

##### `scopeType`<sup>Optional</sup> <a name="scopeType" id="cdk-extensions.ec2.IpamScopeAttributes.property.scopeType"></a>

```typescript
public readonly scopeType: string;
```

- *Type:* string

The type of the scope.

---

### IpamScopeOptions <a name="IpamScopeOptions" id="cdk-extensions.ec2.IpamScopeOptions"></a>

Optional configuration for the IPAM scope resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamScopeOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamScopeOptions: ec2.IpamScopeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamScopeOptions.property.description">description</a></code> | <code>string</code> | The description of the scope. |

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamScopeOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The description of the scope.

> [[IPAMScope Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-description)]([IPAMScope Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-description))

---

### IpamScopeProps <a name="IpamScopeProps" id="cdk-extensions.ec2.IpamScopeProps"></a>

Configuration for the IPAM scope resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.IpamScopeProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipamScopeProps: ec2.IpamScopeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamScopeProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamScopeProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.IpamScopeProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.IpamScopeProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IpamScopeProps.property.description">description</a></code> | <code>string</code> | The description of the scope. |
| <code><a href="#cdk-extensions.ec2.IpamScopeProps.property.ipam">ipam</a></code> | <code>cdk-extensions.ec2.IIpam</code> | The IPAM for which you're creating this scope. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.IpamScopeProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.IpamScopeProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.IpamScopeProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.IpamScopeProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.IpamScopeProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The description of the scope.

> [[IPAMScope Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-description)]([IPAMScope Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-description))

---

##### `ipam`<sup>Required</sup> <a name="ipam" id="cdk-extensions.ec2.IpamScopeProps.property.ipam"></a>

```typescript
public readonly ipam: IIpam;
```

- *Type:* cdk-extensions.ec2.IIpam

The IPAM for which you're creating this scope.

> [[IPAMScope IpamId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-ipamid)]([IPAMScope IpamId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-ipamscope.html#cfn-ec2-ipamscope-ipamid))

---

### Ipv4ConfigurationOptions <a name="Ipv4ConfigurationOptions" id="cdk-extensions.ec2.Ipv4ConfigurationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.Ipv4ConfigurationOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipv4ConfigurationOptions: ec2.Ipv4ConfigurationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.Ipv4ConfigurationOptions.property.defaultNetmaskLength">defaultNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.Ipv4ConfigurationOptions.property.maxNetmaskLength">maxNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.Ipv4ConfigurationOptions.property.minNetmaskLength">minNetmaskLength</a></code> | <code>number</code> | *No description.* |

---

##### `defaultNetmaskLength`<sup>Optional</sup> <a name="defaultNetmaskLength" id="cdk-extensions.ec2.Ipv4ConfigurationOptions.property.defaultNetmaskLength"></a>

```typescript
public readonly defaultNetmaskLength: number;
```

- *Type:* number

---

##### `maxNetmaskLength`<sup>Optional</sup> <a name="maxNetmaskLength" id="cdk-extensions.ec2.Ipv4ConfigurationOptions.property.maxNetmaskLength"></a>

```typescript
public readonly maxNetmaskLength: number;
```

- *Type:* number

---

##### `minNetmaskLength`<sup>Optional</sup> <a name="minNetmaskLength" id="cdk-extensions.ec2.Ipv4ConfigurationOptions.property.minNetmaskLength"></a>

```typescript
public readonly minNetmaskLength: number;
```

- *Type:* number

---

### Ipv6ConfigurationOptions <a name="Ipv6ConfigurationOptions" id="cdk-extensions.ec2.Ipv6ConfigurationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.Ipv6ConfigurationOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const ipv6ConfigurationOptions: ec2.Ipv6ConfigurationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.Ipv6ConfigurationOptions.property.defaultNetmaskLength">defaultNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.Ipv6ConfigurationOptions.property.maxNetmaskLength">maxNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.Ipv6ConfigurationOptions.property.minNetmaskLength">minNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.Ipv6ConfigurationOptions.property.publiclyAdvertisable">publiclyAdvertisable</a></code> | <code>boolean</code> | *No description.* |

---

##### `defaultNetmaskLength`<sup>Optional</sup> <a name="defaultNetmaskLength" id="cdk-extensions.ec2.Ipv6ConfigurationOptions.property.defaultNetmaskLength"></a>

```typescript
public readonly defaultNetmaskLength: number;
```

- *Type:* number

---

##### `maxNetmaskLength`<sup>Optional</sup> <a name="maxNetmaskLength" id="cdk-extensions.ec2.Ipv6ConfigurationOptions.property.maxNetmaskLength"></a>

```typescript
public readonly maxNetmaskLength: number;
```

- *Type:* number

---

##### `minNetmaskLength`<sup>Optional</sup> <a name="minNetmaskLength" id="cdk-extensions.ec2.Ipv6ConfigurationOptions.property.minNetmaskLength"></a>

```typescript
public readonly minNetmaskLength: number;
```

- *Type:* number

---

##### `publiclyAdvertisable`<sup>Optional</sup> <a name="publiclyAdvertisable" id="cdk-extensions.ec2.Ipv6ConfigurationOptions.property.publiclyAdvertisable"></a>

```typescript
public readonly publiclyAdvertisable: boolean;
```

- *Type:* boolean

---

### JdbcConnectionProps <a name="JdbcConnectionProps" id="cdk-extensions.glue.JdbcConnectionProps"></a>

Configuration for the Glue Workflow resource.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.JdbcConnectionProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const jdbcConnectionProps: glue.JdbcConnectionProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.password">password</a></code> | <code>aws-cdk-lib.SecretValue</code> | A SecretValue providing the password for the Connection to authenticate to the source with. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.url">url</a></code> | <code>string</code> | The URL to the source for the Connection. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.username">username</a></code> | <code>string</code> | The username for the Connection to authenticate to the source with. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | VPC to attach to the Connection. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.description">description</a></code> | <code>string</code> | A description of the Connection. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.enforceSsl">enforceSsl</a></code> | <code>boolean</code> | Boolean value on whether to require encryption on the Connection. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.name">name</a></code> | <code>string</code> | A name for the Connection. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.securityGroups">securityGroups</a></code> | <code>aws-cdk-lib.aws_ec2.ISecurityGroup[]</code> | A list of Security Groups to apply to the Connection. |
| <code><a href="#cdk-extensions.glue.JdbcConnectionProps.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | Options for selection of subnets from the VPC to attach to the Connection. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.JdbcConnectionProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.JdbcConnectionProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.JdbcConnectionProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.JdbcConnectionProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `password`<sup>Required</sup> <a name="password" id="cdk-extensions.glue.JdbcConnectionProps.property.password"></a>

```typescript
public readonly password: SecretValue;
```

- *Type:* aws-cdk-lib.SecretValue

A SecretValue providing the password for the Connection to authenticate to the source with.

> [[AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype)]([AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype))

---

##### `url`<sup>Required</sup> <a name="url" id="cdk-extensions.glue.JdbcConnectionProps.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

The URL to the source for the Connection.

> [[AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype)]([AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype))

---

##### `username`<sup>Required</sup> <a name="username" id="cdk-extensions.glue.JdbcConnectionProps.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

The username for the Connection to authenticate to the source with.

> [[AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype)]([AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype))

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.glue.JdbcConnectionProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

VPC to attach to the Connection.

> [[IVpc Interface](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.IVpc.html)]([IVpc Interface](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.IVpc.html))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.JdbcConnectionProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A description of the Connection.

---

##### `enforceSsl`<sup>Optional</sup> <a name="enforceSsl" id="cdk-extensions.glue.JdbcConnectionProps.property.enforceSsl"></a>

```typescript
public readonly enforceSsl: boolean;
```

- *Type:* boolean

Boolean value on whether to require encryption on the Connection.

> [[AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype)]([AWS::Glue::Connection ConnectionInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-connection-connectioninput.html#cfn-glue-connection-connectioninput-connectiontype))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.JdbcConnectionProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A name for the Connection.

---

##### `securityGroups`<sup>Optional</sup> <a name="securityGroups" id="cdk-extensions.glue.JdbcConnectionProps.property.securityGroups"></a>

```typescript
public readonly securityGroups: ISecurityGroup[];
```

- *Type:* aws-cdk-lib.aws_ec2.ISecurityGroup[]

A list of Security Groups to apply to the Connection.

---

##### `subnets`<sup>Optional</sup> <a name="subnets" id="cdk-extensions.glue.JdbcConnectionProps.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

Options for selection of subnets from the VPC to attach to the Connection.

> [[CDK SubnetSelection](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.SubnetSelection.html)]([CDK SubnetSelection](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.SubnetSelection.html))

---

### JdbcTargetOptions <a name="JdbcTargetOptions" id="cdk-extensions.glue.JdbcTargetOptions"></a>

Configuration for Crawler JDBC target.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.JdbcTargetOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const jdbcTargetOptions: glue.JdbcTargetOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcTargetOptions.property.exclusions">exclusions</a></code> | <code>string[]</code> | A list of glob patterns used to exclude from the crawl. |
| <code><a href="#cdk-extensions.glue.JdbcTargetOptions.property.paths">paths</a></code> | <code>string[]</code> | The path of the JDBC target. |

---

##### `exclusions`<sup>Optional</sup> <a name="exclusions" id="cdk-extensions.glue.JdbcTargetOptions.property.exclusions"></a>

```typescript
public readonly exclusions: string[];
```

- *Type:* string[]

A list of glob patterns used to exclude from the crawl.

For more information

> [[Catalog Tables with a Crawler](https://docs.aws.amazon.com/glue/latest/dg/add-crawler.html)]([Catalog Tables with a Crawler](https://docs.aws.amazon.com/glue/latest/dg/add-crawler.html))

---

##### `paths`<sup>Optional</sup> <a name="paths" id="cdk-extensions.glue.JdbcTargetOptions.property.paths"></a>

```typescript
public readonly paths: string[];
```

- *Type:* string[]

The path of the JDBC target.

> [[AWS::Glue::Crawler JdbcTarget](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-jdbctarget.html#cfn-glue-crawler-jdbctarget-path)]([AWS::Glue::Crawler JdbcTarget](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-jdbctarget.html#cfn-glue-crawler-jdbctarget-path))

---

### JobBookmarksEncryption <a name="JobBookmarksEncryption" id="cdk-extensions.glue.JobBookmarksEncryption"></a>

Job bookmarks encryption configuration.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.JobBookmarksEncryption.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const jobBookmarksEncryption: glue.JobBookmarksEncryption = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JobBookmarksEncryption.property.mode">mode</a></code> | <code>cdk-extensions.glue.JobBookmarksEncryptionMode</code> | Encryption mode. |
| <code><a href="#cdk-extensions.glue.JobBookmarksEncryption.property.kmsKey">kmsKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | The KMS key to be used to encrypt the data. |

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk-extensions.glue.JobBookmarksEncryption.property.mode"></a>

```typescript
public readonly mode: JobBookmarksEncryptionMode;
```

- *Type:* cdk-extensions.glue.JobBookmarksEncryptionMode

Encryption mode.

---

##### `kmsKey`<sup>Optional</sup> <a name="kmsKey" id="cdk-extensions.glue.JobBookmarksEncryption.property.kmsKey"></a>

```typescript
public readonly kmsKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey
- *Default:* A key will be created if one is not provided.

The KMS key to be used to encrypt the data.

---

### JobExecutableConfig <a name="JobExecutableConfig" id="cdk-extensions.glue.JobExecutableConfig"></a>

Result of binding a `JobExecutable` into a `Job`.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.JobExecutableConfig.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const jobExecutableConfig: glue.JobExecutableConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.glueVersion">glueVersion</a></code> | <code>cdk-extensions.glue.GlueVersion</code> | Glue version. |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.language">language</a></code> | <code>cdk-extensions.glue.JobLanguage</code> | The language of the job (Scala or Python). |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.script">script</a></code> | <code>cdk-extensions.glue.Code</code> | The script that is executed by a job. |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.type">type</a></code> | <code>cdk-extensions.glue.JobType</code> | Specify the type of the job whether it's an Apache Spark ETL or streaming one or if it's a Python shell job. |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.className">className</a></code> | <code>string</code> | The Scala class that serves as the entry point for the job. |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.extraFiles">extraFiles</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional files, such as configuration files that AWS Glue copies to the working directory of your script before executing it. |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.extraJars">extraJars</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional Java .jar files that AWS Glue adds to the Java classpath before executing your script. |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.extraJarsFirst">extraJarsFirst</a></code> | <code>boolean</code> | Setting this value to true prioritizes the customer's extra JAR files in the classpath. |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.extraPythonFiles">extraPythonFiles</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional Python files that AWS Glue adds to the Python path before executing your script. |
| <code><a href="#cdk-extensions.glue.JobExecutableConfig.property.pythonVersion">pythonVersion</a></code> | <code>cdk-extensions.glue.PythonVersion</code> | The Python version to use. |

---

##### `glueVersion`<sup>Required</sup> <a name="glueVersion" id="cdk-extensions.glue.JobExecutableConfig.property.glueVersion"></a>

```typescript
public readonly glueVersion: GlueVersion;
```

- *Type:* cdk-extensions.glue.GlueVersion

Glue version.

> [https://docs.aws.amazon.com/glue/latest/dg/release-notes.html](https://docs.aws.amazon.com/glue/latest/dg/release-notes.html)

---

##### `language`<sup>Required</sup> <a name="language" id="cdk-extensions.glue.JobExecutableConfig.property.language"></a>

```typescript
public readonly language: JobLanguage;
```

- *Type:* cdk-extensions.glue.JobLanguage

The language of the job (Scala or Python).

> [`--job-language` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--job-language` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `script`<sup>Required</sup> <a name="script" id="cdk-extensions.glue.JobExecutableConfig.property.script"></a>

```typescript
public readonly script: Code;
```

- *Type:* cdk-extensions.glue.Code

The script that is executed by a job.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk-extensions.glue.JobExecutableConfig.property.type"></a>

```typescript
public readonly type: JobType;
```

- *Type:* cdk-extensions.glue.JobType

Specify the type of the job whether it's an Apache Spark ETL or streaming one or if it's a Python shell job.

---

##### `className`<sup>Optional</sup> <a name="className" id="cdk-extensions.glue.JobExecutableConfig.property.className"></a>

```typescript
public readonly className: string;
```

- *Type:* string
- *Default:* no scala className specified

The Scala class that serves as the entry point for the job.

This applies only if your the job langauage is Scala.

> [`--class` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--class` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraFiles`<sup>Optional</sup> <a name="extraFiles" id="cdk-extensions.glue.JobExecutableConfig.property.extraFiles"></a>

```typescript
public readonly extraFiles: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* no extra files specified.

Additional files, such as configuration files that AWS Glue copies to the working directory of your script before executing it.

> [`--extra-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraJars`<sup>Optional</sup> <a name="extraJars" id="cdk-extensions.glue.JobExecutableConfig.property.extraJars"></a>

```typescript
public readonly extraJars: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* no extra jars specified.

Additional Java .jar files that AWS Glue adds to the Java classpath before executing your script.

> [`--extra-jars` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-jars` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraJarsFirst`<sup>Optional</sup> <a name="extraJarsFirst" id="cdk-extensions.glue.JobExecutableConfig.property.extraJarsFirst"></a>

```typescript
public readonly extraJarsFirst: boolean;
```

- *Type:* boolean
- *Default:* extra jars are not prioritized.

Setting this value to true prioritizes the customer's extra JAR files in the classpath.

> [`--user-jars-first` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--user-jars-first` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraPythonFiles`<sup>Optional</sup> <a name="extraPythonFiles" id="cdk-extensions.glue.JobExecutableConfig.property.extraPythonFiles"></a>

```typescript
public readonly extraPythonFiles: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* no extra python files specified.

Additional Python files that AWS Glue adds to the Python path before executing your script.

> [`--extra-py-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-py-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `pythonVersion`<sup>Optional</sup> <a name="pythonVersion" id="cdk-extensions.glue.JobExecutableConfig.property.pythonVersion"></a>

```typescript
public readonly pythonVersion: PythonVersion;
```

- *Type:* cdk-extensions.glue.PythonVersion
- *Default:* no python version specified

The Python version to use.

---

### JobProps <a name="JobProps" id="cdk-extensions.glue.JobProps"></a>

Configuration for the Glue Job resource.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.JobProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const jobProps: glue.JobProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JobProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.JobProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.JobProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.JobProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.JobProps.property.executable">executable</a></code> | <code>cdk-extensions.glue.JobExecutable</code> | Executable properties for the Job. |
| <code><a href="#cdk-extensions.glue.JobProps.property.allocatedCapacity">allocatedCapacity</a></code> | <code>number</code> | The number of capacity units that are allocated to this job. |
| <code><a href="#cdk-extensions.glue.JobProps.property.connections">connections</a></code> | <code>cdk-extensions.glue.Connection[]</code> | List of Connections for use with this job. |
| <code><a href="#cdk-extensions.glue.JobProps.property.continuousLogging">continuousLogging</a></code> | <code>cdk-extensions.glue.ContinuousLoggingProps</code> | Set of properties for configuration of Continuous Logging. |
| <code><a href="#cdk-extensions.glue.JobProps.property.defaultArguments">defaultArguments</a></code> | <code>{[ key: string ]: string}</code> | The default arguments for this job, specified as name-value pairs. |
| <code><a href="#cdk-extensions.glue.JobProps.property.description">description</a></code> | <code>string</code> | A description of the job. |
| <code><a href="#cdk-extensions.glue.JobProps.property.enableProfilingMetrics">enableProfilingMetrics</a></code> | <code>boolean</code> | Boolean value for whether to enable Profiling Metrics. |
| <code><a href="#cdk-extensions.glue.JobProps.property.maxCapacity">maxCapacity</a></code> | <code>number</code> | The number of AWS Glue data processing units (DPUs) that can be allocated when this job runs. |
| <code><a href="#cdk-extensions.glue.JobProps.property.maxConcurrentRuns">maxConcurrentRuns</a></code> | <code>number</code> | Maximum number of concurrent executions. |
| <code><a href="#cdk-extensions.glue.JobProps.property.maxRetries">maxRetries</a></code> | <code>number</code> | The maximum number of times to retry this job after a JobRun fails. |
| <code><a href="#cdk-extensions.glue.JobProps.property.name">name</a></code> | <code>string</code> | A name for the Job. |
| <code><a href="#cdk-extensions.glue.JobProps.property.notifyDelayAfter">notifyDelayAfter</a></code> | <code>aws-cdk-lib.Duration</code> | After a job run starts, the number of minutes to wait before sending a job run delay notification. |
| <code><a href="#cdk-extensions.glue.JobProps.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | The name or Amazon Resource Name (ARN) of the IAM role associated with this job. |
| <code><a href="#cdk-extensions.glue.JobProps.property.securityConfiguration">securityConfiguration</a></code> | <code>cdk-extensions.glue.SecurityConfiguration</code> | The Security Configuration object to be applied to the Job. |
| <code><a href="#cdk-extensions.glue.JobProps.property.timeout">timeout</a></code> | <code>aws-cdk-lib.Duration</code> | The job timeout in minutes. |
| <code><a href="#cdk-extensions.glue.JobProps.property.workerCount">workerCount</a></code> | <code>number</code> | The number of worker available the Job. |
| <code><a href="#cdk-extensions.glue.JobProps.property.workerType">workerType</a></code> | <code>cdk-extensions.glue.WorkerType</code> | The type of predefined worker that is allocated when a job runs. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.JobProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.JobProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.JobProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.JobProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `executable`<sup>Required</sup> <a name="executable" id="cdk-extensions.glue.JobProps.property.executable"></a>

```typescript
public readonly executable: JobExecutable;
```

- *Type:* cdk-extensions.glue.JobExecutable

Executable properties for the Job.

---

##### `allocatedCapacity`<sup>Optional</sup> <a name="allocatedCapacity" id="cdk-extensions.glue.JobProps.property.allocatedCapacity"></a>

```typescript
public readonly allocatedCapacity: number;
```

- *Type:* number

The number of capacity units that are allocated to this job.

> [[AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-allocatedcapacity)]([AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-allocatedcapacity))

---

##### `connections`<sup>Optional</sup> <a name="connections" id="cdk-extensions.glue.JobProps.property.connections"></a>

```typescript
public readonly connections: Connection[];
```

- *Type:* cdk-extensions.glue.Connection[]

List of Connections for use with this job.

> [[AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-connections)]([AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-connections))

---

##### `continuousLogging`<sup>Optional</sup> <a name="continuousLogging" id="cdk-extensions.glue.JobProps.property.continuousLogging"></a>

```typescript
public readonly continuousLogging: ContinuousLoggingProps;
```

- *Type:* cdk-extensions.glue.ContinuousLoggingProps

Set of properties for configuration of Continuous Logging.

---

##### `defaultArguments`<sup>Optional</sup> <a name="defaultArguments" id="cdk-extensions.glue.JobProps.property.defaultArguments"></a>

```typescript
public readonly defaultArguments: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The default arguments for this job, specified as name-value pairs.

You can specify arguments here that your own job-execution script consumes, in addition to arguments that AWS Glue itself consumes.

> [[AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-defaultarguments)]([AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-defaultarguments))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.JobProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A description of the job.

---

##### `enableProfilingMetrics`<sup>Optional</sup> <a name="enableProfilingMetrics" id="cdk-extensions.glue.JobProps.property.enableProfilingMetrics"></a>

```typescript
public readonly enableProfilingMetrics: boolean;
```

- *Type:* boolean

Boolean value for whether to enable Profiling Metrics.

---

##### `maxCapacity`<sup>Optional</sup> <a name="maxCapacity" id="cdk-extensions.glue.JobProps.property.maxCapacity"></a>

```typescript
public readonly maxCapacity: number;
```

- *Type:* number

The number of AWS Glue data processing units (DPUs) that can be allocated when this job runs.

A DPU is a relative measure of processing power that consists of 4 vCPUs of compute capacity and 16 GB of memory.

Do not set Max Capacity if using WorkerType and NumberOfWorkers.

The value that can be allocated for MaxCapacity depends on whether you are running a Python shell job or an Apache Spark ETL job:

    - When you specify a Python shell job (JobCommand.Name="pythonshell"), you can allocate either 0.0625 or 1 DPU. The default is 0.0625 DPU.

    - When you specify an Apache Spark ETL job (JobCommand.Name="glueetl"), you can allocate from 2 to 100 DPUs. The default is 10 DPUs. This job type cannot have a fractional DPU allocation.

---

##### `maxConcurrentRuns`<sup>Optional</sup> <a name="maxConcurrentRuns" id="cdk-extensions.glue.JobProps.property.maxConcurrentRuns"></a>

```typescript
public readonly maxConcurrentRuns: number;
```

- *Type:* number

Maximum number of concurrent executions.

> [[AWS::Glue::Job ExecutionProperty](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-job-executionproperty.html)]([AWS::Glue::Job ExecutionProperty](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-job-executionproperty.html))

---

##### `maxRetries`<sup>Optional</sup> <a name="maxRetries" id="cdk-extensions.glue.JobProps.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* number

The maximum number of times to retry this job after a JobRun fails.

> [[AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-maxretries)]([AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-maxretries))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.JobProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A name for the Job.

---

##### `notifyDelayAfter`<sup>Optional</sup> <a name="notifyDelayAfter" id="cdk-extensions.glue.JobProps.property.notifyDelayAfter"></a>

```typescript
public readonly notifyDelayAfter: Duration;
```

- *Type:* aws-cdk-lib.Duration

After a job run starts, the number of minutes to wait before sending a job run delay notification.

> [[AWS::Glue::Job NotificationProperty](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-job-notificationproperty.html)]([AWS::Glue::Job NotificationProperty](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-job-notificationproperty.html))

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.glue.JobProps.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

The name or Amazon Resource Name (ARN) of the IAM role associated with this job.

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.JobProps.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: SecurityConfiguration;
```

- *Type:* cdk-extensions.glue.SecurityConfiguration

The Security Configuration object to be applied to the Job.

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="cdk-extensions.glue.JobProps.property.timeout"></a>

```typescript
public readonly timeout: Duration;
```

- *Type:* aws-cdk-lib.Duration

The job timeout in minutes.

This is the maximum time that a job run can consume resources before it is terminated and enters TIMEOUT status. The default is 2,880 minutes (48 hours).

> [[AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-timeout)]([AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-timeout))

---

##### `workerCount`<sup>Optional</sup> <a name="workerCount" id="cdk-extensions.glue.JobProps.property.workerCount"></a>

```typescript
public readonly workerCount: number;
```

- *Type:* number

The number of worker available the Job.

---

##### `workerType`<sup>Optional</sup> <a name="workerType" id="cdk-extensions.glue.JobProps.property.workerType"></a>

```typescript
public readonly workerType: WorkerType;
```

- *Type:* cdk-extensions.glue.WorkerType

The type of predefined worker that is allocated when a job runs.

Accepts a value of Standard, G.1X, or G.2X.

> [[AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-workertype)]([AWS::Glue::Job](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-job.html#cfn-glue-job-workertype))

---

### JsonPartitioningOptions <a name="JsonPartitioningOptions" id="cdk-extensions.kinesis_firehose.JsonPartitioningOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.JsonPartitioningOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const jsonPartitioningOptions: kinesis_firehose.JsonPartitioningOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningOptions.property.retryInterval">retryInterval</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningOptions.property.partitions">partitions</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.JsonPartitioningOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `retryInterval`<sup>Optional</sup> <a name="retryInterval" id="cdk-extensions.kinesis_firehose.JsonPartitioningOptions.property.retryInterval"></a>

```typescript
public readonly retryInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

---

##### `partitions`<sup>Required</sup> <a name="partitions" id="cdk-extensions.kinesis_firehose.JsonPartitioningOptions.property.partitions"></a>

```typescript
public readonly partitions: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

### LambdaPartitioningOptions <a name="LambdaPartitioningOptions" id="cdk-extensions.kinesis_firehose.LambdaPartitioningOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.LambdaPartitioningOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const lambdaPartitioningOptions: kinesis_firehose.LambdaPartitioningOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningOptions.property.retryInterval">retryInterval</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningOptions.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | *No description.* |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.LambdaPartitioningOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `retryInterval`<sup>Optional</sup> <a name="retryInterval" id="cdk-extensions.kinesis_firehose.LambdaPartitioningOptions.property.retryInterval"></a>

```typescript
public readonly retryInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="cdk-extensions.kinesis_firehose.LambdaPartitioningOptions.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

### LambdaProcessorOptions <a name="LambdaProcessorOptions" id="cdk-extensions.kinesis_firehose.LambdaProcessorOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.LambdaProcessorOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const lambdaProcessorOptions: kinesis_firehose.LambdaProcessorOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaProcessorOptions.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | *No description.* |

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="cdk-extensions.kinesis_firehose.LambdaProcessorOptions.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---

### LiftOptions <a name="LiftOptions" id="cdk-extensions.k8s_aws.LiftOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.LiftOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const liftOptions: k8s_aws.LiftOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.LiftOptions.property.nestedUnder">nestedUnder</a></code> | <code>string</code> | Lift records nested under the this key. |

---

##### `nestedUnder`<sup>Required</sup> <a name="nestedUnder" id="cdk-extensions.k8s_aws.LiftOptions.property.nestedUnder"></a>

```typescript
public readonly nestedUnder: string;
```

- *Type:* string

Lift records nested under the this key.

---

### LocalVpnEndpointConfiguration <a name="LocalVpnEndpointConfiguration" id="cdk-extensions.ec2.LocalVpnEndpointConfiguration"></a>

Configuration object containing the vlues needed to configure the local end of a VPN connection.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.LocalVpnEndpointConfiguration.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const localVpnEndpointConfiguration: ec2.LocalVpnEndpointConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.LocalVpnEndpointConfiguration.property.transitGatewayId">transitGatewayId</a></code> | <code>string</code> | The ID of the transit gateway that serves as the local end of the VPN connection. |
| <code><a href="#cdk-extensions.ec2.LocalVpnEndpointConfiguration.property.vpnGatewayId">vpnGatewayId</a></code> | <code>string</code> | The ID of the VPN gateway that serves as the local end of the VPN connection. |

---

##### `transitGatewayId`<sup>Optional</sup> <a name="transitGatewayId" id="cdk-extensions.ec2.LocalVpnEndpointConfiguration.property.transitGatewayId"></a>

```typescript
public readonly transitGatewayId: string;
```

- *Type:* string

The ID of the transit gateway that serves as the local end of the VPN connection.

---

##### `vpnGatewayId`<sup>Optional</sup> <a name="vpnGatewayId" id="cdk-extensions.ec2.LocalVpnEndpointConfiguration.property.vpnGatewayId"></a>

```typescript
public readonly vpnGatewayId: string;
```

- *Type:* string

The ID of the VPN gateway that serves as the local end of the VPN connection.

---

### LoggingAspectOptions <a name="LoggingAspectOptions" id="cdk-extensions.s3_buckets.LoggingAspectOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.LoggingAspectOptions.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const loggingAspectOptions: s3_buckets.LoggingAspectOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.LoggingAspectOptions.property.exclusions">exclusions</a></code> | <code>constructs.IConstruct[]</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.LoggingAspectOptions.property.force">force</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.LoggingAspectOptions.property.prefix">prefix</a></code> | <code>string</code> | *No description.* |

---

##### `exclusions`<sup>Optional</sup> <a name="exclusions" id="cdk-extensions.s3_buckets.LoggingAspectOptions.property.exclusions"></a>

```typescript
public readonly exclusions: IConstruct[];
```

- *Type:* constructs.IConstruct[]

---

##### `force`<sup>Optional</sup> <a name="force" id="cdk-extensions.s3_buckets.LoggingAspectOptions.property.force"></a>

```typescript
public readonly force: boolean;
```

- *Type:* boolean

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk-extensions.s3_buckets.LoggingAspectOptions.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

---

### LogRetentionControllerProps <a name="LogRetentionControllerProps" id="cdk-extensions.lambda.LogRetentionControllerProps"></a>

Configuration for the LogRetentionController resource.

#### Initializer <a name="Initializer" id="cdk-extensions.lambda.LogRetentionControllerProps.Initializer"></a>

```typescript
import { lambda } from 'cdk-extensions'

const logRetentionControllerProps: lambda.LogRetentionControllerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.lambda.LogRetentionControllerProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.lambda.LogRetentionControllerProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.lambda.LogRetentionControllerProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.lambda.LogRetentionControllerProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.lambda.LogRetentionControllerProps.property.executionLogging">executionLogging</a></code> | <code>cdk-extensions.lambda.ExecutionLogOptions</code> | Execution logging configuration for the state machine that is used to configure log retention for log groups created via AWS Lambda. |
| <code><a href="#cdk-extensions.lambda.LogRetentionControllerProps.property.retention">retention</a></code> | <code>aws-cdk-lib.aws_logs.RetentionDays</code> | The length of time logs sent to log groups created by AWS Lambda should be retained before being deleted. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.lambda.LogRetentionControllerProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.lambda.LogRetentionControllerProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.lambda.LogRetentionControllerProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.lambda.LogRetentionControllerProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `executionLogging`<sup>Optional</sup> <a name="executionLogging" id="cdk-extensions.lambda.LogRetentionControllerProps.property.executionLogging"></a>

```typescript
public readonly executionLogging: ExecutionLogOptions;
```

- *Type:* cdk-extensions.lambda.ExecutionLogOptions

Execution logging configuration for the state machine that is used to configure log retention for log groups created via AWS Lambda.

> [[StateMachine LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-stepfunctions-statemachine.html#cfn-stepfunctions-statemachine-loggingconfiguration)]([StateMachine LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-stepfunctions-statemachine.html#cfn-stepfunctions-statemachine-loggingconfiguration))

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.lambda.LogRetentionControllerProps.property.retention"></a>

```typescript
public readonly retention: RetentionDays;
```

- *Type:* aws-cdk-lib.aws_logs.RetentionDays

The length of time logs sent to log groups created by AWS Lambda should be retained before being deleted.

> [[LogGroup RetentionInDays](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-logs-loggroup.html#cfn-logs-loggroup-retentionindays)]([LogGroup RetentionInDays](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-logs-loggroup.html#cfn-logs-loggroup-retentionindays))

---

### MetadataExtractionProcessorOptions <a name="MetadataExtractionProcessorOptions" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessorOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessorOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const metadataExtractionProcessorOptions: kinesis_firehose.MetadataExtractionProcessorOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.MetadataExtractionProcessorOptions.property.query">query</a></code> | <code>cdk-extensions.kinesis_firehose.MetaDataExtractionQuery</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.MetadataExtractionProcessorOptions.property.engine">engine</a></code> | <code>cdk-extensions.kinesis_firehose.JsonParsingEngine</code> | *No description.* |

---

##### `query`<sup>Required</sup> <a name="query" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessorOptions.property.query"></a>

```typescript
public readonly query: MetaDataExtractionQuery;
```

- *Type:* cdk-extensions.kinesis_firehose.MetaDataExtractionQuery

---

##### `engine`<sup>Optional</sup> <a name="engine" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessorOptions.property.engine"></a>

```typescript
public readonly engine: JsonParsingEngine;
```

- *Type:* cdk-extensions.kinesis_firehose.JsonParsingEngine

---

### MonthRange <a name="MonthRange" id="cdk-extensions.aps.MonthRange"></a>

A range of calendar months identified by number, where January = 1.

Ranges are also accepted by specifying `end` inclusive on both ends.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.MonthRange.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const monthRange: aps.MonthRange = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.MonthRange.property.start">start</a></code> | <code>number</code> | The month where the range should start. |
| <code><a href="#cdk-extensions.aps.MonthRange.property.end">end</a></code> | <code>number</code> | The month at the end of the range if the range should cover multiple months (inclusive). |

---

##### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.MonthRange.property.start"></a>

```typescript
public readonly start: number;
```

- *Type:* number

The month where the range should start.

---

##### `end`<sup>Optional</sup> <a name="end" id="cdk-extensions.aps.MonthRange.property.end"></a>

```typescript
public readonly end: number;
```

- *Type:* number

The month at the end of the range if the range should cover multiple months (inclusive).

---

### NamedQueryProps <a name="NamedQueryProps" id="cdk-extensions.athena.NamedQueryProps"></a>

Configuration for a NamedQuery.

#### Initializer <a name="Initializer" id="cdk-extensions.athena.NamedQueryProps.Initializer"></a>

```typescript
import { athena } from 'cdk-extensions'

const namedQueryProps: athena.NamedQueryProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.athena.NamedQueryProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.athena.NamedQueryProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.athena.NamedQueryProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.athena.NamedQueryProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.athena.NamedQueryProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | The Glue database to which the query belongs. |
| <code><a href="#cdk-extensions.athena.NamedQueryProps.property.queryString">queryString</a></code> | <code>string</code> | The SQL statements that make up the query. |
| <code><a href="#cdk-extensions.athena.NamedQueryProps.property.description">description</a></code> | <code>string</code> | A human friendly description explaining the functionality of the query. |
| <code><a href="#cdk-extensions.athena.NamedQueryProps.property.name">name</a></code> | <code>string</code> | The name of the query. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.athena.NamedQueryProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.athena.NamedQueryProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.athena.NamedQueryProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.athena.NamedQueryProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.athena.NamedQueryProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

The Glue database to which the query belongs.

> [[NamedQuery Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-database)]([NamedQuery Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-database))

---

##### `queryString`<sup>Required</sup> <a name="queryString" id="cdk-extensions.athena.NamedQueryProps.property.queryString"></a>

```typescript
public readonly queryString: string;
```

- *Type:* string

The SQL statements that make up the query.

> [[Athena SQL reference](https://docs.aws.amazon.com/athena/latest/ug/ddl-sql-reference.html)]([Athena SQL reference](https://docs.aws.amazon.com/athena/latest/ug/ddl-sql-reference.html))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.athena.NamedQueryProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A human friendly description explaining the functionality of the query.

> [[NamedQuery Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-description)]([NamedQuery Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-description))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.athena.NamedQueryProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the query.

> [[NamedQuery Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-name)]([NamedQuery Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-athena-namedquery.html#cfn-athena-namedquery-name))

---

### NamespacedExternalSecretOptions <a name="NamespacedExternalSecretOptions" id="cdk-extensions.k8s_aws.NamespacedExternalSecretOptions"></a>

Configuration options for adding a Kubernetes secret synced from an external provider to a specific Kubernetes namespace.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.NamespacedExternalSecretOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const namespacedExternalSecretOptions: k8s_aws.NamespacedExternalSecretOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.NamespacedExternalSecretOptions.property.fields">fields</a></code> | <code>cdk-extensions.k8s_aws.SecretFieldReference[]</code> | A collection of field mappings that tells the external secrets operator the structure of the Kubernetes secret to create and which how fields in the Kubernetes secret should map to fields in the secret from the external secret provider. |
| <code><a href="#cdk-extensions.k8s_aws.NamespacedExternalSecretOptions.property.name">name</a></code> | <code>string</code> | The name of the Kubernetes secret that will be created, as it will appear from within the Kubernetes cluster. |
| <code><a href="#cdk-extensions.k8s_aws.NamespacedExternalSecretOptions.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the synced secret should be created. |

---

##### `fields`<sup>Optional</sup> <a name="fields" id="cdk-extensions.k8s_aws.NamespacedExternalSecretOptions.property.fields"></a>

```typescript
public readonly fields: SecretFieldReference[];
```

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference[]
- *Default:* The Kubernetes secret will mirror the fields from the secret in the external provider.

A collection of field mappings that tells the external secrets operator the structure of the Kubernetes secret to create and which how fields in the Kubernetes secret should map to fields in the secret from the external secret provider.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.k8s_aws.NamespacedExternalSecretOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* A name will be auto-generated.

The name of the Kubernetes secret that will be created, as it will appear from within the Kubernetes cluster.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.NamespacedExternalSecretOptions.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string
- *Default:* 'default'

The Kubernetes namespace where the synced secret should be created.

---

### NestOptions <a name="NestOptions" id="cdk-extensions.k8s_aws.NestOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.NestOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const nestOptions: k8s_aws.NestOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.NestOptions.property.nestUnder">nestUnder</a></code> | <code>string</code> | Nest records matching `wildcard` under this key. |
| <code><a href="#cdk-extensions.k8s_aws.NestOptions.property.wildcards">wildcards</a></code> | <code>string[]</code> | Nest records which field matches this wildcard,. |

---

##### `nestUnder`<sup>Required</sup> <a name="nestUnder" id="cdk-extensions.k8s_aws.NestOptions.property.nestUnder"></a>

```typescript
public readonly nestUnder: string;
```

- *Type:* string

Nest records matching `wildcard` under this key.

---

##### `wildcards`<sup>Required</sup> <a name="wildcards" id="cdk-extensions.k8s_aws.NestOptions.property.wildcards"></a>

```typescript
public readonly wildcards: string[];
```

- *Type:* string[]

Nest records which field matches this wildcard,.

---

### NetmaskLengthOptions <a name="NetmaskLengthOptions" id="cdk-extensions.ec2.NetmaskLengthOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.NetmaskLengthOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const netmaskLengthOptions: ec2.NetmaskLengthOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.NetmaskLengthOptions.property.defaultNetmaskLength">defaultNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.NetmaskLengthOptions.property.maxNetmaskLength">maxNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.NetmaskLengthOptions.property.minNetmaskLength">minNetmaskLength</a></code> | <code>number</code> | *No description.* |

---

##### `defaultNetmaskLength`<sup>Optional</sup> <a name="defaultNetmaskLength" id="cdk-extensions.ec2.NetmaskLengthOptions.property.defaultNetmaskLength"></a>

```typescript
public readonly defaultNetmaskLength: number;
```

- *Type:* number

---

##### `maxNetmaskLength`<sup>Optional</sup> <a name="maxNetmaskLength" id="cdk-extensions.ec2.NetmaskLengthOptions.property.maxNetmaskLength"></a>

```typescript
public readonly maxNetmaskLength: number;
```

- *Type:* number

---

##### `minNetmaskLength`<sup>Optional</sup> <a name="minNetmaskLength" id="cdk-extensions.ec2.NetmaskLengthOptions.property.minNetmaskLength"></a>

```typescript
public readonly minNetmaskLength: number;
```

- *Type:* number

---

### NetworkControllerProps <a name="NetworkControllerProps" id="cdk-extensions.ec2_patterns.NetworkControllerProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.NetworkControllerProps.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const networkControllerProps: ec2_patterns.NetworkControllerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkControllerProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkControllerProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkControllerProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkControllerProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2_patterns.NetworkControllerProps.property.defaultNetmask">defaultNetmask</a></code> | <code>number</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2_patterns.NetworkControllerProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2_patterns.NetworkControllerProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2_patterns.NetworkControllerProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2_patterns.NetworkControllerProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `defaultNetmask`<sup>Optional</sup> <a name="defaultNetmask" id="cdk-extensions.ec2_patterns.NetworkControllerProps.property.defaultNetmask"></a>

```typescript
public readonly defaultNetmask: number;
```

- *Type:* number

---

### OpenxJsonInputSerDeOptions <a name="OpenxJsonInputSerDeOptions" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const openxJsonInputSerDeOptions: kinesis_firehose.OpenxJsonInputSerDeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions.property.caseInsensitive">caseInsensitive</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions.property.columnKeyMappings">columnKeyMappings</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions.property.convertDotsToUnderscores">convertDotsToUnderscores</a></code> | <code>boolean</code> | *No description.* |

---

##### `caseInsensitive`<sup>Optional</sup> <a name="caseInsensitive" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions.property.caseInsensitive"></a>

```typescript
public readonly caseInsensitive: boolean;
```

- *Type:* boolean

---

##### `columnKeyMappings`<sup>Optional</sup> <a name="columnKeyMappings" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions.property.columnKeyMappings"></a>

```typescript
public readonly columnKeyMappings: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `convertDotsToUnderscores`<sup>Optional</sup> <a name="convertDotsToUnderscores" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions.property.convertDotsToUnderscores"></a>

```typescript
public readonly convertDotsToUnderscores: boolean;
```

- *Type:* boolean

---

### OrcOutputSerDeOptions <a name="OrcOutputSerDeOptions" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const orcOutputSerDeOptions: kinesis_firehose.OrcOutputSerDeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.blockSizeBytes">blockSizeBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.bloomFilterColumns">bloomFilterColumns</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.bloomFilterFalsePositiveProbability">bloomFilterFalsePositiveProbability</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.compression">compression</a></code> | <code>cdk-extensions.kinesis_firehose.OrcCompressionFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.dictionaryKeyThreshold">dictionaryKeyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.enablePadding">enablePadding</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.formatVersion">formatVersion</a></code> | <code>cdk-extensions.kinesis_firehose.OrcFormatVersion</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.paddingTolerance">paddingTolerance</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.rowIndexStride">rowIndexStride</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.stripeSizeBytes">stripeSizeBytes</a></code> | <code>number</code> | *No description.* |

---

##### `blockSizeBytes`<sup>Optional</sup> <a name="blockSizeBytes" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.blockSizeBytes"></a>

```typescript
public readonly blockSizeBytes: number;
```

- *Type:* number

---

##### `bloomFilterColumns`<sup>Optional</sup> <a name="bloomFilterColumns" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.bloomFilterColumns"></a>

```typescript
public readonly bloomFilterColumns: string[];
```

- *Type:* string[]

---

##### `bloomFilterFalsePositiveProbability`<sup>Optional</sup> <a name="bloomFilterFalsePositiveProbability" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.bloomFilterFalsePositiveProbability"></a>

```typescript
public readonly bloomFilterFalsePositiveProbability: number;
```

- *Type:* number

---

##### `compression`<sup>Optional</sup> <a name="compression" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.compression"></a>

```typescript
public readonly compression: OrcCompressionFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.OrcCompressionFormat

---

##### `dictionaryKeyThreshold`<sup>Optional</sup> <a name="dictionaryKeyThreshold" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.dictionaryKeyThreshold"></a>

```typescript
public readonly dictionaryKeyThreshold: number;
```

- *Type:* number

---

##### `enablePadding`<sup>Optional</sup> <a name="enablePadding" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.enablePadding"></a>

```typescript
public readonly enablePadding: boolean;
```

- *Type:* boolean

---

##### `formatVersion`<sup>Optional</sup> <a name="formatVersion" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.formatVersion"></a>

```typescript
public readonly formatVersion: OrcFormatVersion;
```

- *Type:* cdk-extensions.kinesis_firehose.OrcFormatVersion

---

##### `paddingTolerance`<sup>Optional</sup> <a name="paddingTolerance" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.paddingTolerance"></a>

```typescript
public readonly paddingTolerance: number;
```

- *Type:* number

---

##### `rowIndexStride`<sup>Optional</sup> <a name="rowIndexStride" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.rowIndexStride"></a>

```typescript
public readonly rowIndexStride: number;
```

- *Type:* number

---

##### `stripeSizeBytes`<sup>Optional</sup> <a name="stripeSizeBytes" id="cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions.property.stripeSizeBytes"></a>

```typescript
public readonly stripeSizeBytes: number;
```

- *Type:* number

---

### ParquetOutputSerDeOptions <a name="ParquetOutputSerDeOptions" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const parquetOutputSerDeOptions: kinesis_firehose.ParquetOutputSerDeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.blockSizeBytes">blockSizeBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.compression">compression</a></code> | <code>cdk-extensions.kinesis_firehose.ParquetCompressionFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.enableDictionaryCompression">enableDictionaryCompression</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.maxPaddingBytes">maxPaddingBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.pageSizeBytes">pageSizeBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.writerVersion">writerVersion</a></code> | <code>cdk-extensions.kinesis_firehose.ParquetWriterVersion</code> | *No description.* |

---

##### `blockSizeBytes`<sup>Optional</sup> <a name="blockSizeBytes" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.blockSizeBytes"></a>

```typescript
public readonly blockSizeBytes: number;
```

- *Type:* number

---

##### `compression`<sup>Optional</sup> <a name="compression" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.compression"></a>

```typescript
public readonly compression: ParquetCompressionFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.ParquetCompressionFormat

---

##### `enableDictionaryCompression`<sup>Optional</sup> <a name="enableDictionaryCompression" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.enableDictionaryCompression"></a>

```typescript
public readonly enableDictionaryCompression: boolean;
```

- *Type:* boolean

---

##### `maxPaddingBytes`<sup>Optional</sup> <a name="maxPaddingBytes" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.maxPaddingBytes"></a>

```typescript
public readonly maxPaddingBytes: number;
```

- *Type:* number

---

##### `pageSizeBytes`<sup>Optional</sup> <a name="pageSizeBytes" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.pageSizeBytes"></a>

```typescript
public readonly pageSizeBytes: number;
```

- *Type:* number

---

##### `writerVersion`<sup>Optional</sup> <a name="writerVersion" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions.property.writerVersion"></a>

```typescript
public readonly writerVersion: ParquetWriterVersion;
```

- *Type:* cdk-extensions.kinesis_firehose.ParquetWriterVersion

---

### PermissionSetProps <a name="PermissionSetProps" id="cdk-extensions.sso.PermissionSetProps"></a>

Configuration for PermissionSet resource.

#### Initializer <a name="Initializer" id="cdk-extensions.sso.PermissionSetProps.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

const permissionSetProps: sso.PermissionSetProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.instance">instance</a></code> | <code>cdk-extensions.sso.IInstance</code> | The ARN of the IAM Identity Center instance under which the operation will be executed. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.description">description</a></code> | <code>string</code> | A user friendly description providing details about the permission set. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.inlinePolicies">inlinePolicies</a></code> | <code>{[ key: string ]: aws-cdk-lib.aws_iam.PolicyDocument}</code> | Adds inline policy documents that will be embedded in the permission set. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.managedPolicies">managedPolicies</a></code> | <code>aws-cdk-lib.aws_iam.IManagedPolicy[]</code> | A list of the IAM managed policies that you want to attach to the permission set. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.name">name</a></code> | <code>string</code> | The name of the permission set. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.permissionsBoundary">permissionsBoundary</a></code> | <code>cdk-extensions.sso.PermissionsBoundary</code> | Specifies the configuration of the AWS managed or customer managed policy that you want to set as a permissions boundary. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.relayState">relayState</a></code> | <code>string</code> | Used to redirect users within the application during the federation authentication process. |
| <code><a href="#cdk-extensions.sso.PermissionSetProps.property.sessionDuration">sessionDuration</a></code> | <code>aws-cdk-lib.Duration</code> | The length of time that the application user sessions are valid for. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.sso.PermissionSetProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.sso.PermissionSetProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.sso.PermissionSetProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.sso.PermissionSetProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk-extensions.sso.PermissionSetProps.property.instance"></a>

```typescript
public readonly instance: IInstance;
```

- *Type:* cdk-extensions.sso.IInstance

The ARN of the IAM Identity Center instance under which the operation will be executed.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.sso.PermissionSetProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A user friendly description providing details about the permission set.

> [[AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-description)]([AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-description))

---

##### `inlinePolicies`<sup>Optional</sup> <a name="inlinePolicies" id="cdk-extensions.sso.PermissionSetProps.property.inlinePolicies"></a>

```typescript
public readonly inlinePolicies: {[ key: string ]: PolicyDocument};
```

- *Type:* {[ key: string ]: aws-cdk-lib.aws_iam.PolicyDocument}

Adds inline policy documents that will be embedded in the permission set.

> [[AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-inlinepolicy)]([AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-inlinepolicy))

---

##### `managedPolicies`<sup>Optional</sup> <a name="managedPolicies" id="cdk-extensions.sso.PermissionSetProps.property.managedPolicies"></a>

```typescript
public readonly managedPolicies: IManagedPolicy[];
```

- *Type:* aws-cdk-lib.aws_iam.IManagedPolicy[]

A list of the IAM managed policies that you want to attach to the permission set.

Managed policies specified here must be AWS managed.
To reference custom managed policies use the {@link PermissionSet.addCustomerManagedPolicy}
method.

> [[AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-managedpolicies)]([AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-managedpolicies))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.sso.PermissionSetProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the permission set.

> [[AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-name)]([AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-name))

---

##### `permissionsBoundary`<sup>Optional</sup> <a name="permissionsBoundary" id="cdk-extensions.sso.PermissionSetProps.property.permissionsBoundary"></a>

```typescript
public readonly permissionsBoundary: PermissionsBoundary;
```

- *Type:* cdk-extensions.sso.PermissionsBoundary

Specifies the configuration of the AWS managed or customer managed policy that you want to set as a permissions boundary.

Specify either
CustomerManagedPolicyReference to use the name and path of a customer
managed policy, or ManagedPolicyArn to use the ARN of an AWS managed
policy. A permissions boundary represents the maximum permissions that
any policy can grant your role. For more information, see [Permissions
boundaries](https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies_boundaries.html) for IAM entities in the AWS Identity and Access Management
User Guide.

> [[AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-permissionsboundary)]([AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-permissionsboundary))

---

##### `relayState`<sup>Optional</sup> <a name="relayState" id="cdk-extensions.sso.PermissionSetProps.property.relayState"></a>

```typescript
public readonly relayState: string;
```

- *Type:* string

Used to redirect users within the application during the federation authentication process.

For example, you can redirect users to a
specific page that is most applicable to their job after singing in to
an AWS account.

> [[AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-relaystatetype)]([AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-relaystatetype))

---

##### `sessionDuration`<sup>Optional</sup> <a name="sessionDuration" id="cdk-extensions.sso.PermissionSetProps.property.sessionDuration"></a>

```typescript
public readonly sessionDuration: Duration;
```

- *Type:* aws-cdk-lib.Duration

The length of time that the application user sessions are valid for.

> [[AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-sessionduration)]([AWS::SSO::PermissionSet](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-permissionset.html#cfn-sso-permissionset-sessionduration))

---

### ProcessorConfigurationOptions <a name="ProcessorConfigurationOptions" id="cdk-extensions.kinesis_firehose.ProcessorConfigurationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.ProcessorConfigurationOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const processorConfigurationOptions: kinesis_firehose.ProcessorConfigurationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorConfigurationOptions.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorConfigurationOptions.property.processors">processors</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]</code> | *No description.* |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.ProcessorConfigurationOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `processors`<sup>Optional</sup> <a name="processors" id="cdk-extensions.kinesis_firehose.ProcessorConfigurationOptions.property.processors"></a>

```typescript
public readonly processors: DeliveryStreamProcessor[];
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]

---

### ProcessorConfigurationResult <a name="ProcessorConfigurationResult" id="cdk-extensions.kinesis_firehose.ProcessorConfigurationResult"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.ProcessorConfigurationResult.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const processorConfigurationResult: kinesis_firehose.ProcessorConfigurationResult = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorConfigurationResult.property.processors">processors</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorConfigurationResult.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |

---

##### `processors`<sup>Required</sup> <a name="processors" id="cdk-extensions.kinesis_firehose.ProcessorConfigurationResult.property.processors"></a>

```typescript
public readonly processors: DeliveryStreamProcessor[];
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.ProcessorConfigurationResult.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

### PrometheusOptions <a name="PrometheusOptions" id="cdk-extensions.k8s_fargate.PrometheusOptions"></a>

Optional configurations for the Prometheus resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_fargate.PrometheusOptions.Initializer"></a>

```typescript
import { k8s_fargate } from 'cdk-extensions'

const prometheusOptions: k8s_fargate.PrometheusOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusOptions.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be deployed. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusOptions.property.queueConfiguration">queueConfiguration</a></code> | <code>cdk-extensions.k8s_fargate.QueueConfiguration</code> | {@inheritdoc QueueConfiguration}. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusOptions.property.serviceAccountName">serviceAccountName</a></code> | <code>string</code> | Name of the Kubernetes service account that should be created and used by Prometheus. |

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_fargate.PrometheusOptions.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the service should be deployed.

---

##### `queueConfiguration`<sup>Optional</sup> <a name="queueConfiguration" id="cdk-extensions.k8s_fargate.PrometheusOptions.property.queueConfiguration"></a>

```typescript
public readonly queueConfiguration: QueueConfiguration;
```

- *Type:* cdk-extensions.k8s_fargate.QueueConfiguration

{@inheritdoc QueueConfiguration}.

---

##### `serviceAccountName`<sup>Optional</sup> <a name="serviceAccountName" id="cdk-extensions.k8s_fargate.PrometheusOptions.property.serviceAccountName"></a>

```typescript
public readonly serviceAccountName: string;
```

- *Type:* string

Name of the Kubernetes service account that should be created and used by Prometheus.

---

### PrometheusProps <a name="PrometheusProps" id="cdk-extensions.k8s_fargate.PrometheusProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_fargate.PrometheusProps.Initializer"></a>

```typescript
import { k8s_fargate } from 'cdk-extensions'

const prometheusProps: k8s_fargate.PrometheusProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be deployed. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.queueConfiguration">queueConfiguration</a></code> | <code>cdk-extensions.k8s_fargate.QueueConfiguration</code> | {@inheritdoc QueueConfiguration}. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.serviceAccountName">serviceAccountName</a></code> | <code>string</code> | Name of the Kubernetes service account that should be created and used by Prometheus. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.Cluster</code> | The EKS cluster where Prometheus should be deployed. |
| <code><a href="#cdk-extensions.k8s_fargate.PrometheusProps.property.workspace">workspace</a></code> | <code>cdk-extensions.aps.IWorkspace</code> | The Amazon Managed Service for Prometheus workspace where the Prometheus server should sned its data. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_fargate.PrometheusProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_fargate.PrometheusProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_fargate.PrometheusProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_fargate.PrometheusProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_fargate.PrometheusProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the service should be deployed.

---

##### `queueConfiguration`<sup>Optional</sup> <a name="queueConfiguration" id="cdk-extensions.k8s_fargate.PrometheusProps.property.queueConfiguration"></a>

```typescript
public readonly queueConfiguration: QueueConfiguration;
```

- *Type:* cdk-extensions.k8s_fargate.QueueConfiguration

{@inheritdoc QueueConfiguration}.

---

##### `serviceAccountName`<sup>Optional</sup> <a name="serviceAccountName" id="cdk-extensions.k8s_fargate.PrometheusProps.property.serviceAccountName"></a>

```typescript
public readonly serviceAccountName: string;
```

- *Type:* string

Name of the Kubernetes service account that should be created and used by Prometheus.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_fargate.PrometheusProps.property.cluster"></a>

```typescript
public readonly cluster: Cluster;
```

- *Type:* aws-cdk-lib.aws_eks.Cluster

The EKS cluster where Prometheus should be deployed.

---

##### `workspace`<sup>Required</sup> <a name="workspace" id="cdk-extensions.k8s_fargate.PrometheusProps.property.workspace"></a>

```typescript
public readonly workspace: IWorkspace;
```

- *Type:* cdk-extensions.aps.IWorkspace

The Amazon Managed Service for Prometheus workspace where the Prometheus server should sned its data.

---

### PythonShellExecutableProps <a name="PythonShellExecutableProps" id="cdk-extensions.glue.PythonShellExecutableProps"></a>

Props for creating a Python shell job executable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.PythonShellExecutableProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const pythonShellExecutableProps: glue.PythonShellExecutableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.PythonShellExecutableProps.property.glueVersion">glueVersion</a></code> | <code>cdk-extensions.glue.GlueVersion</code> | Glue version. |
| <code><a href="#cdk-extensions.glue.PythonShellExecutableProps.property.pythonVersion">pythonVersion</a></code> | <code>cdk-extensions.glue.PythonVersion</code> | The Python version to use. |
| <code><a href="#cdk-extensions.glue.PythonShellExecutableProps.property.script">script</a></code> | <code>cdk-extensions.glue.Code</code> | The script that executes a job. |
| <code><a href="#cdk-extensions.glue.PythonShellExecutableProps.property.extraFiles">extraFiles</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional files, such as configuration files that AWS Glue copies to the working directory of your script before executing it. |
| <code><a href="#cdk-extensions.glue.PythonShellExecutableProps.property.extraPythonFiles">extraPythonFiles</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional Python files that AWS Glue adds to the Python path before executing your script. |

---

##### `glueVersion`<sup>Required</sup> <a name="glueVersion" id="cdk-extensions.glue.PythonShellExecutableProps.property.glueVersion"></a>

```typescript
public readonly glueVersion: GlueVersion;
```

- *Type:* cdk-extensions.glue.GlueVersion

Glue version.

> [https://docs.aws.amazon.com/glue/latest/dg/release-notes.html](https://docs.aws.amazon.com/glue/latest/dg/release-notes.html)

---

##### `pythonVersion`<sup>Required</sup> <a name="pythonVersion" id="cdk-extensions.glue.PythonShellExecutableProps.property.pythonVersion"></a>

```typescript
public readonly pythonVersion: PythonVersion;
```

- *Type:* cdk-extensions.glue.PythonVersion

The Python version to use.

---

##### `script`<sup>Required</sup> <a name="script" id="cdk-extensions.glue.PythonShellExecutableProps.property.script"></a>

```typescript
public readonly script: Code;
```

- *Type:* cdk-extensions.glue.Code

The script that executes a job.

---

##### `extraFiles`<sup>Optional</sup> <a name="extraFiles" id="cdk-extensions.glue.PythonShellExecutableProps.property.extraFiles"></a>

```typescript
public readonly extraFiles: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* [] - no extra files are copied to the working directory

Additional files, such as configuration files that AWS Glue copies to the working directory of your script before executing it.

Only individual files are supported, directories are not supported.

> [`--extra-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraPythonFiles`<sup>Optional</sup> <a name="extraPythonFiles" id="cdk-extensions.glue.PythonShellExecutableProps.property.extraPythonFiles"></a>

```typescript
public readonly extraPythonFiles: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* no extra python files and argument is not set

Additional Python files that AWS Glue adds to the Python path before executing your script.

Only individual files are supported, directories are not supported.

> [`--extra-py-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-py-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

### PythonSparkJobExecutableProps <a name="PythonSparkJobExecutableProps" id="cdk-extensions.glue.PythonSparkJobExecutableProps"></a>

Props for creating a Python Spark (ETL or Streaming) job executable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.PythonSparkJobExecutableProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const pythonSparkJobExecutableProps: glue.PythonSparkJobExecutableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.PythonSparkJobExecutableProps.property.glueVersion">glueVersion</a></code> | <code>cdk-extensions.glue.GlueVersion</code> | Glue version. |
| <code><a href="#cdk-extensions.glue.PythonSparkJobExecutableProps.property.pythonVersion">pythonVersion</a></code> | <code>cdk-extensions.glue.PythonVersion</code> | The Python version to use. |
| <code><a href="#cdk-extensions.glue.PythonSparkJobExecutableProps.property.script">script</a></code> | <code>cdk-extensions.glue.Code</code> | The script that executes a job. |
| <code><a href="#cdk-extensions.glue.PythonSparkJobExecutableProps.property.extraFiles">extraFiles</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional files, such as configuration files that AWS Glue copies to the working directory of your script before executing it. |
| <code><a href="#cdk-extensions.glue.PythonSparkJobExecutableProps.property.extraJars">extraJars</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional Java .jar files that AWS Glue adds to the Java classpath before executing your script. Only individual files are supported, directories are not supported. |
| <code><a href="#cdk-extensions.glue.PythonSparkJobExecutableProps.property.extraJarsFirst">extraJarsFirst</a></code> | <code>boolean</code> | Setting this value to true prioritizes the customer's extra JAR files in the classpath. |
| <code><a href="#cdk-extensions.glue.PythonSparkJobExecutableProps.property.extraPythonFiles">extraPythonFiles</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional Python files that AWS Glue adds to the Python path before executing your script. |

---

##### `glueVersion`<sup>Required</sup> <a name="glueVersion" id="cdk-extensions.glue.PythonSparkJobExecutableProps.property.glueVersion"></a>

```typescript
public readonly glueVersion: GlueVersion;
```

- *Type:* cdk-extensions.glue.GlueVersion

Glue version.

> [https://docs.aws.amazon.com/glue/latest/dg/release-notes.html](https://docs.aws.amazon.com/glue/latest/dg/release-notes.html)

---

##### `pythonVersion`<sup>Required</sup> <a name="pythonVersion" id="cdk-extensions.glue.PythonSparkJobExecutableProps.property.pythonVersion"></a>

```typescript
public readonly pythonVersion: PythonVersion;
```

- *Type:* cdk-extensions.glue.PythonVersion

The Python version to use.

---

##### `script`<sup>Required</sup> <a name="script" id="cdk-extensions.glue.PythonSparkJobExecutableProps.property.script"></a>

```typescript
public readonly script: Code;
```

- *Type:* cdk-extensions.glue.Code

The script that executes a job.

---

##### `extraFiles`<sup>Optional</sup> <a name="extraFiles" id="cdk-extensions.glue.PythonSparkJobExecutableProps.property.extraFiles"></a>

```typescript
public readonly extraFiles: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* [] - no extra files are copied to the working directory

Additional files, such as configuration files that AWS Glue copies to the working directory of your script before executing it.

Only individual files are supported, directories are not supported.

> [`--extra-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraJars`<sup>Optional</sup> <a name="extraJars" id="cdk-extensions.glue.PythonSparkJobExecutableProps.property.extraJars"></a>

```typescript
public readonly extraJars: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* [] - no extra jars are added to the classpath

Additional Java .jar files that AWS Glue adds to the Java classpath before executing your script. Only individual files are supported, directories are not supported.

> [`--extra-jars` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-jars` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraJarsFirst`<sup>Optional</sup> <a name="extraJarsFirst" id="cdk-extensions.glue.PythonSparkJobExecutableProps.property.extraJarsFirst"></a>

```typescript
public readonly extraJarsFirst: boolean;
```

- *Type:* boolean
- *Default:* false - priority is not given to user-provided jars

Setting this value to true prioritizes the customer's extra JAR files in the classpath.

> [`--user-jars-first` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--user-jars-first` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraPythonFiles`<sup>Optional</sup> <a name="extraPythonFiles" id="cdk-extensions.glue.PythonSparkJobExecutableProps.property.extraPythonFiles"></a>

```typescript
public readonly extraPythonFiles: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* no extra python files and argument is not set

Additional Python files that AWS Glue adds to the Python path before executing your script.

Only individual files are supported, directories are not supported.

> [`--extra-py-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-py-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

### QueueConfiguration <a name="QueueConfiguration" id="cdk-extensions.k8s_fargate.QueueConfiguration"></a>

Configures the queue used to write to Amazon Managed Service for Prometheus.

> [[Remote write configuration](https://prometheus.io/docs/prometheus/latest/configuration/configuration/#remote_write)]([Remote write configuration](https://prometheus.io/docs/prometheus/latest/configuration/configuration/#remote_write))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_fargate.QueueConfiguration.Initializer"></a>

```typescript
import { k8s_fargate } from 'cdk-extensions'

const queueConfiguration: k8s_fargate.QueueConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_fargate.QueueConfiguration.property.capacity">capacity</a></code> | <code>number</code> | Number of samples to buffer per shard before we block reading of more samples from the WAL. |
| <code><a href="#cdk-extensions.k8s_fargate.QueueConfiguration.property.maxSamplesPerSend">maxSamplesPerSend</a></code> | <code>number</code> | Maximum number of samples per send. |
| <code><a href="#cdk-extensions.k8s_fargate.QueueConfiguration.property.maxShards">maxShards</a></code> | <code>number</code> | Maximum number of shards, i.e. amount of concurrency. |

---

##### `capacity`<sup>Optional</sup> <a name="capacity" id="cdk-extensions.k8s_fargate.QueueConfiguration.property.capacity"></a>

```typescript
public readonly capacity: number;
```

- *Type:* number

Number of samples to buffer per shard before we block reading of more samples from the WAL.

It is recommended to have enough capacity in each
shard to buffer several requests to keep throughput up while processing
occasional slow remote requests.

---

##### `maxSamplesPerSend`<sup>Optional</sup> <a name="maxSamplesPerSend" id="cdk-extensions.k8s_fargate.QueueConfiguration.property.maxSamplesPerSend"></a>

```typescript
public readonly maxSamplesPerSend: number;
```

- *Type:* number

Maximum number of samples per send.

---

##### `maxShards`<sup>Optional</sup> <a name="maxShards" id="cdk-extensions.k8s_fargate.QueueConfiguration.property.maxShards"></a>

```typescript
public readonly maxShards: number;
```

- *Type:* number

Maximum number of shards, i.e. amount of concurrency.

---

### RawBucketProps <a name="RawBucketProps" id="cdk-extensions.s3_buckets.RawBucketProps"></a>

Configuration for objects bucket.

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.RawBucketProps.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const rawBucketProps: s3_buckets.RawBucketProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.accelerateConfiguration">accelerateConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.AccelerateConfigurationProperty</code> | Configures the transfer acceleration state for an Amazon S3 bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.accessControl">accessControl</a></code> | <code>string</code> | A canned access control list (ACL) that grants predefined permissions to the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.analyticsConfigurations">analyticsConfigurations</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.AnalyticsConfigurationProperty[]</code> | Specifies the configuration and any analyses for the analytics filter of an Amazon S3 bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.bucketEncryption">bucketEncryption</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.BucketEncryptionProperty</code> | Specifies default encryption for a bucket using server-side encryption with Amazon S3-managed keys (SSE-S3) or AWS KMS-managed keys (SSE-KMS) bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.bucketName">bucketName</a></code> | <code>string</code> | A name for the bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.corsConfiguration">corsConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.CorsConfigurationProperty</code> | Describes the cross-origin access configuration for objects in an Amazon S3 bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.intelligentTieringConfigurations">intelligentTieringConfigurations</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.IntelligentTieringConfigurationProperty[]</code> | Defines how Amazon S3 handles Intelligent-Tiering storage. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.inventoryConfigurations">inventoryConfigurations</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.InventoryConfigurationProperty[]</code> | Specifies the inventory configuration for an Amazon S3 bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.lifecycleConfiguration">lifecycleConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.LifecycleConfigurationProperty</code> | Specifies the lifecycle configuration for objects in an Amazon S3 bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.loggingConfiguration">loggingConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.LoggingConfigurationProperty</code> | Settings that define where logs are stored. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.metricsConfigurations">metricsConfigurations</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.MetricsConfigurationProperty[]</code> | Specifies a metrics configuration for the CloudWatch request metrics (specified by the metrics configuration ID) from an Amazon S3 bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.notificationConfiguration">notificationConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.NotificationConfigurationProperty</code> | Configuration that defines how Amazon S3 handles bucket notifications. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.objectLockConfiguration">objectLockConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.ObjectLockConfigurationProperty</code> | Places an Object Lock configuration on the specified bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.objectLockEnabled">objectLockEnabled</a></code> | <code>boolean \| aws-cdk-lib.IResolvable</code> | Indicates whether this bucket has an Object Lock configuration enabled. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.ownershipControls">ownershipControls</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.OwnershipControlsProperty</code> | Configuration that defines how Amazon S3 handles Object Ownership rules. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.publicAccessBlockConfiguration">publicAccessBlockConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.PublicAccessBlockConfigurationProperty</code> | Configuration that defines how Amazon S3 handles public access. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.replicationConfiguration">replicationConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.ReplicationConfigurationProperty</code> | Configuration for replicating objects in an S3 bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.tags">tags</a></code> | <code>aws-cdk-lib.CfnTag[]</code> | An arbitrary set of tags (key-value pairs) for this S3 bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.versioningConfiguration">versioningConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.VersioningConfigurationProperty</code> | Enables multiple versions of all objects in this bucket. |
| <code><a href="#cdk-extensions.s3_buckets.RawBucketProps.property.websiteConfiguration">websiteConfiguration</a></code> | <code>aws-cdk-lib.IResolvable \| aws-cdk-lib.aws_s3.CfnBucket.WebsiteConfigurationProperty</code> | Information used to configure the bucket as a static website. |

---

##### `accelerateConfiguration`<sup>Optional</sup> <a name="accelerateConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.accelerateConfiguration"></a>

```typescript
public readonly accelerateConfiguration: IResolvable | AccelerateConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.AccelerateConfigurationProperty

Configures the transfer acceleration state for an Amazon S3 bucket.

For more information, see [Amazon S3 Transfer Acceleration](https://docs.aws.amazon.com/AmazonS3/latest/dev/transfer-acceleration.html) in the *Amazon S3 User Guide* .

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-accelerateconfiguration](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-accelerateconfiguration)

---

##### `accessControl`<sup>Optional</sup> <a name="accessControl" id="cdk-extensions.s3_buckets.RawBucketProps.property.accessControl"></a>

```typescript
public readonly accessControl: string;
```

- *Type:* string

A canned access control list (ACL) that grants predefined permissions to the bucket.

For more information about canned ACLs, see [Canned ACL](https://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html#canned-acl) in the *Amazon S3 User Guide* .

Be aware that the syntax for this property differs from the information provided in the *Amazon S3 User Guide* . The AccessControl property is case-sensitive and must be one of the following values: Private, PublicRead, PublicReadWrite, AuthenticatedRead, LogDeliveryWrite, BucketOwnerRead, BucketOwnerFullControl, or AwsExecRead.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-accesscontrol](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-accesscontrol)

---

##### `analyticsConfigurations`<sup>Optional</sup> <a name="analyticsConfigurations" id="cdk-extensions.s3_buckets.RawBucketProps.property.analyticsConfigurations"></a>

```typescript
public readonly analyticsConfigurations: IResolvable | IResolvable | AnalyticsConfigurationProperty[];
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.AnalyticsConfigurationProperty[]

Specifies the configuration and any analyses for the analytics filter of an Amazon S3 bucket.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-analyticsconfigurations](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-analyticsconfigurations)

---

##### `bucketEncryption`<sup>Optional</sup> <a name="bucketEncryption" id="cdk-extensions.s3_buckets.RawBucketProps.property.bucketEncryption"></a>

```typescript
public readonly bucketEncryption: IResolvable | BucketEncryptionProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.BucketEncryptionProperty

Specifies default encryption for a bucket using server-side encryption with Amazon S3-managed keys (SSE-S3) or AWS KMS-managed keys (SSE-KMS) bucket.

For information about the Amazon S3 default encryption feature, see [Amazon S3 Default Encryption for S3 Buckets](https://docs.aws.amazon.com/AmazonS3/latest/dev/bucket-encryption.html) in the *Amazon S3 User Guide* .

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-bucketencryption](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-bucketencryption)

---

##### `bucketName`<sup>Optional</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.RawBucketProps.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

A name for the bucket.

If you don't specify a name, AWS CloudFormation generates a unique ID and uses that ID for the bucket name. The bucket name must contain only lowercase letters, numbers, periods (.), and dashes (-) and must follow [Amazon S3 bucket restrictions and limitations](https://docs.aws.amazon.com/AmazonS3/latest/dev/BucketRestrictions.html) . For more information, see [Rules for naming Amazon S3 buckets](https://docs.aws.amazon.com/AmazonS3/latest/dev/BucketRestrictions.html#bucketnamingrules) in the *Amazon S3 User Guide* .

> If you specify a name, you can't perform updates that require replacement of this resource. You can perform updates that require no or some interruption. If you need to replace the resource, specify a new name.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-name](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-name)

---

##### `corsConfiguration`<sup>Optional</sup> <a name="corsConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.corsConfiguration"></a>

```typescript
public readonly corsConfiguration: IResolvable | CorsConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.CorsConfigurationProperty

Describes the cross-origin access configuration for objects in an Amazon S3 bucket.

For more information, see [Enabling Cross-Origin Resource Sharing](https://docs.aws.amazon.com/AmazonS3/latest/dev/cors.html) in the *Amazon S3 User Guide* .

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-crossoriginconfig](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-crossoriginconfig)

---

##### `intelligentTieringConfigurations`<sup>Optional</sup> <a name="intelligentTieringConfigurations" id="cdk-extensions.s3_buckets.RawBucketProps.property.intelligentTieringConfigurations"></a>

```typescript
public readonly intelligentTieringConfigurations: IResolvable | IResolvable | IntelligentTieringConfigurationProperty[];
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.IntelligentTieringConfigurationProperty[]

Defines how Amazon S3 handles Intelligent-Tiering storage.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-intelligenttieringconfigurations](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-intelligenttieringconfigurations)

---

##### `inventoryConfigurations`<sup>Optional</sup> <a name="inventoryConfigurations" id="cdk-extensions.s3_buckets.RawBucketProps.property.inventoryConfigurations"></a>

```typescript
public readonly inventoryConfigurations: IResolvable | IResolvable | InventoryConfigurationProperty[];
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.InventoryConfigurationProperty[]

Specifies the inventory configuration for an Amazon S3 bucket.

For more information, see [GET Bucket inventory](https://docs.aws.amazon.com/AmazonS3/latest/API/RESTBucketGETInventoryConfig.html) in the *Amazon S3 API Reference* .

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-inventoryconfigurations](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-inventoryconfigurations)

---

##### `lifecycleConfiguration`<sup>Optional</sup> <a name="lifecycleConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.lifecycleConfiguration"></a>

```typescript
public readonly lifecycleConfiguration: IResolvable | LifecycleConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.LifecycleConfigurationProperty

Specifies the lifecycle configuration for objects in an Amazon S3 bucket.

For more information, see [Object Lifecycle Management](https://docs.aws.amazon.com/AmazonS3/latest/dev/object-lifecycle-mgmt.html) in the *Amazon S3 User Guide* .

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-lifecycleconfig](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-lifecycleconfig)

---

##### `loggingConfiguration`<sup>Optional</sup> <a name="loggingConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.loggingConfiguration"></a>

```typescript
public readonly loggingConfiguration: IResolvable | LoggingConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.LoggingConfigurationProperty

Settings that define where logs are stored.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-loggingconfig](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-loggingconfig)

---

##### `metricsConfigurations`<sup>Optional</sup> <a name="metricsConfigurations" id="cdk-extensions.s3_buckets.RawBucketProps.property.metricsConfigurations"></a>

```typescript
public readonly metricsConfigurations: IResolvable | IResolvable | MetricsConfigurationProperty[];
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.MetricsConfigurationProperty[]

Specifies a metrics configuration for the CloudWatch request metrics (specified by the metrics configuration ID) from an Amazon S3 bucket.

If you're updating an existing metrics configuration, note that this is a full replacement of the existing metrics configuration. If you don't include the elements you want to keep, they are erased. For more information, see [PutBucketMetricsConfiguration](https://docs.aws.amazon.com/AmazonS3/latest/API/RESTBucketPUTMetricConfiguration.html) .

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-metricsconfigurations](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-metricsconfigurations)

---

##### `notificationConfiguration`<sup>Optional</sup> <a name="notificationConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.notificationConfiguration"></a>

```typescript
public readonly notificationConfiguration: IResolvable | NotificationConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.NotificationConfigurationProperty

Configuration that defines how Amazon S3 handles bucket notifications.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-notification](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-notification)

---

##### `objectLockConfiguration`<sup>Optional</sup> <a name="objectLockConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.objectLockConfiguration"></a>

```typescript
public readonly objectLockConfiguration: IResolvable | ObjectLockConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.ObjectLockConfigurationProperty

Places an Object Lock configuration on the specified bucket.

The rule specified in the Object Lock configuration will be applied by default to every new object placed in the specified bucket. For more information, see [Locking Objects](https://docs.aws.amazon.com/AmazonS3/latest/dev/object-lock.html) .

> - The `DefaultRetention` settings require both a mode and a period.
> - The `DefaultRetention` period can be either `Days` or `Years` but you must select one. You cannot specify `Days` and `Years` at the same time.
> - You can only enable Object Lock for new buckets. If you want to turn on Object Lock for an existing bucket, contact AWS Support.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-objectlockconfiguration](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-objectlockconfiguration)

---

##### `objectLockEnabled`<sup>Optional</sup> <a name="objectLockEnabled" id="cdk-extensions.s3_buckets.RawBucketProps.property.objectLockEnabled"></a>

```typescript
public readonly objectLockEnabled: boolean | IResolvable;
```

- *Type:* boolean | aws-cdk-lib.IResolvable

Indicates whether this bucket has an Object Lock configuration enabled.

Enable `ObjectLockEnabled` when you apply `ObjectLockConfiguration` to a bucket.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-objectlockenabled](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-objectlockenabled)

---

##### `ownershipControls`<sup>Optional</sup> <a name="ownershipControls" id="cdk-extensions.s3_buckets.RawBucketProps.property.ownershipControls"></a>

```typescript
public readonly ownershipControls: IResolvable | OwnershipControlsProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.OwnershipControlsProperty

Configuration that defines how Amazon S3 handles Object Ownership rules.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-ownershipcontrols](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-ownershipcontrols)

---

##### `publicAccessBlockConfiguration`<sup>Optional</sup> <a name="publicAccessBlockConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.publicAccessBlockConfiguration"></a>

```typescript
public readonly publicAccessBlockConfiguration: IResolvable | PublicAccessBlockConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.PublicAccessBlockConfigurationProperty

Configuration that defines how Amazon S3 handles public access.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-publicaccessblockconfiguration](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-publicaccessblockconfiguration)

---

##### `replicationConfiguration`<sup>Optional</sup> <a name="replicationConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.replicationConfiguration"></a>

```typescript
public readonly replicationConfiguration: IResolvable | ReplicationConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.ReplicationConfigurationProperty

Configuration for replicating objects in an S3 bucket.

To enable replication, you must also enable versioning by using the `VersioningConfiguration` property.

Amazon S3 can store replicated objects in a single destination bucket or multiple destination buckets. The destination bucket or buckets must already exist.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-replicationconfiguration](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-replicationconfiguration)

---

##### `tags`<sup>Optional</sup> <a name="tags" id="cdk-extensions.s3_buckets.RawBucketProps.property.tags"></a>

```typescript
public readonly tags: CfnTag[];
```

- *Type:* aws-cdk-lib.CfnTag[]

An arbitrary set of tags (key-value pairs) for this S3 bucket.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-tags](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-tags)

---

##### `versioningConfiguration`<sup>Optional</sup> <a name="versioningConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.versioningConfiguration"></a>

```typescript
public readonly versioningConfiguration: IResolvable | VersioningConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.VersioningConfigurationProperty

Enables multiple versions of all objects in this bucket.

You might enable versioning to prevent objects from being deleted or overwritten by mistake or to archive objects so that you can retrieve previous versions of them.

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-versioning](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-versioning)

---

##### `websiteConfiguration`<sup>Optional</sup> <a name="websiteConfiguration" id="cdk-extensions.s3_buckets.RawBucketProps.property.websiteConfiguration"></a>

```typescript
public readonly websiteConfiguration: IResolvable | WebsiteConfigurationProperty;
```

- *Type:* aws-cdk-lib.IResolvable | aws-cdk-lib.aws_s3.CfnBucket.WebsiteConfigurationProperty

Information used to configure the bucket as a static website.

For more information, see [Hosting Websites on Amazon S3](https://docs.aws.amazon.com/AmazonS3/latest/dev/WebsiteHosting.html) .

> [http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-websiteconfiguration](http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-s3-bucket.html#cfn-s3-bucket-websiteconfiguration)

---

### RecordDeaggregationProcessorOptions <a name="RecordDeaggregationProcessorOptions" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessorOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessorOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const recordDeaggregationProcessorOptions: kinesis_firehose.RecordDeaggregationProcessorOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessorOptions.property.subRecordType">subRecordType</a></code> | <code>cdk-extensions.kinesis_firehose.SubRecordType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessorOptions.property.delimiter">delimiter</a></code> | <code>string</code> | *No description.* |

---

##### `subRecordType`<sup>Required</sup> <a name="subRecordType" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessorOptions.property.subRecordType"></a>

```typescript
public readonly subRecordType: SubRecordType;
```

- *Type:* cdk-extensions.kinesis_firehose.SubRecordType

---

##### `delimiter`<sup>Optional</sup> <a name="delimiter" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessorOptions.property.delimiter"></a>

```typescript
public readonly delimiter: string;
```

- *Type:* string

---

### RecordingRuleProps <a name="RecordingRuleProps" id="cdk-extensions.aps.RecordingRuleProps"></a>

Options needed to configure a Prometheus recording rule inside an APS rules configuration.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.RecordingRuleProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const recordingRuleProps: aps.RecordingRuleProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RecordingRuleProps.property.expression">expression</a></code> | <code>string</code> | The PromQL expression to evaluate. |
| <code><a href="#cdk-extensions.aps.RecordingRuleProps.property.record">record</a></code> | <code>string</code> | The name of the time series to output to. |
| <code><a href="#cdk-extensions.aps.RecordingRuleProps.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Labels to add or overwrite before storing the result. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk-extensions.aps.RecordingRuleProps.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

The PromQL expression to evaluate.

Every evaluation cycle this is
evaluated at the current time, and the result recorded as a new set of
time series with the metric name as given by `record`.

> [[Querying prometheus](https://prometheus.io/docs/prometheus/latest/querying/basics/)]([Querying prometheus](https://prometheus.io/docs/prometheus/latest/querying/basics/))

---

##### `record`<sup>Required</sup> <a name="record" id="cdk-extensions.aps.RecordingRuleProps.property.record"></a>

```typescript
public readonly record: string;
```

- *Type:* string

The name of the time series to output to.

Must be a valid metric name.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk-extensions.aps.RecordingRuleProps.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Labels to add or overwrite before storing the result.

---

### ReferencedManagedPolicyProps <a name="ReferencedManagedPolicyProps" id="cdk-extensions.sso.ReferencedManagedPolicyProps"></a>

Represents configuration options when creating a managed policy from a class generated when adding a custom policy reference.

#### Initializer <a name="Initializer" id="cdk-extensions.sso.ReferencedManagedPolicyProps.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

const referencedManagedPolicyProps: sso.ReferencedManagedPolicyProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicyProps.property.description">description</a></code> | <code>string</code> | A friendly description of the policy. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicyProps.property.document">document</a></code> | <code>aws-cdk-lib.aws_iam.PolicyDocument</code> | The policy document that you want to use as the content for the new policy. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicyProps.property.groups">groups</a></code> | <code>aws-cdk-lib.aws_iam.IGroup[]</code> | The groups to attach the policy to. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicyProps.property.roles">roles</a></code> | <code>aws-cdk-lib.aws_iam.IRole[]</code> | The roles to attach the policy to. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicyProps.property.statements">statements</a></code> | <code>aws-cdk-lib.aws_iam.PolicyStatement[]</code> | Initial set of permissions to add to this policy document. |
| <code><a href="#cdk-extensions.sso.ReferencedManagedPolicyProps.property.users">users</a></code> | <code>aws-cdk-lib.aws_iam.IUser[]</code> | The users to attach the policy to. |

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.sso.ReferencedManagedPolicyProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A friendly description of the policy.

Typically used to store information about the permissions defined in the
policy. For example, "Grants access to production DynamoDB tables."

The policy description is immutable. After a value is assigned, it
cannot be changed.

---

##### `document`<sup>Optional</sup> <a name="document" id="cdk-extensions.sso.ReferencedManagedPolicyProps.property.document"></a>

```typescript
public readonly document: PolicyDocument;
```

- *Type:* aws-cdk-lib.aws_iam.PolicyDocument

The policy document that you want to use as the content for the new policy.

---

##### `groups`<sup>Optional</sup> <a name="groups" id="cdk-extensions.sso.ReferencedManagedPolicyProps.property.groups"></a>

```typescript
public readonly groups: IGroup[];
```

- *Type:* aws-cdk-lib.aws_iam.IGroup[]

The groups to attach the policy to.

When creating managed policies that will be referenced by IAM identity
center it is possible to associate them with other resources such as
users, groups, and roles. However, this is typically not done as IAM
Identity Center will handle configuring associations in the background.

---

##### `roles`<sup>Optional</sup> <a name="roles" id="cdk-extensions.sso.ReferencedManagedPolicyProps.property.roles"></a>

```typescript
public readonly roles: IRole[];
```

- *Type:* aws-cdk-lib.aws_iam.IRole[]

The roles to attach the policy to.

When creating managed policies that will be referenced by IAM identity
center it is possible to associate them with other resources such as
users, groups, and roles. However, this is typically not done as IAM
Identity Center will handle configuring associations in the background.

---

##### `statements`<sup>Optional</sup> <a name="statements" id="cdk-extensions.sso.ReferencedManagedPolicyProps.property.statements"></a>

```typescript
public readonly statements: PolicyStatement[];
```

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement[]

Initial set of permissions to add to this policy document.

---

##### `users`<sup>Optional</sup> <a name="users" id="cdk-extensions.sso.ReferencedManagedPolicyProps.property.users"></a>

```typescript
public readonly users: IUser[];
```

- *Type:* aws-cdk-lib.aws_iam.IUser[]

The users to attach the policy to.

When creating managed policies that will be referenced by IAM identity
center it is possible to associate them with other resources such as
users, groups, and roles. However, this is typically not done as IAM
Identity Center will handle configuring associations in the background.

---

### ReferenceOptions <a name="ReferenceOptions" id="cdk-extensions.sso.ReferenceOptions"></a>

Configuration options for creating a referenced customer managed policy.

#### Initializer <a name="Initializer" id="cdk-extensions.sso.ReferenceOptions.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

const referenceOptions: sso.ReferenceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ReferenceOptions.property.name">name</a></code> | <code>string</code> | The name of the customer managed policy. |
| <code><a href="#cdk-extensions.sso.ReferenceOptions.property.path">path</a></code> | <code>string</code> | The path for the policy. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.sso.ReferenceOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the customer managed policy.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk-extensions.sso.ReferenceOptions.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string
- *Default:* '/''

The path for the policy.

For more information about paths, see [IAM identifiers](https://docs.aws.amazon.com/IAM/latest/UserGuide/Using_Identifiers.html) in the IAM User
Guide.

This parameter is optional. If it is not included, it defaults to a slash (/).

This parameter allows a string of characters consisting of either a
forward slash (/) by itself or a string that must begin and end with
forward slashes. In addition, it can contain any ASCII character from
the ! (`\u0021`) through the DEL character (`\u007F`), including most
punctuation characters, digits, and upper and lowercased letters.

---

### RegisterTransitGatewayProps <a name="RegisterTransitGatewayProps" id="cdk-extensions.networkmanager.RegisterTransitGatewayProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.networkmanager.RegisterTransitGatewayProps.Initializer"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

const registerTransitGatewayProps: networkmanager.RegisterTransitGatewayProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.RegisterTransitGatewayProps.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | *No description.* |

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.networkmanager.RegisterTransitGatewayProps.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

---

### RemoteVpnEndpointConfiguration <a name="RemoteVpnEndpointConfiguration" id="cdk-extensions.ec2.RemoteVpnEndpointConfiguration"></a>

Configuration object containing the vlues needed to configure the remote end of a VPN connection.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.RemoteVpnEndpointConfiguration.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const remoteVpnEndpointConfiguration: ec2.RemoteVpnEndpointConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.RemoteVpnEndpointConfiguration.property.customerGatewayAsn">customerGatewayAsn</a></code> | <code>number</code> | The BGP ASN of the customer gateway which is configured with the details of the remote endpoint device. |
| <code><a href="#cdk-extensions.ec2.RemoteVpnEndpointConfiguration.property.customerGatewayId">customerGatewayId</a></code> | <code>string</code> | The ID of the customer gateway which is configured with the details of the remote endpoint device. |
| <code><a href="#cdk-extensions.ec2.RemoteVpnEndpointConfiguration.property.customerGatewayIp">customerGatewayIp</a></code> | <code>string</code> | The IP address of the customer gateway which is configured with the details of the remote endpoint device. |

---

##### `customerGatewayAsn`<sup>Required</sup> <a name="customerGatewayAsn" id="cdk-extensions.ec2.RemoteVpnEndpointConfiguration.property.customerGatewayAsn"></a>

```typescript
public readonly customerGatewayAsn: number;
```

- *Type:* number

The BGP ASN of the customer gateway which is configured with the details of the remote endpoint device.

---

##### `customerGatewayId`<sup>Required</sup> <a name="customerGatewayId" id="cdk-extensions.ec2.RemoteVpnEndpointConfiguration.property.customerGatewayId"></a>

```typescript
public readonly customerGatewayId: string;
```

- *Type:* string

The ID of the customer gateway which is configured with the details of the remote endpoint device.

---

##### `customerGatewayIp`<sup>Required</sup> <a name="customerGatewayIp" id="cdk-extensions.ec2.RemoteVpnEndpointConfiguration.property.customerGatewayIp"></a>

```typescript
public readonly customerGatewayIp: string;
```

- *Type:* string

The IP address of the customer gateway which is configured with the details of the remote endpoint device.

---

### ResolvedFluentBitConfiguration <a name="ResolvedFluentBitConfiguration" id="cdk-extensions.k8s_aws.ResolvedFluentBitConfiguration"></a>

The output of a Fluent Bit configuration object for consumption be the resource configuring Fluent Bit.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.ResolvedFluentBitConfiguration.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const resolvedFluentBitConfiguration: k8s_aws.ResolvedFluentBitConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ResolvedFluentBitConfiguration.property.configFile">configFile</a></code> | <code>string</code> | The configuration rended as a configuration file that can be read by the Fluent Bit service. |
| <code><a href="#cdk-extensions.k8s_aws.ResolvedFluentBitConfiguration.property.parsers">parsers</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitParserPlugin[]</code> | A list of parsers referenced by this plugin. |
| <code><a href="#cdk-extensions.k8s_aws.ResolvedFluentBitConfiguration.property.permissions">permissions</a></code> | <code>aws-cdk-lib.aws_iam.PolicyStatement[]</code> | IAM permissions required by resources that will be using this plugin. |

---

##### `configFile`<sup>Required</sup> <a name="configFile" id="cdk-extensions.k8s_aws.ResolvedFluentBitConfiguration.property.configFile"></a>

```typescript
public readonly configFile: string;
```

- *Type:* string

The configuration rended as a configuration file that can be read by the Fluent Bit service.

---

##### `parsers`<sup>Optional</sup> <a name="parsers" id="cdk-extensions.k8s_aws.ResolvedFluentBitConfiguration.property.parsers"></a>

```typescript
public readonly parsers: IFluentBitParserPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin[]

A list of parsers referenced by this plugin.

---

##### `permissions`<sup>Optional</sup> <a name="permissions" id="cdk-extensions.k8s_aws.ResolvedFluentBitConfiguration.property.permissions"></a>

```typescript
public readonly permissions: PolicyStatement[];
```

- *Type:* aws-cdk-lib.aws_iam.PolicyStatement[]

IAM permissions required by resources that will be using this plugin.

---

### ResolvedIpamAllocationConfiguration <a name="ResolvedIpamAllocationConfiguration" id="cdk-extensions.ec2.ResolvedIpamAllocationConfiguration"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.ResolvedIpamAllocationConfiguration.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const resolvedIpamAllocationConfiguration: ec2.ResolvedIpamAllocationConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ResolvedIpamAllocationConfiguration.property.cidr">cidr</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.ResolvedIpamAllocationConfiguration.property.netmaskLength">netmaskLength</a></code> | <code>number</code> | *No description.* |

---

##### `cidr`<sup>Optional</sup> <a name="cidr" id="cdk-extensions.ec2.ResolvedIpamAllocationConfiguration.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* string

---

##### `netmaskLength`<sup>Optional</sup> <a name="netmaskLength" id="cdk-extensions.ec2.ResolvedIpamAllocationConfiguration.property.netmaskLength"></a>

```typescript
public readonly netmaskLength: number;
```

- *Type:* number

---

### ResolvedIpamPoolCidrConfiguration <a name="ResolvedIpamPoolCidrConfiguration" id="cdk-extensions.ec2.ResolvedIpamPoolCidrConfiguration"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.ResolvedIpamPoolCidrConfiguration.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const resolvedIpamPoolCidrConfiguration: ec2.ResolvedIpamPoolCidrConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ResolvedIpamPoolCidrConfiguration.property.cidr">cidr</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.ResolvedIpamPoolCidrConfiguration.property.netmaskLength">netmaskLength</a></code> | <code>number</code> | *No description.* |

---

##### `cidr`<sup>Optional</sup> <a name="cidr" id="cdk-extensions.ec2.ResolvedIpamPoolCidrConfiguration.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* string

---

##### `netmaskLength`<sup>Optional</sup> <a name="netmaskLength" id="cdk-extensions.ec2.ResolvedIpamPoolCidrConfiguration.property.netmaskLength"></a>

```typescript
public readonly netmaskLength: number;
```

- *Type:* number

---

### ResourceShareAttributes <a name="ResourceShareAttributes" id="cdk-extensions.ram.ResourceShareAttributes"></a>

Configuration for importing an existing RAM resource share.

#### Initializer <a name="Initializer" id="cdk-extensions.ram.ResourceShareAttributes.Initializer"></a>

```typescript
import { ram } from 'cdk-extensions'

const resourceShareAttributes: ram.ResourceShareAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ram.ResourceShareAttributes.property.resourceShareArn">resourceShareArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the RAM resource share. |
| <code><a href="#cdk-extensions.ram.ResourceShareAttributes.property.resourceShareId">resourceShareId</a></code> | <code>string</code> | The ID generated by AWS for the RAM resource share. |

---

##### `resourceShareArn`<sup>Optional</sup> <a name="resourceShareArn" id="cdk-extensions.ram.ResourceShareAttributes.property.resourceShareArn"></a>

```typescript
public readonly resourceShareArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the RAM resource share.

---

##### `resourceShareId`<sup>Optional</sup> <a name="resourceShareId" id="cdk-extensions.ram.ResourceShareAttributes.property.resourceShareId"></a>

```typescript
public readonly resourceShareId: string;
```

- *Type:* string

The ID generated by AWS for the RAM resource share.

---

### ResourceShareProps <a name="ResourceShareProps" id="cdk-extensions.ram.ResourceShareProps"></a>

Configuration for ResourceShare resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ram.ResourceShareProps.Initializer"></a>

```typescript
import { ram } from 'cdk-extensions'

const resourceShareProps: ram.ResourceShareProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.allowExternalPrincipals">allowExternalPrincipals</a></code> | <code>boolean</code> | Specifies whether principals outside your organization in AWS Organizations can be associated with a resource share. |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.autoDiscoverAccounts">autoDiscoverAccounts</a></code> | <code>boolean</code> | Controls whether the resource share should attempt to search for AWS accounts that are part of the same CDK application. |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.name">name</a></code> | <code>string</code> | Specifies the name of the resource share. |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.principals">principals</a></code> | <code>cdk-extensions.ram.ISharedPrincipal[]</code> | Specifies a list of one or more principals to associate with the resource share. |
| <code><a href="#cdk-extensions.ram.ResourceShareProps.property.resources">resources</a></code> | <code>cdk-extensions.ram.ISharable[]</code> | Specifies a list of AWS resources to share with the configured principal accounts and organizations. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ram.ResourceShareProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ram.ResourceShareProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ram.ResourceShareProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ram.ResourceShareProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `allowExternalPrincipals`<sup>Optional</sup> <a name="allowExternalPrincipals" id="cdk-extensions.ram.ResourceShareProps.property.allowExternalPrincipals"></a>

```typescript
public readonly allowExternalPrincipals: boolean;
```

- *Type:* boolean
- *Default:* true

Specifies whether principals outside your organization in AWS Organizations can be associated with a resource share.

A value of `true`
lets you share with individual AWS accounts that are not in your
organization. A value of `false` only has meaning if your account is a
member of an AWS Organization.

> [[ResourceShare.AllowExternalPrinicpals](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-allowexternalprincipals)]([ResourceShare.AllowExternalPrinicpals](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-allowexternalprincipals))

---

##### `autoDiscoverAccounts`<sup>Optional</sup> <a name="autoDiscoverAccounts" id="cdk-extensions.ram.ResourceShareProps.property.autoDiscoverAccounts"></a>

```typescript
public readonly autoDiscoverAccounts: boolean;
```

- *Type:* boolean

Controls whether the resource share should attempt to search for AWS accounts that are part of the same CDK application.

Any accounts is finds
will be added to the resource automatically and will be able to use the
shared resources.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ram.ResourceShareProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Specifies the name of the resource share.

> [[ResourceShare.Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-name)]([ResourceShare.Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-name))

---

##### `principals`<sup>Optional</sup> <a name="principals" id="cdk-extensions.ram.ResourceShareProps.property.principals"></a>

```typescript
public readonly principals: ISharedPrincipal[];
```

- *Type:* cdk-extensions.ram.ISharedPrincipal[]

Specifies a list of one or more principals to associate with the resource share.

> [[ResourceShare.Prinicipals](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-principals)]([ResourceShare.Prinicipals](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-principals))

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk-extensions.ram.ResourceShareProps.property.resources"></a>

```typescript
public readonly resources: ISharable[];
```

- *Type:* cdk-extensions.ram.ISharable[]

Specifies a list of AWS resources to share with the configured principal accounts and organizations.

> [[ResourceShare.ResourceArns](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-resourcearns)]([ResourceShare.ResourceArns](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html#cfn-ram-resourceshare-resourcearns))

---

### RewriteTagRule <a name="RewriteTagRule" id="cdk-extensions.k8s_aws.RewriteTagRule"></a>

Defines the matching criteria and the format of the Tag for the rewrite tag Fluent Bit filter plugin.

> [[Rules](https://docs.fluentbit.io/manual/pipeline/filters/rewrite-tag#rules)]([Rules](https://docs.fluentbit.io/manual/pipeline/filters/rewrite-tag#rules))

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.RewriteTagRule.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const rewriteTagRule: k8s_aws.RewriteTagRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.RewriteTagRule.property.keep">keep</a></code> | <code>boolean</code> | If a rule matches a rule the filter will emit a copy of the record with the new defined Tag. |
| <code><a href="#cdk-extensions.k8s_aws.RewriteTagRule.property.key">key</a></code> | <code>string</code> | The key represents the name of the record key that holds the value that we want to use to match our regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.RewriteTagRule.property.newTag">newTag</a></code> | <code>string</code> | If a regular expression has matched the value of the defined key in the rule, we are ready to compose a new Tag for that specific record. |
| <code><a href="#cdk-extensions.k8s_aws.RewriteTagRule.property.regex">regex</a></code> | <code>string</code> | Using a simple regular expression we can specify a matching pattern to use against the value of the key specified, also we can take advantage of group capturing to create custom placeholder values. |

---

##### `keep`<sup>Required</sup> <a name="keep" id="cdk-extensions.k8s_aws.RewriteTagRule.property.keep"></a>

```typescript
public readonly keep: boolean;
```

- *Type:* boolean

If a rule matches a rule the filter will emit a copy of the record with the new defined Tag.

The property keep takes a boolean value to define if the original
record with the old Tag must be preserved and continue in the pipeline
or just be discarded.

> [[Keep](https://docs.fluentbit.io/manual/pipeline/filters/rewrite-tag#keep)]([Keep](https://docs.fluentbit.io/manual/pipeline/filters/rewrite-tag#keep))

---

##### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.RewriteTagRule.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The key represents the name of the record key that holds the value that we want to use to match our regular expression.

A key name is specified and prefixed with a `$`.

> [[Key](https://docs.fluentbit.io/manual/pipeline/filters/rewrite-tag#key)]([Key](https://docs.fluentbit.io/manual/pipeline/filters/rewrite-tag#key))

---

##### `newTag`<sup>Required</sup> <a name="newTag" id="cdk-extensions.k8s_aws.RewriteTagRule.property.newTag"></a>

```typescript
public readonly newTag: string;
```

- *Type:* string

If a regular expression has matched the value of the defined key in the rule, we are ready to compose a new Tag for that specific record.

The tag is a concatenated string that can contain any of the following
characters: `a-z,A-Z,0-9` and `.-,`.

> [[New Tag](https://docs.fluentbit.io/manual/pipeline/filters/rewrite-tag#new-tag)]([New Tag](https://docs.fluentbit.io/manual/pipeline/filters/rewrite-tag#new-tag))

---

##### `regex`<sup>Required</sup> <a name="regex" id="cdk-extensions.k8s_aws.RewriteTagRule.property.regex"></a>

```typescript
public readonly regex: string;
```

- *Type:* string

Using a simple regular expression we can specify a matching pattern to use against the value of the key specified, also we can take advantage of group capturing to create custom placeholder values.

> [[Rubular regex tester](https://rubular.com/)]([Rubular regex tester](https://rubular.com/))

---

### Route53DnsOptions <a name="Route53DnsOptions" id="cdk-extensions.k8s_aws.Route53DnsOptions"></a>

Optional configuration for the Route53Dns resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.Route53DnsOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const route53DnsOptions: k8s_aws.Route53DnsOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.apiRetries">apiRetries</a></code> | <code>number</code> | Maximum number of retries for AWS API calls before giving up. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.batchChangeSize">batchChangeSize</a></code> | <code>number</code> | Set the maximum number of changes that will be applied in each batch. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.domainFilter">domainFilter</a></code> | <code>string[]</code> | Limits possible target zones by domain suffixes. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.evaluateTargetHealth">evaluateTargetHealth</a></code> | <code>boolean</code> | Sets a flag determining whether the health of the backend service should be evaluated when determining DNS routing. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.logFormat">logFormat</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsLogFormat</code> | Sets the output format external dns will use when generating logs. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.logLevel">logLevel</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsLogLevel</code> | Controls the verbosity of logs generated using the external-dns service. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be deployed. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.preferCname">preferCname</a></code> | <code>boolean</code> | When true, alias records will be avoided and CNAME records will be used instead. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.recordOwnershipRegistry">recordOwnershipRegistry</a></code> | <code>cdk-extensions.k8s_aws.IExternalDnsRegistry</code> | Registry specifying how ExternalDNS should track record ownership. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.region">region</a></code> | <code>string</code> | Override the default region external-dns uses when calling AWS API's. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.replicaCount">replicaCount</a></code> | <code>number</code> | Desired number of ExternalDNS replicas. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.syncPolicy">syncPolicy</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsSyncPolicy</code> | Controls the operations ExternalDNS will perform on the records it manages. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.zoneTags">zoneTags</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsZoneTag[]</code> | A set of tags that can be used to restrict which hosted zones external DNS will make changes to. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsOptions.property.zoneType">zoneType</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsZoneType</code> | Controls the types of hosted zones external-dns will create records for. |

---

##### `apiRetries`<sup>Optional</sup> <a name="apiRetries" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.apiRetries"></a>

```typescript
public readonly apiRetries: number;
```

- *Type:* number
- *Default:* 3

Maximum number of retries for AWS API calls before giving up.

---

##### `batchChangeSize`<sup>Optional</sup> <a name="batchChangeSize" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.batchChangeSize"></a>

```typescript
public readonly batchChangeSize: number;
```

- *Type:* number
- *Default:* 1000

Set the maximum number of changes that will be applied in each batch.

---

##### `domainFilter`<sup>Optional</sup> <a name="domainFilter" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.domainFilter"></a>

```typescript
public readonly domainFilter: string[];
```

- *Type:* string[]

Limits possible target zones by domain suffixes.

---

##### `evaluateTargetHealth`<sup>Optional</sup> <a name="evaluateTargetHealth" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.evaluateTargetHealth"></a>

```typescript
public readonly evaluateTargetHealth: boolean;
```

- *Type:* boolean

Sets a flag determining whether the health of the backend service should be evaluated when determining DNS routing.

---

##### `logFormat`<sup>Optional</sup> <a name="logFormat" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.logFormat"></a>

```typescript
public readonly logFormat: ExternalDnsLogFormat;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsLogFormat
- *Default:* {@link ExternalDnsLogLevel.JSON}

Sets the output format external dns will use when generating logs.

---

##### `logLevel`<sup>Optional</sup> <a name="logLevel" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.logLevel"></a>

```typescript
public readonly logLevel: ExternalDnsLogLevel;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsLogLevel
- *Default:* {@link ExternalDnsLogLevel.INFO}

Controls the verbosity of logs generated using the external-dns service.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string
- *Default:* 'kube-system'

The Kubernetes namespace where the service should be deployed.

---

##### `preferCname`<sup>Optional</sup> <a name="preferCname" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.preferCname"></a>

```typescript
public readonly preferCname: boolean;
```

- *Type:* boolean
- *Default:* false

When true, alias records will be avoided and CNAME records will be used instead.

---

##### `recordOwnershipRegistry`<sup>Optional</sup> <a name="recordOwnershipRegistry" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.recordOwnershipRegistry"></a>

```typescript
public readonly recordOwnershipRegistry: IExternalDnsRegistry;
```

- *Type:* cdk-extensions.k8s_aws.IExternalDnsRegistry
- *Default:* A TXT registry configured with defaults.

Registry specifying how ExternalDNS should track record ownership.

Without a registry to track record ownership, External has no way to know
which records it owns and manages and which are owned and managed by a
different service.

This can cause conflicts if there are multiple instances of External DNS
running or if there are other services managing DNS records in similar
zones as the different services could try to make conflicting changes due
to lacking a shared state.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

Override the default region external-dns uses when calling AWS API's.

---

##### `replicaCount`<sup>Optional</sup> <a name="replicaCount" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.replicaCount"></a>

```typescript
public readonly replicaCount: number;
```

- *Type:* number
- *Default:* 1

Desired number of ExternalDNS replicas.

---

##### `syncPolicy`<sup>Optional</sup> <a name="syncPolicy" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.syncPolicy"></a>

```typescript
public readonly syncPolicy: ExternalDnsSyncPolicy;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsSyncPolicy
- *Default:* {@link ExternalDnsSyncPolicy.SYNC}

Controls the operations ExternalDNS will perform on the records it manages.

---

##### `zoneTags`<sup>Optional</sup> <a name="zoneTags" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.zoneTags"></a>

```typescript
public readonly zoneTags: ExternalDnsZoneTag[];
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneTag[]

A set of tags that can be used to restrict which hosted zones external DNS will make changes to.

---

##### `zoneType`<sup>Optional</sup> <a name="zoneType" id="cdk-extensions.k8s_aws.Route53DnsOptions.property.zoneType"></a>

```typescript
public readonly zoneType: ExternalDnsZoneType;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneType
- *Default:* ExternalDnsZoneType.ALL

Controls the types of hosted zones external-dns will create records for.

---

### Route53DnsProps <a name="Route53DnsProps" id="cdk-extensions.k8s_aws.Route53DnsProps"></a>

Full configuration for the Route53Dns resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.Route53DnsProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const route53DnsProps: k8s_aws.Route53DnsProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.region">region</a></code> | <code>string</code> | Override the default region external-dns uses when calling AWS API's. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.apiRetries">apiRetries</a></code> | <code>number</code> | Maximum number of retries for AWS API calls before giving up. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.batchChangeSize">batchChangeSize</a></code> | <code>number</code> | Set the maximum number of changes that will be applied in each batch. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.domainFilter">domainFilter</a></code> | <code>string[]</code> | Limits possible target zones by domain suffixes. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.evaluateTargetHealth">evaluateTargetHealth</a></code> | <code>boolean</code> | Sets a flag determining whether the health of the backend service should be evaluated when determining DNS routing. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.logFormat">logFormat</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsLogFormat</code> | Sets the output format external dns will use when generating logs. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.logLevel">logLevel</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsLogLevel</code> | Controls the verbosity of logs generated using the external-dns service. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the service should be deployed. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.preferCname">preferCname</a></code> | <code>boolean</code> | When true, alias records will be avoided and CNAME records will be used instead. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.recordOwnershipRegistry">recordOwnershipRegistry</a></code> | <code>cdk-extensions.k8s_aws.IExternalDnsRegistry</code> | Registry specifying how ExternalDNS should track record ownership. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.replicaCount">replicaCount</a></code> | <code>number</code> | Desired number of ExternalDNS replicas. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.syncPolicy">syncPolicy</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsSyncPolicy</code> | Controls the operations ExternalDNS will perform on the records it manages. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.zoneTags">zoneTags</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsZoneTag[]</code> | A set of tags that can be used to restrict which hosted zones external DNS will make changes to. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.zoneType">zoneType</a></code> | <code>cdk-extensions.k8s_aws.ExternalDnsZoneType</code> | Controls the types of hosted zones external-dns will create records for. |
| <code><a href="#cdk-extensions.k8s_aws.Route53DnsProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where external-dns should be deployed. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.Route53DnsProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.Route53DnsProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.Route53DnsProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.Route53DnsProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

Override the default region external-dns uses when calling AWS API's.

---

##### `apiRetries`<sup>Optional</sup> <a name="apiRetries" id="cdk-extensions.k8s_aws.Route53DnsProps.property.apiRetries"></a>

```typescript
public readonly apiRetries: number;
```

- *Type:* number
- *Default:* 3

Maximum number of retries for AWS API calls before giving up.

---

##### `batchChangeSize`<sup>Optional</sup> <a name="batchChangeSize" id="cdk-extensions.k8s_aws.Route53DnsProps.property.batchChangeSize"></a>

```typescript
public readonly batchChangeSize: number;
```

- *Type:* number
- *Default:* 1000

Set the maximum number of changes that will be applied in each batch.

---

##### `domainFilter`<sup>Optional</sup> <a name="domainFilter" id="cdk-extensions.k8s_aws.Route53DnsProps.property.domainFilter"></a>

```typescript
public readonly domainFilter: string[];
```

- *Type:* string[]

Limits possible target zones by domain suffixes.

---

##### `evaluateTargetHealth`<sup>Optional</sup> <a name="evaluateTargetHealth" id="cdk-extensions.k8s_aws.Route53DnsProps.property.evaluateTargetHealth"></a>

```typescript
public readonly evaluateTargetHealth: boolean;
```

- *Type:* boolean

Sets a flag determining whether the health of the backend service should be evaluated when determining DNS routing.

---

##### `logFormat`<sup>Optional</sup> <a name="logFormat" id="cdk-extensions.k8s_aws.Route53DnsProps.property.logFormat"></a>

```typescript
public readonly logFormat: ExternalDnsLogFormat;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsLogFormat
- *Default:* {@link ExternalDnsLogLevel.JSON}

Sets the output format external dns will use when generating logs.

---

##### `logLevel`<sup>Optional</sup> <a name="logLevel" id="cdk-extensions.k8s_aws.Route53DnsProps.property.logLevel"></a>

```typescript
public readonly logLevel: ExternalDnsLogLevel;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsLogLevel
- *Default:* {@link ExternalDnsLogLevel.INFO}

Controls the verbosity of logs generated using the external-dns service.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.Route53DnsProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string
- *Default:* 'kube-system'

The Kubernetes namespace where the service should be deployed.

---

##### `preferCname`<sup>Optional</sup> <a name="preferCname" id="cdk-extensions.k8s_aws.Route53DnsProps.property.preferCname"></a>

```typescript
public readonly preferCname: boolean;
```

- *Type:* boolean
- *Default:* false

When true, alias records will be avoided and CNAME records will be used instead.

---

##### `recordOwnershipRegistry`<sup>Optional</sup> <a name="recordOwnershipRegistry" id="cdk-extensions.k8s_aws.Route53DnsProps.property.recordOwnershipRegistry"></a>

```typescript
public readonly recordOwnershipRegistry: IExternalDnsRegistry;
```

- *Type:* cdk-extensions.k8s_aws.IExternalDnsRegistry
- *Default:* A TXT registry configured with defaults.

Registry specifying how ExternalDNS should track record ownership.

Without a registry to track record ownership, External has no way to know
which records it owns and manages and which are owned and managed by a
different service.

This can cause conflicts if there are multiple instances of External DNS
running or if there are other services managing DNS records in similar
zones as the different services could try to make conflicting changes due
to lacking a shared state.

---

##### `replicaCount`<sup>Optional</sup> <a name="replicaCount" id="cdk-extensions.k8s_aws.Route53DnsProps.property.replicaCount"></a>

```typescript
public readonly replicaCount: number;
```

- *Type:* number
- *Default:* 1

Desired number of ExternalDNS replicas.

---

##### `syncPolicy`<sup>Optional</sup> <a name="syncPolicy" id="cdk-extensions.k8s_aws.Route53DnsProps.property.syncPolicy"></a>

```typescript
public readonly syncPolicy: ExternalDnsSyncPolicy;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsSyncPolicy
- *Default:* {@link ExternalDnsSyncPolicy.SYNC}

Controls the operations ExternalDNS will perform on the records it manages.

---

##### `zoneTags`<sup>Optional</sup> <a name="zoneTags" id="cdk-extensions.k8s_aws.Route53DnsProps.property.zoneTags"></a>

```typescript
public readonly zoneTags: ExternalDnsZoneTag[];
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneTag[]

A set of tags that can be used to restrict which hosted zones external DNS will make changes to.

---

##### `zoneType`<sup>Optional</sup> <a name="zoneType" id="cdk-extensions.k8s_aws.Route53DnsProps.property.zoneType"></a>

```typescript
public readonly zoneType: ExternalDnsZoneType;
```

- *Type:* cdk-extensions.k8s_aws.ExternalDnsZoneType
- *Default:* ExternalDnsZoneType.ALL

Controls the types of hosted zones external-dns will create records for.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.Route53DnsProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where external-dns should be deployed.

---

### RuleGroupConfigurationDetails <a name="RuleGroupConfigurationDetails" id="cdk-extensions.aps.RuleGroupConfigurationDetails"></a>

The details that are needed to configure an APS rule groups namespace that will consume a rule group configuration.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.RuleGroupConfigurationDetails.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const ruleGroupConfigurationDetails: aps.RuleGroupConfigurationDetails = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupConfigurationDetails.property.content">content</a></code> | <code>string</code> | The content of the rules configuration definition, in the format of an APS rules configuration file. |

---

##### `content`<sup>Required</sup> <a name="content" id="cdk-extensions.aps.RuleGroupConfigurationDetails.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* string

The content of the rules configuration definition, in the format of an APS rules configuration file.

> [[Creating a rules file](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-ruler-rulesfile.html)]([Creating a rules file](https://docs.aws.amazon.com/prometheus/latest/userguide/AMP-ruler-rulesfile.html))

---

### RuleGroupConfigurationProps <a name="RuleGroupConfigurationProps" id="cdk-extensions.aps.RuleGroupConfigurationProps"></a>

Configuration options for a Prometheus rule group configuration.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.RuleGroupConfigurationProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const ruleGroupConfigurationProps: aps.RuleGroupConfigurationProps = { ... }
```


### RuleGroupProps <a name="RuleGroupProps" id="cdk-extensions.aps.RuleGroupProps"></a>

Options needed to configure a Prometheus rule group for use with an APS rule groups namespace configuration.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.RuleGroupProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const ruleGroupProps: aps.RuleGroupProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupProps.property.interval">interval</a></code> | <code>aws-cdk-lib.Duration</code> | How often rules in the group are evaluated. |
| <code><a href="#cdk-extensions.aps.RuleGroupProps.property.limit">limit</a></code> | <code>number</code> | Limit the number of alerts an alerting rule and series a recording rule can produce. |
| <code><a href="#cdk-extensions.aps.RuleGroupProps.property.name">name</a></code> | <code>string</code> | The name of the group. |
| <code><a href="#cdk-extensions.aps.RuleGroupProps.property.rules">rules</a></code> | <code>cdk-extensions.aps.IPrometheusRule[]</code> | The rules to be evaluated per the rule group's configuration. |

---

##### `interval`<sup>Optional</sup> <a name="interval" id="cdk-extensions.aps.RuleGroupProps.property.interval"></a>

```typescript
public readonly interval: Duration;
```

- *Type:* aws-cdk-lib.Duration

How often rules in the group are evaluated.

---

##### `limit`<sup>Optional</sup> <a name="limit" id="cdk-extensions.aps.RuleGroupProps.property.limit"></a>

```typescript
public readonly limit: number;
```

- *Type:* number

Limit the number of alerts an alerting rule and series a recording rule can produce.

0 is no limit.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.aps.RuleGroupProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the group.

Must be unique within the configuration.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk-extensions.aps.RuleGroupProps.property.rules"></a>

```typescript
public readonly rules: IPrometheusRule[];
```

- *Type:* cdk-extensions.aps.IPrometheusRule[]

The rules to be evaluated per the rule group's configuration.

---

### RuleGroupsNamespaceProps <a name="RuleGroupsNamespaceProps" id="cdk-extensions.aps.RuleGroupsNamespaceProps"></a>

Configuration for the RuleGroupsNamespace resource.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.RuleGroupsNamespaceProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const ruleGroupsNamespaceProps: aps.RuleGroupsNamespaceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespaceProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespaceProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespaceProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespaceProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespaceProps.property.workspace">workspace</a></code> | <code>cdk-extensions.aps.IWorkspace</code> | The APS workspace that contains this rule groups namespace. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespaceProps.property.configuration">configuration</a></code> | <code>cdk-extensions.aps.IRuleGroupConfiguration</code> | The rules definition file for this namespace. |
| <code><a href="#cdk-extensions.aps.RuleGroupsNamespaceProps.property.name">name</a></code> | <code>string</code> | The name of the rule groups namespace. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.aps.RuleGroupsNamespaceProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.aps.RuleGroupsNamespaceProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.aps.RuleGroupsNamespaceProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.aps.RuleGroupsNamespaceProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `workspace`<sup>Required</sup> <a name="workspace" id="cdk-extensions.aps.RuleGroupsNamespaceProps.property.workspace"></a>

```typescript
public readonly workspace: IWorkspace;
```

- *Type:* cdk-extensions.aps.IWorkspace

The APS workspace that contains this rule groups namespace.

> [[RuleGroupsNamespace Workspace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-workspace)]([RuleGroupsNamespace Workspace](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-workspace))

---

##### `configuration`<sup>Optional</sup> <a name="configuration" id="cdk-extensions.aps.RuleGroupsNamespaceProps.property.configuration"></a>

```typescript
public readonly configuration: IRuleGroupConfiguration;
```

- *Type:* cdk-extensions.aps.IRuleGroupConfiguration

The rules definition file for this namespace.

> [[RuleGroupsNamespace Data](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-data)]([RuleGroupsNamespace Data](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-data))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.aps.RuleGroupsNamespaceProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the rule groups namespace.

> [[RuleGroupsNamespace Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-name)]([RuleGroupsNamespace Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-rulegroupsnamespace.html#cfn-aps-rulegroupsnamespace-name))

---

### S3AccessLogsBucketProps <a name="S3AccessLogsBucketProps" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps"></a>

Configuration for objects bucket.

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const s3AccessLogsBucketProps: s3_buckets.S3AccessLogsBucketProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.bucketName">bucketName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucketName`<sup>Optional</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---

##### `tableName`<sup>Optional</sup> <a name="tableName" id="cdk-extensions.s3_buckets.S3AccessLogsBucketProps.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

### S3AccessLogsTableProps <a name="S3AccessLogsTableProps" id="cdk-extensions.glue_tables.S3AccessLogsTableProps"></a>

Configuration for S3AccessLogsTable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

const s3AccessLogsTableProps: glue_tables.S3AccessLogsTableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | A bucket where logs will be stored. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the S3 Access Logs. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.name">name</a></code> | <code>string</code> | Name for S3 Access Logs Table. |
| <code><a href="#cdk-extensions.glue_tables.S3AccessLogsTableProps.property.s3Prefix">s3Prefix</a></code> | <code>string</code> | Set a custom prefix for the S3 Bucket. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

A bucket where logs will be stored.

> [[AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html)]([AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html))

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in.

> [[AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html)]([AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html))

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the S3 Access Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name for S3 Access Logs Table.

---

##### `s3Prefix`<sup>Optional</sup> <a name="s3Prefix" id="cdk-extensions.glue_tables.S3AccessLogsTableProps.property.s3Prefix"></a>

```typescript
public readonly s3Prefix: string;
```

- *Type:* string

Set a custom prefix for the S3 Bucket.

---

### S3DestinationOptions <a name="S3DestinationOptions" id="cdk-extensions.kinesis_firehose.S3DestinationOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

const s3DestinationOptions: kinesis_firehose.S3DestinationOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.S3DestinationOptions.property.buffering">buffering</a></code> | <code>cdk-extensions.kinesis_firehose.BufferingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3DestinationOptions.property.cloudwatchLoggingConfiguration">cloudwatchLoggingConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3DestinationOptions.property.compressionFormat">compressionFormat</a></code> | <code>cdk-extensions.kinesis_firehose.S3CompressionFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3DestinationOptions.property.encryptionEnabled">encryptionEnabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3DestinationOptions.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3DestinationOptions.property.errorOutputPrefix">errorOutputPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3DestinationOptions.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3DestinationOptions.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |

---

##### `buffering`<sup>Optional</sup> <a name="buffering" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.property.buffering"></a>

```typescript
public readonly buffering: BufferingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BufferingConfiguration

---

##### `cloudwatchLoggingConfiguration`<sup>Optional</sup> <a name="cloudwatchLoggingConfiguration" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.property.cloudwatchLoggingConfiguration"></a>

```typescript
public readonly cloudwatchLoggingConfiguration: CloudWatchLoggingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration

---

##### `compressionFormat`<sup>Optional</sup> <a name="compressionFormat" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.property.compressionFormat"></a>

```typescript
public readonly compressionFormat: S3CompressionFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.S3CompressionFormat

---

##### `encryptionEnabled`<sup>Optional</sup> <a name="encryptionEnabled" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.property.encryptionEnabled"></a>

```typescript
public readonly encryptionEnabled: boolean;
```

- *Type:* boolean

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

---

##### `errorOutputPrefix`<sup>Optional</sup> <a name="errorOutputPrefix" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.property.errorOutputPrefix"></a>

```typescript
public readonly errorOutputPrefix: string;
```

- *Type:* string

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.S3DestinationOptions.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

### S3Encryption <a name="S3Encryption" id="cdk-extensions.glue.S3Encryption"></a>

S3 encryption configuration.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.S3Encryption.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const s3Encryption: glue.S3Encryption = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.S3Encryption.property.mode">mode</a></code> | <code>cdk-extensions.glue.S3EncryptionMode</code> | Encryption mode. |
| <code><a href="#cdk-extensions.glue.S3Encryption.property.kmsKey">kmsKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | The KMS key to be used to encrypt the data. |

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk-extensions.glue.S3Encryption.property.mode"></a>

```typescript
public readonly mode: S3EncryptionMode;
```

- *Type:* cdk-extensions.glue.S3EncryptionMode

Encryption mode.

---

##### `kmsKey`<sup>Optional</sup> <a name="kmsKey" id="cdk-extensions.glue.S3Encryption.property.kmsKey"></a>

```typescript
public readonly kmsKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey
- *Default:* no kms key if mode = S3_MANAGED. A key will be created if one is not provided and mode = KMS.

The KMS key to be used to encrypt the data.

---

### S3TargetOptions <a name="S3TargetOptions" id="cdk-extensions.glue.S3TargetOptions"></a>

Configuration for Crawler S3 target.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.S3TargetOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const s3TargetOptions: glue.S3TargetOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.S3TargetOptions.property.connection">connection</a></code> | <code>cdk-extensions.glue.Connection</code> | A {@link aws-glue.Connection \| "Connection" } object to connect to the target with. |
| <code><a href="#cdk-extensions.glue.S3TargetOptions.property.exclusions">exclusions</a></code> | <code>string[]</code> | A list of glob patterns used to exclude from the crawl. |
| <code><a href="#cdk-extensions.glue.S3TargetOptions.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | A Prefix Key for identification and organization of objects in the bucket. |
| <code><a href="#cdk-extensions.glue.S3TargetOptions.property.sampleSize">sampleSize</a></code> | <code>string</code> | Sets the number of files in each leaf folder to be crawled when crawling sample files in a dataset. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="cdk-extensions.glue.S3TargetOptions.property.connection"></a>

```typescript
public readonly connection: Connection;
```

- *Type:* cdk-extensions.glue.Connection

A {@link aws-glue.Connection | "Connection" } object to connect to the target with.

---

##### `exclusions`<sup>Optional</sup> <a name="exclusions" id="cdk-extensions.glue.S3TargetOptions.property.exclusions"></a>

```typescript
public readonly exclusions: string[];
```

- *Type:* string[]

A list of glob patterns used to exclude from the crawl.

> [[For More Information](https://docs.aws.amazon.com/glue/latest/dg/add-crawler.html)]([For More Information](https://docs.aws.amazon.com/glue/latest/dg/add-crawler.html))

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk-extensions.glue.S3TargetOptions.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string

A Prefix Key for identification and organization of objects in the bucket.

---

##### `sampleSize`<sup>Optional</sup> <a name="sampleSize" id="cdk-extensions.glue.S3TargetOptions.property.sampleSize"></a>

```typescript
public readonly sampleSize: string;
```

- *Type:* string

Sets the number of files in each leaf folder to be crawled when crawling sample files in a dataset.

If not set, all the files are crawled. A valid value is an integer between 1 and 249.

> [[AWS::Glue::Crawler S3Target](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-s3target.html#cfn-glue-crawler-s3target-samplesize)]([AWS::Glue::Crawler S3Target](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-crawler-s3target.html#cfn-glue-crawler-s3target-samplesize))

---

### ScalaJobExecutableProps <a name="ScalaJobExecutableProps" id="cdk-extensions.glue.ScalaJobExecutableProps"></a>

Props for creating a Scala Spark (ETL or Streaming) job executable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.ScalaJobExecutableProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const scalaJobExecutableProps: glue.ScalaJobExecutableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ScalaJobExecutableProps.property.className">className</a></code> | <code>string</code> | The fully qualified Scala class name that serves as the entry point for the job. |
| <code><a href="#cdk-extensions.glue.ScalaJobExecutableProps.property.glueVersion">glueVersion</a></code> | <code>cdk-extensions.glue.GlueVersion</code> | Glue version. |
| <code><a href="#cdk-extensions.glue.ScalaJobExecutableProps.property.script">script</a></code> | <code>cdk-extensions.glue.Code</code> | The script that executes a job. |
| <code><a href="#cdk-extensions.glue.ScalaJobExecutableProps.property.extraFiles">extraFiles</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional files, such as configuration files that AWS Glue copies to the working directory of your script before executing it. |
| <code><a href="#cdk-extensions.glue.ScalaJobExecutableProps.property.extraJars">extraJars</a></code> | <code>cdk-extensions.glue.Code[]</code> | Additional Java .jar files that AWS Glue adds to the Java classpath before executing your script. Only individual files are supported, directories are not supported. |
| <code><a href="#cdk-extensions.glue.ScalaJobExecutableProps.property.extraJarsFirst">extraJarsFirst</a></code> | <code>boolean</code> | Setting this value to true prioritizes the customer's extra JAR files in the classpath. |

---

##### `className`<sup>Required</sup> <a name="className" id="cdk-extensions.glue.ScalaJobExecutableProps.property.className"></a>

```typescript
public readonly className: string;
```

- *Type:* string

The fully qualified Scala class name that serves as the entry point for the job.

> [`--class` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--class` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `glueVersion`<sup>Required</sup> <a name="glueVersion" id="cdk-extensions.glue.ScalaJobExecutableProps.property.glueVersion"></a>

```typescript
public readonly glueVersion: GlueVersion;
```

- *Type:* cdk-extensions.glue.GlueVersion

Glue version.

> [https://docs.aws.amazon.com/glue/latest/dg/release-notes.html](https://docs.aws.amazon.com/glue/latest/dg/release-notes.html)

---

##### `script`<sup>Required</sup> <a name="script" id="cdk-extensions.glue.ScalaJobExecutableProps.property.script"></a>

```typescript
public readonly script: Code;
```

- *Type:* cdk-extensions.glue.Code

The script that executes a job.

---

##### `extraFiles`<sup>Optional</sup> <a name="extraFiles" id="cdk-extensions.glue.ScalaJobExecutableProps.property.extraFiles"></a>

```typescript
public readonly extraFiles: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* [] - no extra files are copied to the working directory

Additional files, such as configuration files that AWS Glue copies to the working directory of your script before executing it.

Only individual files are supported, directories are not supported.

> [`--extra-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-files` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraJars`<sup>Optional</sup> <a name="extraJars" id="cdk-extensions.glue.ScalaJobExecutableProps.property.extraJars"></a>

```typescript
public readonly extraJars: Code[];
```

- *Type:* cdk-extensions.glue.Code[]
- *Default:* [] - no extra jars are added to the classpath

Additional Java .jar files that AWS Glue adds to the Java classpath before executing your script. Only individual files are supported, directories are not supported.

> [`--extra-jars` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--extra-jars` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

##### `extraJarsFirst`<sup>Optional</sup> <a name="extraJarsFirst" id="cdk-extensions.glue.ScalaJobExecutableProps.property.extraJarsFirst"></a>

```typescript
public readonly extraJarsFirst: boolean;
```

- *Type:* boolean
- *Default:* false - priority is not given to user-provided jars

Setting this value to true prioritizes the customer's extra JAR files in the classpath.

> [`--user-jars-first` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html](`--user-jars-first` in https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)

---

### SecretFieldReference <a name="SecretFieldReference" id="cdk-extensions.k8s_aws.SecretFieldReference"></a>

Options for how to synchronize a specific field in a secret being imported.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.SecretFieldReference.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const secretFieldReference: k8s_aws.SecretFieldReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretFieldReference.property.kubernetesKey">kubernetesKey</a></code> | <code>string</code> | The name of the data key to be used for the field in the imported Kubernetes secret. |
| <code><a href="#cdk-extensions.k8s_aws.SecretFieldReference.property.metadataPolicy">metadataPolicy</a></code> | <code>cdk-extensions.k8s_aws.MetadataPolicy</code> | Policy for fetching tags/labels from provider secrets. |
| <code><a href="#cdk-extensions.k8s_aws.SecretFieldReference.property.remoteKey">remoteKey</a></code> | <code>string</code> | The JSON key for the field in the secret being imported. |

---

##### `kubernetesKey`<sup>Required</sup> <a name="kubernetesKey" id="cdk-extensions.k8s_aws.SecretFieldReference.property.kubernetesKey"></a>

```typescript
public readonly kubernetesKey: string;
```

- *Type:* string

The name of the data key to be used for the field in the imported Kubernetes secret.

---

##### `metadataPolicy`<sup>Optional</sup> <a name="metadataPolicy" id="cdk-extensions.k8s_aws.SecretFieldReference.property.metadataPolicy"></a>

```typescript
public readonly metadataPolicy: MetadataPolicy;
```

- *Type:* cdk-extensions.k8s_aws.MetadataPolicy

Policy for fetching tags/labels from provider secrets.

---

##### `remoteKey`<sup>Optional</sup> <a name="remoteKey" id="cdk-extensions.k8s_aws.SecretFieldReference.property.remoteKey"></a>

```typescript
public readonly remoteKey: string;
```

- *Type:* string

The JSON key for the field in the secret being imported.

---

### SecretReferenceConfiguration <a name="SecretReferenceConfiguration" id="cdk-extensions.k8s_aws.SecretReferenceConfiguration"></a>

Configuration detailing how secrets are to be synchronized.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.SecretReferenceConfiguration.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const secretReferenceConfiguration: k8s_aws.SecretReferenceConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretReferenceConfiguration.property.remoteRef">remoteRef</a></code> | <code>string</code> | The ID of the secret to be imported from the provider. |
| <code><a href="#cdk-extensions.k8s_aws.SecretReferenceConfiguration.property.fields">fields</a></code> | <code>cdk-extensions.k8s_aws.SecretFieldReference[]</code> | A mapping of fields and per field options to use when synchronizing a secret from a provider. |

---

##### `remoteRef`<sup>Required</sup> <a name="remoteRef" id="cdk-extensions.k8s_aws.SecretReferenceConfiguration.property.remoteRef"></a>

```typescript
public readonly remoteRef: string;
```

- *Type:* string

The ID of the secret to be imported from the provider.

---

##### `fields`<sup>Optional</sup> <a name="fields" id="cdk-extensions.k8s_aws.SecretReferenceConfiguration.property.fields"></a>

```typescript
public readonly fields: SecretFieldReference[];
```

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference[]

A mapping of fields and per field options to use when synchronizing a secret from a provider.

---

### SecretsManagerReferenceOptions <a name="SecretsManagerReferenceOptions" id="cdk-extensions.k8s_aws.SecretsManagerReferenceOptions"></a>

Configuration options for referencing a Secrets Manager secret as a Kubernetes secret.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.SecretsManagerReferenceOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const secretsManagerReferenceOptions: k8s_aws.SecretsManagerReferenceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerReferenceOptions.property.fields">fields</a></code> | <code>cdk-extensions.k8s_aws.SecretFieldReference[]</code> | Defines a mapping of how JSON keys in the Secrets Manager secret should appear in the imported Kubernetes secret. |

---

##### `fields`<sup>Optional</sup> <a name="fields" id="cdk-extensions.k8s_aws.SecretsManagerReferenceOptions.property.fields"></a>

```typescript
public readonly fields: SecretFieldReference[];
```

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference[]

Defines a mapping of how JSON keys in the Secrets Manager secret should appear in the imported Kubernetes secret.

---

### SecretsManagerSecretStoreProps <a name="SecretsManagerSecretStoreProps" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps"></a>

Configuration options for adding a new secret store resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const secretsManagerSecretStoreProps: k8s_aws.SecretsManagerSecretStoreProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.name">name</a></code> | <code>string</code> | A human friendly name for the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the secret store should be created. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the secret store should be created.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A human friendly name for the secret store.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.SecretsManagerSecretStoreProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the secret store should be created.

---

### SecurityConfigurationProps <a name="SecurityConfigurationProps" id="cdk-extensions.glue.SecurityConfigurationProps"></a>

Configuration for the Glue SecurityConfiguration resource.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.SecurityConfigurationProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const securityConfigurationProps: glue.SecurityConfigurationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.SecurityConfigurationProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.SecurityConfigurationProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.SecurityConfigurationProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.SecurityConfigurationProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.SecurityConfigurationProps.property.cloudWatchEncryption">cloudWatchEncryption</a></code> | <code>cdk-extensions.glue.CloudWatchEncryption</code> | Cloudwatch Encryption Settings. |
| <code><a href="#cdk-extensions.glue.SecurityConfigurationProps.property.jobBookmarksEncryption">jobBookmarksEncryption</a></code> | <code>cdk-extensions.glue.JobBookmarksEncryption</code> | The encryption configuration for job bookmarks. |
| <code><a href="#cdk-extensions.glue.SecurityConfigurationProps.property.name">name</a></code> | <code>string</code> | Name for the Security Configuration. |
| <code><a href="#cdk-extensions.glue.SecurityConfigurationProps.property.s3Encryption">s3Encryption</a></code> | <code>cdk-extensions.glue.S3Encryption</code> | The encyption configuration for Amazon Simple Storage Service (Amazon S3) data. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.SecurityConfigurationProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.SecurityConfigurationProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.SecurityConfigurationProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.SecurityConfigurationProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cloudWatchEncryption`<sup>Optional</sup> <a name="cloudWatchEncryption" id="cdk-extensions.glue.SecurityConfigurationProps.property.cloudWatchEncryption"></a>

```typescript
public readonly cloudWatchEncryption: CloudWatchEncryption;
```

- *Type:* cdk-extensions.glue.CloudWatchEncryption

Cloudwatch Encryption Settings.

> [[AWS::Glue::SecurityConfiguration EncryptionConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-securityconfiguration-encryptionconfiguration.html#cfn-glue-securityconfiguration-encryptionconfiguration-cloudwatchencryption)]([AWS::Glue::SecurityConfiguration EncryptionConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-securityconfiguration-encryptionconfiguration.html#cfn-glue-securityconfiguration-encryptionconfiguration-cloudwatchencryption))

---

##### `jobBookmarksEncryption`<sup>Optional</sup> <a name="jobBookmarksEncryption" id="cdk-extensions.glue.SecurityConfigurationProps.property.jobBookmarksEncryption"></a>

```typescript
public readonly jobBookmarksEncryption: JobBookmarksEncryption;
```

- *Type:* cdk-extensions.glue.JobBookmarksEncryption

The encryption configuration for job bookmarks.

> [[AWS::Glue::SecurityConfiguration EncryptionConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-securityconfiguration-encryptionconfiguration.html#cfn-glue-securityconfiguration-encryptionconfiguration-jobbookmarksencryption)]([AWS::Glue::SecurityConfiguration EncryptionConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-securityconfiguration-encryptionconfiguration.html#cfn-glue-securityconfiguration-encryptionconfiguration-jobbookmarksencryption))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.SecurityConfigurationProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name for the Security Configuration.

---

##### `s3Encryption`<sup>Optional</sup> <a name="s3Encryption" id="cdk-extensions.glue.SecurityConfigurationProps.property.s3Encryption"></a>

```typescript
public readonly s3Encryption: S3Encryption;
```

- *Type:* cdk-extensions.glue.S3Encryption

The encyption configuration for Amazon Simple Storage Service (Amazon S3) data.

> [[AWS::Glue::SecurityConfiguration EncryptionConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-securityconfiguration-encryptionconfiguration.html#cfn-glue-securityconfiguration-encryptionconfiguration-s3encryptions)]([AWS::Glue::SecurityConfiguration EncryptionConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-securityconfiguration-encryptionconfiguration.html#cfn-glue-securityconfiguration-encryptionconfiguration-s3encryptions))

---

### SesLogsBucketProps <a name="SesLogsBucketProps" id="cdk-extensions.s3_buckets.SesLogsBucketProps"></a>

Configuration for objects bucket.

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.SesLogsBucketProps.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const sesLogsBucketProps: s3_buckets.SesLogsBucketProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.bucketName">bucketName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.SesLogsBucketProps.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucketName`<sup>Optional</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---

##### `tableName`<sup>Optional</sup> <a name="tableName" id="cdk-extensions.s3_buckets.SesLogsBucketProps.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

### SesLogsTableProps <a name="SesLogsTableProps" id="cdk-extensions.glue_tables.SesLogsTableProps"></a>

Configuration for SesLogsTable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue_tables.SesLogsTableProps.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

const sesLogsTableProps: glue_tables.SesLogsTableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | A bucket where logs will be stored. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the Ses Logs. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.name">name</a></code> | <code>string</code> | Name for SES Logs Table. |
| <code><a href="#cdk-extensions.glue_tables.SesLogsTableProps.property.s3Prefix">s3Prefix</a></code> | <code>string</code> | Set a custom prefix for the S3 Bucket. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue_tables.SesLogsTableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue_tables.SesLogsTableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue_tables.SesLogsTableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue_tables.SesLogsTableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue_tables.SesLogsTableProps.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

A bucket where logs will be stored.

> [[AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html)]([AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html))

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.SesLogsTableProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in.

> [[AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html)]([AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html))

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.glue_tables.SesLogsTableProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the Ses Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.SesLogsTableProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.SesLogsTableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name for SES Logs Table.

---

##### `s3Prefix`<sup>Optional</sup> <a name="s3Prefix" id="cdk-extensions.glue_tables.SesLogsTableProps.property.s3Prefix"></a>

```typescript
public readonly s3Prefix: string;
```

- *Type:* string

Set a custom prefix for the S3 Bucket.

---

### SharingOptions <a name="SharingOptions" id="cdk-extensions.ec2.SharingOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.SharingOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const sharingOptions: ec2.SharingOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.SharingOptions.property.allowExternalPrincipals">allowExternalPrincipals</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.SharingOptions.property.autoDiscoverAccounts">autoDiscoverAccounts</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.SharingOptions.property.principals">principals</a></code> | <code>cdk-extensions.ram.ISharedPrincipal[]</code> | *No description.* |

---

##### `allowExternalPrincipals`<sup>Optional</sup> <a name="allowExternalPrincipals" id="cdk-extensions.ec2.SharingOptions.property.allowExternalPrincipals"></a>

```typescript
public readonly allowExternalPrincipals: boolean;
```

- *Type:* boolean

---

##### `autoDiscoverAccounts`<sup>Optional</sup> <a name="autoDiscoverAccounts" id="cdk-extensions.ec2.SharingOptions.property.autoDiscoverAccounts"></a>

```typescript
public readonly autoDiscoverAccounts: boolean;
```

- *Type:* boolean

---

##### `principals`<sup>Optional</sup> <a name="principals" id="cdk-extensions.ec2.SharingOptions.property.principals"></a>

```typescript
public readonly principals: ISharedPrincipal[];
```

- *Type:* cdk-extensions.ram.ISharedPrincipal[]

---

### SiteProps <a name="SiteProps" id="cdk-extensions.networkmanager.SiteProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.networkmanager.SiteProps.Initializer"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

const siteProps: networkmanager.SiteProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.globalNetwork">globalNetwork</a></code> | <code>cdk-extensions.networkmanager.IGlobalNetwork</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.latitude">latitude</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.SiteProps.property.longitude">longitude</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.networkmanager.SiteProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.networkmanager.SiteProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.networkmanager.SiteProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.networkmanager.SiteProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `globalNetwork`<sup>Required</sup> <a name="globalNetwork" id="cdk-extensions.networkmanager.SiteProps.property.globalNetwork"></a>

```typescript
public readonly globalNetwork: IGlobalNetwork;
```

- *Type:* cdk-extensions.networkmanager.IGlobalNetwork

---

##### `address`<sup>Optional</sup> <a name="address" id="cdk-extensions.networkmanager.SiteProps.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.networkmanager.SiteProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `latitude`<sup>Optional</sup> <a name="latitude" id="cdk-extensions.networkmanager.SiteProps.property.latitude"></a>

```typescript
public readonly latitude: string;
```

- *Type:* string

---

##### `longitude`<sup>Optional</sup> <a name="longitude" id="cdk-extensions.networkmanager.SiteProps.property.longitude"></a>

```typescript
public readonly longitude: string;
```

- *Type:* string

---

### SsmParameterReferenceOptions <a name="SsmParameterReferenceOptions" id="cdk-extensions.k8s_aws.SsmParameterReferenceOptions"></a>

Configuration options for referencing an SSM parameter as a Kubernetes secret.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.SsmParameterReferenceOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const ssmParameterReferenceOptions: k8s_aws.SsmParameterReferenceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterReferenceOptions.property.fields">fields</a></code> | <code>cdk-extensions.k8s_aws.SecretFieldReference[]</code> | Defines a mapping of how JSON keys in the SSM parameter should appear in the imported Kubernetes secret. |

---

##### `fields`<sup>Optional</sup> <a name="fields" id="cdk-extensions.k8s_aws.SsmParameterReferenceOptions.property.fields"></a>

```typescript
public readonly fields: SecretFieldReference[];
```

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference[]

Defines a mapping of how JSON keys in the SSM parameter should appear in the imported Kubernetes secret.

---

### SsmParameterSecretStoreProps <a name="SsmParameterSecretStoreProps" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps"></a>

Configuration options for adding a new secret store resource.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const ssmParameterSecretStoreProps: k8s_aws.SsmParameterSecretStoreProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.cluster">cluster</a></code> | <code>aws-cdk-lib.aws_eks.ICluster</code> | The EKS cluster where the secret store should be created. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.name">name</a></code> | <code>string</code> | A human friendly name for the secret store. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.namespace">namespace</a></code> | <code>string</code> | The Kubernetes namespace where the secret store should be created. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cluster`<sup>Required</sup> <a name="cluster" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.cluster"></a>

```typescript
public readonly cluster: ICluster;
```

- *Type:* aws-cdk-lib.aws_eks.ICluster

The EKS cluster where the secret store should be created.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A human friendly name for the secret store.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk-extensions.k8s_aws.SsmParameterSecretStoreProps.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

The Kubernetes namespace where the secret store should be created.

---

### StructColumnProps <a name="StructColumnProps" id="cdk-extensions.glue.StructColumnProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.glue.StructColumnProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const structColumnProps: glue.StructColumnProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.StructColumnProps.property.comment">comment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.StructColumnProps.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.StructColumnProps.property.data">data</a></code> | <code>cdk-extensions.glue.Column[]</code> | *No description.* |

---

##### `comment`<sup>Optional</sup> <a name="comment" id="cdk-extensions.glue.StructColumnProps.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.StructColumnProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk-extensions.glue.StructColumnProps.property.data"></a>

```typescript
public readonly data: Column[];
```

- *Type:* cdk-extensions.glue.Column[]

---

### TableProps <a name="TableProps" id="cdk-extensions.glue.TableProps"></a>

Configuration for Table.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.TableProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const tableProps: glue.TableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.TableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.TableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.TableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.TableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.TableProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | Database object to add Table to. |
| <code><a href="#cdk-extensions.glue.TableProps.property.columns">columns</a></code> | <code>cdk-extensions.glue.Column[]</code> | A list of the Columns in the table. |
| <code><a href="#cdk-extensions.glue.TableProps.property.compressed">compressed</a></code> | <code>boolean</code> | True if the data in the table is compressed, or False if not. |
| <code><a href="#cdk-extensions.glue.TableProps.property.dataFormat">dataFormat</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat object indicating the expected input/output format. |
| <code><a href="#cdk-extensions.glue.TableProps.property.description">description</a></code> | <code>string</code> | A description for the Table. |
| <code><a href="#cdk-extensions.glue.TableProps.property.location">location</a></code> | <code>string</code> | The physical location of the table. |
| <code><a href="#cdk-extensions.glue.TableProps.property.name">name</a></code> | <code>string</code> | A name for the Table. |
| <code><a href="#cdk-extensions.glue.TableProps.property.owner">owner</a></code> | <code>string</code> | The table owner. |
| <code><a href="#cdk-extensions.glue.TableProps.property.parameters">parameters</a></code> | <code>{[ key: string ]: string}</code> | These key-value pairs define properties associated with the table. |
| <code><a href="#cdk-extensions.glue.TableProps.property.partitionKeys">partitionKeys</a></code> | <code>cdk-extensions.glue.Column[]</code> | A list of columns by which the table is partitioned. |
| <code><a href="#cdk-extensions.glue.TableProps.property.retention">retention</a></code> | <code>aws-cdk-lib.Duration</code> | The retention time for this table. |
| <code><a href="#cdk-extensions.glue.TableProps.property.serdeName">serdeName</a></code> | <code>string</code> | Name of the SerDe. |
| <code><a href="#cdk-extensions.glue.TableProps.property.serdeParameters">serdeParameters</a></code> | <code>{[ key: string ]: string}</code> | These key-value pairs define initialization parameters for the SerDe. |
| <code><a href="#cdk-extensions.glue.TableProps.property.storageParameters">storageParameters</a></code> | <code>{[ key: string ]: string}</code> | The user-supplied properties in key-value form. |
| <code><a href="#cdk-extensions.glue.TableProps.property.storedAsSubDirectories">storedAsSubDirectories</a></code> | <code>boolean</code> | True if the table data is stored in subdirectories, or False if not. |
| <code><a href="#cdk-extensions.glue.TableProps.property.tableType">tableType</a></code> | <code>cdk-extensions.glue.TableType</code> | The type of this table. |
| <code><a href="#cdk-extensions.glue.TableProps.property.targetTable">targetTable</a></code> | <code>cdk-extensions.glue.Table</code> | A TableIdentifier structure that describes a target table for resource linking. |
| <code><a href="#cdk-extensions.glue.TableProps.property.viewExpandedText">viewExpandedText</a></code> | <code>string</code> | Included for Apache Hive compatibility. |
| <code><a href="#cdk-extensions.glue.TableProps.property.viewOriginalText">viewOriginalText</a></code> | <code>string</code> | Included for Apache Hive compatibility. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.TableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.TableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.TableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.TableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue.TableProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

Database object to add Table to.

---

##### `columns`<sup>Optional</sup> <a name="columns" id="cdk-extensions.glue.TableProps.property.columns"></a>

```typescript
public readonly columns: Column[];
```

- *Type:* cdk-extensions.glue.Column[]

A list of the Columns in the table.

> [[AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-columns)]([AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-columns))

---

##### `compressed`<sup>Optional</sup> <a name="compressed" id="cdk-extensions.glue.TableProps.property.compressed"></a>

```typescript
public readonly compressed: boolean;
```

- *Type:* boolean

True if the data in the table is compressed, or False if not.

> [[AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-compressed)]([AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-compressed))

---

##### `dataFormat`<sup>Optional</sup> <a name="dataFormat" id="cdk-extensions.glue.TableProps.property.dataFormat"></a>

```typescript
public readonly dataFormat: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat object indicating the expected input/output format.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.TableProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A description for the Table.

---

##### `location`<sup>Optional</sup> <a name="location" id="cdk-extensions.glue.TableProps.property.location"></a>

```typescript
public readonly location: string;
```

- *Type:* string

The physical location of the table.

By default, this takes the form of the warehouse location, followed by the database location in the warehouse, followed by the table name.

> [[AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-location)]([AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-location))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.TableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A name for the Table.

---

##### `owner`<sup>Optional</sup> <a name="owner" id="cdk-extensions.glue.TableProps.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

The table owner.

Included for Apache Hive compatibility. Not used in the normal course of AWS Glue operations.

> [[AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-owner)]([AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-owner))

---

##### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk-extensions.glue.TableProps.property.parameters"></a>

```typescript
public readonly parameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

These key-value pairs define properties associated with the table.

> [[AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-parameters)]([AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-parameters))

---

##### `partitionKeys`<sup>Optional</sup> <a name="partitionKeys" id="cdk-extensions.glue.TableProps.property.partitionKeys"></a>

```typescript
public readonly partitionKeys: Column[];
```

- *Type:* cdk-extensions.glue.Column[]

A list of columns by which the table is partitioned.

Only primitive types are supported as partition keys.

> [[AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-parameterskeys)]([AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-parameterskeys))

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.glue.TableProps.property.retention"></a>

```typescript
public readonly retention: Duration;
```

- *Type:* aws-cdk-lib.Duration

The retention time for this table.

> [[AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-retention)]([AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-retention))

---

##### `serdeName`<sup>Optional</sup> <a name="serdeName" id="cdk-extensions.glue.TableProps.property.serdeName"></a>

```typescript
public readonly serdeName: string;
```

- *Type:* string

Name of the SerDe.

> [[AWS::Glue::Table SerdeInfo](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-serdeinfo.html#cfn-glue-table-serdeinfo-name)]([AWS::Glue::Table SerdeInfo](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-serdeinfo.html#cfn-glue-table-serdeinfo-name))

---

##### `serdeParameters`<sup>Optional</sup> <a name="serdeParameters" id="cdk-extensions.glue.TableProps.property.serdeParameters"></a>

```typescript
public readonly serdeParameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

These key-value pairs define initialization parameters for the SerDe.

> [[AWS::Glue::Table SerdeInfo](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-serdeinfo.html#cfn-glue-table-serdeinfo-parameters)]([AWS::Glue::Table SerdeInfo](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-serdeinfo.html#cfn-glue-table-serdeinfo-parameters))

---

##### `storageParameters`<sup>Optional</sup> <a name="storageParameters" id="cdk-extensions.glue.TableProps.property.storageParameters"></a>

```typescript
public readonly storageParameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The user-supplied properties in key-value form.

> [[AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-parameters)]([AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-parameters))

---

##### `storedAsSubDirectories`<sup>Optional</sup> <a name="storedAsSubDirectories" id="cdk-extensions.glue.TableProps.property.storedAsSubDirectories"></a>

```typescript
public readonly storedAsSubDirectories: boolean;
```

- *Type:* boolean

True if the table data is stored in subdirectories, or False if not.

> [[AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-storedassubdirectories)]([AWS::Glue::Table StorageDescriptor](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-storagedescriptor.html#cfn-glue-table-storagedescriptor-storedassubdirectories))

---

##### `tableType`<sup>Optional</sup> <a name="tableType" id="cdk-extensions.glue.TableProps.property.tableType"></a>

```typescript
public readonly tableType: TableType;
```

- *Type:* cdk-extensions.glue.TableType

The type of this table.

AWS Glue will create tables with the EXTERNAL_TABLE type. Other services, such as Athena, may create tables with additional table types.

> [[AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-tabletype)]([AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-tabletype))

---

##### `targetTable`<sup>Optional</sup> <a name="targetTable" id="cdk-extensions.glue.TableProps.property.targetTable"></a>

```typescript
public readonly targetTable: Table;
```

- *Type:* cdk-extensions.glue.Table

A TableIdentifier structure that describes a target table for resource linking.

> [[AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-targettable)]([AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-targettable))

---

##### `viewExpandedText`<sup>Optional</sup> <a name="viewExpandedText" id="cdk-extensions.glue.TableProps.property.viewExpandedText"></a>

```typescript
public readonly viewExpandedText: string;
```

- *Type:* string

Included for Apache Hive compatibility.

Not used in the normal course of AWS Glue operations.

> [[AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-viewexpandedtext)]([AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-viewexpandedtext))

---

##### `viewOriginalText`<sup>Optional</sup> <a name="viewOriginalText" id="cdk-extensions.glue.TableProps.property.viewOriginalText"></a>

```typescript
public readonly viewOriginalText: string;
```

- *Type:* string

Included for Apache Hive compatibility.

Not used in the normal course of AWS Glue operations. If the table is a VIRTUAL_VIEW, certain Athena configuration encoded in base64.

> [[AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-vieworiginaltext)]([AWS::Glue::Table TableInput](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-tableinput.html#cfn-glue-table-tableinput-vieworiginaltext))

---

### TieredSubnetsOptions <a name="TieredSubnetsOptions" id="cdk-extensions.ec2.TieredSubnetsOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TieredSubnetsOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const tieredSubnetsOptions: ec2.TieredSubnetsOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TieredSubnetsOptions.property.provider">provider</a></code> | <code>cdk-extensions.ec2.ICidrProvider</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TieredSubnetsOptions.property.tierMask">tierMask</a></code> | <code>number</code> | *No description.* |

---

##### `provider`<sup>Required</sup> <a name="provider" id="cdk-extensions.ec2.TieredSubnetsOptions.property.provider"></a>

```typescript
public readonly provider: ICidrProvider;
```

- *Type:* cdk-extensions.ec2.ICidrProvider

---

##### `tierMask`<sup>Optional</sup> <a name="tierMask" id="cdk-extensions.ec2.TieredSubnetsOptions.property.tierMask"></a>

```typescript
public readonly tierMask: number;
```

- *Type:* number

---

### TimeIntervalEntryProps <a name="TimeIntervalEntryProps" id="cdk-extensions.aps.TimeIntervalEntryProps"></a>

Configuration for the alert manager time interval.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.TimeIntervalEntryProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const timeIntervalEntryProps: aps.TimeIntervalEntryProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntryProps.property.daysOfTheMonth">daysOfTheMonth</a></code> | <code>cdk-extensions.aps.DayOfMonthRange[]</code> | A list of ranges specifying the days of the month that the time interval should apply for. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntryProps.property.months">months</a></code> | <code>cdk-extensions.aps.MonthRange[]</code> | A list of ranges specifying the months that the time interval should apply for. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntryProps.property.times">times</a></code> | <code>cdk-extensions.aps.TimeRange[]</code> | A list of ranges specifying the time periods that the time interval should apply for. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntryProps.property.timeZone">timeZone</a></code> | <code>string</code> | A string that matches a location in the IANA time zone database. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntryProps.property.weekdays">weekdays</a></code> | <code>cdk-extensions.aps.WeekdayRange[]</code> | A list of ranges specifying the weekdays that the time interval should apply for. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntryProps.property.years">years</a></code> | <code>cdk-extensions.aps.YearRange[]</code> | A list of ranges specifying the years that the time interval should apply for. |

---

##### `daysOfTheMonth`<sup>Optional</sup> <a name="daysOfTheMonth" id="cdk-extensions.aps.TimeIntervalEntryProps.property.daysOfTheMonth"></a>

```typescript
public readonly daysOfTheMonth: DayOfMonthRange[];
```

- *Type:* cdk-extensions.aps.DayOfMonthRange[]

A list of ranges specifying the days of the month that the time interval should apply for.

---

##### `months`<sup>Optional</sup> <a name="months" id="cdk-extensions.aps.TimeIntervalEntryProps.property.months"></a>

```typescript
public readonly months: MonthRange[];
```

- *Type:* cdk-extensions.aps.MonthRange[]

A list of ranges specifying the months that the time interval should apply for.

---

##### `times`<sup>Optional</sup> <a name="times" id="cdk-extensions.aps.TimeIntervalEntryProps.property.times"></a>

```typescript
public readonly times: TimeRange[];
```

- *Type:* cdk-extensions.aps.TimeRange[]

A list of ranges specifying the time periods that the time interval should apply for.

---

##### `timeZone`<sup>Optional</sup> <a name="timeZone" id="cdk-extensions.aps.TimeIntervalEntryProps.property.timeZone"></a>

```typescript
public readonly timeZone: string;
```

- *Type:* string

A string that matches a location in the IANA time zone database.

For example, 'Australia/Sydney'. The location provides the time zone for
the time interval.

You may also use `Local` as a location to use the local time of the
machine where Alertmanager is running, or `UTC` for UTC time. If no
timezone is provided, the time interval is taken to be in UTC time.

---

##### `weekdays`<sup>Optional</sup> <a name="weekdays" id="cdk-extensions.aps.TimeIntervalEntryProps.property.weekdays"></a>

```typescript
public readonly weekdays: WeekdayRange[];
```

- *Type:* cdk-extensions.aps.WeekdayRange[]

A list of ranges specifying the weekdays that the time interval should apply for.

---

##### `years`<sup>Optional</sup> <a name="years" id="cdk-extensions.aps.TimeIntervalEntryProps.property.years"></a>

```typescript
public readonly years: YearRange[];
```

- *Type:* cdk-extensions.aps.YearRange[]

A list of ranges specifying the years that the time interval should apply for.

---

### TimeIntervalProps <a name="TimeIntervalProps" id="cdk-extensions.aps.TimeIntervalProps"></a>

Configuration for the alert manager time interval.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.TimeIntervalProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const timeIntervalProps: aps.TimeIntervalProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.TimeIntervalProps.property.intervals">intervals</a></code> | <code>cdk-extensions.aps.TimeIntervalEntry[]</code> | The interval definitions that define the periods of time that the time interval should apply for. |
| <code><a href="#cdk-extensions.aps.TimeIntervalProps.property.name">name</a></code> | <code>string</code> | The name of the time interval as it will be referenced throught the rest of the alert manager configuration. |

---

##### `intervals`<sup>Optional</sup> <a name="intervals" id="cdk-extensions.aps.TimeIntervalProps.property.intervals"></a>

```typescript
public readonly intervals: TimeIntervalEntry[];
```

- *Type:* cdk-extensions.aps.TimeIntervalEntry[]

The interval definitions that define the periods of time that the time interval should apply for.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.aps.TimeIntervalProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the time interval as it will be referenced throught the rest of the alert manager configuration.

---

### TimeRange <a name="TimeRange" id="cdk-extensions.aps.TimeRange"></a>

Ranges inclusive of the starting time and exclusive of the end time to make it easy to represent times that start/end on hour boundaries.

For example, `start: '17:00'` and `end: '24:00'` will begin at 17:00 and
finish immediately before 24:00.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.TimeRange.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const timeRange: aps.TimeRange = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.TimeRange.property.end">end</a></code> | <code>string</code> | The end time, specified in the format 'HH:MM' using 24 hour time. |
| <code><a href="#cdk-extensions.aps.TimeRange.property.start">start</a></code> | <code>string</code> | The start time, specified in the format 'HH:MM' using 24 hour time. |

---

##### `end`<sup>Required</sup> <a name="end" id="cdk-extensions.aps.TimeRange.property.end"></a>

```typescript
public readonly end: string;
```

- *Type:* string

The end time, specified in the format 'HH:MM' using 24 hour time.

---

##### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.TimeRange.property.start"></a>

```typescript
public readonly start: string;
```

- *Type:* string

The start time, specified in the format 'HH:MM' using 24 hour time.

---

### TransitGatewayAttachmentProps <a name="TransitGatewayAttachmentProps" id="cdk-extensions.ec2.TransitGatewayAttachmentProps"></a>

Configuration for TransitGatewayAttachment resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayAttachmentProps: ec2.TransitGatewayAttachmentProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The transit gateway for which the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | The VPC where the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.applianceModeSupport">applianceModeSupport</a></code> | <code>boolean</code> | Enables appliance mode on the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.dnsSupport">dnsSupport</a></code> | <code>boolean</code> | Enables DNS support for the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.ipv6Support">ipv6Support</a></code> | <code>boolean</code> | Enables DNS support for the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.name">name</a></code> | <code>string</code> | The name of the Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentProps.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | The subnets where the attachment should be created. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The transit gateway for which the attachment should be created.

> [[TransitGatewayVpcAttachment TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-transitgatewayid)]([TransitGatewayVpcAttachment TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-transitgatewayid))

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

The VPC where the attachment should be created.

> [[TransitGatewayVpcAttachment VpcId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-vpcid)]([TransitGatewayVpcAttachment VpcId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-vpcid))

---

##### `applianceModeSupport`<sup>Optional</sup> <a name="applianceModeSupport" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.applianceModeSupport"></a>

```typescript
public readonly applianceModeSupport: boolean;
```

- *Type:* boolean

Enables appliance mode on the attachment.

When appliance mode is enabled, all traffic flowing between attachments is
forwarded to an appliance in a shared VPC to be inspected and processed.

> [[Appliance in a shared services VPC](https://docs.aws.amazon.com/vpc/latest/tgw/transit-gateway-appliance-scenario.html)]([Appliance in a shared services VPC](https://docs.aws.amazon.com/vpc/latest/tgw/transit-gateway-appliance-scenario.html))

---

##### `dnsSupport`<sup>Optional</sup> <a name="dnsSupport" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.dnsSupport"></a>

```typescript
public readonly dnsSupport: boolean;
```

- *Type:* boolean

Enables DNS support for the attachment.

With DNS Support enabled public DNS names that resolve to a connected VPC
will be translated to private IP addresses when resolved in a connected VPC.

> [[TransitGatewayVpcAttachment DnsSupport](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-ec2-transitgatewayvpcattachment-options.html#cfn-ec2-transitgatewayvpcattachment-options-dnssupport)]([TransitGatewayVpcAttachment DnsSupport](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-ec2-transitgatewayvpcattachment-options.html#cfn-ec2-transitgatewayvpcattachment-options-dnssupport))

---

##### `ipv6Support`<sup>Optional</sup> <a name="ipv6Support" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.ipv6Support"></a>

```typescript
public readonly ipv6Support: boolean;
```

- *Type:* boolean

Enables DNS support for the attachment.

With DNS Support enabled public DNS names that resolve to a connected VPC
will be translated to private IP addresses when resolved in a connected VPC.

> [[IPv6 connectivity with TransitGateway](https://docs.aws.amazon.com/whitepapers/latest/ipv6-on-aws/amazon-vpc-connectivity-options-for-ipv6.html#ipv6-connectivity-with-transit-gateway)]([IPv6 connectivity with TransitGateway](https://docs.aws.amazon.com/whitepapers/latest/ipv6-on-aws/amazon-vpc-connectivity-options-for-ipv6.html#ipv6-connectivity-with-transit-gateway))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Transit Gateway Attachment.

Used to tag the attachment with a name that will be displayed in the AWS
EC2 console.

> [[TransitGatewayVpcAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-tags)]([TransitGatewayVpcAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-tags))

---

##### `subnets`<sup>Optional</sup> <a name="subnets" id="cdk-extensions.ec2.TransitGatewayAttachmentProps.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

The subnets where the attachment should be created.

Can select up to one subnet per Availability Zone.

> [[TransitGatewayVpcAttachment SubnetIds](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-subnetids)]([TransitGatewayVpcAttachment SubnetIds](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-subnetids))

---

### TransitGatewayAttachmentResourceProps <a name="TransitGatewayAttachmentResourceProps" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps"></a>

Configuration for TransitGatewayAttachmentResource resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayAttachmentResourceProps: ec2.TransitGatewayAttachmentResourceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The transit gateway for which the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.vpc">vpc</a></code> | <code>aws-cdk-lib.aws_ec2.IVpc</code> | The VPC where the attachment should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.applianceModeSupport">applianceModeSupport</a></code> | <code>boolean</code> | Enables appliance mode on the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.dnsSupport">dnsSupport</a></code> | <code>boolean</code> | Enables DNS support for the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.ipv6Support">ipv6Support</a></code> | <code>boolean</code> | Enables DNS support for the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.name">name</a></code> | <code>string</code> | The name of the Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | The subnets where the attachment should be created. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The transit gateway for which the attachment should be created.

> [[TransitGatewayVpcAttachment TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-transitgatewayid)]([TransitGatewayVpcAttachment TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-transitgatewayid))

---

##### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.vpc"></a>

```typescript
public readonly vpc: IVpc;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpc

The VPC where the attachment should be created.

> [[TransitGatewayVpcAttachment VpcId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-vpcid)]([TransitGatewayVpcAttachment VpcId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-vpcid))

---

##### `applianceModeSupport`<sup>Optional</sup> <a name="applianceModeSupport" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.applianceModeSupport"></a>

```typescript
public readonly applianceModeSupport: boolean;
```

- *Type:* boolean

Enables appliance mode on the attachment.

When appliance mode is enabled, all traffic flowing between attachments is
forwarded to an appliance in a shared VPC to be inspected and processed.

> [[Appliance in a shared services VPC](https://docs.aws.amazon.com/vpc/latest/tgw/transit-gateway-appliance-scenario.html)]([Appliance in a shared services VPC](https://docs.aws.amazon.com/vpc/latest/tgw/transit-gateway-appliance-scenario.html))

---

##### `dnsSupport`<sup>Optional</sup> <a name="dnsSupport" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.dnsSupport"></a>

```typescript
public readonly dnsSupport: boolean;
```

- *Type:* boolean

Enables DNS support for the attachment.

With DNS Support enabled public DNS names that resolve to a connected VPC
will be translated to private IP addresses when resolved in a connected VPC.

> [[TransitGatewayVpcAttachment DnsSupport](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-ec2-transitgatewayvpcattachment-options.html#cfn-ec2-transitgatewayvpcattachment-options-dnssupport)]([TransitGatewayVpcAttachment DnsSupport](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-ec2-transitgatewayvpcattachment-options.html#cfn-ec2-transitgatewayvpcattachment-options-dnssupport))

---

##### `ipv6Support`<sup>Optional</sup> <a name="ipv6Support" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.ipv6Support"></a>

```typescript
public readonly ipv6Support: boolean;
```

- *Type:* boolean

Enables DNS support for the attachment.

With DNS Support enabled public DNS names that resolve to a connected VPC
will be translated to private IP addresses when resolved in a connected VPC.

> [[IPv6 connectivity with TransitGateway](https://docs.aws.amazon.com/whitepapers/latest/ipv6-on-aws/amazon-vpc-connectivity-options-for-ipv6.html#ipv6-connectivity-with-transit-gateway)]([IPv6 connectivity with TransitGateway](https://docs.aws.amazon.com/whitepapers/latest/ipv6-on-aws/amazon-vpc-connectivity-options-for-ipv6.html#ipv6-connectivity-with-transit-gateway))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Transit Gateway Attachment.

Used to tag the attachment with a name that will be displayed in the AWS
EC2 console.

> [[TransitGatewayVpcAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-tags)]([TransitGatewayVpcAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-tags))

---

##### `subnets`<sup>Optional</sup> <a name="subnets" id="cdk-extensions.ec2.TransitGatewayAttachmentResourceProps.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

The subnets where the attachment should be created.

Can select up to one subnet per Availability Zone.

> [[TransitGatewayVpcAttachment SubnetIds](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-subnetids)]([TransitGatewayVpcAttachment SubnetIds](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayvpcattachment.html#cfn-ec2-transitgatewayvpcattachment-subnetids))

---

### TransitGatewayHubConfiguration <a name="TransitGatewayHubConfiguration" id="cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const transitGatewayHubConfiguration: ec2_patterns.TransitGatewayHubConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.allowExternal">allowExternal</a></code> | <code>boolean</code> | Allows Transit Gateway sharing with resources outside of the Transit Gateway owner account's AWS Organization. |
| <code><a href="#cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.autoAcceptSharedAttachments">autoAcceptSharedAttachments</a></code> | <code>boolean</code> | Enable or disable automatic acceptance of attachment requests. |
| <code><a href="#cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.autoDiscovery">autoDiscovery</a></code> | <code>boolean</code> | Enables auto-discovery of AWS accounts via CDK resources. |
| <code><a href="#cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.defaultRouteTableId">defaultRouteTableId</a></code> | <code>string</code> | The ID of the default Transit Gateway Route Table that got created for the Transit Gateway associated with this VPC. |
| <code><a href="#cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.principals">principals</a></code> | <code>cdk-extensions.ram.ISharedPrincipal[]</code> | A list of principals which allow other accounts access to the Transit Gateway. |

---

##### `allowExternal`<sup>Optional</sup> <a name="allowExternal" id="cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.allowExternal"></a>

```typescript
public readonly allowExternal: boolean;
```

- *Type:* boolean

Allows Transit Gateway sharing with resources outside of the Transit Gateway owner account's AWS Organization.

By default, resources cannot be shared with accounts outside of the organization.

---

##### `autoAcceptSharedAttachments`<sup>Optional</sup> <a name="autoAcceptSharedAttachments" id="cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.autoAcceptSharedAttachments"></a>

```typescript
public readonly autoAcceptSharedAttachments: boolean;
```

- *Type:* boolean

Enable or disable automatic acceptance of attachment requests.

When this is enabled, any transit gateway attachments created in other accounts where this
transit gateway has been shared will be automatically created without manual intervention
being needed in the account that did created the share.

---

##### `autoDiscovery`<sup>Optional</sup> <a name="autoDiscovery" id="cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.autoDiscovery"></a>

```typescript
public readonly autoDiscovery: boolean;
```

- *Type:* boolean

Enables auto-discovery of AWS accounts via CDK resources.

Account discovery uses stages
and stacks to find all accounts that the CDK has resources for.

Environment agnostic stages and stacks cannot be used for auto-discovery.

With auto-discovery enabled, the stack containing the Transit Gateway will need to be
updated before it will become available in newly added accounts. Because of this it is
inferior to using grouping principals such as organizations or organizational units.

If access to sharing via AWS OIrganizations is available, that should be preferred over
auto-discovery.

Transit gateway sharing will be anabled if either auto-discovery is enabled or principals
are specified.

---

##### `defaultRouteTableId`<sup>Optional</sup> <a name="defaultRouteTableId" id="cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.defaultRouteTableId"></a>

```typescript
public readonly defaultRouteTableId: string;
```

- *Type:* string

The ID of the default Transit Gateway Route Table that got created for the Transit Gateway associated with this VPC.

This is needed because the default route table is used for handling routing of all traffic within
the organization but not exposed directly via CloudFormation.

See [feature request](https://github.com/aws-cloudformation/cloudformation-coverage-roadmap/issues/180)
related to this in the AWS CloudFormation roadmap.

This is only needed if the VPC is being configured to act as a hub for network traffic. Won't be
available until after this stack has been deployed for the first time.

---

##### `principals`<sup>Optional</sup> <a name="principals" id="cdk-extensions.ec2_patterns.TransitGatewayHubConfiguration.property.principals"></a>

```typescript
public readonly principals: ISharedPrincipal[];
```

- *Type:* cdk-extensions.ram.ISharedPrincipal[]

A list of principals which allow other accounts access to the Transit Gateway.

With shared
access, other accounts can create Attachments to facilitate cross account networking.

Principals provided should not overlap with CDK resources if auto-discovery is enabled.

Transit gateway sharing will be anabled if either auto-discovery is enabled or principals
are specified.

---

### TransitGatewayNatProviderOptions <a name="TransitGatewayNatProviderOptions" id="cdk-extensions.ec2.TransitGatewayNatProviderOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayNatProviderOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayNatProviderOptions: ec2.TransitGatewayNatProviderOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProviderOptions.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | *No description.* |

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayNatProviderOptions.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

---

### TransitGatewayPeeringAttachmentImportAttributes <a name="TransitGatewayPeeringAttachmentImportAttributes" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes"></a>

Configuration options for importing a transit gateway peering attachment.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayPeeringAttachmentImportAttributes: ec2.TransitGatewayPeeringAttachmentImportAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.arn">arn</a></code> | <code>string</code> | The ARN of this Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.attachmentId">attachmentId</a></code> | <code>string</code> | The ID of this Transit Gateway Attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.creationTime">creationTime</a></code> | <code>string</code> | The time the transit gateway peering attachment was created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.state">state</a></code> | <code>string</code> | The state of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.status">status</a></code> | <code>string</code> | The status of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.statusCode">statusCode</a></code> | <code>string</code> | The status code for the current status of the attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.statusMessage">statusMessage</a></code> | <code>string</code> | The status message for the current status of the attachment. |

---

##### `arn`<sup>Optional</sup> <a name="arn" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.arn"></a>

```typescript
public readonly arn: string;
```

- *Type:* string

The ARN of this Transit Gateway Attachment.

---

##### `attachmentId`<sup>Optional</sup> <a name="attachmentId" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.attachmentId"></a>

```typescript
public readonly attachmentId: string;
```

- *Type:* string

The ID of this Transit Gateway Attachment.

---

##### `creationTime`<sup>Optional</sup> <a name="creationTime" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.creationTime"></a>

```typescript
public readonly creationTime: string;
```

- *Type:* string

The time the transit gateway peering attachment was created.

---

##### `state`<sup>Optional</sup> <a name="state" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.state"></a>

```typescript
public readonly state: string;
```

- *Type:* string

The state of the transit gateway peering attachment.

---

##### `status`<sup>Optional</sup> <a name="status" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

The status of the transit gateway peering attachment.

---

##### `statusCode`<sup>Optional</sup> <a name="statusCode" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.statusCode"></a>

```typescript
public readonly statusCode: string;
```

- *Type:* string

The status code for the current status of the attachment.

---

##### `statusMessage`<sup>Optional</sup> <a name="statusMessage" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentImportAttributes.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

The status message for the current status of the attachment.

---

### TransitGatewayPeeringAttachmentOptions <a name="TransitGatewayPeeringAttachmentOptions" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions"></a>

Optional configuration for TransitGatewayPeeringAttachment resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayPeeringAttachmentOptions: ec2.TransitGatewayPeeringAttachmentOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions.property.name">name</a></code> | <code>string</code> | The name of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions.property.peerAccountId">peerAccountId</a></code> | <code>string</code> | The account that contains the transit gateway being peered with. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions.property.peerRegion">peerRegion</a></code> | <code>string</code> | The region that contains the transit gateway being peered with. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the transit gateway peering attachment.

Used to tag the attachment with a name that will be displayed in the AWS
EC2 console.

> [[TransitGatewayPeeringAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-tags)]([TransitGatewayPeeringAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-tags))

---

##### `peerAccountId`<sup>Optional</sup> <a name="peerAccountId" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions.property.peerAccountId"></a>

```typescript
public readonly peerAccountId: string;
```

- *Type:* string

The account that contains the transit gateway being peered with.

> [[TransitGatewayPeeringAttachment PeerAccountId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peeraccountid)]([TransitGatewayPeeringAttachment PeerAccountId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peeraccountid))

---

##### `peerRegion`<sup>Optional</sup> <a name="peerRegion" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentOptions.property.peerRegion"></a>

```typescript
public readonly peerRegion: string;
```

- *Type:* string

The region that contains the transit gateway being peered with.

> [[TransitGatewayPeeringAttachment PeerRegion](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peerregion)]([TransitGatewayPeeringAttachment PeerRegion](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peerregion))

---

### TransitGatewayPeeringAttachmentProps <a name="TransitGatewayPeeringAttachmentProps" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps"></a>

Configuration for TransitGatewayPeeringAttachment resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayPeeringAttachmentProps: ec2.TransitGatewayPeeringAttachmentProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.name">name</a></code> | <code>string</code> | The name of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.peerAccountId">peerAccountId</a></code> | <code>string</code> | The account that contains the transit gateway being peered with. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.peerRegion">peerRegion</a></code> | <code>string</code> | The region that contains the transit gateway being peered with. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.localTransitGateway">localTransitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The local side of the transit gateway peering connection. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.peerTransitGateway">peerTransitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The remote transit gateway being peered with. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the transit gateway peering attachment.

Used to tag the attachment with a name that will be displayed in the AWS
EC2 console.

> [[TransitGatewayPeeringAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-tags)]([TransitGatewayPeeringAttachment Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-tags))

---

##### `peerAccountId`<sup>Optional</sup> <a name="peerAccountId" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.peerAccountId"></a>

```typescript
public readonly peerAccountId: string;
```

- *Type:* string

The account that contains the transit gateway being peered with.

> [[TransitGatewayPeeringAttachment PeerAccountId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peeraccountid)]([TransitGatewayPeeringAttachment PeerAccountId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peeraccountid))

---

##### `peerRegion`<sup>Optional</sup> <a name="peerRegion" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.peerRegion"></a>

```typescript
public readonly peerRegion: string;
```

- *Type:* string

The region that contains the transit gateway being peered with.

> [[TransitGatewayPeeringAttachment PeerRegion](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peerregion)]([TransitGatewayPeeringAttachment PeerRegion](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peerregion))

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `localTransitGateway`<sup>Required</sup> <a name="localTransitGateway" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.localTransitGateway"></a>

```typescript
public readonly localTransitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The local side of the transit gateway peering connection.

> [[TransitGatewayPeeringAttachment TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-transitgatewayid)]([TransitGatewayPeeringAttachment TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-transitgatewayid))

---

##### `peerTransitGateway`<sup>Required</sup> <a name="peerTransitGateway" id="cdk-extensions.ec2.TransitGatewayPeeringAttachmentProps.property.peerTransitGateway"></a>

```typescript
public readonly peerTransitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The remote transit gateway being peered with.

> [[TransitGatewayPeeringAttachment PeerTransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peertransitgatewayid)]([TransitGatewayPeeringAttachment PeerTransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewaypeeringattachment.html#cfn-ec2-transitgatewaypeeringattachment-peertransitgatewayid))

---

### TransitGatewayProps <a name="TransitGatewayProps" id="cdk-extensions.ec2.TransitGatewayProps"></a>

Configuration for TransitGateway resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayProps: ec2.TransitGatewayProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.amazonSideAsn">amazonSideAsn</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.autoAcceptSharedAttachments">autoAcceptSharedAttachments</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.cidrBlocks">cidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.defaultRouteTableAssociation">defaultRouteTableAssociation</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.defaultRouteTableId">defaultRouteTableId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.defaultRouteTablePropagation">defaultRouteTablePropagation</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.dnsSupport">dnsSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.multicastSupport">multicastSupport</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayProps.property.vpnEcmpSupport">vpnEcmpSupport</a></code> | <code>boolean</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.TransitGatewayProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.TransitGatewayProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.TransitGatewayProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.TransitGatewayProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `amazonSideAsn`<sup>Optional</sup> <a name="amazonSideAsn" id="cdk-extensions.ec2.TransitGatewayProps.property.amazonSideAsn"></a>

```typescript
public readonly amazonSideAsn: number;
```

- *Type:* number

---

##### `autoAcceptSharedAttachments`<sup>Optional</sup> <a name="autoAcceptSharedAttachments" id="cdk-extensions.ec2.TransitGatewayProps.property.autoAcceptSharedAttachments"></a>

```typescript
public readonly autoAcceptSharedAttachments: boolean;
```

- *Type:* boolean

---

##### `cidrBlocks`<sup>Optional</sup> <a name="cidrBlocks" id="cdk-extensions.ec2.TransitGatewayProps.property.cidrBlocks"></a>

```typescript
public readonly cidrBlocks: string[];
```

- *Type:* string[]

---

##### `defaultRouteTableAssociation`<sup>Optional</sup> <a name="defaultRouteTableAssociation" id="cdk-extensions.ec2.TransitGatewayProps.property.defaultRouteTableAssociation"></a>

```typescript
public readonly defaultRouteTableAssociation: boolean;
```

- *Type:* boolean

---

##### `defaultRouteTableId`<sup>Optional</sup> <a name="defaultRouteTableId" id="cdk-extensions.ec2.TransitGatewayProps.property.defaultRouteTableId"></a>

```typescript
public readonly defaultRouteTableId: string;
```

- *Type:* string

---

##### `defaultRouteTablePropagation`<sup>Optional</sup> <a name="defaultRouteTablePropagation" id="cdk-extensions.ec2.TransitGatewayProps.property.defaultRouteTablePropagation"></a>

```typescript
public readonly defaultRouteTablePropagation: boolean;
```

- *Type:* boolean

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.ec2.TransitGatewayProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `dnsSupport`<sup>Optional</sup> <a name="dnsSupport" id="cdk-extensions.ec2.TransitGatewayProps.property.dnsSupport"></a>

```typescript
public readonly dnsSupport: boolean;
```

- *Type:* boolean

---

##### `multicastSupport`<sup>Optional</sup> <a name="multicastSupport" id="cdk-extensions.ec2.TransitGatewayProps.property.multicastSupport"></a>

```typescript
public readonly multicastSupport: boolean;
```

- *Type:* boolean

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `vpnEcmpSupport`<sup>Optional</sup> <a name="vpnEcmpSupport" id="cdk-extensions.ec2.TransitGatewayProps.property.vpnEcmpSupport"></a>

```typescript
public readonly vpnEcmpSupport: boolean;
```

- *Type:* boolean

---

### TransitGatewayRegistrationProps <a name="TransitGatewayRegistrationProps" id="cdk-extensions.networkmanager.TransitGatewayRegistrationProps"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.networkmanager.TransitGatewayRegistrationProps.Initializer"></a>

```typescript
import { networkmanager } from 'cdk-extensions'

const transitGatewayRegistrationProps: networkmanager.TransitGatewayRegistrationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.globalNetwork">globalNetwork</a></code> | <code>cdk-extensions.networkmanager.IGlobalNetwork</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `globalNetwork`<sup>Required</sup> <a name="globalNetwork" id="cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.globalNetwork"></a>

```typescript
public readonly globalNetwork: IGlobalNetwork;
```

- *Type:* cdk-extensions.networkmanager.IGlobalNetwork

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.networkmanager.TransitGatewayRegistrationProps.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

---

### TransitGatewayRouteOptions <a name="TransitGatewayRouteOptions" id="cdk-extensions.ec2.TransitGatewayRouteOptions"></a>

Options for adding a route to a transit gateway route table.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayRouteOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayRouteOptions: ec2.TransitGatewayRouteOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteOptions.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteOptions.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteOptions.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteOptions.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteOptions.property.cidr">cidr</a></code> | <code>string</code> | The CIDR range to match for the route. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteOptions.property.attachment">attachment</a></code> | <code>cdk-extensions.ec2.ITransitGatewayAttachment</code> | The transit gateway attachment where matched traffic should be routed. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteOptions.property.blackhole">blackhole</a></code> | <code>boolean</code> | Whether the traffic should be black holed (discarded) rather than being routed to an attachment. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.TransitGatewayRouteOptions.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.TransitGatewayRouteOptions.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.TransitGatewayRouteOptions.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.TransitGatewayRouteOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.TransitGatewayRouteOptions.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* string

The CIDR range to match for the route.

---

##### `attachment`<sup>Optional</sup> <a name="attachment" id="cdk-extensions.ec2.TransitGatewayRouteOptions.property.attachment"></a>

```typescript
public readonly attachment: ITransitGatewayAttachment;
```

- *Type:* cdk-extensions.ec2.ITransitGatewayAttachment

The transit gateway attachment where matched traffic should be routed.

---

##### `blackhole`<sup>Optional</sup> <a name="blackhole" id="cdk-extensions.ec2.TransitGatewayRouteOptions.property.blackhole"></a>

```typescript
public readonly blackhole: boolean;
```

- *Type:* boolean

Whether the traffic should be black holed (discarded) rather than being routed to an attachment.

---

### TransitGatewayRouteProps <a name="TransitGatewayRouteProps" id="cdk-extensions.ec2.TransitGatewayRouteProps"></a>

Configuration for TransitGatewayRoute resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayRouteProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayRouteProps: ec2.TransitGatewayRouteProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteProps.property.cidr">cidr</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteProps.property.routeTable">routeTable</a></code> | <code>cdk-extensions.ec2.ITransitGatewayRouteTable</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteProps.property.attachment">attachment</a></code> | <code>cdk-extensions.ec2.ITransitGatewayAttachment</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteProps.property.blackhole">blackhole</a></code> | <code>boolean</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.TransitGatewayRouteProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.TransitGatewayRouteProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.TransitGatewayRouteProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.TransitGatewayRouteProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.TransitGatewayRouteProps.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* string

---

##### `routeTable`<sup>Required</sup> <a name="routeTable" id="cdk-extensions.ec2.TransitGatewayRouteProps.property.routeTable"></a>

```typescript
public readonly routeTable: ITransitGatewayRouteTable;
```

- *Type:* cdk-extensions.ec2.ITransitGatewayRouteTable

---

##### `attachment`<sup>Optional</sup> <a name="attachment" id="cdk-extensions.ec2.TransitGatewayRouteProps.property.attachment"></a>

```typescript
public readonly attachment: ITransitGatewayAttachment;
```

- *Type:* cdk-extensions.ec2.ITransitGatewayAttachment

---

##### `blackhole`<sup>Optional</sup> <a name="blackhole" id="cdk-extensions.ec2.TransitGatewayRouteProps.property.blackhole"></a>

```typescript
public readonly blackhole: boolean;
```

- *Type:* boolean

---

### TransitGatewayRouteTableOptions <a name="TransitGatewayRouteTableOptions" id="cdk-extensions.ec2.TransitGatewayRouteTableOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayRouteTableOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayRouteTableOptions: ec2.TransitGatewayRouteTableOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTableOptions.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayRouteTableOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

### TransitGatewayRouteTableProps <a name="TransitGatewayRouteTableProps" id="cdk-extensions.ec2.TransitGatewayRouteTableProps"></a>

Configuration for TransitGatewayRouteTable resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TransitGatewayRouteTableProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const transitGatewayRouteTableProps: ec2.TransitGatewayRouteTableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTableProps.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The transit gateway for which the route table should be created. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayRouteTableProps.property.name">name</a></code> | <code>string</code> | The name of the transit gateway route table. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.TransitGatewayRouteTableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.TransitGatewayRouteTableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.TransitGatewayRouteTableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.TransitGatewayRouteTableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayRouteTableProps.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The transit gateway for which the route table should be created.

> [[TransitGatewayRouteTable TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html#cfn-ec2-transitgatewayroutetable-transitgatewayid)]([TransitGatewayRouteTable TransitGatewayId](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html#cfn-ec2-transitgatewayroutetable-transitgatewayid))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.TransitGatewayRouteTableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the transit gateway route table.

Used to tag the route table with a name that will be displayed in the AWS
VPC console.

> [[TransitGatewayRouteTable Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html#cfn-ec2-transitgatewayroutetable-tags)]([TransitGatewayRouteTable Tags](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ec2-transitgatewayroutetable.html#cfn-ec2-transitgatewayroutetable-tags))

---

### TransitGatewaySpokeConfiguration <a name="TransitGatewaySpokeConfiguration" id="cdk-extensions.ec2_patterns.TransitGatewaySpokeConfiguration"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2_patterns.TransitGatewaySpokeConfiguration.Initializer"></a>

```typescript
import { ec2_patterns } from 'cdk-extensions'

const transitGatewaySpokeConfiguration: ec2_patterns.TransitGatewaySpokeConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2_patterns.TransitGatewaySpokeConfiguration.property.transitGatewayId">transitGatewayId</a></code> | <code>string</code> | The ID of a Transit Gateway. |

---

##### `transitGatewayId`<sup>Required</sup> <a name="transitGatewayId" id="cdk-extensions.ec2_patterns.TransitGatewaySpokeConfiguration.property.transitGatewayId"></a>

```typescript
public readonly transitGatewayId: string;
```

- *Type:* string

The ID of a Transit Gateway.

This Transit Gateway may have been created by another VPC in the
same account or shared by a VPC in another account. If this is passed then a Transit Gateway
Attachment will be created for the specified Transit Gateway and a new one will not be created
even if {@link TransitGatewayHubConfiguration.principal | principals} are provided.

---

### TriggerOptions <a name="TriggerOptions" id="cdk-extensions.glue.TriggerOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.glue.TriggerOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const triggerOptions: glue.TriggerOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.type">type</a></code> | <code>cdk-extensions.glue.TriggerType</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.actions">actions</a></code> | <code>cdk-extensions.glue.ITriggerAction[]</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.predicateConditions">predicateConditions</a></code> | <code>cdk-extensions.glue.ITriggerPredicate[]</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.predicateOperator">predicateOperator</a></code> | <code>cdk-extensions.glue.PredicateOperator</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.schedule">schedule</a></code> | <code>aws-cdk-lib.aws_events.Schedule</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerOptions.property.startOnCreation">startOnCreation</a></code> | <code>boolean</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.TriggerOptions.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.TriggerOptions.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.TriggerOptions.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.TriggerOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk-extensions.glue.TriggerOptions.property.type"></a>

```typescript
public readonly type: TriggerType;
```

- *Type:* cdk-extensions.glue.TriggerType

---

##### `actions`<sup>Optional</sup> <a name="actions" id="cdk-extensions.glue.TriggerOptions.property.actions"></a>

```typescript
public readonly actions: ITriggerAction[];
```

- *Type:* cdk-extensions.glue.ITriggerAction[]

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.TriggerOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.TriggerOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `predicateConditions`<sup>Optional</sup> <a name="predicateConditions" id="cdk-extensions.glue.TriggerOptions.property.predicateConditions"></a>

```typescript
public readonly predicateConditions: ITriggerPredicate[];
```

- *Type:* cdk-extensions.glue.ITriggerPredicate[]

---

##### `predicateOperator`<sup>Optional</sup> <a name="predicateOperator" id="cdk-extensions.glue.TriggerOptions.property.predicateOperator"></a>

```typescript
public readonly predicateOperator: PredicateOperator;
```

- *Type:* cdk-extensions.glue.PredicateOperator

---

##### `schedule`<sup>Optional</sup> <a name="schedule" id="cdk-extensions.glue.TriggerOptions.property.schedule"></a>

```typescript
public readonly schedule: Schedule;
```

- *Type:* aws-cdk-lib.aws_events.Schedule

---

##### `startOnCreation`<sup>Optional</sup> <a name="startOnCreation" id="cdk-extensions.glue.TriggerOptions.property.startOnCreation"></a>

```typescript
public readonly startOnCreation: boolean;
```

- *Type:* boolean

---

### TriggerProps <a name="TriggerProps" id="cdk-extensions.glue.TriggerProps"></a>

Configuration for the GlueTrigger resource.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.TriggerProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const triggerProps: glue.TriggerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.type">type</a></code> | <code>cdk-extensions.glue.TriggerType</code> | The type of trigger that this is. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.actions">actions</a></code> | <code>cdk-extensions.glue.ITriggerAction[]</code> | A list of actions initiated by this trigger. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.description">description</a></code> | <code>string</code> | A description for the trigger. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.name">name</a></code> | <code>string</code> | A name for the trigger. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.predicateConditions">predicateConditions</a></code> | <code>cdk-extensions.glue.ITriggerPredicate[]</code> | A list of the conditions that determine when the trigger will fire. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.predicateOperator">predicateOperator</a></code> | <code>cdk-extensions.glue.PredicateOperator</code> | Operator for chaining predicate conditions if multiple are given. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.schedule">schedule</a></code> | <code>aws-cdk-lib.aws_events.Schedule</code> | A cron expression used to specify the schedule. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.startOnCreation">startOnCreation</a></code> | <code>boolean</code> | Set to true to start SCHEDULED and CONDITIONAL triggers when created. |
| <code><a href="#cdk-extensions.glue.TriggerProps.property.workflow">workflow</a></code> | <code>cdk-extensions.glue.Workflow</code> | The name of the workflow associated with the trigger. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.TriggerProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.TriggerProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.TriggerProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.TriggerProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk-extensions.glue.TriggerProps.property.type"></a>

```typescript
public readonly type: TriggerType;
```

- *Type:* cdk-extensions.glue.TriggerType

The type of trigger that this is.

> [[Trigger Type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-type)]([Trigger Type](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-type))

---

##### `actions`<sup>Optional</sup> <a name="actions" id="cdk-extensions.glue.TriggerProps.property.actions"></a>

```typescript
public readonly actions: ITriggerAction[];
```

- *Type:* cdk-extensions.glue.ITriggerAction[]

A list of actions initiated by this trigger.

> [[Trigger Actions](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-actions)]([Trigger Actions](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-actions))

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.TriggerProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A description for the trigger.

> [[Trigger Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-description)]([Trigger Description](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-description))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.TriggerProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A name for the trigger.

> [[Trigger Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-name)]([Trigger Name](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-name))

---

##### `predicateConditions`<sup>Optional</sup> <a name="predicateConditions" id="cdk-extensions.glue.TriggerProps.property.predicateConditions"></a>

```typescript
public readonly predicateConditions: ITriggerPredicate[];
```

- *Type:* cdk-extensions.glue.ITriggerPredicate[]

A list of the conditions that determine when the trigger will fire.

> [[Trigger Predicate](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-predicate.html)]([Trigger Predicate](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-predicate.html))

---

##### `predicateOperator`<sup>Optional</sup> <a name="predicateOperator" id="cdk-extensions.glue.TriggerProps.property.predicateOperator"></a>

```typescript
public readonly predicateOperator: PredicateOperator;
```

- *Type:* cdk-extensions.glue.PredicateOperator

Operator for chaining predicate conditions if multiple are given.

> [[Trigger Predicate.Logical](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-predicate.html#cfn-glue-trigger-predicate-logical)]([Trigger Predicate.Logical](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-predicate.html#cfn-glue-trigger-predicate-logical))

---

##### `schedule`<sup>Optional</sup> <a name="schedule" id="cdk-extensions.glue.TriggerProps.property.schedule"></a>

```typescript
public readonly schedule: Schedule;
```

- *Type:* aws-cdk-lib.aws_events.Schedule

A cron expression used to specify the schedule.

> [[Time-Based Schedules for Jobs and Crawlers](https://docs.aws.amazon.com/glue/latest/dg/monitor-data-warehouse-schedule.html)]([Time-Based Schedules for Jobs and Crawlers](https://docs.aws.amazon.com/glue/latest/dg/monitor-data-warehouse-schedule.html))

---

##### `startOnCreation`<sup>Optional</sup> <a name="startOnCreation" id="cdk-extensions.glue.TriggerProps.property.startOnCreation"></a>

```typescript
public readonly startOnCreation: boolean;
```

- *Type:* boolean

Set to true to start SCHEDULED and CONDITIONAL triggers when created.

True
is not supported for ON_DEMAND triggers.

> [[Trigger StartOnCreation](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-startoncreation)]([Trigger StartOnCreation](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-startoncreation))

---

##### `workflow`<sup>Optional</sup> <a name="workflow" id="cdk-extensions.glue.TriggerProps.property.workflow"></a>

```typescript
public readonly workflow: Workflow;
```

- *Type:* cdk-extensions.glue.Workflow

The name of the workflow associated with the trigger.

> [[Trigger WorkflowName](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-workflowname)]([Trigger WorkflowName](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-trigger.html#cfn-glue-trigger-workflowname))

---

### TunnelOptions <a name="TunnelOptions" id="cdk-extensions.ec2.TunnelOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.TunnelOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const tunnelOptions: ec2.TunnelOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TunnelOptions.property.insideCidr">insideCidr</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TunnelOptions.property.preSharedKey">preSharedKey</a></code> | <code>aws-cdk-lib.SecretValue</code> | *No description.* |

---

##### `insideCidr`<sup>Optional</sup> <a name="insideCidr" id="cdk-extensions.ec2.TunnelOptions.property.insideCidr"></a>

```typescript
public readonly insideCidr: string;
```

- *Type:* string

---

##### `preSharedKey`<sup>Optional</sup> <a name="preSharedKey" id="cdk-extensions.ec2.TunnelOptions.property.preSharedKey"></a>

```typescript
public readonly preSharedKey: SecretValue;
```

- *Type:* aws-cdk-lib.SecretValue

---

### TxtRegistryOptions <a name="TxtRegistryOptions" id="cdk-extensions.k8s_aws.TxtRegistryOptions"></a>

Configuration options for setting up a TXT registry for ExternalDNS.

#### Initializer <a name="Initializer" id="cdk-extensions.k8s_aws.TxtRegistryOptions.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

const txtRegistryOptions: k8s_aws.TxtRegistryOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistryOptions.property.ownerId">ownerId</a></code> | <code>string</code> | A unique identifier that is used to establish ownership of managed DNS records. |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistryOptions.property.prefix">prefix</a></code> | <code>string</code> | A prefix to be added top TXT ownership records. |

---

##### `ownerId`<sup>Optional</sup> <a name="ownerId" id="cdk-extensions.k8s_aws.TxtRegistryOptions.property.ownerId"></a>

```typescript
public readonly ownerId: string;
```

- *Type:* string
- *Default:* Unique address of the owning CDK node.

A unique identifier that is used to establish ownership of managed DNS records.

Prevents conflicts in the event of multiple clusters running external-dns.

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk-extensions.k8s_aws.TxtRegistryOptions.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string
- *Default:* 'edns.''

A prefix to be added top TXT ownership records.

By default, the ownership record is a TXT record with the same name as the
managed record that was created. This causes issues as some record types
(CNAME's) do not allow duplicate records of a different type.

This prefix is used to prevent such name collissions while still allowing
DNS ownership records to be created.

---

### VpcAttachmentOptions <a name="VpcAttachmentOptions" id="cdk-extensions.ec2.VpcAttachmentOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.VpcAttachmentOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const vpcAttachmentOptions: ec2.VpcAttachmentOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpcAttachmentOptions.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpcAttachmentOptions.property.subnets">subnets</a></code> | <code>aws-cdk-lib.aws_ec2.SubnetSelection</code> | *No description.* |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.ec2.VpcAttachmentOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `subnets`<sup>Optional</sup> <a name="subnets" id="cdk-extensions.ec2.VpcAttachmentOptions.property.subnets"></a>

```typescript
public readonly subnets: SubnetSelection;
```

- *Type:* aws-cdk-lib.aws_ec2.SubnetSelection

---

### VpnAttachmentOptions <a name="VpnAttachmentOptions" id="cdk-extensions.ec2.VpnAttachmentOptions"></a>

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.VpnAttachmentOptions.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const vpnAttachmentOptions: ec2.VpnAttachmentOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnAttachmentOptions.property.remoteEndpoint">remoteEndpoint</a></code> | <code>cdk-extensions.ec2.IRemoteVpnEndpoint</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnAttachmentOptions.property.connectionType">connectionType</a></code> | <code>cdk-extensions.ec2.VpnConnectionType</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnAttachmentOptions.property.staticRoutesOnly">staticRoutesOnly</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnAttachmentOptions.property.tunnelConfigurations">tunnelConfigurations</a></code> | <code>cdk-extensions.ec2.TunnelOptions[]</code> | *No description.* |

---

##### `remoteEndpoint`<sup>Required</sup> <a name="remoteEndpoint" id="cdk-extensions.ec2.VpnAttachmentOptions.property.remoteEndpoint"></a>

```typescript
public readonly remoteEndpoint: IRemoteVpnEndpoint;
```

- *Type:* cdk-extensions.ec2.IRemoteVpnEndpoint

---

##### `connectionType`<sup>Optional</sup> <a name="connectionType" id="cdk-extensions.ec2.VpnAttachmentOptions.property.connectionType"></a>

```typescript
public readonly connectionType: VpnConnectionType;
```

- *Type:* cdk-extensions.ec2.VpnConnectionType

---

##### `staticRoutesOnly`<sup>Optional</sup> <a name="staticRoutesOnly" id="cdk-extensions.ec2.VpnAttachmentOptions.property.staticRoutesOnly"></a>

```typescript
public readonly staticRoutesOnly: boolean;
```

- *Type:* boolean

---

##### `tunnelConfigurations`<sup>Optional</sup> <a name="tunnelConfigurations" id="cdk-extensions.ec2.VpnAttachmentOptions.property.tunnelConfigurations"></a>

```typescript
public readonly tunnelConfigurations: TunnelOptions[];
```

- *Type:* cdk-extensions.ec2.TunnelOptions[]

---

### VpnConnectionProps <a name="VpnConnectionProps" id="cdk-extensions.ec2.VpnConnectionProps"></a>

Configuration for the VpnConnection resource.

#### Initializer <a name="Initializer" id="cdk-extensions.ec2.VpnConnectionProps.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

const vpnConnectionProps: ec2.VpnConnectionProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.localEndpoint">localEndpoint</a></code> | <code>cdk-extensions.ec2.ILocalVpnEndpoint</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.remoteEndpoint">remoteEndpoint</a></code> | <code>cdk-extensions.ec2.IRemoteVpnEndpoint</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.connectionType">connectionType</a></code> | <code>cdk-extensions.ec2.VpnConnectionType</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.staticRoutesOnly">staticRoutesOnly</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnectionProps.property.tunnelConfigurations">tunnelConfigurations</a></code> | <code>cdk-extensions.ec2.TunnelOptions[]</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.ec2.VpnConnectionProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.ec2.VpnConnectionProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.ec2.VpnConnectionProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.ec2.VpnConnectionProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `localEndpoint`<sup>Required</sup> <a name="localEndpoint" id="cdk-extensions.ec2.VpnConnectionProps.property.localEndpoint"></a>

```typescript
public readonly localEndpoint: ILocalVpnEndpoint;
```

- *Type:* cdk-extensions.ec2.ILocalVpnEndpoint

---

##### `remoteEndpoint`<sup>Required</sup> <a name="remoteEndpoint" id="cdk-extensions.ec2.VpnConnectionProps.property.remoteEndpoint"></a>

```typescript
public readonly remoteEndpoint: IRemoteVpnEndpoint;
```

- *Type:* cdk-extensions.ec2.IRemoteVpnEndpoint

---

##### `connectionType`<sup>Optional</sup> <a name="connectionType" id="cdk-extensions.ec2.VpnConnectionProps.property.connectionType"></a>

```typescript
public readonly connectionType: VpnConnectionType;
```

- *Type:* cdk-extensions.ec2.VpnConnectionType

---

##### `staticRoutesOnly`<sup>Optional</sup> <a name="staticRoutesOnly" id="cdk-extensions.ec2.VpnConnectionProps.property.staticRoutesOnly"></a>

```typescript
public readonly staticRoutesOnly: boolean;
```

- *Type:* boolean

---

##### `tunnelConfigurations`<sup>Optional</sup> <a name="tunnelConfigurations" id="cdk-extensions.ec2.VpnConnectionProps.property.tunnelConfigurations"></a>

```typescript
public readonly tunnelConfigurations: TunnelOptions[];
```

- *Type:* cdk-extensions.ec2.TunnelOptions[]

---

### WafLogsBucketProps <a name="WafLogsBucketProps" id="cdk-extensions.s3_buckets.WafLogsBucketProps"></a>

Configuration for objects bucket.

#### Initializer <a name="Initializer" id="cdk-extensions.s3_buckets.WafLogsBucketProps.Initializer"></a>

```typescript
import { s3_buckets } from 'cdk-extensions'

const wafLogsBucketProps: s3_buckets.WafLogsBucketProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.bucketName">bucketName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.s3_buckets.WafLogsBucketProps.property.tableName">tableName</a></code> | <code>string</code> | *No description.* |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucketName`<sup>Optional</sup> <a name="bucketName" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

---

##### `database`<sup>Optional</sup> <a name="database" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

---

##### `tableName`<sup>Optional</sup> <a name="tableName" id="cdk-extensions.s3_buckets.WafLogsBucketProps.property.tableName"></a>

```typescript
public readonly tableName: string;
```

- *Type:* string

---

### WafLogsTableProps <a name="WafLogsTableProps" id="cdk-extensions.glue_tables.WafLogsTableProps"></a>

Configuration for S3AccessLogsTable.

#### Initializer <a name="Initializer" id="cdk-extensions.glue_tables.WafLogsTableProps.Initializer"></a>

```typescript
import { glue_tables } from 'cdk-extensions'

const wafLogsTableProps: glue_tables.WafLogsTableProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | A bucket where logs will be stored. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.createQueries">createQueries</a></code> | <code>boolean</code> | Boolean indicating whether to create default Athena queries for the WAF Logs. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.friendlyQueryNames">friendlyQueryNames</a></code> | <code>boolean</code> | Boolean for adding "friendly names" for the created Athena queries. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.name">name</a></code> | <code>string</code> | Name for WAF Logs Table. |
| <code><a href="#cdk-extensions.glue_tables.WafLogsTableProps.property.s3Prefix">s3Prefix</a></code> | <code>string</code> | Set a custom prefix for the S3 Bucket. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue_tables.WafLogsTableProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue_tables.WafLogsTableProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue_tables.WafLogsTableProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue_tables.WafLogsTableProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue_tables.WafLogsTableProps.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

A bucket where logs will be stored.

> [[AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html)]([AWS S3 iBucket](https://docs.aws.amazon.com/cdk/api/v2/docs/aws-cdk-lib.aws_s3.IBucket.html))

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.glue_tables.WafLogsTableProps.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

A cdk-extensions/glue {@link aws-glue!Database } object that the table should be created in.

> [[AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html)]([AWS::Glue::Database](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-glue-database.html))

---

##### `createQueries`<sup>Optional</sup> <a name="createQueries" id="cdk-extensions.glue_tables.WafLogsTableProps.property.createQueries"></a>

```typescript
public readonly createQueries: boolean;
```

- *Type:* boolean

Boolean indicating whether to create default Athena queries for the WAF Logs.

> [[`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html)]([`CfnNamedQueries`](https://docs.aws.amazon.com/cdk/api/v1/python/aws_cdk.aws_athena/CfnNamedQuery.html))

---

##### `friendlyQueryNames`<sup>Optional</sup> <a name="friendlyQueryNames" id="cdk-extensions.glue_tables.WafLogsTableProps.property.friendlyQueryNames"></a>

```typescript
public readonly friendlyQueryNames: boolean;
```

- *Type:* boolean

Boolean for adding "friendly names" for the created Athena queries.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue_tables.WafLogsTableProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name for WAF Logs Table.

---

##### `s3Prefix`<sup>Optional</sup> <a name="s3Prefix" id="cdk-extensions.glue_tables.WafLogsTableProps.property.s3Prefix"></a>

```typescript
public readonly s3Prefix: string;
```

- *Type:* string

Set a custom prefix for the S3 Bucket.

---

### WeekdayRange <a name="WeekdayRange" id="cdk-extensions.aps.WeekdayRange"></a>

A day of the week, where the week begins on Sunday and ends on Saturday.

For convenience, ranges are also accepted by specifying `end` and are
inclusive on both ends.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.WeekdayRange.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const weekdayRange: aps.WeekdayRange = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.WeekdayRange.property.start">start</a></code> | <code>cdk-extensions.aps.Weekday</code> | The day of the week where the range should start. |
| <code><a href="#cdk-extensions.aps.WeekdayRange.property.end">end</a></code> | <code>cdk-extensions.aps.Weekday</code> | The day of the week where the range should end. |

---

##### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.WeekdayRange.property.start"></a>

```typescript
public readonly start: Weekday;
```

- *Type:* cdk-extensions.aps.Weekday

The day of the week where the range should start.

---

##### `end`<sup>Optional</sup> <a name="end" id="cdk-extensions.aps.WeekdayRange.property.end"></a>

```typescript
public readonly end: Weekday;
```

- *Type:* cdk-extensions.aps.Weekday

The day of the week where the range should end.

If not specified, the range will end at the end of the day specified by
`start`.

---

### WorkflowActionOptions <a name="WorkflowActionOptions" id="cdk-extensions.glue.WorkflowActionOptions"></a>

Configuration for the Workflow Action resource.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.WorkflowActionOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const workflowActionOptions: glue.WorkflowActionOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowActionOptions.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowActionOptions.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.WorkflowActionOptions.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.WorkflowActionOptions.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowActionOptions.property.arguments">arguments</a></code> | <code>{[ key: string ]: string}</code> | The arguments to use when the associated trigger fires. |
| <code><a href="#cdk-extensions.glue.WorkflowActionOptions.property.notifyDelayAfter">notifyDelayAfter</a></code> | <code>aws-cdk-lib.Duration</code> | After a job run starts, the number of minutes to wait before sending a job run delay notification. |
| <code><a href="#cdk-extensions.glue.WorkflowActionOptions.property.securityConfiguration">securityConfiguration</a></code> | <code>string</code> | The name of the SecurityConfiguration structure to be used with this action. |
| <code><a href="#cdk-extensions.glue.WorkflowActionOptions.property.timeout">timeout</a></code> | <code>aws-cdk-lib.Duration</code> | The `JobRun` timeout in minutes. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.WorkflowActionOptions.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.WorkflowActionOptions.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.WorkflowActionOptions.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.WorkflowActionOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `arguments`<sup>Optional</sup> <a name="arguments" id="cdk-extensions.glue.WorkflowActionOptions.property.arguments"></a>

```typescript
public readonly arguments: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The arguments to use when the associated trigger fires.

Jobs run via the associated trigger will have their default arguments
replaced with the arguments specified.

You can specify arguments here that your own job-execution script
consumes, in addition to arguments that AWS Glue itself consumes.

> [[Trigger Actions.Arguments](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-arguments)]([Trigger Actions.Arguments](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-arguments))

---

##### `notifyDelayAfter`<sup>Optional</sup> <a name="notifyDelayAfter" id="cdk-extensions.glue.WorkflowActionOptions.property.notifyDelayAfter"></a>

```typescript
public readonly notifyDelayAfter: Duration;
```

- *Type:* aws-cdk-lib.Duration

After a job run starts, the number of minutes to wait before sending a job run delay notification.

> [[Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter)]([Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter))

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.WorkflowActionOptions.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: string;
```

- *Type:* string

The name of the SecurityConfiguration structure to be used with this action.

> [[Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration)]([Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration))

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="cdk-extensions.glue.WorkflowActionOptions.property.timeout"></a>

```typescript
public readonly timeout: Duration;
```

- *Type:* aws-cdk-lib.Duration

The `JobRun` timeout in minutes.

This is the maximum time that a job run
can consume resources before it is terminated and enters TIMEOUT status.
The default is 48 hours. This overrides the timeout value set in the
parent job.

> [[Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout)]([Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout))

---

### WorkflowCrawlerActionOptions <a name="WorkflowCrawlerActionOptions" id="cdk-extensions.glue.WorkflowCrawlerActionOptions"></a>

Configuration options for the WorkflowCrawlerAction class.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const workflowCrawlerActionOptions: glue.WorkflowCrawlerActionOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerActionOptions.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerActionOptions.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerActionOptions.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerActionOptions.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerActionOptions.property.arguments">arguments</a></code> | <code>{[ key: string ]: string}</code> | The arguments to use when the associated trigger fires. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerActionOptions.property.notifyDelayAfter">notifyDelayAfter</a></code> | <code>aws-cdk-lib.Duration</code> | After a job run starts, the number of minutes to wait before sending a job run delay notification. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerActionOptions.property.securityConfiguration">securityConfiguration</a></code> | <code>string</code> | The name of the SecurityConfiguration structure to be used with this action. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerActionOptions.property.timeout">timeout</a></code> | <code>aws-cdk-lib.Duration</code> | The `JobRun` timeout in minutes. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `arguments`<sup>Optional</sup> <a name="arguments" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.property.arguments"></a>

```typescript
public readonly arguments: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The arguments to use when the associated trigger fires.

Jobs run via the associated trigger will have their default arguments
replaced with the arguments specified.

You can specify arguments here that your own job-execution script
consumes, in addition to arguments that AWS Glue itself consumes.

> [[Trigger Actions.Arguments](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-arguments)]([Trigger Actions.Arguments](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-arguments))

---

##### `notifyDelayAfter`<sup>Optional</sup> <a name="notifyDelayAfter" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.property.notifyDelayAfter"></a>

```typescript
public readonly notifyDelayAfter: Duration;
```

- *Type:* aws-cdk-lib.Duration

After a job run starts, the number of minutes to wait before sending a job run delay notification.

> [[Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter)]([Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter))

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: string;
```

- *Type:* string

The name of the SecurityConfiguration structure to be used with this action.

> [[Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration)]([Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration))

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="cdk-extensions.glue.WorkflowCrawlerActionOptions.property.timeout"></a>

```typescript
public readonly timeout: Duration;
```

- *Type:* aws-cdk-lib.Duration

The `JobRun` timeout in minutes.

This is the maximum time that a job run
can consume resources before it is terminated and enters TIMEOUT status.
The default is 48 hours. This overrides the timeout value set in the
parent job.

> [[Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout)]([Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout))

---

### WorkflowCrawlerPredicateOptions <a name="WorkflowCrawlerPredicateOptions" id="cdk-extensions.glue.WorkflowCrawlerPredicateOptions"></a>

Configuration options that specify the state a crawler must meet in order to satisfy the conditions of the predicate.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.WorkflowCrawlerPredicateOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const workflowCrawlerPredicateOptions: glue.WorkflowCrawlerPredicateOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.logicalOperator">logicalOperator</a></code> | <code>cdk-extensions.glue.PredicateLogicalOperator</code> | The logical operator which should be applied in determining whether a crawler meets the requested conditions. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.state">state</a></code> | <code>cdk-extensions.glue.CrawlerState</code> | The state that the crawler must be in in order to meet the criteria to trigger the next stage of the workflow. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `logicalOperator`<sup>Optional</sup> <a name="logicalOperator" id="cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.logicalOperator"></a>

```typescript
public readonly logicalOperator: PredicateLogicalOperator;
```

- *Type:* cdk-extensions.glue.PredicateLogicalOperator

The logical operator which should be applied in determining whether a crawler meets the requested conditions.

At the moment, the only supported operator is `EQUALS`.

> [[Trigger Predicate.Conditions.LogicalOperator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-logicaloperator)]([Trigger Predicate.Conditions.LogicalOperator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-logicaloperator))

---

##### `state`<sup>Optional</sup> <a name="state" id="cdk-extensions.glue.WorkflowCrawlerPredicateOptions.property.state"></a>

```typescript
public readonly state: CrawlerState;
```

- *Type:* cdk-extensions.glue.CrawlerState

The state that the crawler must be in in order to meet the criteria to trigger the next stage of the workflow.

> [[Trigger Predicate.Conditions.CrawlState](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-crawlstate)]([Trigger Predicate.Conditions.CrawlState](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-crawlstate))

---

### WorkflowJobActionOptions <a name="WorkflowJobActionOptions" id="cdk-extensions.glue.WorkflowJobActionOptions"></a>

Configuration options for the WorkflowJobAction class.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.WorkflowJobActionOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const workflowJobActionOptions: glue.WorkflowJobActionOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.arguments">arguments</a></code> | <code>{[ key: string ]: string}</code> | The arguments to use when the associated trigger fires. |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.notifyDelayAfter">notifyDelayAfter</a></code> | <code>aws-cdk-lib.Duration</code> | After a job run starts, the number of minutes to wait before sending a job run delay notification. |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.securityConfiguration">securityConfiguration</a></code> | <code>string</code> | The name of the SecurityConfiguration structure to be used with this action. |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.timeout">timeout</a></code> | <code>aws-cdk-lib.Duration</code> | The `JobRun` timeout in minutes. |
| <code><a href="#cdk-extensions.glue.WorkflowJobActionOptions.property.bookmarkConfiguration">bookmarkConfiguration</a></code> | <code>cdk-extensions.glue.BookmarkConfiguration</code> | The bookmark configuration override to use for the Glue job that is being triggered. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.WorkflowJobActionOptions.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.WorkflowJobActionOptions.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.WorkflowJobActionOptions.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.WorkflowJobActionOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `arguments`<sup>Optional</sup> <a name="arguments" id="cdk-extensions.glue.WorkflowJobActionOptions.property.arguments"></a>

```typescript
public readonly arguments: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The arguments to use when the associated trigger fires.

Jobs run via the associated trigger will have their default arguments
replaced with the arguments specified.

You can specify arguments here that your own job-execution script
consumes, in addition to arguments that AWS Glue itself consumes.

> [[Trigger Actions.Arguments](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-arguments)]([Trigger Actions.Arguments](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-arguments))

---

##### `notifyDelayAfter`<sup>Optional</sup> <a name="notifyDelayAfter" id="cdk-extensions.glue.WorkflowJobActionOptions.property.notifyDelayAfter"></a>

```typescript
public readonly notifyDelayAfter: Duration;
```

- *Type:* aws-cdk-lib.Duration

After a job run starts, the number of minutes to wait before sending a job run delay notification.

> [[Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter)]([Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter))

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.WorkflowJobActionOptions.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: string;
```

- *Type:* string

The name of the SecurityConfiguration structure to be used with this action.

> [[Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration)]([Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration))

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="cdk-extensions.glue.WorkflowJobActionOptions.property.timeout"></a>

```typescript
public readonly timeout: Duration;
```

- *Type:* aws-cdk-lib.Duration

The `JobRun` timeout in minutes.

This is the maximum time that a job run
can consume resources before it is terminated and enters TIMEOUT status.
The default is 48 hours. This overrides the timeout value set in the
parent job.

> [[Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout)]([Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout))

---

##### `bookmarkConfiguration`<sup>Optional</sup> <a name="bookmarkConfiguration" id="cdk-extensions.glue.WorkflowJobActionOptions.property.bookmarkConfiguration"></a>

```typescript
public readonly bookmarkConfiguration: BookmarkConfiguration;
```

- *Type:* cdk-extensions.glue.BookmarkConfiguration

The bookmark configuration override to use for the Glue job that is being triggered.

---

### WorkflowJobPredicateOptions <a name="WorkflowJobPredicateOptions" id="cdk-extensions.glue.WorkflowJobPredicateOptions"></a>

Configuration options that specify the state a job must meet in order to satisfy the conditions of the predicate.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.WorkflowJobPredicateOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const workflowJobPredicateOptions: glue.WorkflowJobPredicateOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicateOptions.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicateOptions.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicateOptions.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicateOptions.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicateOptions.property.logicalOperator">logicalOperator</a></code> | <code>cdk-extensions.glue.PredicateLogicalOperator</code> | The logical operator which should be applied in determining whether a job meets the requested conditions. |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicateOptions.property.state">state</a></code> | <code>cdk-extensions.glue.JobState</code> | The state that the job must be in in order to meet the criteria to trigger the next stage of the workflow. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.WorkflowJobPredicateOptions.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.WorkflowJobPredicateOptions.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.WorkflowJobPredicateOptions.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.WorkflowJobPredicateOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `logicalOperator`<sup>Optional</sup> <a name="logicalOperator" id="cdk-extensions.glue.WorkflowJobPredicateOptions.property.logicalOperator"></a>

```typescript
public readonly logicalOperator: PredicateLogicalOperator;
```

- *Type:* cdk-extensions.glue.PredicateLogicalOperator

The logical operator which should be applied in determining whether a job meets the requested conditions.

At the moment, the only supported operator is `EQUALS`.

> [[Trigger Predicate.Conditions.LogicalOperator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-logicaloperator)]([Trigger Predicate.Conditions.LogicalOperator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-logicaloperator))

---

##### `state`<sup>Optional</sup> <a name="state" id="cdk-extensions.glue.WorkflowJobPredicateOptions.property.state"></a>

```typescript
public readonly state: JobState;
```

- *Type:* cdk-extensions.glue.JobState

The state that the job must be in in order to meet the criteria to trigger the next stage of the workflow.

> [[Trigger Predicate.Conditions.State](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-state)]([Trigger Predicate.Conditions.State](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-state))

---

### WorkflowPredicateOptions <a name="WorkflowPredicateOptions" id="cdk-extensions.glue.WorkflowPredicateOptions"></a>

Options for a generic Glue Trigger predicate.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.WorkflowPredicateOptions.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const workflowPredicateOptions: glue.WorkflowPredicateOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowPredicateOptions.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowPredicateOptions.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.WorkflowPredicateOptions.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.WorkflowPredicateOptions.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.WorkflowPredicateOptions.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.WorkflowPredicateOptions.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.WorkflowPredicateOptions.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.WorkflowPredicateOptions.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

### WorkflowProps <a name="WorkflowProps" id="cdk-extensions.glue.WorkflowProps"></a>

Configuration for the Glue Workflow resource.

#### Initializer <a name="Initializer" id="cdk-extensions.glue.WorkflowProps.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

const workflowProps: glue.WorkflowProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.glue.WorkflowProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.glue.WorkflowProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.glue.WorkflowProps.property.description">description</a></code> | <code>string</code> | A description of the Workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowProps.property.name">name</a></code> | <code>string</code> | A name of the Workflow. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.glue.WorkflowProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.glue.WorkflowProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.glue.WorkflowProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.glue.WorkflowProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk-extensions.glue.WorkflowProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A description of the Workflow.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.WorkflowProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A name of the Workflow.

---

### WorkspaceAlertingOptions <a name="WorkspaceAlertingOptions" id="cdk-extensions.aps.WorkspaceAlertingOptions"></a>

Alerting configuration to use when setting up an APS workspace.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.WorkspaceAlertingOptions.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const workspaceAlertingOptions: aps.WorkspaceAlertingOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.WorkspaceAlertingOptions.property.configuration">configuration</a></code> | <code>cdk-extensions.aps.IAlertManagerConfiguration</code> | The alert manager configuration to use when setting up alerting. |
| <code><a href="#cdk-extensions.aps.WorkspaceAlertingOptions.property.enabled">enabled</a></code> | <code>boolean</code> | Controls whether alerting from the APS workspace should be configured. |
| <code><a href="#cdk-extensions.aps.WorkspaceAlertingOptions.property.topic">topic</a></code> | <code>aws-cdk-lib.aws_sns.ITopic</code> | The SNS topic where alerts should be sent when using the default alerting configuration. |

---

##### `configuration`<sup>Optional</sup> <a name="configuration" id="cdk-extensions.aps.WorkspaceAlertingOptions.property.configuration"></a>

```typescript
public readonly configuration: IAlertManagerConfiguration;
```

- *Type:* cdk-extensions.aps.IAlertManagerConfiguration

The alert manager configuration to use when setting up alerting.

If alerting is enabled and no configuration is given a default
configuration that sends all alerts to SNS will be used.

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.aps.WorkspaceAlertingOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean
- *Default:* true

Controls whether alerting from the APS workspace should be configured.

---

##### `topic`<sup>Optional</sup> <a name="topic" id="cdk-extensions.aps.WorkspaceAlertingOptions.property.topic"></a>

```typescript
public readonly topic: ITopic;
```

- *Type:* aws-cdk-lib.aws_sns.ITopic

The SNS topic where alerts should be sent when using the default alerting configuration.

If a custom alert manager configuration is provided this option is ignored.

---

### WorkspaceAttributes <a name="WorkspaceAttributes" id="cdk-extensions.aps.WorkspaceAttributes"></a>

Configuration for importing an existing APS workspace.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.WorkspaceAttributes.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const workspaceAttributes: aps.WorkspaceAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.WorkspaceAttributes.property.workspaceArn">workspaceArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the APS workspace. |
| <code><a href="#cdk-extensions.aps.WorkspaceAttributes.property.workspaceId">workspaceId</a></code> | <code>string</code> | The ID generated by AWS for the APS workspace. |
| <code><a href="#cdk-extensions.aps.WorkspaceAttributes.property.workspacePrometheusEndpoint">workspacePrometheusEndpoint</a></code> | <code>string</code> | The Prometheus endpoint attribute of the workspace. |

---

##### `workspaceArn`<sup>Optional</sup> <a name="workspaceArn" id="cdk-extensions.aps.WorkspaceAttributes.property.workspaceArn"></a>

```typescript
public readonly workspaceArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the APS workspace.

---

##### `workspaceId`<sup>Optional</sup> <a name="workspaceId" id="cdk-extensions.aps.WorkspaceAttributes.property.workspaceId"></a>

```typescript
public readonly workspaceId: string;
```

- *Type:* string

The ID generated by AWS for the APS workspace.

---

##### `workspacePrometheusEndpoint`<sup>Optional</sup> <a name="workspacePrometheusEndpoint" id="cdk-extensions.aps.WorkspaceAttributes.property.workspacePrometheusEndpoint"></a>

```typescript
public readonly workspacePrometheusEndpoint: string;
```

- *Type:* string

The Prometheus endpoint attribute of the workspace.

This is the endpoint prefix without the remote_write or query API
appended.

---

### WorkspaceLoggingOptions <a name="WorkspaceLoggingOptions" id="cdk-extensions.aps.WorkspaceLoggingOptions"></a>

Logging configuration to use when setting up the APS workspace.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.WorkspaceLoggingOptions.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const workspaceLoggingOptions: aps.WorkspaceLoggingOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.WorkspaceLoggingOptions.property.enabled">enabled</a></code> | <code>boolean</code> | Controls whether logging for the workspace should be enabled. |
| <code><a href="#cdk-extensions.aps.WorkspaceLoggingOptions.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | The log group where events from the APS workspace will be written. |
| <code><a href="#cdk-extensions.aps.WorkspaceLoggingOptions.property.retention">retention</a></code> | <code>aws-cdk-lib.aws_logs.RetentionDays</code> | The length of time that logs from the APS workspace should be kept when a new log group is created for the workspace. |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.aps.WorkspaceLoggingOptions.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean
- *Default:* true

Controls whether logging for the workspace should be enabled.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.aps.WorkspaceLoggingOptions.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The log group where events from the APS workspace will be written.

If logging is enabled and no log group is provided a new log group will be
created.

> [[Workspace LoggingConfiguration.LogGroupArn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-aps-workspace-loggingconfiguration.html#cfn-aps-workspace-loggingconfiguration-loggrouparn)]([Workspace LoggingConfiguration.LogGroupArn](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-aps-workspace-loggingconfiguration.html#cfn-aps-workspace-loggingconfiguration-loggrouparn))

---

##### `retention`<sup>Optional</sup> <a name="retention" id="cdk-extensions.aps.WorkspaceLoggingOptions.property.retention"></a>

```typescript
public readonly retention: RetentionDays;
```

- *Type:* aws-cdk-lib.aws_logs.RetentionDays

The length of time that logs from the APS workspace should be kept when a new log group is created for the workspace.

This property is ignored when a log group is passed as part of the logging
configuration.

> [[LogGroup RetentionInDays](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-logs-loggroup.html#cfn-logs-loggroup-retentionindays)]([LogGroup RetentionInDays](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-logs-loggroup.html#cfn-logs-loggroup-retentionindays))

---

### WorkspaceProps <a name="WorkspaceProps" id="cdk-extensions.aps.WorkspaceProps"></a>

Configuration for the Workspace resource.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.WorkspaceProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const workspaceProps: aps.WorkspaceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.WorkspaceProps.property.account">account</a></code> | <code>string</code> | The AWS account ID this resource belongs to. |
| <code><a href="#cdk-extensions.aps.WorkspaceProps.property.environmentFromArn">environmentFromArn</a></code> | <code>string</code> | ARN to deduce region and account from. |
| <code><a href="#cdk-extensions.aps.WorkspaceProps.property.physicalName">physicalName</a></code> | <code>string</code> | The value passed in by users to the physical name prop of the resource. |
| <code><a href="#cdk-extensions.aps.WorkspaceProps.property.region">region</a></code> | <code>string</code> | The AWS region this resource belongs to. |
| <code><a href="#cdk-extensions.aps.WorkspaceProps.property.alerting">alerting</a></code> | <code>cdk-extensions.aps.WorkspaceAlertingOptions</code> | The details used to configure alerting for the APS workspace. |
| <code><a href="#cdk-extensions.aps.WorkspaceProps.property.alias">alias</a></code> | <code>string</code> | An alias that you assign to this workspace to help you identify it. It does not need to be unique. |
| <code><a href="#cdk-extensions.aps.WorkspaceProps.property.logging">logging</a></code> | <code>cdk-extensions.aps.WorkspaceLoggingOptions</code> | The details used for configuring logging for the APS workspace. |

---

##### `account`<sup>Optional</sup> <a name="account" id="cdk-extensions.aps.WorkspaceProps.property.account"></a>

```typescript
public readonly account: string;
```

- *Type:* string
- *Default:* the resource is in the same account as the stack it belongs to

The AWS account ID this resource belongs to.

---

##### `environmentFromArn`<sup>Optional</sup> <a name="environmentFromArn" id="cdk-extensions.aps.WorkspaceProps.property.environmentFromArn"></a>

```typescript
public readonly environmentFromArn: string;
```

- *Type:* string
- *Default:* take environment from `account`, `region` parameters, or use Stack environment.

ARN to deduce region and account from.

The ARN is parsed and the account and region are taken from the ARN.
This should be used for imported resources.

Cannot be supplied together with either `account` or `region`.

---

##### `physicalName`<sup>Optional</sup> <a name="physicalName" id="cdk-extensions.aps.WorkspaceProps.property.physicalName"></a>

```typescript
public readonly physicalName: string;
```

- *Type:* string
- *Default:* The physical name will be allocated by CloudFormation at deployment time

The value passed in by users to the physical name prop of the resource.

`undefined` implies that a physical name will be allocated by
  CloudFormation during deployment.
- a concrete value implies a specific physical name
- `PhysicalName.GENERATE_IF_NEEDED` is a marker that indicates that a physical will only be generated
  by the CDK if it is needed for cross-environment references. Otherwise, it will be allocated by CloudFormation.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.aps.WorkspaceProps.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string
- *Default:* the resource is in the same region as the stack it belongs to

The AWS region this resource belongs to.

---

##### `alerting`<sup>Optional</sup> <a name="alerting" id="cdk-extensions.aps.WorkspaceProps.property.alerting"></a>

```typescript
public readonly alerting: WorkspaceAlertingOptions;
```

- *Type:* cdk-extensions.aps.WorkspaceAlertingOptions

The details used to configure alerting for the APS workspace.

> [[Workspace AlertManagerDefinition](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-alertmanagerdefinition)]([Workspace AlertManagerDefinition](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-alertmanagerdefinition))

---

##### `alias`<sup>Optional</sup> <a name="alias" id="cdk-extensions.aps.WorkspaceProps.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

An alias that you assign to this workspace to help you identify it. It does not need to be unique.

The alias can be as many as 100 characters and can include any type of
characters.

> [[Workspace Alias](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-alias)]([Workspace Alias](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-alias))

---

##### `logging`<sup>Optional</sup> <a name="logging" id="cdk-extensions.aps.WorkspaceProps.property.logging"></a>

```typescript
public readonly logging: WorkspaceLoggingOptions;
```

- *Type:* cdk-extensions.aps.WorkspaceLoggingOptions

The details used for configuring logging for the APS workspace.

> [[Workspace LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-loggingconfiguration)]([Workspace LoggingConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-aps-workspace.html#cfn-aps-workspace-loggingconfiguration))

---

### YearRange <a name="YearRange" id="cdk-extensions.aps.YearRange"></a>

A numerical range of years.

Ranges to cover multiple years are accepted. For example, `start: 2020` and
`end: 2022`.

Inclusive on both ends.

#### Initializer <a name="Initializer" id="cdk-extensions.aps.YearRange.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

const yearRange: aps.YearRange = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.YearRange.property.start">start</a></code> | <code>number</code> | The year where the range should start. |
| <code><a href="#cdk-extensions.aps.YearRange.property.end">end</a></code> | <code>number</code> | The year where the range should end. |

---

##### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.YearRange.property.start"></a>

```typescript
public readonly start: number;
```

- *Type:* number

The year where the range should start.

---

##### `end`<sup>Optional</sup> <a name="end" id="cdk-extensions.aps.YearRange.property.end"></a>

```typescript
public readonly end: number;
```

- *Type:* number

The year where the range should end.

If not specified, the range will end at the end of the year specified by
`start`.

---

## Classes <a name="Classes" id="Classes"></a>

### AccessControlAttribute <a name="AccessControlAttribute" id="cdk-extensions.sso.AccessControlAttribute"></a>

Represents and ABAC attribute in IAM Identity Center.

These are IAM Identity Center identity store attributes that you can
configure for use in attributes-based access control (ABAC). You can create
permissions policies that determine who can access your AWS resources based
upon the configured attribute values. When you enable ABAC and specify
`AccessControlAttributes`, IAM Identity Center passes the attribute values
of the authenticated user into IAM for use in policy evaluation.

#### Initializers <a name="Initializers" id="cdk-extensions.sso.AccessControlAttribute.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.AccessControlAttribute(options: AccessControlAttributeOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.AccessControlAttribute.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.sso.AccessControlAttributeOptions</code> | The configuration settings to use when configuring the attribute. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.sso.AccessControlAttribute.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.sso.AccessControlAttributeOptions

The configuration settings to use when configuring the attribute.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.AccessControlAttribute.addSource">addSource</a></code> | Adds an identity source to use when mapping the attribute to IAM Identity Center. |
| <code><a href="#cdk-extensions.sso.AccessControlAttribute.bind">bind</a></code> | Generates the raw CloudFormation configuration that this attribute represents within the context of a given scope. |

---

##### `addSource` <a name="addSource" id="cdk-extensions.sso.AccessControlAttribute.addSource"></a>

```typescript
public addSource(source: string): AccessControlAttribute
```

Adds an identity source to use when mapping the attribute to IAM Identity Center.

###### `source`<sup>Required</sup> <a name="source" id="cdk-extensions.sso.AccessControlAttribute.addSource.parameter.source"></a>

- *Type:* string

The source to add.

---

##### `bind` <a name="bind" id="cdk-extensions.sso.AccessControlAttribute.bind"></a>

```typescript
public bind(scope: IConstruct): AccessControlAttributeProperty
```

Generates the raw CloudFormation configuration that this attribute represents within the context of a given scope.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.AccessControlAttribute.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct managing the access control attribute configuration that will consume details of this attribute.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.AccessControlAttribute.property.name">name</a></code> | <code>string</code> | The name of the attribute associated with your identities in your identity source. |
| <code><a href="#cdk-extensions.sso.AccessControlAttribute.property.sources">sources</a></code> | <code>string[]</code> | A list of identity sources to use when mapping a specified attribute to IAM Identity Center. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.sso.AccessControlAttribute.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute associated with your identities in your identity source.

This is used to map a specified attribute in your
identity source with an attribute in IAM Identity Center.

---

##### `sources`<sup>Required</sup> <a name="sources" id="cdk-extensions.sso.AccessControlAttribute.property.sources"></a>

```typescript
public readonly sources: string[];
```

- *Type:* string[]

A list of identity sources to use when mapping a specified attribute to IAM Identity Center.

Note that the array is readonly and changes made
to it will not be reflected when generating ABAC attribute
configuration. To add a source to the attribute use the {@link addSource}
method.

---


### AddressConfiguration <a name="AddressConfiguration" id="cdk-extensions.ec2.AddressConfiguration"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.AddressConfiguration.ipv4">ipv4</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfiguration.ipv6">ipv6</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfiguration.of">of</a></code> | *No description.* |

---

##### `ipv4` <a name="ipv4" id="cdk-extensions.ec2.AddressConfiguration.ipv4"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.AddressConfiguration.ipv4(options?: Ipv4ConfigurationOptions)
```

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.AddressConfiguration.ipv4.parameter.options"></a>

- *Type:* cdk-extensions.ec2.Ipv4ConfigurationOptions

---

##### `ipv6` <a name="ipv6" id="cdk-extensions.ec2.AddressConfiguration.ipv6"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.AddressConfiguration.ipv6(options?: Ipv6ConfigurationOptions)
```

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.AddressConfiguration.ipv6.parameter.options"></a>

- *Type:* cdk-extensions.ec2.Ipv6ConfigurationOptions

---

##### `of` <a name="of" id="cdk-extensions.ec2.AddressConfiguration.of"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.AddressConfiguration.of(props: AddressConfigurationProps)
```

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.AddressConfiguration.of.parameter.props"></a>

- *Type:* cdk-extensions.ec2.AddressConfigurationProps

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.AddressConfiguration.property.family">family</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfiguration.property.defaultNetmaskLength">defaultNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfiguration.property.maxNetmaskLength">maxNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfiguration.property.minNetmaskLength">minNetmaskLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.AddressConfiguration.property.publiclyAdvertisable">publiclyAdvertisable</a></code> | <code>boolean</code> | *No description.* |

---

##### `family`<sup>Required</sup> <a name="family" id="cdk-extensions.ec2.AddressConfiguration.property.family"></a>

```typescript
public readonly family: string;
```

- *Type:* string

---

##### `defaultNetmaskLength`<sup>Optional</sup> <a name="defaultNetmaskLength" id="cdk-extensions.ec2.AddressConfiguration.property.defaultNetmaskLength"></a>

```typescript
public readonly defaultNetmaskLength: number;
```

- *Type:* number

---

##### `maxNetmaskLength`<sup>Optional</sup> <a name="maxNetmaskLength" id="cdk-extensions.ec2.AddressConfiguration.property.maxNetmaskLength"></a>

```typescript
public readonly maxNetmaskLength: number;
```

- *Type:* number

---

##### `minNetmaskLength`<sup>Optional</sup> <a name="minNetmaskLength" id="cdk-extensions.ec2.AddressConfiguration.property.minNetmaskLength"></a>

```typescript
public readonly minNetmaskLength: number;
```

- *Type:* number

---

##### `publiclyAdvertisable`<sup>Optional</sup> <a name="publiclyAdvertisable" id="cdk-extensions.ec2.AddressConfiguration.property.publiclyAdvertisable"></a>

```typescript
public readonly publiclyAdvertisable: boolean;
```

- *Type:* boolean

---


### AlertingRule <a name="AlertingRule" id="cdk-extensions.aps.AlertingRule"></a>

- *Implements:* cdk-extensions.aps.IPrometheusRule

Alerting rules allow you to define alert conditions based on Prometheus expression language expressions and to send notifications about firing alerts to an external service.

Whenever the alert expression results in one
or more vector elements at a given point in time, the alert counts as active
for these elements' label sets.

> [[Alerting rules](https://prometheus.io/docs/prometheus/latest/configuration/alerting_rules/)]([Alerting rules](https://prometheus.io/docs/prometheus/latest/configuration/alerting_rules/))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.AlertingRule.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.AlertingRule(props: AlertingRuleProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertingRule.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.aps.AlertingRuleProps</code> | Arguments defining the configuration of the alerting rule. |

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.aps.AlertingRule.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.aps.AlertingRuleProps

Arguments defining the configuration of the alerting rule.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertingRule.addAnnotation">addAnnotation</a></code> | Sets a new annotation that will be added to each generated alert. |
| <code><a href="#cdk-extensions.aps.AlertingRule.addLabel">addLabel</a></code> | Sets a new label that will be added or overridden for each generated alert. |
| <code><a href="#cdk-extensions.aps.AlertingRule.bind">bind</a></code> | Associates the alerting rule with a construct that is configuring an APS rule groups namespace. |

---

##### `addAnnotation` <a name="addAnnotation" id="cdk-extensions.aps.AlertingRule.addAnnotation"></a>

```typescript
public addAnnotation(label: string, template: string): AlertingRule
```

Sets a new annotation that will be added to each generated alert.

###### `label`<sup>Required</sup> <a name="label" id="cdk-extensions.aps.AlertingRule.addAnnotation.parameter.label"></a>

- *Type:* string

The name of the annotation to add.

---

###### `template`<sup>Required</sup> <a name="template" id="cdk-extensions.aps.AlertingRule.addAnnotation.parameter.template"></a>

- *Type:* string

The template that will be used to render the value of the annotation.

---

##### `addLabel` <a name="addLabel" id="cdk-extensions.aps.AlertingRule.addLabel"></a>

```typescript
public addLabel(label: string, template: string): AlertingRule
```

Sets a new label that will be added or overridden for each generated alert.

###### `label`<sup>Required</sup> <a name="label" id="cdk-extensions.aps.AlertingRule.addLabel.parameter.label"></a>

- *Type:* string

The name of the label to add.

---

###### `template`<sup>Required</sup> <a name="template" id="cdk-extensions.aps.AlertingRule.addLabel.parameter.template"></a>

- *Type:* string

The template that will be used to render the value of the label.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.AlertingRule.bind"></a>

```typescript
public bind(_scope: IConstruct): {[ key: string ]: any}
```

Associates the alerting rule with a construct that is configuring an APS rule groups namespace.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.aps.AlertingRule.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of the APS rule groups namespace that will be consuming this rule.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertingRule.property.alert">alert</a></code> | <code>string</code> | The name of the alert. |
| <code><a href="#cdk-extensions.aps.AlertingRule.property.expression">expression</a></code> | <code>string</code> | The PromQL expression to evaluate. |
| <code><a href="#cdk-extensions.aps.AlertingRule.property.period">period</a></code> | <code>aws-cdk-lib.Duration</code> | Alerts are considered firing once they have been returned for this long. |

---

##### `alert`<sup>Required</sup> <a name="alert" id="cdk-extensions.aps.AlertingRule.property.alert"></a>

```typescript
public readonly alert: string;
```

- *Type:* string

The name of the alert.

Must be a valid label value.

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk-extensions.aps.AlertingRule.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

The PromQL expression to evaluate.

Every evaluation cycle this is
evaluated at the current time, and all resultant time series become
pending/firing alerts.

> [[Querying prometheus](https://prometheus.io/docs/prometheus/latest/querying/basics/)]([Querying prometheus](https://prometheus.io/docs/prometheus/latest/querying/basics/))

---

##### `period`<sup>Optional</sup> <a name="period" id="cdk-extensions.aps.AlertingRule.property.period"></a>

```typescript
public readonly period: Duration;
```

- *Type:* aws-cdk-lib.Duration

Alerts are considered firing once they have been returned for this long.

Alerts which have not yet fired for long enough are considered pending.

---


### AlertManagerDestination <a name="AlertManagerDestination" id="cdk-extensions.aps.AlertManagerDestination"></a>

Provides an interface for creating various alert manager destination objects that can receive notifications when an alert happens in Prometheus.

#### Initializers <a name="Initializers" id="cdk-extensions.aps.AlertManagerDestination.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.AlertManagerDestination()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerDestination.snsTopic">snsTopic</a></code> | Creates an alert manager destination that sends alert notifications to an Amazon SNS topic. |

---

##### `snsTopic` <a name="snsTopic" id="cdk-extensions.aps.AlertManagerDestination.snsTopic"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerDestination.snsTopic(topic: ITopic, options?: AlertManagerSnsDestinationOptions)
```

Creates an alert manager destination that sends alert notifications to an Amazon SNS topic.

###### `topic`<sup>Required</sup> <a name="topic" id="cdk-extensions.aps.AlertManagerDestination.snsTopic.parameter.topic"></a>

- *Type:* aws-cdk-lib.aws_sns.ITopic

The SNS topic where alert notifications should be sent.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.aps.AlertManagerDestination.snsTopic.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertManagerSnsDestinationOptions

Options controlling aspects of how alert notification should be handled when being sent to the SNS topic.

---



### AlertManagerDestinationCategory <a name="AlertManagerDestinationCategory" id="cdk-extensions.aps.AlertManagerDestinationCategory"></a>

Specifies the type of destination where alert manager can send notifications.

Corresponds with a config block inside an alert manager receiver
configuration.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.of">of</a></code> | An escape hatch method that allows specifying arbitrary values for the type a receiver field a destination should be placed under. |

---

##### `of` <a name="of" id="cdk-extensions.aps.AlertManagerDestinationCategory.of"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerDestinationCategory.of(name: string)
```

An escape hatch method that allows specifying arbitrary values for the type a receiver field a destination should be placed under.

In the event that new destination types are added by alert manager, this
can be used to implement custom destinations in the event that it hasn't
had the chance to be implemented here.

Whenever possible, it is recommended the static values provided be used.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.aps.AlertManagerDestinationCategory.of.parameter.name"></a>

- *Type:* string

The name of the key in a receiver config where the destination being configured should be placed.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.name">name</a></code> | <code>string</code> | The name of the category, as it would appear as a key in the configuration for an alert manager receiver. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the category, as it would appear as a key in the configuration for an alert manager receiver.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.EMAIL">EMAIL</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications via email. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.OPSGENIE">OPSGENIE</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications using Opsgenie. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.PAGERDUTY">PAGERDUTY</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications using PagerDuty. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.PUSHOVER">PUSHOVER</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications using Pushover. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.SLACK">SLACK</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications via Slack. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.SNS">SNS</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications using Amazon SNS. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.TELEGRAM">TELEGRAM</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications via Telegram. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.VICTOROPS">VICTOROPS</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications using VictorOps. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.WEBEX">WEBEX</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications using Webex. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.WEBHOOK">WEBHOOK</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications via a webhook. |
| <code><a href="#cdk-extensions.aps.AlertManagerDestinationCategory.property.WECHAT">WECHAT</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | Sends notifications via WeChat. |

---

##### `EMAIL`<sup>Required</sup> <a name="EMAIL" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.EMAIL"></a>

```typescript
public readonly EMAIL: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications via email.

Not currently supported by APS.

---

##### `OPSGENIE`<sup>Required</sup> <a name="OPSGENIE" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.OPSGENIE"></a>

```typescript
public readonly OPSGENIE: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications using Opsgenie.

Not currently supported by APS.

---

##### `PAGERDUTY`<sup>Required</sup> <a name="PAGERDUTY" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.PAGERDUTY"></a>

```typescript
public readonly PAGERDUTY: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications using PagerDuty.

Not currently supported by APS.

---

##### `PUSHOVER`<sup>Required</sup> <a name="PUSHOVER" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.PUSHOVER"></a>

```typescript
public readonly PUSHOVER: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications using Pushover.

Not currently supported by APS.

---

##### `SLACK`<sup>Required</sup> <a name="SLACK" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.SLACK"></a>

```typescript
public readonly SLACK: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications via Slack.

Not currently supported by APS.

---

##### `SNS`<sup>Required</sup> <a name="SNS" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.SNS"></a>

```typescript
public readonly SNS: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications using Amazon SNS.

---

##### `TELEGRAM`<sup>Required</sup> <a name="TELEGRAM" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.TELEGRAM"></a>

```typescript
public readonly TELEGRAM: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications via Telegram.

Not currently supported by APS.

---

##### `VICTOROPS`<sup>Required</sup> <a name="VICTOROPS" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.VICTOROPS"></a>

```typescript
public readonly VICTOROPS: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications using VictorOps.

Not currently supported by APS.

---

##### `WEBEX`<sup>Required</sup> <a name="WEBEX" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.WEBEX"></a>

```typescript
public readonly WEBEX: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications using Webex.

Not currently supported by APS.

---

##### `WEBHOOK`<sup>Required</sup> <a name="WEBHOOK" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.WEBHOOK"></a>

```typescript
public readonly WEBHOOK: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications via a webhook.

Not currently supported by APS.

---

##### `WECHAT`<sup>Required</sup> <a name="WECHAT" id="cdk-extensions.aps.AlertManagerDestinationCategory.property.WECHAT"></a>

```typescript
public readonly WECHAT: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

Sends notifications via WeChat.

Not currently supported by APS.

---

### AlertManagerInhibitRuleProps <a name="AlertManagerInhibitRuleProps" id="cdk-extensions.aps.AlertManagerInhibitRuleProps"></a>

Configuration options for the alert manager inhibit rule.

#### Initializers <a name="Initializers" id="cdk-extensions.aps.AlertManagerInhibitRuleProps.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.AlertManagerInhibitRuleProps()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRuleProps.property.equalLabels">equalLabels</a></code> | <code>string[]</code> | Labels that must have an equal value in the source and target alert for the inhibition to take effect. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRuleProps.property.sourceMatchers">sourceMatchers</a></code> | <code>cdk-extensions.aps.AlertManagerMatcher[]</code> | A list of matchers for which one or more alerts have to exist for the inhibition to take effect. |
| <code><a href="#cdk-extensions.aps.AlertManagerInhibitRuleProps.property.targetMatchers">targetMatchers</a></code> | <code>cdk-extensions.aps.AlertManagerMatcher[]</code> | A list of matchers that have to be fulfilled by the target alerts to be muted. |

---

##### `equalLabels`<sup>Optional</sup> <a name="equalLabels" id="cdk-extensions.aps.AlertManagerInhibitRuleProps.property.equalLabels"></a>

```typescript
public readonly equalLabels: string[];
```

- *Type:* string[]

Labels that must have an equal value in the source and target alert for the inhibition to take effect.

---

##### `sourceMatchers`<sup>Optional</sup> <a name="sourceMatchers" id="cdk-extensions.aps.AlertManagerInhibitRuleProps.property.sourceMatchers"></a>

```typescript
public readonly sourceMatchers: AlertManagerMatcher[];
```

- *Type:* cdk-extensions.aps.AlertManagerMatcher[]

A list of matchers for which one or more alerts have to exist for the inhibition to take effect.

---

##### `targetMatchers`<sup>Optional</sup> <a name="targetMatchers" id="cdk-extensions.aps.AlertManagerInhibitRuleProps.property.targetMatchers"></a>

```typescript
public readonly targetMatchers: AlertManagerMatcher[];
```

- *Type:* cdk-extensions.aps.AlertManagerMatcher[]

A list of matchers that have to be fulfilled by the target alerts to be muted.

---


### AlertManagerMatcher <a name="AlertManagerMatcher" id="cdk-extensions.aps.AlertManagerMatcher"></a>

An expression that alert manager can use to evaluate incoming alerts to determine the actions it should take.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerMatcher.fromComponents">fromComponents</a></code> | Builds a simple matcher using the standard components supported by the matcher expression syntax. |
| <code><a href="#cdk-extensions.aps.AlertManagerMatcher.fromCompound">fromCompound</a></code> | Creates a compund matcher expression by joining one or more other matcher objects. |
| <code><a href="#cdk-extensions.aps.AlertManagerMatcher.fromString">fromString</a></code> | Creates a matcher from a raw string expression. |

---

##### `fromComponents` <a name="fromComponents" id="cdk-extensions.aps.AlertManagerMatcher.fromComponents"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerMatcher.fromComponents(label: string, operator: MatchOperator, value: string)
```

Builds a simple matcher using the standard components supported by the matcher expression syntax.

Handles formatting an escaping of values.

###### `label`<sup>Required</sup> <a name="label" id="cdk-extensions.aps.AlertManagerMatcher.fromComponents.parameter.label"></a>

- *Type:* string

The Prometheus label name to match against.

---

###### `operator`<sup>Required</sup> <a name="operator" id="cdk-extensions.aps.AlertManagerMatcher.fromComponents.parameter.operator"></a>

- *Type:* cdk-extensions.aps.MatchOperator

The logical operator to use when evaluating the matcher.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.aps.AlertManagerMatcher.fromComponents.parameter.value"></a>

- *Type:* string

The value being compared against the specified label using the specified operator.

---

##### `fromCompound` <a name="fromCompound" id="cdk-extensions.aps.AlertManagerMatcher.fromCompound"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerMatcher.fromCompound(matchers: AlertManagerMatcher)
```

Creates a compund matcher expression by joining one or more other matcher objects.

###### `matchers`<sup>Required</sup> <a name="matchers" id="cdk-extensions.aps.AlertManagerMatcher.fromCompound.parameter.matchers"></a>

- *Type:* cdk-extensions.aps.AlertManagerMatcher

The matcher objects to join into a compound expression.

---

##### `fromString` <a name="fromString" id="cdk-extensions.aps.AlertManagerMatcher.fromString"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerMatcher.fromString(expression: string)
```

Creates a matcher from a raw string expression.

This allows for specifying
arbitrary matching conditions that may be too complex to be supported by
the other means of constructing matchers.

> [[Matcher expression syntax](https://prometheus.io/docs/alerting/latest/configuration/#matcher)]([Matcher expression syntax](https://prometheus.io/docs/alerting/latest/configuration/#matcher))

###### `expression`<sup>Required</sup> <a name="expression" id="cdk-extensions.aps.AlertManagerMatcher.fromString.parameter.expression"></a>

- *Type:* string

The PromQL-like expression to use for matching.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerMatcher.property.expression">expression</a></code> | <code>string</code> | The PromQL like expression to use for the matcher. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk-extensions.aps.AlertManagerMatcher.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

The PromQL like expression to use for the matcher.

---


### AlertManagerSnsDestination <a name="AlertManagerSnsDestination" id="cdk-extensions.aps.AlertManagerSnsDestination"></a>

- *Implements:* cdk-extensions.aps.IAlertManagerDestination

An alert manager destination that provides details for sending alert notifications to an Amazon SNS topic.

> [[Alert manager SNS configuration](https://prometheus.io/docs/alerting/latest/configuration/#sns_config)]([Alert manager SNS configuration](https://prometheus.io/docs/alerting/latest/configuration/#sns_config))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.AlertManagerSnsDestination.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.AlertManagerSnsDestination(options: AlertManagerSnsDestinationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.aps.AlertManagerSnsDestinationProps</code> | Arguments related to the configuration of the destination. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.AlertManagerSnsDestination.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertManagerSnsDestinationProps

Arguments related to the configuration of the destination.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.addAttribute">addAttribute</a></code> | Registers a new attribute to be added to sent SNS messages. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.bind">bind</a></code> | Associates the destination with a construct that is handling the configuration of alert manager. |

---

##### `addAttribute` <a name="addAttribute" id="cdk-extensions.aps.AlertManagerSnsDestination.addAttribute"></a>

```typescript
public addAttribute(key: string, value: string): AlertManagerSnsDestination
```

Registers a new attribute to be added to sent SNS messages.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.aps.AlertManagerSnsDestination.addAttribute.parameter.key"></a>

- *Type:* string

The name of the attribute.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.aps.AlertManagerSnsDestination.addAttribute.parameter.value"></a>

- *Type:* string

The value to use for the named attribute.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.AlertManagerSnsDestination.bind"></a>

```typescript
public bind(scope: IConstruct): {[ key: string ]: any}
```

Associates the destination with a construct that is handling the configuration of alert manager.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.AlertManagerSnsDestination.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling alert manager configuration.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.property.attributes">attributes</a></code> | <code>{[ key: string ]: string}</code> | Attributes to be applied to SNS messages. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.property.category">category</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | The destination type being configured. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.property.topic">topic</a></code> | <code>aws-cdk-lib.aws_sns.ITopic</code> | SNS topic where alerts will be sent. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.property.apiUrl">apiUrl</a></code> | <code>string</code> | The SNS API URL i.e. https://sns.us-east-2.amazonaws.com. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.property.message">message</a></code> | <code>string</code> | The message content of the SNS notification. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.property.sendResolved">sendResolved</a></code> | <code>boolean</code> | Controls whether to notify about resolved alerts. |
| <code><a href="#cdk-extensions.aps.AlertManagerSnsDestination.property.subject">subject</a></code> | <code>string</code> | Subject line when the message is delivered to email endpoints. |

---

##### `attributes`<sup>Required</sup> <a name="attributes" id="cdk-extensions.aps.AlertManagerSnsDestination.property.attributes"></a>

```typescript
public readonly attributes: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Attributes to be applied to SNS messages.

---

##### `category`<sup>Required</sup> <a name="category" id="cdk-extensions.aps.AlertManagerSnsDestination.property.category"></a>

```typescript
public readonly category: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

The destination type being configured.

Represents a config block in an alert manager receiver configuration.

---

##### `topic`<sup>Required</sup> <a name="topic" id="cdk-extensions.aps.AlertManagerSnsDestination.property.topic"></a>

```typescript
public readonly topic: ITopic;
```

- *Type:* aws-cdk-lib.aws_sns.ITopic

SNS topic where alerts will be sent.

If you are using a FIFO SNS topic you should set a message group interval
longer than 5 minutes to prevent messages with the same group key being
deduplicated by the SNS default deduplication window.

---

##### `apiUrl`<sup>Optional</sup> <a name="apiUrl" id="cdk-extensions.aps.AlertManagerSnsDestination.property.apiUrl"></a>

```typescript
public readonly apiUrl: string;
```

- *Type:* string

The SNS API URL i.e. https://sns.us-east-2.amazonaws.com.

If not specified, the SNS API URL from the SNS SDK will be used.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk-extensions.aps.AlertManagerSnsDestination.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

The message content of the SNS notification.

---

##### `sendResolved`<sup>Optional</sup> <a name="sendResolved" id="cdk-extensions.aps.AlertManagerSnsDestination.property.sendResolved"></a>

```typescript
public readonly sendResolved: boolean;
```

- *Type:* boolean

Controls whether to notify about resolved alerts.

---

##### `subject`<sup>Optional</sup> <a name="subject" id="cdk-extensions.aps.AlertManagerSnsDestination.property.subject"></a>

```typescript
public readonly subject: string;
```

- *Type:* string

Subject line when the message is delivered to email endpoints.

---


### AlertManagerTemplate <a name="AlertManagerTemplate" id="cdk-extensions.aps.AlertManagerTemplate"></a>

A template that can be used for formatting alerts sent by alert manager.

> [[Notification template examples](https://prometheus.io/docs/alerting/latest/notification_examples/)]([Notification template examples](https://prometheus.io/docs/alerting/latest/notification_examples/))


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerTemplate.fromFile">fromFile</a></code> | Loads an alert template from the local filesystem. |
| <code><a href="#cdk-extensions.aps.AlertManagerTemplate.fromString">fromString</a></code> | Loads an alert manager template using a template string. |

---

##### `fromFile` <a name="fromFile" id="cdk-extensions.aps.AlertManagerTemplate.fromFile"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerTemplate.fromFile(path: string)
```

Loads an alert template from the local filesystem.

###### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.aps.AlertManagerTemplate.fromFile.parameter.path"></a>

- *Type:* string

The path to the file containg the template.

---

##### `fromString` <a name="fromString" id="cdk-extensions.aps.AlertManagerTemplate.fromString"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.AlertManagerTemplate.fromString(content: string)
```

Loads an alert manager template using a template string.

###### `content`<sup>Required</sup> <a name="content" id="cdk-extensions.aps.AlertManagerTemplate.fromString.parameter.content"></a>

- *Type:* string

The template content as a string.

Uses the Go templating
system.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.AlertManagerTemplate.property.content">content</a></code> | <code>string</code> | The template content as a string. |

---

##### `content`<sup>Required</sup> <a name="content" id="cdk-extensions.aps.AlertManagerTemplate.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* string

The template content as a string.

Uses the Go templating system.

---


### AppendDelimiterProcessor <a name="AppendDelimiterProcessor" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessor"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.AppendDelimiterProcessor(options: AppendDelimiterProcessorOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.AppendDelimiterProcessorOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.AppendDelimiterProcessorOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.bind"></a>

```typescript
public bind(_scope: IConstruct): ProcessorProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.property.processorType">processorType</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.property.delimiter">delimiter</a></code> | <code>string</code> | *No description.* |

---

##### `processorType`<sup>Required</sup> <a name="processorType" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.property.processorType"></a>

```typescript
public readonly processorType: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `delimiter`<sup>Required</sup> <a name="delimiter" id="cdk-extensions.kinesis_firehose.AppendDelimiterProcessor.property.delimiter"></a>

```typescript
public readonly delimiter: string;
```

- *Type:* string

---


### ArrayColumn <a name="ArrayColumn" id="cdk-extensions.glue.ArrayColumn"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue.ArrayColumn.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.ArrayColumn(props: ArrayColumnProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ArrayColumn.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.ArrayColumnProps</code> | *No description.* |

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.ArrayColumn.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.ArrayColumnProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.ArrayColumn.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.ArrayColumn.bind"></a>

```typescript
public bind(scope: IConstruct): ColumnProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.ArrayColumn.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ArrayColumn.property.typeString">typeString</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ArrayColumn.property.comment">comment</a></code> | <code>string</code> | A free-form text comment. |
| <code><a href="#cdk-extensions.glue.ArrayColumn.property.name">name</a></code> | <code>string</code> | The name of the Column. |

---

##### `typeString`<sup>Required</sup> <a name="typeString" id="cdk-extensions.glue.ArrayColumn.property.typeString"></a>

```typescript
public readonly typeString: string;
```

- *Type:* string

---

##### `comment`<sup>Optional</sup> <a name="comment" id="cdk-extensions.glue.ArrayColumn.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

A free-form text comment.

> [[AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-comment)]([AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-comment))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.ArrayColumn.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Column.

> [[AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-name)]([AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-name))

---


### AssetCode <a name="AssetCode" id="cdk-extensions.glue.AssetCode"></a>

Job Code from a local file.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.AssetCode.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.AssetCode(path: string, options?: AssetOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.AssetCode.Initializer.parameter.path">path</a></code> | <code>string</code> | The path to the Code file. |
| <code><a href="#cdk-extensions.glue.AssetCode.Initializer.parameter.options">options</a></code> | <code>aws-cdk-lib.AssetOptions</code> | *No description.* |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.glue.AssetCode.Initializer.parameter.path"></a>

- *Type:* string

The path to the Code file.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.AssetCode.Initializer.parameter.options"></a>

- *Type:* aws-cdk-lib.AssetOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.AssetCode.bind">bind</a></code> | Called when the Job is initialized to allow this object to bind. |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.AssetCode.bind"></a>

```typescript
public bind(scope: Construct, grantable: IGrantable): CodeConfig
```

Called when the Job is initialized to allow this object to bind.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.AssetCode.bind.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `grantable`<sup>Required</sup> <a name="grantable" id="cdk-extensions.glue.AssetCode.bind.parameter.grantable"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.AssetCode.fromAsset">fromAsset</a></code> | Job code from a local disk path. |
| <code><a href="#cdk-extensions.glue.AssetCode.fromBucket">fromBucket</a></code> | Job code as an S3 object. |

---

##### `fromAsset` <a name="fromAsset" id="cdk-extensions.glue.AssetCode.fromAsset"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.AssetCode.fromAsset(path: string, options?: AssetOptions)
```

Job code from a local disk path.

###### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.glue.AssetCode.fromAsset.parameter.path"></a>

- *Type:* string

Code file (not a directory).

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.AssetCode.fromAsset.parameter.options"></a>

- *Type:* aws-cdk-lib.AssetOptions

---

##### `fromBucket` <a name="fromBucket" id="cdk-extensions.glue.AssetCode.fromBucket"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.AssetCode.fromBucket(bucket: IBucket, key: string)
```

Job code as an S3 object.

###### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue.AssetCode.fromBucket.parameter.bucket"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucket

The S3 bucket.

---

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.AssetCode.fromBucket.parameter.key"></a>

- *Type:* string

The object key.

---



### AssignmentTarget <a name="AssignmentTarget" id="cdk-extensions.sso.AssignmentTarget"></a>

Represents a resource that can have permissions granted for using IAM Identity Center such as an AWS account.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.AssignmentTarget.awsAccount">awsAccount</a></code> | Creates an assignment target that represents an AWS account. |
| <code><a href="#cdk-extensions.sso.AssignmentTarget.of">of</a></code> | An escape hatch method that allows specifying a custom target for an assignment in the event new target options are added and the provided methods for configuring targets are yet to catch up. |

---

##### `awsAccount` <a name="awsAccount" id="cdk-extensions.sso.AssignmentTarget.awsAccount"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.AssignmentTarget.awsAccount(accountId: string)
```

Creates an assignment target that represents an AWS account.

###### `accountId`<sup>Required</sup> <a name="accountId" id="cdk-extensions.sso.AssignmentTarget.awsAccount.parameter.accountId"></a>

- *Type:* string

The ID of the AWS account for which permissions should be granted.

---

##### `of` <a name="of" id="cdk-extensions.sso.AssignmentTarget.of"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.AssignmentTarget.of(targetType: AssignmentTargetType, targetId: string)
```

An escape hatch method that allows specifying a custom target for an assignment in the event new target options are added and the provided methods for configuring targets are yet to catch up.

It is recommended that the provided static methods be used whenever
possible for configuring assignment targets instead of calling `of`.

###### `targetType`<sup>Required</sup> <a name="targetType" id="cdk-extensions.sso.AssignmentTarget.of.parameter.targetType"></a>

- *Type:* cdk-extensions.sso.AssignmentTargetType

The entity type for which permissions will be granted.

---

###### `targetId`<sup>Required</sup> <a name="targetId" id="cdk-extensions.sso.AssignmentTarget.of.parameter.targetId"></a>

- *Type:* string

The unique identifier specifying the entity for which permissions will be granted.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.AssignmentTarget.property.targetId">targetId</a></code> | <code>string</code> | The unique identifier for the resource for which permissions will be granted. |
| <code><a href="#cdk-extensions.sso.AssignmentTarget.property.targetType">targetType</a></code> | <code>cdk-extensions.sso.AssignmentTargetType</code> | The type of resource for which permissions will be granted. |

---

##### `targetId`<sup>Required</sup> <a name="targetId" id="cdk-extensions.sso.AssignmentTarget.property.targetId"></a>

```typescript
public readonly targetId: string;
```

- *Type:* string

The unique identifier for the resource for which permissions will be granted.

---

##### `targetType`<sup>Required</sup> <a name="targetType" id="cdk-extensions.sso.AssignmentTarget.property.targetType"></a>

```typescript
public readonly targetType: AssignmentTargetType;
```

- *Type:* cdk-extensions.sso.AssignmentTargetType

The type of resource for which permissions will be granted.

---


### AssignmentTargetType <a name="AssignmentTargetType" id="cdk-extensions.sso.AssignmentTargetType"></a>

Provides a wrapper around the accepted values for the IAM Identity Center [Assignment.TargetType attribute](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-assignment.html#cfn-sso-assignment-targettype).

Accepted values are provided as static properties that can be used when
configuring an assignment.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.AssignmentTargetType.of">of</a></code> | An escape hatch method that allows specifying a custom target type in the even more options are added and the provided static types are yet to catch up. |

---

##### `of` <a name="of" id="cdk-extensions.sso.AssignmentTargetType.of"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.AssignmentTargetType.of(name: string)
```

An escape hatch method that allows specifying a custom target type in the even more options are added and the provided static types are yet to catch up.

It is recommended that the provided static types be used when possible
instead of calling `of`.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.sso.AssignmentTargetType.of.parameter.name"></a>

- *Type:* string

The name of the assignment target type.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.AssignmentTargetType.property.name">name</a></code> | <code>string</code> | The name describing the type of target. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.sso.AssignmentTargetType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name describing the type of target.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.AssignmentTargetType.property.AWS_ACCOUNT">AWS_ACCOUNT</a></code> | <code>cdk-extensions.sso.AssignmentTargetType</code> | An AWS account. |

---

##### `AWS_ACCOUNT`<sup>Required</sup> <a name="AWS_ACCOUNT" id="cdk-extensions.sso.AssignmentTargetType.property.AWS_ACCOUNT"></a>

```typescript
public readonly AWS_ACCOUNT: AssignmentTargetType;
```

- *Type:* cdk-extensions.sso.AssignmentTargetType

An AWS account.

---

### AwsServiceDiscoveryRegistry <a name="AwsServiceDiscoveryRegistry" id="cdk-extensions.k8s_aws.AwsServiceDiscoveryRegistry"></a>

- *Implements:* cdk-extensions.k8s_aws.IExternalDnsRegistry

An ExternalDNS registry that tracks DNS record ownership information using AWS Service Discovery.

> [[AWS Cloud Map](https://docs.aws.amazon.com/cloud-map/latest/dg/what-is-cloud-map.html)]([AWS Cloud Map](https://docs.aws.amazon.com/cloud-map/latest/dg/what-is-cloud-map.html))

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.AwsServiceDiscoveryRegistry.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.AwsServiceDiscoveryRegistry()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AwsServiceDiscoveryRegistry.bind">bind</a></code> | Generates an object with all the information needed to use the registry in a given CDK scope. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.AwsServiceDiscoveryRegistry.bind"></a>

```typescript
public bind(scope: IConstruct): ExternalDnsRegistryConfiguration
```

Generates an object with all the information needed to use the registry in a given CDK scope.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.AwsServiceDiscoveryRegistry.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The CDK resource that is configuring ExternalDNS.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.AwsServiceDiscoveryRegistry.property.registryType">registryType</a></code> | <code>string</code> | The type name of ExternalDNS registry. |

---

##### `registryType`<sup>Required</sup> <a name="registryType" id="cdk-extensions.k8s_aws.AwsServiceDiscoveryRegistry.property.registryType"></a>

```typescript
public readonly registryType: string;
```

- *Type:* string

The type name of ExternalDNS registry.

---


### BackupConfiguration <a name="BackupConfiguration" id="cdk-extensions.kinesis_firehose.BackupConfiguration"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.BackupConfiguration.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.BackupConfiguration(options: BackupConfigurationOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BackupConfiguration.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.BackupConfigurationOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.BackupConfiguration.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.BackupConfigurationOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BackupConfiguration.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.BackupConfiguration.bind"></a>

```typescript
public bind(scope: IConstruct): BackupConfigurationResult
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.BackupConfiguration.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BackupConfiguration.property.destination">destination</a></code> | <code>cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.BackupConfiguration.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |

---

##### `destination`<sup>Required</sup> <a name="destination" id="cdk-extensions.kinesis_firehose.BackupConfiguration.property.destination"></a>

```typescript
public readonly destination: IDeliveryStreamBackupDestination;
```

- *Type:* cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.BackupConfiguration.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---


### BasicColumn <a name="BasicColumn" id="cdk-extensions.glue.BasicColumn"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue.BasicColumn.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.BasicColumn(props: BasicColumnProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.BasicColumn.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.BasicColumnProps</code> | *No description.* |

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.BasicColumn.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.BasicColumnProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.BasicColumn.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.BasicColumn.bind"></a>

```typescript
public bind(scope: IConstruct): ColumnProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.BasicColumn.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.BasicColumn.property.typeString">typeString</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.BasicColumn.property.comment">comment</a></code> | <code>string</code> | A free-form text comment. |
| <code><a href="#cdk-extensions.glue.BasicColumn.property.name">name</a></code> | <code>string</code> | The name of the Column. |

---

##### `typeString`<sup>Required</sup> <a name="typeString" id="cdk-extensions.glue.BasicColumn.property.typeString"></a>

```typescript
public readonly typeString: string;
```

- *Type:* string

---

##### `comment`<sup>Optional</sup> <a name="comment" id="cdk-extensions.glue.BasicColumn.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

A free-form text comment.

> [[AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-comment)]([AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-comment))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.BasicColumn.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Column.

> [[AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-name)]([AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-name))

---


### BookmarkConfiguration <a name="BookmarkConfiguration" id="cdk-extensions.glue.BookmarkConfiguration"></a>

Controls the bookmark state of a Glue job.

> [[Using job bookmarks in AWS Glue](https://docs.aws.amazon.com/glue/latest/dg/monitor-continuations.html#monitor-continuations-implement)]([Using job bookmarks in AWS Glue](https://docs.aws.amazon.com/glue/latest/dg/monitor-continuations.html#monitor-continuations-implement))


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.BookmarkConfiguration.disable">disable</a></code> | Job bookmarks are not used, and the job always processes the entire dataset. |
| <code><a href="#cdk-extensions.glue.BookmarkConfiguration.enable">enable</a></code> | Causes the job to update the state after a run to keep track of previously processed data. |
| <code><a href="#cdk-extensions.glue.BookmarkConfiguration.of">of</a></code> | An escape hatch method that allows specifying arbitrary values for the `job-bookmark-option` argument of a Glue job. |
| <code><a href="#cdk-extensions.glue.BookmarkConfiguration.pause">pause</a></code> | Process incremental data since the last successful run or the data in a specified range, without updating the state of last bookmark. |

---

##### `disable` <a name="disable" id="cdk-extensions.glue.BookmarkConfiguration.disable"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.BookmarkConfiguration.disable()
```

Job bookmarks are not used, and the job always processes the entire dataset.

You are responsible for managing the output from previous job
runs.

##### `enable` <a name="enable" id="cdk-extensions.glue.BookmarkConfiguration.enable"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.BookmarkConfiguration.enable()
```

Causes the job to update the state after a run to keep track of previously processed data.

If your job has a source with job bookmark support, it
will keep track of processed data, and when a job runs, it processes new
data since the last checkpoint.

##### `of` <a name="of" id="cdk-extensions.glue.BookmarkConfiguration.of"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.BookmarkConfiguration.of(value: string, range?: BookmarkRange)
```

An escape hatch method that allows specifying arbitrary values for the `job-bookmark-option` argument of a Glue job.

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.BookmarkConfiguration.of.parameter.value"></a>

- *Type:* string

The value to pass to the `job-bookmark-option` argument.

---

###### `range`<sup>Optional</sup> <a name="range" id="cdk-extensions.glue.BookmarkConfiguration.of.parameter.range"></a>

- *Type:* cdk-extensions.glue.BookmarkRange

An optional range of job ID's that will correspond to the `job-bookmark-from` and `job-bookmark-to` arguments.

---

##### `pause` <a name="pause" id="cdk-extensions.glue.BookmarkConfiguration.pause"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.BookmarkConfiguration.pause(range?: BookmarkRange)
```

Process incremental data since the last successful run or the data in a specified range, without updating the state of last bookmark.

You are
responsible for managing the output from previous job runs.

###### `range`<sup>Optional</sup> <a name="range" id="cdk-extensions.glue.BookmarkConfiguration.pause.parameter.range"></a>

- *Type:* cdk-extensions.glue.BookmarkRange

The range of run ID's that should have their data processed.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.BookmarkConfiguration.property.value">value</a></code> | <code>string</code> | The value to pass to the `job-bookmark-option` argument. |
| <code><a href="#cdk-extensions.glue.BookmarkConfiguration.property.range">range</a></code> | <code>cdk-extensions.glue.BookmarkRange</code> | An optional range of job ID's that will correspond to the `job-bookmark-from` and `job-bookmark-to` arguments. |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.BookmarkConfiguration.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

The value to pass to the `job-bookmark-option` argument.

---

##### `range`<sup>Optional</sup> <a name="range" id="cdk-extensions.glue.BookmarkConfiguration.property.range"></a>

```typescript
public readonly range: BookmarkRange;
```

- *Type:* cdk-extensions.glue.BookmarkRange

An optional range of job ID's that will correspond to the `job-bookmark-from` and `job-bookmark-to` arguments.

---


### BufferingConfiguration <a name="BufferingConfiguration" id="cdk-extensions.kinesis_firehose.BufferingConfiguration"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.BufferingConfiguration.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.BufferingConfiguration(options: BufferingConfigurationOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BufferingConfiguration.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.BufferingConfigurationOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.BufferingConfiguration.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.BufferingConfigurationOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BufferingConfiguration.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.BufferingConfiguration.bind"></a>

```typescript
public bind(_scope: IConstruct): BufferingHintsProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.BufferingConfiguration.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.BufferingConfiguration.property.interval">interval</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.BufferingConfiguration.property.sizeInMb">sizeInMb</a></code> | <code>number</code> | *No description.* |

---

##### `interval`<sup>Optional</sup> <a name="interval" id="cdk-extensions.kinesis_firehose.BufferingConfiguration.property.interval"></a>

```typescript
public readonly interval: Duration;
```

- *Type:* aws-cdk-lib.Duration

---

##### `sizeInMb`<sup>Optional</sup> <a name="sizeInMb" id="cdk-extensions.kinesis_firehose.BufferingConfiguration.property.sizeInMb"></a>

```typescript
public readonly sizeInMb: number;
```

- *Type:* number

---


### CidrProvider <a name="CidrProvider" id="cdk-extensions.ec2.CidrProvider"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.CidrProvider.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.CidrProvider()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.CidrProvider.cidr">cidr</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.CidrProvider.ipamPool">ipamPool</a></code> | *No description.* |

---

##### `cidr` <a name="cidr" id="cdk-extensions.ec2.CidrProvider.cidr"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.CidrProvider.cidr(cidr: string)
```

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.CidrProvider.cidr.parameter.cidr"></a>

- *Type:* string

---

##### `ipamPool` <a name="ipamPool" id="cdk-extensions.ec2.CidrProvider.ipamPool"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.CidrProvider.ipamPool(pool: IIpamPool, netmask: number)
```

###### `pool`<sup>Required</sup> <a name="pool" id="cdk-extensions.ec2.CidrProvider.ipamPool.parameter.pool"></a>

- *Type:* cdk-extensions.ec2.IIpamPool

---

###### `netmask`<sup>Required</sup> <a name="netmask" id="cdk-extensions.ec2.CidrProvider.ipamPool.parameter.netmask"></a>

- *Type:* number

---



### ClassificationString <a name="ClassificationString" id="cdk-extensions.glue.ClassificationString"></a>

Classification string given to tables with this data format.

> [https://docs.aws.amazon.com/glue/latest/dg/add-classifier.html#classifier-built-in](https://docs.aws.amazon.com/glue/latest/dg/add-classifier.html#classifier-built-in)

#### Initializers <a name="Initializers" id="cdk-extensions.glue.ClassificationString.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.ClassificationString(value: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ClassificationString.Initializer.parameter.value">value</a></code> | <code>string</code> | *No description.* |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.ClassificationString.Initializer.parameter.value"></a>

- *Type:* string

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ClassificationString.property.value">value</a></code> | <code>string</code> | *No description.* |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.ClassificationString.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ClassificationString.property.AVRO">AVRO</a></code> | <code>cdk-extensions.glue.ClassificationString</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ClassificationString.property.CSV">CSV</a></code> | <code>cdk-extensions.glue.ClassificationString</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ClassificationString.property.JSON">JSON</a></code> | <code>cdk-extensions.glue.ClassificationString</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ClassificationString.property.ORC">ORC</a></code> | <code>cdk-extensions.glue.ClassificationString</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ClassificationString.property.PARQUET">PARQUET</a></code> | <code>cdk-extensions.glue.ClassificationString</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.ClassificationString.property.XML">XML</a></code> | <code>cdk-extensions.glue.ClassificationString</code> | *No description.* |

---

##### `AVRO`<sup>Required</sup> <a name="AVRO" id="cdk-extensions.glue.ClassificationString.property.AVRO"></a>

```typescript
public readonly AVRO: ClassificationString;
```

- *Type:* cdk-extensions.glue.ClassificationString

> [https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-avro](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-avro)

---

##### `CSV`<sup>Required</sup> <a name="CSV" id="cdk-extensions.glue.ClassificationString.property.CSV"></a>

```typescript
public readonly CSV: ClassificationString;
```

- *Type:* cdk-extensions.glue.ClassificationString

> [https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-csv](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-csv)

---

##### `JSON`<sup>Required</sup> <a name="JSON" id="cdk-extensions.glue.ClassificationString.property.JSON"></a>

```typescript
public readonly JSON: ClassificationString;
```

- *Type:* cdk-extensions.glue.ClassificationString

> [https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-json](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-json)

---

##### `ORC`<sup>Required</sup> <a name="ORC" id="cdk-extensions.glue.ClassificationString.property.ORC"></a>

```typescript
public readonly ORC: ClassificationString;
```

- *Type:* cdk-extensions.glue.ClassificationString

> [https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-orc](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-orc)

---

##### `PARQUET`<sup>Required</sup> <a name="PARQUET" id="cdk-extensions.glue.ClassificationString.property.PARQUET"></a>

```typescript
public readonly PARQUET: ClassificationString;
```

- *Type:* cdk-extensions.glue.ClassificationString

> [https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-parquet](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-parquet)

---

##### `XML`<sup>Required</sup> <a name="XML" id="cdk-extensions.glue.ClassificationString.property.XML"></a>

```typescript
public readonly XML: ClassificationString;
```

- *Type:* cdk-extensions.glue.ClassificationString

> [https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-xml](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-format.html#aws-glue-programming-etl-format-xml)

---

### CloudWatchLoggingConfiguration <a name="CloudWatchLoggingConfiguration" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.CloudWatchLoggingConfiguration(options: CloudWatchLoggingConfigurationOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.CloudWatchLoggingConfigurationOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.bind"></a>

```typescript
public bind(scope: IConstruct): CloudWatchLoggingOptionsProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.property.logStream">logStream</a></code> | <code>aws-cdk-lib.aws_logs.ILogStream</code> | *No description.* |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

---

##### `logStream`<sup>Optional</sup> <a name="logStream" id="cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration.property.logStream"></a>

```typescript
public readonly logStream: ILogStream;
```

- *Type:* aws-cdk-lib.aws_logs.ILogStream

---


### Code <a name="Code" id="cdk-extensions.glue.Code"></a>

Represents a Glue Job's Code assets (an asset can be a scripts, a jar, a python file or any other file).

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Code.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Code()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Code.bind">bind</a></code> | Called when the Job is initialized to allow this object to bind. |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.Code.bind"></a>

```typescript
public bind(scope: Construct, grantable: IGrantable): CodeConfig
```

Called when the Job is initialized to allow this object to bind.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Code.bind.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `grantable`<sup>Required</sup> <a name="grantable" id="cdk-extensions.glue.Code.bind.parameter.grantable"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Code.fromAsset">fromAsset</a></code> | Job code from a local disk path. |
| <code><a href="#cdk-extensions.glue.Code.fromBucket">fromBucket</a></code> | Job code as an S3 object. |

---

##### `fromAsset` <a name="fromAsset" id="cdk-extensions.glue.Code.fromAsset"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Code.fromAsset(path: string, options?: AssetOptions)
```

Job code from a local disk path.

###### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.glue.Code.fromAsset.parameter.path"></a>

- *Type:* string

Code file (not a directory).

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.Code.fromAsset.parameter.options"></a>

- *Type:* aws-cdk-lib.AssetOptions

---

##### `fromBucket` <a name="fromBucket" id="cdk-extensions.glue.Code.fromBucket"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.Code.fromBucket(bucket: IBucket, key: string)
```

Job code as an S3 object.

###### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue.Code.fromBucket.parameter.bucket"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucket

The S3 bucket.

---

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.Code.fromBucket.parameter.key"></a>

- *Type:* string

The object key.

---



### Column <a name="Column" id="cdk-extensions.glue.Column"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue.Column.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.Column(props: ColumnProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Column.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.ColumnProps</code> | *No description.* |

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.Column.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.ColumnProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.Column.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.Column.bind"></a>

```typescript
public bind(scope: IConstruct): ColumnProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.Column.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.Column.property.typeString">typeString</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.Column.property.comment">comment</a></code> | <code>string</code> | A free-form text comment. |
| <code><a href="#cdk-extensions.glue.Column.property.name">name</a></code> | <code>string</code> | The name of the Column. |

---

##### `typeString`<sup>Required</sup> <a name="typeString" id="cdk-extensions.glue.Column.property.typeString"></a>

```typescript
public readonly typeString: string;
```

- *Type:* string

---

##### `comment`<sup>Optional</sup> <a name="comment" id="cdk-extensions.glue.Column.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

A free-form text comment.

> [[AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-comment)]([AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-comment))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.Column.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Column.

> [[AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-name)]([AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-name))

---


### CustomerGatewayConfigurationRemoteVpnEndpoint <a name="CustomerGatewayConfigurationRemoteVpnEndpoint" id="cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint"></a>

- *Implements:* cdk-extensions.ec2.IRemoteVpnEndpoint

Specifies a remote VPN endpoint device by directly specifyingits details.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.CustomerGatewayConfigurationRemoteVpnEndpoint(configuration: CustomerGatewayProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.Initializer.parameter.configuration">configuration</a></code> | <code>cdk-extensions.ec2.CustomerGatewayProps</code> | The details of the device on the remote end of the VPN connection. |

---

##### `configuration`<sup>Required</sup> <a name="configuration" id="cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.Initializer.parameter.configuration"></a>

- *Type:* cdk-extensions.ec2.CustomerGatewayProps

The details of the device on the remote end of the VPN connection.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.bind">bind</a></code> | Produces a configuration that can be used when configuring the remote end of a VPN connection. |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.bind"></a>

```typescript
public bind(scope: IConstruct): RemoteVpnEndpointConfiguration
```

Produces a configuration that can be used when configuring the remote end of a VPN connection.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the VPN connection that will be referencing the remote endpoint.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.property.configuration">configuration</a></code> | <code>cdk-extensions.ec2.CustomerGatewayProps</code> | The details of the device on the remote end of the VPN connection. |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.property.customerGateway">customerGateway</a></code> | <code>cdk-extensions.ec2.CustomerGateway</code> | The customer gateway that was created to represent the device on the remote end of the VPN connection. |

---

##### `configuration`<sup>Required</sup> <a name="configuration" id="cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.property.configuration"></a>

```typescript
public readonly configuration: CustomerGatewayProps;
```

- *Type:* cdk-extensions.ec2.CustomerGatewayProps

The details of the device on the remote end of the VPN connection.

---

##### `customerGateway`<sup>Optional</sup> <a name="customerGateway" id="cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint.property.customerGateway"></a>

```typescript
public readonly customerGateway: CustomerGateway;
```

- *Type:* cdk-extensions.ec2.CustomerGateway

The customer gateway that was created to represent the device on the remote end of the VPN connection.

---


### CustomerGatewayRemoteVpnEndpoint <a name="CustomerGatewayRemoteVpnEndpoint" id="cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint"></a>

- *Implements:* cdk-extensions.ec2.IRemoteVpnEndpoint

Specifies a remote VPN endpoint device that has its details configured in an existing customer gateway.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.CustomerGatewayRemoteVpnEndpoint(customerGateway: ICustomerGateway)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint.Initializer.parameter.customerGateway">customerGateway</a></code> | <code>cdk-extensions.ec2.ICustomerGateway</code> | The customer gateway that is configured with the details of the remote endpoint device. |

---

##### `customerGateway`<sup>Required</sup> <a name="customerGateway" id="cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint.Initializer.parameter.customerGateway"></a>

- *Type:* cdk-extensions.ec2.ICustomerGateway

The customer gateway that is configured with the details of the remote endpoint device.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint.bind">bind</a></code> | Produces a configuration that can be used when configuring the remote end of a VPN connection. |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint.bind"></a>

```typescript
public bind(_scope: IConstruct): RemoteVpnEndpointConfiguration
```

Produces a configuration that can be used when configuring the remote end of a VPN connection.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the VPN connection that will be referencing the remote endpoint.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint.property.customerGateway">customerGateway</a></code> | <code>cdk-extensions.ec2.ICustomerGateway</code> | The customer gateway that is configured with the details of the remote endpoint device. |

---

##### `customerGateway`<sup>Required</sup> <a name="customerGateway" id="cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint.property.customerGateway"></a>

```typescript
public readonly customerGateway: ICustomerGateway;
```

- *Type:* cdk-extensions.ec2.ICustomerGateway

The customer gateway that is configured with the details of the remote endpoint device.

---


### CustomProcessor <a name="CustomProcessor" id="cdk-extensions.kinesis_firehose.CustomProcessor"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.CustomProcessor.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.CustomProcessor(options: CustomProcessorOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CustomProcessor.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.CustomProcessorOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.CustomProcessor.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.CustomProcessorOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CustomProcessor.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.CustomProcessor.addParameter">addParameter</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.CustomProcessor.bind"></a>

```typescript
public bind(_scope: IConstruct): ProcessorProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.CustomProcessor.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

##### `addParameter` <a name="addParameter" id="cdk-extensions.kinesis_firehose.CustomProcessor.addParameter"></a>

```typescript
public addParameter(name: string, value: string): void
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.kinesis_firehose.CustomProcessor.addParameter.parameter.name"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.kinesis_firehose.CustomProcessor.addParameter.parameter.value"></a>

- *Type:* string

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.CustomProcessor.property.processorType">processorType</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |

---

##### `processorType`<sup>Required</sup> <a name="processorType" id="cdk-extensions.kinesis_firehose.CustomProcessor.property.processorType"></a>

```typescript
public readonly processorType: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---


### DatabaseProxyEndpointAccess <a name="DatabaseProxyEndpointAccess" id="cdk-extensions.rds.DatabaseProxyEndpointAccess"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointAccess.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk-extensions.rds.DatabaseProxyEndpointAccess.of"></a>

```typescript
import { rds } from 'cdk-extensions'

rds.DatabaseProxyEndpointAccess.of(role: string)
```

###### `role`<sup>Required</sup> <a name="role" id="cdk-extensions.rds.DatabaseProxyEndpointAccess.of.parameter.role"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointAccess.property.role">role</a></code> | <code>string</code> | *No description.* |

---

##### `role`<sup>Required</sup> <a name="role" id="cdk-extensions.rds.DatabaseProxyEndpointAccess.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointAccess.property.READ_ONLY">READ_ONLY</a></code> | <code>cdk-extensions.rds.DatabaseProxyEndpointAccess</code> | *No description.* |
| <code><a href="#cdk-extensions.rds.DatabaseProxyEndpointAccess.property.READ_WRITE">READ_WRITE</a></code> | <code>cdk-extensions.rds.DatabaseProxyEndpointAccess</code> | *No description.* |

---

##### `READ_ONLY`<sup>Required</sup> <a name="READ_ONLY" id="cdk-extensions.rds.DatabaseProxyEndpointAccess.property.READ_ONLY"></a>

```typescript
public readonly READ_ONLY: DatabaseProxyEndpointAccess;
```

- *Type:* cdk-extensions.rds.DatabaseProxyEndpointAccess

---

##### `READ_WRITE`<sup>Required</sup> <a name="READ_WRITE" id="cdk-extensions.rds.DatabaseProxyEndpointAccess.property.READ_WRITE"></a>

```typescript
public readonly READ_WRITE: DatabaseProxyEndpointAccess;
```

- *Type:* cdk-extensions.rds.DatabaseProxyEndpointAccess

---

### DataFormat <a name="DataFormat" id="cdk-extensions.glue.DataFormat"></a>

Defines the input/output formats and ser/de for a single DataFormat.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.DataFormat.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.DataFormat(props: DataFormatProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.DataFormat.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.DataFormatProps</code> | *No description.* |

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.DataFormat.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.DataFormatProps

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.DataFormat.property.inputFormat">inputFormat</a></code> | <code>cdk-extensions.glue.InputFormat</code> | `InputFormat` for this data format. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.outputFormat">outputFormat</a></code> | <code>cdk-extensions.glue.OutputFormat</code> | `OutputFormat` for this data format. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.serializationLibrary">serializationLibrary</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | Serialization library for this data format. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.classificationString">classificationString</a></code> | <code>cdk-extensions.glue.ClassificationString</code> | Classification string given to tables with this data format. |

---

##### `inputFormat`<sup>Required</sup> <a name="inputFormat" id="cdk-extensions.glue.DataFormat.property.inputFormat"></a>

```typescript
public readonly inputFormat: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

`InputFormat` for this data format.

---

##### `outputFormat`<sup>Required</sup> <a name="outputFormat" id="cdk-extensions.glue.DataFormat.property.outputFormat"></a>

```typescript
public readonly outputFormat: OutputFormat;
```

- *Type:* cdk-extensions.glue.OutputFormat

`OutputFormat` for this data format.

---

##### `serializationLibrary`<sup>Required</sup> <a name="serializationLibrary" id="cdk-extensions.glue.DataFormat.property.serializationLibrary"></a>

```typescript
public readonly serializationLibrary: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

Serialization library for this data format.

---

##### `classificationString`<sup>Optional</sup> <a name="classificationString" id="cdk-extensions.glue.DataFormat.property.classificationString"></a>

```typescript
public readonly classificationString: ClassificationString;
```

- *Type:* cdk-extensions.glue.ClassificationString

Classification string given to tables with this data format.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.DataFormat.property.APACHE_LOGS">APACHE_LOGS</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat for Apache Web Server Logs. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.AVRO">AVRO</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat for Apache Avro. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.CLOUDTRAIL_LOGS">CLOUDTRAIL_LOGS</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat for CloudTrail logs stored on S3. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.CSV">CSV</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat for CSV Files. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.JSON">JSON</a></code> | <code>cdk-extensions.glue.DataFormat</code> | Stored as plain text files in JSON format. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.LOGSTASH">LOGSTASH</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat for Logstash Logs, using the GROK SerDe. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.ORC">ORC</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat for Apache ORC (Optimized Row Columnar). |
| <code><a href="#cdk-extensions.glue.DataFormat.property.PARQUET">PARQUET</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat for Apache Parquet. |
| <code><a href="#cdk-extensions.glue.DataFormat.property.TSV">TSV</a></code> | <code>cdk-extensions.glue.DataFormat</code> | DataFormat for TSV (Tab-Separated Values). |

---

##### `APACHE_LOGS`<sup>Required</sup> <a name="APACHE_LOGS" id="cdk-extensions.glue.DataFormat.property.APACHE_LOGS"></a>

```typescript
public readonly APACHE_LOGS: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat for Apache Web Server Logs.

Also works for CloudFront logs

> [https://docs.aws.amazon.com/athena/latest/ug/apache.html](https://docs.aws.amazon.com/athena/latest/ug/apache.html)

---

##### `AVRO`<sup>Required</sup> <a name="AVRO" id="cdk-extensions.glue.DataFormat.property.AVRO"></a>

```typescript
public readonly AVRO: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat for Apache Avro.

> [https://docs.aws.amazon.com/athena/latest/ug/avro.html](https://docs.aws.amazon.com/athena/latest/ug/avro.html)

---

##### `CLOUDTRAIL_LOGS`<sup>Required</sup> <a name="CLOUDTRAIL_LOGS" id="cdk-extensions.glue.DataFormat.property.CLOUDTRAIL_LOGS"></a>

```typescript
public readonly CLOUDTRAIL_LOGS: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat for CloudTrail logs stored on S3.

> [https://docs.aws.amazon.com/athena/latest/ug/cloudtrail.html](https://docs.aws.amazon.com/athena/latest/ug/cloudtrail.html)

---

##### `CSV`<sup>Required</sup> <a name="CSV" id="cdk-extensions.glue.DataFormat.property.CSV"></a>

```typescript
public readonly CSV: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat for CSV Files.

> [https://docs.aws.amazon.com/athena/latest/ug/csv.html](https://docs.aws.amazon.com/athena/latest/ug/csv.html)

---

##### `JSON`<sup>Required</sup> <a name="JSON" id="cdk-extensions.glue.DataFormat.property.JSON"></a>

```typescript
public readonly JSON: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

Stored as plain text files in JSON format.

Uses OpenX Json SerDe for serialization and deseralization.

> [https://docs.aws.amazon.com/athena/latest/ug/json.html](https://docs.aws.amazon.com/athena/latest/ug/json.html)

---

##### `LOGSTASH`<sup>Required</sup> <a name="LOGSTASH" id="cdk-extensions.glue.DataFormat.property.LOGSTASH"></a>

```typescript
public readonly LOGSTASH: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat for Logstash Logs, using the GROK SerDe.

> [https://docs.aws.amazon.com/athena/latest/ug/grok.html](https://docs.aws.amazon.com/athena/latest/ug/grok.html)

---

##### `ORC`<sup>Required</sup> <a name="ORC" id="cdk-extensions.glue.DataFormat.property.ORC"></a>

```typescript
public readonly ORC: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat for Apache ORC (Optimized Row Columnar).

> [https://docs.aws.amazon.com/athena/latest/ug/orc.html](https://docs.aws.amazon.com/athena/latest/ug/orc.html)

---

##### `PARQUET`<sup>Required</sup> <a name="PARQUET" id="cdk-extensions.glue.DataFormat.property.PARQUET"></a>

```typescript
public readonly PARQUET: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat for Apache Parquet.

> [https://docs.aws.amazon.com/athena/latest/ug/parquet.html](https://docs.aws.amazon.com/athena/latest/ug/parquet.html)

---

##### `TSV`<sup>Required</sup> <a name="TSV" id="cdk-extensions.glue.DataFormat.property.TSV"></a>

```typescript
public readonly TSV: DataFormat;
```

- *Type:* cdk-extensions.glue.DataFormat

DataFormat for TSV (Tab-Separated Values).

> [https://docs.aws.amazon.com/athena/latest/ug/lazy-simple-serde.html](https://docs.aws.amazon.com/athena/latest/ug/lazy-simple-serde.html)

---

### DataFormatConversion <a name="DataFormatConversion" id="cdk-extensions.kinesis_firehose.DataFormatConversion"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.DataFormatConversion.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.DataFormatConversion(options: DataFormatConversionOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.DataFormatConversionOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.DataFormatConversion.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.DataFormatConversionOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.DataFormatConversion.bind"></a>

```typescript
public bind(scope: IConstruct): DataFormatConversionConfigurationProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.DataFormatConversion.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.database">database</a></code> | <code>cdk-extensions.glue.Database</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.inputFormat">inputFormat</a></code> | <code>cdk-extensions.kinesis_firehose.InputFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.outputFormat">outputFormat</a></code> | <code>cdk-extensions.kinesis_firehose.OutputFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.table">table</a></code> | <code>cdk-extensions.glue.Table</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.catalogId">catalogId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.region">region</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DataFormatConversion.property.version">version</a></code> | <code>cdk-extensions.kinesis_firehose.TableVersion</code> | *No description.* |

---

##### `database`<sup>Required</sup> <a name="database" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.database"></a>

```typescript
public readonly database: Database;
```

- *Type:* cdk-extensions.glue.Database

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `inputFormat`<sup>Required</sup> <a name="inputFormat" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.inputFormat"></a>

```typescript
public readonly inputFormat: InputFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.InputFormat

---

##### `outputFormat`<sup>Required</sup> <a name="outputFormat" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.outputFormat"></a>

```typescript
public readonly outputFormat: OutputFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.OutputFormat

---

##### `table`<sup>Required</sup> <a name="table" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.table"></a>

```typescript
public readonly table: Table;
```

- *Type:* cdk-extensions.glue.Table

---

##### `catalogId`<sup>Optional</sup> <a name="catalogId" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.catalogId"></a>

```typescript
public readonly catalogId: string;
```

- *Type:* string

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `version`<sup>Optional</sup> <a name="version" id="cdk-extensions.kinesis_firehose.DataFormatConversion.property.version"></a>

```typescript
public readonly version: TableVersion;
```

- *Type:* cdk-extensions.kinesis_firehose.TableVersion

---


### DataSize <a name="DataSize" id="cdk-extensions.core.DataSize"></a>

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.core.DataSize.toBytes">toBytes</a></code> | Convert the DataSize object to the byte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toGibibytes">toGibibytes</a></code> | Convert the DataSize object to its gibibyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toGigabytes">toGigabytes</a></code> | Convert the DataSize object to its gigabyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toKibibytes">toKibibytes</a></code> | Convert the DataSize object to its kibibyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toKilobytes">toKilobytes</a></code> | Convert the DataSize object to its kilobyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toMebibytes">toMebibytes</a></code> | Convert the DataSize object to its mebibyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toMegabytes">toMegabytes</a></code> | Convert the DataSize object to its megabyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toPebibytes">toPebibytes</a></code> | Convert the DataSize object to its pebibyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toPetabytes">toPetabytes</a></code> | Convert the DataSize object to its petabyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toTebibytes">toTebibytes</a></code> | Convert the DataSize object to its tebibyte representation. |
| <code><a href="#cdk-extensions.core.DataSize.toTerabytes">toTerabytes</a></code> | Convert the DataSize object to its terabyte representation. |

---

##### `toBytes` <a name="toBytes" id="cdk-extensions.core.DataSize.toBytes"></a>

```typescript
public toBytes(): number
```

Convert the DataSize object to the byte representation.

##### `toGibibytes` <a name="toGibibytes" id="cdk-extensions.core.DataSize.toGibibytes"></a>

```typescript
public toGibibytes(): number
```

Convert the DataSize object to its gibibyte representation.

If the data size doesn't fit evently into gibibytes it will be rounded
up to the closest gibibyte which will be required to hold all the data.

##### `toGigabytes` <a name="toGigabytes" id="cdk-extensions.core.DataSize.toGigabytes"></a>

```typescript
public toGigabytes(): number
```

Convert the DataSize object to its gigabyte representation.

If the data size doesn't fit evently into gigabytes it will be rounded
up to the closest gigabyte which will be required to hold all the data.

##### `toKibibytes` <a name="toKibibytes" id="cdk-extensions.core.DataSize.toKibibytes"></a>

```typescript
public toKibibytes(): number
```

Convert the DataSize object to its kibibyte representation.

If the data size doesn't fit evently into kibibytes it will be rounded
up to the closest kibibyte which will be required to hold all the data.

##### `toKilobytes` <a name="toKilobytes" id="cdk-extensions.core.DataSize.toKilobytes"></a>

```typescript
public toKilobytes(): number
```

Convert the DataSize object to its kilobyte representation.

If the data size doesn't fit evently into kilobytes it will be rounded
up to the closest kilobyte which will be required to hold all the data.

##### `toMebibytes` <a name="toMebibytes" id="cdk-extensions.core.DataSize.toMebibytes"></a>

```typescript
public toMebibytes(): number
```

Convert the DataSize object to its mebibyte representation.

If the data size doesn't fit evently into mebibytes it will be rounded
up to the closest mebibyte which will be required to hold all the data.

##### `toMegabytes` <a name="toMegabytes" id="cdk-extensions.core.DataSize.toMegabytes"></a>

```typescript
public toMegabytes(): number
```

Convert the DataSize object to its megabyte representation.

If the data size doesn't fit evently into megabytes it will be rounded
up to the closest megabyte which will be required to hold all the data.

##### `toPebibytes` <a name="toPebibytes" id="cdk-extensions.core.DataSize.toPebibytes"></a>

```typescript
public toPebibytes(): number
```

Convert the DataSize object to its pebibyte representation.

If the data size doesn't fit evently into pebibytes it will be rounded
up to the closest pebibyte which will be required to hold all the data.

##### `toPetabytes` <a name="toPetabytes" id="cdk-extensions.core.DataSize.toPetabytes"></a>

```typescript
public toPetabytes(): number
```

Convert the DataSize object to its petabyte representation.

If the data size doesn't fit evently into petabytes it will be rounded
up to the closest petabyte which will be required to hold all the data.

##### `toTebibytes` <a name="toTebibytes" id="cdk-extensions.core.DataSize.toTebibytes"></a>

```typescript
public toTebibytes(): number
```

Convert the DataSize object to its tebibyte representation.

If the data size doesn't fit evently into tebibytes it will be rounded
up to the closest tebibyte which will be required to hold all the data.

##### `toTerabytes` <a name="toTerabytes" id="cdk-extensions.core.DataSize.toTerabytes"></a>

```typescript
public toTerabytes(): number
```

Convert the DataSize object to its terabyte representation.

If the data size doesn't fit evently into terabytes it will be rounded
up to the closest terabyte which will be required to hold all the data.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.core.DataSize.bytes">bytes</a></code> | Create a `DataSize` representing an amount of bytes. |
| <code><a href="#cdk-extensions.core.DataSize.gibibytes">gibibytes</a></code> | Create a `DataSize` representing an amount of gibibytes. |
| <code><a href="#cdk-extensions.core.DataSize.gigabytes">gigabytes</a></code> | Create a `DataSize` representing an amount of gigabytes. |
| <code><a href="#cdk-extensions.core.DataSize.kibibytes">kibibytes</a></code> | Create a `DataSize` representing an amount of kibibytes. |
| <code><a href="#cdk-extensions.core.DataSize.kilobytes">kilobytes</a></code> | Create a `DataSize` representing an amount of kilobytes. |
| <code><a href="#cdk-extensions.core.DataSize.mebibytes">mebibytes</a></code> | Create a `DataSize` representing an amount of mebibytes. |
| <code><a href="#cdk-extensions.core.DataSize.megabytes">megabytes</a></code> | Create a `DataSize` representing an amount of megabytes. |
| <code><a href="#cdk-extensions.core.DataSize.pebibytes">pebibytes</a></code> | Create a `DataSize` representing an amount of pebibytes. |
| <code><a href="#cdk-extensions.core.DataSize.petabytes">petabytes</a></code> | Create a `DataSize` representing an amount of petabytes. |
| <code><a href="#cdk-extensions.core.DataSize.tebibytes">tebibytes</a></code> | Create a `DataSize` representing an amount of tebibytes. |
| <code><a href="#cdk-extensions.core.DataSize.terabytes">terabytes</a></code> | Create a `DataSize` representing an amount of terabytes. |

---

##### `bytes` <a name="bytes" id="cdk-extensions.core.DataSize.bytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.bytes(bytes: number)
```

Create a `DataSize` representing an amount of bytes.

###### `bytes`<sup>Required</sup> <a name="bytes" id="cdk-extensions.core.DataSize.bytes.parameter.bytes"></a>

- *Type:* number

The number of bytes this `DataSize` will represent.

---

##### `gibibytes` <a name="gibibytes" id="cdk-extensions.core.DataSize.gibibytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.gibibytes(gibibytes: number)
```

Create a `DataSize` representing an amount of gibibytes.

###### `gibibytes`<sup>Required</sup> <a name="gibibytes" id="cdk-extensions.core.DataSize.gibibytes.parameter.gibibytes"></a>

- *Type:* number

The number of gibibytes this `DataSize` will represent.

---

##### `gigabytes` <a name="gigabytes" id="cdk-extensions.core.DataSize.gigabytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.gigabytes(gigabytes: number)
```

Create a `DataSize` representing an amount of gigabytes.

###### `gigabytes`<sup>Required</sup> <a name="gigabytes" id="cdk-extensions.core.DataSize.gigabytes.parameter.gigabytes"></a>

- *Type:* number

The number of gigabytes this `DataSize` will represent.

---

##### `kibibytes` <a name="kibibytes" id="cdk-extensions.core.DataSize.kibibytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.kibibytes(kibibytes: number)
```

Create a `DataSize` representing an amount of kibibytes.

###### `kibibytes`<sup>Required</sup> <a name="kibibytes" id="cdk-extensions.core.DataSize.kibibytes.parameter.kibibytes"></a>

- *Type:* number

The number of kibibytes this `DataSize` will represent.

---

##### `kilobytes` <a name="kilobytes" id="cdk-extensions.core.DataSize.kilobytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.kilobytes(kilobytes: number)
```

Create a `DataSize` representing an amount of kilobytes.

###### `kilobytes`<sup>Required</sup> <a name="kilobytes" id="cdk-extensions.core.DataSize.kilobytes.parameter.kilobytes"></a>

- *Type:* number

The number of kilobytes this `DataSize` will represent.

---

##### `mebibytes` <a name="mebibytes" id="cdk-extensions.core.DataSize.mebibytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.mebibytes(mebibytes: number)
```

Create a `DataSize` representing an amount of mebibytes.

###### `mebibytes`<sup>Required</sup> <a name="mebibytes" id="cdk-extensions.core.DataSize.mebibytes.parameter.mebibytes"></a>

- *Type:* number

The number of mebibytes this `DataSize` will represent.

---

##### `megabytes` <a name="megabytes" id="cdk-extensions.core.DataSize.megabytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.megabytes(megabytes: number)
```

Create a `DataSize` representing an amount of megabytes.

###### `megabytes`<sup>Required</sup> <a name="megabytes" id="cdk-extensions.core.DataSize.megabytes.parameter.megabytes"></a>

- *Type:* number

The number of megabytes this `DataSize` will represent.

---

##### `pebibytes` <a name="pebibytes" id="cdk-extensions.core.DataSize.pebibytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.pebibytes(pebibytes: number)
```

Create a `DataSize` representing an amount of pebibytes.

###### `pebibytes`<sup>Required</sup> <a name="pebibytes" id="cdk-extensions.core.DataSize.pebibytes.parameter.pebibytes"></a>

- *Type:* number

The number of pebibytes this `DataSize` will represent.

---

##### `petabytes` <a name="petabytes" id="cdk-extensions.core.DataSize.petabytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.petabytes(petabytes: number)
```

Create a `DataSize` representing an amount of petabytes.

###### `petabytes`<sup>Required</sup> <a name="petabytes" id="cdk-extensions.core.DataSize.petabytes.parameter.petabytes"></a>

- *Type:* number

The number of petabytes this `DataSize` will represent.

---

##### `tebibytes` <a name="tebibytes" id="cdk-extensions.core.DataSize.tebibytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.tebibytes(tebibytes: number)
```

Create a `DataSize` representing an amount of tebibytes.

###### `tebibytes`<sup>Required</sup> <a name="tebibytes" id="cdk-extensions.core.DataSize.tebibytes.parameter.tebibytes"></a>

- *Type:* number

The number of tebibytes this `DataSize` will represent.

---

##### `terabytes` <a name="terabytes" id="cdk-extensions.core.DataSize.terabytes"></a>

```typescript
import { core } from 'cdk-extensions'

core.DataSize.terabytes(terabytes: number)
```

Create a `DataSize` representing an amount of terabytes.

###### `terabytes`<sup>Required</sup> <a name="terabytes" id="cdk-extensions.core.DataSize.terabytes.parameter.terabytes"></a>

- *Type:* number

The number of terabytes this `DataSize` will represent.

---



### DeliveryStreamDestination <a name="DeliveryStreamDestination" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestination"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestination.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.DeliveryStreamDestination()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestination.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestination.bind"></a>

```typescript
public bind(scope: IConstruct): DeliveryStreamDestinationConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestination.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamDestination.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.DeliveryStreamDestination.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---


### DeliveryStreamProcessor <a name="DeliveryStreamProcessor" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessor"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessor.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.DeliveryStreamProcessor(options: DeliveryStreamProcessorOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProcessor.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamProcessorOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessor.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProcessorOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProcessor.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessor.bind"></a>

```typescript
public bind(_scope: IConstruct): ProcessorProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessor.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamProcessor.property.processorType">processorType</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |

---

##### `processorType`<sup>Required</sup> <a name="processorType" id="cdk-extensions.kinesis_firehose.DeliveryStreamProcessor.property.processorType"></a>

```typescript
public readonly processorType: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---


### Domain <a name="Domain" id="cdk-extensions.route53.Domain"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.route53.Domain.Initializer"></a>

```typescript
import { route53 } from 'cdk-extensions'

new route53.Domain(zone: IHostedZone, isPublic: boolean, options?: DomainOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.route53.Domain.Initializer.parameter.zone">zone</a></code> | <code>aws-cdk-lib.aws_route53.IHostedZone</code> | *No description.* |
| <code><a href="#cdk-extensions.route53.Domain.Initializer.parameter.isPublic">isPublic</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.route53.Domain.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.route53.DomainOptions</code> | *No description.* |

---

##### `zone`<sup>Required</sup> <a name="zone" id="cdk-extensions.route53.Domain.Initializer.parameter.zone"></a>

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

---

##### `isPublic`<sup>Required</sup> <a name="isPublic" id="cdk-extensions.route53.Domain.Initializer.parameter.isPublic"></a>

- *Type:* boolean

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.route53.Domain.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.route53.DomainOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.route53.Domain.visit">visit</a></code> | *No description.* |

---

##### `visit` <a name="visit" id="cdk-extensions.route53.Domain.visit"></a>

```typescript
public visit(node: IConstruct): void
```

###### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.route53.Domain.visit.parameter.node"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.route53.Domain.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.route53.Domain.property.isPublic">isPublic</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.route53.Domain.property.zone">zone</a></code> | <code>aws-cdk-lib.aws_route53.IHostedZone</code> | *No description.* |
| <code><a href="#cdk-extensions.route53.Domain.property.zoneName">zoneName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.route53.Domain.property.certificate">certificate</a></code> | <code>aws-cdk-lib.aws_certificatemanager.ICertificate</code> | *No description.* |
| <code><a href="#cdk-extensions.route53.Domain.property.subdomain">subdomain</a></code> | <code>string</code> | *No description.* |

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="cdk-extensions.route53.Domain.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `isPublic`<sup>Required</sup> <a name="isPublic" id="cdk-extensions.route53.Domain.property.isPublic"></a>

```typescript
public readonly isPublic: boolean;
```

- *Type:* boolean

---

##### `zone`<sup>Required</sup> <a name="zone" id="cdk-extensions.route53.Domain.property.zone"></a>

```typescript
public readonly zone: IHostedZone;
```

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

---

##### `zoneName`<sup>Required</sup> <a name="zoneName" id="cdk-extensions.route53.Domain.property.zoneName"></a>

```typescript
public readonly zoneName: string;
```

- *Type:* string

---

##### `certificate`<sup>Optional</sup> <a name="certificate" id="cdk-extensions.route53.Domain.property.certificate"></a>

```typescript
public readonly certificate: ICertificate;
```

- *Type:* aws-cdk-lib.aws_certificatemanager.ICertificate

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk-extensions.route53.Domain.property.subdomain"></a>

```typescript
public readonly subdomain: string;
```

- *Type:* string

---


### DomainManager <a name="DomainManager" id="cdk-extensions.route53.DomainManager"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.route53.DomainManager.Initializer"></a>

```typescript
import { route53 } from 'cdk-extensions'

new route53.DomainManager()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.route53.DomainManager.isDnsResolvable">isDnsResolvable</a></code> | *No description.* |

---

##### `isDnsResolvable` <a name="isDnsResolvable" id="cdk-extensions.route53.DomainManager.isDnsResolvable"></a>

```typescript
import { route53 } from 'cdk-extensions'

route53.DomainManager.isDnsResolvable(node: IConstruct)
```

###### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.route53.DomainManager.isDnsResolvable.parameter.node"></a>

- *Type:* constructs.IConstruct

---



### Domains <a name="Domains" id="cdk-extensions.route53.Domains"></a>

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.route53.Domains.add">add</a></code> | *No description.* |

---

##### `add` <a name="add" id="cdk-extensions.route53.Domains.add"></a>

```typescript
public add(hostedZone: IHostedZone, isPublic: boolean, options?: DomainOptions): void
```

###### `hostedZone`<sup>Required</sup> <a name="hostedZone" id="cdk-extensions.route53.Domains.add.parameter.hostedZone"></a>

- *Type:* aws-cdk-lib.aws_route53.IHostedZone

---

###### `isPublic`<sup>Required</sup> <a name="isPublic" id="cdk-extensions.route53.Domains.add.parameter.isPublic"></a>

- *Type:* boolean

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.route53.Domains.add.parameter.options"></a>

- *Type:* cdk-extensions.route53.DomainOptions

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.route53.Domains.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk-extensions.route53.Domains.of"></a>

```typescript
import { route53 } from 'cdk-extensions'

route53.Domains.of(scope: IConstruct)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.route53.Domains.of.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.route53.Domains.property.ROOT">ROOT</a></code> | <code>string</code> | *No description.* |

---

##### `ROOT`<sup>Required</sup> <a name="ROOT" id="cdk-extensions.route53.Domains.property.ROOT"></a>

```typescript
public readonly ROOT: string;
```

- *Type:* string

---

### DynamicPartitioning <a name="DynamicPartitioning" id="cdk-extensions.kinesis_firehose.DynamicPartitioning"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.DynamicPartitioning(options: CommonPartitioningOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DynamicPartitioning.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.CommonPartitioningOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.CommonPartitioningOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DynamicPartitioning.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.bind"></a>

```typescript
public bind(_scope: IConstruct): DynamicPartitioningConfiguration
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DynamicPartitioning.fromJson">fromJson</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DynamicPartitioning.fromLambda">fromLambda</a></code> | *No description.* |

---

##### `fromJson` <a name="fromJson" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.fromJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.DynamicPartitioning.fromJson(options: JsonPartitioningOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.fromJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.JsonPartitioningOptions

---

##### `fromLambda` <a name="fromLambda" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.fromLambda"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.DynamicPartitioning.fromLambda(options: LambdaPartitioningOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.fromLambda.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.LambdaPartitioningOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DynamicPartitioning.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DynamicPartitioning.property.retryInterval">retryInterval</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `retryInterval`<sup>Optional</sup> <a name="retryInterval" id="cdk-extensions.kinesis_firehose.DynamicPartitioning.property.retryInterval"></a>

```typescript
public readonly retryInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

---


### ElasticsearchOutputBufferSize <a name="ElasticsearchOutputBufferSize" id="cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize"></a>

Represents the size of the Elasticsearch output buffer to be used by Fluent Bit.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.bytes">bytes</a></code> | Set the output buffer to a specified data size. |
| <code><a href="#cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.of">of</a></code> | An escape hatch that allows an arbitrary value to be set for the Elasticsearch buffer output property. |

---

##### `bytes` <a name="bytes" id="cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.bytes"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ElasticsearchOutputBufferSize.bytes(size: DataSize)
```

Set the output buffer to a specified data size.

###### `size`<sup>Required</sup> <a name="size" id="cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.bytes.parameter.size"></a>

- *Type:* cdk-extensions.core.DataSize

The size of the output buffer.

---

##### `of` <a name="of" id="cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.of"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ElasticsearchOutputBufferSize.of(value: string)
```

An escape hatch that allows an arbitrary value to be set for the Elasticsearch buffer output property.

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.of.parameter.value"></a>

- *Type:* string

The value to use for the Elasticsearch buffer output property.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.property.value">value</a></code> | <code>string</code> | The value to use for the Elasticsearch buffer output property. |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

The value to use for the Elasticsearch buffer output property.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.property.UNLIMITED">UNLIMITED</a></code> | <code>cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize</code> | Set the output buffer size to unlimited. |

---

##### `UNLIMITED`<sup>Required</sup> <a name="UNLIMITED" id="cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize.property.UNLIMITED"></a>

```typescript
public readonly UNLIMITED: ElasticsearchOutputBufferSize;
```

- *Type:* cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize

Set the output buffer size to unlimited.

---

### EmitterStorageType <a name="EmitterStorageType" id="cdk-extensions.k8s_aws.EmitterStorageType"></a>

Define a buffering mechanism for the new records created by the rewrite tag Fluent Bit filter plugin.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.EmitterStorageType.of">of</a></code> | An escape hatch that allows for specifying a custom value for the rewrite tag plugin's `Emitter_Storage.type` field. |

---

##### `of` <a name="of" id="cdk-extensions.k8s_aws.EmitterStorageType.of"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.EmitterStorageType.of(name: string)
```

An escape hatch that allows for specifying a custom value for the rewrite tag plugin's `Emitter_Storage.type` field.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.EmitterStorageType.of.parameter.name"></a>

- *Type:* string

The name of the buffering type to use.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.EmitterStorageType.property.name">name</a></code> | <code>string</code> | The name of the emitter storage type as it should appear in the plugin configuration file. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.EmitterStorageType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the emitter storage type as it should appear in the plugin configuration file.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.EmitterStorageType.property.FILESYSTEM">FILESYSTEM</a></code> | <code>cdk-extensions.k8s_aws.EmitterStorageType</code> | Buffer records on the filesystem. |
| <code><a href="#cdk-extensions.k8s_aws.EmitterStorageType.property.MEMORY">MEMORY</a></code> | <code>cdk-extensions.k8s_aws.EmitterStorageType</code> | Buffer records in memory. |

---

##### `FILESYSTEM`<sup>Required</sup> <a name="FILESYSTEM" id="cdk-extensions.k8s_aws.EmitterStorageType.property.FILESYSTEM"></a>

```typescript
public readonly FILESYSTEM: EmitterStorageType;
```

- *Type:* cdk-extensions.k8s_aws.EmitterStorageType

Buffer records on the filesystem.

This is recommended if the destination for new records generated might
face backpressure due to latency or slow network speeds.

---

##### `MEMORY`<sup>Required</sup> <a name="MEMORY" id="cdk-extensions.k8s_aws.EmitterStorageType.property.MEMORY"></a>

```typescript
public readonly MEMORY: EmitterStorageType;
```

- *Type:* cdk-extensions.k8s_aws.EmitterStorageType

Buffer records in memory.

This is the default behavior.

---

### ExtendedS3Destination <a name="ExtendedS3Destination" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.ExtendedS3Destination(bucket: IBucket, options?: ExtendedS3DestinationOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.Initializer.parameter.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions</code> | *No description.* |

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.Initializer.parameter.bucket"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucket

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.ExtendedS3DestinationOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.renderBackupConfiguration">renderBackupConfiguration</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.addProcessor">addProcessor</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.bind"></a>

```typescript
public bind(scope: IConstruct): DeliveryStreamDestinationConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `renderBackupConfiguration` <a name="renderBackupConfiguration" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.renderBackupConfiguration"></a>

```typescript
public renderBackupConfiguration(scope: IConstruct, enabled?: boolean): BackupConfigurationResult
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.renderBackupConfiguration.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.renderBackupConfiguration.parameter.enabled"></a>

- *Type:* boolean

---

##### `addProcessor` <a name="addProcessor" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.addProcessor"></a>

```typescript
public addProcessor(processor: DeliveryStreamProcessor): ExtendedS3Destination
```

###### `processor`<sup>Required</sup> <a name="processor" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.addProcessor.parameter.processor"></a>

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProcessor

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.buffering">buffering</a></code> | <code>cdk-extensions.kinesis_firehose.BufferingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.cloudwatchLoggingConfiguration">cloudwatchLoggingConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.compressionFormat">compressionFormat</a></code> | <code>cdk-extensions.kinesis_firehose.S3CompressionFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.encryptionEnabled">encryptionEnabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.errorOutputPrefix">errorOutputPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.processingEnabled">processingEnabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.processors">processors</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.backupConfiguration">backupConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.BackupConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.dataFormatConversion">dataFormatConversion</a></code> | <code>cdk-extensions.kinesis_firehose.DataFormatConversion</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.dynamicPartitioning">dynamicPartitioning</a></code> | <code>cdk-extensions.kinesis_firehose.DynamicPartitioning</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.processorConfiguration">processorConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorConfiguration</code> | *No description.* |

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

---

##### `buffering`<sup>Optional</sup> <a name="buffering" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.buffering"></a>

```typescript
public readonly buffering: BufferingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BufferingConfiguration

---

##### `cloudwatchLoggingConfiguration`<sup>Optional</sup> <a name="cloudwatchLoggingConfiguration" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.cloudwatchLoggingConfiguration"></a>

```typescript
public readonly cloudwatchLoggingConfiguration: CloudWatchLoggingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration

---

##### `compressionFormat`<sup>Optional</sup> <a name="compressionFormat" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.compressionFormat"></a>

```typescript
public readonly compressionFormat: S3CompressionFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.S3CompressionFormat

---

##### `encryptionEnabled`<sup>Optional</sup> <a name="encryptionEnabled" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.encryptionEnabled"></a>

```typescript
public readonly encryptionEnabled: boolean;
```

- *Type:* boolean

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

---

##### `errorOutputPrefix`<sup>Optional</sup> <a name="errorOutputPrefix" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.errorOutputPrefix"></a>

```typescript
public readonly errorOutputPrefix: string;
```

- *Type:* string

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string

---

##### `processingEnabled`<sup>Required</sup> <a name="processingEnabled" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.processingEnabled"></a>

```typescript
public readonly processingEnabled: boolean;
```

- *Type:* boolean

---

##### `processors`<sup>Required</sup> <a name="processors" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.processors"></a>

```typescript
public readonly processors: DeliveryStreamProcessor[];
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]

---

##### `backupConfiguration`<sup>Optional</sup> <a name="backupConfiguration" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.backupConfiguration"></a>

```typescript
public readonly backupConfiguration: BackupConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BackupConfiguration

---

##### `dataFormatConversion`<sup>Optional</sup> <a name="dataFormatConversion" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.dataFormatConversion"></a>

```typescript
public readonly dataFormatConversion: DataFormatConversion;
```

- *Type:* cdk-extensions.kinesis_firehose.DataFormatConversion

---

##### `dynamicPartitioning`<sup>Optional</sup> <a name="dynamicPartitioning" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.dynamicPartitioning"></a>

```typescript
public readonly dynamicPartitioning: DynamicPartitioning;
```

- *Type:* cdk-extensions.kinesis_firehose.DynamicPartitioning

---

##### `processorConfiguration`<sup>Optional</sup> <a name="processorConfiguration" id="cdk-extensions.kinesis_firehose.ExtendedS3Destination.property.processorConfiguration"></a>

```typescript
public readonly processorConfiguration: ProcessorConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorConfiguration

---


### ExternalDnsRegistry <a name="ExternalDnsRegistry" id="cdk-extensions.k8s_aws.ExternalDnsRegistry"></a>

Helper class that provides access to the available ExternalDns registry options.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.ExternalDnsRegistry.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.ExternalDnsRegistry()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsRegistry.awsServiceDiscovery">awsServiceDiscovery</a></code> | An ExternalDNS registry that tracks DNS record ownership information using AWS Service Discovery. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsRegistry.noop">noop</a></code> | A placeholder ExternalDNS registry that says ExternalDNS should use not use a registry. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsRegistry.txt">txt</a></code> | An ExternalDNS registry that tracks DNS record ownership information using DNS TXT records. |

---

##### `awsServiceDiscovery` <a name="awsServiceDiscovery" id="cdk-extensions.k8s_aws.ExternalDnsRegistry.awsServiceDiscovery"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalDnsRegistry.awsServiceDiscovery()
```

An ExternalDNS registry that tracks DNS record ownership information using AWS Service Discovery.

> [[AWS Cloud Map](https://docs.aws.amazon.com/cloud-map/latest/dg/what-is-cloud-map.html)]([AWS Cloud Map](https://docs.aws.amazon.com/cloud-map/latest/dg/what-is-cloud-map.html))

##### `noop` <a name="noop" id="cdk-extensions.k8s_aws.ExternalDnsRegistry.noop"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalDnsRegistry.noop()
```

A placeholder ExternalDNS registry that says ExternalDNS should use not use a registry.

When configuring ExternalDNS without a registry, the service has no idea
the original creator and maintainer of DNS records. This means that
there are likely to be conflicts if there are multiple services that
could create or change DNS records in the same zone.

##### `txt` <a name="txt" id="cdk-extensions.k8s_aws.ExternalDnsRegistry.txt"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ExternalDnsRegistry.txt(options?: TxtRegistryOptions)
```

An ExternalDNS registry that tracks DNS record ownership information using DNS TXT records.

> [[About TXT records](https://support.google.com/a/answer/2716800?hl=en)]([About TXT records](https://support.google.com/a/answer/2716800?hl=en))

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.ExternalDnsRegistry.txt.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.TxtRegistryOptions

Options configuring how ExternalDNS will use TXT records to validate ownership.

---



### FlowLogDestination <a name="FlowLogDestination" id="cdk-extensions.ec2.FlowLogDestination"></a>

- *Implements:* cdk-extensions.ec2.ILogDestination

Represents a resource that can act as a deliver endpoint for captured flow logs.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.FlowLogDestination.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.FlowLogDestination()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogDestination.bind">bind</a></code> | Returns a configuration object with all the fields and resources needed to configure a flow log to write to the destination. |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.FlowLogDestination.bind"></a>

```typescript
public bind(scope: IConstruct): FlowLogDestinationConfig
```

Returns a configuration object with all the fields and resources needed to configure a flow log to write to the destination.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.FlowLogDestination.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The CDK Construct that will be consuming the configuration and using it to configure a flow log.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogDestination.toCloudWatchLogs">toCloudWatchLogs</a></code> | Represents a CloudWatch log group that will serve as the endpoint where flow logs should be delivered. |
| <code><a href="#cdk-extensions.ec2.FlowLogDestination.toS3">toS3</a></code> | Represents a CloudWatch log group that will serve as the endpoint where flow logs should be delivered. |

---

##### `toCloudWatchLogs` <a name="toCloudWatchLogs" id="cdk-extensions.ec2.FlowLogDestination.toCloudWatchLogs"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.FlowLogDestination.toCloudWatchLogs(logGroup?: ILogGroup, role?: IRole)
```

Represents a CloudWatch log group that will serve as the endpoint where flow logs should be delivered.

> [[Publish flow logs to CloudWatch Logs](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs-cwl.html)]([Publish flow logs to CloudWatch Logs](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs-cwl.html))

###### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.ec2.FlowLogDestination.toCloudWatchLogs.parameter.logGroup"></a>

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The CloudWatch LogGroup where flow logs should be delivered.

---

###### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.ec2.FlowLogDestination.toCloudWatchLogs.parameter.role"></a>

- *Type:* aws-cdk-lib.aws_iam.IRole

An IAM role that allows Amazon EC2 to publish flow logs to a CloudWatch Logs log group in your account.

---

##### `toS3` <a name="toS3" id="cdk-extensions.ec2.FlowLogDestination.toS3"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.FlowLogDestination.toS3(bucket?: IBucket, options?: FlowLogS3Options)
```

Represents a CloudWatch log group that will serve as the endpoint where flow logs should be delivered.

> [[Publish flow logs to Amazon S3](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs-s3.html)]([Publish flow logs to Amazon S3](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs-s3.html))

###### `bucket`<sup>Optional</sup> <a name="bucket" id="cdk-extensions.ec2.FlowLogDestination.toS3.parameter.bucket"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucket

The S3 Bucket where flow logs should be delivered.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.FlowLogDestination.toS3.parameter.options"></a>

- *Type:* cdk-extensions.ec2.FlowLogS3Options

Configuration options controlling how flow logs will be written to S3.

---



### FlowLogField <a name="FlowLogField" id="cdk-extensions.ec2.FlowLogField"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.FlowLogField.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.FlowLogField(name: string, type: FlowLogDataType)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogField.Initializer.parameter.name">name</a></code> | <code>string</code> | The name of the Flow Log field, as it should be used when building a format string. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.Initializer.parameter.type">type</a></code> | <code>cdk-extensions.ec2.FlowLogDataType</code> | The data type of the field as it would appear in Parquet. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.FlowLogField.Initializer.parameter.name"></a>

- *Type:* string

The name of the Flow Log field, as it should be used when building a format string.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk-extensions.ec2.FlowLogField.Initializer.parameter.type"></a>

- *Type:* cdk-extensions.ec2.FlowLogDataType

The data type of the field as it would appear in Parquet.

For information on the type for various files, see documentation on the
[available fields](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs.html#flow-logs-fields).

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogField.lookupField">lookupField</a></code> | Tries to retieve full flow log field data for a log field based on name. |

---

##### `lookupField` <a name="lookupField" id="cdk-extensions.ec2.FlowLogField.lookupField"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.FlowLogField.lookupField(name: string)
```

Tries to retieve full flow log field data for a log field based on name.

Returns undefined if the field name is not recognized.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.FlowLogField.lookupField.parameter.name"></a>

- *Type:* string

The name of the FlowLogField to look up.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.name">name</a></code> | <code>string</code> | The name of the Flow Log field, as it should be used when building a format string. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.type">type</a></code> | <code>cdk-extensions.ec2.FlowLogDataType</code> | The data type of the field as it would appear in Parquet. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.FlowLogField.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Flow Log field, as it should be used when building a format string.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk-extensions.ec2.FlowLogField.property.type"></a>

```typescript
public readonly type: FlowLogDataType;
```

- *Type:* cdk-extensions.ec2.FlowLogDataType

The data type of the field as it would appear in Parquet.

For
information on the type for various files, see documentation on the
[available fields](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs.html#flow-logs-fields).

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.ACCOUNT_ID">ACCOUNT_ID</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The AWS account ID of the owner of the source network interface for which traffic is recorded. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.ACTION">ACTION</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The action that is associated with the traffic:. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.AZ_ID">AZ_ID</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The ID of the Availability Zone that contains the network interface for which traffic is recorded. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.BYTES">BYTES</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The number of bytes transferred during the flow. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.DSTADDR">DSTADDR</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The destination address for outgoing traffic, or the IPv4 or IPv6 address of the network interface for incoming traffic on the network interface. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.DSTPORT">DSTPORT</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The destination port of the traffic. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.END">END</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The time, in Unix seconds, when the last packet of the flow was received within the aggregation interval. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.FLOW_DIRECTION">FLOW_DIRECTION</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The direction of the flow with respect to the interface where traffic is captured. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.INSTANCE_ID">INSTANCE_ID</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The ID of the instance that's associated with network interface for which the traffic is recorded, if the instance is owned by you. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.INTERFACE_ID">INTERFACE_ID</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The ID of the network interface for which the traffic is recorded. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.LOG_STATUS">LOG_STATUS</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The logging status of the flow log:. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.PACKETS">PACKETS</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The number of packets transferred during the flow. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.PKT_DST_AWS_SERVICE">PKT_DST_AWS_SERVICE</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The name of the subset of IP address ranges for the pkt-dstaddr field, if the destination IP address is for an AWS service. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.PKT_DSTADDR">PKT_DSTADDR</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The packet-level (original) destination IP address for the traffic. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.PKT_SRC_AWS_SERVICE">PKT_SRC_AWS_SERVICE</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The name of the subset of IP address ranges for the pkt-srcaddr field, if the source IP address is for an AWS service. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.PKT_SRCADDR">PKT_SRCADDR</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The packet-level (original) source IP address of the traffic. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.PROTOCOL">PROTOCOL</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The IANA protocol number of the traffic. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.REGION">REGION</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The Region that contains the network interface for which traffic is recorded. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.SRCADDR">SRCADDR</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The source address for incoming traffic, or the IPv4 or IPv6 address of the network interface for outgoing traffic on the network interface. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.SRCPORT">SRCPORT</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The source port of the traffic. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.START">START</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The time, in Unix seconds, when the first packet of the flow was received within the aggregation interval. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.SUBLOCATION_ID">SUBLOCATION_ID</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The ID of the sublocation that contains the network interface for which traffic is recorded. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.SUBLOCATION_TYPE">SUBLOCATION_TYPE</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The type of sublocation that's returned in the sublocation-id field. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.SUBNET_ID">SUBNET_ID</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The ID of the subnet that contains the network interface for which the traffic is recorded. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.TCP_FLAGS">TCP_FLAGS</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The bitmask value for the following TCP flags:. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.TRAFFIC_PATH">TRAFFIC_PATH</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The path that egress traffic takes to the destination. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.TYPE">TYPE</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The type of traffic. The possible values are: IPv4 \| IPv6 \| EFA. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.VERSION">VERSION</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The VPC Flow Logs version. |
| <code><a href="#cdk-extensions.ec2.FlowLogField.property.VPC_ID">VPC_ID</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The ID of the VPC that contains the network interface for which the traffic is recorded. |

---

##### `ACCOUNT_ID`<sup>Required</sup> <a name="ACCOUNT_ID" id="cdk-extensions.ec2.FlowLogField.property.ACCOUNT_ID"></a>

```typescript
public readonly ACCOUNT_ID: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The AWS account ID of the owner of the source network interface for which traffic is recorded.

If the network interface is created by an
AWS service, for example when creating a VPC endpoint or Network Load
Balancer, the record might display unknown for this field.

---

##### `ACTION`<sup>Required</sup> <a name="ACTION" id="cdk-extensions.ec2.FlowLogField.property.ACTION"></a>

```typescript
public readonly ACTION: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The action that is associated with the traffic:.

ACCEPT: The recorded traffic was permitted by the security groups and
network ACLs.
REJECT: The recorded traffic was not permitted by the security groups
or network ACLs.

---

##### `AZ_ID`<sup>Required</sup> <a name="AZ_ID" id="cdk-extensions.ec2.FlowLogField.property.AZ_ID"></a>

```typescript
public readonly AZ_ID: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The ID of the Availability Zone that contains the network interface for which traffic is recorded.

If the traffic is from a sublocation, the
record displays a '-' symbol for this field.

---

##### `BYTES`<sup>Required</sup> <a name="BYTES" id="cdk-extensions.ec2.FlowLogField.property.BYTES"></a>

```typescript
public readonly BYTES: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The number of bytes transferred during the flow.

---

##### `DSTADDR`<sup>Required</sup> <a name="DSTADDR" id="cdk-extensions.ec2.FlowLogField.property.DSTADDR"></a>

```typescript
public readonly DSTADDR: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The destination address for outgoing traffic, or the IPv4 or IPv6 address of the network interface for incoming traffic on the network interface.

The IPv4 address of the network interface is always its
private IPv4 address.

See also:
{@link FlowLogField.PKT_DSTADDR | PKT_DSTADDR}

---

##### `DSTPORT`<sup>Required</sup> <a name="DSTPORT" id="cdk-extensions.ec2.FlowLogField.property.DSTPORT"></a>

```typescript
public readonly DSTPORT: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The destination port of the traffic.

---

##### `END`<sup>Required</sup> <a name="END" id="cdk-extensions.ec2.FlowLogField.property.END"></a>

```typescript
public readonly END: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The time, in Unix seconds, when the last packet of the flow was received within the aggregation interval.

This might be up to 60
seconds after the packet was transmitted or received on the network
interface.

---

##### `FLOW_DIRECTION`<sup>Required</sup> <a name="FLOW_DIRECTION" id="cdk-extensions.ec2.FlowLogField.property.FLOW_DIRECTION"></a>

```typescript
public readonly FLOW_DIRECTION: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The direction of the flow with respect to the interface where traffic is captured.

The possible values are: ingress | egress.

---

##### `INSTANCE_ID`<sup>Required</sup> <a name="INSTANCE_ID" id="cdk-extensions.ec2.FlowLogField.property.INSTANCE_ID"></a>

```typescript
public readonly INSTANCE_ID: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The ID of the instance that's associated with network interface for which the traffic is recorded, if the instance is owned by you.

Returns
a '-' symbol for a requester-managed network interface; for example,
the network interface for a NAT gateway.

See also:
[Request-managed ENI](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/requester-managed-eni.html)

---

##### `INTERFACE_ID`<sup>Required</sup> <a name="INTERFACE_ID" id="cdk-extensions.ec2.FlowLogField.property.INTERFACE_ID"></a>

```typescript
public readonly INTERFACE_ID: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The ID of the network interface for which the traffic is recorded.

---

##### `LOG_STATUS`<sup>Required</sup> <a name="LOG_STATUS" id="cdk-extensions.ec2.FlowLogField.property.LOG_STATUS"></a>

```typescript
public readonly LOG_STATUS: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The logging status of the flow log:.

OK: Data is logging normally to the chosen destinations.
NODATA: There was no network traffic to or from the network interface
during the aggregation interval.
SKIPDATA — Some flow log records were skipped during the aggregation
interval. This might be because of an internal capacity constraint, or
an internal error.

---

##### `PACKETS`<sup>Required</sup> <a name="PACKETS" id="cdk-extensions.ec2.FlowLogField.property.PACKETS"></a>

```typescript
public readonly PACKETS: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The number of packets transferred during the flow.

---

##### `PKT_DST_AWS_SERVICE`<sup>Required</sup> <a name="PKT_DST_AWS_SERVICE" id="cdk-extensions.ec2.FlowLogField.property.PKT_DST_AWS_SERVICE"></a>

```typescript
public readonly PKT_DST_AWS_SERVICE: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The name of the subset of IP address ranges for the pkt-dstaddr field, if the destination IP address is for an AWS service.

For a list of
possible values, see the {@link FlowLogField.PKT_SRC_AWS_SERVICE | PKT_SRC_AWS_SERVICE} field.

---

##### `PKT_DSTADDR`<sup>Required</sup> <a name="PKT_DSTADDR" id="cdk-extensions.ec2.FlowLogField.property.PKT_DSTADDR"></a>

```typescript
public readonly PKT_DSTADDR: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The packet-level (original) destination IP address for the traffic.

Use
this field with the dstaddr field to distinguish between the IP address
of an intermediate layer through which traffic flows, and the final
destination IP address of the traffic. For example, when traffic flows
through a network interface for a NAT gateway, or where the IP address
of a pod in Amazon EKS is different from the IP address of the network
interface of the instance node on which the pod is running (for
communication within a VPC).

See also:
[Flow Log Example NAT](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs-records-examples.html#flow-log-example-nat)

---

##### `PKT_SRC_AWS_SERVICE`<sup>Required</sup> <a name="PKT_SRC_AWS_SERVICE" id="cdk-extensions.ec2.FlowLogField.property.PKT_SRC_AWS_SERVICE"></a>

```typescript
public readonly PKT_SRC_AWS_SERVICE: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The name of the subset of IP address ranges for the pkt-srcaddr field, if the source IP address is for an AWS service.

The possible values
are: AMAZON | AMAZON_APPFLOW | AMAZON_CONNECT | API_GATEWAY |
CHIME_MEETINGS | CHIME_VOICECONNECTOR | CLOUD9 | CLOUDFRONT |
CODEBUILD | DYNAMODB | EBS | EC2 | EC2_INSTANCE_CONNECT |
GLOBALACCELERATOR | KINESIS_VIDEO_STREAMS | ROUTE53 |
ROUTE53_HEALTHCHECKS | ROUTE53_HEALTHCHECKS_PUBLISHING |
ROUTE53_RESOLVER | S3 | WORKSPACES_GATEWAYS.

---

##### `PKT_SRCADDR`<sup>Required</sup> <a name="PKT_SRCADDR" id="cdk-extensions.ec2.FlowLogField.property.PKT_SRCADDR"></a>

```typescript
public readonly PKT_SRCADDR: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The packet-level (original) source IP address of the traffic.

Use this
field with the srcaddr field to distinguish between the IP address of
an intermediate layer through which traffic flows, and the original
source IP address of the traffic. For example, when traffic flows
through a network interface for a NAT gateway, or where the IP address
of a pod in Amazon EKS is different from the IP address of the network
interface of the instance node on which the pod is running (for
communication within a VPC).

See also:
[Flow Log Example NAT](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs-records-examples.html#flow-log-example-nat)

---

##### `PROTOCOL`<sup>Required</sup> <a name="PROTOCOL" id="cdk-extensions.ec2.FlowLogField.property.PROTOCOL"></a>

```typescript
public readonly PROTOCOL: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The IANA protocol number of the traffic.

See also:
[Assigned Internet Protocol Numbers](http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml).

---

##### `REGION`<sup>Required</sup> <a name="REGION" id="cdk-extensions.ec2.FlowLogField.property.REGION"></a>

```typescript
public readonly REGION: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The Region that contains the network interface for which traffic is recorded.

---

##### `SRCADDR`<sup>Required</sup> <a name="SRCADDR" id="cdk-extensions.ec2.FlowLogField.property.SRCADDR"></a>

```typescript
public readonly SRCADDR: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The source address for incoming traffic, or the IPv4 or IPv6 address of the network interface for outgoing traffic on the network interface.

The IPv4 address of the network interface is always its private IPv4
address.

See also:
{@link FlowLogField.PKT_SRCADDR | PKT_SRCADDR}

---

##### `SRCPORT`<sup>Required</sup> <a name="SRCPORT" id="cdk-extensions.ec2.FlowLogField.property.SRCPORT"></a>

```typescript
public readonly SRCPORT: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The source port of the traffic.

---

##### `START`<sup>Required</sup> <a name="START" id="cdk-extensions.ec2.FlowLogField.property.START"></a>

```typescript
public readonly START: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The time, in Unix seconds, when the first packet of the flow was received within the aggregation interval.

This might be up to 60
seconds after the packet was transmitted or received on the network
interface.

---

##### `SUBLOCATION_ID`<sup>Required</sup> <a name="SUBLOCATION_ID" id="cdk-extensions.ec2.FlowLogField.property.SUBLOCATION_ID"></a>

```typescript
public readonly SUBLOCATION_ID: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The ID of the sublocation that contains the network interface for which traffic is recorded.

If the traffic is not from a sublocation, the
record displays a '-' symbol for this field.

---

##### `SUBLOCATION_TYPE`<sup>Required</sup> <a name="SUBLOCATION_TYPE" id="cdk-extensions.ec2.FlowLogField.property.SUBLOCATION_TYPE"></a>

```typescript
public readonly SUBLOCATION_TYPE: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The type of sublocation that's returned in the sublocation-id field.

The possible values are: wavelength | outpost | localzone. If the
traffic is not from a sublocation, the record displays a '-' symbol
for this field.

See also:
[Wavelength](https://aws.amazon.com/wavelength/)
[Outposts](https://docs.aws.amazon.com/outposts/latest/userguide/)
[Local Zones](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-regions-availability-zones.html#concepts-local-zones)

---

##### `SUBNET_ID`<sup>Required</sup> <a name="SUBNET_ID" id="cdk-extensions.ec2.FlowLogField.property.SUBNET_ID"></a>

```typescript
public readonly SUBNET_ID: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The ID of the subnet that contains the network interface for which the traffic is recorded.

---

##### `TCP_FLAGS`<sup>Required</sup> <a name="TCP_FLAGS" id="cdk-extensions.ec2.FlowLogField.property.TCP_FLAGS"></a>

```typescript
public readonly TCP_FLAGS: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The bitmask value for the following TCP flags:.

FIN: 1
SYN: 2
RST: 4
PSH: 8
ACK: 16
SYN-ACK: 18
URG: 32

When a flow log entry consists of only ACK packets, the flag value is
0, not 16.

TCP flags can be OR-ed during the aggregation interval. For short
connections, the flags might be set on the same line in the flow log
record, for example, 19 for SYN-ACK and FIN, and 3 for SYN and FIN.

See also:
[TCP Segment Structure](https://en.wikipedia.org/wiki/Transmission_Control_Protocol#TCP_segment_structure)
[TCP Flag Sequence](https://docs.aws.amazon.com/vpc/latest/userguide/flow-logs-records-examples.html#flow-log-example-tcp-flag)

---

##### `TRAFFIC_PATH`<sup>Required</sup> <a name="TRAFFIC_PATH" id="cdk-extensions.ec2.FlowLogField.property.TRAFFIC_PATH"></a>

```typescript
public readonly TRAFFIC_PATH: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The path that egress traffic takes to the destination.

To determine
whether the traffic is egress traffic, check the flow-direction field.
The possible values are as follows. If none of the values apply, the
field is set to -.

1: Through another resource in the same VPC
2: Through an internet gateway or a gateway VPC endpoint
3: Through a virtual private gateway
4: Through an intra-region VPC peering connection
5: Through an inter-region VPC peering connection
6: Through a local gateway
7: Through a gateway VPC endpoint (Nitro-based instances only)
8: Through an internet gateway (Nitro-based instances only)

---

##### `TYPE`<sup>Required</sup> <a name="TYPE" id="cdk-extensions.ec2.FlowLogField.property.TYPE"></a>

```typescript
public readonly TYPE: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The type of traffic. The possible values are: IPv4 | IPv6 | EFA.

See also:
[Elastic Fabric Adapter](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/efa.html)

---

##### `VERSION`<sup>Required</sup> <a name="VERSION" id="cdk-extensions.ec2.FlowLogField.property.VERSION"></a>

```typescript
public readonly VERSION: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The VPC Flow Logs version.

If you use the default format, the version
is 2. If you use a custom format, the version is the highest version
among the specified fields. For example, if you specify only fields
from version 2, the version is 2. If you specify a mixture of fields
from versions 2, 3, and 4, the version is 4.

---

##### `VPC_ID`<sup>Required</sup> <a name="VPC_ID" id="cdk-extensions.ec2.FlowLogField.property.VPC_ID"></a>

```typescript
public readonly VPC_ID: FlowLogField;
```

- *Type:* cdk-extensions.ec2.FlowLogField

The ID of the VPC that contains the network interface for which the traffic is recorded.

---

### FlowLogFormat <a name="FlowLogFormat" id="cdk-extensions.ec2.FlowLogFormat"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.FlowLogFormat.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.FlowLogFormat(fields: FlowLogField)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.Initializer.parameter.fields">fields</a></code> | <code>cdk-extensions.ec2.FlowLogField</code> | The fields that should be included in the flow log output. |

---

##### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.ec2.FlowLogFormat.Initializer.parameter.fields"></a>

- *Type:* cdk-extensions.ec2.FlowLogField

The fields that should be included in the flow log output.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.addField">addField</a></code> | Adds a new field to the flow log output. |

---

##### `addField` <a name="addField" id="cdk-extensions.ec2.FlowLogFormat.addField"></a>

```typescript
public addField(field: FlowLogField): void
```

Adds a new field to the flow log output.

New fields are added at the
end of a log entry after all the other fields that came before it.

###### `field`<sup>Required</sup> <a name="field" id="cdk-extensions.ec2.FlowLogFormat.addField.parameter.field"></a>

- *Type:* cdk-extensions.ec2.FlowLogField

The field to add to the FlowLogFormat.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.fromTemplate">fromTemplate</a></code> | Parses a flow log format template string to create a new FlowLogFormat object. |

---

##### `fromTemplate` <a name="fromTemplate" id="cdk-extensions.ec2.FlowLogFormat.fromTemplate"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.FlowLogFormat.fromTemplate(template: string)
```

Parses a flow log format template string to create a new FlowLogFormat object.

###### `template`<sup>Required</sup> <a name="template" id="cdk-extensions.ec2.FlowLogFormat.fromTemplate.parameter.template"></a>

- *Type:* string

A flow log template string to parse.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.property.fields">fields</a></code> | <code>cdk-extensions.ec2.FlowLogField[]</code> | The fields that make up the flow log format, in the order that they should appear in the log entries. |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.property.template">template</a></code> | <code>string</code> | The rendered format string in the format expected by AWS when creating a new Flow Log. |

---

##### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.ec2.FlowLogFormat.property.fields"></a>

```typescript
public readonly fields: FlowLogField[];
```

- *Type:* cdk-extensions.ec2.FlowLogField[]

The fields that make up the flow log format, in the order that they should appear in the log entries.

---

##### `template`<sup>Required</sup> <a name="template" id="cdk-extensions.ec2.FlowLogFormat.property.template"></a>

```typescript
public readonly template: string;
```

- *Type:* string

The rendered format string in the format expected by AWS when creating a new Flow Log.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.property.V2">V2</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | The basic set of fields included in most flow logs. |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.property.V3">V3</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | Includes all the fields available in V2. |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.property.V4">V4</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | Includes all the fields available in V3. |
| <code><a href="#cdk-extensions.ec2.FlowLogFormat.property.V5">V5</a></code> | <code>cdk-extensions.ec2.FlowLogFormat</code> | Includes all the fields available in V4. |

---

##### `V2`<sup>Required</sup> <a name="V2" id="cdk-extensions.ec2.FlowLogFormat.property.V2"></a>

```typescript
public readonly V2: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

The basic set of fields included in most flow logs.

This is the default
format that is used when new flow logs are created without specifying a
custom format.

---

##### `V3`<sup>Required</sup> <a name="V3" id="cdk-extensions.ec2.FlowLogFormat.property.V3"></a>

```typescript
public readonly V3: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

Includes all the fields available in V2.

Adds fields to help identify
AWS resources associated with traffic as well as fields that give
greater visibility into protocol specific details.

---

##### `V4`<sup>Required</sup> <a name="V4" id="cdk-extensions.ec2.FlowLogFormat.property.V4"></a>

```typescript
public readonly V4: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

Includes all the fields available in V3.

Adds fields for identifying
the region and availabilty zone associated with flows, as well as
details related to extended zones such as Wavelength, Outputs, and
Local Zones.

---

##### `V5`<sup>Required</sup> <a name="V5" id="cdk-extensions.ec2.FlowLogFormat.property.V5"></a>

```typescript
public readonly V5: FlowLogFormat;
```

- *Type:* cdk-extensions.ec2.FlowLogFormat

Includes all the fields available in V4.

Adds fields to help identify
related AWS services and improve visibility into packet routing.

---

### FluentBitCloudWatchLogsOutput <a name="FluentBitCloudWatchLogsOutput" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput"></a>

Represents configuration for outputing logs from Fluent Bit to CloudWatch Logs.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitCloudWatchLogsOutput(options?: FluentBitCloudWatchLogsOutputOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions</code> | Options for configuring the output. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutputOptions

Options for configuring the output.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logGroup">logGroup</a></code> | <code>cdk-extensions.k8s_aws.FluentBitLogGroupOutput</code> | The CloudWatch Log Group configuration for output records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logStream">logStream</a></code> | <code>cdk-extensions.k8s_aws.FluentBitLogStreamOutput</code> | The CloudWatch LogStream configuration for outbound records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.autoCreateGroup">autoCreateGroup</a></code> | <code>boolean</code> | Automatically create the log group. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.autoRetryRequests">autoRetryRequests</a></code> | <code>boolean</code> | Immediately retry failed requests to AWS services once. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.endpoint">endpoint</a></code> | <code>string</code> | Specify a custom endpoint for the CloudWatch Logs API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logFormat">logFormat</a></code> | <code>string</code> | An optional parameter that can be used to tell CloudWatch the format of the data. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logGroupTemplate">logGroupTemplate</a></code> | <code>string</code> | Template for Log Group name using Fluent Bit record_accessor syntax. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logKey">logKey</a></code> | <code>string</code> | By default, the whole log record will be sent to CloudWatch. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logRetention">logRetention</a></code> | <code>aws-cdk-lib.aws_logs.RetentionDays</code> | If set to a number greater than zero, and newly create log group's retention policy is set to this many days. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logStreamTemplate">logStreamTemplate</a></code> | <code>string</code> | Template for Log Stream name using Fluent Bit record accessor syntax. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.metricDimensions">metricDimensions</a></code> | <code>string[]</code> | A list of lists containing the dimension keys that will be applied to all metrics. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.metricNamespace">metricNamespace</a></code> | <code>string</code> | An optional string representing the CloudWatch namespace for the metrics. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.region">region</a></code> | <code>string</code> | The AWS region. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | ARN of an IAM role to assume (for cross account access). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.stsEndpoint">stsEndpoint</a></code> | <code>string</code> | Specify a custom STS endpoint for the AWS STS API. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `logGroup`<sup>Required</sup> <a name="logGroup" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logGroup"></a>

```typescript
public readonly logGroup: FluentBitLogGroupOutput;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitLogGroupOutput

The CloudWatch Log Group configuration for output records.

---

##### `logStream`<sup>Required</sup> <a name="logStream" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logStream"></a>

```typescript
public readonly logStream: FluentBitLogStreamOutput;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitLogStreamOutput

The CloudWatch LogStream configuration for outbound records.

---

##### `autoCreateGroup`<sup>Optional</sup> <a name="autoCreateGroup" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.autoCreateGroup"></a>

```typescript
public readonly autoCreateGroup: boolean;
```

- *Type:* boolean

Automatically create the log group.

---

##### `autoRetryRequests`<sup>Optional</sup> <a name="autoRetryRequests" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.autoRetryRequests"></a>

```typescript
public readonly autoRetryRequests: boolean;
```

- *Type:* boolean

Immediately retry failed requests to AWS services once.

This option does
not affect the normal Fluent Bit retry mechanism with backoff. Instead,
it enables an immediate retry with no delay for networking errors, which
may help improve throughput when there are transient/random networking
issues.

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

Specify a custom endpoint for the CloudWatch Logs API.

---

##### `logFormat`<sup>Optional</sup> <a name="logFormat" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logFormat"></a>

```typescript
public readonly logFormat: string;
```

- *Type:* string

An optional parameter that can be used to tell CloudWatch the format of the data.

A value of json/emf enables CloudWatch to extract custom
metrics embedded in a JSON payload.

> [[Embedded Metric Format](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CloudWatch_Embedded_Metric_Format_Specification.html)]([Embedded Metric Format](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CloudWatch_Embedded_Metric_Format_Specification.html))

---

##### `logGroupTemplate`<sup>Optional</sup> <a name="logGroupTemplate" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logGroupTemplate"></a>

```typescript
public readonly logGroupTemplate: string;
```

- *Type:* string

Template for Log Group name using Fluent Bit record_accessor syntax.

This field is optional and if configured it overrides the configured Log
Group.

If the template translation fails, an error is logged and the provided
Log Group (which is still required) is used instead.

> [[Fluent Bit record accessor snytax](https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/record-accessor)]([Fluent Bit record accessor snytax](https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/record-accessor))

---

##### `logKey`<sup>Optional</sup> <a name="logKey" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logKey"></a>

```typescript
public readonly logKey: string;
```

- *Type:* string

By default, the whole log record will be sent to CloudWatch.

If you
specify a key name with this option, then only the value of that key
will be sent to CloudWatch.

---

##### `logRetention`<sup>Optional</sup> <a name="logRetention" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logRetention"></a>

```typescript
public readonly logRetention: RetentionDays;
```

- *Type:* aws-cdk-lib.aws_logs.RetentionDays

If set to a number greater than zero, and newly create log group's retention policy is set to this many days.

---

##### `logStreamTemplate`<sup>Optional</sup> <a name="logStreamTemplate" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.logStreamTemplate"></a>

```typescript
public readonly logStreamTemplate: string;
```

- *Type:* string

Template for Log Stream name using Fluent Bit record accessor syntax.

This field is optional and if configured it overrides the other log
stream options. If the template translation fails, an error is logged
and the logStream or logStreamPrefix are used instead (and thus one of
those fields is still required to be configured).

> [[Fluent Bit record accessor snytax](https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/record-accessor)]([Fluent Bit record accessor snytax](https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/record-accessor))

---

##### `metricDimensions`<sup>Optional</sup> <a name="metricDimensions" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.metricDimensions"></a>

```typescript
public readonly metricDimensions: string[];
```

- *Type:* string[]

A list of lists containing the dimension keys that will be applied to all metrics.

The values within a dimension set MUST also be members on
the root-node.

> [[Dimensions](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/cloudwatch_concepts.html#Dimension)]([Dimensions](https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/cloudwatch_concepts.html#Dimension))

---

##### `metricNamespace`<sup>Optional</sup> <a name="metricNamespace" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.metricNamespace"></a>

```typescript
public readonly metricNamespace: string;
```

- *Type:* string

An optional string representing the CloudWatch namespace for the metrics.

> [[Metric Tutorial](https://docs.fluentbit.io/manual/pipeline/outputs/cloudwatch#metrics-tutorial)]([Metric Tutorial](https://docs.fluentbit.io/manual/pipeline/outputs/cloudwatch#metrics-tutorial))

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

The AWS region.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

ARN of an IAM role to assume (for cross account access).

---

##### `stsEndpoint`<sup>Optional</sup> <a name="stsEndpoint" id="cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput.property.stsEndpoint"></a>

```typescript
public readonly stsEndpoint: string;
```

- *Type:* string

Specify a custom STS endpoint for the AWS STS API.

---


### FluentBitElasticsearchOutput <a name="FluentBitElasticsearchOutput" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitElasticsearchOutput(options: FluentBitElasticsearchOutputOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions</code> | Options for configuring the output. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitElasticsearchOutputOptions

Options for configuring the output.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.host">host</a></code> | <code>string</code> | IP address or hostname of the target Elasticsearch instance. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsAuth">awsAuth</a></code> | <code>boolean</code> | Enable AWS Sigv4 Authentication for Amazon Elasticsearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsExternalId">awsExternalId</a></code> | <code>string</code> | External ID for the AWS IAM Role specified with `awsRole`. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsRegion">awsRegion</a></code> | <code>string</code> | Specify the AWS region for Elasticsearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsRole">awsRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | AWS IAM Role to assume to put records to your Amazon cluster. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsStsEndpoint">awsStsEndpoint</a></code> | <code>string</code> | Specify the custom sts endpoint to be used with STS API for Amazon Elasticsearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.bufferSize">bufferSize</a></code> | <code>cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize</code> | Specify the buffer size used to read the response from the Elasticsearch HTTP service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.cloudAuth">cloudAuth</a></code> | <code>string</code> | Specify the credentials to use to connect to Elastic's Elasticsearch Service running on Elastic Cloud. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.cloudId">cloudId</a></code> | <code>string</code> | If you are using Elastic's Elasticsearch Service you can specify the cloud_id of the cluster running. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.compress">compress</a></code> | <code>cdk-extensions.k8s_aws.ElasticsearchCompressionFormat</code> | Set payload compression mechanism. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.currentTimeIndex">currentTimeIndex</a></code> | <code>boolean</code> | Use current time for index generation instead of message record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.generateId">generateId</a></code> | <code>boolean</code> | When enabled, generate `_id` for outgoing records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.httpPasswd">httpPasswd</a></code> | <code>string</code> | Password for user defined in `httpUser`. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.httpUser">httpUser</a></code> | <code>string</code> | Optional username credential for access. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.idKey">idKey</a></code> | <code>string</code> | If set, `_id` will be the value of the key from incoming record and `generateId` option is ignored. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.includeTagKey">includeTagKey</a></code> | <code>boolean</code> | When enabled, it append the Tag name to the record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.index">index</a></code> | <code>string</code> | Index name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.logstashDateFormat">logstashDateFormat</a></code> | <code>string</code> | Time format (based on strftime) to generate the second part of the Index name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.logstashFormat">logstashFormat</a></code> | <code>boolean</code> | Enable Logstash format compatibility. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.logstashPrefix">logstashPrefix</a></code> | <code>string</code> | When `logstashFormat` is enabled, the Index name is composed using a prefix and the date, e.g: If `logstashPrefix` is equals to 'mydata' your index will become 'mydata-YYYY.MM.DD'. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.logstashPrefixKey">logstashPrefixKey</a></code> | <code>string</code> | When included: the value in the record that belongs to the key will be looked up and over-write the `logstashPrefix` for index generation. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.path">path</a></code> | <code>string</code> | Elasticsearch accepts new data on HTTP query path "/_bulk". |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.pipeline">pipeline</a></code> | <code>string</code> | Elasticsearch allows to setup filters called pipelines. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.port">port</a></code> | <code>number</code> | TCP port of the target Elasticsearch instance. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.replaceDots">replaceDots</a></code> | <code>boolean</code> | When enabled, replace field name dots with underscore. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.suppressTypeName">suppressTypeName</a></code> | <code>boolean</code> | When enabled, mapping types is removed and `type` option is ignored. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.tagKey">tagKey</a></code> | <code>string</code> | When `includeTagKey` is enabled, this property defines the key name for the tag. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.timeKey">timeKey</a></code> | <code>string</code> | When `logstashFormat` is enabled, each record will get a new timestamp field. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.timeKeyFormat">timeKeyFormat</a></code> | <code>string</code> | When `logstashFormat` is enabled, this property defines the format of the timestamp. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.timeKeyNanos">timeKeyNanos</a></code> | <code>boolean</code> | When `logstashFormat` is enabled, enabling this property sends nanosecond precision timestamps. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.traceError">traceError</a></code> | <code>boolean</code> | When enabled print the Elasticsearch API calls to stdout when Elasticsearch returns an error (for diag only). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.traceOutput">traceOutput</a></code> | <code>boolean</code> | When enabled print the Elasticsearch API calls to stdout (for diag only). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.type">type</a></code> | <code>string</code> | Type name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.workers">workers</a></code> | <code>number</code> | Enables dedicated thread(s) for this output. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.writeOperation">writeOperation</a></code> | <code>string</code> | Operation to use to write in bulk requests. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `host`<sup>Required</sup> <a name="host" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

IP address or hostname of the target Elasticsearch instance.

---

##### `awsAuth`<sup>Optional</sup> <a name="awsAuth" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsAuth"></a>

```typescript
public readonly awsAuth: boolean;
```

- *Type:* boolean

Enable AWS Sigv4 Authentication for Amazon Elasticsearch Service.

---

##### `awsExternalId`<sup>Optional</sup> <a name="awsExternalId" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsExternalId"></a>

```typescript
public readonly awsExternalId: string;
```

- *Type:* string

External ID for the AWS IAM Role specified with `awsRole`.

---

##### `awsRegion`<sup>Optional</sup> <a name="awsRegion" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsRegion"></a>

```typescript
public readonly awsRegion: string;
```

- *Type:* string

Specify the AWS region for Elasticsearch Service.

---

##### `awsRole`<sup>Optional</sup> <a name="awsRole" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsRole"></a>

```typescript
public readonly awsRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

AWS IAM Role to assume to put records to your Amazon cluster.

---

##### `awsStsEndpoint`<sup>Optional</sup> <a name="awsStsEndpoint" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.awsStsEndpoint"></a>

```typescript
public readonly awsStsEndpoint: string;
```

- *Type:* string

Specify the custom sts endpoint to be used with STS API for Amazon Elasticsearch Service.

---

##### `bufferSize`<sup>Optional</sup> <a name="bufferSize" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.bufferSize"></a>

```typescript
public readonly bufferSize: ElasticsearchOutputBufferSize;
```

- *Type:* cdk-extensions.k8s_aws.ElasticsearchOutputBufferSize

Specify the buffer size used to read the response from the Elasticsearch HTTP service.

This option is useful for debugging purposes where is
required to read full responses, note that response size grows depending
of the number of records inserted.

---

##### `cloudAuth`<sup>Optional</sup> <a name="cloudAuth" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.cloudAuth"></a>

```typescript
public readonly cloudAuth: string;
```

- *Type:* string

Specify the credentials to use to connect to Elastic's Elasticsearch Service running on Elastic Cloud.

---

##### `cloudId`<sup>Optional</sup> <a name="cloudId" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

If you are using Elastic's Elasticsearch Service you can specify the cloud_id of the cluster running.

---

##### `compress`<sup>Optional</sup> <a name="compress" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.compress"></a>

```typescript
public readonly compress: ElasticsearchCompressionFormat;
```

- *Type:* cdk-extensions.k8s_aws.ElasticsearchCompressionFormat

Set payload compression mechanism.

---

##### `currentTimeIndex`<sup>Optional</sup> <a name="currentTimeIndex" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.currentTimeIndex"></a>

```typescript
public readonly currentTimeIndex: boolean;
```

- *Type:* boolean

Use current time for index generation instead of message record.

---

##### `generateId`<sup>Optional</sup> <a name="generateId" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.generateId"></a>

```typescript
public readonly generateId: boolean;
```

- *Type:* boolean

When enabled, generate `_id` for outgoing records.

This prevents duplicate
records when retrying.

---

##### `httpPasswd`<sup>Optional</sup> <a name="httpPasswd" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.httpPasswd"></a>

```typescript
public readonly httpPasswd: string;
```

- *Type:* string

Password for user defined in `httpUser`.

---

##### `httpUser`<sup>Optional</sup> <a name="httpUser" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.httpUser"></a>

```typescript
public readonly httpUser: string;
```

- *Type:* string

Optional username credential for access.

---

##### `idKey`<sup>Optional</sup> <a name="idKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.idKey"></a>

```typescript
public readonly idKey: string;
```

- *Type:* string

If set, `_id` will be the value of the key from incoming record and `generateId` option is ignored.

---

##### `includeTagKey`<sup>Optional</sup> <a name="includeTagKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.includeTagKey"></a>

```typescript
public readonly includeTagKey: boolean;
```

- *Type:* boolean

When enabled, it append the Tag name to the record.

---

##### `index`<sup>Optional</sup> <a name="index" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* string

Index name.

---

##### `logstashDateFormat`<sup>Optional</sup> <a name="logstashDateFormat" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.logstashDateFormat"></a>

```typescript
public readonly logstashDateFormat: string;
```

- *Type:* string

Time format (based on strftime) to generate the second part of the Index name.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `logstashFormat`<sup>Optional</sup> <a name="logstashFormat" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.logstashFormat"></a>

```typescript
public readonly logstashFormat: boolean;
```

- *Type:* boolean

Enable Logstash format compatibility.

---

##### `logstashPrefix`<sup>Optional</sup> <a name="logstashPrefix" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.logstashPrefix"></a>

```typescript
public readonly logstashPrefix: string;
```

- *Type:* string

When `logstashFormat` is enabled, the Index name is composed using a prefix and the date, e.g: If `logstashPrefix` is equals to 'mydata' your index will become 'mydata-YYYY.MM.DD'.

The last string appended belongs to the date when the data is being
generated.

---

##### `logstashPrefixKey`<sup>Optional</sup> <a name="logstashPrefixKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.logstashPrefixKey"></a>

```typescript
public readonly logstashPrefixKey: string;
```

- *Type:* string

When included: the value in the record that belongs to the key will be looked up and over-write the `logstashPrefix` for index generation.

If
the key/value is not found in the record then the `logstashPrefix` option
will act as a fallback.

Nested keys are not supported (if desired, you can use the nest filter
plugin to remove nesting).

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Elasticsearch accepts new data on HTTP query path "/_bulk".

But it is
also possible to serve Elasticsearch behind a reverse proxy on a
subpath. This option defines such path on the fluent-bit side. It
simply adds a path prefix in the indexing HTTP POST URI.

---

##### `pipeline`<sup>Optional</sup> <a name="pipeline" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.pipeline"></a>

```typescript
public readonly pipeline: string;
```

- *Type:* string

Elasticsearch allows to setup filters called pipelines.

This option
allows to define which pipeline the database should use.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

TCP port of the target Elasticsearch instance.

---

##### `replaceDots`<sup>Optional</sup> <a name="replaceDots" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.replaceDots"></a>

```typescript
public readonly replaceDots: boolean;
```

- *Type:* boolean

When enabled, replace field name dots with underscore.

---

##### `suppressTypeName`<sup>Optional</sup> <a name="suppressTypeName" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.suppressTypeName"></a>

```typescript
public readonly suppressTypeName: boolean;
```

- *Type:* boolean

When enabled, mapping types is removed and `type` option is ignored.

---

##### `tagKey`<sup>Optional</sup> <a name="tagKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.tagKey"></a>

```typescript
public readonly tagKey: string;
```

- *Type:* string

When `includeTagKey` is enabled, this property defines the key name for the tag.

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

When `logstashFormat` is enabled, each record will get a new timestamp field.

The`timeKey` property defines the name of that field.

---

##### `timeKeyFormat`<sup>Optional</sup> <a name="timeKeyFormat" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.timeKeyFormat"></a>

```typescript
public readonly timeKeyFormat: string;
```

- *Type:* string

When `logstashFormat` is enabled, this property defines the format of the timestamp.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKeyNanos`<sup>Optional</sup> <a name="timeKeyNanos" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.timeKeyNanos"></a>

```typescript
public readonly timeKeyNanos: boolean;
```

- *Type:* boolean

When `logstashFormat` is enabled, enabling this property sends nanosecond precision timestamps.

---

##### `traceError`<sup>Optional</sup> <a name="traceError" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.traceError"></a>

```typescript
public readonly traceError: boolean;
```

- *Type:* boolean

When enabled print the Elasticsearch API calls to stdout when Elasticsearch returns an error (for diag only).

---

##### `traceOutput`<sup>Optional</sup> <a name="traceOutput" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.traceOutput"></a>

```typescript
public readonly traceOutput: boolean;
```

- *Type:* boolean

When enabled print the Elasticsearch API calls to stdout (for diag only).

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Type name.

---

##### `workers`<sup>Optional</sup> <a name="workers" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.workers"></a>

```typescript
public readonly workers: number;
```

- *Type:* number

Enables dedicated thread(s) for this output.

---

##### `writeOperation`<sup>Optional</sup> <a name="writeOperation" id="cdk-extensions.k8s_aws.FluentBitElasticsearchOutput.property.writeOperation"></a>

```typescript
public readonly writeOperation: string;
```

- *Type:* string

Operation to use to write in bulk requests.

---


### FluentBitFilter <a name="FluentBitFilter" id="cdk-extensions.k8s_aws.FluentBitFilter"></a>

Standard filter options which can be applied to Fluent Bit to control the output and formatting of logs.

Filters change the structure of log records by doing things like adding
metadata to a record, restructuring a record, or adding and removing fields.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitFilter()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.appendFields">appendFields</a></code> | Creates a filter that adds fields to a record that matches the given pattern. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.blacklistFields">blacklistFields</a></code> | Creates a filter that removes a set of fields from any records that match a given pattern. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.grep">grep</a></code> | Filters log entries based on a pattern. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.kubernetes">kubernetes</a></code> | Adds Kubernetes metadata to output records including pod information, labels, etc.. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.lift">lift</a></code> | Lifts nested fields in a record up to their parent object. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.modify">modify</a></code> | Applies various transformations to matched records including adding, removing, copying, and renaming fields. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.nest">nest</a></code> | Nests a set of fields in a record under into a specified object. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.parser">parser</a></code> | Applies a set of parsers to matched records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.rewriteTag">rewriteTag</a></code> | Allows modification of tags set by the input configuration to affect the routing of when records are output. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.throttle">throttle</a></code> | Sets an average rate of messages that are allowed to be output over a configured period of time. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilter.whitelistFields">whitelistFields</a></code> | Creates a filter that removes all fields in a record that are not approved. |

---

##### `appendFields` <a name="appendFields" id="cdk-extensions.k8s_aws.FluentBitFilter.appendFields"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.appendFields(match: FluentBitMatch, records: AppendedRecord)
```

Creates a filter that adds fields to a record that matches the given pattern.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.appendFields.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `records`<sup>Required</sup> <a name="records" id="cdk-extensions.k8s_aws.FluentBitFilter.appendFields.parameter.records"></a>

- *Type:* cdk-extensions.k8s_aws.AppendedRecord

The fields to be added to matched records.

---

##### `blacklistFields` <a name="blacklistFields" id="cdk-extensions.k8s_aws.FluentBitFilter.blacklistFields"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.blacklistFields(match: FluentBitMatch, fields: string)
```

Creates a filter that removes a set of fields from any records that match a given pattern.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.blacklistFields.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.k8s_aws.FluentBitFilter.blacklistFields.parameter.fields"></a>

- *Type:* string

The fields which should be removed from the record if they are present.

---

##### `grep` <a name="grep" id="cdk-extensions.k8s_aws.FluentBitFilter.grep"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.grep(match: FluentBitMatch, pattern: FluentBitGrepRegex)
```

Filters log entries based on a pattern.

Log entries can be removed and
not forwarded based on whether they match or do not match the given
pattern.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.grep.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.k8s_aws.FluentBitFilter.grep.parameter.pattern"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitGrepRegex

The pattern to match against incoming records.

---

##### `kubernetes` <a name="kubernetes" id="cdk-extensions.k8s_aws.FluentBitFilter.kubernetes"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.kubernetes(match: FluentBitMatch)
```

Adds Kubernetes metadata to output records including pod information, labels, etc..

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.kubernetes.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

##### `lift` <a name="lift" id="cdk-extensions.k8s_aws.FluentBitFilter.lift"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.lift(match: FluentBitMatch, nestedUnder: string)
```

Lifts nested fields in a record up to their parent object.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.lift.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `nestedUnder`<sup>Required</sup> <a name="nestedUnder" id="cdk-extensions.k8s_aws.FluentBitFilter.lift.parameter.nestedUnder"></a>

- *Type:* string

The record object under which you want to lift fields.

---

##### `modify` <a name="modify" id="cdk-extensions.k8s_aws.FluentBitFilter.modify"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.modify(match: FluentBitMatch, operations: ModifyOperation)
```

Applies various transformations to matched records including adding, removing, copying, and renaming fields.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.modify.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `operations`<sup>Required</sup> <a name="operations" id="cdk-extensions.k8s_aws.FluentBitFilter.modify.parameter.operations"></a>

- *Type:* cdk-extensions.k8s_aws.ModifyOperation

The operations to apply to the matched records.

---

##### `nest` <a name="nest" id="cdk-extensions.k8s_aws.FluentBitFilter.nest"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.nest(match: FluentBitMatch, nestUnder: string, fields: string)
```

Nests a set of fields in a record under into a specified object.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.nest.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `nestUnder`<sup>Required</sup> <a name="nestUnder" id="cdk-extensions.k8s_aws.FluentBitFilter.nest.parameter.nestUnder"></a>

- *Type:* string

The record object under which you want to nest matched fields.

---

###### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.k8s_aws.FluentBitFilter.nest.parameter.fields"></a>

- *Type:* string

The fields to nest under the specified object.

---

##### `parser` <a name="parser" id="cdk-extensions.k8s_aws.FluentBitFilter.parser"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.parser(match: FluentBitMatch, key: string, parsers: IFluentBitParserPlugin)
```

Applies a set of parsers to matched records.

The parser is used to read the input record and set structured fields in
the output.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.parser.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.FluentBitFilter.parser.parameter.key"></a>

- *Type:* string

The key of the field to be parsed.

---

###### `parsers`<sup>Required</sup> <a name="parsers" id="cdk-extensions.k8s_aws.FluentBitFilter.parser.parameter.parsers"></a>

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin

The parser plugins to use to read matched records.

---

##### `rewriteTag` <a name="rewriteTag" id="cdk-extensions.k8s_aws.FluentBitFilter.rewriteTag"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.rewriteTag(match: FluentBitMatch, rules: RewriteTagRule)
```

Allows modification of tags set by the input configuration to affect the routing of when records are output.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.rewriteTag.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `rules`<sup>Required</sup> <a name="rules" id="cdk-extensions.k8s_aws.FluentBitFilter.rewriteTag.parameter.rules"></a>

- *Type:* cdk-extensions.k8s_aws.RewriteTagRule

The rules that define the matching criteria of format of the tag for the matching record.

---

##### `throttle` <a name="throttle" id="cdk-extensions.k8s_aws.FluentBitFilter.throttle"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.throttle(match: FluentBitMatch, interval: Duration, rate: number, window: number)
```

Sets an average rate of messages that are allowed to be output over a configured period of time.

When the rate of messages surpasses the configured limits messages will
be dropped.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.throttle.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `interval`<sup>Required</sup> <a name="interval" id="cdk-extensions.k8s_aws.FluentBitFilter.throttle.parameter.interval"></a>

- *Type:* aws-cdk-lib.Duration

The interval of time over rate should be sampled to calculate an average.

---

###### `rate`<sup>Required</sup> <a name="rate" id="cdk-extensions.k8s_aws.FluentBitFilter.throttle.parameter.rate"></a>

- *Type:* number

The average amount of messages over a given period.

---

###### `window`<sup>Required</sup> <a name="window" id="cdk-extensions.k8s_aws.FluentBitFilter.throttle.parameter.window"></a>

- *Type:* number

Amount of intervals to calculate average over.

---

##### `whitelistFields` <a name="whitelistFields" id="cdk-extensions.k8s_aws.FluentBitFilter.whitelistFields"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitFilter.whitelistFields(match: FluentBitMatch, fields: string)
```

Creates a filter that removes all fields in a record that are not approved.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilter.whitelistFields.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the filter should be applied.

---

###### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.k8s_aws.FluentBitFilter.whitelistFields.parameter.fields"></a>

- *Type:* string

The fields which are allowed to appear in the output record.

---



### FluentBitFilterPluginBase <a name="FluentBitFilterPluginBase" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase"></a>

- *Implements:* cdk-extensions.k8s_aws.IFluentBitFilterPlugin

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitFilterPluginBase(name: string, options?: FluentBitFilterPluginCommonOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilterPluginBase.Initializer.parameter.name">name</a></code> | <code>string</code> | The name of the output plugin to configure. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilterPluginBase.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitFilterPluginCommonOptions</code> | Configuration options that apply to all Fluent Bit output plugin. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase.Initializer.parameter.name"></a>

- *Type:* string

The name of the output plugin to configure.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitFilterPluginCommonOptions

Configuration options that apply to all Fluent Bit output plugin.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilterPluginBase.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilterPluginBase.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilterPluginBase.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitFilterPluginBase.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitFilterPluginBase.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---


### FluentBitGrepFilter <a name="FluentBitGrepFilter" id="cdk-extensions.k8s_aws.FluentBitGrepFilter"></a>

A Fluent Bit filter that allows log records to be kept or discarded based on whether they match a given regular expression or not.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitGrepFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitGrepFilter(options: FluentBitGrepFilterOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepFilter.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitGrepFilterOptions</code> | Options for configuring the filter. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitGrepFilter.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitGrepFilterOptions

Options for configuring the filter.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepFilter.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitGrepFilter.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitGrepFilter.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepFilter.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepFilter.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepFilter.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitGrepFilter.property.pattern">pattern</a></code> | <code>cdk-extensions.k8s_aws.FluentBitGrepRegex</code> | The pattern to use for filtering records processed by the plugin. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitGrepFilter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitGrepFilter.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitGrepFilter.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.k8s_aws.FluentBitGrepFilter.property.pattern"></a>

```typescript
public readonly pattern: FluentBitGrepRegex;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitGrepRegex

The pattern to use for filtering records processed by the plugin.

---


### FluentBitJsonParser <a name="FluentBitJsonParser" id="cdk-extensions.k8s_aws.FluentBitJsonParser"></a>

A Fluent Bit filter that parsed inbound messages in JSON format.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitJsonParser.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitJsonParser(name: string, options?: FluentBitJsonParserOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParser.Initializer.parameter.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParser.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitJsonParserOptions</code> | Options for configuring the parser. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitJsonParser.Initializer.parameter.name"></a>

- *Type:* string

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitJsonParser.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitJsonParserOptions

Options for configuring the parser.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParser.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitJsonParser.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitJsonParser.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParser.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParser.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParser.property.format">format</a></code> | <code>string</code> | The data format that the parser extracts records from. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParser.property.timeFormat">timeFormat</a></code> | <code>string</code> | Defines the format of the timestamp on the inbound record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitJsonParser.property.timeKey">timeKey</a></code> | <code>string</code> | The key under which timestamp information for the inbound record is given. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitJsonParser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitJsonParser.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.k8s_aws.FluentBitJsonParser.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

The data format that the parser extracts records from.

---

##### `timeFormat`<sup>Optional</sup> <a name="timeFormat" id="cdk-extensions.k8s_aws.FluentBitJsonParser.property.timeFormat"></a>

```typescript
public readonly timeFormat: string;
```

- *Type:* string

Defines the format of the timestamp on the inbound record.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitJsonParser.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

The key under which timestamp information for the inbound record is given.

---


### FluentBitKinesisFirehoseOutput <a name="FluentBitKinesisFirehoseOutput" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput"></a>

Represents configuration for outputing logs from Fluent Bit to Kinesis Firehose.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitKinesisFirehoseOutput(options?: FluentBitKinesisFirehoseOutputOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions</code> | Options for configuring the output. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutputOptions

Options for configuring the output.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.autoRetryRequests">autoRetryRequests</a></code> | <code>boolean</code> | Immediately retry failed requests to AWS services once. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.compression">compression</a></code> | <code>cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat</code> | Compression type for Firehose records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.deliveryStream">deliveryStream</a></code> | <code>cdk-extensions.kinesis_firehose.IDeliveryStream</code> | The Kinesis Firehose Delivery stream that you want log records sent to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.endpoint">endpoint</a></code> | <code>string</code> | Specify a custom endpoint for the Firehose API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.logKey">logKey</a></code> | <code>string</code> | By default, the whole log record will be sent to Firehose. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.region">region</a></code> | <code>string</code> | The AWS region. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | ARN of an IAM role to assume (for cross account access). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.stsEndpoint">stsEndpoint</a></code> | <code>string</code> | Specify a custom STS endpoint for the AWS STS API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.timeKey">timeKey</a></code> | <code>string</code> | Add the timestamp to the record under this key. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.timeKeyFormat">timeKeyFormat</a></code> | <code>string</code> | A strftime compliant format string for the timestamp. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `autoRetryRequests`<sup>Optional</sup> <a name="autoRetryRequests" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.autoRetryRequests"></a>

```typescript
public readonly autoRetryRequests: boolean;
```

- *Type:* boolean

Immediately retry failed requests to AWS services once.

This option does
not affect the normal Fluent Bit retry mechanism with backoff. Instead,
it enables an immediate retry with no delay for networking errors, which
may help improve throughput when there are transient/random networking
issues.

---

##### `compression`<sup>Optional</sup> <a name="compression" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.compression"></a>

```typescript
public readonly compression: KinesisFirehoseCompressionFormat;
```

- *Type:* cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat

Compression type for Firehose records.

Each log record is individually
compressed and sent to Firehose.

---

##### `deliveryStream`<sup>Optional</sup> <a name="deliveryStream" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.deliveryStream"></a>

```typescript
public readonly deliveryStream: IDeliveryStream;
```

- *Type:* cdk-extensions.kinesis_firehose.IDeliveryStream

The Kinesis Firehose Delivery stream that you want log records sent to.

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

Specify a custom endpoint for the Firehose API.

---

##### `logKey`<sup>Optional</sup> <a name="logKey" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.logKey"></a>

```typescript
public readonly logKey: string;
```

- *Type:* string

By default, the whole log record will be sent to Firehose.

If you
specify a key name with this option, then only the value of that key
will be sent to Firehose.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

The AWS region.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

ARN of an IAM role to assume (for cross account access).

---

##### `stsEndpoint`<sup>Optional</sup> <a name="stsEndpoint" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.stsEndpoint"></a>

```typescript
public readonly stsEndpoint: string;
```

- *Type:* string

Specify a custom STS endpoint for the AWS STS API.

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

Add the timestamp to the record under this key.

---

##### `timeKeyFormat`<sup>Optional</sup> <a name="timeKeyFormat" id="cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput.property.timeKeyFormat"></a>

```typescript
public readonly timeKeyFormat: string;
```

- *Type:* string

A strftime compliant format string for the timestamp.

---


### FluentBitKinesisOutput <a name="FluentBitKinesisOutput" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput"></a>

Represents configuration for outputing logs from Fluent Bit to Kinesis Data Streams.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitKinesisOutput(options?: FluentBitKinesisOutputOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions</code> | Options for configuring the output/. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitKinesisOutputOptions

Options for configuring the output/.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.autoRetryRequests">autoRetryRequests</a></code> | <code>boolean</code> | Immediately retry failed requests to AWS services once. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.endpoint">endpoint</a></code> | <code>string</code> | Specify a custom endpoint for the Firehose API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.logKey">logKey</a></code> | <code>string</code> | By default, the whole log record will be sent to Firehose. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.region">region</a></code> | <code>string</code> | The AWS region. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | ARN of an IAM role to assume (for cross account access). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.stream">stream</a></code> | <code>aws-cdk-lib.aws_kinesis.IStream</code> | The name of the Kinesis Streams Delivery stream that you want log records sent to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.stsEndpoint">stsEndpoint</a></code> | <code>string</code> | Specify a custom STS endpoint for the AWS STS API. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.timeKey">timeKey</a></code> | <code>string</code> | Add the timestamp to the record under this key. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.timeKeyFormat">timeKeyFormat</a></code> | <code>string</code> | A strftime compliant format string for the timestamp. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `autoRetryRequests`<sup>Optional</sup> <a name="autoRetryRequests" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.autoRetryRequests"></a>

```typescript
public readonly autoRetryRequests: boolean;
```

- *Type:* boolean

Immediately retry failed requests to AWS services once.

This option does
not affect the normal Fluent Bit retry mechanism with backoff. Instead,
it enables an immediate retry with no delay for networking errors, which
may help improve throughput when there are transient/random networking
issues.

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

Specify a custom endpoint for the Firehose API.

---

##### `logKey`<sup>Optional</sup> <a name="logKey" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.logKey"></a>

```typescript
public readonly logKey: string;
```

- *Type:* string

By default, the whole log record will be sent to Firehose.

If you
specify a key name with this option, then only the value of that key
will be sent to Firehose.

---

##### `region`<sup>Optional</sup> <a name="region" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

The AWS region.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

ARN of an IAM role to assume (for cross account access).

---

##### `stream`<sup>Optional</sup> <a name="stream" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.stream"></a>

```typescript
public readonly stream: IStream;
```

- *Type:* aws-cdk-lib.aws_kinesis.IStream

The name of the Kinesis Streams Delivery stream that you want log records sent to.

---

##### `stsEndpoint`<sup>Optional</sup> <a name="stsEndpoint" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.stsEndpoint"></a>

```typescript
public readonly stsEndpoint: string;
```

- *Type:* string

Specify a custom STS endpoint for the AWS STS API.

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

Add the timestamp to the record under this key.

---

##### `timeKeyFormat`<sup>Optional</sup> <a name="timeKeyFormat" id="cdk-extensions.k8s_aws.FluentBitKinesisOutput.property.timeKeyFormat"></a>

```typescript
public readonly timeKeyFormat: string;
```

- *Type:* string

A strftime compliant format string for the timestamp.

---


### FluentBitKubernetesFilter <a name="FluentBitKubernetesFilter" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter"></a>

A Fluent Bit filter that allows log records to be annotated with Kubernetes metadata based on the containers that generated them.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitKubernetesFilter(options?: FluentBitKubernetesFilterOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions</code> | Options for configuring the filter. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitKubernetesFilterOptions

Options for configuring the filter.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.annotations">annotations</a></code> | <code>boolean</code> | Include Kubernetes resource annotations in the extra metadata. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.bufferSize">bufferSize</a></code> | <code>cdk-extensions.core.DataSize</code> | Set the buffer size for HTTP client when reading responses from Kubernetes API server. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.cacheUseDockerId">cacheUseDockerId</a></code> | <code>boolean</code> | When enabled, metadata will be fetched from K8s when docker_id is changed. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.dnsRetries">dnsRetries</a></code> | <code>number</code> | DNS lookup retries N times until the network starts working. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.dnsWaitTime">dnsWaitTime</a></code> | <code>aws-cdk-lib.Duration</code> | DNS lookup interval between network status checks. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.dummyMeta">dummyMeta</a></code> | <code>boolean</code> | If set, use dummy-meta data (for test/dev purposes). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.k8sLoggingExclude">k8sLoggingExclude</a></code> | <code>boolean</code> | Allow Kubernetes Pods to exclude their logs from the log processor. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.k8sLoggingParser">k8sLoggingParser</a></code> | <code>boolean</code> | Allow Kubernetes Pods to suggest a pre-defined Parser. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.keepLog">keepLog</a></code> | <code>boolean</code> | When `keepLog` is disabled, the log field is removed from the incoming message once it has been successfully merged (`mergeLog` must be enabled as well). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeCaFile">kubeCaFile</a></code> | <code>string</code> | CA certificate file. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeCaPath">kubeCaPath</a></code> | <code>string</code> | Absolute path to scan for certificate files. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeletHost">kubeletHost</a></code> | <code>string</code> | Kubelet host using for HTTP request, this only works when `useKubelet` is enabled. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeletPort">kubeletPort</a></code> | <code>number</code> | Kubelet port using for HTTP request, this only works when `useKubelet` is enabled. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeMetaCacheTtl">kubeMetaCacheTtl</a></code> | <code>aws-cdk-lib.Duration</code> | Configurable TTL for K8s cached metadata. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeMetaPreloadCacheDir">kubeMetaPreloadCacheDir</a></code> | <code>string</code> | If set, Kubernetes meta-data can be cached/pre-loaded from files in JSON format in this directory, named as namespace-pod.meta. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeTagPrefix">kubeTagPrefix</a></code> | <code>string</code> | When the source records comes from Tail input plugin, this option allows to specify what's the prefix used in Tail configuration. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeTokenCommand">kubeTokenCommand</a></code> | <code>string</code> | Command to get Kubernetes authorization token. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeTokenFile">kubeTokenFile</a></code> | <code>string</code> | Token file. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeTokenTtl">kubeTokenTtl</a></code> | <code>aws-cdk-lib.Duration</code> | Configurable 'time to live' for the K8s token. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeUrl">kubeUrl</a></code> | <code>string</code> | API Server end-point. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.labels">labels</a></code> | <code>boolean</code> | Include Kubernetes resource labels in the extra metadata. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.mergeLog">mergeLog</a></code> | <code>boolean</code> | When enabled, it checks if the `log` field content is a JSON string map, if so, it append the map fields as part of the log structure. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.mergeLogKey">mergeLogKey</a></code> | <code>string</code> | When `mergeLog` is enabled, the filter tries to assume the `log` field from the incoming message is a JSON string message and make a structured representation of it at the same level of the `log` field in the map. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.mergeLogTrim">mergeLogTrim</a></code> | <code>boolean</code> | When Merge_Log is enabled, trim (remove possible \n or \r) field values. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.mergeParser">mergeParser</a></code> | <code>string</code> | Optional parser name to specify how to parse the data contained in the log key. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.regexParser">regexParser</a></code> | <code>string</code> | Set an alternative Parser to process record Tag and extract pod_name, namespace_name, container_name and docker_id. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.tlsDebug">tlsDebug</a></code> | <code>number</code> | Debug level between 0 (nothing) and 4 (every detail). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.tlsVerify">tlsVerify</a></code> | <code>boolean</code> | When enabled, turns on certificate validation when connecting to the Kubernetes API server. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.useJournal">useJournal</a></code> | <code>boolean</code> | When enabled, the filter reads logs coming in Journald format. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.useKubelet">useKubelet</a></code> | <code>boolean</code> | This is an optional feature flag to get metadata information from kubelet instead of calling Kube Server API to enhance the log. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `annotations`<sup>Optional</sup> <a name="annotations" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.annotations"></a>

```typescript
public readonly annotations: boolean;
```

- *Type:* boolean

Include Kubernetes resource annotations in the extra metadata.

---

##### `bufferSize`<sup>Optional</sup> <a name="bufferSize" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.bufferSize"></a>

```typescript
public readonly bufferSize: DataSize;
```

- *Type:* cdk-extensions.core.DataSize

Set the buffer size for HTTP client when reading responses from Kubernetes API server.

A value of 0 results in no limit, and the buffer will expand as-needed.

Note that if pod specifications exceed the buffer limit, the API
response will be discarded when retrieving metadata, and some kubernetes
metadata will fail to be injected to the logs.

---

##### `cacheUseDockerId`<sup>Optional</sup> <a name="cacheUseDockerId" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.cacheUseDockerId"></a>

```typescript
public readonly cacheUseDockerId: boolean;
```

- *Type:* boolean

When enabled, metadata will be fetched from K8s when docker_id is changed.

---

##### `dnsRetries`<sup>Optional</sup> <a name="dnsRetries" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.dnsRetries"></a>

```typescript
public readonly dnsRetries: number;
```

- *Type:* number

DNS lookup retries N times until the network starts working.

---

##### `dnsWaitTime`<sup>Optional</sup> <a name="dnsWaitTime" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.dnsWaitTime"></a>

```typescript
public readonly dnsWaitTime: Duration;
```

- *Type:* aws-cdk-lib.Duration

DNS lookup interval between network status checks.

---

##### `dummyMeta`<sup>Optional</sup> <a name="dummyMeta" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.dummyMeta"></a>

```typescript
public readonly dummyMeta: boolean;
```

- *Type:* boolean

If set, use dummy-meta data (for test/dev purposes).

---

##### `k8sLoggingExclude`<sup>Optional</sup> <a name="k8sLoggingExclude" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.k8sLoggingExclude"></a>

```typescript
public readonly k8sLoggingExclude: boolean;
```

- *Type:* boolean

Allow Kubernetes Pods to exclude their logs from the log processor.

---

##### `k8sLoggingParser`<sup>Optional</sup> <a name="k8sLoggingParser" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.k8sLoggingParser"></a>

```typescript
public readonly k8sLoggingParser: boolean;
```

- *Type:* boolean

Allow Kubernetes Pods to suggest a pre-defined Parser.

---

##### `keepLog`<sup>Optional</sup> <a name="keepLog" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.keepLog"></a>

```typescript
public readonly keepLog: boolean;
```

- *Type:* boolean

When `keepLog` is disabled, the log field is removed from the incoming message once it has been successfully merged (`mergeLog` must be enabled as well).

---

##### `kubeCaFile`<sup>Optional</sup> <a name="kubeCaFile" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeCaFile"></a>

```typescript
public readonly kubeCaFile: string;
```

- *Type:* string

CA certificate file.

---

##### `kubeCaPath`<sup>Optional</sup> <a name="kubeCaPath" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeCaPath"></a>

```typescript
public readonly kubeCaPath: string;
```

- *Type:* string

Absolute path to scan for certificate files.

---

##### `kubeletHost`<sup>Optional</sup> <a name="kubeletHost" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeletHost"></a>

```typescript
public readonly kubeletHost: string;
```

- *Type:* string

Kubelet host using for HTTP request, this only works when `useKubelet` is enabled.

---

##### `kubeletPort`<sup>Optional</sup> <a name="kubeletPort" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeletPort"></a>

```typescript
public readonly kubeletPort: number;
```

- *Type:* number

Kubelet port using for HTTP request, this only works when `useKubelet` is enabled.

---

##### `kubeMetaCacheTtl`<sup>Optional</sup> <a name="kubeMetaCacheTtl" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeMetaCacheTtl"></a>

```typescript
public readonly kubeMetaCacheTtl: Duration;
```

- *Type:* aws-cdk-lib.Duration

Configurable TTL for K8s cached metadata.

By default, it is set to 0 which means TTL for cache entries is disabled
and cache entries are evicted at random when capacity is reached.

In order to enable this option, you should set the number to a time
interval.

---

##### `kubeMetaPreloadCacheDir`<sup>Optional</sup> <a name="kubeMetaPreloadCacheDir" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeMetaPreloadCacheDir"></a>

```typescript
public readonly kubeMetaPreloadCacheDir: string;
```

- *Type:* string

If set, Kubernetes meta-data can be cached/pre-loaded from files in JSON format in this directory, named as namespace-pod.meta.

---

##### `kubeTagPrefix`<sup>Optional</sup> <a name="kubeTagPrefix" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeTagPrefix"></a>

```typescript
public readonly kubeTagPrefix: string;
```

- *Type:* string

When the source records comes from Tail input plugin, this option allows to specify what's the prefix used in Tail configuration.

---

##### `kubeTokenCommand`<sup>Optional</sup> <a name="kubeTokenCommand" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeTokenCommand"></a>

```typescript
public readonly kubeTokenCommand: string;
```

- *Type:* string

Command to get Kubernetes authorization token.

If you want to manually choose a command to get it, you can set the
command here.

For example, run running the following to get the token using aws-cli:

```
aws-iam-authenticator -i your-cluster-name token --token-only
```

This option is currently Linux-only.

---

##### `kubeTokenFile`<sup>Optional</sup> <a name="kubeTokenFile" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeTokenFile"></a>

```typescript
public readonly kubeTokenFile: string;
```

- *Type:* string

Token file.

---

##### `kubeTokenTtl`<sup>Optional</sup> <a name="kubeTokenTtl" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeTokenTtl"></a>

```typescript
public readonly kubeTokenTtl: Duration;
```

- *Type:* aws-cdk-lib.Duration

Configurable 'time to live' for the K8s token.

After this time, the token is reloaded from `kubeTokenFile` or the
`kubeTokenCommand`.

---

##### `kubeUrl`<sup>Optional</sup> <a name="kubeUrl" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.kubeUrl"></a>

```typescript
public readonly kubeUrl: string;
```

- *Type:* string

API Server end-point.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.labels"></a>

```typescript
public readonly labels: boolean;
```

- *Type:* boolean

Include Kubernetes resource labels in the extra metadata.

---

##### `mergeLog`<sup>Optional</sup> <a name="mergeLog" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.mergeLog"></a>

```typescript
public readonly mergeLog: boolean;
```

- *Type:* boolean

When enabled, it checks if the `log` field content is a JSON string map, if so, it append the map fields as part of the log structure.

---

##### `mergeLogKey`<sup>Optional</sup> <a name="mergeLogKey" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.mergeLogKey"></a>

```typescript
public readonly mergeLogKey: string;
```

- *Type:* string

When `mergeLog` is enabled, the filter tries to assume the `log` field from the incoming message is a JSON string message and make a structured representation of it at the same level of the `log` field in the map.

Now if `mergeLogKey` is set (a string name), all the new structured
fields taken from the original `log` content are inserted under the new
key.

---

##### `mergeLogTrim`<sup>Optional</sup> <a name="mergeLogTrim" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.mergeLogTrim"></a>

```typescript
public readonly mergeLogTrim: boolean;
```

- *Type:* boolean

When Merge_Log is enabled, trim (remove possible \n or \r) field values.

---

##### `mergeParser`<sup>Optional</sup> <a name="mergeParser" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.mergeParser"></a>

```typescript
public readonly mergeParser: string;
```

- *Type:* string

Optional parser name to specify how to parse the data contained in the log key.

Recommended use is for developers or testing only.

---

##### `regexParser`<sup>Optional</sup> <a name="regexParser" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.regexParser"></a>

```typescript
public readonly regexParser: string;
```

- *Type:* string

Set an alternative Parser to process record Tag and extract pod_name, namespace_name, container_name and docker_id.

The parser must be registered in a parsers file.

> [[Parsers File](https://github.com/fluent/fluent-bit/blob/master/conf/parsers.conf)]([Parsers File](https://github.com/fluent/fluent-bit/blob/master/conf/parsers.conf))

---

##### `tlsDebug`<sup>Optional</sup> <a name="tlsDebug" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.tlsDebug"></a>

```typescript
public readonly tlsDebug: number;
```

- *Type:* number

Debug level between 0 (nothing) and 4 (every detail).

---

##### `tlsVerify`<sup>Optional</sup> <a name="tlsVerify" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.tlsVerify"></a>

```typescript
public readonly tlsVerify: boolean;
```

- *Type:* boolean

When enabled, turns on certificate validation when connecting to the Kubernetes API server.

---

##### `useJournal`<sup>Optional</sup> <a name="useJournal" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.useJournal"></a>

```typescript
public readonly useJournal: boolean;
```

- *Type:* boolean

When enabled, the filter reads logs coming in Journald format.

---

##### `useKubelet`<sup>Optional</sup> <a name="useKubelet" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.useKubelet"></a>

```typescript
public readonly useKubelet: boolean;
```

- *Type:* boolean

This is an optional feature flag to get metadata information from kubelet instead of calling Kube Server API to enhance the log.

> [[Kube API heavy traffic issue for large cluster](https://docs.fluentbit.io/manual/pipeline/filters/kubernetes#optional-feature-using-kubelet-to-get-metadata)]([Kube API heavy traffic issue for large cluster](https://docs.fluentbit.io/manual/pipeline/filters/kubernetes#optional-feature-using-kubelet-to-get-metadata))

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.PLUGIN_NAME">PLUGIN_NAME</a></code> | <code>string</code> | The name of the plugin as it will appear in the fluent bit configuration. |

---

##### `PLUGIN_NAME`<sup>Required</sup> <a name="PLUGIN_NAME" id="cdk-extensions.k8s_aws.FluentBitKubernetesFilter.property.PLUGIN_NAME"></a>

```typescript
public readonly PLUGIN_NAME: string;
```

- *Type:* string

The name of the plugin as it will appear in the fluent bit configuration.

---

### FluentBitLogfmtParser <a name="FluentBitLogfmtParser" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser"></a>

A Fluent Bit filter that parsed inbound messages in LTSV format.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitLogfmtParser(name: string, options?: FluentBitLogfmtParserOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.Initializer.parameter.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions</code> | Options for configuring the parser. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.Initializer.parameter.name"></a>

- *Type:* string

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitLogfmtParserOptions

Options for configuring the parser.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.format">format</a></code> | <code>string</code> | The data format that the parser extracts records from. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.timeFormat">timeFormat</a></code> | <code>string</code> | Defines the format of the timestamp on the inbound record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.timeKey">timeKey</a></code> | <code>string</code> | The key under which timestamp information for the inbound record is given. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.types">types</a></code> | <code>{[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}</code> | Maps group names matched by the regex to the data types they should be interpreted as. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

The data format that the parser extracts records from.

---

##### `timeFormat`<sup>Optional</sup> <a name="timeFormat" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.timeFormat"></a>

```typescript
public readonly timeFormat: string;
```

- *Type:* string

Defines the format of the timestamp on the inbound record.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

The key under which timestamp information for the inbound record is given.

---

##### `types`<sup>Optional</sup> <a name="types" id="cdk-extensions.k8s_aws.FluentBitLogfmtParser.property.types"></a>

```typescript
public readonly types: {[ key: string ]: ParserPluginDataType};
```

- *Type:* {[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}

Maps group names matched by the regex to the data types they should be interpreted as.

---


### FluentBitLogGroupOutput <a name="FluentBitLogGroupOutput" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput"></a>

Represents valid log group output configuration options to be used by Fluent Bit when writing to CloudWatch Logs.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogGroupOutput.create">create</a></code> | Sets a flag saying that a log group should be created automatically. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogGroupOutput.fromLogGroup">fromLogGroup</a></code> | Sets the destination log group to a LogGroup CDK resource. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogGroupOutput.fromName">fromName</a></code> | Sets the destination for logs to the named log group. |

---

##### `create` <a name="create" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.create"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitLogGroupOutput.create()
```

Sets a flag saying that a log group should be created automatically.

Depending on the configuration of the plugin, this flag will either cause
permissions to be granted for Fluent Bit to create the log group itself or
the plugin CDK resource will create a Log Group and use that as the
destination.

##### `fromLogGroup` <a name="fromLogGroup" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.fromLogGroup"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitLogGroupOutput.fromLogGroup(logGroup: ILogGroup)
```

Sets the destination log group to a LogGroup CDK resource.

###### `logGroup`<sup>Required</sup> <a name="logGroup" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.fromLogGroup.parameter.logGroup"></a>

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The log group where output records should be written.

---

##### `fromName` <a name="fromName" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.fromName"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitLogGroupOutput.fromName(name: string, create?: boolean)
```

Sets the destination for logs to the named log group.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.fromName.parameter.name"></a>

- *Type:* string

The name of the log group where output records should be written.

---

###### `create`<sup>Optional</sup> <a name="create" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.fromName.parameter.create"></a>

- *Type:* boolean

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogGroupOutput.property.autoCreate">autoCreate</a></code> | <code>boolean</code> | Flag that determines whether or not a log group should be automatically created. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogGroupOutput.property.logGroup">logGroup</a></code> | <code>aws-cdk-lib.aws_logs.ILogGroup</code> | A log group resource object to use as the destination. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogGroupOutput.property.logGroupName">logGroupName</a></code> | <code>string</code> | The name for the log group that should be used for output records. |

---

##### `autoCreate`<sup>Optional</sup> <a name="autoCreate" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.property.autoCreate"></a>

```typescript
public readonly autoCreate: boolean;
```

- *Type:* boolean

Flag that determines whether or not a log group should be automatically created.

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.property.logGroup"></a>

```typescript
public readonly logGroup: ILogGroup;
```

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

A log group resource object to use as the destination.

---

##### `logGroupName`<sup>Optional</sup> <a name="logGroupName" id="cdk-extensions.k8s_aws.FluentBitLogGroupOutput.property.logGroupName"></a>

```typescript
public readonly logGroupName: string;
```

- *Type:* string

The name for the log group that should be used for output records.

---


### FluentBitLogStreamOutput <a name="FluentBitLogStreamOutput" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput"></a>

Represents valid log stream output configuration options to be used by Fluent Bit when writing to CloudWatch Logs.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromLogStream">fromLogStream</a></code> | Sets output to be a log stream resource object. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromName">fromName</a></code> | Sets output to a named log stream. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromPrefix">fromPrefix</a></code> | Sets output to a prefixed log stream. |

---

##### `fromLogStream` <a name="fromLogStream" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromLogStream"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitLogStreamOutput.fromLogStream(logStream: ILogStream)
```

Sets output to be a log stream resource object.

###### `logStream`<sup>Required</sup> <a name="logStream" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromLogStream.parameter.logStream"></a>

- *Type:* aws-cdk-lib.aws_logs.ILogStream

The log stream where records should be written.

---

##### `fromName` <a name="fromName" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromName"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitLogStreamOutput.fromName(name: string)
```

Sets output to a named log stream.

If a log stream with the given name doesn't exist in the configured log
group a log stream with the given name will be created.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromName.parameter.name"></a>

- *Type:* string

The name of the log stream where records should be written.

---

##### `fromPrefix` <a name="fromPrefix" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromPrefix"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitLogStreamOutput.fromPrefix(prefix: string)
```

Sets output to a prefixed log stream.

Log streams will be created on a per-pod basis with the name oof the log
streams starting with the provided prefix.

###### `prefix`<sup>Required</sup> <a name="prefix" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput.fromPrefix.parameter.prefix"></a>

- *Type:* string

The prefix for log streams which will be created.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogStreamOutput.property.logStreamName">logStreamName</a></code> | <code>string</code> | The name of the log stream where records should be created. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLogStreamOutput.property.logStreamPrefix">logStreamPrefix</a></code> | <code>string</code> | The prefix for log streams that will be created on a per-pod basis. |

---

##### `logStreamName`<sup>Optional</sup> <a name="logStreamName" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput.property.logStreamName"></a>

```typescript
public readonly logStreamName: string;
```

- *Type:* string

The name of the log stream where records should be created.

---

##### `logStreamPrefix`<sup>Optional</sup> <a name="logStreamPrefix" id="cdk-extensions.k8s_aws.FluentBitLogStreamOutput.property.logStreamPrefix"></a>

```typescript
public readonly logStreamPrefix: string;
```

- *Type:* string

The prefix for log streams that will be created on a per-pod basis.

---


### FluentBitLtsvParser <a name="FluentBitLtsvParser" id="cdk-extensions.k8s_aws.FluentBitLtsvParser"></a>

A Fluent Bit filter that parsed inbound messages in LTSV format.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitLtsvParser(name: string, options?: FluentBitLtsvParserOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.Initializer.parameter.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitLtsvParserOptions</code> | Options for configuring the parser. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.Initializer.parameter.name"></a>

- *Type:* string

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitLtsvParserOptions

Options for configuring the parser.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.property.format">format</a></code> | <code>string</code> | The data format that the parser extracts records from. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.property.timeFormat">timeFormat</a></code> | <code>string</code> | Defines the format of the timestamp on the inbound record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.property.timeKey">timeKey</a></code> | <code>string</code> | The key under which timestamp information for the inbound record is given. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitLtsvParser.property.types">types</a></code> | <code>{[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}</code> | Maps group names matched by the regex to the data types they should be interpreted as. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

The data format that the parser extracts records from.

---

##### `timeFormat`<sup>Optional</sup> <a name="timeFormat" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.property.timeFormat"></a>

```typescript
public readonly timeFormat: string;
```

- *Type:* string
- *Default:* Inputs

Defines the format of the timestamp on the inbound record.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string
- *Default:* Inputs

The key under which timestamp information for the inbound record is given.

---

##### `types`<sup>Optional</sup> <a name="types" id="cdk-extensions.k8s_aws.FluentBitLtsvParser.property.types"></a>

```typescript
public readonly types: {[ key: string ]: ParserPluginDataType};
```

- *Type:* {[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}
- *Default:* Inputs

Maps group names matched by the regex to the data types they should be interpreted as.

---


### FluentBitMatch <a name="FluentBitMatch" id="cdk-extensions.k8s_aws.FluentBitMatch"></a>

Represents a filter that can be applied to Filter and Output plugins that scopes down what records the given filter should apply to.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatch.toObject">toObject</a></code> | Creates a record object that can be used to represent the match in Fluent Bit configuration files. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatch.toString">toString</a></code> | Creates a string representation of this match object that reflects how it will appear in a Fluent Bit configuration file. |

---

##### `toObject` <a name="toObject" id="cdk-extensions.k8s_aws.FluentBitMatch.toObject"></a>

```typescript
public toObject(): {[ key: string ]: string}
```

Creates a record object that can be used to represent the match in Fluent Bit configuration files.

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.FluentBitMatch.toString"></a>

```typescript
public toString(): string
```

Creates a string representation of this match object that reflects how it will appear in a Fluent Bit configuration file.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatch.glob">glob</a></code> | Creates a match pattern that supports basic wildcard matching using the star character (`*`). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatch.regex">regex</a></code> | Creates a match pattern that supports full regex matching. |

---

##### `glob` <a name="glob" id="cdk-extensions.k8s_aws.FluentBitMatch.glob"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitMatch.glob(pattern: string)
```

Creates a match pattern that supports basic wildcard matching using the star character (`*`).

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.k8s_aws.FluentBitMatch.glob.parameter.pattern"></a>

- *Type:* string

The pattern to use to match against the tags of an incoming record.

It's case sensitive and support the star (`*`)
character as a wildcard.

---

##### `regex` <a name="regex" id="cdk-extensions.k8s_aws.FluentBitMatch.regex"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitMatch.regex(pattern: string)
```

Creates a match pattern that supports full regex matching.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.k8s_aws.FluentBitMatch.regex.parameter.pattern"></a>

- *Type:* string

A regular expression to match against the tags of incoming records.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatch.property.evaluator">evaluator</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatchEvaluator</code> | The pattern matching syntax to use when evaluating incoming tags. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatch.property.pattern">pattern</a></code> | <code>string</code> | The pattern to compare against the tags of incoming records. |

---

##### `evaluator`<sup>Required</sup> <a name="evaluator" id="cdk-extensions.k8s_aws.FluentBitMatch.property.evaluator"></a>

```typescript
public readonly evaluator: FluentBitMatchEvaluator;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatchEvaluator

The pattern matching syntax to use when evaluating incoming tags.

---

##### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.k8s_aws.FluentBitMatch.property.pattern"></a>

```typescript
public readonly pattern: string;
```

- *Type:* string

The pattern to compare against the tags of incoming records.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatch.property.ALL">ALL</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | Represents a pattern that will match all log entries. |

---

##### `ALL`<sup>Required</sup> <a name="ALL" id="cdk-extensions.k8s_aws.FluentBitMatch.property.ALL"></a>

```typescript
public readonly ALL: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

Represents a pattern that will match all log entries.

---

### FluentBitModifyFilter <a name="FluentBitModifyFilter" id="cdk-extensions.k8s_aws.FluentBitModifyFilter"></a>

A Fluent Bit filter that allows changing records using rules and conditions.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitModifyFilter(options?: FluentBitModifyFilterOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitModifyFilterOptions</code> | The configuration options to use for filter. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitModifyFilterOptions

The configuration options to use for filter.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.addCondition">addCondition</a></code> | Adds a new condition to the modify filter. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.addOperation">addOperation</a></code> | Adds a new operation to the modify filter. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---

##### `addCondition` <a name="addCondition" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.addCondition"></a>

```typescript
public addCondition(condition: ModifyCondition): FluentBitModifyFilter
```

Adds a new condition to the modify filter.

All conditions must evaluate to `true` in order for operations are
performed.

If one or more conditions do not evaluate to true, no conditions are
performed.

###### `condition`<sup>Required</sup> <a name="condition" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.addCondition.parameter.condition"></a>

- *Type:* cdk-extensions.k8s_aws.ModifyCondition

The condition to add to the filter.

---

##### `addOperation` <a name="addOperation" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.addOperation"></a>

```typescript
public addOperation(operation: ModifyOperation): FluentBitModifyFilter
```

Adds a new operation to the modify filter.

###### `operation`<sup>Required</sup> <a name="operation" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.addOperation.parameter.operation"></a>

- *Type:* cdk-extensions.k8s_aws.ModifyOperation

The operation to add to the filter.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.property.conditions">conditions</a></code> | <code>cdk-extensions.k8s_aws.ModifyCondition[]</code> | Collection of conditions to apply for the filter. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitModifyFilter.property.operations">operations</a></code> | <code>cdk-extensions.k8s_aws.ModifyOperation[]</code> | Collection of operations to apply for the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `conditions`<sup>Required</sup> <a name="conditions" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.property.conditions"></a>

```typescript
public readonly conditions: ModifyCondition[];
```

- *Type:* cdk-extensions.k8s_aws.ModifyCondition[]

Collection of conditions to apply for the filter.

---

##### `operations`<sup>Required</sup> <a name="operations" id="cdk-extensions.k8s_aws.FluentBitModifyFilter.property.operations"></a>

```typescript
public readonly operations: ModifyOperation[];
```

- *Type:* cdk-extensions.k8s_aws.ModifyOperation[]

Collection of operations to apply for the filter.

---


### FluentBitNestFilter <a name="FluentBitNestFilter" id="cdk-extensions.k8s_aws.FluentBitNestFilter"></a>

A Fluent Bit filter that allows operating on or with nested data.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitNestFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitNestFilter(options: FluentBitNestFilterOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilter.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitNestFilterOptions</code> | The configuration options for the plugin. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitNestFilter.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitNestFilterOptions

The configuration options for the plugin.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilter.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitNestFilter.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitNestFilter.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilter.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilter.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilter.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilter.property.operation">operation</a></code> | <code>cdk-extensions.k8s_aws.NestFilterOperation</code> | Operation specific details for the plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilter.property.addPrefix">addPrefix</a></code> | <code>string</code> | Prefix affected keys with this string. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitNestFilter.property.removePrefix">removePrefix</a></code> | <code>string</code> | Remove prefix from affected keys if it matches this string. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitNestFilter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitNestFilter.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitNestFilter.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `operation`<sup>Required</sup> <a name="operation" id="cdk-extensions.k8s_aws.FluentBitNestFilter.property.operation"></a>

```typescript
public readonly operation: NestFilterOperation;
```

- *Type:* cdk-extensions.k8s_aws.NestFilterOperation

Operation specific details for the plugin.

---

##### `addPrefix`<sup>Optional</sup> <a name="addPrefix" id="cdk-extensions.k8s_aws.FluentBitNestFilter.property.addPrefix"></a>

```typescript
public readonly addPrefix: string;
```

- *Type:* string

Prefix affected keys with this string.

---

##### `removePrefix`<sup>Optional</sup> <a name="removePrefix" id="cdk-extensions.k8s_aws.FluentBitNestFilter.property.removePrefix"></a>

```typescript
public readonly removePrefix: string;
```

- *Type:* string

Remove prefix from affected keys if it matches this string.

---


### FluentBitOpenSearchOutput <a name="FluentBitOpenSearchOutput" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitOpenSearchOutput(options: FluentBitOpenSearchOutputOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions</code> | Options for configuring the output. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitOpenSearchOutputOptions

Options for configuring the output.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.domain">domain</a></code> | <code>aws-cdk-lib.aws_opensearchservice.IDomain</code> | The Opensearch domain to which logs should be shipped. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.port">port</a></code> | <code>number</code> | TCP port of the target OpenSearch instance. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsAuth">awsAuth</a></code> | <code>boolean</code> | Enable AWS Sigv4 Authentication for Amazon OpenSearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsExternalId">awsExternalId</a></code> | <code>string</code> | External ID for the AWS IAM Role specified with `awsRole`. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsRegion">awsRegion</a></code> | <code>string</code> | Specify the AWS region for Amazon OpenSearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsRole">awsRole</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | AWS IAM Role to assume to put records to your Amazon cluster. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsStsEndpoint">awsStsEndpoint</a></code> | <code>string</code> | Specify the custom sts endpoint to be used with STS API for Amazon OpenSearch Service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.bufferSize">bufferSize</a></code> | <code>cdk-extensions.k8s_aws.OpenSearchOutputBufferSize</code> | Specify the buffer size used to read the response from the OpenSearch HTTP service. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.currentTimeIndex">currentTimeIndex</a></code> | <code>boolean</code> | Use current time for index generation instead of message record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.generateId">generateId</a></code> | <code>boolean</code> | When enabled, generate `_id` for outgoing records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.httpPasswd">httpPasswd</a></code> | <code>string</code> | Password for user defined in `httpUser`. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.httpUser">httpUser</a></code> | <code>string</code> | Optional username credential for access. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.idKey">idKey</a></code> | <code>string</code> | If set, `_id` will be the value of the key from incoming record and `generateId` option is ignored. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.includeTagKey">includeTagKey</a></code> | <code>boolean</code> | When enabled, it append the Tag name to the record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.index">index</a></code> | <code>string</code> | Index name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.logstashDateFormat">logstashDateFormat</a></code> | <code>string</code> | Time format (based on strftime) to generate the second part of the Index name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.logstashFormat">logstashFormat</a></code> | <code>boolean</code> | Enable Logstash format compatibility. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.logstashPrefix">logstashPrefix</a></code> | <code>string</code> | When `logstashFormat` is enabled, the Index name is composed using a prefix and the date, e.g: If `logstashPrefix` is equals to 'mydata' your index will become 'mydata-YYYY.MM.DD'. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.logstashPrefixKey">logstashPrefixKey</a></code> | <code>string</code> | When included: the value in the record that belongs to the key will be looked up and over-write the `logstashPrefix` for index generation. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.path">path</a></code> | <code>string</code> | OpenSearch accepts new data on HTTP query path "/_bulk". |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.pipeline">pipeline</a></code> | <code>string</code> | OpenSearch allows to setup filters called pipelines. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.replaceDots">replaceDots</a></code> | <code>boolean</code> | When enabled, replace field name dots with underscore. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.suppressTypeName">suppressTypeName</a></code> | <code>boolean</code> | When enabled, mapping types is removed and `type` option is ignored. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.tagKey">tagKey</a></code> | <code>string</code> | When `includeTagKey` is enabled, this property defines the key name for the tag. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.timeKey">timeKey</a></code> | <code>string</code> | When `logstashFormat` is enabled, each record will get a new timestamp field. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.timeKeyFormat">timeKeyFormat</a></code> | <code>string</code> | When `logstashFormat` is enabled, this property defines the format of the timestamp. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.timeKeyNanos">timeKeyNanos</a></code> | <code>boolean</code> | When `logstashFormat` is enabled, enabling this property sends nanosecond precision timestamps. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.traceError">traceError</a></code> | <code>boolean</code> | When enabled print the OpenSearch API calls to stdout when OpenSearch returns an error (for diag only). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.traceOutput">traceOutput</a></code> | <code>boolean</code> | When enabled print the OpenSearch API calls to stdout (for diag only). |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.type">type</a></code> | <code>string</code> | Type name. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.workers">workers</a></code> | <code>number</code> | Enables dedicated thread(s) for this output. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.writeOperation">writeOperation</a></code> | <code>string</code> | Operation to use to write in bulk requests. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `domain`<sup>Required</sup> <a name="domain" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.domain"></a>

```typescript
public readonly domain: IDomain;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.IDomain

The Opensearch domain to which logs should be shipped.

---

##### `port`<sup>Required</sup> <a name="port" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

TCP port of the target OpenSearch instance.

---

##### `awsAuth`<sup>Optional</sup> <a name="awsAuth" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsAuth"></a>

```typescript
public readonly awsAuth: boolean;
```

- *Type:* boolean

Enable AWS Sigv4 Authentication for Amazon OpenSearch Service.

---

##### `awsExternalId`<sup>Optional</sup> <a name="awsExternalId" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsExternalId"></a>

```typescript
public readonly awsExternalId: string;
```

- *Type:* string

External ID for the AWS IAM Role specified with `awsRole`.

---

##### `awsRegion`<sup>Optional</sup> <a name="awsRegion" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsRegion"></a>

```typescript
public readonly awsRegion: string;
```

- *Type:* string

Specify the AWS region for Amazon OpenSearch Service.

---

##### `awsRole`<sup>Optional</sup> <a name="awsRole" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsRole"></a>

```typescript
public readonly awsRole: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

AWS IAM Role to assume to put records to your Amazon cluster.

---

##### `awsStsEndpoint`<sup>Optional</sup> <a name="awsStsEndpoint" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.awsStsEndpoint"></a>

```typescript
public readonly awsStsEndpoint: string;
```

- *Type:* string

Specify the custom sts endpoint to be used with STS API for Amazon OpenSearch Service.

---

##### `bufferSize`<sup>Optional</sup> <a name="bufferSize" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.bufferSize"></a>

```typescript
public readonly bufferSize: OpenSearchOutputBufferSize;
```

- *Type:* cdk-extensions.k8s_aws.OpenSearchOutputBufferSize

Specify the buffer size used to read the response from the OpenSearch HTTP service.

This option is useful for debugging purposes where is
required to read full responses, note that response size grows depending
of the number of records inserted.

---

##### `currentTimeIndex`<sup>Optional</sup> <a name="currentTimeIndex" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.currentTimeIndex"></a>

```typescript
public readonly currentTimeIndex: boolean;
```

- *Type:* boolean

Use current time for index generation instead of message record.

---

##### `generateId`<sup>Optional</sup> <a name="generateId" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.generateId"></a>

```typescript
public readonly generateId: boolean;
```

- *Type:* boolean

When enabled, generate `_id` for outgoing records.

This prevents duplicate
records when retrying.

---

##### `httpPasswd`<sup>Optional</sup> <a name="httpPasswd" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.httpPasswd"></a>

```typescript
public readonly httpPasswd: string;
```

- *Type:* string

Password for user defined in `httpUser`.

---

##### `httpUser`<sup>Optional</sup> <a name="httpUser" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.httpUser"></a>

```typescript
public readonly httpUser: string;
```

- *Type:* string

Optional username credential for access.

---

##### `idKey`<sup>Optional</sup> <a name="idKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.idKey"></a>

```typescript
public readonly idKey: string;
```

- *Type:* string

If set, `_id` will be the value of the key from incoming record and `generateId` option is ignored.

---

##### `includeTagKey`<sup>Optional</sup> <a name="includeTagKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.includeTagKey"></a>

```typescript
public readonly includeTagKey: boolean;
```

- *Type:* boolean

When enabled, it append the Tag name to the record.

---

##### `index`<sup>Optional</sup> <a name="index" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* string

Index name.

---

##### `logstashDateFormat`<sup>Optional</sup> <a name="logstashDateFormat" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.logstashDateFormat"></a>

```typescript
public readonly logstashDateFormat: string;
```

- *Type:* string

Time format (based on strftime) to generate the second part of the Index name.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `logstashFormat`<sup>Optional</sup> <a name="logstashFormat" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.logstashFormat"></a>

```typescript
public readonly logstashFormat: boolean;
```

- *Type:* boolean

Enable Logstash format compatibility.

---

##### `logstashPrefix`<sup>Optional</sup> <a name="logstashPrefix" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.logstashPrefix"></a>

```typescript
public readonly logstashPrefix: string;
```

- *Type:* string

When `logstashFormat` is enabled, the Index name is composed using a prefix and the date, e.g: If `logstashPrefix` is equals to 'mydata' your index will become 'mydata-YYYY.MM.DD'.

The last string appended belongs to the date when the data is being
generated.

---

##### `logstashPrefixKey`<sup>Optional</sup> <a name="logstashPrefixKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.logstashPrefixKey"></a>

```typescript
public readonly logstashPrefixKey: string;
```

- *Type:* string

When included: the value in the record that belongs to the key will be looked up and over-write the `logstashPrefix` for index generation.

If
the key/value is not found in the record then the `logstashPrefix` option
will act as a fallback.

Nested keys are not supported (if desired, you can use the nest filter
plugin to remove nesting).

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

OpenSearch accepts new data on HTTP query path "/_bulk".

But it is also
possible to serve OpenSearch behind a reverse proxy on a subpath. This
option defines such path on the fluent-bit side. It simply adds a path
prefix in the indexing HTTP POST URI.

---

##### `pipeline`<sup>Optional</sup> <a name="pipeline" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.pipeline"></a>

```typescript
public readonly pipeline: string;
```

- *Type:* string

OpenSearch allows to setup filters called pipelines.

This option allows
to define which pipeline the database should use.

---

##### `replaceDots`<sup>Optional</sup> <a name="replaceDots" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.replaceDots"></a>

```typescript
public readonly replaceDots: boolean;
```

- *Type:* boolean

When enabled, replace field name dots with underscore.

---

##### `suppressTypeName`<sup>Optional</sup> <a name="suppressTypeName" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.suppressTypeName"></a>

```typescript
public readonly suppressTypeName: boolean;
```

- *Type:* boolean

When enabled, mapping types is removed and `type` option is ignored.

---

##### `tagKey`<sup>Optional</sup> <a name="tagKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.tagKey"></a>

```typescript
public readonly tagKey: string;
```

- *Type:* string

When `includeTagKey` is enabled, this property defines the key name for the tag.

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

When `logstashFormat` is enabled, each record will get a new timestamp field.

The`timeKey` property defines the name of that field.

---

##### `timeKeyFormat`<sup>Optional</sup> <a name="timeKeyFormat" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.timeKeyFormat"></a>

```typescript
public readonly timeKeyFormat: string;
```

- *Type:* string

When `logstashFormat` is enabled, this property defines the format of the timestamp.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKeyNanos`<sup>Optional</sup> <a name="timeKeyNanos" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.timeKeyNanos"></a>

```typescript
public readonly timeKeyNanos: boolean;
```

- *Type:* boolean

When `logstashFormat` is enabled, enabling this property sends nanosecond precision timestamps.

---

##### `traceError`<sup>Optional</sup> <a name="traceError" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.traceError"></a>

```typescript
public readonly traceError: boolean;
```

- *Type:* boolean

When enabled print the OpenSearch API calls to stdout when OpenSearch returns an error (for diag only).

---

##### `traceOutput`<sup>Optional</sup> <a name="traceOutput" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.traceOutput"></a>

```typescript
public readonly traceOutput: boolean;
```

- *Type:* boolean

When enabled print the OpenSearch API calls to stdout (for diag only).

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Type name.

---

##### `workers`<sup>Optional</sup> <a name="workers" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.workers"></a>

```typescript
public readonly workers: number;
```

- *Type:* number

Enables dedicated thread(s) for this output.

---

##### `writeOperation`<sup>Optional</sup> <a name="writeOperation" id="cdk-extensions.k8s_aws.FluentBitOpenSearchOutput.property.writeOperation"></a>

```typescript
public readonly writeOperation: string;
```

- *Type:* string

Operation to use to write in bulk requests.

---


### FluentBitOutput <a name="FluentBitOutput" id="cdk-extensions.k8s_aws.FluentBitOutput"></a>

Common options that allow configuration of destinations where Fluent Bit should send records after processing.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitOutput.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitOutput()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutput.cloudwatchLogs">cloudwatchLogs</a></code> | Sends matched records to a CloudWatch Logs log group. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutput.kinesis">kinesis</a></code> | Sends matched records to a Kinesis data stream. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutput.kinesisFirehose">kinesisFirehose</a></code> | Sends matched records to a Kinesis Firehose delivery stream. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutput.opensearch">opensearch</a></code> | Sends matched records to an OpenSearch domain. |

---

##### `cloudwatchLogs` <a name="cloudwatchLogs" id="cdk-extensions.k8s_aws.FluentBitOutput.cloudwatchLogs"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitOutput.cloudwatchLogs(match: FluentBitMatch, logGroup: ILogGroup)
```

Sends matched records to a CloudWatch Logs log group.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitOutput.cloudwatchLogs.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the output should be applied.

---

###### `logGroup`<sup>Required</sup> <a name="logGroup" id="cdk-extensions.k8s_aws.FluentBitOutput.cloudwatchLogs.parameter.logGroup"></a>

- *Type:* aws-cdk-lib.aws_logs.ILogGroup

The log group where matched records should be sent.

---

##### `kinesis` <a name="kinesis" id="cdk-extensions.k8s_aws.FluentBitOutput.kinesis"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitOutput.kinesis(match: FluentBitMatch, stream: IStream)
```

Sends matched records to a Kinesis data stream.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitOutput.kinesis.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the output should be applied.

---

###### `stream`<sup>Required</sup> <a name="stream" id="cdk-extensions.k8s_aws.FluentBitOutput.kinesis.parameter.stream"></a>

- *Type:* aws-cdk-lib.aws_kinesis.IStream

The Kinesis stream where matched records should be sent.

---

##### `kinesisFirehose` <a name="kinesisFirehose" id="cdk-extensions.k8s_aws.FluentBitOutput.kinesisFirehose"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitOutput.kinesisFirehose(match: FluentBitMatch, deliveryStream: IDeliveryStream)
```

Sends matched records to a Kinesis Firehose delivery stream.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitOutput.kinesisFirehose.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the output should be applied.

---

###### `deliveryStream`<sup>Required</sup> <a name="deliveryStream" id="cdk-extensions.k8s_aws.FluentBitOutput.kinesisFirehose.parameter.deliveryStream"></a>

- *Type:* cdk-extensions.kinesis_firehose.IDeliveryStream

The Firehose delivery stream where matched records should be sent.

---

##### `opensearch` <a name="opensearch" id="cdk-extensions.k8s_aws.FluentBitOutput.opensearch"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitOutput.opensearch(match: FluentBitMatch, domain: IDomain)
```

Sends matched records to an OpenSearch domain.

###### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitOutput.opensearch.parameter.match"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

A pattern filtering to which records the output should be applied.

---

###### `domain`<sup>Required</sup> <a name="domain" id="cdk-extensions.k8s_aws.FluentBitOutput.opensearch.parameter.domain"></a>

- *Type:* aws-cdk-lib.aws_opensearchservice.IDomain

The OpenSearch domain where matched records should be sent.

---



### FluentBitOutputPluginBase <a name="FluentBitOutputPluginBase" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase"></a>

- *Implements:* cdk-extensions.k8s_aws.IFluentBitOutputPlugin

Represents a Fluent Bit plugin that controls log output to a given destination.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitOutputPluginBase(name: string, options?: FluentBitOutputPluginCommonOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutputPluginBase.Initializer.parameter.name">name</a></code> | <code>string</code> | The name of the output plugin to configure. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutputPluginBase.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitOutputPluginCommonOptions</code> | Configuration options that apply to all Fluent Bit output plugin. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase.Initializer.parameter.name"></a>

- *Type:* string

The name of the output plugin to configure.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitOutputPluginCommonOptions

Configuration options that apply to all Fluent Bit output plugin.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutputPluginBase.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutputPluginBase.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutputPluginBase.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitOutputPluginBase.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitOutputPluginBase.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---


### FluentBitParser <a name="FluentBitParser" id="cdk-extensions.k8s_aws.FluentBitParser"></a>

Standard parse comfigurations which can be applied to Fluent Bit to allow for parsing data from incoming records.

The records to which parsers are applied is controlled using the parser
filter.

> [{@link FluentBitParserFilter}]({@link FluentBitParserFilter})

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitParser.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitParser()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParser.json">json</a></code> | Creates a parser that processes records that are formatted in JSON. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParser.logfmt">logfmt</a></code> | Creates a parser that processes records that are formatted using the `logfmt` standard. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParser.ltsv">ltsv</a></code> | Creates a parser that processes records that are formatted using the `ltsv` standard. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParser.regex">regex</a></code> | Creates a parser that uses regular expressions to parse incoming records. |

---

##### `json` <a name="json" id="cdk-extensions.k8s_aws.FluentBitParser.json"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitParser.json(name: string)
```

Creates a parser that processes records that are formatted in JSON.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitParser.json.parameter.name"></a>

- *Type:* string

The name of the parser which will be used for referencing it in other configurations.

---

##### `logfmt` <a name="logfmt" id="cdk-extensions.k8s_aws.FluentBitParser.logfmt"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitParser.logfmt(name: string)
```

Creates a parser that processes records that are formatted using the `logfmt` standard.

> [[Golang logfmt documentation](https://pkg.go.dev/github.com/kr/logfmt)]([Golang logfmt documentation](https://pkg.go.dev/github.com/kr/logfmt))

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitParser.logfmt.parameter.name"></a>

- *Type:* string

The name of the parser which will be used for referencing it in other configurations.

---

##### `ltsv` <a name="ltsv" id="cdk-extensions.k8s_aws.FluentBitParser.ltsv"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitParser.ltsv(name: string)
```

Creates a parser that processes records that are formatted using the `ltsv` standard.

> [[LTSV](http://ltsv.org/)]([LTSV](http://ltsv.org/))

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitParser.ltsv.parameter.name"></a>

- *Type:* string

The name of the parser which will be used for referencing it in other configurations.

---

##### `regex` <a name="regex" id="cdk-extensions.k8s_aws.FluentBitParser.regex"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.FluentBitParser.regex(name: string, regex: string)
```

Creates a parser that uses regular expressions to parse incoming records.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitParser.regex.parameter.name"></a>

- *Type:* string

The name of the parser which will be used for referencing it in other configurations.

---

###### `regex`<sup>Required</sup> <a name="regex" id="cdk-extensions.k8s_aws.FluentBitParser.regex.parameter.regex"></a>

- *Type:* string

The regular expression to use to parse records.

---



### FluentBitParserFilter <a name="FluentBitParserFilter" id="cdk-extensions.k8s_aws.FluentBitParserFilter"></a>

A Fluent Bit filter that allows parsing of fields in event records.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitParserFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitParserFilter(options: FluentBitParserFilterOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitParserFilterOptions</code> | The configuration options to use for filter. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitParserFilter.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitParserFilterOptions

The configuration options to use for filter.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.addParser">addParser</a></code> | Adds a new parser to apply to matched log entries. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitParserFilter.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitParserFilter.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---

##### `addParser` <a name="addParser" id="cdk-extensions.k8s_aws.FluentBitParserFilter.addParser"></a>

```typescript
public addParser(parser: IFluentBitParserPlugin): FluentBitParserFilter
```

Adds a new parser to apply to matched log entries.

###### `parser`<sup>Required</sup> <a name="parser" id="cdk-extensions.k8s_aws.FluentBitParserFilter.addParser.parameter.parser"></a>

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin

The parser to use for matched log entries.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.property.keyName">keyName</a></code> | <code>string</code> | Specify field name in record to parse. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.property.parsers">parsers</a></code> | <code>cdk-extensions.k8s_aws.IFluentBitParserPlugin[]</code> | Collection of the parsers that should be used to evaluate the filter. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.property.preserveKey">preserveKey</a></code> | <code>boolean</code> | Keep original `keyName` field in the parsed result. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserFilter.property.reserveData">reserveData</a></code> | <code>boolean</code> | Keep all other original fields in the parsed result. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitParserFilter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitParserFilter.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitParserFilter.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `keyName`<sup>Required</sup> <a name="keyName" id="cdk-extensions.k8s_aws.FluentBitParserFilter.property.keyName"></a>

```typescript
public readonly keyName: string;
```

- *Type:* string

Specify field name in record to parse.

---

##### `parsers`<sup>Required</sup> <a name="parsers" id="cdk-extensions.k8s_aws.FluentBitParserFilter.property.parsers"></a>

```typescript
public readonly parsers: IFluentBitParserPlugin[];
```

- *Type:* cdk-extensions.k8s_aws.IFluentBitParserPlugin[]

Collection of the parsers that should be used to evaluate the filter.

---

##### `preserveKey`<sup>Optional</sup> <a name="preserveKey" id="cdk-extensions.k8s_aws.FluentBitParserFilter.property.preserveKey"></a>

```typescript
public readonly preserveKey: boolean;
```

- *Type:* boolean
- *Default:* false

Keep original `keyName` field in the parsed result.

If `false`, the field will be removed.

---

##### `reserveData`<sup>Optional</sup> <a name="reserveData" id="cdk-extensions.k8s_aws.FluentBitParserFilter.property.reserveData"></a>

```typescript
public readonly reserveData: boolean;
```

- *Type:* boolean
- *Default:* false

Keep all other original fields in the parsed result.

If `false`, all other original fields will be removed.

---


### FluentBitParserPluginBase <a name="FluentBitParserPluginBase" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase"></a>

- *Implements:* cdk-extensions.k8s_aws.IFluentBitParserPlugin

Represents a Fluent Bit plugin that parses inbound records to populate fields.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitParserPluginBase(name: string, format: string, _options?: FluentBitParserPluginCommonOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserPluginBase.Initializer.parameter.name">name</a></code> | <code>string</code> | The name of the output plugin to configure. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserPluginBase.Initializer.parameter.format">format</a></code> | <code>string</code> | The data format that the parser extracts records from. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserPluginBase.Initializer.parameter._options">_options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitParserPluginCommonOptions</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.Initializer.parameter.name"></a>

- *Type:* string

The name of the output plugin to configure.

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.Initializer.parameter.format"></a>

- *Type:* string

The data format that the parser extracts records from.

---

##### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.Initializer.parameter._options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitParserPluginCommonOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserPluginBase.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserPluginBase.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserPluginBase.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitParserPluginBase.property.format">format</a></code> | <code>string</code> | The data format that the parser extracts records from. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.k8s_aws.FluentBitParserPluginBase.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

The data format that the parser extracts records from.

---


### FluentBitPlugin <a name="FluentBitPlugin" id="cdk-extensions.k8s_aws.FluentBitPlugin"></a>

- *Implements:* cdk-extensions.k8s_aws.IFluentBitPlugin

A Fluent Bit plugin that allows for configuration of options and can be used to configure logging from containers.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitPlugin.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitPlugin(options: FluentBitPluginCommonOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPlugin.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitPluginCommonOptions</code> | Configuration options for the plugin. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitPlugin.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitPluginCommonOptions

Configuration options for the plugin.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPlugin.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitPlugin.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.FluentBitPlugin.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPlugin.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPlugin.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitPlugin.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitPlugin.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---


### FluentBitRecordModifierFilter <a name="FluentBitRecordModifierFilter" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter"></a>

A Fluent Bit filter that allows appending fields or excluding specific fields.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitRecordModifierFilter(options?: FluentBitRecordModifierFilterOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions</code> | The configuration options to use for filter. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitRecordModifierFilterOptions

The configuration options to use for filter.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addAllow">addAllow</a></code> | Adds a tag to be allowed on a matched input record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addRecord">addRecord</a></code> | Add a record to be appended to matched events. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addRemove">addRemove</a></code> | Adds a tag to be removed on a matched input record. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---

##### `addAllow` <a name="addAllow" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addAllow"></a>

```typescript
public addAllow(tag: string): FluentBitRecordModifierFilter
```

Adds a tag to be allowed on a matched input record.

If a tag is not matched it is removed.

###### `tag`<sup>Required</sup> <a name="tag" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addAllow.parameter.tag"></a>

- *Type:* string

The tag to add to the allow list.

---

##### `addRecord` <a name="addRecord" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addRecord"></a>

```typescript
public addRecord(record: AppendedRecord): FluentBitRecordModifierFilter
```

Add a record to be appended to matched events.

###### `record`<sup>Required</sup> <a name="record" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addRecord.parameter.record"></a>

- *Type:* cdk-extensions.k8s_aws.AppendedRecord

The record to be appended to matched input.

---

##### `addRemove` <a name="addRemove" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addRemove"></a>

```typescript
public addRemove(tag: string): FluentBitRecordModifierFilter
```

Adds a tag to be removed on a matched input record.

If a tag is matched it is removed.

###### `tag`<sup>Required</sup> <a name="tag" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.addRemove.parameter.tag"></a>

- *Type:* string

The tag to add to the allow list.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.allow">allow</a></code> | <code>string[]</code> | Collection of tags that are allowed on a matched input record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.records">records</a></code> | <code>cdk-extensions.k8s_aws.AppendedRecord[]</code> | Collection of the records to be appending to matched input. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.remove">remove</a></code> | <code>string[]</code> | Collection of tags to exclude from a matched input record. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `allow`<sup>Required</sup> <a name="allow" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.allow"></a>

```typescript
public readonly allow: string[];
```

- *Type:* string[]

Collection of tags that are allowed on a matched input record.

If a tag is not matched it is removed.

---

##### `records`<sup>Required</sup> <a name="records" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.records"></a>

```typescript
public readonly records: AppendedRecord[];
```

- *Type:* cdk-extensions.k8s_aws.AppendedRecord[]

Collection of the records to be appending to matched input.

---

##### `remove`<sup>Required</sup> <a name="remove" id="cdk-extensions.k8s_aws.FluentBitRecordModifierFilter.property.remove"></a>

```typescript
public readonly remove: string[];
```

- *Type:* string[]

Collection of tags to exclude from a matched input record.

If a tag is matched it is removed.

---


### FluentBitRegexParser <a name="FluentBitRegexParser" id="cdk-extensions.k8s_aws.FluentBitRegexParser"></a>

A Fluent Bit filter that parsed inbound messages using regular expressions.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitRegexParser.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitRegexParser(name: string, options: FluentBitRegexParserOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.Initializer.parameter.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitRegexParserOptions</code> | Options for configuring the parser. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitRegexParser.Initializer.parameter.name"></a>

- *Type:* string

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitRegexParser.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitRegexParserOptions

Options for configuring the parser.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitRegexParser.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitRegexParser.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.property.format">format</a></code> | <code>string</code> | The data format that the parser extracts records from. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.property.regex">regex</a></code> | <code>string</code> | The regular expression to use to parse the incoming records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.property.skipEmptyValues">skipEmptyValues</a></code> | <code>boolean</code> | If enabled, the parser ignores empty value of the record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.property.timeFormat">timeFormat</a></code> | <code>string</code> | Defines the format of the timestamp on the inbound record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.property.timeKey">timeKey</a></code> | <code>string</code> | The key under which timestamp information for the inbound record is given. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRegexParser.property.types">types</a></code> | <code>{[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}</code> | Maps group names matched by the regex to the data types they should be interpreted as. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitRegexParser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitRegexParser.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.k8s_aws.FluentBitRegexParser.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

The data format that the parser extracts records from.

---

##### `regex`<sup>Required</sup> <a name="regex" id="cdk-extensions.k8s_aws.FluentBitRegexParser.property.regex"></a>

```typescript
public readonly regex: string;
```

- *Type:* string

The regular expression to use to parse the incoming records.

Use regex group names to define the name of fields being captured.

---

##### `skipEmptyValues`<sup>Optional</sup> <a name="skipEmptyValues" id="cdk-extensions.k8s_aws.FluentBitRegexParser.property.skipEmptyValues"></a>

```typescript
public readonly skipEmptyValues: boolean;
```

- *Type:* boolean

If enabled, the parser ignores empty value of the record.

---

##### `timeFormat`<sup>Optional</sup> <a name="timeFormat" id="cdk-extensions.k8s_aws.FluentBitRegexParser.property.timeFormat"></a>

```typescript
public readonly timeFormat: string;
```

- *Type:* string

Defines the format of the timestamp on the inbound record.

> [[strftime](http://man7.org/linux/man-pages/man3/strftime.3.html)]([strftime](http://man7.org/linux/man-pages/man3/strftime.3.html))

---

##### `timeKey`<sup>Optional</sup> <a name="timeKey" id="cdk-extensions.k8s_aws.FluentBitRegexParser.property.timeKey"></a>

```typescript
public readonly timeKey: string;
```

- *Type:* string

The key under which timestamp information for the inbound record is given.

---

##### `types`<sup>Optional</sup> <a name="types" id="cdk-extensions.k8s_aws.FluentBitRegexParser.property.types"></a>

```typescript
public readonly types: {[ key: string ]: ParserPluginDataType};
```

- *Type:* {[ key: string ]: cdk-extensions.k8s_aws.ParserPluginDataType}

Maps group names matched by the regex to the data types they should be interpreted as.

---


### FluentBitRewriteTagFilter <a name="FluentBitRewriteTagFilter" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter"></a>

A Fluent Bit filter that allows parsing of fields in event records.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitRewriteTagFilter(options?: FluentBitRewriteTagFilterOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions</code> | The configuration options to use for filter. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitRewriteTagFilterOptions

The configuration options to use for filter.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.addRule">addRule</a></code> | Adds a new rule to apply to matched log entries. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---

##### `addRule` <a name="addRule" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.addRule"></a>

```typescript
public addRule(rule: RewriteTagRule): FluentBitRewriteTagFilter
```

Adds a new rule to apply to matched log entries.

###### `rule`<sup>Required</sup> <a name="rule" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.addRule.parameter.rule"></a>

- *Type:* cdk-extensions.k8s_aws.RewriteTagRule

The rule to apply for matched log entries.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.emitterName">emitterName</a></code> | <code>string</code> | When the filter emits a record under the new Tag, there is an internal emitter plugin that takes care of the job. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.rules">rules</a></code> | <code>cdk-extensions.k8s_aws.RewriteTagRule[]</code> | Collection of rules defining matching criteria and the format of the tag for the matching record. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.emitterMemBufLimit">emitterMemBufLimit</a></code> | <code>cdk-extensions.core.DataSize</code> | Set a limit on the amount of memory the tag rewrite emitter can consume if the outputs provide backpressure. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.emitterStorageType">emitterStorageType</a></code> | <code>cdk-extensions.k8s_aws.EmitterStorageType</code> | Define a buffering mechanism for the new records created. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `emitterName`<sup>Required</sup> <a name="emitterName" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.emitterName"></a>

```typescript
public readonly emitterName: string;
```

- *Type:* string

When the filter emits a record under the new Tag, there is an internal emitter plugin that takes care of the job.

Since this emitter expose
metrics as any other component of the pipeline, you can use this
property to configure an optional name for it.

---

##### `rules`<sup>Required</sup> <a name="rules" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.rules"></a>

```typescript
public readonly rules: RewriteTagRule[];
```

- *Type:* cdk-extensions.k8s_aws.RewriteTagRule[]

Collection of rules defining matching criteria and the format of the tag for the matching record.

---

##### `emitterMemBufLimit`<sup>Optional</sup> <a name="emitterMemBufLimit" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.emitterMemBufLimit"></a>

```typescript
public readonly emitterMemBufLimit: DataSize;
```

- *Type:* cdk-extensions.core.DataSize

Set a limit on the amount of memory the tag rewrite emitter can consume if the outputs provide backpressure.

---

##### `emitterStorageType`<sup>Optional</sup> <a name="emitterStorageType" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.emitterStorageType"></a>

```typescript
public readonly emitterStorageType: EmitterStorageType;
```

- *Type:* cdk-extensions.k8s_aws.EmitterStorageType

Define a buffering mechanism for the new records created.

Note these records are part of the emitter plugin.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.PLUGIN_NAME">PLUGIN_NAME</a></code> | <code>string</code> | The name of the plugin as it will appear in the fluent bit configuration. |

---

##### `PLUGIN_NAME`<sup>Required</sup> <a name="PLUGIN_NAME" id="cdk-extensions.k8s_aws.FluentBitRewriteTagFilter.property.PLUGIN_NAME"></a>

```typescript
public readonly PLUGIN_NAME: string;
```

- *Type:* string

The name of the plugin as it will appear in the fluent bit configuration.

---

### FluentBitThrottleFilter <a name="FluentBitThrottleFilter" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter"></a>

A Fluent Bit filter that sets the average *Rate* of messages per *Interval*, based on leaky bucket and sliding window algorithm.

In case of overflood,
it will leak within certain rate.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.FluentBitThrottleFilter(options?: FluentBitThrottleFilterOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions</code> | Options for configuring the filter. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.FluentBitThrottleFilterOptions

Options for configuring the filter.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.bind"></a>

```typescript
public bind(_scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring logging using Fluent Bit.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.match">match</a></code> | <code>cdk-extensions.k8s_aws.FluentBitMatch</code> | The pattern to match for records that this output should apply to. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.interval">interval</a></code> | <code>aws-cdk-lib.Duration</code> | Time interval. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.rate">rate</a></code> | <code>number</code> | Amount of messages for the time. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.window">window</a></code> | <code>number</code> | Amount of intervals to calculate average over. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.printStatus">printStatus</a></code> | <code>boolean</code> | Whether to print status messages with current rate and the limits to information logs. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `match`<sup>Required</sup> <a name="match" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.match"></a>

```typescript
public readonly match: FluentBitMatch;
```

- *Type:* cdk-extensions.k8s_aws.FluentBitMatch

The pattern to match for records that this output should apply to.

---

##### `interval`<sup>Required</sup> <a name="interval" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.interval"></a>

```typescript
public readonly interval: Duration;
```

- *Type:* aws-cdk-lib.Duration

Time interval.

---

##### `rate`<sup>Required</sup> <a name="rate" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.rate"></a>

```typescript
public readonly rate: number;
```

- *Type:* number

Amount of messages for the time.

---

##### `window`<sup>Required</sup> <a name="window" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.window"></a>

```typescript
public readonly window: number;
```

- *Type:* number

Amount of intervals to calculate average over.

---

##### `printStatus`<sup>Optional</sup> <a name="printStatus" id="cdk-extensions.k8s_aws.FluentBitThrottleFilter.property.printStatus"></a>

```typescript
public readonly printStatus: boolean;
```

- *Type:* boolean

Whether to print status messages with current rate and the limits to information logs.

---


### GlueVersion <a name="GlueVersion" id="cdk-extensions.glue.GlueVersion"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.GlueVersion.of">of</a></code> | Custom Glue version. |

---

##### `of` <a name="of" id="cdk-extensions.glue.GlueVersion.of"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.GlueVersion.of(version: string)
```

Custom Glue version.

###### `version`<sup>Required</sup> <a name="version" id="cdk-extensions.glue.GlueVersion.of.parameter.version"></a>

- *Type:* string

custom version.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.GlueVersion.property.name">name</a></code> | <code>string</code> | The name of this GlueVersion, as expected by Job resource. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.glue.GlueVersion.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this GlueVersion, as expected by Job resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.GlueVersion.property.V0_9">V0_9</a></code> | <code>cdk-extensions.glue.GlueVersion</code> | Glue version using Spark 2.2.1 and Python 2.7. |
| <code><a href="#cdk-extensions.glue.GlueVersion.property.V1_0">V1_0</a></code> | <code>cdk-extensions.glue.GlueVersion</code> | Glue version using Spark 2.4.3, Python 2.7 and Python 3.6. |
| <code><a href="#cdk-extensions.glue.GlueVersion.property.V2_0">V2_0</a></code> | <code>cdk-extensions.glue.GlueVersion</code> | Glue version using Spark 2.4.3 and Python 3.7. |
| <code><a href="#cdk-extensions.glue.GlueVersion.property.V3_0">V3_0</a></code> | <code>cdk-extensions.glue.GlueVersion</code> | Glue version using Spark 3.1.1 and Python 3.7. |

---

##### `V0_9`<sup>Required</sup> <a name="V0_9" id="cdk-extensions.glue.GlueVersion.property.V0_9"></a>

```typescript
public readonly V0_9: GlueVersion;
```

- *Type:* cdk-extensions.glue.GlueVersion

Glue version using Spark 2.2.1 and Python 2.7.

---

##### `V1_0`<sup>Required</sup> <a name="V1_0" id="cdk-extensions.glue.GlueVersion.property.V1_0"></a>

```typescript
public readonly V1_0: GlueVersion;
```

- *Type:* cdk-extensions.glue.GlueVersion

Glue version using Spark 2.4.3, Python 2.7 and Python 3.6.

---

##### `V2_0`<sup>Required</sup> <a name="V2_0" id="cdk-extensions.glue.GlueVersion.property.V2_0"></a>

```typescript
public readonly V2_0: GlueVersion;
```

- *Type:* cdk-extensions.glue.GlueVersion

Glue version using Spark 2.4.3 and Python 3.7.

---

##### `V3_0`<sup>Required</sup> <a name="V3_0" id="cdk-extensions.glue.GlueVersion.property.V3_0"></a>

```typescript
public readonly V3_0: GlueVersion;
```

- *Type:* cdk-extensions.glue.GlueVersion

Glue version using Spark 3.1.1 and Python 3.7.

---

### Group <a name="Group" id="cdk-extensions.sso.Group"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.sso.Group.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.Group()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.Group.fromGroupId">fromGroupId</a></code> | *No description.* |

---

##### `fromGroupId` <a name="fromGroupId" id="cdk-extensions.sso.Group.fromGroupId"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.Group.fromGroupId(scope: IConstruct, id: string, groupId: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.Group.fromGroupId.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.Group.fromGroupId.parameter.id"></a>

- *Type:* string

---

###### `groupId`<sup>Required</sup> <a name="groupId" id="cdk-extensions.sso.Group.fromGroupId.parameter.groupId"></a>

- *Type:* string

---



### HiveJsonInputSerDe <a name="HiveJsonInputSerDe" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.HiveJsonInputSerDe(options?: HiveJsonInputSerDeOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions</code> | *No description.* |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.addTimestampFormat">addTimestampFormat</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.bind"></a>

```typescript
public bind(_scope: IConstruct): InputFormatConfigurationProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

##### `addTimestampFormat` <a name="addTimestampFormat" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.addTimestampFormat"></a>

```typescript
public addTimestampFormat(format: string): HiveJsonInputSerDe
```

###### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.addTimestampFormat.parameter.format"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.hiveJson">hiveJson</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.openxJson">openxJson</a></code> | *No description.* |

---

##### `hiveJson` <a name="hiveJson" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.hiveJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.HiveJsonInputSerDe.hiveJson(options: HiveJsonInputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.hiveJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions

---

##### `openxJson` <a name="openxJson" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.openxJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.HiveJsonInputSerDe.openxJson(options: OpenxJsonInputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.HiveJsonInputSerDe.openxJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions

---



### HttpEndpointDestination <a name="HttpEndpointDestination" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.HttpEndpointDestination(url: string, options?: HttpEndpointDestinationOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.Initializer.parameter.url">url</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions</code> | *No description.* |

---

##### `url`<sup>Required</sup> <a name="url" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.Initializer.parameter.url"></a>

- *Type:* string

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.HttpEndpointDestinationOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.addCommonAttribute">addCommonAttribute</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.addProcessor">addProcessor</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.bind"></a>

```typescript
public bind(scope: IConstruct): DeliveryStreamDestinationConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `addCommonAttribute` <a name="addCommonAttribute" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.addCommonAttribute"></a>

```typescript
public addCommonAttribute(name: string, value: string): HttpEndpointDestination
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.addCommonAttribute.parameter.name"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.addCommonAttribute.parameter.value"></a>

- *Type:* string

---

##### `addProcessor` <a name="addProcessor" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.addProcessor"></a>

```typescript
public addProcessor(processor: DeliveryStreamProcessor): HttpEndpointDestination
```

###### `processor`<sup>Required</sup> <a name="processor" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.addProcessor.parameter.processor"></a>

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProcessor

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.endpointUrl">endpointUrl</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.processingEnabled">processingEnabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.accessKey">accessKey</a></code> | <code>aws-cdk-lib.SecretValue</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.backupConfiguration">backupConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.BackupConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.buffering">buffering</a></code> | <code>cdk-extensions.kinesis_firehose.BufferingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.cloudwatchLoggingConfiguration">cloudwatchLoggingConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.commonAttributes">commonAttributes</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.contentEncoding">contentEncoding</a></code> | <code>cdk-extensions.kinesis_firehose.ContentEncoding</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.endpointName">endpointName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.processorConfiguration">processorConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.retryDuration">retryDuration</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `endpointUrl`<sup>Required</sup> <a name="endpointUrl" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.endpointUrl"></a>

```typescript
public readonly endpointUrl: string;
```

- *Type:* string

---

##### `processingEnabled`<sup>Required</sup> <a name="processingEnabled" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.processingEnabled"></a>

```typescript
public readonly processingEnabled: boolean;
```

- *Type:* boolean

---

##### `accessKey`<sup>Optional</sup> <a name="accessKey" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.accessKey"></a>

```typescript
public readonly accessKey: SecretValue;
```

- *Type:* aws-cdk-lib.SecretValue

---

##### `backupConfiguration`<sup>Optional</sup> <a name="backupConfiguration" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.backupConfiguration"></a>

```typescript
public readonly backupConfiguration: BackupConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BackupConfiguration

---

##### `buffering`<sup>Optional</sup> <a name="buffering" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.buffering"></a>

```typescript
public readonly buffering: BufferingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BufferingConfiguration

---

##### `cloudwatchLoggingConfiguration`<sup>Optional</sup> <a name="cloudwatchLoggingConfiguration" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.cloudwatchLoggingConfiguration"></a>

```typescript
public readonly cloudwatchLoggingConfiguration: CloudWatchLoggingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration

---

##### `commonAttributes`<sup>Optional</sup> <a name="commonAttributes" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.commonAttributes"></a>

```typescript
public readonly commonAttributes: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `contentEncoding`<sup>Optional</sup> <a name="contentEncoding" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.contentEncoding"></a>

```typescript
public readonly contentEncoding: ContentEncoding;
```

- *Type:* cdk-extensions.kinesis_firehose.ContentEncoding

---

##### `endpointName`<sup>Optional</sup> <a name="endpointName" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.endpointName"></a>

```typescript
public readonly endpointName: string;
```

- *Type:* string

---

##### `processorConfiguration`<sup>Optional</sup> <a name="processorConfiguration" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.processorConfiguration"></a>

```typescript
public readonly processorConfiguration: ProcessorConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorConfiguration

---

##### `retryDuration`<sup>Optional</sup> <a name="retryDuration" id="cdk-extensions.kinesis_firehose.HttpEndpointDestination.property.retryDuration"></a>

```typescript
public readonly retryDuration: Duration;
```

- *Type:* aws-cdk-lib.Duration

---


### IdentityCenterPrincipalType <a name="IdentityCenterPrincipalType" id="cdk-extensions.sso.IdentityCenterPrincipalType"></a>

Provides a wrapper around the accepted values for the IAM Identity Center [Assignment.PrincipalType attribute](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-assignment.html#cfn-sso-assignment-principaltype).

Accepted values are provided as static properties that can be used when
configuring an assignment.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.IdentityCenterPrincipalType.of">of</a></code> | An escape hatch method that allows specifying a custom principal types in the even more options are added and the provided static types are yet to catch up. |

---

##### `of` <a name="of" id="cdk-extensions.sso.IdentityCenterPrincipalType.of"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.IdentityCenterPrincipalType.of(name: string)
```

An escape hatch method that allows specifying a custom principal types in the even more options are added and the provided static types are yet to catch up.

It is recommended that the provided static types be used when possible
instead of calling `of`.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.sso.IdentityCenterPrincipalType.of.parameter.name"></a>

- *Type:* string

The name for a type of IAM Identity Center Principal.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.IdentityCenterPrincipalType.property.name">name</a></code> | <code>string</code> | The name for a type of IAM Identity Center Principal. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.sso.IdentityCenterPrincipalType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name for a type of IAM Identity Center Principal.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.IdentityCenterPrincipalType.property.GROUP">GROUP</a></code> | <code>cdk-extensions.sso.IdentityCenterPrincipalType</code> | An IAM Identity Center group. |
| <code><a href="#cdk-extensions.sso.IdentityCenterPrincipalType.property.USER">USER</a></code> | <code>cdk-extensions.sso.IdentityCenterPrincipalType</code> | An IAM Identity Center user. |

---

##### `GROUP`<sup>Required</sup> <a name="GROUP" id="cdk-extensions.sso.IdentityCenterPrincipalType.property.GROUP"></a>

```typescript
public readonly GROUP: IdentityCenterPrincipalType;
```

- *Type:* cdk-extensions.sso.IdentityCenterPrincipalType

An IAM Identity Center group.

---

##### `USER`<sup>Required</sup> <a name="USER" id="cdk-extensions.sso.IdentityCenterPrincipalType.property.USER"></a>

```typescript
public readonly USER: IdentityCenterPrincipalType;
```

- *Type:* cdk-extensions.sso.IdentityCenterPrincipalType

An IAM Identity Center user.

---

### InputFormat <a name="InputFormat" id="cdk-extensions.glue.InputFormat"></a>

Absolute class name of the Hadoop `InputFormat` to use when reading table files.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.InputFormat.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.InputFormat(className: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.InputFormat.Initializer.parameter.className">className</a></code> | <code>string</code> | *No description.* |

---

##### `className`<sup>Required</sup> <a name="className" id="cdk-extensions.glue.InputFormat.Initializer.parameter.className"></a>

- *Type:* string

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.InputFormat.property.className">className</a></code> | <code>string</code> | *No description.* |

---

##### `className`<sup>Required</sup> <a name="className" id="cdk-extensions.glue.InputFormat.property.className"></a>

```typescript
public readonly className: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.InputFormat.property.AVRO">AVRO</a></code> | <code>cdk-extensions.glue.InputFormat</code> | InputFormat for Avro files. |
| <code><a href="#cdk-extensions.glue.InputFormat.property.CLOUDTRAIL">CLOUDTRAIL</a></code> | <code>cdk-extensions.glue.InputFormat</code> | InputFormat for Cloudtrail Logs. |
| <code><a href="#cdk-extensions.glue.InputFormat.property.ORC">ORC</a></code> | <code>cdk-extensions.glue.InputFormat</code> | InputFormat for Orc files. |
| <code><a href="#cdk-extensions.glue.InputFormat.property.PARQUET">PARQUET</a></code> | <code>cdk-extensions.glue.InputFormat</code> | InputFormat for Parquet files. |
| <code><a href="#cdk-extensions.glue.InputFormat.property.TEXT">TEXT</a></code> | <code>cdk-extensions.glue.InputFormat</code> | An InputFormat for plain text files. |

---

##### `AVRO`<sup>Required</sup> <a name="AVRO" id="cdk-extensions.glue.InputFormat.property.AVRO"></a>

```typescript
public readonly AVRO: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

InputFormat for Avro files.

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/avro/AvroContainerInputFormat.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/avro/AvroContainerInputFormat.html)

---

##### `CLOUDTRAIL`<sup>Required</sup> <a name="CLOUDTRAIL" id="cdk-extensions.glue.InputFormat.property.CLOUDTRAIL"></a>

```typescript
public readonly CLOUDTRAIL: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

InputFormat for Cloudtrail Logs.

> [https://docs.aws.amazon.com/athena/latest/ug/cloudtrail.html](https://docs.aws.amazon.com/athena/latest/ug/cloudtrail.html)

---

##### `ORC`<sup>Required</sup> <a name="ORC" id="cdk-extensions.glue.InputFormat.property.ORC"></a>

```typescript
public readonly ORC: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

InputFormat for Orc files.

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/orc/OrcInputFormat.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/orc/OrcInputFormat.html)

---

##### `PARQUET`<sup>Required</sup> <a name="PARQUET" id="cdk-extensions.glue.InputFormat.property.PARQUET"></a>

```typescript
public readonly PARQUET: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

InputFormat for Parquet files.

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/parquet/MapredParquetInputFormat.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/parquet/MapredParquetInputFormat.html)

---

##### `TEXT`<sup>Required</sup> <a name="TEXT" id="cdk-extensions.glue.InputFormat.property.TEXT"></a>

```typescript
public readonly TEXT: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

An InputFormat for plain text files.

Files are broken into lines. Either linefeed or
carriage-return are used to signal end of line. Keys are the position in the file, and
values are the line of text.
JSON & CSV files are examples of this InputFormat

> [https://hadoop.apache.org/docs/stable/api/org/apache/hadoop/mapred/TextInputFormat.html](https://hadoop.apache.org/docs/stable/api/org/apache/hadoop/mapred/TextInputFormat.html)

---

### InputFormat <a name="InputFormat" id="cdk-extensions.kinesis_firehose.InputFormat"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.InputFormat.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.InputFormat()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.InputFormat.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.InputFormat.bind"></a>

```typescript
public bind(scope: IConstruct): InputFormatConfigurationProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.InputFormat.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.InputFormat.hiveJson">hiveJson</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.InputFormat.openxJson">openxJson</a></code> | *No description.* |

---

##### `hiveJson` <a name="hiveJson" id="cdk-extensions.kinesis_firehose.InputFormat.hiveJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.InputFormat.hiveJson(options: HiveJsonInputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.InputFormat.hiveJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions

---

##### `openxJson` <a name="openxJson" id="cdk-extensions.kinesis_firehose.InputFormat.openxJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.InputFormat.openxJson(options: OpenxJsonInputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.InputFormat.openxJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions

---



### Instance <a name="Instance" id="cdk-extensions.sso.Instance"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.sso.Instance.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.Instance()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.Instance.fromArn">fromArn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.sso.Instance.fromInstanceId">fromInstanceId</a></code> | *No description.* |

---

##### `fromArn` <a name="fromArn" id="cdk-extensions.sso.Instance.fromArn"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.Instance.fromArn(scope: IConstruct, id: string, arn: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.Instance.fromArn.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.Instance.fromArn.parameter.id"></a>

- *Type:* string

---

###### `arn`<sup>Required</sup> <a name="arn" id="cdk-extensions.sso.Instance.fromArn.parameter.arn"></a>

- *Type:* string

---

##### `fromInstanceId` <a name="fromInstanceId" id="cdk-extensions.sso.Instance.fromInstanceId"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.Instance.fromInstanceId(scope: IConstruct, id: string, instanceId: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.Instance.fromInstanceId.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.Instance.fromInstanceId.parameter.id"></a>

- *Type:* string

---

###### `instanceId`<sup>Required</sup> <a name="instanceId" id="cdk-extensions.sso.Instance.fromInstanceId.parameter.instanceId"></a>

- *Type:* string

---



### IpamAllocationConfiguration <a name="IpamAllocationConfiguration" id="cdk-extensions.ec2.IpamAllocationConfiguration"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.IpamAllocationConfiguration.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.IpamAllocationConfiguration()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamAllocationConfiguration.auto">auto</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocationConfiguration.cidr">cidr</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamAllocationConfiguration.netmask">netmask</a></code> | *No description.* |

---

##### `auto` <a name="auto" id="cdk-extensions.ec2.IpamAllocationConfiguration.auto"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamAllocationConfiguration.auto()
```

##### `cidr` <a name="cidr" id="cdk-extensions.ec2.IpamAllocationConfiguration.cidr"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamAllocationConfiguration.cidr(cidr: string)
```

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.IpamAllocationConfiguration.cidr.parameter.cidr"></a>

- *Type:* string

---

##### `netmask` <a name="netmask" id="cdk-extensions.ec2.IpamAllocationConfiguration.netmask"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamAllocationConfiguration.netmask(length: number)
```

###### `length`<sup>Required</sup> <a name="length" id="cdk-extensions.ec2.IpamAllocationConfiguration.netmask.parameter.length"></a>

- *Type:* number

---



### IpamConsumer <a name="IpamConsumer" id="cdk-extensions.ec2.IpamConsumer"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamConsumer.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk-extensions.ec2.IpamConsumer.of"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamConsumer.of(name: string)
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.IpamConsumer.of.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamConsumer.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.IpamConsumer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamConsumer.property.EC2">EC2</a></code> | <code>cdk-extensions.ec2.IpamConsumer</code> | *No description.* |

---

##### `EC2`<sup>Required</sup> <a name="EC2" id="cdk-extensions.ec2.IpamConsumer.property.EC2"></a>

```typescript
public readonly EC2: IpamConsumer;
```

- *Type:* cdk-extensions.ec2.IpamConsumer

---

### IpamPoolCidrConfiguration <a name="IpamPoolCidrConfiguration" id="cdk-extensions.ec2.IpamPoolCidrConfiguration"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.IpamPoolCidrConfiguration.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.IpamPoolCidrConfiguration()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidrConfiguration.cidr">cidr</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IpamPoolCidrConfiguration.netmask">netmask</a></code> | *No description.* |

---

##### `cidr` <a name="cidr" id="cdk-extensions.ec2.IpamPoolCidrConfiguration.cidr"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamPoolCidrConfiguration.cidr(cidr: string)
```

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.IpamPoolCidrConfiguration.cidr.parameter.cidr"></a>

- *Type:* string

---

##### `netmask` <a name="netmask" id="cdk-extensions.ec2.IpamPoolCidrConfiguration.netmask"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.IpamPoolCidrConfiguration.netmask(length: number)
```

###### `length`<sup>Required</sup> <a name="length" id="cdk-extensions.ec2.IpamPoolCidrConfiguration.netmask.parameter.length"></a>

- *Type:* number

---



### JdbcTarget <a name="JdbcTarget" id="cdk-extensions.glue.JdbcTarget"></a>

- *Implements:* cdk-extensions.glue.ICrawlerTarget

#### Initializers <a name="Initializers" id="cdk-extensions.glue.JdbcTarget.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.JdbcTarget(connection: Connection, options: JdbcTargetOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcTarget.Initializer.parameter.connection">connection</a></code> | <code>cdk-extensions.glue.Connection</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.JdbcTarget.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.glue.JdbcTargetOptions</code> | *No description.* |

---

##### `connection`<sup>Required</sup> <a name="connection" id="cdk-extensions.glue.JdbcTarget.Initializer.parameter.connection"></a>

- *Type:* cdk-extensions.glue.Connection

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.glue.JdbcTarget.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.glue.JdbcTargetOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcTarget.addExclusion">addExclusion</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.JdbcTarget.addPath">addPath</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.JdbcTarget.bind">bind</a></code> | *No description.* |

---

##### `addExclusion` <a name="addExclusion" id="cdk-extensions.glue.JdbcTarget.addExclusion"></a>

```typescript
public addExclusion(exclusion: string): void
```

###### `exclusion`<sup>Required</sup> <a name="exclusion" id="cdk-extensions.glue.JdbcTarget.addExclusion.parameter.exclusion"></a>

- *Type:* string

---

##### `addPath` <a name="addPath" id="cdk-extensions.glue.JdbcTarget.addPath"></a>

```typescript
public addPath(path: string): void
```

###### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.glue.JdbcTarget.addPath.parameter.path"></a>

- *Type:* string

---

##### `bind` <a name="bind" id="cdk-extensions.glue.JdbcTarget.bind"></a>

```typescript
public bind(_crawler: Crawler): CrawlerTargetCollection
```

###### `_crawler`<sup>Required</sup> <a name="_crawler" id="cdk-extensions.glue.JdbcTarget.bind.parameter._crawler"></a>

- *Type:* cdk-extensions.glue.Crawler

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JdbcTarget.property.connection">connection</a></code> | <code>cdk-extensions.glue.Connection</code> | *No description.* |

---

##### `connection`<sup>Required</sup> <a name="connection" id="cdk-extensions.glue.JdbcTarget.property.connection"></a>

```typescript
public readonly connection: Connection;
```

- *Type:* cdk-extensions.glue.Connection

---


### JobExecutable <a name="JobExecutable" id="cdk-extensions.glue.JobExecutable"></a>

The executable properties related to the Glue job's GlueVersion, JobType and code.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JobExecutable.bind">bind</a></code> | Called during Job initialization to get JobExecutableConfig. |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.JobExecutable.bind"></a>

```typescript
public bind(): JobExecutableConfig
```

Called during Job initialization to get JobExecutableConfig.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JobExecutable.of">of</a></code> | Create a custom JobExecutable. |
| <code><a href="#cdk-extensions.glue.JobExecutable.pythonEtl">pythonEtl</a></code> | Create Python executable props for Apache Spark ETL job. |
| <code><a href="#cdk-extensions.glue.JobExecutable.pythonShell">pythonShell</a></code> | Create Python executable props for python shell jobs. |
| <code><a href="#cdk-extensions.glue.JobExecutable.pythonStreaming">pythonStreaming</a></code> | Create Python executable props for Apache Spark Streaming job. |
| <code><a href="#cdk-extensions.glue.JobExecutable.scalaEtl">scalaEtl</a></code> | Create Scala executable props for Apache Spark ETL job. |
| <code><a href="#cdk-extensions.glue.JobExecutable.scalaStreaming">scalaStreaming</a></code> | Create Scala executable props for Apache Spark Streaming job. |

---

##### `of` <a name="of" id="cdk-extensions.glue.JobExecutable.of"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JobExecutable.of(config: JobExecutableConfig)
```

Create a custom JobExecutable.

###### `config`<sup>Required</sup> <a name="config" id="cdk-extensions.glue.JobExecutable.of.parameter.config"></a>

- *Type:* cdk-extensions.glue.JobExecutableConfig

custom job executable configuration.

---

##### `pythonEtl` <a name="pythonEtl" id="cdk-extensions.glue.JobExecutable.pythonEtl"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JobExecutable.pythonEtl(props: PythonSparkJobExecutableProps)
```

Create Python executable props for Apache Spark ETL job.

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.JobExecutable.pythonEtl.parameter.props"></a>

- *Type:* cdk-extensions.glue.PythonSparkJobExecutableProps

Python Apache Spark Job props.

---

##### `pythonShell` <a name="pythonShell" id="cdk-extensions.glue.JobExecutable.pythonShell"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JobExecutable.pythonShell(props: PythonShellExecutableProps)
```

Create Python executable props for python shell jobs.

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.JobExecutable.pythonShell.parameter.props"></a>

- *Type:* cdk-extensions.glue.PythonShellExecutableProps

Python Shell Job props.

---

##### `pythonStreaming` <a name="pythonStreaming" id="cdk-extensions.glue.JobExecutable.pythonStreaming"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JobExecutable.pythonStreaming(props: PythonSparkJobExecutableProps)
```

Create Python executable props for Apache Spark Streaming job.

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.JobExecutable.pythonStreaming.parameter.props"></a>

- *Type:* cdk-extensions.glue.PythonSparkJobExecutableProps

Python Apache Spark Job props.

---

##### `scalaEtl` <a name="scalaEtl" id="cdk-extensions.glue.JobExecutable.scalaEtl"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JobExecutable.scalaEtl(props: ScalaJobExecutableProps)
```

Create Scala executable props for Apache Spark ETL job.

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.JobExecutable.scalaEtl.parameter.props"></a>

- *Type:* cdk-extensions.glue.ScalaJobExecutableProps

Scala Apache Spark Job props.

---

##### `scalaStreaming` <a name="scalaStreaming" id="cdk-extensions.glue.JobExecutable.scalaStreaming"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JobExecutable.scalaStreaming(props: ScalaJobExecutableProps)
```

Create Scala executable props for Apache Spark Streaming job.

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.JobExecutable.scalaStreaming.parameter.props"></a>

- *Type:* cdk-extensions.glue.ScalaJobExecutableProps

Scala Apache Spark Job props.

---



### JobType <a name="JobType" id="cdk-extensions.glue.JobType"></a>

The job type.

If you need to use a JobType that doesn't exist as a static member, you
can instantiate a `JobType` object, e.g: `JobType.of('other name')`.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JobType.of">of</a></code> | Custom type name. |

---

##### `of` <a name="of" id="cdk-extensions.glue.JobType.of"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.JobType.of(name: string)
```

Custom type name.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.glue.JobType.of.parameter.name"></a>

- *Type:* string

type name.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JobType.property.name">name</a></code> | <code>string</code> | The name of this JobType, as expected by Job resource. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.glue.JobType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this JobType, as expected by Job resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.JobType.property.ETL">ETL</a></code> | <code>cdk-extensions.glue.JobType</code> | Command for running a Glue ETL job. |
| <code><a href="#cdk-extensions.glue.JobType.property.PYTHON_SHELL">PYTHON_SHELL</a></code> | <code>cdk-extensions.glue.JobType</code> | Command for running a Glue python shell job. |
| <code><a href="#cdk-extensions.glue.JobType.property.STREAMING">STREAMING</a></code> | <code>cdk-extensions.glue.JobType</code> | Command for running a Glue streaming job. |

---

##### `ETL`<sup>Required</sup> <a name="ETL" id="cdk-extensions.glue.JobType.property.ETL"></a>

```typescript
public readonly ETL: JobType;
```

- *Type:* cdk-extensions.glue.JobType

Command for running a Glue ETL job.

---

##### `PYTHON_SHELL`<sup>Required</sup> <a name="PYTHON_SHELL" id="cdk-extensions.glue.JobType.property.PYTHON_SHELL"></a>

```typescript
public readonly PYTHON_SHELL: JobType;
```

- *Type:* cdk-extensions.glue.JobType

Command for running a Glue python shell job.

---

##### `STREAMING`<sup>Required</sup> <a name="STREAMING" id="cdk-extensions.glue.JobType.property.STREAMING"></a>

```typescript
public readonly STREAMING: JobType;
```

- *Type:* cdk-extensions.glue.JobType

Command for running a Glue streaming job.

---

### JoinedJson <a name="JoinedJson" id="cdk-extensions.asserts.JoinedJson"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.asserts.JoinedJson.Initializer"></a>

```typescript
import { asserts } from 'cdk-extensions'

new asserts.JoinedJson(pattern: any)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.asserts.JoinedJson.Initializer.parameter.pattern">pattern</a></code> | <code>any</code> | *No description.* |

---

##### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.JoinedJson.Initializer.parameter.pattern"></a>

- *Type:* any

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.asserts.JoinedJson.test">test</a></code> | Test whether a target matches the provided pattern. |

---

##### `test` <a name="test" id="cdk-extensions.asserts.JoinedJson.test"></a>

```typescript
public test(actual: any): MatchResult
```

Test whether a target matches the provided pattern.

Every Matcher must implement this method.
This method will be invoked by the assertions framework. Do not call this method directly.

###### `actual`<sup>Required</sup> <a name="actual" id="cdk-extensions.asserts.JoinedJson.test.parameter.actual"></a>

- *Type:* any

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.asserts.JoinedJson.isMatcher">isMatcher</a></code> | Check whether the provided object is a subtype of the `IMatcher`. |

---

##### `isMatcher` <a name="isMatcher" id="cdk-extensions.asserts.JoinedJson.isMatcher"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.JoinedJson.isMatcher(x: any)
```

Check whether the provided object is a subtype of the `IMatcher`.

###### `x`<sup>Required</sup> <a name="x" id="cdk-extensions.asserts.JoinedJson.isMatcher.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.asserts.JoinedJson.property.name">name</a></code> | <code>string</code> | A name for the matcher. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.asserts.JoinedJson.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

A name for the matcher.

This is collected as part of the result and may be presented to the user.

---


### JsonPartitioningSource <a name="JsonPartitioningSource" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.JsonPartitioningSource(options: JsonPartitioningOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningSource.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.JsonPartitioningOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.JsonPartitioningOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningSource.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningSource.addPartition">addPartition</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.bind"></a>

```typescript
public bind(scope: IConstruct): DynamicPartitioningConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `addPartition` <a name="addPartition" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.addPartition"></a>

```typescript
public addPartition(name: string, query: string): void
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.addPartition.parameter.name"></a>

- *Type:* string

---

###### `query`<sup>Required</sup> <a name="query" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.addPartition.parameter.query"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningSource.fromJson">fromJson</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningSource.fromLambda">fromLambda</a></code> | *No description.* |

---

##### `fromJson` <a name="fromJson" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.fromJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.JsonPartitioningSource.fromJson(options: JsonPartitioningOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.fromJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.JsonPartitioningOptions

---

##### `fromLambda` <a name="fromLambda" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.fromLambda"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.JsonPartitioningSource.fromLambda(options: LambdaPartitioningOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.fromLambda.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.LambdaPartitioningOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningSource.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonPartitioningSource.property.retryInterval">retryInterval</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `retryInterval`<sup>Optional</sup> <a name="retryInterval" id="cdk-extensions.kinesis_firehose.JsonPartitioningSource.property.retryInterval"></a>

```typescript
public readonly retryInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

---


### JsonQuery <a name="JsonQuery" id="cdk-extensions.kinesis_firehose.JsonQuery"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.JsonQuery.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.JsonQuery(fields?: {[ key: string ]: string})
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonQuery.Initializer.parameter.fields">fields</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `fields`<sup>Optional</sup> <a name="fields" id="cdk-extensions.kinesis_firehose.JsonQuery.Initializer.parameter.fields"></a>

- *Type:* {[ key: string ]: string}

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonQuery.render">render</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonQuery.addField">addField</a></code> | *No description.* |

---

##### `render` <a name="render" id="cdk-extensions.kinesis_firehose.JsonQuery.render"></a>

```typescript
public render(): string
```

##### `addField` <a name="addField" id="cdk-extensions.kinesis_firehose.JsonQuery.addField"></a>

```typescript
public addField(name: string, query: string): JsonQuery
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.kinesis_firehose.JsonQuery.addField.parameter.name"></a>

- *Type:* string

---

###### `query`<sup>Required</sup> <a name="query" id="cdk-extensions.kinesis_firehose.JsonQuery.addField.parameter.query"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonQuery.jq">jq</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonQuery.of">of</a></code> | *No description.* |

---

##### `jq` <a name="jq" id="cdk-extensions.kinesis_firehose.JsonQuery.jq"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.JsonQuery.jq(fields: {[ key: string ]: string})
```

###### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.kinesis_firehose.JsonQuery.jq.parameter.fields"></a>

- *Type:* {[ key: string ]: string}

---

##### `of` <a name="of" id="cdk-extensions.kinesis_firehose.JsonQuery.of"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.JsonQuery.of(query: string)
```

###### `query`<sup>Required</sup> <a name="query" id="cdk-extensions.kinesis_firehose.JsonQuery.of.parameter.query"></a>

- *Type:* string

---



### LambdaPartitioningSource <a name="LambdaPartitioningSource" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.LambdaPartitioningSource(options: LambdaPartitioningOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningSource.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.LambdaPartitioningOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.LambdaPartitioningOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningSource.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.bind"></a>

```typescript
public bind(scope: IConstruct): DynamicPartitioningConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningSource.fromJson">fromJson</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningSource.fromLambda">fromLambda</a></code> | *No description.* |

---

##### `fromJson` <a name="fromJson" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.fromJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.LambdaPartitioningSource.fromJson(options: JsonPartitioningOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.fromJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.JsonPartitioningOptions

---

##### `fromLambda` <a name="fromLambda" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.fromLambda"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.LambdaPartitioningSource.fromLambda(options: LambdaPartitioningOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.fromLambda.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.LambdaPartitioningOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningSource.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningSource.property.retryInterval">retryInterval</a></code> | <code>aws-cdk-lib.Duration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaPartitioningSource.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | *No description.* |

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `retryInterval`<sup>Optional</sup> <a name="retryInterval" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.property.retryInterval"></a>

```typescript
public readonly retryInterval: Duration;
```

- *Type:* aws-cdk-lib.Duration

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="cdk-extensions.kinesis_firehose.LambdaPartitioningSource.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---


### LambdaProcessor <a name="LambdaProcessor" id="cdk-extensions.kinesis_firehose.LambdaProcessor"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.LambdaProcessor.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.LambdaProcessor(options: LambdaProcessorOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaProcessor.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.LambdaProcessorOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.LambdaProcessor.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.LambdaProcessorOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaProcessor.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.LambdaProcessor.bind"></a>

```typescript
public bind(_scope: IConstruct): ProcessorProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.LambdaProcessor.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaProcessor.property.processorType">processorType</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.LambdaProcessor.property.lambdaFunction">lambdaFunction</a></code> | <code>aws-cdk-lib.aws_lambda.IFunction</code> | *No description.* |

---

##### `processorType`<sup>Required</sup> <a name="processorType" id="cdk-extensions.kinesis_firehose.LambdaProcessor.property.processorType"></a>

```typescript
public readonly processorType: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `lambdaFunction`<sup>Required</sup> <a name="lambdaFunction" id="cdk-extensions.kinesis_firehose.LambdaProcessor.property.lambdaFunction"></a>

```typescript
public readonly lambdaFunction: IFunction;
```

- *Type:* aws-cdk-lib.aws_lambda.IFunction

---


### ManagedPolicyPermissionsBoundary <a name="ManagedPolicyPermissionsBoundary" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.ManagedPolicyPermissionsBoundary(policy: IManagedPolicy)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ManagedPolicyPermissionsBoundary.Initializer.parameter.policy">policy</a></code> | <code>aws-cdk-lib.aws_iam.IManagedPolicy</code> | *No description.* |

---

##### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.Initializer.parameter.policy"></a>

- *Type:* aws-cdk-lib.aws_iam.IManagedPolicy

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.ManagedPolicyPermissionsBoundary.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.bind"></a>

```typescript
public bind(_scope: IConstruct): PermissionsBoundaryProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.ManagedPolicyPermissionsBoundary.fromManagedPolicy">fromManagedPolicy</a></code> | *No description.* |
| <code><a href="#cdk-extensions.sso.ManagedPolicyPermissionsBoundary.fromReference">fromReference</a></code> | *No description.* |

---

##### `fromManagedPolicy` <a name="fromManagedPolicy" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.fromManagedPolicy"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ManagedPolicyPermissionsBoundary.fromManagedPolicy(policy: IManagedPolicy)
```

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.fromManagedPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.aws_iam.IManagedPolicy

---

##### `fromReference` <a name="fromReference" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.fromReference"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ManagedPolicyPermissionsBoundary.fromReference(options: ReferenceOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.fromReference.parameter.options"></a>

- *Type:* cdk-extensions.sso.ReferenceOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ManagedPolicyPermissionsBoundary.property.managedPolicy">managedPolicy</a></code> | <code>aws-cdk-lib.aws_iam.IManagedPolicy</code> | *No description.* |

---

##### `managedPolicy`<sup>Required</sup> <a name="managedPolicy" id="cdk-extensions.sso.ManagedPolicyPermissionsBoundary.property.managedPolicy"></a>

```typescript
public readonly managedPolicy: IManagedPolicy;
```

- *Type:* aws-cdk-lib.aws_iam.IManagedPolicy

---


### Match <a name="Match" id="cdk-extensions.asserts.Match"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.asserts.Match.Initializer"></a>

```typescript
import { asserts } from 'cdk-extensions'

new asserts.Match()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.asserts.Match.absent">absent</a></code> | Use this matcher in the place of a field's value, if the field must not be present. |
| <code><a href="#cdk-extensions.asserts.Match.anyValue">anyValue</a></code> | Matches any non-null value at the target. |
| <code><a href="#cdk-extensions.asserts.Match.arrayEquals">arrayEquals</a></code> | Matches the specified pattern with the array found in the same relative path of the target. |
| <code><a href="#cdk-extensions.asserts.Match.arrayWith">arrayWith</a></code> | Matches the specified pattern with the array found in the same relative path of the target. |
| <code><a href="#cdk-extensions.asserts.Match.exact">exact</a></code> | Deep exact matching of the specified pattern to the target. |
| <code><a href="#cdk-extensions.asserts.Match.not">not</a></code> | Matches any target which does NOT follow the specified pattern. |
| <code><a href="#cdk-extensions.asserts.Match.objectEquals">objectEquals</a></code> | Matches the specified pattern to an object found in the same relative path of the target. |
| <code><a href="#cdk-extensions.asserts.Match.objectLike">objectLike</a></code> | Matches the specified pattern to an object found in the same relative path of the target. |
| <code><a href="#cdk-extensions.asserts.Match.serializedJson">serializedJson</a></code> | Matches any string-encoded JSON and applies the specified pattern after parsing it. |
| <code><a href="#cdk-extensions.asserts.Match.stringLikeRegexp">stringLikeRegexp</a></code> | Matches targets according to a regular expression. |
| <code><a href="#cdk-extensions.asserts.Match.joinedJson">joinedJson</a></code> | *No description.* |

---

##### `absent` <a name="absent" id="cdk-extensions.asserts.Match.absent"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.absent()
```

Use this matcher in the place of a field's value, if the field must not be present.

##### `anyValue` <a name="anyValue" id="cdk-extensions.asserts.Match.anyValue"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.anyValue()
```

Matches any non-null value at the target.

##### `arrayEquals` <a name="arrayEquals" id="cdk-extensions.asserts.Match.arrayEquals"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.arrayEquals(pattern: any[])
```

Matches the specified pattern with the array found in the same relative path of the target.

The set of elements (or matchers) must match exactly and in order.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.arrayEquals.parameter.pattern"></a>

- *Type:* any[]

the pattern to match.

---

##### `arrayWith` <a name="arrayWith" id="cdk-extensions.asserts.Match.arrayWith"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.arrayWith(pattern: any[])
```

Matches the specified pattern with the array found in the same relative path of the target.

The set of elements (or matchers) must be in the same order as would be found.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.arrayWith.parameter.pattern"></a>

- *Type:* any[]

the pattern to match.

---

##### `exact` <a name="exact" id="cdk-extensions.asserts.Match.exact"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.exact(pattern: any)
```

Deep exact matching of the specified pattern to the target.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.exact.parameter.pattern"></a>

- *Type:* any

the pattern to match.

---

##### `not` <a name="not" id="cdk-extensions.asserts.Match.not"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.not(pattern: any)
```

Matches any target which does NOT follow the specified pattern.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.not.parameter.pattern"></a>

- *Type:* any

the pattern to NOT match.

---

##### `objectEquals` <a name="objectEquals" id="cdk-extensions.asserts.Match.objectEquals"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.objectEquals(pattern: {[ key: string ]: any})
```

Matches the specified pattern to an object found in the same relative path of the target.

The keys and their values (or matchers) must match exactly with the target.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.objectEquals.parameter.pattern"></a>

- *Type:* {[ key: string ]: any}

the pattern to match.

---

##### `objectLike` <a name="objectLike" id="cdk-extensions.asserts.Match.objectLike"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.objectLike(pattern: {[ key: string ]: any})
```

Matches the specified pattern to an object found in the same relative path of the target.

The keys and their values (or matchers) must be present in the target but the target can be a superset.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.objectLike.parameter.pattern"></a>

- *Type:* {[ key: string ]: any}

the pattern to match.

---

##### `serializedJson` <a name="serializedJson" id="cdk-extensions.asserts.Match.serializedJson"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.serializedJson(pattern: any)
```

Matches any string-encoded JSON and applies the specified pattern after parsing it.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.serializedJson.parameter.pattern"></a>

- *Type:* any

the pattern to match after parsing the encoded JSON.

---

##### `stringLikeRegexp` <a name="stringLikeRegexp" id="cdk-extensions.asserts.Match.stringLikeRegexp"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.stringLikeRegexp(pattern: string)
```

Matches targets according to a regular expression.

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.stringLikeRegexp.parameter.pattern"></a>

- *Type:* string

---

##### `joinedJson` <a name="joinedJson" id="cdk-extensions.asserts.Match.joinedJson"></a>

```typescript
import { asserts } from 'cdk-extensions'

asserts.Match.joinedJson(pattern: any)
```

###### `pattern`<sup>Required</sup> <a name="pattern" id="cdk-extensions.asserts.Match.joinedJson.parameter.pattern"></a>

- *Type:* any

---



### MetadataExtractionProcessor <a name="MetadataExtractionProcessor" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessor"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.MetadataExtractionProcessor(options: MetadataExtractionProcessorOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.MetadataExtractionProcessorOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.MetadataExtractionProcessorOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.bind"></a>

```typescript
public bind(_scope: IConstruct): ProcessorProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.property.processorType">processorType</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.property.engine">engine</a></code> | <code>cdk-extensions.kinesis_firehose.JsonParsingEngine</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.property.query">query</a></code> | <code>cdk-extensions.kinesis_firehose.MetaDataExtractionQuery</code> | *No description.* |

---

##### `processorType`<sup>Required</sup> <a name="processorType" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.property.processorType"></a>

```typescript
public readonly processorType: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `engine`<sup>Required</sup> <a name="engine" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.property.engine"></a>

```typescript
public readonly engine: JsonParsingEngine;
```

- *Type:* cdk-extensions.kinesis_firehose.JsonParsingEngine

---

##### `query`<sup>Required</sup> <a name="query" id="cdk-extensions.kinesis_firehose.MetadataExtractionProcessor.property.query"></a>

```typescript
public readonly query: MetaDataExtractionQuery;
```

- *Type:* cdk-extensions.kinesis_firehose.MetaDataExtractionQuery

---


### MetaDataExtractionQuery <a name="MetaDataExtractionQuery" id="cdk-extensions.kinesis_firehose.MetaDataExtractionQuery"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.MetaDataExtractionQuery(query: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.Initializer.parameter.query">query</a></code> | <code>string</code> | *No description.* |

---

##### `query`<sup>Required</sup> <a name="query" id="cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.Initializer.parameter.query"></a>

- *Type:* string

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.render">render</a></code> | *No description.* |

---

##### `render` <a name="render" id="cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.render"></a>

```typescript
public render(): string
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.jq">jq</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.of">of</a></code> | *No description.* |

---

##### `jq` <a name="jq" id="cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.jq"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.MetaDataExtractionQuery.jq(fields: {[ key: string ]: string})
```

###### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.jq.parameter.fields"></a>

- *Type:* {[ key: string ]: string}

---

##### `of` <a name="of" id="cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.of"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.MetaDataExtractionQuery.of(query: string)
```

###### `query`<sup>Required</sup> <a name="query" id="cdk-extensions.kinesis_firehose.MetaDataExtractionQuery.of.parameter.query"></a>

- *Type:* string

---



### ModifyCondition <a name="ModifyCondition" id="cdk-extensions.k8s_aws.ModifyCondition"></a>

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.toString">toString</a></code> | Gets a string representation of the arguments of this condition for use in a Fluent Bit plugin field. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.ModifyCondition.toString"></a>

```typescript
public toString(): string
```

Gets a string representation of the arguments of this condition for use in a Fluent Bit plugin field.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.aKeyMatches">aKeyMatches</a></code> | Condition that returns true if any key matches a specified regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.keyDoesNotExists">keyDoesNotExists</a></code> | Condition that returns true if a specified key does not exist. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.keyExists">keyExists</a></code> | Condition that returns true if a specified key exists. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.keyValueDoesNotEqual">keyValueDoesNotEqual</a></code> | Condition that returns true if a specified key exists and its value does not match the specified value. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.keyValueDoesNotMatch">keyValueDoesNotMatch</a></code> | Condition that returns true if a specified key exists and its value does not match the specified regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.keyValueEquals">keyValueEquals</a></code> | Condition that returns true if a specified key exists and its value matches the specified value. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.keyValueMatches">keyValueMatches</a></code> | Condition that returns true if a specified key exists and its value matches the specified regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.matchingKeysDoNotHaveMatchingValues">matchingKeysDoNotHaveMatchingValues</a></code> | Condition that returns true if all keys matching a specified regular expression have values that do not match another regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.matchingKeysHaveMatchingValues">matchingKeysHaveMatchingValues</a></code> | Condition that returns true if all keys matching a specified regular expression have values that match another regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.noKeyMatches">noKeyMatches</a></code> | Condition that returns true if no key matches a specified regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.of">of</a></code> | An escape hatch method that allows fo defining custom conditions to be evaluated by the modify Fluent Bit filter plugin. |

---

##### `aKeyMatches` <a name="aKeyMatches" id="cdk-extensions.k8s_aws.ModifyCondition.aKeyMatches"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.aKeyMatches(regex: string)
```

Condition that returns true if any key matches a specified regular expression.

###### `regex`<sup>Required</sup> <a name="regex" id="cdk-extensions.k8s_aws.ModifyCondition.aKeyMatches.parameter.regex"></a>

- *Type:* string

The regular expression to evaluate against field keys.

---

##### `keyDoesNotExists` <a name="keyDoesNotExists" id="cdk-extensions.k8s_aws.ModifyCondition.keyDoesNotExists"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.keyDoesNotExists(key: string)
```

Condition that returns true if a specified key does not exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyCondition.keyDoesNotExists.parameter.key"></a>

- *Type:* string

The key to check for existence.

---

##### `keyExists` <a name="keyExists" id="cdk-extensions.k8s_aws.ModifyCondition.keyExists"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.keyExists(key: string)
```

Condition that returns true if a specified key exists.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyCondition.keyExists.parameter.key"></a>

- *Type:* string

The key to check for existence.

---

##### `keyValueDoesNotEqual` <a name="keyValueDoesNotEqual" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueDoesNotEqual"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.keyValueDoesNotEqual(key: string, value: string)
```

Condition that returns true if a specified key exists and its value does not match the specified value.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueDoesNotEqual.parameter.key"></a>

- *Type:* string

The key to check for existence.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueDoesNotEqual.parameter.value"></a>

- *Type:* string

The value to check for the given key.

---

##### `keyValueDoesNotMatch` <a name="keyValueDoesNotMatch" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueDoesNotMatch"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.keyValueDoesNotMatch(key: string, value: string)
```

Condition that returns true if a specified key exists and its value does not match the specified regular expression.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueDoesNotMatch.parameter.key"></a>

- *Type:* string

The key to check for existence.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueDoesNotMatch.parameter.value"></a>

- *Type:* string

The regular expression to check for the given key.

---

##### `keyValueEquals` <a name="keyValueEquals" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueEquals"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.keyValueEquals(key: string, value: string)
```

Condition that returns true if a specified key exists and its value matches the specified value.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueEquals.parameter.key"></a>

- *Type:* string

The key to check for existence.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueEquals.parameter.value"></a>

- *Type:* string

The value to match for the given key.

---

##### `keyValueMatches` <a name="keyValueMatches" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueMatches"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.keyValueMatches(key: string, value: string)
```

Condition that returns true if a specified key exists and its value matches the specified regular expression.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueMatches.parameter.key"></a>

- *Type:* string

The key to check for existence.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ModifyCondition.keyValueMatches.parameter.value"></a>

- *Type:* string

The regular expression to match for the given key.

---

##### `matchingKeysDoNotHaveMatchingValues` <a name="matchingKeysDoNotHaveMatchingValues" id="cdk-extensions.k8s_aws.ModifyCondition.matchingKeysDoNotHaveMatchingValues"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.matchingKeysDoNotHaveMatchingValues(key: string, value: string)
```

Condition that returns true if all keys matching a specified regular expression have values that do not match another regular expression.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyCondition.matchingKeysDoNotHaveMatchingValues.parameter.key"></a>

- *Type:* string

The regular expression to use to filter keys.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ModifyCondition.matchingKeysDoNotHaveMatchingValues.parameter.value"></a>

- *Type:* string

The regular expression to check the value of fields.

---

##### `matchingKeysHaveMatchingValues` <a name="matchingKeysHaveMatchingValues" id="cdk-extensions.k8s_aws.ModifyCondition.matchingKeysHaveMatchingValues"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.matchingKeysHaveMatchingValues(key: string, value: string)
```

Condition that returns true if all keys matching a specified regular expression have values that match another regular expression.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyCondition.matchingKeysHaveMatchingValues.parameter.key"></a>

- *Type:* string

The regular expression to use to filter keys.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ModifyCondition.matchingKeysHaveMatchingValues.parameter.value"></a>

- *Type:* string

The regular expression to check the value of fields.

---

##### `noKeyMatches` <a name="noKeyMatches" id="cdk-extensions.k8s_aws.ModifyCondition.noKeyMatches"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.noKeyMatches(regex: string)
```

Condition that returns true if no key matches a specified regular expression.

###### `regex`<sup>Required</sup> <a name="regex" id="cdk-extensions.k8s_aws.ModifyCondition.noKeyMatches.parameter.regex"></a>

- *Type:* string

The regular expression to evaluate against field keys.

---

##### `of` <a name="of" id="cdk-extensions.k8s_aws.ModifyCondition.of"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyCondition.of(condition: string, args: string[])
```

An escape hatch method that allows fo defining custom conditions to be evaluated by the modify Fluent Bit filter plugin.

###### `condition`<sup>Required</sup> <a name="condition" id="cdk-extensions.k8s_aws.ModifyCondition.of.parameter.condition"></a>

- *Type:* string

The name of the condition to be evaluated.

---

###### `args`<sup>Required</sup> <a name="args" id="cdk-extensions.k8s_aws.ModifyCondition.of.parameter.args"></a>

- *Type:* string[]

The arguments to the operation.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.property.args">args</a></code> | <code>string[]</code> | Collection of arguments that apply to the condition. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyCondition.property.condition">condition</a></code> | <code>string</code> | The name of the condition being evaluated. |

---

##### `args`<sup>Required</sup> <a name="args" id="cdk-extensions.k8s_aws.ModifyCondition.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]

Collection of arguments that apply to the condition.

---

##### `condition`<sup>Required</sup> <a name="condition" id="cdk-extensions.k8s_aws.ModifyCondition.property.condition"></a>

```typescript
public readonly condition: string;
```

- *Type:* string

The name of the condition being evaluated.

---


### ModifyOperation <a name="ModifyOperation" id="cdk-extensions.k8s_aws.ModifyOperation"></a>

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.toString">toString</a></code> | Gets a string representation of the arguments of this operation for use in a Fluent Bit plugin field. |

---

##### `toString` <a name="toString" id="cdk-extensions.k8s_aws.ModifyOperation.toString"></a>

```typescript
public toString(): string
```

Gets a string representation of the arguments of this operation for use in a Fluent Bit plugin field.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.add">add</a></code> | Sets a field in the output to a specific value. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.copy">copy</a></code> | Copies a field from the input to a field with a new name if the field exists and a field with the new name does not exist. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.hardCopy">hardCopy</a></code> | Copies a field from the input to a field with a new name if the field exists and a field with the new name does not exist. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.hardRename">hardRename</a></code> | Renames a field from the input if the field exists. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.moveToEnd">moveToEnd</a></code> | Moves fiels matching the given wildcard key to the end of the message. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.moveToStart">moveToStart</a></code> | Moves fiels matching the given wildcard key to the start of the message. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.of">of</a></code> | An escape hatch method that allows fo defining custom operations to be performed by the modify Fluent Bit filter plugin. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.remove">remove</a></code> | Removes a field in the output with a specific key. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.removeRegex">removeRegex</a></code> | Removes all fields in the output matching the regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.removeWildcard">removeWildcard</a></code> | Removes all fields in the output matching the wildcard key. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.rename">rename</a></code> | Renames a field from the input if the field exists and a field with the new name does not exist. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.set">set</a></code> | Sets a field in the output to a specific value. |

---

##### `add` <a name="add" id="cdk-extensions.k8s_aws.ModifyOperation.add"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.add(key: string, value: string)
```

Sets a field in the output to a specific value.

If a field with the same name already exists it will be kept as is.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyOperation.add.parameter.key"></a>

- *Type:* string

The key name of the field to set.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ModifyOperation.add.parameter.value"></a>

- *Type:* string

The value to set for the specified field.

---

##### `copy` <a name="copy" id="cdk-extensions.k8s_aws.ModifyOperation.copy"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.copy(originalKey: string, newKey: string)
```

Copies a field from the input to a field with a new name if the field exists and a field with the new name does not exist.

If a field with the new name already exists it is overwritten.

###### `originalKey`<sup>Required</sup> <a name="originalKey" id="cdk-extensions.k8s_aws.ModifyOperation.copy.parameter.originalKey"></a>

- *Type:* string

The key in the input to be copied.

---

###### `newKey`<sup>Required</sup> <a name="newKey" id="cdk-extensions.k8s_aws.ModifyOperation.copy.parameter.newKey"></a>

- *Type:* string

The new name of the field to be copied to.

---

##### `hardCopy` <a name="hardCopy" id="cdk-extensions.k8s_aws.ModifyOperation.hardCopy"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.hardCopy(originalKey: string, newKey: string)
```

Copies a field from the input to a field with a new name if the field exists and a field with the new name does not exist.

###### `originalKey`<sup>Required</sup> <a name="originalKey" id="cdk-extensions.k8s_aws.ModifyOperation.hardCopy.parameter.originalKey"></a>

- *Type:* string

The key in the input to be copied.

---

###### `newKey`<sup>Required</sup> <a name="newKey" id="cdk-extensions.k8s_aws.ModifyOperation.hardCopy.parameter.newKey"></a>

- *Type:* string

The new name of the field to be copied to.

---

##### `hardRename` <a name="hardRename" id="cdk-extensions.k8s_aws.ModifyOperation.hardRename"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.hardRename(originalKey: string, renamedKey: string)
```

Renames a field from the input if the field exists.

If a field with the desired name already exists it is overwritten.

###### `originalKey`<sup>Required</sup> <a name="originalKey" id="cdk-extensions.k8s_aws.ModifyOperation.hardRename.parameter.originalKey"></a>

- *Type:* string

The key in the input to be renamed.

---

###### `renamedKey`<sup>Required</sup> <a name="renamedKey" id="cdk-extensions.k8s_aws.ModifyOperation.hardRename.parameter.renamedKey"></a>

- *Type:* string

The new name of the key in the output.

---

##### `moveToEnd` <a name="moveToEnd" id="cdk-extensions.k8s_aws.ModifyOperation.moveToEnd"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.moveToEnd(key: string)
```

Moves fiels matching the given wildcard key to the end of the message.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyOperation.moveToEnd.parameter.key"></a>

- *Type:* string

The wildcard to to match.

---

##### `moveToStart` <a name="moveToStart" id="cdk-extensions.k8s_aws.ModifyOperation.moveToStart"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.moveToStart(key: string)
```

Moves fiels matching the given wildcard key to the start of the message.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyOperation.moveToStart.parameter.key"></a>

- *Type:* string

The wildcard to to match.

---

##### `of` <a name="of" id="cdk-extensions.k8s_aws.ModifyOperation.of"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.of(operation: string, args: string[])
```

An escape hatch method that allows fo defining custom operations to be performed by the modify Fluent Bit filter plugin.

###### `operation`<sup>Required</sup> <a name="operation" id="cdk-extensions.k8s_aws.ModifyOperation.of.parameter.operation"></a>

- *Type:* string

The name of the operation to be performed.

---

###### `args`<sup>Required</sup> <a name="args" id="cdk-extensions.k8s_aws.ModifyOperation.of.parameter.args"></a>

- *Type:* string[]

The arguments to the operation.

---

##### `remove` <a name="remove" id="cdk-extensions.k8s_aws.ModifyOperation.remove"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.remove(key: string)
```

Removes a field in the output with a specific key.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyOperation.remove.parameter.key"></a>

- *Type:* string

The key name of the field to remove.

---

##### `removeRegex` <a name="removeRegex" id="cdk-extensions.k8s_aws.ModifyOperation.removeRegex"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.removeRegex(regex: string)
```

Removes all fields in the output matching the regular expression.

###### `regex`<sup>Required</sup> <a name="regex" id="cdk-extensions.k8s_aws.ModifyOperation.removeRegex.parameter.regex"></a>

- *Type:* string

The regular expression specifying which fields to remove.

---

##### `removeWildcard` <a name="removeWildcard" id="cdk-extensions.k8s_aws.ModifyOperation.removeWildcard"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.removeWildcard(key: string)
```

Removes all fields in the output matching the wildcard key.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyOperation.removeWildcard.parameter.key"></a>

- *Type:* string

The wildcard expression specifying which fields to remove.

---

##### `rename` <a name="rename" id="cdk-extensions.k8s_aws.ModifyOperation.rename"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.rename(originalKey: string, renamedKey: string)
```

Renames a field from the input if the field exists and a field with the new name does not exist.

###### `originalKey`<sup>Required</sup> <a name="originalKey" id="cdk-extensions.k8s_aws.ModifyOperation.rename.parameter.originalKey"></a>

- *Type:* string

The key in the input to be renamed.

---

###### `renamedKey`<sup>Required</sup> <a name="renamedKey" id="cdk-extensions.k8s_aws.ModifyOperation.rename.parameter.renamedKey"></a>

- *Type:* string

The new name of the key in the output.

---

##### `set` <a name="set" id="cdk-extensions.k8s_aws.ModifyOperation.set"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ModifyOperation.set(key: string, value: string)
```

Sets a field in the output to a specific value.

If a field with the same name already exists it will be overridden with
the specified value.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.k8s_aws.ModifyOperation.set.parameter.key"></a>

- *Type:* string

The key name of the field to set.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.ModifyOperation.set.parameter.value"></a>

- *Type:* string

The value to set for the specified field.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.property.args">args</a></code> | <code>string[]</code> | Collection of arguments that apply to the operation. |
| <code><a href="#cdk-extensions.k8s_aws.ModifyOperation.property.operation">operation</a></code> | <code>string</code> | The name of the operation being performed. |

---

##### `args`<sup>Required</sup> <a name="args" id="cdk-extensions.k8s_aws.ModifyOperation.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]

Collection of arguments that apply to the operation.

---

##### `operation`<sup>Required</sup> <a name="operation" id="cdk-extensions.k8s_aws.ModifyOperation.property.operation"></a>

```typescript
public readonly operation: string;
```

- *Type:* string

The name of the operation being performed.

---


### NatProvider <a name="NatProvider" id="cdk-extensions.ec2.NatProvider"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.NatProvider.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.NatProvider()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.NatProvider.gateway">gateway</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.NatProvider.instance">instance</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.NatProvider.transitGateway">transitGateway</a></code> | *No description.* |

---

##### `gateway` <a name="gateway" id="cdk-extensions.ec2.NatProvider.gateway"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.NatProvider.gateway(props?: NatGatewayProps)
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.NatProvider.gateway.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_ec2.NatGatewayProps

---

##### `instance` <a name="instance" id="cdk-extensions.ec2.NatProvider.instance"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.NatProvider.instance(props: NatInstanceProps)
```

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.NatProvider.instance.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_ec2.NatInstanceProps

---

##### `transitGateway` <a name="transitGateway" id="cdk-extensions.ec2.NatProvider.transitGateway"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.NatProvider.transitGateway(props: TransitGatewayNatProviderOptions)
```

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.NatProvider.transitGateway.parameter.props"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayNatProviderOptions

---



### NestFilterOperation <a name="NestFilterOperation" id="cdk-extensions.k8s_aws.NestFilterOperation"></a>

- *Implements:* cdk-extensions.k8s_aws.INestFilterOperation

Operations with exclusive options that can be performed by the Fluent Bit Nest filter plugin.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.NestFilterOperation.lift">lift</a></code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.NestFilterOperation.nest">nest</a></code> | *No description.* |

---

##### `lift` <a name="lift" id="cdk-extensions.k8s_aws.NestFilterOperation.lift"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.NestFilterOperation.lift(options: LiftOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.NestFilterOperation.lift.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.LiftOptions

---

##### `nest` <a name="nest" id="cdk-extensions.k8s_aws.NestFilterOperation.nest"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.NestFilterOperation.nest(options: NestOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.NestFilterOperation.nest.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.NestOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.NestFilterOperation.property.fields">fields</a></code> | <code>{[ key: string ]: string[]}</code> | The fields representing configuration options for the operation. |
| <code><a href="#cdk-extensions.k8s_aws.NestFilterOperation.property.operation">operation</a></code> | <code>cdk-extensions.k8s_aws.NestFilterOperationType</code> | The type of operation to be performed. |

---

##### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.k8s_aws.NestFilterOperation.property.fields"></a>

```typescript
public readonly fields: {[ key: string ]: string[]};
```

- *Type:* {[ key: string ]: string[]}

The fields representing configuration options for the operation.

---

##### `operation`<sup>Required</sup> <a name="operation" id="cdk-extensions.k8s_aws.NestFilterOperation.property.operation"></a>

```typescript
public readonly operation: NestFilterOperationType;
```

- *Type:* cdk-extensions.k8s_aws.NestFilterOperationType

The type of operation to be performed.

---


### NoopRegistry <a name="NoopRegistry" id="cdk-extensions.k8s_aws.NoopRegistry"></a>

- *Implements:* cdk-extensions.k8s_aws.IExternalDnsRegistry

A placeholder ExternalDNS registry that says ExternalDNS should use not use a registry.

When configuring ExternalDNS without a registry, the service has no idea the
original creator and maintainer of DNS records. This means that there are
likely to be conflicts if there are multiple services that could create or
change DNS records in the same zone.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.NoopRegistry.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.NoopRegistry()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.NoopRegistry.bind">bind</a></code> | Generates an object with all the information needed to use the registry in a given CDK scope. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.NoopRegistry.bind"></a>

```typescript
public bind(_scope: IConstruct): ExternalDnsRegistryConfiguration
```

Generates an object with all the information needed to use the registry in a given CDK scope.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.NoopRegistry.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The CDK resource that is configuring ExternalDNS.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.NoopRegistry.property.registryType">registryType</a></code> | <code>string</code> | The type name of ExternalDNS registry. |

---

##### `registryType`<sup>Required</sup> <a name="registryType" id="cdk-extensions.k8s_aws.NoopRegistry.property.registryType"></a>

```typescript
public readonly registryType: string;
```

- *Type:* string

The type name of ExternalDNS registry.

---


### OpenSearchOutputBufferSize <a name="OpenSearchOutputBufferSize" id="cdk-extensions.k8s_aws.OpenSearchOutputBufferSize"></a>

Represents the size of the OpenSeach output buffer to be used by Fluent Bit.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.bytes">bytes</a></code> | Set the output buffer to a specified data size. |
| <code><a href="#cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.of">of</a></code> | An escape hatch that allows an arbitrary value to be set for the OpenSearch buffer output property. |

---

##### `bytes` <a name="bytes" id="cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.bytes"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.OpenSearchOutputBufferSize.bytes(size: DataSize)
```

Set the output buffer to a specified data size.

###### `size`<sup>Required</sup> <a name="size" id="cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.bytes.parameter.size"></a>

- *Type:* cdk-extensions.core.DataSize

The size of the output buffer.

---

##### `of` <a name="of" id="cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.of"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.OpenSearchOutputBufferSize.of(value: string)
```

An escape hatch that allows an arbitrary value to be set for the OpenSearch buffer output property.

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.of.parameter.value"></a>

- *Type:* string

The value to use for the OpenSearch buffer output property.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.property.value">value</a></code> | <code>string</code> | The value to use for the OpenSearch buffer output property. |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

The value to use for the OpenSearch buffer output property.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.property.UNLIMITED">UNLIMITED</a></code> | <code>cdk-extensions.k8s_aws.OpenSearchOutputBufferSize</code> | Set the output buffer size to unlimited. |

---

##### `UNLIMITED`<sup>Required</sup> <a name="UNLIMITED" id="cdk-extensions.k8s_aws.OpenSearchOutputBufferSize.property.UNLIMITED"></a>

```typescript
public readonly UNLIMITED: OpenSearchOutputBufferSize;
```

- *Type:* cdk-extensions.k8s_aws.OpenSearchOutputBufferSize

Set the output buffer size to unlimited.

---

### OpenxJsonInputSerDe <a name="OpenxJsonInputSerDe" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.OpenxJsonInputSerDe(options?: OpenxJsonInputSerDeOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions</code> | *No description.* |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.addColumnKeyMapping">addColumnKeyMapping</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.bind"></a>

```typescript
public bind(_scope: IConstruct): InputFormatConfigurationProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

##### `addColumnKeyMapping` <a name="addColumnKeyMapping" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.addColumnKeyMapping"></a>

```typescript
public addColumnKeyMapping(columnName: string, jsonKey: string): OpenxJsonInputSerDe
```

###### `columnName`<sup>Required</sup> <a name="columnName" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.addColumnKeyMapping.parameter.columnName"></a>

- *Type:* string

---

###### `jsonKey`<sup>Required</sup> <a name="jsonKey" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.addColumnKeyMapping.parameter.jsonKey"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.hiveJson">hiveJson</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.openxJson">openxJson</a></code> | *No description.* |

---

##### `hiveJson` <a name="hiveJson" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.hiveJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.OpenxJsonInputSerDe.hiveJson(options: HiveJsonInputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.hiveJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.HiveJsonInputSerDeOptions

---

##### `openxJson` <a name="openxJson" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.openxJson"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.OpenxJsonInputSerDe.openxJson(options: OpenxJsonInputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.openxJson.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.OpenxJsonInputSerDeOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.property.caseInsensitive">caseInsensitive</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.property.convertDotsToUnderscores">convertDotsToUnderscores</a></code> | <code>boolean</code> | *No description.* |

---

##### `caseInsensitive`<sup>Optional</sup> <a name="caseInsensitive" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.property.caseInsensitive"></a>

```typescript
public readonly caseInsensitive: boolean;
```

- *Type:* boolean

---

##### `convertDotsToUnderscores`<sup>Optional</sup> <a name="convertDotsToUnderscores" id="cdk-extensions.kinesis_firehose.OpenxJsonInputSerDe.property.convertDotsToUnderscores"></a>

```typescript
public readonly convertDotsToUnderscores: boolean;
```

- *Type:* boolean

---


### OrcOutputSerDe <a name="OrcOutputSerDe" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.OrcOutputSerDe(options?: OrcOutputSerDeOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions</code> | *No description.* |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.addBloomFilterColumn">addBloomFilterColumn</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.bind"></a>

```typescript
public bind(_scope: IConstruct): OutputFormatConfigurationProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

##### `addBloomFilterColumn` <a name="addBloomFilterColumn" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.addBloomFilterColumn"></a>

```typescript
public addBloomFilterColumn(column: string): OrcOutputSerDe
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.addBloomFilterColumn.parameter.column"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.orc">orc</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.parquet">parquet</a></code> | *No description.* |

---

##### `orc` <a name="orc" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.orc"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.OrcOutputSerDe.orc(options: OrcOutputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.orc.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions

---

##### `parquet` <a name="parquet" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.parquet"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.OrcOutputSerDe.parquet(options: ParquetOutputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.parquet.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.blockSizeBytes">blockSizeBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.bloomFilterColumns">bloomFilterColumns</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.bloomFilterFalsePositiveProbability">bloomFilterFalsePositiveProbability</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.compression">compression</a></code> | <code>cdk-extensions.kinesis_firehose.OrcCompressionFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.dictionaryKeyThreshold">dictionaryKeyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.enablePadding">enablePadding</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.formatVersion">formatVersion</a></code> | <code>cdk-extensions.kinesis_firehose.OrcFormatVersion</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.paddingTolerance">paddingTolerance</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.rowIndexStride">rowIndexStride</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.stripeSizeBytes">stripeSizeBytes</a></code> | <code>number</code> | *No description.* |

---

##### `blockSizeBytes`<sup>Optional</sup> <a name="blockSizeBytes" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.blockSizeBytes"></a>

```typescript
public readonly blockSizeBytes: number;
```

- *Type:* number

---

##### `bloomFilterColumns`<sup>Optional</sup> <a name="bloomFilterColumns" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.bloomFilterColumns"></a>

```typescript
public readonly bloomFilterColumns: string[];
```

- *Type:* string[]

---

##### `bloomFilterFalsePositiveProbability`<sup>Optional</sup> <a name="bloomFilterFalsePositiveProbability" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.bloomFilterFalsePositiveProbability"></a>

```typescript
public readonly bloomFilterFalsePositiveProbability: number;
```

- *Type:* number

---

##### `compression`<sup>Optional</sup> <a name="compression" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.compression"></a>

```typescript
public readonly compression: OrcCompressionFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.OrcCompressionFormat

---

##### `dictionaryKeyThreshold`<sup>Optional</sup> <a name="dictionaryKeyThreshold" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.dictionaryKeyThreshold"></a>

```typescript
public readonly dictionaryKeyThreshold: number;
```

- *Type:* number

---

##### `enablePadding`<sup>Optional</sup> <a name="enablePadding" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.enablePadding"></a>

```typescript
public readonly enablePadding: boolean;
```

- *Type:* boolean

---

##### `formatVersion`<sup>Optional</sup> <a name="formatVersion" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.formatVersion"></a>

```typescript
public readonly formatVersion: OrcFormatVersion;
```

- *Type:* cdk-extensions.kinesis_firehose.OrcFormatVersion

---

##### `paddingTolerance`<sup>Optional</sup> <a name="paddingTolerance" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.paddingTolerance"></a>

```typescript
public readonly paddingTolerance: number;
```

- *Type:* number

---

##### `rowIndexStride`<sup>Optional</sup> <a name="rowIndexStride" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.rowIndexStride"></a>

```typescript
public readonly rowIndexStride: number;
```

- *Type:* number

---

##### `stripeSizeBytes`<sup>Optional</sup> <a name="stripeSizeBytes" id="cdk-extensions.kinesis_firehose.OrcOutputSerDe.property.stripeSizeBytes"></a>

```typescript
public readonly stripeSizeBytes: number;
```

- *Type:* number

---


### OutputFormat <a name="OutputFormat" id="cdk-extensions.glue.OutputFormat"></a>

Absolute class name of the Hadoop `OutputFormat` to use when writing table files.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.OutputFormat.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.OutputFormat(className: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.OutputFormat.Initializer.parameter.className">className</a></code> | <code>string</code> | *No description.* |

---

##### `className`<sup>Required</sup> <a name="className" id="cdk-extensions.glue.OutputFormat.Initializer.parameter.className"></a>

- *Type:* string

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.OutputFormat.property.className">className</a></code> | <code>string</code> | *No description.* |

---

##### `className`<sup>Required</sup> <a name="className" id="cdk-extensions.glue.OutputFormat.property.className"></a>

```typescript
public readonly className: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.OutputFormat.property.AVRO">AVRO</a></code> | <code>cdk-extensions.glue.InputFormat</code> | OutputFormat for Avro files. |
| <code><a href="#cdk-extensions.glue.OutputFormat.property.HIVE_IGNORE_KEY_TEXT">HIVE_IGNORE_KEY_TEXT</a></code> | <code>cdk-extensions.glue.OutputFormat</code> | Writes text data with a null key (value only). |
| <code><a href="#cdk-extensions.glue.OutputFormat.property.ORC">ORC</a></code> | <code>cdk-extensions.glue.InputFormat</code> | OutputFormat for Orc files. |
| <code><a href="#cdk-extensions.glue.OutputFormat.property.PARQUET">PARQUET</a></code> | <code>cdk-extensions.glue.OutputFormat</code> | OutputFormat for Parquet files. |

---

##### `AVRO`<sup>Required</sup> <a name="AVRO" id="cdk-extensions.glue.OutputFormat.property.AVRO"></a>

```typescript
public readonly AVRO: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

OutputFormat for Avro files.

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/avro/AvroContainerOutputFormat.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/avro/AvroContainerOutputFormat.html)

---

##### `HIVE_IGNORE_KEY_TEXT`<sup>Required</sup> <a name="HIVE_IGNORE_KEY_TEXT" id="cdk-extensions.glue.OutputFormat.property.HIVE_IGNORE_KEY_TEXT"></a>

```typescript
public readonly HIVE_IGNORE_KEY_TEXT: OutputFormat;
```

- *Type:* cdk-extensions.glue.OutputFormat

Writes text data with a null key (value only).

> [https://hive.apache.org/javadocs/r2.2.0/api/org/apache/hadoop/hive/ql/io/HiveIgnoreKeyTextOutputFormat.html](https://hive.apache.org/javadocs/r2.2.0/api/org/apache/hadoop/hive/ql/io/HiveIgnoreKeyTextOutputFormat.html)

---

##### `ORC`<sup>Required</sup> <a name="ORC" id="cdk-extensions.glue.OutputFormat.property.ORC"></a>

```typescript
public readonly ORC: InputFormat;
```

- *Type:* cdk-extensions.glue.InputFormat

OutputFormat for Orc files.

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/orc/OrcOutputFormat.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/orc/OrcOutputFormat.html)

---

##### `PARQUET`<sup>Required</sup> <a name="PARQUET" id="cdk-extensions.glue.OutputFormat.property.PARQUET"></a>

```typescript
public readonly PARQUET: OutputFormat;
```

- *Type:* cdk-extensions.glue.OutputFormat

OutputFormat for Parquet files.

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/parquet/MapredParquetOutputFormat.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/parquet/MapredParquetOutputFormat.html)

---

### OutputFormat <a name="OutputFormat" id="cdk-extensions.kinesis_firehose.OutputFormat"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.OutputFormat.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.OutputFormat()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OutputFormat.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.OutputFormat.bind"></a>

```typescript
public bind(scope: IConstruct): OutputFormatConfigurationProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.OutputFormat.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OutputFormat.orc">orc</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OutputFormat.parquet">parquet</a></code> | *No description.* |

---

##### `orc` <a name="orc" id="cdk-extensions.kinesis_firehose.OutputFormat.orc"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.OutputFormat.orc(options: OrcOutputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.OutputFormat.orc.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions

---

##### `parquet` <a name="parquet" id="cdk-extensions.kinesis_firehose.OutputFormat.parquet"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.OutputFormat.parquet(options: ParquetOutputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.OutputFormat.parquet.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions

---



### ParquetOutputSerDe <a name="ParquetOutputSerDe" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.ParquetOutputSerDe(options?: ParquetOutputSerDeOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions</code> | *No description.* |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.bind"></a>

```typescript
public bind(_scope: IConstruct): OutputFormatConfigurationProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.orc">orc</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.parquet">parquet</a></code> | *No description.* |

---

##### `orc` <a name="orc" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.orc"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.ParquetOutputSerDe.orc(options: OrcOutputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.orc.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.OrcOutputSerDeOptions

---

##### `parquet` <a name="parquet" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.parquet"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.ParquetOutputSerDe.parquet(options: ParquetOutputSerDeOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.parquet.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.ParquetOutputSerDeOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.blockSizeBytes">blockSizeBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.compression">compression</a></code> | <code>cdk-extensions.kinesis_firehose.ParquetCompressionFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.enableDictionaryCompression">enableDictionaryCompression</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.maxPaddingBytes">maxPaddingBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.pageSizeBytes">pageSizeBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.writerVersion">writerVersion</a></code> | <code>cdk-extensions.kinesis_firehose.ParquetWriterVersion</code> | *No description.* |

---

##### `blockSizeBytes`<sup>Optional</sup> <a name="blockSizeBytes" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.blockSizeBytes"></a>

```typescript
public readonly blockSizeBytes: number;
```

- *Type:* number

---

##### `compression`<sup>Optional</sup> <a name="compression" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.compression"></a>

```typescript
public readonly compression: ParquetCompressionFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.ParquetCompressionFormat

---

##### `enableDictionaryCompression`<sup>Optional</sup> <a name="enableDictionaryCompression" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.enableDictionaryCompression"></a>

```typescript
public readonly enableDictionaryCompression: boolean;
```

- *Type:* boolean

---

##### `maxPaddingBytes`<sup>Optional</sup> <a name="maxPaddingBytes" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.maxPaddingBytes"></a>

```typescript
public readonly maxPaddingBytes: number;
```

- *Type:* number

---

##### `pageSizeBytes`<sup>Optional</sup> <a name="pageSizeBytes" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.pageSizeBytes"></a>

```typescript
public readonly pageSizeBytes: number;
```

- *Type:* number

---

##### `writerVersion`<sup>Optional</sup> <a name="writerVersion" id="cdk-extensions.kinesis_firehose.ParquetOutputSerDe.property.writerVersion"></a>

```typescript
public readonly writerVersion: ParquetWriterVersion;
```

- *Type:* cdk-extensions.kinesis_firehose.ParquetWriterVersion

---


### ParserPluginDataType <a name="ParserPluginDataType" id="cdk-extensions.k8s_aws.ParserPluginDataType"></a>

Represents the various types of data that can be mapped in Fluent Bit using a parser plugin.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.of">of</a></code> | An escape hatch method that allow specifying arbitrary custom data types. |

---

##### `of` <a name="of" id="cdk-extensions.k8s_aws.ParserPluginDataType.of"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

k8s_aws.ParserPluginDataType.of(name: string)
```

An escape hatch method that allow specifying arbitrary custom data types.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.ParserPluginDataType.of.parameter.name"></a>

- *Type:* string

The name of the data type.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.name">name</a></code> | <code>string</code> | The name of the data type. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the data type.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.BOOL">BOOL</a></code> | <code>cdk-extensions.k8s_aws.ParserPluginDataType</code> | Object that is true or false. |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.FLOAT">FLOAT</a></code> | <code>cdk-extensions.k8s_aws.ParserPluginDataType</code> | Floating point number values. |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.HEX">HEX</a></code> | <code>cdk-extensions.k8s_aws.ParserPluginDataType</code> | Hexidecimal number values. |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.INTEGER">INTEGER</a></code> | <code>cdk-extensions.k8s_aws.ParserPluginDataType</code> | While number values. |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.LOGFMT">LOGFMT</a></code> | <code>cdk-extensions.k8s_aws.ParserPluginDataType</code> | Logfmt formatted data. |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.LTSV">LTSV</a></code> | <code>cdk-extensions.k8s_aws.ParserPluginDataType</code> | Labeled tab-separated values. |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.REGEX">REGEX</a></code> | <code>cdk-extensions.k8s_aws.ParserPluginDataType</code> | Regular expression. |
| <code><a href="#cdk-extensions.k8s_aws.ParserPluginDataType.property.STRING">STRING</a></code> | <code>cdk-extensions.k8s_aws.ParserPluginDataType</code> | Text data. |

---

##### `BOOL`<sup>Required</sup> <a name="BOOL" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.BOOL"></a>

```typescript
public readonly BOOL: ParserPluginDataType;
```

- *Type:* cdk-extensions.k8s_aws.ParserPluginDataType

Object that is true or false.

---

##### `FLOAT`<sup>Required</sup> <a name="FLOAT" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.FLOAT"></a>

```typescript
public readonly FLOAT: ParserPluginDataType;
```

- *Type:* cdk-extensions.k8s_aws.ParserPluginDataType

Floating point number values.

---

##### `HEX`<sup>Required</sup> <a name="HEX" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.HEX"></a>

```typescript
public readonly HEX: ParserPluginDataType;
```

- *Type:* cdk-extensions.k8s_aws.ParserPluginDataType

Hexidecimal number values.

---

##### `INTEGER`<sup>Required</sup> <a name="INTEGER" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.INTEGER"></a>

```typescript
public readonly INTEGER: ParserPluginDataType;
```

- *Type:* cdk-extensions.k8s_aws.ParserPluginDataType

While number values.

---

##### `LOGFMT`<sup>Required</sup> <a name="LOGFMT" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.LOGFMT"></a>

```typescript
public readonly LOGFMT: ParserPluginDataType;
```

- *Type:* cdk-extensions.k8s_aws.ParserPluginDataType

Logfmt formatted data.

> [[Golang logfmt documentation](https://pkg.go.dev/github.com/kr/logfmt)]([Golang logfmt documentation](https://pkg.go.dev/github.com/kr/logfmt))

---

##### `LTSV`<sup>Required</sup> <a name="LTSV" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.LTSV"></a>

```typescript
public readonly LTSV: ParserPluginDataType;
```

- *Type:* cdk-extensions.k8s_aws.ParserPluginDataType

Labeled tab-separated values.

> [[LTSV](http://ltsv.org/)]([LTSV](http://ltsv.org/))

---

##### `REGEX`<sup>Required</sup> <a name="REGEX" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.REGEX"></a>

```typescript
public readonly REGEX: ParserPluginDataType;
```

- *Type:* cdk-extensions.k8s_aws.ParserPluginDataType

Regular expression.

---

##### `STRING`<sup>Required</sup> <a name="STRING" id="cdk-extensions.k8s_aws.ParserPluginDataType.property.STRING"></a>

```typescript
public readonly STRING: ParserPluginDataType;
```

- *Type:* cdk-extensions.k8s_aws.ParserPluginDataType

Text data.

---

### PermissionsBoundary <a name="PermissionsBoundary" id="cdk-extensions.sso.PermissionsBoundary"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.sso.PermissionsBoundary.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.PermissionsBoundary()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.PermissionsBoundary.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.sso.PermissionsBoundary.bind"></a>

```typescript
public bind(scope: IConstruct): PermissionsBoundaryProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.PermissionsBoundary.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.PermissionsBoundary.fromManagedPolicy">fromManagedPolicy</a></code> | *No description.* |
| <code><a href="#cdk-extensions.sso.PermissionsBoundary.fromReference">fromReference</a></code> | *No description.* |

---

##### `fromManagedPolicy` <a name="fromManagedPolicy" id="cdk-extensions.sso.PermissionsBoundary.fromManagedPolicy"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.PermissionsBoundary.fromManagedPolicy(policy: IManagedPolicy)
```

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.PermissionsBoundary.fromManagedPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.aws_iam.IManagedPolicy

---

##### `fromReference` <a name="fromReference" id="cdk-extensions.sso.PermissionsBoundary.fromReference"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.PermissionsBoundary.fromReference(options: ReferenceOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.sso.PermissionsBoundary.fromReference.parameter.options"></a>

- *Type:* cdk-extensions.sso.ReferenceOptions

---



### ProcessorConfiguration <a name="ProcessorConfiguration" id="cdk-extensions.kinesis_firehose.ProcessorConfiguration"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.ProcessorConfiguration.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.ProcessorConfiguration(options: ProcessorConfigurationOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorConfiguration.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorConfigurationOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.ProcessorConfiguration.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.ProcessorConfigurationOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorConfiguration.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.ProcessorConfiguration.bind"></a>

```typescript
public bind(_scope: IConstruct): ProcessorConfigurationResult
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.ProcessorConfiguration.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorConfiguration.property.enabled">enabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorConfiguration.property.processors">processors</a></code> | <code>cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]</code> | *No description.* |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.ProcessorConfiguration.property.enabled"></a>

```typescript
public readonly enabled: boolean;
```

- *Type:* boolean

---

##### `processors`<sup>Optional</sup> <a name="processors" id="cdk-extensions.kinesis_firehose.ProcessorConfiguration.property.processors"></a>

```typescript
public readonly processors: DeliveryStreamProcessor[];
```

- *Type:* cdk-extensions.kinesis_firehose.DeliveryStreamProcessor[]

---


### ProcessorType <a name="ProcessorType" id="cdk-extensions.kinesis_firehose.ProcessorType"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorType.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk-extensions.kinesis_firehose.ProcessorType.of"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.ProcessorType.of(name: string)
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.kinesis_firehose.ProcessorType.of.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorType.property.name">name</a></code> | <code>string</code> | The name of the processor to apply to the delivery stream. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.kinesis_firehose.ProcessorType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the processor to apply to the delivery stream.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorType.property.APPEND_DELIMITER_TO_RECORD">APPEND_DELIMITER_TO_RECORD</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorType.property.LAMBDA">LAMBDA</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorType.property.METADATA_EXTRACTION">METADATA_EXTRACTION</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ProcessorType.property.RECORD_DEAGGREGATION">RECORD_DEAGGREGATION</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |

---

##### `APPEND_DELIMITER_TO_RECORD`<sup>Required</sup> <a name="APPEND_DELIMITER_TO_RECORD" id="cdk-extensions.kinesis_firehose.ProcessorType.property.APPEND_DELIMITER_TO_RECORD"></a>

```typescript
public readonly APPEND_DELIMITER_TO_RECORD: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `LAMBDA`<sup>Required</sup> <a name="LAMBDA" id="cdk-extensions.kinesis_firehose.ProcessorType.property.LAMBDA"></a>

```typescript
public readonly LAMBDA: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `METADATA_EXTRACTION`<sup>Required</sup> <a name="METADATA_EXTRACTION" id="cdk-extensions.kinesis_firehose.ProcessorType.property.METADATA_EXTRACTION"></a>

```typescript
public readonly METADATA_EXTRACTION: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `RECORD_DEAGGREGATION`<sup>Required</sup> <a name="RECORD_DEAGGREGATION" id="cdk-extensions.kinesis_firehose.ProcessorType.property.RECORD_DEAGGREGATION"></a>

```typescript
public readonly RECORD_DEAGGREGATION: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

### PrometheusRule <a name="PrometheusRule" id="cdk-extensions.aps.PrometheusRule"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.aps.PrometheusRule.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.PrometheusRule()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.PrometheusRule.alertingRule">alertingRule</a></code> | *No description.* |
| <code><a href="#cdk-extensions.aps.PrometheusRule.recordingRule">recordingRule</a></code> | *No description.* |

---

##### `alertingRule` <a name="alertingRule" id="cdk-extensions.aps.PrometheusRule.alertingRule"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.PrometheusRule.alertingRule(options: AlertingRuleProps)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.PrometheusRule.alertingRule.parameter.options"></a>

- *Type:* cdk-extensions.aps.AlertingRuleProps

---

##### `recordingRule` <a name="recordingRule" id="cdk-extensions.aps.PrometheusRule.recordingRule"></a>

```typescript
import { aps } from 'cdk-extensions'

aps.PrometheusRule.recordingRule(options: RecordingRuleProps)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.PrometheusRule.recordingRule.parameter.options"></a>

- *Type:* cdk-extensions.aps.RecordingRuleProps

---



### PublicIpSource <a name="PublicIpSource" id="cdk-extensions.ec2.PublicIpSource"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.PublicIpSource.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk-extensions.ec2.PublicIpSource.of"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.PublicIpSource.of(name: string)
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.PublicIpSource.of.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.PublicIpSource.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.PublicIpSource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.PublicIpSource.property.AMAZON">AMAZON</a></code> | <code>cdk-extensions.ec2.PublicIpSource</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.PublicIpSource.property.BYOIP">BYOIP</a></code> | <code>cdk-extensions.ec2.PublicIpSource</code> | *No description.* |

---

##### `AMAZON`<sup>Required</sup> <a name="AMAZON" id="cdk-extensions.ec2.PublicIpSource.property.AMAZON"></a>

```typescript
public readonly AMAZON: PublicIpSource;
```

- *Type:* cdk-extensions.ec2.PublicIpSource

---

##### `BYOIP`<sup>Required</sup> <a name="BYOIP" id="cdk-extensions.ec2.PublicIpSource.property.BYOIP"></a>

```typescript
public readonly BYOIP: PublicIpSource;
```

- *Type:* cdk-extensions.ec2.PublicIpSource

---

### RecordDeaggregationProcessor <a name="RecordDeaggregationProcessor" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.RecordDeaggregationProcessor(options: RecordDeaggregationProcessorOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.RecordDeaggregationProcessorOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.RecordDeaggregationProcessorOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.bind"></a>

```typescript
public bind(_scope: IConstruct): ProcessorProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.delimited">delimited</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.json">json</a></code> | *No description.* |

---

##### `delimited` <a name="delimited" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.delimited"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.RecordDeaggregationProcessor.delimited(options: DelimitedDeaggregationOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.delimited.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.DelimitedDeaggregationOptions

---

##### `json` <a name="json" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.json"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.RecordDeaggregationProcessor.json()
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.property.processorType">processorType</a></code> | <code>cdk-extensions.kinesis_firehose.ProcessorType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.property.subRecordType">subRecordType</a></code> | <code>cdk-extensions.kinesis_firehose.SubRecordType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.property.delimiter">delimiter</a></code> | <code>string</code> | *No description.* |

---

##### `processorType`<sup>Required</sup> <a name="processorType" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.property.processorType"></a>

```typescript
public readonly processorType: ProcessorType;
```

- *Type:* cdk-extensions.kinesis_firehose.ProcessorType

---

##### `subRecordType`<sup>Required</sup> <a name="subRecordType" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.property.subRecordType"></a>

```typescript
public readonly subRecordType: SubRecordType;
```

- *Type:* cdk-extensions.kinesis_firehose.SubRecordType

---

##### `delimiter`<sup>Optional</sup> <a name="delimiter" id="cdk-extensions.kinesis_firehose.RecordDeaggregationProcessor.property.delimiter"></a>

```typescript
public readonly delimiter: string;
```

- *Type:* string

---


### RecordingRule <a name="RecordingRule" id="cdk-extensions.aps.RecordingRule"></a>

- *Implements:* cdk-extensions.aps.IPrometheusRule

Recording rules allow you to precompute frequently needed or computationally expensive expressions and save their result as a new set of time series.

Querying the precomputed result will then often be much faster than
executing the original expression every time it is needed. This is
especially useful for dashboards, which need to query the same expression
repeatedly every time they refresh.

> [[Defining recording rules](https://prometheus.io/docs/prometheus/latest/configuration/recording_rules/)]([Defining recording rules](https://prometheus.io/docs/prometheus/latest/configuration/recording_rules/))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.RecordingRule.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.RecordingRule(props: RecordingRuleProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RecordingRule.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.aps.RecordingRuleProps</code> | Arguments defining the configuration of the reporting rule. |

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.aps.RecordingRule.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.aps.RecordingRuleProps

Arguments defining the configuration of the reporting rule.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.RecordingRule.addLabel">addLabel</a></code> | Sets a new label and value that will be added or overridden before storing the result. |
| <code><a href="#cdk-extensions.aps.RecordingRule.bind">bind</a></code> | Associates the recording rule with a construct that is configuring an APS rule groups namespace. |

---

##### `addLabel` <a name="addLabel" id="cdk-extensions.aps.RecordingRule.addLabel"></a>

```typescript
public addLabel(label: string, value: string): RecordingRule
```

Sets a new label and value that will be added or overridden before storing the result.

###### `label`<sup>Required</sup> <a name="label" id="cdk-extensions.aps.RecordingRule.addLabel.parameter.label"></a>

- *Type:* string

The name of the label to add.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.aps.RecordingRule.addLabel.parameter.value"></a>

- *Type:* string

The values of the label to add.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.RecordingRule.bind"></a>

```typescript
public bind(_scope: IConstruct): {[ key: string ]: any}
```

Associates the recording rule with a construct that is configuring an APS rule groups namespace.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.aps.RecordingRule.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of the APS rule groups namespace that will be consuming this rule.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.RecordingRule.property.expression">expression</a></code> | <code>string</code> | The PromQL expression to evaluate. |
| <code><a href="#cdk-extensions.aps.RecordingRule.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Labels to add or overwrite before storing the result. |
| <code><a href="#cdk-extensions.aps.RecordingRule.property.record">record</a></code> | <code>string</code> | The name of the time series to output to. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk-extensions.aps.RecordingRule.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

The PromQL expression to evaluate.

Every evaluation cycle this is
evaluated at the current time, and the result recorded as a new set of
time series with the metric name as given by `record`.

> [[Querying prometheus](https://prometheus.io/docs/prometheus/latest/querying/basics/)]([Querying prometheus](https://prometheus.io/docs/prometheus/latest/querying/basics/))

---

##### `labels`<sup>Required</sup> <a name="labels" id="cdk-extensions.aps.RecordingRule.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Labels to add or overwrite before storing the result.

---

##### `record`<sup>Required</sup> <a name="record" id="cdk-extensions.aps.RecordingRule.property.record"></a>

```typescript
public readonly record: string;
```

- *Type:* string

The name of the time series to output to.

Must be a valid metric name.

---


### ReferencedPermissionsBoundary <a name="ReferencedPermissionsBoundary" id="cdk-extensions.sso.ReferencedPermissionsBoundary"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.sso.ReferencedPermissionsBoundary.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.ReferencedPermissionsBoundary(options: ReferenceOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedPermissionsBoundary.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.sso.ReferenceOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.sso.ReferencedPermissionsBoundary.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.sso.ReferenceOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedPermissionsBoundary.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.sso.ReferencedPermissionsBoundary.bind"></a>

```typescript
public bind(_scope: IConstruct): PermissionsBoundaryProperty
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.sso.ReferencedPermissionsBoundary.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedPermissionsBoundary.fromManagedPolicy">fromManagedPolicy</a></code> | *No description.* |
| <code><a href="#cdk-extensions.sso.ReferencedPermissionsBoundary.fromReference">fromReference</a></code> | *No description.* |

---

##### `fromManagedPolicy` <a name="fromManagedPolicy" id="cdk-extensions.sso.ReferencedPermissionsBoundary.fromManagedPolicy"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedPermissionsBoundary.fromManagedPolicy(policy: IManagedPolicy)
```

###### `policy`<sup>Required</sup> <a name="policy" id="cdk-extensions.sso.ReferencedPermissionsBoundary.fromManagedPolicy.parameter.policy"></a>

- *Type:* aws-cdk-lib.aws_iam.IManagedPolicy

---

##### `fromReference` <a name="fromReference" id="cdk-extensions.sso.ReferencedPermissionsBoundary.fromReference"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.ReferencedPermissionsBoundary.fromReference(options: ReferenceOptions)
```

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.sso.ReferencedPermissionsBoundary.fromReference.parameter.options"></a>

- *Type:* cdk-extensions.sso.ReferenceOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.ReferencedPermissionsBoundary.property.referencedPolicy">referencedPolicy</a></code> | <code>cdk-extensions.sso.ReferencedManagedPolicy</code> | *No description.* |

---

##### `referencedPolicy`<sup>Required</sup> <a name="referencedPolicy" id="cdk-extensions.sso.ReferencedPermissionsBoundary.property.referencedPolicy"></a>

```typescript
public readonly referencedPolicy: ReferencedManagedPolicy;
```

- *Type:* cdk-extensions.sso.ReferencedManagedPolicy

---


### S3Code <a name="S3Code" id="cdk-extensions.glue.S3Code"></a>

Glue job Code from an S3 bucket.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.S3Code.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.S3Code(bucket: IBucket, key: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.S3Code.Initializer.parameter.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.S3Code.Initializer.parameter.key">key</a></code> | <code>string</code> | *No description.* |

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue.S3Code.Initializer.parameter.bucket"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucket

---

##### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.S3Code.Initializer.parameter.key"></a>

- *Type:* string

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.S3Code.bind">bind</a></code> | Called when the Job is initialized to allow this object to bind. |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.S3Code.bind"></a>

```typescript
public bind(_scope: Construct, grantable: IGrantable): CodeConfig
```

Called when the Job is initialized to allow this object to bind.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.glue.S3Code.bind.parameter._scope"></a>

- *Type:* constructs.Construct

---

###### `grantable`<sup>Required</sup> <a name="grantable" id="cdk-extensions.glue.S3Code.bind.parameter.grantable"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.S3Code.fromAsset">fromAsset</a></code> | Job code from a local disk path. |
| <code><a href="#cdk-extensions.glue.S3Code.fromBucket">fromBucket</a></code> | Job code as an S3 object. |

---

##### `fromAsset` <a name="fromAsset" id="cdk-extensions.glue.S3Code.fromAsset"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.S3Code.fromAsset(path: string, options?: AssetOptions)
```

Job code from a local disk path.

###### `path`<sup>Required</sup> <a name="path" id="cdk-extensions.glue.S3Code.fromAsset.parameter.path"></a>

- *Type:* string

Code file (not a directory).

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.S3Code.fromAsset.parameter.options"></a>

- *Type:* aws-cdk-lib.AssetOptions

---

##### `fromBucket` <a name="fromBucket" id="cdk-extensions.glue.S3Code.fromBucket"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.S3Code.fromBucket(bucket: IBucket, key: string)
```

Job code as an S3 object.

###### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue.S3Code.fromBucket.parameter.bucket"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucket

The S3 bucket.

---

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.S3Code.fromBucket.parameter.key"></a>

- *Type:* string

The object key.

---



### S3Destination <a name="S3Destination" id="cdk-extensions.kinesis_firehose.S3Destination"></a>

- *Implements:* cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination

#### Initializers <a name="Initializers" id="cdk-extensions.kinesis_firehose.S3Destination.Initializer"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

new kinesis_firehose.S3Destination(bucket: IBucket, options?: S3DestinationOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.Initializer.parameter.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.kinesis_firehose.S3DestinationOptions</code> | *No description.* |

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.kinesis_firehose.S3Destination.Initializer.parameter.bucket"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucket

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.kinesis_firehose.S3Destination.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.kinesis_firehose.S3DestinationOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.renderBackupConfiguration">renderBackupConfiguration</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.kinesis_firehose.S3Destination.bind"></a>

```typescript
public bind(scope: IConstruct): DeliveryStreamDestinationConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.S3Destination.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `renderBackupConfiguration` <a name="renderBackupConfiguration" id="cdk-extensions.kinesis_firehose.S3Destination.renderBackupConfiguration"></a>

```typescript
public renderBackupConfiguration(scope: IConstruct, enabled?: boolean): BackupConfigurationResult
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.S3Destination.renderBackupConfiguration.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.S3Destination.renderBackupConfiguration.parameter.enabled"></a>

- *Type:* boolean

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.role">role</a></code> | <code>aws-cdk-lib.aws_iam.IRole</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.buffering">buffering</a></code> | <code>cdk-extensions.kinesis_firehose.BufferingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.cloudwatchLoggingConfiguration">cloudwatchLoggingConfiguration</a></code> | <code>cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.compressionFormat">compressionFormat</a></code> | <code>cdk-extensions.kinesis_firehose.S3CompressionFormat</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.encryptionEnabled">encryptionEnabled</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.encryptionKey">encryptionKey</a></code> | <code>aws-cdk-lib.aws_kms.IKey</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.errorOutputPrefix">errorOutputPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3Destination.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | *No description.* |

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk-extensions.kinesis_firehose.S3Destination.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.kinesis_firehose.S3Destination.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

---

##### `buffering`<sup>Optional</sup> <a name="buffering" id="cdk-extensions.kinesis_firehose.S3Destination.property.buffering"></a>

```typescript
public readonly buffering: BufferingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.BufferingConfiguration

---

##### `cloudwatchLoggingConfiguration`<sup>Optional</sup> <a name="cloudwatchLoggingConfiguration" id="cdk-extensions.kinesis_firehose.S3Destination.property.cloudwatchLoggingConfiguration"></a>

```typescript
public readonly cloudwatchLoggingConfiguration: CloudWatchLoggingConfiguration;
```

- *Type:* cdk-extensions.kinesis_firehose.CloudWatchLoggingConfiguration

---

##### `compressionFormat`<sup>Optional</sup> <a name="compressionFormat" id="cdk-extensions.kinesis_firehose.S3Destination.property.compressionFormat"></a>

```typescript
public readonly compressionFormat: S3CompressionFormat;
```

- *Type:* cdk-extensions.kinesis_firehose.S3CompressionFormat

---

##### `encryptionEnabled`<sup>Optional</sup> <a name="encryptionEnabled" id="cdk-extensions.kinesis_firehose.S3Destination.property.encryptionEnabled"></a>

```typescript
public readonly encryptionEnabled: boolean;
```

- *Type:* boolean

---

##### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdk-extensions.kinesis_firehose.S3Destination.property.encryptionKey"></a>

```typescript
public readonly encryptionKey: IKey;
```

- *Type:* aws-cdk-lib.aws_kms.IKey

---

##### `errorOutputPrefix`<sup>Optional</sup> <a name="errorOutputPrefix" id="cdk-extensions.kinesis_firehose.S3Destination.property.errorOutputPrefix"></a>

```typescript
public readonly errorOutputPrefix: string;
```

- *Type:* string

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk-extensions.kinesis_firehose.S3Destination.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string

---


### S3Target <a name="S3Target" id="cdk-extensions.glue.S3Target"></a>

- *Implements:* cdk-extensions.glue.ICrawlerTarget

#### Initializers <a name="Initializers" id="cdk-extensions.glue.S3Target.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.S3Target(bucket: IBucket, options?: S3TargetOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.S3Target.Initializer.parameter.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.S3Target.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.glue.S3TargetOptions</code> | *No description.* |

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue.S3Target.Initializer.parameter.bucket"></a>

- *Type:* aws-cdk-lib.aws_s3.IBucket

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.S3Target.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.glue.S3TargetOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.S3Target.addExclusion">addExclusion</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.S3Target.bind">bind</a></code> | *No description.* |

---

##### `addExclusion` <a name="addExclusion" id="cdk-extensions.glue.S3Target.addExclusion"></a>

```typescript
public addExclusion(exclusion: string): void
```

###### `exclusion`<sup>Required</sup> <a name="exclusion" id="cdk-extensions.glue.S3Target.addExclusion.parameter.exclusion"></a>

- *Type:* string

---

##### `bind` <a name="bind" id="cdk-extensions.glue.S3Target.bind"></a>

```typescript
public bind(crawler: Crawler): CrawlerTargetCollection
```

###### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.glue.S3Target.bind.parameter.crawler"></a>

- *Type:* cdk-extensions.glue.Crawler

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.S3Target.property.bucket">bucket</a></code> | <code>aws-cdk-lib.aws_s3.IBucket</code> | Bucket to use as the Target. |
| <code><a href="#cdk-extensions.glue.S3Target.property.connection">connection</a></code> | <code>cdk-extensions.glue.Connection</code> | {@link S3TargetOptions.connection}. |
| <code><a href="#cdk-extensions.glue.S3Target.property.exclusions">exclusions</a></code> | <code>string[]</code> | {@link S3TargetOptions.exclusions}. |
| <code><a href="#cdk-extensions.glue.S3Target.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | {@link S3TargetOptions.keyPrefix}. |
| <code><a href="#cdk-extensions.glue.S3Target.property.sampleSize">sampleSize</a></code> | <code>string</code> | {@link S3TargetOptions.sampleSize}. |

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="cdk-extensions.glue.S3Target.property.bucket"></a>

```typescript
public readonly bucket: IBucket;
```

- *Type:* aws-cdk-lib.aws_s3.IBucket

Bucket to use as the Target.

---

##### `connection`<sup>Optional</sup> <a name="connection" id="cdk-extensions.glue.S3Target.property.connection"></a>

```typescript
public readonly connection: Connection;
```

- *Type:* cdk-extensions.glue.Connection

{@link S3TargetOptions.connection}.

---

##### `exclusions`<sup>Optional</sup> <a name="exclusions" id="cdk-extensions.glue.S3Target.property.exclusions"></a>

```typescript
public readonly exclusions: string[];
```

- *Type:* string[]

{@link S3TargetOptions.exclusions}.

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk-extensions.glue.S3Target.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string

{@link S3TargetOptions.keyPrefix}.

---

##### `sampleSize`<sup>Optional</sup> <a name="sampleSize" id="cdk-extensions.glue.S3Target.property.sampleSize"></a>

```typescript
public readonly sampleSize: string;
```

- *Type:* string

{@link S3TargetOptions.sampleSize}.

---


### SecretReference <a name="SecretReference" id="cdk-extensions.core.SecretReference"></a>

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.core.SecretReference.valueForScope">valueForScope</a></code> | *No description.* |

---

##### `valueForScope` <a name="valueForScope" id="cdk-extensions.core.SecretReference.valueForScope"></a>

```typescript
public valueForScope(scope: IConstruct): string
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.core.SecretReference.valueForScope.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.core.SecretReference.string">string</a></code> | *No description.* |

---

##### `string` <a name="string" id="cdk-extensions.core.SecretReference.string"></a>

```typescript
import { core } from 'cdk-extensions'

core.SecretReference.string(scope: IConstruct, key: string, value: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.core.SecretReference.string.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.core.SecretReference.string.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.core.SecretReference.string.parameter.value"></a>

- *Type:* string

---



### SecretsManagerReference <a name="SecretsManagerReference" id="cdk-extensions.k8s_aws.SecretsManagerReference"></a>

- *Implements:* cdk-extensions.k8s_aws.ISecretReference

Defines a reference for importing and synchronizing a Secrets Manager secret to a Kubernetes secret.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.SecretsManagerReference.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.SecretsManagerReference(secret: ISecret, options?: SecretsManagerReferenceOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerReference.Initializer.parameter.secret">secret</a></code> | <code>aws-cdk-lib.aws_secretsmanager.ISecret</code> | The secret being referenced to import into Kubernetes. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerReference.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.SecretsManagerReferenceOptions</code> | Configuration options for the Secrets Manager reference. |

---

##### `secret`<sup>Required</sup> <a name="secret" id="cdk-extensions.k8s_aws.SecretsManagerReference.Initializer.parameter.secret"></a>

- *Type:* aws-cdk-lib.aws_secretsmanager.ISecret

The secret being referenced to import into Kubernetes.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.SecretsManagerReference.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.SecretsManagerReferenceOptions

Configuration options for the Secrets Manager reference.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerReference.addFieldMapping">addFieldMapping</a></code> | Adds a field mapping that specifies how a field from a Secrets Manager JSON secret should be mapped into the imported Kubernetes secret. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerReference.bind">bind</a></code> | Binds the reference to an object that is in charge of generating the manifest for the external secret. |

---

##### `addFieldMapping` <a name="addFieldMapping" id="cdk-extensions.k8s_aws.SecretsManagerReference.addFieldMapping"></a>

```typescript
public addFieldMapping(field: SecretFieldReference): SecretsManagerReference
```

Adds a field mapping that specifies how a field from a Secrets Manager JSON secret should be mapped into the imported Kubernetes secret.

###### `field`<sup>Required</sup> <a name="field" id="cdk-extensions.k8s_aws.SecretsManagerReference.addFieldMapping.parameter.field"></a>

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference

The configuration for how to map the field from Secrets Manager to the Kubernetes secret.

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.SecretsManagerReference.bind"></a>

```typescript
public bind(_scope: IConstruct): SecretReferenceConfiguration
```

Binds the reference to an object that is in charge of generating the manifest for the external secret.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.SecretsManagerReference.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct that will consume the generated configuration.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerReference.property.fields">fields</a></code> | <code>cdk-extensions.k8s_aws.SecretFieldReference[]</code> | An array of field mappings which will be applied to this secret reference when mapping keys from SecretsManager JSON objects to keys in the imported secret. |
| <code><a href="#cdk-extensions.k8s_aws.SecretsManagerReference.property.secret">secret</a></code> | <code>aws-cdk-lib.aws_secretsmanager.ISecret</code> | The secret being referenced to import into Kubernetes. |

---

##### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.k8s_aws.SecretsManagerReference.property.fields"></a>

```typescript
public readonly fields: SecretFieldReference[];
```

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference[]

An array of field mappings which will be applied to this secret reference when mapping keys from SecretsManager JSON objects to keys in the imported secret.

---

##### `secret`<sup>Required</sup> <a name="secret" id="cdk-extensions.k8s_aws.SecretsManagerReference.property.secret"></a>

```typescript
public readonly secret: ISecret;
```

- *Type:* aws-cdk-lib.aws_secretsmanager.ISecret

The secret being referenced to import into Kubernetes.

---


### SerializationLibrary <a name="SerializationLibrary" id="cdk-extensions.glue.SerializationLibrary"></a>

Serialization library to use when serializing/deserializing (SerDe) table records.

> [https://cwiki.apache.org/confluence/display/Hive/SerDe](https://cwiki.apache.org/confluence/display/Hive/SerDe)

#### Initializers <a name="Initializers" id="cdk-extensions.glue.SerializationLibrary.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.SerializationLibrary(className: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.Initializer.parameter.className">className</a></code> | <code>string</code> | *No description.* |

---

##### `className`<sup>Required</sup> <a name="className" id="cdk-extensions.glue.SerializationLibrary.Initializer.parameter.className"></a>

- *Type:* string

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.className">className</a></code> | <code>string</code> | *No description.* |

---

##### `className`<sup>Required</sup> <a name="className" id="cdk-extensions.glue.SerializationLibrary.property.className"></a>

```typescript
public readonly className: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.AVRO">AVRO</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.CLOUDTRAIL">CLOUDTRAIL</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.GROK">GROK</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.HIVE_JSON">HIVE_JSON</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.LAZY_SIMPLE">LAZY_SIMPLE</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.OPEN_CSV">OPEN_CSV</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.OPENX_JSON">OPENX_JSON</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.ORC">ORC</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.PARQUET">PARQUET</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.SerializationLibrary.property.REGEXP">REGEXP</a></code> | <code>cdk-extensions.glue.SerializationLibrary</code> | *No description.* |

---

##### `AVRO`<sup>Required</sup> <a name="AVRO" id="cdk-extensions.glue.SerializationLibrary.property.AVRO"></a>

```typescript
public readonly AVRO: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/serde2/avro/AvroSerDe.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/serde2/avro/AvroSerDe.html)

---

##### `CLOUDTRAIL`<sup>Required</sup> <a name="CLOUDTRAIL" id="cdk-extensions.glue.SerializationLibrary.property.CLOUDTRAIL"></a>

```typescript
public readonly CLOUDTRAIL: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://docs.aws.amazon.com/athena/latest/ug/cloudtrail.html](https://docs.aws.amazon.com/athena/latest/ug/cloudtrail.html)

---

##### `GROK`<sup>Required</sup> <a name="GROK" id="cdk-extensions.glue.SerializationLibrary.property.GROK"></a>

```typescript
public readonly GROK: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://docs.aws.amazon.com/athena/latest/ug/grok.html](https://docs.aws.amazon.com/athena/latest/ug/grok.html)

---

##### `HIVE_JSON`<sup>Required</sup> <a name="HIVE_JSON" id="cdk-extensions.glue.SerializationLibrary.property.HIVE_JSON"></a>

```typescript
public readonly HIVE_JSON: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hive/hcatalog/data/JsonSerDe.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hive/hcatalog/data/JsonSerDe.html)

---

##### `LAZY_SIMPLE`<sup>Required</sup> <a name="LAZY_SIMPLE" id="cdk-extensions.glue.SerializationLibrary.property.LAZY_SIMPLE"></a>

```typescript
public readonly LAZY_SIMPLE: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/serde2/lazy/LazySimpleSerDe.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/serde2/lazy/LazySimpleSerDe.html)

---

##### `OPEN_CSV`<sup>Required</sup> <a name="OPEN_CSV" id="cdk-extensions.glue.SerializationLibrary.property.OPEN_CSV"></a>

```typescript
public readonly OPEN_CSV: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/serde2/OpenCSVSerde.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/serde2/OpenCSVSerde.html)

---

##### `OPENX_JSON`<sup>Required</sup> <a name="OPENX_JSON" id="cdk-extensions.glue.SerializationLibrary.property.OPENX_JSON"></a>

```typescript
public readonly OPENX_JSON: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://github.com/rcongiu/Hive-JSON-Serde](https://github.com/rcongiu/Hive-JSON-Serde)

---

##### `ORC`<sup>Required</sup> <a name="ORC" id="cdk-extensions.glue.SerializationLibrary.property.ORC"></a>

```typescript
public readonly ORC: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/orc/OrcSerde.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/orc/OrcSerde.html)

---

##### `PARQUET`<sup>Required</sup> <a name="PARQUET" id="cdk-extensions.glue.SerializationLibrary.property.PARQUET"></a>

```typescript
public readonly PARQUET: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/parquet/serde/ParquetHiveSerDe.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/ql/io/parquet/serde/ParquetHiveSerDe.html)

---

##### `REGEXP`<sup>Required</sup> <a name="REGEXP" id="cdk-extensions.glue.SerializationLibrary.property.REGEXP"></a>

```typescript
public readonly REGEXP: SerializationLibrary;
```

- *Type:* cdk-extensions.glue.SerializationLibrary

> [https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/serde2/RegexSerDe.html](https://hive.apache.org/javadocs/r1.2.2/api/org/apache/hadoop/hive/serde2/RegexSerDe.html)

---

### SharedPrincipal <a name="SharedPrincipal" id="cdk-extensions.ram.SharedPrincipal"></a>

- *Implements:* cdk-extensions.ram.ISharedPrincipal

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram.SharedPrincipal.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.ram.SharedPrincipal.bind"></a>

```typescript
public bind(_scope: IConstruct): string
```

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.ram.SharedPrincipal.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram.SharedPrincipal.fromAccountId">fromAccountId</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram.SharedPrincipal.fromConstruct">fromConstruct</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram.SharedPrincipal.fromOrganizationalUnitArn">fromOrganizationalUnitArn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram.SharedPrincipal.fromOrganizationArn">fromOrganizationArn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram.SharedPrincipal.fromRole">fromRole</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram.SharedPrincipal.fromStage">fromStage</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram.SharedPrincipal.fromUser">fromUser</a></code> | *No description.* |

---

##### `fromAccountId` <a name="fromAccountId" id="cdk-extensions.ram.SharedPrincipal.fromAccountId"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.SharedPrincipal.fromAccountId(account: string)
```

###### `account`<sup>Required</sup> <a name="account" id="cdk-extensions.ram.SharedPrincipal.fromAccountId.parameter.account"></a>

- *Type:* string

---

##### `fromConstruct` <a name="fromConstruct" id="cdk-extensions.ram.SharedPrincipal.fromConstruct"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.SharedPrincipal.fromConstruct(construct: IConstruct)
```

###### `construct`<sup>Required</sup> <a name="construct" id="cdk-extensions.ram.SharedPrincipal.fromConstruct.parameter.construct"></a>

- *Type:* constructs.IConstruct

---

##### `fromOrganizationalUnitArn` <a name="fromOrganizationalUnitArn" id="cdk-extensions.ram.SharedPrincipal.fromOrganizationalUnitArn"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.SharedPrincipal.fromOrganizationalUnitArn(arn: string)
```

###### `arn`<sup>Required</sup> <a name="arn" id="cdk-extensions.ram.SharedPrincipal.fromOrganizationalUnitArn.parameter.arn"></a>

- *Type:* string

---

##### `fromOrganizationArn` <a name="fromOrganizationArn" id="cdk-extensions.ram.SharedPrincipal.fromOrganizationArn"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.SharedPrincipal.fromOrganizationArn(arn: string)
```

###### `arn`<sup>Required</sup> <a name="arn" id="cdk-extensions.ram.SharedPrincipal.fromOrganizationArn.parameter.arn"></a>

- *Type:* string

---

##### `fromRole` <a name="fromRole" id="cdk-extensions.ram.SharedPrincipal.fromRole"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.SharedPrincipal.fromRole(role: IRole)
```

###### `role`<sup>Required</sup> <a name="role" id="cdk-extensions.ram.SharedPrincipal.fromRole.parameter.role"></a>

- *Type:* aws-cdk-lib.aws_iam.IRole

---

##### `fromStage` <a name="fromStage" id="cdk-extensions.ram.SharedPrincipal.fromStage"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.SharedPrincipal.fromStage(stage: Stage)
```

###### `stage`<sup>Required</sup> <a name="stage" id="cdk-extensions.ram.SharedPrincipal.fromStage.parameter.stage"></a>

- *Type:* aws-cdk-lib.Stage

---

##### `fromUser` <a name="fromUser" id="cdk-extensions.ram.SharedPrincipal.fromUser"></a>

```typescript
import { ram } from 'cdk-extensions'

ram.SharedPrincipal.fromUser(user: IUser)
```

###### `user`<sup>Required</sup> <a name="user" id="cdk-extensions.ram.SharedPrincipal.fromUser.parameter.user"></a>

- *Type:* aws-cdk-lib.aws_iam.IUser

---



### SharedResource <a name="SharedResource" id="cdk-extensions.ram_resources.SharedResource"></a>

- *Implements:* cdk-extensions.ram.ISharable

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram_resources.SharedResource.share">share</a></code> | Configures resource sharing for the associated resource. |

---

##### `share` <a name="share" id="cdk-extensions.ram_resources.SharedResource.share"></a>

```typescript
public share(_scope: IConstruct): string
```

Configures resource sharing for the associated resource.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.ram_resources.SharedResource.share.parameter._scope"></a>

- *Type:* constructs.IConstruct

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram_resources.SharedResource.fromArn">fromArn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram_resources.SharedResource.fromIpamPool">fromIpamPool</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram_resources.SharedResource.fromProject">fromProject</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram_resources.SharedResource.fromSubnet">fromSubnet</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ram_resources.SharedResource.fromTransitGateway">fromTransitGateway</a></code> | *No description.* |

---

##### `fromArn` <a name="fromArn" id="cdk-extensions.ram_resources.SharedResource.fromArn"></a>

```typescript
import { ram_resources } from 'cdk-extensions'

ram_resources.SharedResource.fromArn(arn: string)
```

###### `arn`<sup>Required</sup> <a name="arn" id="cdk-extensions.ram_resources.SharedResource.fromArn.parameter.arn"></a>

- *Type:* string

---

##### `fromIpamPool` <a name="fromIpamPool" id="cdk-extensions.ram_resources.SharedResource.fromIpamPool"></a>

```typescript
import { ram_resources } from 'cdk-extensions'

ram_resources.SharedResource.fromIpamPool(pool: IIpamPool)
```

###### `pool`<sup>Required</sup> <a name="pool" id="cdk-extensions.ram_resources.SharedResource.fromIpamPool.parameter.pool"></a>

- *Type:* cdk-extensions.ec2.IIpamPool

---

##### `fromProject` <a name="fromProject" id="cdk-extensions.ram_resources.SharedResource.fromProject"></a>

```typescript
import { ram_resources } from 'cdk-extensions'

ram_resources.SharedResource.fromProject(project: IProject)
```

###### `project`<sup>Required</sup> <a name="project" id="cdk-extensions.ram_resources.SharedResource.fromProject.parameter.project"></a>

- *Type:* aws-cdk-lib.aws_codebuild.IProject

---

##### `fromSubnet` <a name="fromSubnet" id="cdk-extensions.ram_resources.SharedResource.fromSubnet"></a>

```typescript
import { ram_resources } from 'cdk-extensions'

ram_resources.SharedResource.fromSubnet(subnet: ISubnet)
```

###### `subnet`<sup>Required</sup> <a name="subnet" id="cdk-extensions.ram_resources.SharedResource.fromSubnet.parameter.subnet"></a>

- *Type:* aws-cdk-lib.aws_ec2.ISubnet

---

##### `fromTransitGateway` <a name="fromTransitGateway" id="cdk-extensions.ram_resources.SharedResource.fromTransitGateway"></a>

```typescript
import { ram_resources } from 'cdk-extensions'

ram_resources.SharedResource.fromTransitGateway(transitGateway: ITransitGateway)
```

###### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ram_resources.SharedResource.fromTransitGateway.parameter.transitGateway"></a>

- *Type:* cdk-extensions.ec2.ITransitGateway

---



### SsmParameterReference <a name="SsmParameterReference" id="cdk-extensions.k8s_aws.SsmParameterReference"></a>

- *Implements:* cdk-extensions.k8s_aws.ISecretReference

Defines a reference for importing and synchronizing an SSM parameter to a Kubernetes secret.

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.SsmParameterReference.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.SsmParameterReference(parameter: IParameter, options: SsmParameterReferenceOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterReference.Initializer.parameter.parameter">parameter</a></code> | <code>aws-cdk-lib.aws_ssm.IParameter</code> | The SSM parameter being referenced to import into Kubernetes. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterReference.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.SsmParameterReferenceOptions</code> | *No description.* |

---

##### `parameter`<sup>Required</sup> <a name="parameter" id="cdk-extensions.k8s_aws.SsmParameterReference.Initializer.parameter.parameter"></a>

- *Type:* aws-cdk-lib.aws_ssm.IParameter

The SSM parameter being referenced to import into Kubernetes.

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.k8s_aws.SsmParameterReference.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.SsmParameterReferenceOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterReference.addFieldMapping">addFieldMapping</a></code> | Adds a field mapping that specifies how a field from an SSM JSON parameter should be mapped into the imported Kubernetes secret. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterReference.bind">bind</a></code> | Binds the reference to an object that is in charge of generating the manifest for the external secret. |

---

##### `addFieldMapping` <a name="addFieldMapping" id="cdk-extensions.k8s_aws.SsmParameterReference.addFieldMapping"></a>

```typescript
public addFieldMapping(field: SecretFieldReference): SsmParameterReference
```

Adds a field mapping that specifies how a field from an SSM JSON parameter should be mapped into the imported Kubernetes secret.

###### `field`<sup>Required</sup> <a name="field" id="cdk-extensions.k8s_aws.SsmParameterReference.addFieldMapping.parameter.field"></a>

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference

The configuration for how to map the field from the SSM parameter to the Kubernetes secret.

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.SsmParameterReference.bind"></a>

```typescript
public bind(_scope: IConstruct): SecretReferenceConfiguration
```

Binds the reference to an object that is in charge of generating the manifest for the external secret.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.k8s_aws.SsmParameterReference.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct that will consume the generated configuration.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterReference.property.fields">fields</a></code> | <code>cdk-extensions.k8s_aws.SecretFieldReference[]</code> | An array of field mappings which will be applied to this secret reference when mapping keys from SSM parameter JSON objects to keys in the imported secret. |
| <code><a href="#cdk-extensions.k8s_aws.SsmParameterReference.property.parameter">parameter</a></code> | <code>aws-cdk-lib.aws_ssm.IParameter</code> | The SSM parameter being referenced to import into Kubernetes. |

---

##### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.k8s_aws.SsmParameterReference.property.fields"></a>

```typescript
public readonly fields: SecretFieldReference[];
```

- *Type:* cdk-extensions.k8s_aws.SecretFieldReference[]

An array of field mappings which will be applied to this secret reference when mapping keys from SSM parameter JSON objects to keys in the imported secret.

---

##### `parameter`<sup>Required</sup> <a name="parameter" id="cdk-extensions.k8s_aws.SsmParameterReference.property.parameter"></a>

```typescript
public readonly parameter: IParameter;
```

- *Type:* aws-cdk-lib.aws_ssm.IParameter

The SSM parameter being referenced to import into Kubernetes.

---


### State <a name="State" id="cdk-extensions.core.State"></a>

Provides a means of storing and retrieving arbitrary data that can be associated with a construct.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.core.State.get">get</a></code> | Gets the value of a key from state. |
| <code><a href="#cdk-extensions.core.State.set">set</a></code> | Sets the value of a key in state. |

---

##### `get` <a name="get" id="cdk-extensions.core.State.get"></a>

```typescript
public get(key: string, defaultValue?: any): any
```

Gets the value of a key from state.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.core.State.get.parameter.key"></a>

- *Type:* string

The key to get from state.

---

###### `defaultValue`<sup>Optional</sup> <a name="defaultValue" id="cdk-extensions.core.State.get.parameter.defaultValue"></a>

- *Type:* any

The value to return if the requested key does not exist in state.

---

##### `set` <a name="set" id="cdk-extensions.core.State.set"></a>

```typescript
public set(key: string, value: any): any
```

Sets the value of a key in state.

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.core.State.set.parameter.key"></a>

- *Type:* string

The key to set in state.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.core.State.set.parameter.value"></a>

- *Type:* any

The value to set for the key in state.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.core.State.of">of</a></code> | Gets an object that allows for interacting with the stored state of a construct. |

---

##### `of` <a name="of" id="cdk-extensions.core.State.of"></a>

```typescript
import { core } from 'cdk-extensions'

core.State.of(scope: IConstruct)
```

Gets an object that allows for interacting with the stored state of a construct.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.core.State.of.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct for which state information is desired.

---



### StructColumn <a name="StructColumn" id="cdk-extensions.glue.StructColumn"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.glue.StructColumn.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.StructColumn(props: StructColumnProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.StructColumn.Initializer.parameter.props">props</a></code> | <code>cdk-extensions.glue.StructColumnProps</code> | *No description.* |

---

##### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.glue.StructColumn.Initializer.parameter.props"></a>

- *Type:* cdk-extensions.glue.StructColumnProps

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.StructColumn.bind">bind</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.StructColumn.addColumn">addColumn</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.StructColumn.bind"></a>

```typescript
public bind(scope: IConstruct): ColumnProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.StructColumn.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

##### `addColumn` <a name="addColumn" id="cdk-extensions.glue.StructColumn.addColumn"></a>

```typescript
public addColumn(column: Column): void
```

###### `column`<sup>Required</sup> <a name="column" id="cdk-extensions.glue.StructColumn.addColumn.parameter.column"></a>

- *Type:* cdk-extensions.glue.Column

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.StructColumn.property.typeString">typeString</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.glue.StructColumn.property.comment">comment</a></code> | <code>string</code> | A free-form text comment. |
| <code><a href="#cdk-extensions.glue.StructColumn.property.name">name</a></code> | <code>string</code> | The name of the Column. |

---

##### `typeString`<sup>Required</sup> <a name="typeString" id="cdk-extensions.glue.StructColumn.property.typeString"></a>

```typescript
public readonly typeString: string;
```

- *Type:* string

---

##### `comment`<sup>Optional</sup> <a name="comment" id="cdk-extensions.glue.StructColumn.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

A free-form text comment.

> [[AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-comment)]([AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-comment))

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk-extensions.glue.StructColumn.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the Column.

> [[AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-name)]([AWS::Glue::Table Column](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-table-column.html#cfn-glue-table-column-name))

---


### SubRecordType <a name="SubRecordType" id="cdk-extensions.kinesis_firehose.SubRecordType"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.SubRecordType.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk-extensions.kinesis_firehose.SubRecordType.of"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.SubRecordType.of(name: string)
```

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.kinesis_firehose.SubRecordType.of.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.SubRecordType.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.kinesis_firehose.SubRecordType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.SubRecordType.property.DELIMITED">DELIMITED</a></code> | <code>cdk-extensions.kinesis_firehose.SubRecordType</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.SubRecordType.property.JSON">JSON</a></code> | <code>cdk-extensions.kinesis_firehose.SubRecordType</code> | *No description.* |

---

##### `DELIMITED`<sup>Required</sup> <a name="DELIMITED" id="cdk-extensions.kinesis_firehose.SubRecordType.property.DELIMITED"></a>

```typescript
public readonly DELIMITED: SubRecordType;
```

- *Type:* cdk-extensions.kinesis_firehose.SubRecordType

---

##### `JSON`<sup>Required</sup> <a name="JSON" id="cdk-extensions.kinesis_firehose.SubRecordType.property.JSON"></a>

```typescript
public readonly JSON: SubRecordType;
```

- *Type:* cdk-extensions.kinesis_firehose.SubRecordType

---

### TableVersion <a name="TableVersion" id="cdk-extensions.kinesis_firehose.TableVersion"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.TableVersion.fixed">fixed</a></code> | *No description.* |

---

##### `fixed` <a name="fixed" id="cdk-extensions.kinesis_firehose.TableVersion.fixed"></a>

```typescript
import { kinesis_firehose } from 'cdk-extensions'

kinesis_firehose.TableVersion.fixed(version: number)
```

###### `version`<sup>Required</sup> <a name="version" id="cdk-extensions.kinesis_firehose.TableVersion.fixed.parameter.version"></a>

- *Type:* number

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.TableVersion.property.version">version</a></code> | <code>string</code> | *No description.* |

---

##### `version`<sup>Required</sup> <a name="version" id="cdk-extensions.kinesis_firehose.TableVersion.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.TableVersion.property.LATEST">LATEST</a></code> | <code>cdk-extensions.kinesis_firehose.TableVersion</code> | *No description.* |

---

##### `LATEST`<sup>Required</sup> <a name="LATEST" id="cdk-extensions.kinesis_firehose.TableVersion.property.LATEST"></a>

```typescript
public readonly LATEST: TableVersion;
```

- *Type:* cdk-extensions.kinesis_firehose.TableVersion

---

### TieredSubnets <a name="TieredSubnets" id="cdk-extensions.ec2.TieredSubnets"></a>

- *Implements:* aws-cdk-lib.aws_ec2.IIpAddresses

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TieredSubnets.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TieredSubnets(options: TieredSubnetsOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TieredSubnets.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.ec2.TieredSubnetsOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.TieredSubnets.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.ec2.TieredSubnetsOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TieredSubnets.allocateSubnetsCidr">allocateSubnetsCidr</a></code> | Called by the VPC to retrieve Subnet options from the Ipam
 
 Don't call this directly, the VPC will call it automatically. |
| <code><a href="#cdk-extensions.ec2.TieredSubnets.allocateVpcCidr">allocateVpcCidr</a></code> | Called by the VPC to retrieve VPC options from the Ipam
 
 Don't call this directly, the VPC will call it automatically. |

---

##### `allocateSubnetsCidr` <a name="allocateSubnetsCidr" id="cdk-extensions.ec2.TieredSubnets.allocateSubnetsCidr"></a>

```typescript
public allocateSubnetsCidr(input: AllocateCidrRequest): SubnetIpamOptions
```

Called by the VPC to retrieve Subnet options from the Ipam
 
 Don't call this directly, the VPC will call it automatically.

###### `input`<sup>Required</sup> <a name="input" id="cdk-extensions.ec2.TieredSubnets.allocateSubnetsCidr.parameter.input"></a>

- *Type:* aws-cdk-lib.aws_ec2.AllocateCidrRequest

---

##### `allocateVpcCidr` <a name="allocateVpcCidr" id="cdk-extensions.ec2.TieredSubnets.allocateVpcCidr"></a>

```typescript
public allocateVpcCidr(): VpcIpamOptions
```

Called by the VPC to retrieve VPC options from the Ipam
 
 Don't call this directly, the VPC will call it automatically.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TieredSubnets.property.provider">provider</a></code> | <code>cdk-extensions.ec2.ICidrProvider</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TieredSubnets.property.tierMask">tierMask</a></code> | <code>number</code> | *No description.* |

---

##### `provider`<sup>Required</sup> <a name="provider" id="cdk-extensions.ec2.TieredSubnets.property.provider"></a>

```typescript
public readonly provider: ICidrProvider;
```

- *Type:* cdk-extensions.ec2.ICidrProvider

---

##### `tierMask`<sup>Optional</sup> <a name="tierMask" id="cdk-extensions.ec2.TieredSubnets.property.tierMask"></a>

```typescript
public readonly tierMask: number;
```

- *Type:* number

---


### TimeIntervalEntry <a name="TimeIntervalEntry" id="cdk-extensions.aps.TimeIntervalEntry"></a>

An object specifying a collection of ranges that together make up an interval of time.

Referenced by alert manager to define periods for which certain settings
should apply.

> [[Time Interval Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#time_interval-0)]([Time Interval Official Documentation](https://prometheus.io/docs/alerting/latest/configuration/#time_interval-0))

#### Initializers <a name="Initializers" id="cdk-extensions.aps.TimeIntervalEntry.Initializer"></a>

```typescript
import { aps } from 'cdk-extensions'

new aps.TimeIntervalEntry(options: TimeIntervalEntryProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.aps.TimeIntervalEntryProps</code> | Configuration options that define the TimeIntervalEntry. |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.aps.TimeIntervalEntry.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.aps.TimeIntervalEntryProps

Configuration options that define the TimeIntervalEntry.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.addDaysOfTheMonth">addDaysOfTheMonth</a></code> | Adds a range specifying the numerical days in the month. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.addMonth">addMonth</a></code> | A range of calendar months identified by number, where January = 1. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.addTimes">addTimes</a></code> | Ranges inclusive of the starting time and exclusive of the end time to make it easy to represent times that start/end on hour boundaries. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.addWeekday">addWeekday</a></code> | Adds a day of the week, where the week begins on Sunday and ends on Saturday. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.addYears">addYears</a></code> | Adds a numerical range of years. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.bind">bind</a></code> | Associates the time interval with a construct that is handling the configuration of alert manager. |

---

##### `addDaysOfTheMonth` <a name="addDaysOfTheMonth" id="cdk-extensions.aps.TimeIntervalEntry.addDaysOfTheMonth"></a>

```typescript
public addDaysOfTheMonth(start: number, end: number): TimeIntervalEntry
```

Adds a range specifying the numerical days in the month.

Days begin at 1. Negative values are also accepted which begin at the end
of the month, e.g. -1 during January would represent January 31. For
example: `start: 1` and `end: 5` or `start:-3` and `end: -1` would both be
valid ranges.

Extending past the start or end of the month will cause it to be clamped.
E.g. specifying `start: 1` and `end: 31` during February will clamp the
actual end date to 28 or 29 depending on leap years.

Inclusive on both ends.

###### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.TimeIntervalEntry.addDaysOfTheMonth.parameter.start"></a>

- *Type:* number

The first day of the month for which the range should apply.

---

###### `end`<sup>Required</sup> <a name="end" id="cdk-extensions.aps.TimeIntervalEntry.addDaysOfTheMonth.parameter.end"></a>

- *Type:* number

The last day of the month for which the range should apply (inclusive).

---

##### `addMonth` <a name="addMonth" id="cdk-extensions.aps.TimeIntervalEntry.addMonth"></a>

```typescript
public addMonth(start: number, end?: number): TimeIntervalEntry
```

A range of calendar months identified by number, where January = 1.

Ranges are also accepted by specifying `end` inclusive on both ends.

###### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.TimeIntervalEntry.addMonth.parameter.start"></a>

- *Type:* number

The month where the range should start.

---

###### `end`<sup>Optional</sup> <a name="end" id="cdk-extensions.aps.TimeIntervalEntry.addMonth.parameter.end"></a>

- *Type:* number

The month at the end of the range if the range should cover multiple months (inclusive).

---

##### `addTimes` <a name="addTimes" id="cdk-extensions.aps.TimeIntervalEntry.addTimes"></a>

```typescript
public addTimes(start: string, end: string): TimeIntervalEntry
```

Ranges inclusive of the starting time and exclusive of the end time to make it easy to represent times that start/end on hour boundaries.

For example, `start: '17:00'` and `end: '24:00'` will begin at 17:00 and
finish immediately before 24:00.

###### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.TimeIntervalEntry.addTimes.parameter.start"></a>

- *Type:* string

The start time, specified in the format 'HH:MM' using 24 hour time.

---

###### `end`<sup>Required</sup> <a name="end" id="cdk-extensions.aps.TimeIntervalEntry.addTimes.parameter.end"></a>

- *Type:* string

The end time, specified in the format 'HH:MM' using 24 hour time.

---

##### `addWeekday` <a name="addWeekday" id="cdk-extensions.aps.TimeIntervalEntry.addWeekday"></a>

```typescript
public addWeekday(start: Weekday, end?: Weekday): TimeIntervalEntry
```

Adds a day of the week, where the week begins on Sunday and ends on Saturday.

For convenience, ranges are also accepted by specifying `end` and are
inclusive on both ends.

###### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.TimeIntervalEntry.addWeekday.parameter.start"></a>

- *Type:* cdk-extensions.aps.Weekday

The day of the week where the range should start.

---

###### `end`<sup>Optional</sup> <a name="end" id="cdk-extensions.aps.TimeIntervalEntry.addWeekday.parameter.end"></a>

- *Type:* cdk-extensions.aps.Weekday

The day of the week where the range should end.

If not
specified, the range will end at the end of the day specified by `start`.

---

##### `addYears` <a name="addYears" id="cdk-extensions.aps.TimeIntervalEntry.addYears"></a>

```typescript
public addYears(start: number, end?: number): TimeIntervalEntry
```

Adds a numerical range of years.

Ranges to cover multiple years are accepted. For example, `start: 2020` and
`end: 2022`.

Inclusive on both ends.

###### `start`<sup>Required</sup> <a name="start" id="cdk-extensions.aps.TimeIntervalEntry.addYears.parameter.start"></a>

- *Type:* number

The year where the range should start.

---

###### `end`<sup>Optional</sup> <a name="end" id="cdk-extensions.aps.TimeIntervalEntry.addYears.parameter.end"></a>

- *Type:* number

The year where the range should end.

If not specified, the
range will end at the end of the year specified by `start`.

---

##### `bind` <a name="bind" id="cdk-extensions.aps.TimeIntervalEntry.bind"></a>

```typescript
public bind(_scope: IConstruct): {[ key: string ]: any}
```

Associates the time interval with a construct that is handling the configuration of alert manager.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.aps.TimeIntervalEntry.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the rendered configuration.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.property.daysOfTheMonth">daysOfTheMonth</a></code> | <code>cdk-extensions.aps.DayOfMonthRange[]</code> | Collection of day of the month ranges for which this time interval will apply. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.property.months">months</a></code> | <code>cdk-extensions.aps.MonthRange[]</code> | Collection of month ranges for which this time interval will apply. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.property.times">times</a></code> | <code>cdk-extensions.aps.TimeRange[]</code> | Collection of time ranges for which this time interval will apply. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.property.weekdays">weekdays</a></code> | <code>cdk-extensions.aps.WeekdayRange[]</code> | Collection of weekday ranges for which this time interval will apply. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.property.years">years</a></code> | <code>cdk-extensions.aps.YearRange[]</code> | Collection of year ranges for which this time interval will apply. |
| <code><a href="#cdk-extensions.aps.TimeIntervalEntry.property.timeZone">timeZone</a></code> | <code>string</code> | A string that matches a location in the IANA time zone database. |

---

##### `daysOfTheMonth`<sup>Required</sup> <a name="daysOfTheMonth" id="cdk-extensions.aps.TimeIntervalEntry.property.daysOfTheMonth"></a>

```typescript
public readonly daysOfTheMonth: DayOfMonthRange[];
```

- *Type:* cdk-extensions.aps.DayOfMonthRange[]

Collection of day of the month ranges for which this time interval will apply.

---

##### `months`<sup>Required</sup> <a name="months" id="cdk-extensions.aps.TimeIntervalEntry.property.months"></a>

```typescript
public readonly months: MonthRange[];
```

- *Type:* cdk-extensions.aps.MonthRange[]

Collection of month ranges for which this time interval will apply.

---

##### `times`<sup>Required</sup> <a name="times" id="cdk-extensions.aps.TimeIntervalEntry.property.times"></a>

```typescript
public readonly times: TimeRange[];
```

- *Type:* cdk-extensions.aps.TimeRange[]

Collection of time ranges for which this time interval will apply.

---

##### `weekdays`<sup>Required</sup> <a name="weekdays" id="cdk-extensions.aps.TimeIntervalEntry.property.weekdays"></a>

```typescript
public readonly weekdays: WeekdayRange[];
```

- *Type:* cdk-extensions.aps.WeekdayRange[]

Collection of weekday ranges for which this time interval will apply.

---

##### `years`<sup>Required</sup> <a name="years" id="cdk-extensions.aps.TimeIntervalEntry.property.years"></a>

```typescript
public readonly years: YearRange[];
```

- *Type:* cdk-extensions.aps.YearRange[]

Collection of year ranges for which this time interval will apply.

---

##### `timeZone`<sup>Optional</sup> <a name="timeZone" id="cdk-extensions.aps.TimeIntervalEntry.property.timeZone"></a>

```typescript
public readonly timeZone: string;
```

- *Type:* string

A string that matches a location in the IANA time zone database.

For example, 'Australia/Sydney'. The location provides the time zone for
the time interval.

You may also use `Local` as a location to use the local time of the
machine where Alertmanager is running, or `UTC` for UTC time. If no
timezone is provided, the time interval is taken to be in UTC time.

---


### TransitGatewayLocalVpnEndpoint <a name="TransitGatewayLocalVpnEndpoint" id="cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint"></a>

- *Implements:* cdk-extensions.ec2.ILocalVpnEndpoint

Specifies a VPN connection endpoint which routes to a transit gateway on the AWS side.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGatewayLocalVpnEndpoint(transitGateway: ITransitGateway)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint.Initializer.parameter.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The transit gateway that serves as the local end of a VPN connection. |

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint.Initializer.parameter.transitGateway"></a>

- *Type:* cdk-extensions.ec2.ITransitGateway

The transit gateway that serves as the local end of a VPN connection.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint.bind">bind</a></code> | Produces a configuration that can be used when configuring the local end of a VPN connection. |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint.bind"></a>

```typescript
public bind(_scope: IConstruct): LocalVpnEndpointConfiguration
```

Produces a configuration that can be used when configuring the local end of a VPN connection.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the VPN connection that will be referencing the local endpoint.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | The transit gateway that serves as the local end of a VPN connection. |

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

The transit gateway that serves as the local end of a VPN connection.

---


### TransitGatewayNatProvider <a name="TransitGatewayNatProvider" id="cdk-extensions.ec2.TransitGatewayNatProvider"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.TransitGatewayNatProvider.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.TransitGatewayNatProvider(options: TransitGatewayNatProviderOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProvider.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.ec2.TransitGatewayNatProviderOptions</code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.TransitGatewayNatProvider.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayNatProviderOptions

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProvider.configureNat">configureNat</a></code> | Called by the VPC to configure NAT
 
 Don't call this directly, the VPC will call it automatically. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProvider.configureSubnet">configureSubnet</a></code> | Configures subnet with the gateway
 
 Don't call this directly, the VPC will call it automatically. |

---

##### `configureNat` <a name="configureNat" id="cdk-extensions.ec2.TransitGatewayNatProvider.configureNat"></a>

```typescript
public configureNat(options: ConfigureNatOptions): void
```

Called by the VPC to configure NAT
 
 Don't call this directly, the VPC will call it automatically.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.TransitGatewayNatProvider.configureNat.parameter.options"></a>

- *Type:* aws-cdk-lib.aws_ec2.ConfigureNatOptions

---

##### `configureSubnet` <a name="configureSubnet" id="cdk-extensions.ec2.TransitGatewayNatProvider.configureSubnet"></a>

```typescript
public configureSubnet(subnet: PrivateSubnet): void
```

Configures subnet with the gateway
 
 Don't call this directly, the VPC will call it automatically.

###### `subnet`<sup>Required</sup> <a name="subnet" id="cdk-extensions.ec2.TransitGatewayNatProvider.configureSubnet.parameter.subnet"></a>

- *Type:* aws-cdk-lib.aws_ec2.PrivateSubnet

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProvider.gateway">gateway</a></code> | Use NAT Gateways to provide NAT services for your VPC. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProvider.instance">instance</a></code> | Use NAT instances to provide NAT services for your VPC. |

---

##### `gateway` <a name="gateway" id="cdk-extensions.ec2.TransitGatewayNatProvider.gateway"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayNatProvider.gateway(props?: NatGatewayProps)
```

Use NAT Gateways to provide NAT services for your VPC.

NAT gateways are managed by AWS.

> [https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html](https://docs.aws.amazon.com/vpc/latest/userguide/vpc-nat-gateway.html)

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.ec2.TransitGatewayNatProvider.gateway.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_ec2.NatGatewayProps

---

##### `instance` <a name="instance" id="cdk-extensions.ec2.TransitGatewayNatProvider.instance"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.TransitGatewayNatProvider.instance(props: NatInstanceProps)
```

Use NAT instances to provide NAT services for your VPC.

NAT instances are managed by you, but in return allow more configuration.

Be aware that instances created using this provider will not be
automatically replaced if they are stopped for any reason. You should implement
your own NatProvider based on AutoScaling groups if you need that.

> [https://docs.aws.amazon.com/vpc/latest/userguide/VPC_NAT_Instance.html](https://docs.aws.amazon.com/vpc/latest/userguide/VPC_NAT_Instance.html)

###### `props`<sup>Required</sup> <a name="props" id="cdk-extensions.ec2.TransitGatewayNatProvider.instance.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_ec2.NatInstanceProps

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProvider.property.configuredGateways">configuredGateways</a></code> | <code>aws-cdk-lib.aws_ec2.GatewayConfig[]</code> | Return list of gateways spawned by the provider. |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProvider.property.transitGateway">transitGateway</a></code> | <code>cdk-extensions.ec2.ITransitGateway</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.TransitGatewayNatProvider.property.transitGatewayAttachment">transitGatewayAttachment</a></code> | <code>cdk-extensions.ec2.TransitGatewayAttachment</code> | *No description.* |

---

##### `configuredGateways`<sup>Required</sup> <a name="configuredGateways" id="cdk-extensions.ec2.TransitGatewayNatProvider.property.configuredGateways"></a>

```typescript
public readonly configuredGateways: GatewayConfig[];
```

- *Type:* aws-cdk-lib.aws_ec2.GatewayConfig[]

Return list of gateways spawned by the provider.

---

##### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.TransitGatewayNatProvider.property.transitGateway"></a>

```typescript
public readonly transitGateway: ITransitGateway;
```

- *Type:* cdk-extensions.ec2.ITransitGateway

---

##### `transitGatewayAttachment`<sup>Optional</sup> <a name="transitGatewayAttachment" id="cdk-extensions.ec2.TransitGatewayNatProvider.property.transitGatewayAttachment"></a>

```typescript
public readonly transitGatewayAttachment: TransitGatewayAttachment;
```

- *Type:* cdk-extensions.ec2.TransitGatewayAttachment

---


### TxtRegistry <a name="TxtRegistry" id="cdk-extensions.k8s_aws.TxtRegistry"></a>

- *Implements:* cdk-extensions.k8s_aws.IExternalDnsRegistry

An ExternalDNS registry that tracks DNS record ownership information using DNS TXT records.

> [[About TXT records](https://support.google.com/a/answer/2716800?hl=en)]([About TXT records](https://support.google.com/a/answer/2716800?hl=en))

#### Initializers <a name="Initializers" id="cdk-extensions.k8s_aws.TxtRegistry.Initializer"></a>

```typescript
import { k8s_aws } from 'cdk-extensions'

new k8s_aws.TxtRegistry(options?: TxtRegistryOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistry.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.k8s_aws.TxtRegistryOptions</code> | Options configuring how ExternalDNS will use TXT records to validate ownership. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.k8s_aws.TxtRegistry.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.k8s_aws.TxtRegistryOptions

Options configuring how ExternalDNS will use TXT records to validate ownership.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistry.bind">bind</a></code> | Generates an object with all the information needed to use the registry in a given CDK scope. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.TxtRegistry.bind"></a>

```typescript
public bind(scope: IConstruct): ExternalDnsRegistryConfiguration
```

Generates an object with all the information needed to use the registry in a given CDK scope.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.TxtRegistry.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The CDK resource that is configuring ExternalDNS.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistry.property.registryType">registryType</a></code> | <code>string</code> | The type name of ExternalDNS registry. |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistry.property.ownerId">ownerId</a></code> | <code>string</code> | A unique identifier that is used to establish ownership of managed DNS records. |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistry.property.prefix">prefix</a></code> | <code>string</code> | A prefix to be added top TXT ownership records. |

---

##### `registryType`<sup>Required</sup> <a name="registryType" id="cdk-extensions.k8s_aws.TxtRegistry.property.registryType"></a>

```typescript
public readonly registryType: string;
```

- *Type:* string

The type name of ExternalDNS registry.

---

##### `ownerId`<sup>Optional</sup> <a name="ownerId" id="cdk-extensions.k8s_aws.TxtRegistry.property.ownerId"></a>

```typescript
public readonly ownerId: string;
```

- *Type:* string

A unique identifier that is used to establish ownership of managed DNS records.

Prevents conflicts in the event of multiple clusters running external-dns.

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk-extensions.k8s_aws.TxtRegistry.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

A prefix to be added top TXT ownership records.

By default, the ownership record is a TXT record with the same name as the
managed record that was created. This causes issues as some record types
(CNAME's) do not allow duplicate records of a different type.

This prefix is used to prevent such name collissions while still allowing
DNS ownership records to be created.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistry.property.DEFAULT_PREFIX">DEFAULT_PREFIX</a></code> | <code>string</code> | The default prefix to append to TXT ownership records creates for the registry. |
| <code><a href="#cdk-extensions.k8s_aws.TxtRegistry.property.NO_PREFIX">NO_PREFIX</a></code> | <code>string</code> | A special value that specifies ExternalDNS should not use any prefix when creating TXT ownership records. |

---

##### `DEFAULT_PREFIX`<sup>Required</sup> <a name="DEFAULT_PREFIX" id="cdk-extensions.k8s_aws.TxtRegistry.property.DEFAULT_PREFIX"></a>

```typescript
public readonly DEFAULT_PREFIX: string;
```

- *Type:* string

The default prefix to append to TXT ownership records creates for the registry.

---

##### `NO_PREFIX`<sup>Required</sup> <a name="NO_PREFIX" id="cdk-extensions.k8s_aws.TxtRegistry.property.NO_PREFIX"></a>

```typescript
public readonly NO_PREFIX: string;
```

- *Type:* string

A special value that specifies ExternalDNS should not use any prefix when creating TXT ownership records.

This is not recommended as it is likely to cause issues with record
creation and management with some record types that do not allow other
records with the same name and different types to exist (CNAME's).

However, if this behavior is desired this value can be passed as the
prefix to override the default behavior with will set a prefix if none
is provided as input.

---

### User <a name="User" id="cdk-extensions.sso.User"></a>

#### Initializers <a name="Initializers" id="cdk-extensions.sso.User.Initializer"></a>

```typescript
import { sso } from 'cdk-extensions'

new sso.User()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.sso.User.fromUserId">fromUserId</a></code> | *No description.* |

---

##### `fromUserId` <a name="fromUserId" id="cdk-extensions.sso.User.fromUserId"></a>

```typescript
import { sso } from 'cdk-extensions'

sso.User.fromUserId(scope: IConstruct, id: string, userId: string)
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.sso.User.fromUserId.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.sso.User.fromUserId.parameter.id"></a>

- *Type:* string

---

###### `userId`<sup>Required</sup> <a name="userId" id="cdk-extensions.sso.User.fromUserId.parameter.userId"></a>

- *Type:* string

---



### VpnConnectionLocalEndpoint <a name="VpnConnectionLocalEndpoint" id="cdk-extensions.ec2.VpnConnectionLocalEndpoint"></a>

Provides options for specifying the local side of a VPN connection.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.VpnConnectionLocalEndpoint.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.VpnConnectionLocalEndpoint()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnectionLocalEndpoint.fromTransitGateway">fromTransitGateway</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.VpnConnectionLocalEndpoint.fromVpnGateway">fromVpnGateway</a></code> | *No description.* |

---

##### `fromTransitGateway` <a name="fromTransitGateway" id="cdk-extensions.ec2.VpnConnectionLocalEndpoint.fromTransitGateway"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.VpnConnectionLocalEndpoint.fromTransitGateway(transitGateway: ITransitGateway)
```

###### `transitGateway`<sup>Required</sup> <a name="transitGateway" id="cdk-extensions.ec2.VpnConnectionLocalEndpoint.fromTransitGateway.parameter.transitGateway"></a>

- *Type:* cdk-extensions.ec2.ITransitGateway

---

##### `fromVpnGateway` <a name="fromVpnGateway" id="cdk-extensions.ec2.VpnConnectionLocalEndpoint.fromVpnGateway"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.VpnConnectionLocalEndpoint.fromVpnGateway(vpnGateway: IVpnGateway)
```

###### `vpnGateway`<sup>Required</sup> <a name="vpnGateway" id="cdk-extensions.ec2.VpnConnectionLocalEndpoint.fromVpnGateway.parameter.vpnGateway"></a>

- *Type:* aws-cdk-lib.aws_ec2.IVpnGateway

---



### VpnConnectionRemoteEndpoint <a name="VpnConnectionRemoteEndpoint" id="cdk-extensions.ec2.VpnConnectionRemoteEndpoint"></a>

Provides options for specifying the remote side of a VPN connection.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.VpnConnectionRemoteEndpoint.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.VpnConnectionRemoteEndpoint()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnectionRemoteEndpoint.fromConfiguration">fromConfiguration</a></code> | Creates a remote connection using the configuration details provided. |
| <code><a href="#cdk-extensions.ec2.VpnConnectionRemoteEndpoint.fromCustomerGateway">fromCustomerGateway</a></code> | Creates a remote connection using a customer gateway. |

---

##### `fromConfiguration` <a name="fromConfiguration" id="cdk-extensions.ec2.VpnConnectionRemoteEndpoint.fromConfiguration"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.VpnConnectionRemoteEndpoint.fromConfiguration(configuration: CustomerGatewayProps)
```

Creates a remote connection using the configuration details provided.

###### `configuration`<sup>Required</sup> <a name="configuration" id="cdk-extensions.ec2.VpnConnectionRemoteEndpoint.fromConfiguration.parameter.configuration"></a>

- *Type:* cdk-extensions.ec2.CustomerGatewayProps

The configuration for the remote endpoint device.

---

##### `fromCustomerGateway` <a name="fromCustomerGateway" id="cdk-extensions.ec2.VpnConnectionRemoteEndpoint.fromCustomerGateway"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.VpnConnectionRemoteEndpoint.fromCustomerGateway(customerGateway: ICustomerGateway)
```

Creates a remote connection using a customer gateway.

###### `customerGateway`<sup>Required</sup> <a name="customerGateway" id="cdk-extensions.ec2.VpnConnectionRemoteEndpoint.fromCustomerGateway.parameter.customerGateway"></a>

- *Type:* cdk-extensions.ec2.ICustomerGateway

The customer gateway that is configured for the remote endpoint device.

---



### VpnConnectionType <a name="VpnConnectionType" id="cdk-extensions.ec2.VpnConnectionType"></a>

Represents a VPN protocol that can be used to establish a connection.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnectionType.of">of</a></code> | An escape hatch method that allows defining custom VPN protocols. |

---

##### `of` <a name="of" id="cdk-extensions.ec2.VpnConnectionType.of"></a>

```typescript
import { ec2 } from 'cdk-extensions'

ec2.VpnConnectionType.of(name: string)
```

An escape hatch method that allows defining custom VPN protocols.

###### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.VpnConnectionType.of.parameter.name"></a>

- *Type:* string

The name of the VPN protocol.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnectionType.property.name">name</a></code> | <code>string</code> | The name of the VPN protocol. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.ec2.VpnConnectionType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the VPN protocol.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnConnectionType.property.IPSEC_1">IPSEC_1</a></code> | <code>cdk-extensions.ec2.VpnConnectionType</code> | The ipsec.1 VPN protocol. |

---

##### `IPSEC_1`<sup>Required</sup> <a name="IPSEC_1" id="cdk-extensions.ec2.VpnConnectionType.property.IPSEC_1"></a>

```typescript
public readonly IPSEC_1: VpnConnectionType;
```

- *Type:* cdk-extensions.ec2.VpnConnectionType

The ipsec.1 VPN protocol.

---

### VpnGatewayLocalVpnEndpoint <a name="VpnGatewayLocalVpnEndpoint" id="cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint"></a>

- *Implements:* cdk-extensions.ec2.ILocalVpnEndpoint

Specifies a VPN connection endpoint which routes to a VPN gateway on the AWS side.

#### Initializers <a name="Initializers" id="cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint.Initializer"></a>

```typescript
import { ec2 } from 'cdk-extensions'

new ec2.VpnGatewayLocalVpnEndpoint(vpnGateway: IVpnGateway)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint.Initializer.parameter.vpnGateway">vpnGateway</a></code> | <code>aws-cdk-lib.aws_ec2.IVpnGateway</code> | The VPN gateway that serves as the local end of a VPN connection. |

---

##### `vpnGateway`<sup>Required</sup> <a name="vpnGateway" id="cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint.Initializer.parameter.vpnGateway"></a>

- *Type:* aws-cdk-lib.aws_ec2.IVpnGateway

The VPN gateway that serves as the local end of a VPN connection.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint.bind">bind</a></code> | Produces a configuration that can be used when configuring the local end of a VPN connection. |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint.bind"></a>

```typescript
public bind(_scope: IConstruct): LocalVpnEndpointConfiguration
```

Produces a configuration that can be used when configuring the local end of a VPN connection.

###### `_scope`<sup>Required</sup> <a name="_scope" id="cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint.bind.parameter._scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the VPN connection that will be referencing the local endpoint.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint.property.vpnGateway">vpnGateway</a></code> | <code>aws-cdk-lib.aws_ec2.IVpnGateway</code> | The VPN gateway that serves as the local end of a VPN connection. |

---

##### `vpnGateway`<sup>Required</sup> <a name="vpnGateway" id="cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint.property.vpnGateway"></a>

```typescript
public readonly vpnGateway: IVpnGateway;
```

- *Type:* aws-cdk-lib.aws_ec2.IVpnGateway

The VPN gateway that serves as the local end of a VPN connection.

---


### WorkerType <a name="WorkerType" id="cdk-extensions.glue.WorkerType"></a>

The type of predefined worker that is allocated when a job runs.

If you need to use a WorkerType that doesn't exist as a static member, you
can instantiate a `WorkerType` object, e.g: `WorkerType.of('other type')`.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.WorkerType.of">of</a></code> | Custom worker type. |

---

##### `of` <a name="of" id="cdk-extensions.glue.WorkerType.of"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.WorkerType.of(workerType: string)
```

Custom worker type.

###### `workerType`<sup>Required</sup> <a name="workerType" id="cdk-extensions.glue.WorkerType.of.parameter.workerType"></a>

- *Type:* string

custom worker type.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkerType.property.name">name</a></code> | <code>string</code> | The name of this WorkerType, as expected by Job resource. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.glue.WorkerType.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this WorkerType, as expected by Job resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkerType.property.G_1X">G_1X</a></code> | <code>cdk-extensions.glue.WorkerType</code> | Each worker maps to 1 DPU (4 vCPU, 16 GB of memory, 64 GB disk), and provides 1 executor per worker. |
| <code><a href="#cdk-extensions.glue.WorkerType.property.G_2X">G_2X</a></code> | <code>cdk-extensions.glue.WorkerType</code> | Each worker maps to 2 DPU (8 vCPU, 32 GB of memory, 128 GB disk), and provides 1 executor per worker. |
| <code><a href="#cdk-extensions.glue.WorkerType.property.STANDARD">STANDARD</a></code> | <code>cdk-extensions.glue.WorkerType</code> | Each worker provides 4 vCPU, 16 GB of memory and a 50GB disk, and 2 executors per worker. |

---

##### `G_1X`<sup>Required</sup> <a name="G_1X" id="cdk-extensions.glue.WorkerType.property.G_1X"></a>

```typescript
public readonly G_1X: WorkerType;
```

- *Type:* cdk-extensions.glue.WorkerType

Each worker maps to 1 DPU (4 vCPU, 16 GB of memory, 64 GB disk), and provides 1 executor per worker.

Suitable for memory-intensive jobs.

---

##### `G_2X`<sup>Required</sup> <a name="G_2X" id="cdk-extensions.glue.WorkerType.property.G_2X"></a>

```typescript
public readonly G_2X: WorkerType;
```

- *Type:* cdk-extensions.glue.WorkerType

Each worker maps to 2 DPU (8 vCPU, 32 GB of memory, 128 GB disk), and provides 1 executor per worker.

Suitable for memory-intensive jobs.

---

##### `STANDARD`<sup>Required</sup> <a name="STANDARD" id="cdk-extensions.glue.WorkerType.property.STANDARD"></a>

```typescript
public readonly STANDARD: WorkerType;
```

- *Type:* cdk-extensions.glue.WorkerType

Each worker provides 4 vCPU, 16 GB of memory and a 50GB disk, and 2 executors per worker.

---

### WorkflowAction <a name="WorkflowAction" id="cdk-extensions.glue.WorkflowAction"></a>

Actions to be started by a Glue workflow trigger when it is activated.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.WorkflowAction.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.WorkflowAction()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowAction.crawler">crawler</a></code> | An action that runs a crawler as part of a Glue workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowAction.job">job</a></code> | An action that runs a Glue job as part of a workflow. |

---

##### `crawler` <a name="crawler" id="cdk-extensions.glue.WorkflowAction.crawler"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.WorkflowAction.crawler(crawler: ICrawler, options?: WorkflowCrawlerActionOptions)
```

An action that runs a crawler as part of a Glue workflow.

###### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.glue.WorkflowAction.crawler.parameter.crawler"></a>

- *Type:* cdk-extensions.glue.ICrawler

The crawler to run as part of the workflow.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowAction.crawler.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowCrawlerActionOptions

The options configuring how the crawler should be run.

---

##### `job` <a name="job" id="cdk-extensions.glue.WorkflowAction.job"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.WorkflowAction.job(job: IJob, options?: WorkflowJobActionOptions)
```

An action that runs a Glue job as part of a workflow.

###### `job`<sup>Required</sup> <a name="job" id="cdk-extensions.glue.WorkflowAction.job.parameter.job"></a>

- *Type:* cdk-extensions.glue.IJob

The job to run as part of the workflow.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowAction.job.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowJobActionOptions

The options configuring how the job should be run.

---



### WorkflowActionBase <a name="WorkflowActionBase" id="cdk-extensions.glue.WorkflowActionBase"></a>

Base class providing common functionality for workflow trigger actions.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.WorkflowActionBase.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.WorkflowActionBase(options?: WorkflowActionOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowActionBase.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.glue.WorkflowActionOptions</code> | Options controlling aspects of the action being executed. |

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowActionBase.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowActionOptions

Options controlling aspects of the action being executed.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowActionBase.addArgument">addArgument</a></code> | Adds an argument that will be passed to the specified action when triggered as part of a workflow. |

---

##### `addArgument` <a name="addArgument" id="cdk-extensions.glue.WorkflowActionBase.addArgument"></a>

```typescript
public addArgument(key: string, value: string): void
```

Adds an argument that will be passed to the specified action when triggered as part of a workflow.

> [[AWS Glue job parameters](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)]([AWS Glue job parameters](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html))

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.WorkflowActionBase.addArgument.parameter.key"></a>

- *Type:* string

The name of the argument being set.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.WorkflowActionBase.addArgument.parameter.value"></a>

- *Type:* string

The value to pass for the specified argument.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowActionBase.property.notifyDelayAfter">notifyDelayAfter</a></code> | <code>aws-cdk-lib.Duration</code> | After a job run starts, the number of minutes to wait before sending a job run delay notification. |
| <code><a href="#cdk-extensions.glue.WorkflowActionBase.property.securityConfiguration">securityConfiguration</a></code> | <code>string</code> | The name of the SecurityConfiguration structure to be used with this action. |
| <code><a href="#cdk-extensions.glue.WorkflowActionBase.property.timeout">timeout</a></code> | <code>aws-cdk-lib.Duration</code> | The `JobRun` timeout in minutes. |

---

##### `notifyDelayAfter`<sup>Optional</sup> <a name="notifyDelayAfter" id="cdk-extensions.glue.WorkflowActionBase.property.notifyDelayAfter"></a>

```typescript
public readonly notifyDelayAfter: Duration;
```

- *Type:* aws-cdk-lib.Duration

After a job run starts, the number of minutes to wait before sending a job run delay notification.

> [[Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter)]([Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter))

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.WorkflowActionBase.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: string;
```

- *Type:* string

The name of the SecurityConfiguration structure to be used with this action.

> [[Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration)]([Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration))

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="cdk-extensions.glue.WorkflowActionBase.property.timeout"></a>

```typescript
public readonly timeout: Duration;
```

- *Type:* aws-cdk-lib.Duration

The `JobRun` timeout in minutes.

This is the maximum time that a job run
can consume resources before it is terminated and enters TIMEOUT status.
The default is 48 hours. This overrides the timeout value set in the
parent job.

> [[Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout)]([Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout))

---


### WorkflowCrawlerAction <a name="WorkflowCrawlerAction" id="cdk-extensions.glue.WorkflowCrawlerAction"></a>

- *Implements:* cdk-extensions.glue.ITriggerAction

Configuration options for the WorkflowCrawlerAction class.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.WorkflowCrawlerAction.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.WorkflowCrawlerAction(crawler: ICrawler, options?: WorkflowCrawlerActionOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerAction.Initializer.parameter.crawler">crawler</a></code> | <code>cdk-extensions.glue.ICrawler</code> | The crawler that should be triggered as part of the workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerAction.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.glue.WorkflowCrawlerActionOptions</code> | The options affecting how the crawler should be triggered. |

---

##### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.glue.WorkflowCrawlerAction.Initializer.parameter.crawler"></a>

- *Type:* cdk-extensions.glue.ICrawler

The crawler that should be triggered as part of the workflow.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowCrawlerAction.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowCrawlerActionOptions

The options affecting how the crawler should be triggered.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerAction.addArgument">addArgument</a></code> | Adds an argument that will be passed to the specified action when triggered as part of a workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerAction.bind">bind</a></code> | Associates this action with a resource that is configuring a Glue trigger. |

---

##### `addArgument` <a name="addArgument" id="cdk-extensions.glue.WorkflowCrawlerAction.addArgument"></a>

```typescript
public addArgument(key: string, value: string): void
```

Adds an argument that will be passed to the specified action when triggered as part of a workflow.

> [[AWS Glue job parameters](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)]([AWS Glue job parameters](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html))

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.WorkflowCrawlerAction.addArgument.parameter.key"></a>

- *Type:* string

The name of the argument being set.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.WorkflowCrawlerAction.addArgument.parameter.value"></a>

- *Type:* string

The value to pass for the specified argument.

---

##### `bind` <a name="bind" id="cdk-extensions.glue.WorkflowCrawlerAction.bind"></a>

```typescript
public bind(scope: IConstruct): ActionProperty
```

Associates this action with a resource that is configuring a Glue trigger.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.WorkflowCrawlerAction.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the trigger that this action will be used in.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerAction.property.notifyDelayAfter">notifyDelayAfter</a></code> | <code>aws-cdk-lib.Duration</code> | After a job run starts, the number of minutes to wait before sending a job run delay notification. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerAction.property.securityConfiguration">securityConfiguration</a></code> | <code>string</code> | The name of the SecurityConfiguration structure to be used with this action. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerAction.property.timeout">timeout</a></code> | <code>aws-cdk-lib.Duration</code> | The `JobRun` timeout in minutes. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerAction.property.crawler">crawler</a></code> | <code>cdk-extensions.glue.ICrawler</code> | The Glue crawler to be triggered as part of the workflow. |

---

##### `notifyDelayAfter`<sup>Optional</sup> <a name="notifyDelayAfter" id="cdk-extensions.glue.WorkflowCrawlerAction.property.notifyDelayAfter"></a>

```typescript
public readonly notifyDelayAfter: Duration;
```

- *Type:* aws-cdk-lib.Duration

After a job run starts, the number of minutes to wait before sending a job run delay notification.

> [[Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter)]([Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter))

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.WorkflowCrawlerAction.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: string;
```

- *Type:* string

The name of the SecurityConfiguration structure to be used with this action.

> [[Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration)]([Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration))

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="cdk-extensions.glue.WorkflowCrawlerAction.property.timeout"></a>

```typescript
public readonly timeout: Duration;
```

- *Type:* aws-cdk-lib.Duration

The `JobRun` timeout in minutes.

This is the maximum time that a job run
can consume resources before it is terminated and enters TIMEOUT status.
The default is 48 hours. This overrides the timeout value set in the
parent job.

> [[Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout)]([Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout))

---

##### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.glue.WorkflowCrawlerAction.property.crawler"></a>

```typescript
public readonly crawler: ICrawler;
```

- *Type:* cdk-extensions.glue.ICrawler

The Glue crawler to be triggered as part of the workflow.

---


### WorkflowCrawlerPredicate <a name="WorkflowCrawlerPredicate" id="cdk-extensions.glue.WorkflowCrawlerPredicate"></a>

- *Implements:* cdk-extensions.glue.ITriggerPredicate

Represents a condition that is predicated on a Glue crawler completion.

The condition can be used to create a trigger that controls the execution of
downstream tasks in a workflow.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.WorkflowCrawlerPredicate.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.WorkflowCrawlerPredicate(crawler: ICrawler, options?: WorkflowCrawlerPredicateOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicate.Initializer.parameter.crawler">crawler</a></code> | <code>cdk-extensions.glue.ICrawler</code> | The crawler which must complete in order to meet the requirements to trigger the next stage of the workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicate.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.glue.WorkflowCrawlerPredicateOptions</code> | Options specifying the conditions the crawler must meet to trigger the next stage of the workflow. |

---

##### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.glue.WorkflowCrawlerPredicate.Initializer.parameter.crawler"></a>

- *Type:* cdk-extensions.glue.ICrawler

The crawler which must complete in order to meet the requirements to trigger the next stage of the workflow.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowCrawlerPredicate.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowCrawlerPredicateOptions

Options specifying the conditions the crawler must meet to trigger the next stage of the workflow.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicate.bind">bind</a></code> | Associates the predicate with a construct that is configuring a trigger for a Glue workflow. |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.WorkflowCrawlerPredicate.bind"></a>

```typescript
public bind(scope: IConstruct): ConditionProperty
```

Associates the predicate with a construct that is configuring a trigger for a Glue workflow.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.WorkflowCrawlerPredicate.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the Glue trigger.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicate.property.crawler">crawler</a></code> | <code>cdk-extensions.glue.ICrawler</code> | The crawler which must complete in order to meet the requirements to trigger the next stage of the workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicate.property.logicalOperator">logicalOperator</a></code> | <code>cdk-extensions.glue.PredicateLogicalOperator</code> | The logical operator which should be applied in determining whether a crawler meets the requested conditions. |
| <code><a href="#cdk-extensions.glue.WorkflowCrawlerPredicate.property.state">state</a></code> | <code>cdk-extensions.glue.CrawlerState</code> | The state that the crawler must be in in order to meet the criteria to trigger the next stage of the workflow. |

---

##### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.glue.WorkflowCrawlerPredicate.property.crawler"></a>

```typescript
public readonly crawler: ICrawler;
```

- *Type:* cdk-extensions.glue.ICrawler

The crawler which must complete in order to meet the requirements to trigger the next stage of the workflow.

> [[Trigger Predicate.Conditions.CrawlerName](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-crawlername)]([Trigger Predicate.Conditions.CrawlerName](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-crawlername))

---

##### `logicalOperator`<sup>Required</sup> <a name="logicalOperator" id="cdk-extensions.glue.WorkflowCrawlerPredicate.property.logicalOperator"></a>

```typescript
public readonly logicalOperator: PredicateLogicalOperator;
```

- *Type:* cdk-extensions.glue.PredicateLogicalOperator

The logical operator which should be applied in determining whether a crawler meets the requested conditions.

At the moment, the only supported operator is `EQUALS`.

> [[Trigger Predicate.Conditions.LogicalOperator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-logicaloperator)]([Trigger Predicate.Conditions.LogicalOperator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-logicaloperator))

---

##### `state`<sup>Required</sup> <a name="state" id="cdk-extensions.glue.WorkflowCrawlerPredicate.property.state"></a>

```typescript
public readonly state: CrawlerState;
```

- *Type:* cdk-extensions.glue.CrawlerState

The state that the crawler must be in in order to meet the criteria to trigger the next stage of the workflow.

> [[Trigger Predicate.Conditions.CrawlState](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-crawlstate)]([Trigger Predicate.Conditions.CrawlState](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-crawlstate))

---


### WorkflowJobAction <a name="WorkflowJobAction" id="cdk-extensions.glue.WorkflowJobAction"></a>

- *Implements:* cdk-extensions.glue.ITriggerAction

Represents the configuration for a job that will be triggered as part of a workflow.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.WorkflowJobAction.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.WorkflowJobAction(job: IJob, options?: WorkflowJobActionOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowJobAction.Initializer.parameter.job">job</a></code> | <code>cdk-extensions.glue.IJob</code> | The job that should be triggered as part of the workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowJobAction.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.glue.WorkflowJobActionOptions</code> | The options affecting how the job should be triggered. |

---

##### `job`<sup>Required</sup> <a name="job" id="cdk-extensions.glue.WorkflowJobAction.Initializer.parameter.job"></a>

- *Type:* cdk-extensions.glue.IJob

The job that should be triggered as part of the workflow.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowJobAction.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowJobActionOptions

The options affecting how the job should be triggered.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowJobAction.addArgument">addArgument</a></code> | Adds an argument that will be passed to the specified action when triggered as part of a workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowJobAction.bind">bind</a></code> | Associates this action with a resource that is configuring a Glue trigger. |

---

##### `addArgument` <a name="addArgument" id="cdk-extensions.glue.WorkflowJobAction.addArgument"></a>

```typescript
public addArgument(key: string, value: string): void
```

Adds an argument that will be passed to the specified action when triggered as part of a workflow.

> [[AWS Glue job parameters](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html)]([AWS Glue job parameters](https://docs.aws.amazon.com/glue/latest/dg/aws-glue-programming-etl-glue-arguments.html))

###### `key`<sup>Required</sup> <a name="key" id="cdk-extensions.glue.WorkflowJobAction.addArgument.parameter.key"></a>

- *Type:* string

The name of the argument being set.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk-extensions.glue.WorkflowJobAction.addArgument.parameter.value"></a>

- *Type:* string

The value to pass for the specified argument.

---

##### `bind` <a name="bind" id="cdk-extensions.glue.WorkflowJobAction.bind"></a>

```typescript
public bind(scope: IConstruct): ActionProperty
```

Associates this action with a resource that is configuring a Glue trigger.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.WorkflowJobAction.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the trigger that this action will be used in.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowJobAction.property.notifyDelayAfter">notifyDelayAfter</a></code> | <code>aws-cdk-lib.Duration</code> | After a job run starts, the number of minutes to wait before sending a job run delay notification. |
| <code><a href="#cdk-extensions.glue.WorkflowJobAction.property.securityConfiguration">securityConfiguration</a></code> | <code>string</code> | The name of the SecurityConfiguration structure to be used with this action. |
| <code><a href="#cdk-extensions.glue.WorkflowJobAction.property.timeout">timeout</a></code> | <code>aws-cdk-lib.Duration</code> | The `JobRun` timeout in minutes. |
| <code><a href="#cdk-extensions.glue.WorkflowJobAction.property.job">job</a></code> | <code>cdk-extensions.glue.IJob</code> | The Glue job to be triggered as part of the workflow. |

---

##### `notifyDelayAfter`<sup>Optional</sup> <a name="notifyDelayAfter" id="cdk-extensions.glue.WorkflowJobAction.property.notifyDelayAfter"></a>

```typescript
public readonly notifyDelayAfter: Duration;
```

- *Type:* aws-cdk-lib.Duration

After a job run starts, the number of minutes to wait before sending a job run delay notification.

> [[Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter)]([Trigger Actions.NotificationProperty.NotifyDelayAfter](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-notificationproperty.html#cfn-glue-trigger-notificationproperty-notifydelayafter))

---

##### `securityConfiguration`<sup>Optional</sup> <a name="securityConfiguration" id="cdk-extensions.glue.WorkflowJobAction.property.securityConfiguration"></a>

```typescript
public readonly securityConfiguration: string;
```

- *Type:* string

The name of the SecurityConfiguration structure to be used with this action.

> [[Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration)]([Trigger Actions.SecurityConfiguration](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-securityconfiguration))

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="cdk-extensions.glue.WorkflowJobAction.property.timeout"></a>

```typescript
public readonly timeout: Duration;
```

- *Type:* aws-cdk-lib.Duration

The `JobRun` timeout in minutes.

This is the maximum time that a job run
can consume resources before it is terminated and enters TIMEOUT status.
The default is 48 hours. This overrides the timeout value set in the
parent job.

> [[Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout)]([Trigger Actions.Timeout](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-action.html#cfn-glue-trigger-action-timeout))

---

##### `job`<sup>Required</sup> <a name="job" id="cdk-extensions.glue.WorkflowJobAction.property.job"></a>

```typescript
public readonly job: IJob;
```

- *Type:* cdk-extensions.glue.IJob

The Glue job to be triggered as part of the workflow.

---


### WorkflowJobPredicate <a name="WorkflowJobPredicate" id="cdk-extensions.glue.WorkflowJobPredicate"></a>

- *Implements:* cdk-extensions.glue.ITriggerPredicate

Represents a condition that is predicated on a Glue job completion.

The condition can be used to create a trigger that controls the execution of
downstream tasks in a workflow.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.WorkflowJobPredicate.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.WorkflowJobPredicate(job: IJob, options?: WorkflowJobPredicateOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicate.Initializer.parameter.job">job</a></code> | <code>cdk-extensions.glue.IJob</code> | The job which must complete in order to meet the requirements to trigger the next stage of the workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicate.Initializer.parameter.options">options</a></code> | <code>cdk-extensions.glue.WorkflowJobPredicateOptions</code> | Options specifying the conditions the job must meet to trigger the next stage of the workflow. |

---

##### `job`<sup>Required</sup> <a name="job" id="cdk-extensions.glue.WorkflowJobPredicate.Initializer.parameter.job"></a>

- *Type:* cdk-extensions.glue.IJob

The job which must complete in order to meet the requirements to trigger the next stage of the workflow.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowJobPredicate.Initializer.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowJobPredicateOptions

Options specifying the conditions the job must meet to trigger the next stage of the workflow.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicate.bind">bind</a></code> | Associates the predicate with a construct that is configuring a trigger for a Glue workflow. |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.WorkflowJobPredicate.bind"></a>

```typescript
public bind(scope: IConstruct): ConditionProperty
```

Associates the predicate with a construct that is configuring a trigger for a Glue workflow.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.WorkflowJobPredicate.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the Glue trigger.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicate.property.job">job</a></code> | <code>cdk-extensions.glue.IJob</code> | The job which must complete in order to meet the requirements to trigger the next stage of the workflow. |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicate.property.logicalOperator">logicalOperator</a></code> | <code>cdk-extensions.glue.PredicateLogicalOperator</code> | The logical operator which should be applied in determining whether a job meets the requested conditions. |
| <code><a href="#cdk-extensions.glue.WorkflowJobPredicate.property.state">state</a></code> | <code>cdk-extensions.glue.JobState</code> | The state that the job must be in in order to meet the criteria to trigger the next stage of the workflow. |

---

##### `job`<sup>Required</sup> <a name="job" id="cdk-extensions.glue.WorkflowJobPredicate.property.job"></a>

```typescript
public readonly job: IJob;
```

- *Type:* cdk-extensions.glue.IJob

The job which must complete in order to meet the requirements to trigger the next stage of the workflow.

> [[Trigger Predicate.Conditions.JobName](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-jobname)]([Trigger Predicate.Conditions.JobName](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-jobname))

---

##### `logicalOperator`<sup>Required</sup> <a name="logicalOperator" id="cdk-extensions.glue.WorkflowJobPredicate.property.logicalOperator"></a>

```typescript
public readonly logicalOperator: PredicateLogicalOperator;
```

- *Type:* cdk-extensions.glue.PredicateLogicalOperator

The logical operator which should be applied in determining whether a job meets the requested conditions.

At the moment, the only supported operator is `EQUALS`.

> [[Trigger Predicate.Conditions.LogicalOperator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-logicaloperator)]([Trigger Predicate.Conditions.LogicalOperator](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-logicaloperator))

---

##### `state`<sup>Required</sup> <a name="state" id="cdk-extensions.glue.WorkflowJobPredicate.property.state"></a>

```typescript
public readonly state: JobState;
```

- *Type:* cdk-extensions.glue.JobState

The state that the job must be in in order to meet the criteria to trigger the next stage of the workflow.

> [[Trigger Predicate.Conditions.State](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-state)]([Trigger Predicate.Conditions.State](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-glue-trigger-condition.html#cfn-glue-trigger-condition-state))

---


### WorkflowPredicate <a name="WorkflowPredicate" id="cdk-extensions.glue.WorkflowPredicate"></a>

Predicate conditions for controlling trigger activation in a Glue workflow.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.WorkflowPredicate.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.WorkflowPredicate()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowPredicate.crawler">crawler</a></code> | A predicate condition dependent on the completion of a Glue crawler. |
| <code><a href="#cdk-extensions.glue.WorkflowPredicate.job">job</a></code> | A predicate condition dependent on the completion of a Glue job. |

---

##### `crawler` <a name="crawler" id="cdk-extensions.glue.WorkflowPredicate.crawler"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.WorkflowPredicate.crawler(crawler: ICrawler, options?: WorkflowCrawlerPredicateOptions)
```

A predicate condition dependent on the completion of a Glue crawler.

###### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.glue.WorkflowPredicate.crawler.parameter.crawler"></a>

- *Type:* cdk-extensions.glue.ICrawler

The crawler which must complete in order to meet the requirements to trigger the next stage of the workflow.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowPredicate.crawler.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowCrawlerPredicateOptions

Options specifying the conditions the crawler must meet to trigger the next stage of the workflow.

---

##### `job` <a name="job" id="cdk-extensions.glue.WorkflowPredicate.job"></a>

```typescript
import { glue } from 'cdk-extensions'

glue.WorkflowPredicate.job(job: IJob, options?: WorkflowJobPredicateOptions)
```

A predicate condition dependent on the completion of a Glue job.

###### `job`<sup>Required</sup> <a name="job" id="cdk-extensions.glue.WorkflowPredicate.job.parameter.job"></a>

- *Type:* cdk-extensions.glue.IJob

The job which must complete in order to meet the requirements to trigger the next stage of the workflow.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.glue.WorkflowPredicate.job.parameter.options"></a>

- *Type:* cdk-extensions.glue.WorkflowJobPredicateOptions

Options specifying the conditions the job must meet to trigger the next stage of the workflow.

---



### WorkflowPredicateBase <a name="WorkflowPredicateBase" id="cdk-extensions.glue.WorkflowPredicateBase"></a>

Base class providing common functionality for trigger predicate conditions.

#### Initializers <a name="Initializers" id="cdk-extensions.glue.WorkflowPredicateBase.Initializer"></a>

```typescript
import { glue } from 'cdk-extensions'

new glue.WorkflowPredicateBase(_options?: WorkflowPredicateOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.WorkflowPredicateBase.Initializer.parameter._options">_options</a></code> | <code>cdk-extensions.glue.WorkflowPredicateOptions</code> | Options specifying the conditions the predicate must meet to trigger the next stage of the workflow. |

---

##### `_options`<sup>Optional</sup> <a name="_options" id="cdk-extensions.glue.WorkflowPredicateBase.Initializer.parameter._options"></a>

- *Type:* cdk-extensions.glue.WorkflowPredicateOptions

Options specifying the conditions the predicate must meet to trigger the next stage of the workflow.

---





## Protocols <a name="Protocols" id="Protocols"></a>

### IAddressConfiguration <a name="IAddressConfiguration" id="cdk-extensions.ec2.IAddressConfiguration"></a>

- *Implemented By:* cdk-extensions.ec2.IAddressConfiguration


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IAddressConfiguration.property.family">family</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IAddressConfiguration.property.publiclyAdvertisable">publiclyAdvertisable</a></code> | <code>boolean</code> | *No description.* |

---

##### `family`<sup>Required</sup> <a name="family" id="cdk-extensions.ec2.IAddressConfiguration.property.family"></a>

```typescript
public readonly family: string;
```

- *Type:* string

---

##### `publiclyAdvertisable`<sup>Optional</sup> <a name="publiclyAdvertisable" id="cdk-extensions.ec2.IAddressConfiguration.property.publiclyAdvertisable"></a>

```typescript
public readonly publiclyAdvertisable: boolean;
```

- *Type:* boolean

---

### IAlertManagerConfiguration <a name="IAlertManagerConfiguration" id="cdk-extensions.aps.IAlertManagerConfiguration"></a>

- *Implemented By:* cdk-extensions.aps.AlertManagerConfiguration, cdk-extensions.aps.IAlertManagerConfiguration

Represents an alert manager configuration object that can be used by resources configuring alerting for Amazon APS.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.IAlertManagerConfiguration.bind">bind</a></code> | Associates the configuration with a construct that is handling the configuration of alert manager for an APS workspace. |

---

##### `bind` <a name="bind" id="cdk-extensions.aps.IAlertManagerConfiguration.bind"></a>

```typescript
public bind(scope: IConstruct): AlertManagerConfigurationDetails
```

Associates the configuration with a construct that is handling the configuration of alert manager for an APS workspace.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.IAlertManagerConfiguration.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of alert manager that will consume the configuration.

---


### IAlertManagerDestination <a name="IAlertManagerDestination" id="cdk-extensions.aps.IAlertManagerDestination"></a>

- *Implemented By:* cdk-extensions.aps.AlertManagerSnsDestination, cdk-extensions.aps.IAlertManagerDestination

Represents a destination where alert manager can send notifications.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.IAlertManagerDestination.bind">bind</a></code> | Associates the destination with a construct that is handling the configuration of alert manager. |

---

##### `bind` <a name="bind" id="cdk-extensions.aps.IAlertManagerDestination.bind"></a>

```typescript
public bind(scope: IConstruct): {[ key: string ]: any}
```

Associates the destination with a construct that is handling the configuration of alert manager.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.IAlertManagerDestination.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling alert manager configuration.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.IAlertManagerDestination.property.category">category</a></code> | <code>cdk-extensions.aps.AlertManagerDestinationCategory</code> | The destination type being configured. |

---

##### `category`<sup>Required</sup> <a name="category" id="cdk-extensions.aps.IAlertManagerDestination.property.category"></a>

```typescript
public readonly category: AlertManagerDestinationCategory;
```

- *Type:* cdk-extensions.aps.AlertManagerDestinationCategory

The destination type being configured.

Represents a config block in an alert manager receiver configuration.

---

### ICidrProvider <a name="ICidrProvider" id="cdk-extensions.ec2.ICidrProvider"></a>

- *Implemented By:* cdk-extensions.ec2.ICidrProvider


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ICidrProvider.property.ipamOptions">ipamOptions</a></code> | <code>aws-cdk-lib.aws_ec2.VpcIpamOptions</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.ICidrProvider.property.netmask">netmask</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.ICidrProvider.property.ipamPool">ipamPool</a></code> | <code>cdk-extensions.ec2.IIpamPool</code> | *No description.* |

---

##### `ipamOptions`<sup>Required</sup> <a name="ipamOptions" id="cdk-extensions.ec2.ICidrProvider.property.ipamOptions"></a>

```typescript
public readonly ipamOptions: VpcIpamOptions;
```

- *Type:* aws-cdk-lib.aws_ec2.VpcIpamOptions

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="cdk-extensions.ec2.ICidrProvider.property.netmask"></a>

```typescript
public readonly netmask: number;
```

- *Type:* number

---

##### `ipamPool`<sup>Optional</sup> <a name="ipamPool" id="cdk-extensions.ec2.ICidrProvider.property.ipamPool"></a>

```typescript
public readonly ipamPool: IIpamPool;
```

- *Type:* cdk-extensions.ec2.IIpamPool

---

### ICrawler <a name="ICrawler" id="cdk-extensions.glue.ICrawler"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* cdk-extensions.glue.Crawler, cdk-extensions.glue.ICrawler


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ICrawler.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.ICrawler.property.crawlerArn">crawlerArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the crawler. |
| <code><a href="#cdk-extensions.glue.ICrawler.property.crawlerName">crawlerName</a></code> | <code>string</code> | The name of the crawler. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.ICrawler.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `crawlerArn`<sup>Required</sup> <a name="crawlerArn" id="cdk-extensions.glue.ICrawler.property.crawlerArn"></a>

```typescript
public readonly crawlerArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the crawler.

---

##### `crawlerName`<sup>Required</sup> <a name="crawlerName" id="cdk-extensions.glue.ICrawler.property.crawlerName"></a>

```typescript
public readonly crawlerName: string;
```

- *Type:* string

The name of the crawler.

---

### ICrawlerTarget <a name="ICrawlerTarget" id="cdk-extensions.glue.ICrawlerTarget"></a>

- *Implemented By:* cdk-extensions.glue.JdbcTarget, cdk-extensions.glue.S3Target, cdk-extensions.glue.ICrawlerTarget

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.ICrawlerTarget.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.ICrawlerTarget.bind"></a>

```typescript
public bind(crawler: Crawler): CrawlerTargetCollection
```

###### `crawler`<sup>Required</sup> <a name="crawler" id="cdk-extensions.glue.ICrawlerTarget.bind.parameter.crawler"></a>

- *Type:* cdk-extensions.glue.Crawler

---


### ICustomerGateway <a name="ICustomerGateway" id="cdk-extensions.ec2.ICustomerGateway"></a>

- *Implemented By:* cdk-extensions.ec2.CustomerGateway, cdk-extensions.ec2.ICustomerGateway

Represents a customer gateway in AWS.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ICustomerGateway.property.customerGatewayAsn">customerGatewayAsn</a></code> | <code>number</code> | The BGP ASN of the customer gateway. |
| <code><a href="#cdk-extensions.ec2.ICustomerGateway.property.customerGatewayId">customerGatewayId</a></code> | <code>string</code> | The ID of the customer gateway. |
| <code><a href="#cdk-extensions.ec2.ICustomerGateway.property.customerGatewayIp">customerGatewayIp</a></code> | <code>string</code> | The IP address of the customer gateway. |

---

##### `customerGatewayAsn`<sup>Required</sup> <a name="customerGatewayAsn" id="cdk-extensions.ec2.ICustomerGateway.property.customerGatewayAsn"></a>

```typescript
public readonly customerGatewayAsn: number;
```

- *Type:* number

The BGP ASN of the customer gateway.

---

##### `customerGatewayId`<sup>Required</sup> <a name="customerGatewayId" id="cdk-extensions.ec2.ICustomerGateway.property.customerGatewayId"></a>

```typescript
public readonly customerGatewayId: string;
```

- *Type:* string

The ID of the customer gateway.

---

##### `customerGatewayIp`<sup>Required</sup> <a name="customerGatewayIp" id="cdk-extensions.ec2.ICustomerGateway.property.customerGatewayIp"></a>

```typescript
public readonly customerGatewayIp: string;
```

- *Type:* string

The IP address of the customer gateway.

---

### IDeliveryStream <a name="IDeliveryStream" id="cdk-extensions.kinesis_firehose.IDeliveryStream"></a>

- *Extends:* aws-cdk-lib.IResource, aws-cdk-lib.aws_iam.IGrantable, aws-cdk-lib.aws_ec2.IConnectable

- *Implemented By:* cdk-extensions.kinesis_firehose.DeliveryStream, cdk-extensions.kinesis_firehose.IDeliveryStream

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.grant">grant</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.grantPutRecords">grantPutRecords</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.metric">metric</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3Bytes">metricBackupToS3Bytes</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3DataFreshness">metricBackupToS3DataFreshness</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3Records">metricBackupToS3Records</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.metricIncomingBytes">metricIncomingBytes</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.metricIncomingRecords">metricIncomingRecords</a></code> | *No description.* |

---

##### `grant` <a name="grant" id="cdk-extensions.kinesis_firehose.IDeliveryStream.grant"></a>

```typescript
public grant(grantee: IGrantable, actions: string): Grant
```

###### `grantee`<sup>Required</sup> <a name="grantee" id="cdk-extensions.kinesis_firehose.IDeliveryStream.grant.parameter.grantee"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

###### `actions`<sup>Required</sup> <a name="actions" id="cdk-extensions.kinesis_firehose.IDeliveryStream.grant.parameter.actions"></a>

- *Type:* string

---

##### `grantPutRecords` <a name="grantPutRecords" id="cdk-extensions.kinesis_firehose.IDeliveryStream.grantPutRecords"></a>

```typescript
public grantPutRecords(grantee: IGrantable): Grant
```

###### `grantee`<sup>Required</sup> <a name="grantee" id="cdk-extensions.kinesis_firehose.IDeliveryStream.grantPutRecords.parameter.grantee"></a>

- *Type:* aws-cdk-lib.aws_iam.IGrantable

---

##### `metric` <a name="metric" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metric"></a>

```typescript
public metric(metricName: string, props?: MetricOptions): Metric
```

###### `metricName`<sup>Required</sup> <a name="metricName" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metric.parameter.metricName"></a>

- *Type:* string

---

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metric.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricBackupToS3Bytes` <a name="metricBackupToS3Bytes" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3Bytes"></a>

```typescript
public metricBackupToS3Bytes(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3Bytes.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricBackupToS3DataFreshness` <a name="metricBackupToS3DataFreshness" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3DataFreshness"></a>

```typescript
public metricBackupToS3DataFreshness(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3DataFreshness.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricBackupToS3Records` <a name="metricBackupToS3Records" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3Records"></a>

```typescript
public metricBackupToS3Records(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricBackupToS3Records.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricIncomingBytes` <a name="metricIncomingBytes" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricIncomingBytes"></a>

```typescript
public metricIncomingBytes(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricIncomingBytes.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

##### `metricIncomingRecords` <a name="metricIncomingRecords" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricIncomingRecords"></a>

```typescript
public metricIncomingRecords(props?: MetricOptions): Metric
```

###### `props`<sup>Optional</sup> <a name="props" id="cdk-extensions.kinesis_firehose.IDeliveryStream.metricIncomingRecords.parameter.props"></a>

- *Type:* aws-cdk-lib.aws_cloudwatch.MetricOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.property.grantPrincipal">grantPrincipal</a></code> | <code>aws-cdk-lib.aws_iam.IPrincipal</code> | The principal to grant permissions to. |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.property.connections">connections</a></code> | <code>aws-cdk-lib.aws_ec2.Connections</code> | The network connections associated with this resource. |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.property.deliveryStreamArn">deliveryStreamArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStream.property.deliveryStreamName">deliveryStreamName</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.kinesis_firehose.IDeliveryStream.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.kinesis_firehose.IDeliveryStream.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.kinesis_firehose.IDeliveryStream.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `grantPrincipal`<sup>Required</sup> <a name="grantPrincipal" id="cdk-extensions.kinesis_firehose.IDeliveryStream.property.grantPrincipal"></a>

```typescript
public readonly grantPrincipal: IPrincipal;
```

- *Type:* aws-cdk-lib.aws_iam.IPrincipal

The principal to grant permissions to.

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk-extensions.kinesis_firehose.IDeliveryStream.property.connections"></a>

```typescript
public readonly connections: Connections;
```

- *Type:* aws-cdk-lib.aws_ec2.Connections

The network connections associated with this resource.

---

##### `deliveryStreamArn`<sup>Required</sup> <a name="deliveryStreamArn" id="cdk-extensions.kinesis_firehose.IDeliveryStream.property.deliveryStreamArn"></a>

```typescript
public readonly deliveryStreamArn: string;
```

- *Type:* string

---

##### `deliveryStreamName`<sup>Required</sup> <a name="deliveryStreamName" id="cdk-extensions.kinesis_firehose.IDeliveryStream.property.deliveryStreamName"></a>

```typescript
public readonly deliveryStreamName: string;
```

- *Type:* string

---

### IDeliveryStreamBackupDestination <a name="IDeliveryStreamBackupDestination" id="cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination"></a>

- *Implemented By:* cdk-extensions.kinesis_firehose.ExtendedS3Destination, cdk-extensions.kinesis_firehose.S3Destination, cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination.renderBackupConfiguration">renderBackupConfiguration</a></code> | *No description.* |

---

##### `renderBackupConfiguration` <a name="renderBackupConfiguration" id="cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination.renderBackupConfiguration"></a>

```typescript
public renderBackupConfiguration(scope: IConstruct, enabled?: boolean): BackupConfigurationResult
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination.renderBackupConfiguration.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

###### `enabled`<sup>Optional</sup> <a name="enabled" id="cdk-extensions.kinesis_firehose.IDeliveryStreamBackupDestination.renderBackupConfiguration.parameter.enabled"></a>

- *Type:* boolean

---


### IDnsResolvable <a name="IDnsResolvable" id="cdk-extensions.route53.IDnsResolvable"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* cdk-extensions.k8s_aws.Echoserver, cdk-extensions.route53.IDnsResolvable

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.route53.IDnsResolvable.registerDomain">registerDomain</a></code> | *No description.* |

---

##### `registerDomain` <a name="registerDomain" id="cdk-extensions.route53.IDnsResolvable.registerDomain"></a>

```typescript
public registerDomain(domain: Domain): void
```

###### `domain`<sup>Required</sup> <a name="domain" id="cdk-extensions.route53.IDnsResolvable.registerDomain.parameter.domain"></a>

- *Type:* cdk-extensions.route53.Domain

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.route53.IDnsResolvable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.route53.IDnsResolvable.property.domainDiscovery">domainDiscovery</a></code> | <code>cdk-extensions.route53.DomainDiscovery</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.route53.IDnsResolvable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `domainDiscovery`<sup>Required</sup> <a name="domainDiscovery" id="cdk-extensions.route53.IDnsResolvable.property.domainDiscovery"></a>

```typescript
public readonly domainDiscovery: DomainDiscovery;
```

- *Type:* cdk-extensions.route53.DomainDiscovery

---

### IExternalDnsRegistry <a name="IExternalDnsRegistry" id="cdk-extensions.k8s_aws.IExternalDnsRegistry"></a>

- *Implemented By:* cdk-extensions.k8s_aws.AwsServiceDiscoveryRegistry, cdk-extensions.k8s_aws.NoopRegistry, cdk-extensions.k8s_aws.TxtRegistry, cdk-extensions.k8s_aws.IExternalDnsRegistry

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.IExternalDnsRegistry.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.IExternalDnsRegistry.bind"></a>

```typescript
public bind(scope: IConstruct): ExternalDnsRegistryConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.IExternalDnsRegistry.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.IExternalDnsRegistry.property.registryType">registryType</a></code> | <code>string</code> | *No description.* |

---

##### `registryType`<sup>Required</sup> <a name="registryType" id="cdk-extensions.k8s_aws.IExternalDnsRegistry.property.registryType"></a>

```typescript
public readonly registryType: string;
```

- *Type:* string

---

### IFluentBitFilterPlugin <a name="IFluentBitFilterPlugin" id="cdk-extensions.k8s_aws.IFluentBitFilterPlugin"></a>

- *Extends:* cdk-extensions.k8s_aws.IFluentBitPlugin

- *Implemented By:* cdk-extensions.k8s_aws.FluentBitFilterPluginBase, cdk-extensions.k8s_aws.FluentBitGrepFilter, cdk-extensions.k8s_aws.FluentBitKubernetesFilter, cdk-extensions.k8s_aws.FluentBitModifyFilter, cdk-extensions.k8s_aws.FluentBitNestFilter, cdk-extensions.k8s_aws.FluentBitParserFilter, cdk-extensions.k8s_aws.FluentBitRecordModifierFilter, cdk-extensions.k8s_aws.FluentBitRewriteTagFilter, cdk-extensions.k8s_aws.FluentBitThrottleFilter, cdk-extensions.k8s_aws.IFluentBitFilterPlugin

Represents a Fluent Bit plugin that controls log filtering and metadata.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitFilterPlugin.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitFilterPlugin.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.IFluentBitFilterPlugin.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.IFluentBitFilterPlugin.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

### IFluentBitOutputPlugin <a name="IFluentBitOutputPlugin" id="cdk-extensions.k8s_aws.IFluentBitOutputPlugin"></a>

- *Extends:* cdk-extensions.k8s_aws.IFluentBitPlugin

- *Implemented By:* cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput, cdk-extensions.k8s_aws.FluentBitElasticsearchOutput, cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput, cdk-extensions.k8s_aws.FluentBitKinesisOutput, cdk-extensions.k8s_aws.FluentBitOpenSearchOutput, cdk-extensions.k8s_aws.FluentBitOutputPluginBase, cdk-extensions.k8s_aws.IFluentBitOutputPlugin

Represents a Fluent Bit plugin that controls log output to a given destination.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitOutputPlugin.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitOutputPlugin.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.IFluentBitOutputPlugin.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.IFluentBitOutputPlugin.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

### IFluentBitParserPlugin <a name="IFluentBitParserPlugin" id="cdk-extensions.k8s_aws.IFluentBitParserPlugin"></a>

- *Extends:* cdk-extensions.k8s_aws.IFluentBitPlugin

- *Implemented By:* cdk-extensions.k8s_aws.FluentBitJsonParser, cdk-extensions.k8s_aws.FluentBitLogfmtParser, cdk-extensions.k8s_aws.FluentBitLtsvParser, cdk-extensions.k8s_aws.FluentBitParserPluginBase, cdk-extensions.k8s_aws.FluentBitRegexParser, cdk-extensions.k8s_aws.IFluentBitParserPlugin

Represents a Fluent Bit plugin that parses inbound records to populate fields.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitParserPlugin.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitParserPlugin.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitParserPlugin.property.format">format</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.IFluentBitParserPlugin.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.IFluentBitParserPlugin.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

##### `format`<sup>Required</sup> <a name="format" id="cdk-extensions.k8s_aws.IFluentBitParserPlugin.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

---

### IFluentBitPlugin <a name="IFluentBitPlugin" id="cdk-extensions.k8s_aws.IFluentBitPlugin"></a>

- *Implemented By:* cdk-extensions.k8s_aws.FluentBitCloudWatchLogsOutput, cdk-extensions.k8s_aws.FluentBitElasticsearchOutput, cdk-extensions.k8s_aws.FluentBitFilterPluginBase, cdk-extensions.k8s_aws.FluentBitGrepFilter, cdk-extensions.k8s_aws.FluentBitJsonParser, cdk-extensions.k8s_aws.FluentBitKinesisFirehoseOutput, cdk-extensions.k8s_aws.FluentBitKinesisOutput, cdk-extensions.k8s_aws.FluentBitKubernetesFilter, cdk-extensions.k8s_aws.FluentBitLogfmtParser, cdk-extensions.k8s_aws.FluentBitLtsvParser, cdk-extensions.k8s_aws.FluentBitModifyFilter, cdk-extensions.k8s_aws.FluentBitNestFilter, cdk-extensions.k8s_aws.FluentBitOpenSearchOutput, cdk-extensions.k8s_aws.FluentBitOutputPluginBase, cdk-extensions.k8s_aws.FluentBitParserFilter, cdk-extensions.k8s_aws.FluentBitParserPluginBase, cdk-extensions.k8s_aws.FluentBitPlugin, cdk-extensions.k8s_aws.FluentBitRecordModifierFilter, cdk-extensions.k8s_aws.FluentBitRegexParser, cdk-extensions.k8s_aws.FluentBitRewriteTagFilter, cdk-extensions.k8s_aws.FluentBitThrottleFilter, cdk-extensions.k8s_aws.IFluentBitFilterPlugin, cdk-extensions.k8s_aws.IFluentBitOutputPlugin, cdk-extensions.k8s_aws.IFluentBitParserPlugin, cdk-extensions.k8s_aws.IFluentBitPlugin

Represents a Fluent Bit plugin that allows for configuration of options and can be used to configure logging from containers.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitPlugin.bind">bind</a></code> | Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.IFluentBitPlugin.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedFluentBitConfiguration
```

Builds a configuration for this plugin and returns the details for consumtion by a resource that is configuring logging.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.IFluentBitPlugin.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitPlugin.property.name">name</a></code> | <code>string</code> | The name of the fluent bit plugin. |
| <code><a href="#cdk-extensions.k8s_aws.IFluentBitPlugin.property.pluginType">pluginType</a></code> | <code>string</code> | The type of fluent bit plugin. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk-extensions.k8s_aws.IFluentBitPlugin.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the fluent bit plugin.

---

##### `pluginType`<sup>Required</sup> <a name="pluginType" id="cdk-extensions.k8s_aws.IFluentBitPlugin.property.pluginType"></a>

```typescript
public readonly pluginType: string;
```

- *Type:* string

The type of fluent bit plugin.

---

### IGlobalNetwork <a name="IGlobalNetwork" id="cdk-extensions.networkmanager.IGlobalNetwork"></a>

- *Implemented By:* cdk-extensions.networkmanager.GlobalNetwork, cdk-extensions.networkmanager.IGlobalNetwork


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.IGlobalNetwork.property.globalNetworkArn">globalNetworkArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.IGlobalNetwork.property.globalNetworkId">globalNetworkId</a></code> | <code>string</code> | *No description.* |

---

##### `globalNetworkArn`<sup>Required</sup> <a name="globalNetworkArn" id="cdk-extensions.networkmanager.IGlobalNetwork.property.globalNetworkArn"></a>

```typescript
public readonly globalNetworkArn: string;
```

- *Type:* string

---

##### `globalNetworkId`<sup>Required</sup> <a name="globalNetworkId" id="cdk-extensions.networkmanager.IGlobalNetwork.property.globalNetworkId"></a>

```typescript
public readonly globalNetworkId: string;
```

- *Type:* string

---

### IGroup <a name="IGroup" id="cdk-extensions.sso.IGroup"></a>

- *Implemented By:* cdk-extensions.sso.GroupBase, cdk-extensions.sso.IGroup


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.IGroup.property.groupId">groupId</a></code> | <code>string</code> | A GUID identifier for a group object in IAM Identity Center are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). |

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="cdk-extensions.sso.IGroup.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

A GUID identifier for a group object in IAM Identity Center are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6).

---

### IIdentityCenterPrincipal <a name="IIdentityCenterPrincipal" id="cdk-extensions.sso.IIdentityCenterPrincipal"></a>

- *Implemented By:* cdk-extensions.sso.GroupBase, cdk-extensions.sso.UserBase, cdk-extensions.sso.IIdentityCenterPrincipal

Represents an entity that can be granted permissions via IAM Identity Center.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.IIdentityCenterPrincipal.property.principalId">principalId</a></code> | <code>string</code> | The unique ID that identifies the entity withing IAM Identity Center. |
| <code><a href="#cdk-extensions.sso.IIdentityCenterPrincipal.property.principalType">principalType</a></code> | <code>cdk-extensions.sso.IdentityCenterPrincipalType</code> | The type of entity being represented. |

---

##### `principalId`<sup>Required</sup> <a name="principalId" id="cdk-extensions.sso.IIdentityCenterPrincipal.property.principalId"></a>

```typescript
public readonly principalId: string;
```

- *Type:* string

The unique ID that identifies the entity withing IAM Identity Center.

---

##### `principalType`<sup>Required</sup> <a name="principalType" id="cdk-extensions.sso.IIdentityCenterPrincipal.property.principalType"></a>

```typescript
public readonly principalType: IdentityCenterPrincipalType;
```

- *Type:* cdk-extensions.sso.IdentityCenterPrincipalType

The type of entity being represented.

---

### IInstance <a name="IInstance" id="cdk-extensions.sso.IInstance"></a>

- *Implemented By:* cdk-extensions.sso.InstanceBase, cdk-extensions.sso.IInstance


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.IInstance.property.instanceArn">instanceArn</a></code> | <code>string</code> | The ARN of the IAM Identity Center instance under which the operation will be executed. |
| <code><a href="#cdk-extensions.sso.IInstance.property.instanceId">instanceId</a></code> | <code>string</code> | The ID of the IAM Identity Center instance under which the operation will be executed. |

---

##### `instanceArn`<sup>Required</sup> <a name="instanceArn" id="cdk-extensions.sso.IInstance.property.instanceArn"></a>

```typescript
public readonly instanceArn: string;
```

- *Type:* string

The ARN of the IAM Identity Center instance under which the operation will be executed.

For more information about ARNs, see Amazon Resource Names (ARNs) and AWS Service Namespaces in the AWS General Reference.

> [[AWS::SSO::Assignment](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-assignment.html#cfn-sso-assignment-instancearn)]([AWS::SSO::Assignment](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sso-assignment.html#cfn-sso-assignment-instancearn))

---

##### `instanceId`<sup>Required</sup> <a name="instanceId" id="cdk-extensions.sso.IInstance.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* string

The ID of the IAM Identity Center instance under which the operation will be executed.

---

### IIpam <a name="IIpam" id="cdk-extensions.ec2.IIpam"></a>

- *Implemented By:* cdk-extensions.ec2.Ipam, cdk-extensions.ec2.IIpam

Represents an IPAM in AWS.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpam.addScope">addScope</a></code> | Adds an IPAM scope to the IPAM. |
| <code><a href="#cdk-extensions.ec2.IIpam.associateResourceDiscovery">associateResourceDiscovery</a></code> | Associates an existing IPAM resource discovery with the IPAM. |

---

##### `addScope` <a name="addScope" id="cdk-extensions.ec2.IIpam.addScope"></a>

```typescript
public addScope(id: string, options: IpamScopeOptions): IIpamScope
```

Adds an IPAM scope to the IPAM.

In IPAM, a scope is the highest-level container within IPAM. Scopes enable
you to reuse IP addresses across multiple unconnected networks without
causing IP address overlap or conflict.

> [[How IPAM works](https://docs.aws.amazon.com/vpc/latest/ipam/how-it-works-ipam.html)]([How IPAM works](https://docs.aws.amazon.com/vpc/latest/ipam/how-it-works-ipam.html))

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IIpam.addScope.parameter.id"></a>

- *Type:* string

A name to be associated to the scope being added.

A unique id
must be used each time this method is invoked.

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.IIpam.addScope.parameter.options"></a>

- *Type:* cdk-extensions.ec2.IpamScopeOptions

Arguments specifying the details of the scope being added.

---

##### `associateResourceDiscovery` <a name="associateResourceDiscovery" id="cdk-extensions.ec2.IIpam.associateResourceDiscovery"></a>

```typescript
public associateResourceDiscovery(resourceDiscovery: IIpamResourceDiscovery): IIpamResourceDiscoveryAssociation
```

Associates an existing IPAM resource discovery with the IPAM.

IPAM aggregates the resource CIDRs discovered by the associated resource
discovery.

###### `resourceDiscovery`<sup>Required</sup> <a name="resourceDiscovery" id="cdk-extensions.ec2.IIpam.associateResourceDiscovery.parameter.resourceDiscovery"></a>

- *Type:* cdk-extensions.ec2.IIpamResourceDiscovery

The IPAM resource discovery to associate with the IPAM.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpam.property.ipamArn">ipamArn</a></code> | <code>string</code> | The ARN of the IPAM. |
| <code><a href="#cdk-extensions.ec2.IIpam.property.ipamId">ipamId</a></code> | <code>string</code> | The ID of the IPAM. |
| <code><a href="#cdk-extensions.ec2.IIpam.property.ipamPrivateDefaultScopeId">ipamPrivateDefaultScopeId</a></code> | <code>string</code> | The ID of the IPAM's default private scope. |
| <code><a href="#cdk-extensions.ec2.IIpam.property.ipamPublicDefaultScopeId">ipamPublicDefaultScopeId</a></code> | <code>string</code> | The ID of the IPAM's default public scope. |
| <code><a href="#cdk-extensions.ec2.IIpam.property.ipamScopeCount">ipamScopeCount</a></code> | <code>number</code> | The number of scopes in the IPAM. |

---

##### `ipamArn`<sup>Required</sup> <a name="ipamArn" id="cdk-extensions.ec2.IIpam.property.ipamArn"></a>

```typescript
public readonly ipamArn: string;
```

- *Type:* string

The ARN of the IPAM.

---

##### `ipamId`<sup>Required</sup> <a name="ipamId" id="cdk-extensions.ec2.IIpam.property.ipamId"></a>

```typescript
public readonly ipamId: string;
```

- *Type:* string

The ID of the IPAM.

---

##### `ipamPrivateDefaultScopeId`<sup>Required</sup> <a name="ipamPrivateDefaultScopeId" id="cdk-extensions.ec2.IIpam.property.ipamPrivateDefaultScopeId"></a>

```typescript
public readonly ipamPrivateDefaultScopeId: string;
```

- *Type:* string

The ID of the IPAM's default private scope.

---

##### `ipamPublicDefaultScopeId`<sup>Required</sup> <a name="ipamPublicDefaultScopeId" id="cdk-extensions.ec2.IIpam.property.ipamPublicDefaultScopeId"></a>

```typescript
public readonly ipamPublicDefaultScopeId: string;
```

- *Type:* string

The ID of the IPAM's default public scope.

---

##### `ipamScopeCount`<sup>Required</sup> <a name="ipamScopeCount" id="cdk-extensions.ec2.IIpam.property.ipamScopeCount"></a>

```typescript
public readonly ipamScopeCount: number;
```

- *Type:* number

The number of scopes in the IPAM.

The scope quota is 5.

---

### IIpamAllocation <a name="IIpamAllocation" id="cdk-extensions.ec2.IIpamAllocation"></a>

- *Implemented By:* cdk-extensions.ec2.IpamAllocation, cdk-extensions.ec2.IIpamAllocation


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamAllocation.property.ipamAllocationCidr">ipamAllocationCidr</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamAllocation.property.ipamAllocationId">ipamAllocationId</a></code> | <code>string</code> | *No description.* |

---

##### `ipamAllocationCidr`<sup>Required</sup> <a name="ipamAllocationCidr" id="cdk-extensions.ec2.IIpamAllocation.property.ipamAllocationCidr"></a>

```typescript
public readonly ipamAllocationCidr: string;
```

- *Type:* string

---

##### `ipamAllocationId`<sup>Required</sup> <a name="ipamAllocationId" id="cdk-extensions.ec2.IIpamAllocation.property.ipamAllocationId"></a>

```typescript
public readonly ipamAllocationId: string;
```

- *Type:* string

---

### IIpamAllocationConfiguration <a name="IIpamAllocationConfiguration" id="cdk-extensions.ec2.IIpamAllocationConfiguration"></a>

- *Implemented By:* cdk-extensions.ec2.IIpamAllocationConfiguration

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamAllocationConfiguration.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.IIpamAllocationConfiguration.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedIpamAllocationConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IIpamAllocationConfiguration.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


### IIpamPool <a name="IIpamPool" id="cdk-extensions.ec2.IIpamPool"></a>

- *Extends:* aws-cdk-lib.IResource

- *Implemented By:* cdk-extensions.ec2.IpamPool, cdk-extensions.ec2.IIpamPool

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamPool.addChildPool">addChildPool</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.addCidrToPool">addCidrToPool</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.allocateCidrFromPool">allocateCidrFromPool</a></code> | *No description.* |

---

##### `addChildPool` <a name="addChildPool" id="cdk-extensions.ec2.IIpamPool.addChildPool"></a>

```typescript
public addChildPool(id: string, options?: AddChildPoolOptions): IIpamPool
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IIpamPool.addChildPool.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.IIpamPool.addChildPool.parameter.options"></a>

- *Type:* cdk-extensions.ec2.AddChildPoolOptions

---

##### `addCidrToPool` <a name="addCidrToPool" id="cdk-extensions.ec2.IIpamPool.addCidrToPool"></a>

```typescript
public addCidrToPool(id: string, options: AddCidrToPoolOptions): AddCidrToPoolResult
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IIpamPool.addCidrToPool.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.IIpamPool.addCidrToPool.parameter.options"></a>

- *Type:* cdk-extensions.ec2.AddCidrToPoolOptions

---

##### `allocateCidrFromPool` <a name="allocateCidrFromPool" id="cdk-extensions.ec2.IIpamPool.allocateCidrFromPool"></a>

```typescript
public allocateCidrFromPool(id: string, options?: AllocateCidrFromPoolOptions): IIpamAllocation
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IIpamPool.allocateCidrFromPool.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.IIpamPool.allocateCidrFromPool.parameter.options"></a>

- *Type:* cdk-extensions.ec2.AllocateCidrFromPoolOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.ipamPoolArn">ipamPoolArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.ipamPoolDepth">ipamPoolDepth</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.ipamPoolId">ipamPoolId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.ipamPoolIpamArn">ipamPoolIpamArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.ipamPoolScopeArn">ipamPoolScopeArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.ipamPoolScopeType">ipamPoolScopeType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.ipamPoolState">ipamPoolState</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPool.property.ipamPoolStateMessage">ipamPoolStateMessage</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.IIpamPool.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.IIpamPool.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.IIpamPool.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `ipamPoolArn`<sup>Required</sup> <a name="ipamPoolArn" id="cdk-extensions.ec2.IIpamPool.property.ipamPoolArn"></a>

```typescript
public readonly ipamPoolArn: string;
```

- *Type:* string

---

##### `ipamPoolDepth`<sup>Required</sup> <a name="ipamPoolDepth" id="cdk-extensions.ec2.IIpamPool.property.ipamPoolDepth"></a>

```typescript
public readonly ipamPoolDepth: number;
```

- *Type:* number

---

##### `ipamPoolId`<sup>Required</sup> <a name="ipamPoolId" id="cdk-extensions.ec2.IIpamPool.property.ipamPoolId"></a>

```typescript
public readonly ipamPoolId: string;
```

- *Type:* string

---

##### `ipamPoolIpamArn`<sup>Required</sup> <a name="ipamPoolIpamArn" id="cdk-extensions.ec2.IIpamPool.property.ipamPoolIpamArn"></a>

```typescript
public readonly ipamPoolIpamArn: string;
```

- *Type:* string

---

##### `ipamPoolScopeArn`<sup>Required</sup> <a name="ipamPoolScopeArn" id="cdk-extensions.ec2.IIpamPool.property.ipamPoolScopeArn"></a>

```typescript
public readonly ipamPoolScopeArn: string;
```

- *Type:* string

---

##### `ipamPoolScopeType`<sup>Required</sup> <a name="ipamPoolScopeType" id="cdk-extensions.ec2.IIpamPool.property.ipamPoolScopeType"></a>

```typescript
public readonly ipamPoolScopeType: string;
```

- *Type:* string

---

##### `ipamPoolState`<sup>Required</sup> <a name="ipamPoolState" id="cdk-extensions.ec2.IIpamPool.property.ipamPoolState"></a>

```typescript
public readonly ipamPoolState: string;
```

- *Type:* string

---

##### `ipamPoolStateMessage`<sup>Required</sup> <a name="ipamPoolStateMessage" id="cdk-extensions.ec2.IIpamPool.property.ipamPoolStateMessage"></a>

```typescript
public readonly ipamPoolStateMessage: string;
```

- *Type:* string

---

### IIpamPoolCidr <a name="IIpamPoolCidr" id="cdk-extensions.ec2.IIpamPoolCidr"></a>

- *Implemented By:* cdk-extensions.ec2.IpamPoolCidr, cdk-extensions.ec2.IIpamPoolCidr


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamPoolCidr.property.ipamPoolCidrId">ipamPoolCidrId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamPoolCidr.property.ipamPoolCidrState">ipamPoolCidrState</a></code> | <code>string</code> | *No description.* |

---

##### `ipamPoolCidrId`<sup>Required</sup> <a name="ipamPoolCidrId" id="cdk-extensions.ec2.IIpamPoolCidr.property.ipamPoolCidrId"></a>

```typescript
public readonly ipamPoolCidrId: string;
```

- *Type:* string

---

##### `ipamPoolCidrState`<sup>Required</sup> <a name="ipamPoolCidrState" id="cdk-extensions.ec2.IIpamPoolCidr.property.ipamPoolCidrState"></a>

```typescript
public readonly ipamPoolCidrState: string;
```

- *Type:* string

---

### IIpamPoolCidrConfiguration <a name="IIpamPoolCidrConfiguration" id="cdk-extensions.ec2.IIpamPoolCidrConfiguration"></a>

- *Implemented By:* cdk-extensions.ec2.IIpamPoolCidrConfiguration

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamPoolCidrConfiguration.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.IIpamPoolCidrConfiguration.bind"></a>

```typescript
public bind(scope: IConstruct): ResolvedIpamPoolCidrConfiguration
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IIpamPoolCidrConfiguration.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamPoolCidrConfiguration.property.inline">inline</a></code> | <code>boolean</code> | *No description.* |

---

##### `inline`<sup>Required</sup> <a name="inline" id="cdk-extensions.ec2.IIpamPoolCidrConfiguration.property.inline"></a>

```typescript
public readonly inline: boolean;
```

- *Type:* boolean

---

### IIpamResourceDiscovery <a name="IIpamResourceDiscovery" id="cdk-extensions.ec2.IIpamResourceDiscovery"></a>

- *Extends:* aws-cdk-lib.IResource

- *Implemented By:* cdk-extensions.ec2.IpamResourceDiscovery, cdk-extensions.ec2.IIpamResourceDiscovery

Represents an IPAM resource discovery in AWS.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.addIpam">addIpam</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.associateIpam">associateIpam</a></code> | *No description.* |

---

##### `addIpam` <a name="addIpam" id="cdk-extensions.ec2.IIpamResourceDiscovery.addIpam"></a>

```typescript
public addIpam(id: string, options: IpamProps): IIpam
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IIpamResourceDiscovery.addIpam.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.IIpamResourceDiscovery.addIpam.parameter.options"></a>

- *Type:* cdk-extensions.ec2.IpamProps

---

##### `associateIpam` <a name="associateIpam" id="cdk-extensions.ec2.IIpamResourceDiscovery.associateIpam"></a>

```typescript
public associateIpam(ipam: IIpam): IIpamResourceDiscoveryAssociation
```

###### `ipam`<sup>Required</sup> <a name="ipam" id="cdk-extensions.ec2.IIpamResourceDiscovery.associateIpam.parameter.ipam"></a>

- *Type:* cdk-extensions.ec2.IIpam

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryArn">ipamResourceDiscoveryArn</a></code> | <code>string</code> | The resource discovery ARN. |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryId">ipamResourceDiscoveryId</a></code> | <code>string</code> | The resource discovery ID. |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryIsDefault">ipamResourceDiscoveryIsDefault</a></code> | <code>aws-cdk-lib.IResolvable</code> | Defines if the resource discovery is the default. |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryOwnerId">ipamResourceDiscoveryOwnerId</a></code> | <code>string</code> | The owner ID. |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryRegion">ipamResourceDiscoveryRegion</a></code> | <code>string</code> | The resource discovery Region. |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryState">ipamResourceDiscoveryState</a></code> | <code>string</code> | The resource discovery's state. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `ipamResourceDiscoveryArn`<sup>Required</sup> <a name="ipamResourceDiscoveryArn" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryArn"></a>

```typescript
public readonly ipamResourceDiscoveryArn: string;
```

- *Type:* string

The resource discovery ARN.

---

##### `ipamResourceDiscoveryId`<sup>Required</sup> <a name="ipamResourceDiscoveryId" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryId"></a>

```typescript
public readonly ipamResourceDiscoveryId: string;
```

- *Type:* string

The resource discovery ID.

---

##### `ipamResourceDiscoveryIsDefault`<sup>Required</sup> <a name="ipamResourceDiscoveryIsDefault" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryIsDefault"></a>

```typescript
public readonly ipamResourceDiscoveryIsDefault: IResolvable;
```

- *Type:* aws-cdk-lib.IResolvable

Defines if the resource discovery is the default.

The default resource
discovery is the resource discovery automatically created when you create
an IPAM.

---

##### `ipamResourceDiscoveryOwnerId`<sup>Required</sup> <a name="ipamResourceDiscoveryOwnerId" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryOwnerId"></a>

```typescript
public readonly ipamResourceDiscoveryOwnerId: string;
```

- *Type:* string

The owner ID.

---

##### `ipamResourceDiscoveryRegion`<sup>Required</sup> <a name="ipamResourceDiscoveryRegion" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryRegion"></a>

```typescript
public readonly ipamResourceDiscoveryRegion: string;
```

- *Type:* string

The resource discovery Region.

---

##### `ipamResourceDiscoveryState`<sup>Required</sup> <a name="ipamResourceDiscoveryState" id="cdk-extensions.ec2.IIpamResourceDiscovery.property.ipamResourceDiscoveryState"></a>

```typescript
public readonly ipamResourceDiscoveryState: string;
```

- *Type:* string

The resource discovery's state.

create-in-progress - Resource discovery is being created.
- create-complete - Resource discovery creation is complete.
- create-failed - Resource discovery creation has failed.
- modify-in-progress - Resource discovery is being modified.
- modify-complete - Resource discovery modification is complete.
- modify-failed - Resource discovery modification has failed.
- delete-in-progress - Resource discovery is being deleted.
- delete-complete - Resource discovery deletion is complete.
- delete-failed - Resource discovery deletion has failed.
- isolate-in-progress - AWS account that created the resource discovery
has been removed and the resource discovery is being isolated.
- isolate-complete - Resource discovery isolation is complete.
- restore-in-progress - AWS account that created the resource discovery
and was isolated has been restored.

---

### IIpamResourceDiscoveryAssociation <a name="IIpamResourceDiscoveryAssociation" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation"></a>

- *Implemented By:* cdk-extensions.ec2.IpamResourceDiscoveryAssociation, cdk-extensions.ec2.IIpamResourceDiscoveryAssociation


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationArn">ipamResourceDiscoveryAssociationArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationId">ipamResourceDiscoveryAssociationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIpamArn">ipamResourceDiscoveryAssociationIpamArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIpamRegion">ipamResourceDiscoveryAssociationIpamRegion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIsDefault">ipamResourceDiscoveryAssociationIsDefault</a></code> | <code>aws-cdk-lib.IResolvable</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationOwnerId">ipamResourceDiscoveryAssociationOwnerId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationResourceDiscoveryId">ipamResourceDiscoveryAssociationResourceDiscoveryId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationResourceDiscoveryStatus">ipamResourceDiscoveryAssociationResourceDiscoveryStatus</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationState">ipamResourceDiscoveryAssociationState</a></code> | <code>string</code> | *No description.* |

---

##### `ipamResourceDiscoveryAssociationArn`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationArn" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationArn"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationArn: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationId`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationId" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationId"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationId: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationIpamArn`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationIpamArn" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIpamArn"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationIpamArn: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationIpamRegion`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationIpamRegion" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIpamRegion"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationIpamRegion: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationIsDefault`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationIsDefault" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationIsDefault"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationIsDefault: IResolvable;
```

- *Type:* aws-cdk-lib.IResolvable

---

##### `ipamResourceDiscoveryAssociationOwnerId`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationOwnerId" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationOwnerId"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationOwnerId: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationResourceDiscoveryId`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationResourceDiscoveryId" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationResourceDiscoveryId"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationResourceDiscoveryId: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationResourceDiscoveryStatus`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationResourceDiscoveryStatus" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationResourceDiscoveryStatus"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationResourceDiscoveryStatus: string;
```

- *Type:* string

---

##### `ipamResourceDiscoveryAssociationState`<sup>Required</sup> <a name="ipamResourceDiscoveryAssociationState" id="cdk-extensions.ec2.IIpamResourceDiscoveryAssociation.property.ipamResourceDiscoveryAssociationState"></a>

```typescript
public readonly ipamResourceDiscoveryAssociationState: string;
```

- *Type:* string

---

### IIpamScope <a name="IIpamScope" id="cdk-extensions.ec2.IIpamScope"></a>

- *Implemented By:* cdk-extensions.ec2.IpamScope, cdk-extensions.ec2.IIpamScope

Represents an IPAM scope in AWS.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamScope.addPool">addPool</a></code> | Adds an IPAM pool to the IPAM scope. |

---

##### `addPool` <a name="addPool" id="cdk-extensions.ec2.IIpamScope.addPool"></a>

```typescript
public addPool(id: string, options?: IpamPoolOptions): IIpamPool
```

Adds an IPAM pool to the IPAM scope.

A pool is a collection of contiguous IP address ranges (or CIDRs). IPAM
pools enable you to organize your IP addresses according to your routing
and security needs.

> [[How IPAM works](https://docs.aws.amazon.com/vpc/latest/ipam/how-it-works-ipam.html)]([How IPAM works](https://docs.aws.amazon.com/vpc/latest/ipam/how-it-works-ipam.html))

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.IIpamScope.addPool.parameter.id"></a>

- *Type:* string

A name to be associated with the pool bing added.

A unique id
must be used each time the method is invoked.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.IIpamScope.addPool.parameter.options"></a>

- *Type:* cdk-extensions.ec2.IpamPoolOptions

Arguments specifying the details of the pool being added.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.IIpamScope.property.ipamScopeArn">ipamScopeArn</a></code> | <code>string</code> | The ARN of the scope. |
| <code><a href="#cdk-extensions.ec2.IIpamScope.property.ipamScopeId">ipamScopeId</a></code> | <code>string</code> | The ID of an IPAM scope. |
| <code><a href="#cdk-extensions.ec2.IIpamScope.property.ipamScopeIpamArn">ipamScopeIpamArn</a></code> | <code>string</code> | The ARN of an IPAM. |
| <code><a href="#cdk-extensions.ec2.IIpamScope.property.ipamScopeIsDefault">ipamScopeIsDefault</a></code> | <code>aws-cdk-lib.IResolvable</code> | Defines if the scope is the default scope or not. |
| <code><a href="#cdk-extensions.ec2.IIpamScope.property.ipamScopePoolCount">ipamScopePoolCount</a></code> | <code>number</code> | The number of pools in a scope. |
| <code><a href="#cdk-extensions.ec2.IIpamScope.property.ipamScopeType">ipamScopeType</a></code> | <code>string</code> | The type of the scope. |

---

##### `ipamScopeArn`<sup>Required</sup> <a name="ipamScopeArn" id="cdk-extensions.ec2.IIpamScope.property.ipamScopeArn"></a>

```typescript
public readonly ipamScopeArn: string;
```

- *Type:* string

The ARN of the scope.

---

##### `ipamScopeId`<sup>Required</sup> <a name="ipamScopeId" id="cdk-extensions.ec2.IIpamScope.property.ipamScopeId"></a>

```typescript
public readonly ipamScopeId: string;
```

- *Type:* string

The ID of an IPAM scope.

---

##### `ipamScopeIpamArn`<sup>Required</sup> <a name="ipamScopeIpamArn" id="cdk-extensions.ec2.IIpamScope.property.ipamScopeIpamArn"></a>

```typescript
public readonly ipamScopeIpamArn: string;
```

- *Type:* string

The ARN of an IPAM.

---

##### `ipamScopeIsDefault`<sup>Required</sup> <a name="ipamScopeIsDefault" id="cdk-extensions.ec2.IIpamScope.property.ipamScopeIsDefault"></a>

```typescript
public readonly ipamScopeIsDefault: IResolvable;
```

- *Type:* aws-cdk-lib.IResolvable

Defines if the scope is the default scope or not.

---

##### `ipamScopePoolCount`<sup>Required</sup> <a name="ipamScopePoolCount" id="cdk-extensions.ec2.IIpamScope.property.ipamScopePoolCount"></a>

```typescript
public readonly ipamScopePoolCount: number;
```

- *Type:* number

The number of pools in a scope.

---

##### `ipamScopeType`<sup>Required</sup> <a name="ipamScopeType" id="cdk-extensions.ec2.IIpamScope.property.ipamScopeType"></a>

```typescript
public readonly ipamScopeType: string;
```

- *Type:* string

The type of the scope.

---

### IJob <a name="IJob" id="cdk-extensions.glue.IJob"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* cdk-extensions.glue.Job, cdk-extensions.glue.IJob

Represnets a Glue Job in AWS.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.IJob.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.IJob.property.jobArn">jobArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the job. |
| <code><a href="#cdk-extensions.glue.IJob.property.jobName">jobName</a></code> | <code>string</code> | The name of the job. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.IJob.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `jobArn`<sup>Required</sup> <a name="jobArn" id="cdk-extensions.glue.IJob.property.jobArn"></a>

```typescript
public readonly jobArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the job.

---

##### `jobName`<sup>Required</sup> <a name="jobName" id="cdk-extensions.glue.IJob.property.jobName"></a>

```typescript
public readonly jobName: string;
```

- *Type:* string

The name of the job.

---

### ILocalVpnEndpoint <a name="ILocalVpnEndpoint" id="cdk-extensions.ec2.ILocalVpnEndpoint"></a>

- *Implemented By:* cdk-extensions.ec2.TransitGatewayLocalVpnEndpoint, cdk-extensions.ec2.VpnGatewayLocalVpnEndpoint, cdk-extensions.ec2.ILocalVpnEndpoint

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.ILocalVpnEndpoint.bind">bind</a></code> | Produces a configuration that can be used when configuring the local end of a VPN connection. |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.ILocalVpnEndpoint.bind"></a>

```typescript
public bind(scope: IConstruct): LocalVpnEndpointConfiguration
```

Produces a configuration that can be used when configuring the local end of a VPN connection.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.ILocalVpnEndpoint.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the VPN connection that will be referencing the local endpoint.

---


### ILogDestination <a name="ILogDestination" id="cdk-extensions.ec2.ILogDestination"></a>

- *Implemented By:* cdk-extensions.ec2.FlowLogDestination, cdk-extensions.ec2.ILogDestination

Represents a resource that can act as a deliver endpoint for captured flow logs.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.ILogDestination.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.ILogDestination.bind"></a>

```typescript
public bind(scope: IConstruct): FlowLogDestinationConfig
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.ILogDestination.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


### INestFilterOperation <a name="INestFilterOperation" id="cdk-extensions.k8s_aws.INestFilterOperation"></a>

- *Implemented By:* cdk-extensions.k8s_aws.NestFilterOperation, cdk-extensions.k8s_aws.INestFilterOperation

Represents an operation with excludive options that can be performed by the Fluent Bit Nest filter plugin.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.INestFilterOperation.property.fields">fields</a></code> | <code>{[ key: string ]: string[]}</code> | *No description.* |
| <code><a href="#cdk-extensions.k8s_aws.INestFilterOperation.property.operation">operation</a></code> | <code>cdk-extensions.k8s_aws.NestFilterOperationType</code> | *No description.* |

---

##### `fields`<sup>Required</sup> <a name="fields" id="cdk-extensions.k8s_aws.INestFilterOperation.property.fields"></a>

```typescript
public readonly fields: {[ key: string ]: string[]};
```

- *Type:* {[ key: string ]: string[]}

---

##### `operation`<sup>Required</sup> <a name="operation" id="cdk-extensions.k8s_aws.INestFilterOperation.property.operation"></a>

```typescript
public readonly operation: NestFilterOperationType;
```

- *Type:* cdk-extensions.k8s_aws.NestFilterOperationType

---

### IPermissionSet <a name="IPermissionSet" id="cdk-extensions.sso.IPermissionSet"></a>

- *Implemented By:* cdk-extensions.sso.PermissionSet, cdk-extensions.sso.IPermissionSet

Represents an IAM Identity Center permission set resource.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.IPermissionSet.property.permissionSetArn">permissionSetArn</a></code> | <code>string</code> | *No description.* |

---

##### `permissionSetArn`<sup>Required</sup> <a name="permissionSetArn" id="cdk-extensions.sso.IPermissionSet.property.permissionSetArn"></a>

```typescript
public readonly permissionSetArn: string;
```

- *Type:* string

---

### IPrometheusRule <a name="IPrometheusRule" id="cdk-extensions.aps.IPrometheusRule"></a>

- *Implemented By:* cdk-extensions.aps.AlertingRule, cdk-extensions.aps.RecordingRule, cdk-extensions.aps.IPrometheusRule

Represents a Prometheus rule that can be added to a rule group and used as part of an APS rules configuration.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.IPrometheusRule.bind">bind</a></code> | Associates the rule with a construct that is configuring an APS rule groups namespace. |

---

##### `bind` <a name="bind" id="cdk-extensions.aps.IPrometheusRule.bind"></a>

```typescript
public bind(scope: IConstruct): {[ key: string ]: any}
```

Associates the rule with a construct that is configuring an APS rule groups namespace.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.IPrometheusRule.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of the APS rule groups namespace that will be consuming this rule.

---


### IRemoteVpnEndpoint <a name="IRemoteVpnEndpoint" id="cdk-extensions.ec2.IRemoteVpnEndpoint"></a>

- *Implemented By:* cdk-extensions.ec2.CustomerGatewayConfigurationRemoteVpnEndpoint, cdk-extensions.ec2.CustomerGatewayRemoteVpnEndpoint, cdk-extensions.ec2.IRemoteVpnEndpoint

An object that can be used to retrieve the details for the remote end of a VPN connection.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.IRemoteVpnEndpoint.bind">bind</a></code> | Produces a configuration that can be used when configuring the remote end of a VPN connection. |

---

##### `bind` <a name="bind" id="cdk-extensions.ec2.IRemoteVpnEndpoint.bind"></a>

```typescript
public bind(scope: IConstruct): RemoteVpnEndpointConfiguration
```

Produces a configuration that can be used when configuring the remote end of a VPN connection.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ec2.IRemoteVpnEndpoint.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct configuring the VPN connection that will be referencing the remote endpoint.

---


### IResourceShare <a name="IResourceShare" id="cdk-extensions.ram.IResourceShare"></a>

- *Extends:* aws-cdk-lib.IResource

- *Implemented By:* cdk-extensions.ram.ResourceShare, cdk-extensions.ram.IResourceShare

Represents an AWS Resource Access Manager (RAM) resource share in AWS.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram.IResourceShare.addPrincipal">addPrincipal</a></code> | Adds a new principal to the resource share. |
| <code><a href="#cdk-extensions.ram.IResourceShare.addResource">addResource</a></code> | Adds a new resource to the resource share. |

---

##### `addPrincipal` <a name="addPrincipal" id="cdk-extensions.ram.IResourceShare.addPrincipal"></a>

```typescript
public addPrincipal(principal: ISharedPrincipal): void
```

Adds a new principal to the resource share.

The principal will have access to all the resources associated with the
resource share.

###### `principal`<sup>Required</sup> <a name="principal" id="cdk-extensions.ram.IResourceShare.addPrincipal.parameter.principal"></a>

- *Type:* cdk-extensions.ram.ISharedPrincipal

The principal to with resources belonging to the resource share will be shared.

---

##### `addResource` <a name="addResource" id="cdk-extensions.ram.IResourceShare.addResource"></a>

```typescript
public addResource(resource: ISharable): void
```

Adds a new resource to the resource share.

The resource will be accessible to all pricipals associated with the
resource share.

###### `resource`<sup>Required</sup> <a name="resource" id="cdk-extensions.ram.IResourceShare.addResource.parameter.resource"></a>

- *Type:* cdk-extensions.ram.ISharable

The resource to make accessible to the pricipals associated with the resource share.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ram.IResourceShare.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ram.IResourceShare.property.env">env</a></code> | <code>aws-cdk-lib.ResourceEnvironment</code> | The environment this resource belongs to. |
| <code><a href="#cdk-extensions.ram.IResourceShare.property.stack">stack</a></code> | <code>aws-cdk-lib.Stack</code> | The stack in which this resource is defined. |
| <code><a href="#cdk-extensions.ram.IResourceShare.property.resourceShareArn">resourceShareArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the RAM resource share. |
| <code><a href="#cdk-extensions.ram.IResourceShare.property.resourceShareId">resourceShareId</a></code> | <code>string</code> | The ID of the RAM resource share. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ram.IResourceShare.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `env`<sup>Required</sup> <a name="env" id="cdk-extensions.ram.IResourceShare.property.env"></a>

```typescript
public readonly env: ResourceEnvironment;
```

- *Type:* aws-cdk-lib.ResourceEnvironment

The environment this resource belongs to.

For resources that are created and managed by the CDK
(generally, those created by creating new class instances like Role, Bucket, etc.),
this is always the same as the environment of the stack they belong to;
however, for imported resources
(those obtained from static methods like fromRoleArn, fromBucketName, etc.),
that might be different than the stack they were imported into.

---

##### `stack`<sup>Required</sup> <a name="stack" id="cdk-extensions.ram.IResourceShare.property.stack"></a>

```typescript
public readonly stack: Stack;
```

- *Type:* aws-cdk-lib.Stack

The stack in which this resource is defined.

---

##### `resourceShareArn`<sup>Required</sup> <a name="resourceShareArn" id="cdk-extensions.ram.IResourceShare.property.resourceShareArn"></a>

```typescript
public readonly resourceShareArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the RAM resource share.

---

##### `resourceShareId`<sup>Required</sup> <a name="resourceShareId" id="cdk-extensions.ram.IResourceShare.property.resourceShareId"></a>

```typescript
public readonly resourceShareId: string;
```

- *Type:* string

The ID of the RAM resource share.

---

### IRuleGroupConfiguration <a name="IRuleGroupConfiguration" id="cdk-extensions.aps.IRuleGroupConfiguration"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* cdk-extensions.aps.RuleGroupConfiguration, cdk-extensions.aps.IRuleGroupConfiguration

Represents a rules configuration that can be consumed by Amazon Managed Service for Prometheus when creating a rule groups namespace.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.IRuleGroupConfiguration.bind">bind</a></code> | Associates the configuration with a resource that is handling the creation of an APS rule groups namespace. |

---

##### `bind` <a name="bind" id="cdk-extensions.aps.IRuleGroupConfiguration.bind"></a>

```typescript
public bind(scope: IConstruct): RuleGroupConfigurationDetails
```

Associates the configuration with a resource that is handling the creation of an APS rule groups namespace.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.aps.IRuleGroupConfiguration.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct handling the configuration of an APS rule groups namespace that will be consuming this configuration.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.IRuleGroupConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.aps.IRuleGroupConfiguration.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

### IRuleGroupsNamespace <a name="IRuleGroupsNamespace" id="cdk-extensions.aps.IRuleGroupsNamespace"></a>

- *Implemented By:* cdk-extensions.aps.RuleGroupsNamespace, cdk-extensions.aps.IRuleGroupsNamespace

Represents an APS rule groups namespace in AWS.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.IRuleGroupsNamespace.property.rulesGroupsNamespaceArn">rulesGroupsNamespaceArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the APS rule groups namespace. |

---

##### `rulesGroupsNamespaceArn`<sup>Required</sup> <a name="rulesGroupsNamespaceArn" id="cdk-extensions.aps.IRuleGroupsNamespace.property.rulesGroupsNamespaceArn"></a>

```typescript
public readonly rulesGroupsNamespaceArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the APS rule groups namespace.

---

### ISecretReference <a name="ISecretReference" id="cdk-extensions.k8s_aws.ISecretReference"></a>

- *Implemented By:* cdk-extensions.k8s_aws.SecretsManagerReference, cdk-extensions.k8s_aws.SsmParameterReference, cdk-extensions.k8s_aws.ISecretReference

Represents a resource the can be synchronized into a Kubernetes secret.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ISecretReference.bind">bind</a></code> | Gets the configuration details for the resource being sychronized in a form that can be universally used to create the synchronization configuration. |

---

##### `bind` <a name="bind" id="cdk-extensions.k8s_aws.ISecretReference.bind"></a>

```typescript
public bind(scope: IConstruct): SecretReferenceConfiguration
```

Gets the configuration details for the resource being sychronized in a form that can be universally used to create the synchronization configuration.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.k8s_aws.ISecretReference.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

The scope of the construct that will be configuring the synchronization configuration.

---


### ISecretStore <a name="ISecretStore" id="cdk-extensions.k8s_aws.ISecretStore"></a>

- *Extends:* constructs.IDependable

- *Implemented By:* cdk-extensions.k8s_aws.AwsSecretStore, cdk-extensions.k8s_aws.SecretsManagerSecretStore, cdk-extensions.k8s_aws.SsmParameterSecretStore, cdk-extensions.k8s_aws.ISecretStore

Represents a Kubernetes secret store resource.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ISecretStore.property.secretStoreName">secretStoreName</a></code> | <code>string</code> | The name of the secret store as it appears in Kubernetes. |

---

##### `secretStoreName`<sup>Required</sup> <a name="secretStoreName" id="cdk-extensions.k8s_aws.ISecretStore.property.secretStoreName"></a>

```typescript
public readonly secretStoreName: string;
```

- *Type:* string

The name of the secret store as it appears in Kubernetes.

---

### ISharable <a name="ISharable" id="cdk-extensions.ram.ISharable"></a>

- *Implemented By:* cdk-extensions.ram_resources.SharedResource, cdk-extensions.ram.ISharable

Represents an AWS resource that can be shared via AWS Resource Access Manager (RAM).

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram.ISharable.share">share</a></code> | Configures resource sharing for the associated resource. |

---

##### `share` <a name="share" id="cdk-extensions.ram.ISharable.share"></a>

```typescript
public share(scope: IConstruct): string
```

Configures resource sharing for the associated resource.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ram.ISharable.share.parameter.scope"></a>

- *Type:* constructs.IConstruct

The construct implementing the resource share that will be used to expose the associated resource to external principals.

---


### ISharedPrincipal <a name="ISharedPrincipal" id="cdk-extensions.ram.ISharedPrincipal"></a>

- *Implemented By:* cdk-extensions.ram.SharedPrincipal, cdk-extensions.ram.ISharedPrincipal

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ram.ISharedPrincipal.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.ram.ISharedPrincipal.bind"></a>

```typescript
public bind(scope: IConstruct): string
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.ram.ISharedPrincipal.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


### ISite <a name="ISite" id="cdk-extensions.networkmanager.ISite"></a>

- *Implemented By:* cdk-extensions.networkmanager.Site, cdk-extensions.networkmanager.ISite


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.networkmanager.ISite.property.siteArn">siteArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.networkmanager.ISite.property.siteId">siteId</a></code> | <code>string</code> | *No description.* |

---

##### `siteArn`<sup>Required</sup> <a name="siteArn" id="cdk-extensions.networkmanager.ISite.property.siteArn"></a>

```typescript
public readonly siteArn: string;
```

- *Type:* string

---

##### `siteId`<sup>Required</sup> <a name="siteId" id="cdk-extensions.networkmanager.ISite.property.siteId"></a>

```typescript
public readonly siteId: string;
```

- *Type:* string

---

### ITransitGateway <a name="ITransitGateway" id="cdk-extensions.ec2.ITransitGateway"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* cdk-extensions.ec2.TransitGateway, cdk-extensions.ec2.ITransitGateway

Represents a transit gateway in AWS.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.ITransitGateway.addRouteTable">addRouteTable</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.ITransitGateway.addVpn">addVpn</a></code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.ITransitGateway.attachVpc">attachVpc</a></code> | *No description.* |

---

##### `addRouteTable` <a name="addRouteTable" id="cdk-extensions.ec2.ITransitGateway.addRouteTable"></a>

```typescript
public addRouteTable(options?: TransitGatewayRouteTableOptions): TransitGatewayRouteTable
```

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.ITransitGateway.addRouteTable.parameter.options"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayRouteTableOptions

---

##### `addVpn` <a name="addVpn" id="cdk-extensions.ec2.ITransitGateway.addVpn"></a>

```typescript
public addVpn(id: string, options: VpnAttachmentOptions): VpnConnection
```

###### `id`<sup>Required</sup> <a name="id" id="cdk-extensions.ec2.ITransitGateway.addVpn.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.ITransitGateway.addVpn.parameter.options"></a>

- *Type:* cdk-extensions.ec2.VpnAttachmentOptions

---

##### `attachVpc` <a name="attachVpc" id="cdk-extensions.ec2.ITransitGateway.attachVpc"></a>

```typescript
public attachVpc(vpc: IVpc, options?: VpcAttachmentOptions): TransitGatewayAttachment
```

###### `vpc`<sup>Required</sup> <a name="vpc" id="cdk-extensions.ec2.ITransitGateway.attachVpc.parameter.vpc"></a>

- *Type:* aws-cdk-lib.aws_ec2.IVpc

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk-extensions.ec2.ITransitGateway.attachVpc.parameter.options"></a>

- *Type:* cdk-extensions.ec2.VpcAttachmentOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ITransitGateway.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.ec2.ITransitGateway.property.transitGatewayArn">transitGatewayArn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk-extensions.ec2.ITransitGateway.property.transitGatewayId">transitGatewayId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.ec2.ITransitGateway.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `transitGatewayArn`<sup>Required</sup> <a name="transitGatewayArn" id="cdk-extensions.ec2.ITransitGateway.property.transitGatewayArn"></a>

```typescript
public readonly transitGatewayArn: string;
```

- *Type:* string

---

##### `transitGatewayId`<sup>Required</sup> <a name="transitGatewayId" id="cdk-extensions.ec2.ITransitGateway.property.transitGatewayId"></a>

```typescript
public readonly transitGatewayId: string;
```

- *Type:* string

---

### ITransitGatewayAttachment <a name="ITransitGatewayAttachment" id="cdk-extensions.ec2.ITransitGatewayAttachment"></a>

- *Implemented By:* cdk-extensions.ec2.TransitGatewayAttachment, cdk-extensions.ec2.TransitGatewayAttachmentBase, cdk-extensions.ec2.TransitGatewayAttachmentResource, cdk-extensions.ec2.TransitGatewayPeeringAttachment, cdk-extensions.ec2.ITransitGatewayAttachment, cdk-extensions.ec2.ITransitGatewayPeeringAttachment

Represents a Transit Gateway Attachment in AWS.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayAttachment.addRoute">addRoute</a></code> | Adds a route that directs traffic to this transit gateway attachment. |

---

##### `addRoute` <a name="addRoute" id="cdk-extensions.ec2.ITransitGatewayAttachment.addRoute"></a>

```typescript
public addRoute(cidr: string, routeTable: ITransitGatewayRouteTable): ITransitGatewayRoute
```

Adds a route that directs traffic to this transit gateway attachment.

###### `cidr`<sup>Required</sup> <a name="cidr" id="cdk-extensions.ec2.ITransitGatewayAttachment.addRoute.parameter.cidr"></a>

- *Type:* string

CIDR range that should be routed to this attachment.

---

###### `routeTable`<sup>Required</sup> <a name="routeTable" id="cdk-extensions.ec2.ITransitGatewayAttachment.addRoute.parameter.routeTable"></a>

- *Type:* cdk-extensions.ec2.ITransitGatewayRouteTable

The transit gateway route table where the route should be added.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayAttachment.property.transitGatewayAttachmentArn">transitGatewayAttachmentArn</a></code> | <code>string</code> | The ARN of the transit gateway attachment. |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayAttachment.property.transitGatewayAttachmentId">transitGatewayAttachmentId</a></code> | <code>string</code> | The ID of the transit gateway attachment. |

---

##### `transitGatewayAttachmentArn`<sup>Required</sup> <a name="transitGatewayAttachmentArn" id="cdk-extensions.ec2.ITransitGatewayAttachment.property.transitGatewayAttachmentArn"></a>

```typescript
public readonly transitGatewayAttachmentArn: string;
```

- *Type:* string

The ARN of the transit gateway attachment.

---

##### `transitGatewayAttachmentId`<sup>Required</sup> <a name="transitGatewayAttachmentId" id="cdk-extensions.ec2.ITransitGatewayAttachment.property.transitGatewayAttachmentId"></a>

```typescript
public readonly transitGatewayAttachmentId: string;
```

- *Type:* string

The ID of the transit gateway attachment.

---

### ITransitGatewayPeeringAttachment <a name="ITransitGatewayPeeringAttachment" id="cdk-extensions.ec2.ITransitGatewayPeeringAttachment"></a>

- *Extends:* cdk-extensions.ec2.ITransitGatewayAttachment

- *Implemented By:* cdk-extensions.ec2.TransitGatewayPeeringAttachment, cdk-extensions.ec2.ITransitGatewayPeeringAttachment

Represents a transit gateway route table in AWS.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentArn">transitGatewayAttachmentArn</a></code> | <code>string</code> | The ARN of the transit gateway attachment. |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentId">transitGatewayAttachmentId</a></code> | <code>string</code> | The ID of the transit gateway attachment. |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentCreationTime">transitGatewayAttachmentCreationTime</a></code> | <code>string</code> | The time the transit gateway peering attachment was created. |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentState">transitGatewayAttachmentState</a></code> | <code>string</code> | The state of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatus">transitGatewayAttachmentStatus</a></code> | <code>string</code> | The status of the transit gateway peering attachment. |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatusCode">transitGatewayAttachmentStatusCode</a></code> | <code>string</code> | The status code for the current status of the attachment. |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatusMessage">transitGatewayAttachmentStatusMessage</a></code> | <code>string</code> | The status message for the current status of the attachment. |

---

##### `transitGatewayAttachmentArn`<sup>Required</sup> <a name="transitGatewayAttachmentArn" id="cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentArn"></a>

```typescript
public readonly transitGatewayAttachmentArn: string;
```

- *Type:* string

The ARN of the transit gateway attachment.

---

##### `transitGatewayAttachmentId`<sup>Required</sup> <a name="transitGatewayAttachmentId" id="cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentId"></a>

```typescript
public readonly transitGatewayAttachmentId: string;
```

- *Type:* string

The ID of the transit gateway attachment.

---

##### `transitGatewayAttachmentCreationTime`<sup>Required</sup> <a name="transitGatewayAttachmentCreationTime" id="cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentCreationTime"></a>

```typescript
public readonly transitGatewayAttachmentCreationTime: string;
```

- *Type:* string

The time the transit gateway peering attachment was created.

---

##### `transitGatewayAttachmentState`<sup>Required</sup> <a name="transitGatewayAttachmentState" id="cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentState"></a>

```typescript
public readonly transitGatewayAttachmentState: string;
```

- *Type:* string

The state of the transit gateway peering attachment.

---

##### `transitGatewayAttachmentStatus`<sup>Required</sup> <a name="transitGatewayAttachmentStatus" id="cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatus"></a>

```typescript
public readonly transitGatewayAttachmentStatus: string;
```

- *Type:* string

The status of the transit gateway peering attachment.

---

##### `transitGatewayAttachmentStatusCode`<sup>Required</sup> <a name="transitGatewayAttachmentStatusCode" id="cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatusCode"></a>

```typescript
public readonly transitGatewayAttachmentStatusCode: string;
```

- *Type:* string

The status code for the current status of the attachment.

---

##### `transitGatewayAttachmentStatusMessage`<sup>Required</sup> <a name="transitGatewayAttachmentStatusMessage" id="cdk-extensions.ec2.ITransitGatewayPeeringAttachment.property.transitGatewayAttachmentStatusMessage"></a>

```typescript
public readonly transitGatewayAttachmentStatusMessage: string;
```

- *Type:* string

The status message for the current status of the attachment.

---

### ITransitGatewayRegistration <a name="ITransitGatewayRegistration" id="cdk-extensions.networkmanager.ITransitGatewayRegistration"></a>

- *Implemented By:* cdk-extensions.networkmanager.TransitGatewayRegistration, cdk-extensions.networkmanager.ITransitGatewayRegistration



### ITransitGatewayRoute <a name="ITransitGatewayRoute" id="cdk-extensions.ec2.ITransitGatewayRoute"></a>

- *Implemented By:* cdk-extensions.ec2.ITransitGatewayRoute

Represents a Transit Gateway Route in AWS.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayRoute.property.transitGatewayRouteId">transitGatewayRouteId</a></code> | <code>string</code> | The ID of the Transit Gateway Route. |

---

##### `transitGatewayRouteId`<sup>Required</sup> <a name="transitGatewayRouteId" id="cdk-extensions.ec2.ITransitGatewayRoute.property.transitGatewayRouteId"></a>

```typescript
public readonly transitGatewayRouteId: string;
```

- *Type:* string

The ID of the Transit Gateway Route.

---

### ITransitGatewayRouteTable <a name="ITransitGatewayRouteTable" id="cdk-extensions.ec2.ITransitGatewayRouteTable"></a>

- *Implemented By:* cdk-extensions.ec2.TransitGatewayRouteTable, cdk-extensions.ec2.ITransitGatewayRouteTable

Represents a transit gateway route table in AWS.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayRouteTable.addRoute">addRoute</a></code> | Adds a route to this transit gateway route table. |

---

##### `addRoute` <a name="addRoute" id="cdk-extensions.ec2.ITransitGatewayRouteTable.addRoute"></a>

```typescript
public addRoute(options: TransitGatewayRouteOptions): TransitGatewayRoute
```

Adds a route to this transit gateway route table.

###### `options`<sup>Required</sup> <a name="options" id="cdk-extensions.ec2.ITransitGatewayRouteTable.addRoute.parameter.options"></a>

- *Type:* cdk-extensions.ec2.TransitGatewayRouteOptions

Configuration for the route being added.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayRouteTable.property.transitGatewayRouteTableArn">transitGatewayRouteTableArn</a></code> | <code>string</code> | The ARN of the transit gateway route table. |
| <code><a href="#cdk-extensions.ec2.ITransitGatewayRouteTable.property.transitGatewayRouteTableId">transitGatewayRouteTableId</a></code> | <code>string</code> | The ID of the transit gateway route table. |

---

##### `transitGatewayRouteTableArn`<sup>Required</sup> <a name="transitGatewayRouteTableArn" id="cdk-extensions.ec2.ITransitGatewayRouteTable.property.transitGatewayRouteTableArn"></a>

```typescript
public readonly transitGatewayRouteTableArn: string;
```

- *Type:* string

The ARN of the transit gateway route table.

---

##### `transitGatewayRouteTableId`<sup>Required</sup> <a name="transitGatewayRouteTableId" id="cdk-extensions.ec2.ITransitGatewayRouteTable.property.transitGatewayRouteTableId"></a>

```typescript
public readonly transitGatewayRouteTableId: string;
```

- *Type:* string

The ID of the transit gateway route table.

---

### ITrigger <a name="ITrigger" id="cdk-extensions.glue.ITrigger"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* cdk-extensions.glue.Trigger, cdk-extensions.glue.ITrigger

Represents a Glue Trigger in AWS.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.glue.ITrigger.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk-extensions.glue.ITrigger.property.triggerArn">triggerArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the trigger. |
| <code><a href="#cdk-extensions.glue.ITrigger.property.triggerName">triggerName</a></code> | <code>string</code> | The name of the trigger. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk-extensions.glue.ITrigger.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `triggerArn`<sup>Required</sup> <a name="triggerArn" id="cdk-extensions.glue.ITrigger.property.triggerArn"></a>

```typescript
public readonly triggerArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the trigger.

---

##### `triggerName`<sup>Required</sup> <a name="triggerName" id="cdk-extensions.glue.ITrigger.property.triggerName"></a>

```typescript
public readonly triggerName: string;
```

- *Type:* string

The name of the trigger.

---

### ITriggerAction <a name="ITriggerAction" id="cdk-extensions.glue.ITriggerAction"></a>

- *Implemented By:* cdk-extensions.glue.WorkflowCrawlerAction, cdk-extensions.glue.WorkflowJobAction, cdk-extensions.glue.ITriggerAction

Represents an action that should be taken when a trigger is executed.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.ITriggerAction.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.ITriggerAction.bind"></a>

```typescript
public bind(scope: IConstruct): ActionProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.ITriggerAction.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


### ITriggerPredicate <a name="ITriggerPredicate" id="cdk-extensions.glue.ITriggerPredicate"></a>

- *Implemented By:* cdk-extensions.glue.WorkflowCrawlerPredicate, cdk-extensions.glue.WorkflowJobPredicate, cdk-extensions.glue.ITriggerPredicate

Represents a precondition that must be satisfied in order for a trigger to be executed.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.ITriggerPredicate.bind">bind</a></code> | *No description.* |

---

##### `bind` <a name="bind" id="cdk-extensions.glue.ITriggerPredicate.bind"></a>

```typescript
public bind(scope: IConstruct): ConditionProperty
```

###### `scope`<sup>Required</sup> <a name="scope" id="cdk-extensions.glue.ITriggerPredicate.bind.parameter.scope"></a>

- *Type:* constructs.IConstruct

---


### IUser <a name="IUser" id="cdk-extensions.sso.IUser"></a>

- *Implemented By:* cdk-extensions.sso.UserBase, cdk-extensions.sso.IUser


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.sso.IUser.property.userId">userId</a></code> | <code>string</code> | A GUID identifier for a user object in IAM Identity Center (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). |

---

##### `userId`<sup>Required</sup> <a name="userId" id="cdk-extensions.sso.IUser.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* string

A GUID identifier for a user object in IAM Identity Center (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6).

---

### IWorkspace <a name="IWorkspace" id="cdk-extensions.aps.IWorkspace"></a>

- *Implemented By:* cdk-extensions.aps.Workspace, cdk-extensions.aps.IWorkspace

Represents an APS workspace in AWS.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk-extensions.aps.IWorkspace.property.workspaceArn">workspaceArn</a></code> | <code>string</code> | The Amazon Resource Name (ARN) of the APS workspace. |
| <code><a href="#cdk-extensions.aps.IWorkspace.property.workspaceId">workspaceId</a></code> | <code>string</code> | The ID generated by AWS for the APS workspace. |
| <code><a href="#cdk-extensions.aps.IWorkspace.property.workspacePrometheusEndpoint">workspacePrometheusEndpoint</a></code> | <code>string</code> | The Prometheus endpoint attribute of the workspace. |
| <code><a href="#cdk-extensions.aps.IWorkspace.property.workspaceQueryUrl">workspaceQueryUrl</a></code> | <code>string</code> | The URL of the remote write endpoint which can be used to ingest metrics into the Prometheus workspace. |
| <code><a href="#cdk-extensions.aps.IWorkspace.property.workspaceRemoteWriteUrl">workspaceRemoteWriteUrl</a></code> | <code>string</code> | The URL of the endpoint that other services can use to query the workspace. |

---

##### `workspaceArn`<sup>Required</sup> <a name="workspaceArn" id="cdk-extensions.aps.IWorkspace.property.workspaceArn"></a>

```typescript
public readonly workspaceArn: string;
```

- *Type:* string

The Amazon Resource Name (ARN) of the APS workspace.

---

##### `workspaceId`<sup>Required</sup> <a name="workspaceId" id="cdk-extensions.aps.IWorkspace.property.workspaceId"></a>

```typescript
public readonly workspaceId: string;
```

- *Type:* string

The ID generated by AWS for the APS workspace.

---

##### `workspacePrometheusEndpoint`<sup>Required</sup> <a name="workspacePrometheusEndpoint" id="cdk-extensions.aps.IWorkspace.property.workspacePrometheusEndpoint"></a>

```typescript
public readonly workspacePrometheusEndpoint: string;
```

- *Type:* string

The Prometheus endpoint attribute of the workspace.

This is the endpoint prefix without the remote_write or query API
appended.

---

##### `workspaceQueryUrl`<sup>Required</sup> <a name="workspaceQueryUrl" id="cdk-extensions.aps.IWorkspace.property.workspaceQueryUrl"></a>

```typescript
public readonly workspaceQueryUrl: string;
```

- *Type:* string

The URL of the remote write endpoint which can be used to ingest metrics into the Prometheus workspace.

---

##### `workspaceRemoteWriteUrl`<sup>Required</sup> <a name="workspaceRemoteWriteUrl" id="cdk-extensions.aps.IWorkspace.property.workspaceRemoteWriteUrl"></a>

```typescript
public readonly workspaceRemoteWriteUrl: string;
```

- *Type:* string

The URL of the endpoint that other services can use to query the workspace.

---

## Enums <a name="Enums" id="Enums"></a>

### CloudWatchEncryptionMode <a name="CloudWatchEncryptionMode" id="cdk-extensions.glue.CloudWatchEncryptionMode"></a>

Encryption mode for CloudWatch Logs.

> [https://docs.aws.amazon.com/glue/latest/webapi/API_CloudWatchEncryption.html#Glue-Type-CloudWatchEncryption-CloudWatchEncryptionMode](https://docs.aws.amazon.com/glue/latest/webapi/API_CloudWatchEncryption.html#Glue-Type-CloudWatchEncryption-CloudWatchEncryptionMode)

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.CloudWatchEncryptionMode.KMS">KMS</a></code> | Server-side encryption (SSE) with an AWS KMS key managed by the account owner. |

---

##### `KMS` <a name="KMS" id="cdk-extensions.glue.CloudWatchEncryptionMode.KMS"></a>

Server-side encryption (SSE) with an AWS KMS key managed by the account owner.

> [https://docs.aws.amazon.com/AmazonS3/latest/dev/UsingKMSEncryption.html](https://docs.aws.amazon.com/AmazonS3/latest/dev/UsingKMSEncryption.html)

---


### ConfigurationVersion <a name="ConfigurationVersion" id="cdk-extensions.glue.ConfigurationVersion"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.ConfigurationVersion.V1_0">V1_0</a></code> | *No description.* |

---

##### `V1_0` <a name="V1_0" id="cdk-extensions.glue.ConfigurationVersion.V1_0"></a>

---


### ConnectionType <a name="ConnectionType" id="cdk-extensions.glue.ConnectionType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.ConnectionType.JDBC">JDBC</a></code> | JDBC - Designates a connection to a database through Java Database Connectivity (JDBC). |
| <code><a href="#cdk-extensions.glue.ConnectionType.KAFKA">KAFKA</a></code> | KAFKA - Designates a connection to an Apache Kafka streaming platform. |
| <code><a href="#cdk-extensions.glue.ConnectionType.MONGODB">MONGODB</a></code> | MONGODB - Designates a connection to a MongoDB document database. |
| <code><a href="#cdk-extensions.glue.ConnectionType.NETWORK">NETWORK</a></code> | NETWORK - Designates a network connection to a data source within an Amazon Virtual Private Cloud environment (Amazon VPC). |

---

##### `JDBC` <a name="JDBC" id="cdk-extensions.glue.ConnectionType.JDBC"></a>

JDBC - Designates a connection to a database through Java Database Connectivity (JDBC).

---


##### `KAFKA` <a name="KAFKA" id="cdk-extensions.glue.ConnectionType.KAFKA"></a>

KAFKA - Designates a connection to an Apache Kafka streaming platform.

---


##### `MONGODB` <a name="MONGODB" id="cdk-extensions.glue.ConnectionType.MONGODB"></a>

MONGODB - Designates a connection to a MongoDB document database.

---


##### `NETWORK` <a name="NETWORK" id="cdk-extensions.glue.ConnectionType.NETWORK"></a>

NETWORK - Designates a network connection to a data source within an Amazon Virtual Private Cloud environment (Amazon VPC).

---


### ContentEncoding <a name="ContentEncoding" id="cdk-extensions.kinesis_firehose.ContentEncoding"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ContentEncoding.GZIP">GZIP</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ContentEncoding.NONE">NONE</a></code> | *No description.* |

---

##### `GZIP` <a name="GZIP" id="cdk-extensions.kinesis_firehose.ContentEncoding.GZIP"></a>

---


##### `NONE` <a name="NONE" id="cdk-extensions.kinesis_firehose.ContentEncoding.NONE"></a>

---


### CrawlerState <a name="CrawlerState" id="cdk-extensions.glue.CrawlerState"></a>

State a Glue crawler must be in in order to satisfy a predicate condition to trigger a part of a workflow.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.CrawlerState.CANCELLED">CANCELLED</a></code> | A crawler execution was cancelled before it could finish. |
| <code><a href="#cdk-extensions.glue.CrawlerState.FAILED">FAILED</a></code> | A crawler that has finished and ended in an error. |
| <code><a href="#cdk-extensions.glue.CrawlerState.SUCCEEDED">SUCCEEDED</a></code> | A crawler which has finished successfully. |

---

##### `CANCELLED` <a name="CANCELLED" id="cdk-extensions.glue.CrawlerState.CANCELLED"></a>

A crawler execution was cancelled before it could finish.

---


##### `FAILED` <a name="FAILED" id="cdk-extensions.glue.CrawlerState.FAILED"></a>

A crawler that has finished and ended in an error.

---


##### `SUCCEEDED` <a name="SUCCEEDED" id="cdk-extensions.glue.CrawlerState.SUCCEEDED"></a>

A crawler which has finished successfully.

---


### DeleteBehavior <a name="DeleteBehavior" id="cdk-extensions.glue.DeleteBehavior"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.DeleteBehavior.DELETE_FROM_DATABASE">DELETE_FROM_DATABASE</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.DeleteBehavior.DEPRECATE_IN_DATABASE">DEPRECATE_IN_DATABASE</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.DeleteBehavior.LOG">LOG</a></code> | *No description.* |

---

##### `DELETE_FROM_DATABASE` <a name="DELETE_FROM_DATABASE" id="cdk-extensions.glue.DeleteBehavior.DELETE_FROM_DATABASE"></a>

---


##### `DEPRECATE_IN_DATABASE` <a name="DEPRECATE_IN_DATABASE" id="cdk-extensions.glue.DeleteBehavior.DEPRECATE_IN_DATABASE"></a>

---


##### `LOG` <a name="LOG" id="cdk-extensions.glue.DeleteBehavior.LOG"></a>

---


### DeliveryStreamType <a name="DeliveryStreamType" id="cdk-extensions.kinesis_firehose.DeliveryStreamType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamType.DIRECT_PUT">DIRECT_PUT</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.DeliveryStreamType.KINESIS_STREAM_AS_SOURCE">KINESIS_STREAM_AS_SOURCE</a></code> | *No description.* |

---

##### `DIRECT_PUT` <a name="DIRECT_PUT" id="cdk-extensions.kinesis_firehose.DeliveryStreamType.DIRECT_PUT"></a>

---


##### `KINESIS_STREAM_AS_SOURCE` <a name="KINESIS_STREAM_AS_SOURCE" id="cdk-extensions.kinesis_firehose.DeliveryStreamType.KINESIS_STREAM_AS_SOURCE"></a>

---


### DomainDiscovery <a name="DomainDiscovery" id="cdk-extensions.route53.DomainDiscovery"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.route53.DomainDiscovery.ALL">ALL</a></code> | *No description.* |
| <code><a href="#cdk-extensions.route53.DomainDiscovery.NONE">NONE</a></code> | *No description.* |
| <code><a href="#cdk-extensions.route53.DomainDiscovery.PRIVATE">PRIVATE</a></code> | *No description.* |
| <code><a href="#cdk-extensions.route53.DomainDiscovery.PUBLIC">PUBLIC</a></code> | *No description.* |

---

##### `ALL` <a name="ALL" id="cdk-extensions.route53.DomainDiscovery.ALL"></a>

---


##### `NONE` <a name="NONE" id="cdk-extensions.route53.DomainDiscovery.NONE"></a>

---


##### `PRIVATE` <a name="PRIVATE" id="cdk-extensions.route53.DomainDiscovery.PRIVATE"></a>

---


##### `PUBLIC` <a name="PUBLIC" id="cdk-extensions.route53.DomainDiscovery.PUBLIC"></a>

---


### ElasticsearchCompressionFormat <a name="ElasticsearchCompressionFormat" id="cdk-extensions.k8s_aws.ElasticsearchCompressionFormat"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ElasticsearchCompressionFormat.GZIP">GZIP</a></code> | Gzip compression format. |

---

##### `GZIP` <a name="GZIP" id="cdk-extensions.k8s_aws.ElasticsearchCompressionFormat.GZIP"></a>

Gzip compression format.

---


### ExternalDnsLogFormat <a name="ExternalDnsLogFormat" id="cdk-extensions.k8s_aws.ExternalDnsLogFormat"></a>

The format external dns should use to output logs.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogFormat.JSON">JSON</a></code> | Output logs will be written as JSON objects. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogFormat.TEXT">TEXT</a></code> | Output logs will be written in plain text. |

---

##### `JSON` <a name="JSON" id="cdk-extensions.k8s_aws.ExternalDnsLogFormat.JSON"></a>

Output logs will be written as JSON objects.

---


##### `TEXT` <a name="TEXT" id="cdk-extensions.k8s_aws.ExternalDnsLogFormat.TEXT"></a>

Output logs will be written in plain text.

---


### ExternalDnsLogLevel <a name="ExternalDnsLogLevel" id="cdk-extensions.k8s_aws.ExternalDnsLogLevel"></a>

Verbosity of the logs generated by the external-dns service.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogLevel.PANIC">PANIC</a></code> | Set log level to 'panic'. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogLevel.DEBUG">DEBUG</a></code> | Set log level to 'debug'. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogLevel.INFO">INFO</a></code> | Set log level to 'info'. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogLevel.WARNING">WARNING</a></code> | Set log level to 'warning'. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogLevel.ERROR">ERROR</a></code> | Set log level to 'error'. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogLevel.FATAL">FATAL</a></code> | Set log level to 'fatal'. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsLogLevel.TRACE">TRACE</a></code> | Set log level to 'trace'. |

---

##### `PANIC` <a name="PANIC" id="cdk-extensions.k8s_aws.ExternalDnsLogLevel.PANIC"></a>

Set log level to 'panic'.

---


##### `DEBUG` <a name="DEBUG" id="cdk-extensions.k8s_aws.ExternalDnsLogLevel.DEBUG"></a>

Set log level to 'debug'.

---


##### `INFO` <a name="INFO" id="cdk-extensions.k8s_aws.ExternalDnsLogLevel.INFO"></a>

Set log level to 'info'.

---


##### `WARNING` <a name="WARNING" id="cdk-extensions.k8s_aws.ExternalDnsLogLevel.WARNING"></a>

Set log level to 'warning'.

---


##### `ERROR` <a name="ERROR" id="cdk-extensions.k8s_aws.ExternalDnsLogLevel.ERROR"></a>

Set log level to 'error'.

---


##### `FATAL` <a name="FATAL" id="cdk-extensions.k8s_aws.ExternalDnsLogLevel.FATAL"></a>

Set log level to 'fatal'.

---


##### `TRACE` <a name="TRACE" id="cdk-extensions.k8s_aws.ExternalDnsLogLevel.TRACE"></a>

Set log level to 'trace'.

---


### ExternalDnsSyncPolicy <a name="ExternalDnsSyncPolicy" id="cdk-extensions.k8s_aws.ExternalDnsSyncPolicy"></a>

Controls the operations ExternalDNS will perform on the records it manages.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsSyncPolicy.SYNC">SYNC</a></code> | Full sync mode. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsSyncPolicy.UPSERT_ONLY">UPSERT_ONLY</a></code> | Only allow create and update operations. |

---

##### `SYNC` <a name="SYNC" id="cdk-extensions.k8s_aws.ExternalDnsSyncPolicy.SYNC"></a>

Full sync mode.

Records will be created, updated, and deleted based on the
statis of their backing resources on the Kubernetes cluster.

---


##### `UPSERT_ONLY` <a name="UPSERT_ONLY" id="cdk-extensions.k8s_aws.ExternalDnsSyncPolicy.UPSERT_ONLY"></a>

Only allow create and update operations.

Records will have their values
set based on the status of their backing Kubernetes resources, however if
those resources are removed the DNS records will be retained, set to their
last configured value.

---


### ExternalDnsZoneType <a name="ExternalDnsZoneType" id="cdk-extensions.k8s_aws.ExternalDnsZoneType"></a>

Controls the types of Hosted Zones external DNS will create records for.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsZoneType.ALL">ALL</a></code> | Create DNS records for both public and private hosted zones. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsZoneType.PRIVATE">PRIVATE</a></code> | Only create DNS records for private hosted zones. |
| <code><a href="#cdk-extensions.k8s_aws.ExternalDnsZoneType.PUBLIC">PUBLIC</a></code> | Only create DNS records for public hosted zones. |

---

##### `ALL` <a name="ALL" id="cdk-extensions.k8s_aws.ExternalDnsZoneType.ALL"></a>

Create DNS records for both public and private hosted zones.

---


##### `PRIVATE` <a name="PRIVATE" id="cdk-extensions.k8s_aws.ExternalDnsZoneType.PRIVATE"></a>

Only create DNS records for private hosted zones.

---


##### `PUBLIC` <a name="PUBLIC" id="cdk-extensions.k8s_aws.ExternalDnsZoneType.PUBLIC"></a>

Only create DNS records for public hosted zones.

---


### FlowLogDataType <a name="FlowLogDataType" id="cdk-extensions.ec2.FlowLogDataType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogDataType.INT_32">INT_32</a></code> | 32 bit signed int. |
| <code><a href="#cdk-extensions.ec2.FlowLogDataType.INT_64">INT_64</a></code> | 64 bit signed int. |
| <code><a href="#cdk-extensions.ec2.FlowLogDataType.STRING">STRING</a></code> | UTF-8 encoded character string. |

---

##### `INT_32` <a name="INT_32" id="cdk-extensions.ec2.FlowLogDataType.INT_32"></a>

32 bit signed int.

---


##### `INT_64` <a name="INT_64" id="cdk-extensions.ec2.FlowLogDataType.INT_64"></a>

64 bit signed int.

---


##### `STRING` <a name="STRING" id="cdk-extensions.ec2.FlowLogDataType.STRING"></a>

UTF-8 encoded character string.

---


### FlowLogFileFormat <a name="FlowLogFileFormat" id="cdk-extensions.ec2.FlowLogFileFormat"></a>

The file format options for flow log files delivered to S3.

> [[Flow log files](https://docs.aws.amazon.com/vpc/latest/tgw/flow-logs-s3.html#flow-logs-s3-path)]([Flow log files](https://docs.aws.amazon.com/vpc/latest/tgw/flow-logs-s3.html#flow-logs-s3-path))

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.ec2.FlowLogFileFormat.PARQUET">PARQUET</a></code> | Apache Parquet is a columnar data format. |
| <code><a href="#cdk-extensions.ec2.FlowLogFileFormat.PLAIN_TEXT">PLAIN_TEXT</a></code> | Plain text. |

---

##### `PARQUET` <a name="PARQUET" id="cdk-extensions.ec2.FlowLogFileFormat.PARQUET"></a>

Apache Parquet is a columnar data format.

Queries on data in Parquet
format are 10 to 100 times faster compared to queries on data in plain
text. Data in Parquet format with Gzip compression takes 20 percent less
storage space than plain text with Gzip compression.

---


##### `PLAIN_TEXT` <a name="PLAIN_TEXT" id="cdk-extensions.ec2.FlowLogFileFormat.PLAIN_TEXT"></a>

Plain text.

This is the default format.

---


### FluentBitMatchEvaluator <a name="FluentBitMatchEvaluator" id="cdk-extensions.k8s_aws.FluentBitMatchEvaluator"></a>

Matching patterns supported by Fluent Bit plugins for scoping down incoming records.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatchEvaluator.GLOB">GLOB</a></code> | A basic pattern match supporting the star (`*`) character as a wildcard. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitMatchEvaluator.REGEX">REGEX</a></code> | Full pattern matching using regular expressions. |

---

##### `GLOB` <a name="GLOB" id="cdk-extensions.k8s_aws.FluentBitMatchEvaluator.GLOB"></a>

A basic pattern match supporting the star (`*`) character as a wildcard.

---


##### `REGEX` <a name="REGEX" id="cdk-extensions.k8s_aws.FluentBitMatchEvaluator.REGEX"></a>

Full pattern matching using regular expressions.

---


### FluentBitPluginType <a name="FluentBitPluginType" id="cdk-extensions.k8s_aws.FluentBitPluginType"></a>

The types of Fluent Bit plugins that can be configured.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPluginType.FILTER">FILTER</a></code> | A plugin that transforms or filters records. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPluginType.OUTPUT">OUTPUT</a></code> | A plugin that configures where output should be sent. |
| <code><a href="#cdk-extensions.k8s_aws.FluentBitPluginType.PARSER">PARSER</a></code> | A plugin that read data from input objects into structured objects. |

---

##### `FILTER` <a name="FILTER" id="cdk-extensions.k8s_aws.FluentBitPluginType.FILTER"></a>

A plugin that transforms or filters records.

---


##### `OUTPUT` <a name="OUTPUT" id="cdk-extensions.k8s_aws.FluentBitPluginType.OUTPUT"></a>

A plugin that configures where output should be sent.

---


##### `PARSER` <a name="PARSER" id="cdk-extensions.k8s_aws.FluentBitPluginType.PARSER"></a>

A plugin that read data from input objects into structured objects.

---


### JobBookmarksEncryptionMode <a name="JobBookmarksEncryptionMode" id="cdk-extensions.glue.JobBookmarksEncryptionMode"></a>

Encryption mode for Job Bookmarks.

> [https://docs.aws.amazon.com/glue/latest/webapi/API_JobBookmarksEncryption.html#Glue-Type-JobBookmarksEncryption-JobBookmarksEncryptionMode](https://docs.aws.amazon.com/glue/latest/webapi/API_JobBookmarksEncryption.html#Glue-Type-JobBookmarksEncryption-JobBookmarksEncryptionMode)

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JobBookmarksEncryptionMode.CLIENT_SIDE_KMS">CLIENT_SIDE_KMS</a></code> | Client-side encryption (CSE) with an AWS KMS key managed by the account owner. |

---

##### `CLIENT_SIDE_KMS` <a name="CLIENT_SIDE_KMS" id="cdk-extensions.glue.JobBookmarksEncryptionMode.CLIENT_SIDE_KMS"></a>

Client-side encryption (CSE) with an AWS KMS key managed by the account owner.

> [https://docs.aws.amazon.com/AmazonS3/latest/dev/UsingClientSideEncryption.html](https://docs.aws.amazon.com/AmazonS3/latest/dev/UsingClientSideEncryption.html)

---


### JobLanguage <a name="JobLanguage" id="cdk-extensions.glue.JobLanguage"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JobLanguage.PYTHON">PYTHON</a></code> | Python. |
| <code><a href="#cdk-extensions.glue.JobLanguage.SCALA">SCALA</a></code> | Scala. |

---

##### `PYTHON` <a name="PYTHON" id="cdk-extensions.glue.JobLanguage.PYTHON"></a>

Python.

---


##### `SCALA` <a name="SCALA" id="cdk-extensions.glue.JobLanguage.SCALA"></a>

Scala.

---


### JobState <a name="JobState" id="cdk-extensions.glue.JobState"></a>

State a Glue job must be in in order to satisfy a predicate condition to trigger a part of a workflow.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.JobState.FAILED">FAILED</a></code> | A job that has finished and ended with an error. |
| <code><a href="#cdk-extensions.glue.JobState.STOPPED">STOPPED</a></code> | A job which was stopped before completion. |
| <code><a href="#cdk-extensions.glue.JobState.SUCCEEDED">SUCCEEDED</a></code> | A job which has finished successfully. |
| <code><a href="#cdk-extensions.glue.JobState.TIMEOUT">TIMEOUT</a></code> | A job which timed out without completing. |

---

##### `FAILED` <a name="FAILED" id="cdk-extensions.glue.JobState.FAILED"></a>

A job that has finished and ended with an error.

---


##### `STOPPED` <a name="STOPPED" id="cdk-extensions.glue.JobState.STOPPED"></a>

A job which was stopped before completion.

---


##### `SUCCEEDED` <a name="SUCCEEDED" id="cdk-extensions.glue.JobState.SUCCEEDED"></a>

A job which has finished successfully.

---


##### `TIMEOUT` <a name="TIMEOUT" id="cdk-extensions.glue.JobState.TIMEOUT"></a>

A job which timed out without completing.

---


### JsonParsingEngine <a name="JsonParsingEngine" id="cdk-extensions.kinesis_firehose.JsonParsingEngine"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.JsonParsingEngine.JQ_1_6">JQ_1_6</a></code> | *No description.* |

---

##### `JQ_1_6` <a name="JQ_1_6" id="cdk-extensions.kinesis_firehose.JsonParsingEngine.JQ_1_6"></a>

---


### KinesisFirehoseCompressionFormat <a name="KinesisFirehoseCompressionFormat" id="cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat.ARROW">ARROW</a></code> | The Apache Arrow compression format. |
| <code><a href="#cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat.GZIP">GZIP</a></code> | Gzip compression format. |

---

##### `ARROW` <a name="ARROW" id="cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat.ARROW"></a>

The Apache Arrow compression format.

Only available if the Fluent Fit service being used to send logs to
Firehose had Apache Arrow enabled at compile time.

---


##### `GZIP` <a name="GZIP" id="cdk-extensions.k8s_aws.KinesisFirehoseCompressionFormat.GZIP"></a>

Gzip compression format.

---


### MatchOperator <a name="MatchOperator" id="cdk-extensions.aps.MatchOperator"></a>

The logical operator an alert manager matcher should use when evaluating filters for labels.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.MatchOperator.EQUALS">EQUALS</a></code> | Evaluate an alert manager filter on the basis that the label matches the string it is being compared against. |
| <code><a href="#cdk-extensions.aps.MatchOperator.NOT_EQUALS">NOT_EQUALS</a></code> | Evaluate an alert manager filter on the basis that the label does not match the string it is being compared against. |
| <code><a href="#cdk-extensions.aps.MatchOperator.RE_EQUALS">RE_EQUALS</a></code> | Evaluate an alert manager filter on the basis that the label matches the regular expression it is being compared against. |
| <code><a href="#cdk-extensions.aps.MatchOperator.RE_NOT_EQUALS">RE_NOT_EQUALS</a></code> | Evaluate an alert manager filter on the basis that the label does not match the regular expression it is being compared against. |

---

##### `EQUALS` <a name="EQUALS" id="cdk-extensions.aps.MatchOperator.EQUALS"></a>

Evaluate an alert manager filter on the basis that the label matches the string it is being compared against.

---


##### `NOT_EQUALS` <a name="NOT_EQUALS" id="cdk-extensions.aps.MatchOperator.NOT_EQUALS"></a>

Evaluate an alert manager filter on the basis that the label does not match the string it is being compared against.

---


##### `RE_EQUALS` <a name="RE_EQUALS" id="cdk-extensions.aps.MatchOperator.RE_EQUALS"></a>

Evaluate an alert manager filter on the basis that the label matches the regular expression it is being compared against.

---


##### `RE_NOT_EQUALS` <a name="RE_NOT_EQUALS" id="cdk-extensions.aps.MatchOperator.RE_NOT_EQUALS"></a>

Evaluate an alert manager filter on the basis that the label does not match the regular expression it is being compared against.

---


### MetadataPolicy <a name="MetadataPolicy" id="cdk-extensions.k8s_aws.MetadataPolicy"></a>

Options for fetching tags/labels from provider secrets.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.MetadataPolicy.FETCH">FETCH</a></code> | Fetch tags/labels from provider secrets. |
| <code><a href="#cdk-extensions.k8s_aws.MetadataPolicy.NONE">NONE</a></code> | Do not fetch tags/labels from provider secrets. |

---

##### `FETCH` <a name="FETCH" id="cdk-extensions.k8s_aws.MetadataPolicy.FETCH"></a>

Fetch tags/labels from provider secrets.

---


##### `NONE` <a name="NONE" id="cdk-extensions.k8s_aws.MetadataPolicy.NONE"></a>

Do not fetch tags/labels from provider secrets.

---


### NestFilterOperationType <a name="NestFilterOperationType" id="cdk-extensions.k8s_aws.NestFilterOperationType"></a>

The modes that the Fluent Bit Nest filter plugin can work in.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.k8s_aws.NestFilterOperationType.LIFT">LIFT</a></code> | Lift data from a nested object. |
| <code><a href="#cdk-extensions.k8s_aws.NestFilterOperationType.NEST">NEST</a></code> | Nest data into a specified object. |

---

##### `LIFT` <a name="LIFT" id="cdk-extensions.k8s_aws.NestFilterOperationType.LIFT"></a>

Lift data from a nested object.

---


##### `NEST` <a name="NEST" id="cdk-extensions.k8s_aws.NestFilterOperationType.NEST"></a>

Nest data into a specified object.

---


### OrcCompressionFormat <a name="OrcCompressionFormat" id="cdk-extensions.kinesis_firehose.OrcCompressionFormat"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcCompressionFormat.NONE">NONE</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcCompressionFormat.SNAPPY">SNAPPY</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcCompressionFormat.ZLIB">ZLIB</a></code> | *No description.* |

---

##### `NONE` <a name="NONE" id="cdk-extensions.kinesis_firehose.OrcCompressionFormat.NONE"></a>

---


##### `SNAPPY` <a name="SNAPPY" id="cdk-extensions.kinesis_firehose.OrcCompressionFormat.SNAPPY"></a>

---


##### `ZLIB` <a name="ZLIB" id="cdk-extensions.kinesis_firehose.OrcCompressionFormat.ZLIB"></a>

---


### OrcFormatVersion <a name="OrcFormatVersion" id="cdk-extensions.kinesis_firehose.OrcFormatVersion"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcFormatVersion.V0_11">V0_11</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.OrcFormatVersion.V0_12">V0_12</a></code> | *No description.* |

---

##### `V0_11` <a name="V0_11" id="cdk-extensions.kinesis_firehose.OrcFormatVersion.V0_11"></a>

---


##### `V0_12` <a name="V0_12" id="cdk-extensions.kinesis_firehose.OrcFormatVersion.V0_12"></a>

---


### ParquetCompressionFormat <a name="ParquetCompressionFormat" id="cdk-extensions.kinesis_firehose.ParquetCompressionFormat"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetCompressionFormat.GZIP">GZIP</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetCompressionFormat.SNAPPY">SNAPPY</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetCompressionFormat.UNCOMPRESSED">UNCOMPRESSED</a></code> | *No description.* |

---

##### `GZIP` <a name="GZIP" id="cdk-extensions.kinesis_firehose.ParquetCompressionFormat.GZIP"></a>

---


##### `SNAPPY` <a name="SNAPPY" id="cdk-extensions.kinesis_firehose.ParquetCompressionFormat.SNAPPY"></a>

---


##### `UNCOMPRESSED` <a name="UNCOMPRESSED" id="cdk-extensions.kinesis_firehose.ParquetCompressionFormat.UNCOMPRESSED"></a>

---


### ParquetWriterVersion <a name="ParquetWriterVersion" id="cdk-extensions.kinesis_firehose.ParquetWriterVersion"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetWriterVersion.V1">V1</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.ParquetWriterVersion.V2">V2</a></code> | *No description.* |

---

##### `V1` <a name="V1" id="cdk-extensions.kinesis_firehose.ParquetWriterVersion.V1"></a>

---


##### `V2` <a name="V2" id="cdk-extensions.kinesis_firehose.ParquetWriterVersion.V2"></a>

---


### PartitionUpdateBehavior <a name="PartitionUpdateBehavior" id="cdk-extensions.glue.PartitionUpdateBehavior"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.PartitionUpdateBehavior.INHERIT_FROM_TABLE">INHERIT_FROM_TABLE</a></code> | *No description.* |

---

##### `INHERIT_FROM_TABLE` <a name="INHERIT_FROM_TABLE" id="cdk-extensions.glue.PartitionUpdateBehavior.INHERIT_FROM_TABLE"></a>

---


### PredicateLogicalOperator <a name="PredicateLogicalOperator" id="cdk-extensions.glue.PredicateLogicalOperator"></a>

Logical operator that specifies how the conditions of a predicate should be evaluated.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.PredicateLogicalOperator.EQUALS">EQUALS</a></code> | State equals specified value. |

---

##### `EQUALS` <a name="EQUALS" id="cdk-extensions.glue.PredicateLogicalOperator.EQUALS"></a>

State equals specified value.

---


### PredicateOperator <a name="PredicateOperator" id="cdk-extensions.glue.PredicateOperator"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.PredicateOperator.AND">AND</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.PredicateOperator.OR">OR</a></code> | *No description.* |

---

##### `AND` <a name="AND" id="cdk-extensions.glue.PredicateOperator.AND"></a>

---


##### `OR` <a name="OR" id="cdk-extensions.glue.PredicateOperator.OR"></a>

---


### PythonVersion <a name="PythonVersion" id="cdk-extensions.glue.PythonVersion"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.PythonVersion.THREE">THREE</a></code> | Python 3 (the exact version depends on GlueVersion and JobCommand used). |
| <code><a href="#cdk-extensions.glue.PythonVersion.TWO">TWO</a></code> | Python 2 (the exact version depends on GlueVersion and JobCommand used). |

---

##### `THREE` <a name="THREE" id="cdk-extensions.glue.PythonVersion.THREE"></a>

Python 3 (the exact version depends on GlueVersion and JobCommand used).

---


##### `TWO` <a name="TWO" id="cdk-extensions.glue.PythonVersion.TWO"></a>

Python 2 (the exact version depends on GlueVersion and JobCommand used).

---


### RecrawlBehavior <a name="RecrawlBehavior" id="cdk-extensions.glue.RecrawlBehavior"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.RecrawlBehavior.EVENT_MODE">EVENT_MODE</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.RecrawlBehavior.EVERYTHING">EVERYTHING</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.RecrawlBehavior.NEW_FOLDERS_ONLY">NEW_FOLDERS_ONLY</a></code> | *No description.* |

---

##### `EVENT_MODE` <a name="EVENT_MODE" id="cdk-extensions.glue.RecrawlBehavior.EVENT_MODE"></a>

---


##### `EVERYTHING` <a name="EVERYTHING" id="cdk-extensions.glue.RecrawlBehavior.EVERYTHING"></a>

---


##### `NEW_FOLDERS_ONLY` <a name="NEW_FOLDERS_ONLY" id="cdk-extensions.glue.RecrawlBehavior.NEW_FOLDERS_ONLY"></a>

---


### S3CompressionFormat <a name="S3CompressionFormat" id="cdk-extensions.kinesis_firehose.S3CompressionFormat"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.kinesis_firehose.S3CompressionFormat.GZIP">GZIP</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3CompressionFormat.HADOOP_SNAPPY">HADOOP_SNAPPY</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3CompressionFormat.SNAPPY">SNAPPY</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3CompressionFormat.UNCOMPRESSED">UNCOMPRESSED</a></code> | *No description.* |
| <code><a href="#cdk-extensions.kinesis_firehose.S3CompressionFormat.ZIP">ZIP</a></code> | *No description.* |

---

##### `GZIP` <a name="GZIP" id="cdk-extensions.kinesis_firehose.S3CompressionFormat.GZIP"></a>

---


##### `HADOOP_SNAPPY` <a name="HADOOP_SNAPPY" id="cdk-extensions.kinesis_firehose.S3CompressionFormat.HADOOP_SNAPPY"></a>

---


##### `SNAPPY` <a name="SNAPPY" id="cdk-extensions.kinesis_firehose.S3CompressionFormat.SNAPPY"></a>

---


##### `UNCOMPRESSED` <a name="UNCOMPRESSED" id="cdk-extensions.kinesis_firehose.S3CompressionFormat.UNCOMPRESSED"></a>

---


##### `ZIP` <a name="ZIP" id="cdk-extensions.kinesis_firehose.S3CompressionFormat.ZIP"></a>

---


### S3EncryptionMode <a name="S3EncryptionMode" id="cdk-extensions.glue.S3EncryptionMode"></a>

Encryption mode for S3.

> [https://docs.aws.amazon.com/glue/latest/webapi/API_S3Encryption.html#Glue-Type-S3Encryption-S3EncryptionMode](https://docs.aws.amazon.com/glue/latest/webapi/API_S3Encryption.html#Glue-Type-S3Encryption-S3EncryptionMode)

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.S3EncryptionMode.KMS">KMS</a></code> | Server-side encryption (SSE) with an AWS KMS key managed by the account owner. |
| <code><a href="#cdk-extensions.glue.S3EncryptionMode.S3_MANAGED">S3_MANAGED</a></code> | Server side encryption (SSE) with an Amazon S3-managed key. |

---

##### `KMS` <a name="KMS" id="cdk-extensions.glue.S3EncryptionMode.KMS"></a>

Server-side encryption (SSE) with an AWS KMS key managed by the account owner.

> [https://docs.aws.amazon.com/AmazonS3/latest/dev/UsingKMSEncryption.html](https://docs.aws.amazon.com/AmazonS3/latest/dev/UsingKMSEncryption.html)

---


##### `S3_MANAGED` <a name="S3_MANAGED" id="cdk-extensions.glue.S3EncryptionMode.S3_MANAGED"></a>

Server side encryption (SSE) with an Amazon S3-managed key.

> [https://docs.aws.amazon.com/AmazonS3/latest/dev/UsingServerSideEncryption.html](https://docs.aws.amazon.com/AmazonS3/latest/dev/UsingServerSideEncryption.html)

---


### TableGroupingPolicy <a name="TableGroupingPolicy" id="cdk-extensions.glue.TableGroupingPolicy"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.TableGroupingPolicy.COMBINE_COMPATIBLE_SCHEMAS">COMBINE_COMPATIBLE_SCHEMAS</a></code> | *No description.* |

---

##### `COMBINE_COMPATIBLE_SCHEMAS` <a name="COMBINE_COMPATIBLE_SCHEMAS" id="cdk-extensions.glue.TableGroupingPolicy.COMBINE_COMPATIBLE_SCHEMAS"></a>

---


### TableType <a name="TableType" id="cdk-extensions.glue.TableType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.TableType.EXTERNAL_TABLE">EXTERNAL_TABLE</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TableType.VIRTUAL_VIEW">VIRTUAL_VIEW</a></code> | *No description.* |

---

##### `EXTERNAL_TABLE` <a name="EXTERNAL_TABLE" id="cdk-extensions.glue.TableType.EXTERNAL_TABLE"></a>

---


##### `VIRTUAL_VIEW` <a name="VIRTUAL_VIEW" id="cdk-extensions.glue.TableType.VIRTUAL_VIEW"></a>

---


### TableUpdateBehavior <a name="TableUpdateBehavior" id="cdk-extensions.glue.TableUpdateBehavior"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.TableUpdateBehavior.MERGE_NEW_COLUMNS">MERGE_NEW_COLUMNS</a></code> | *No description.* |

---

##### `MERGE_NEW_COLUMNS` <a name="MERGE_NEW_COLUMNS" id="cdk-extensions.glue.TableUpdateBehavior.MERGE_NEW_COLUMNS"></a>

---


### TriggerType <a name="TriggerType" id="cdk-extensions.glue.TriggerType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.TriggerType.CONDITIONAL">CONDITIONAL</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerType.EVENT">EVENT</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerType.ON_DEMAND">ON_DEMAND</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.TriggerType.SCHEDULED">SCHEDULED</a></code> | *No description.* |

---

##### `CONDITIONAL` <a name="CONDITIONAL" id="cdk-extensions.glue.TriggerType.CONDITIONAL"></a>

---


##### `EVENT` <a name="EVENT" id="cdk-extensions.glue.TriggerType.EVENT"></a>

---


##### `ON_DEMAND` <a name="ON_DEMAND" id="cdk-extensions.glue.TriggerType.ON_DEMAND"></a>

---


##### `SCHEDULED` <a name="SCHEDULED" id="cdk-extensions.glue.TriggerType.SCHEDULED"></a>

---


### UpdateBehavior <a name="UpdateBehavior" id="cdk-extensions.glue.UpdateBehavior"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.glue.UpdateBehavior.UPDATE_IN_DATABASE">UPDATE_IN_DATABASE</a></code> | *No description.* |
| <code><a href="#cdk-extensions.glue.UpdateBehavior.LOG">LOG</a></code> | *No description.* |

---

##### `UPDATE_IN_DATABASE` <a name="UPDATE_IN_DATABASE" id="cdk-extensions.glue.UpdateBehavior.UPDATE_IN_DATABASE"></a>

---


##### `LOG` <a name="LOG" id="cdk-extensions.glue.UpdateBehavior.LOG"></a>

---


### Weekday <a name="Weekday" id="cdk-extensions.aps.Weekday"></a>

The days of the week to be used in Prometheus alert manager configurations.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk-extensions.aps.Weekday.SUNDAY">SUNDAY</a></code> | Sunday. |
| <code><a href="#cdk-extensions.aps.Weekday.MONDAY">MONDAY</a></code> | Monday. |
| <code><a href="#cdk-extensions.aps.Weekday.TUESDAY">TUESDAY</a></code> | Tuesday. |
| <code><a href="#cdk-extensions.aps.Weekday.WEDNESDAY">WEDNESDAY</a></code> | Wednesday. |
| <code><a href="#cdk-extensions.aps.Weekday.THURSDAY">THURSDAY</a></code> | Thursday. |
| <code><a href="#cdk-extensions.aps.Weekday.FRIDAY">FRIDAY</a></code> | Friday. |
| <code><a href="#cdk-extensions.aps.Weekday.SATURDAY">SATURDAY</a></code> | Saturday. |

---

##### `SUNDAY` <a name="SUNDAY" id="cdk-extensions.aps.Weekday.SUNDAY"></a>

Sunday.

---


##### `MONDAY` <a name="MONDAY" id="cdk-extensions.aps.Weekday.MONDAY"></a>

Monday.

---


##### `TUESDAY` <a name="TUESDAY" id="cdk-extensions.aps.Weekday.TUESDAY"></a>

Tuesday.

---


##### `WEDNESDAY` <a name="WEDNESDAY" id="cdk-extensions.aps.Weekday.WEDNESDAY"></a>

Wednesday.

---


##### `THURSDAY` <a name="THURSDAY" id="cdk-extensions.aps.Weekday.THURSDAY"></a>

Thursday.

---


##### `FRIDAY` <a name="FRIDAY" id="cdk-extensions.aps.Weekday.FRIDAY"></a>

Friday.

---


##### `SATURDAY` <a name="SATURDAY" id="cdk-extensions.aps.Weekday.SATURDAY"></a>

Saturday.

---

